package fr.unedic.cali.asu.caa14.p01.liquidation.dom;

import fr.unedic.cali.asu.asr.liquidation.parcours.ConstitutionDateAttribution;
import fr.unedic.cali.asu.asr.liquidation.parcours.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.asr.liquidation.parcours.ConstitutionDureeReglementaire;
import fr.unedic.cali.asu.asr.liquidation.parcours.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.asr.liquidation.parcours.ConstitutionReglementApplicable;
import fr.unedic.cali.asu.asr.liquidation.parcours.DeterminationConditionQuantiteAffiliation;
import fr.unedic.cali.asu.asr.liquidation.parcours.DeterminationConditionRechercheEmploiAsr;
import fr.unedic.cali.asu.caa14.p01.liquidation.dom.gen.ObjectifExamenAdmissionGen;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.ConstitutionDureeEffective;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.ConstitutionProduitResultant;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.DeterminationCompetencesProduitCourant;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.DeterminationConditionFaitGenerateur;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p04.liquidation.parcours.DeterminationConditionCumulActiviteConservee;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionAge;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionCumulPrestationFamiliale;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionMontantProduitNonNul;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;

public class ObjectifExamenAdmission
  extends ObjectifExamenAdmissionGen
{
  private static final long serialVersionUID = 1L;
  
  public ObjectifExamenAdmission(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjectifExamenAdmission() {}
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenAdmission copie = new ObjectifExamenAdmission();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    return new DeterminationConditionRechercheEmploiAsr();
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    return new DeterminationConditionFaitGenerateur();
  }
  
  public Parcours creerParcoursConditionAge()
  {
    return new DeterminationConditionAge();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return new DeterminationConditionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageTotal()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulAvantageVieillesse()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    return new DeterminationConditionCumulActiviteConservee();
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    return new DeterminationConditionCumulPrestationFamiliale();
  }
  
  public Parcours creerParcoursConditionAnciennete()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    return new DeterminationConditionMontantProduitNonNul();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    return new ConstitutionDureeReglementaire();
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBruts();
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    return null;
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return new ConstitutionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ConstitutionCoefficientTempsPartiel();
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return new ConstitutionCoefficientSaisonnier();
  }
  
  public Parcours creerParcoursReglementApplicable()
  {
    return new ConstitutionReglementApplicable();
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    return new ConstitutionDateAttribution();
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    return new ConstitutionPointDepartIndemnisation();
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return new ConstitutionCaractereSaisonnier();
  }
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return new ConstitutionDateLimiteIndemnisation();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return new ConstitutionProduitResultant();
  }
  
  public Parcours creerParcoursCapitalAvecDureeEffective()
  {
    return null;
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    return new ConstitutionDureeEffective();
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return new DeterminationCompetencesProduitCourant();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenAdmission
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */