package fr.unedic.cali.asu.caa14.p01.liquidation.dom;

import fr.unedic.cali.asu.asr.liquidation.parcours.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.caa14.p01.liquidation.dom.gen.ObjectifExamenRevisionGen;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.ConstitutionDateAttributionRevision;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.ConstitutionPointDepartIndemnisationRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartielRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffective;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireRepriseRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitResultant;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionCapitalAvecDureeEffective;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBrutsRevision;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionMontantReviseRevision;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;

public class ObjectifExamenRevision
  extends ObjectifExamenRevisionGen
{
  private static final long serialVersionUID = 1L;
  
  public ObjectifExamenRevision(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjectifExamenRevision() {}
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenAdmission copie = new ObjectifExamenAdmission();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ConstitutionCoefficientTempsPartielRevision();
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    return new ConstitutionDateAttributionRevision();
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return new DeterminationCompetencesProduitResultant();
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    return new ConstitutionDureeEffective();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    return new ConstitutionDureeReglementaireRepriseRevision();
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBrutsRevision();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursCapitalAvecDureeEffective()
  {
    return new ConstitutionCapitalAvecDureeEffective();
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return null;
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionAge()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageTotal()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulAvantageVieillesse()
  {
    return super.creerParcoursConditionCumulAvantageVieillesse();
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    return new DeterminationConditionMontantReviseRevision();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    return null;
  }
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return new ConstitutionDateLimiteIndemnisation();
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    return new ConstitutionPointDepartIndemnisationRevision();
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursReglementApplicable()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */