package fr.unedic.cali.asu.caa14.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.produits.liquidation.dom.Decision;
import fr.unedic.cali.dom.DecisionSpec;
import java.util.ArrayList;

public class ComparateurDecision
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ComparateurDecision
{
  public static boolean estEgal(DecisionSpec decision1, DecisionSpec decision2)
  {
    boolean estEgal = false;
    if ((decision1 != null) && (decision2 != null)) {
      estEgal = (produitEgal(decision1, decision2)) && (decisionEgal((Decision)decision1, (Decision)decision2)) && (revisionsPossedeAttributionPrecedente((Decision)decision1, (Decision)decision2)) && (reprise1PossedeAttributionPrecedente((Decision)decision1, (Decision)decision2)) && (dureeEffectiveEgale((Decision)decision1, (Decision)decision2)) && (pjiEgal((Decision)decision1, (Decision)decision2)) && (reglementEgal((Decision)decision1, (Decision)decision2)) && (motifRejetEgal((Decision)decision1, (Decision)decision2)) && (montantBrutEgal((Decision)decision1, (Decision)decision2)) && (sjrEgal((Decision)decision1, (Decision)decision2)) && (coefSaisonnierEgal((Decision)decision1, (Decision)decision2)) && (coefTempsPartielEgal((Decision)decision1, (Decision)decision2)) && (dateAttributionEgal((Decision)decision1, (Decision)decision2)) && (topAlsaceMoselleEgal((Decision)decision1, (Decision)decision2)) && (regimeSecuEgal((Decision)decision1, (Decision)decision2)) && (competenceAdministrativeEgale((Decision)decision1, (Decision)decision2));
    }
    if (ignorerChangementAre2009Expatries(decision1, decision2)) {
      estEgal = decisionEgal(decision1, decision2);
    }
    return estEgal;
  }
  
  public static ArrayList rechercheDifferencesComparaisonDecision(DecisionSpec decision1, DecisionSpec decision2)
  {
    ArrayList listeDifferences = new ArrayList();
    if (!estEgal(decision1, decision2)) {
      if (produitEgal(decision1, decision2))
      {
        boolean revisionsPossedeAttributionPrecedente = revisionsPossedeAttributionPrecedente(decision1, decision2);
        boolean reprise1PossedeAttributionPrecedente = reprise1PossedeAttributionPrecedente(decision1, decision2);
        if (decisionEgal(decision1, decision2))
        {
          if ((reprise1PossedeAttributionPrecedente) && (revisionsPossedeAttributionPrecedente))
          {
            Decision decisionAvant = (Decision)decision1;
            Decision decisionApres = (Decision)decision2;
            if (!dureeEffectiveEgale(decisionAvant, decisionApres)) {
              alimenterDureeComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!pjiEgal(decisionAvant, decisionApres)) {
              alimenterPjiComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!reglementEgal(decisionAvant, decisionApres)) {
              alimenterReglementComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!motifRejetEgal(decisionAvant, decisionApres)) {
              alimenterMotifsRejetComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!montantBrutEgal(decisionAvant, decisionApres)) {
              alimenterMontantComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!sjrEgal(decisionAvant, decisionApres)) {
              alimenterSjrComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!coefSaisonnierEgal(decisionAvant, decisionApres)) {
              alimenterCoefSaisonnierComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!coefTempsPartielEgal(decisionAvant, decisionApres)) {
              alimenterCoefTempsPartielComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!dateAttributionEgal(decisionAvant, decisionApres)) {
              alimenterDateAttributionComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!topAlsaceMoselleEgal(decisionAvant, decisionApres)) {
              alimenterAlsaceLorraineComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!regimeSecuEgal(decisionAvant, decisionApres)) {
              alimenterRegimeSecuComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!competenceAdministrativeEgale(decisionAvant, decisionApres)) {
              alimenterCompetenceAdministrativeComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
          }
          else if (!reprise1PossedeAttributionPrecedente)
          {
            alimenterAttribPrecRepriseComparaisonDecision(decision2, listeDifferences);
          }
          else
          {
            alimenterAttribPrecRevisionComparaisonDecision(decision1, decision2, listeDifferences);
          }
        }
        else {
          alimenterDecisionComparaisonDecision(decision1, decision2, listeDifferences);
        }
      }
      else if ((decision1 != null) && (decision2 != null))
      {
        alimenterProduitComparaisonDecision(decision1, decision2, listeDifferences);
        if (!decisionEgal(decision1, decision2)) {
          alimenterDecisionComparaisonDecision(decision1, decision2, listeDifferences);
        }
      }
    }
    return listeDifferences;
  }
}

/* Location:
 * Qualified Name:     ComparateurDecision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */