package fr.unedic.cali.asu.cge01.avant;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeSuspensionIndemnisation;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.ActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.DefinitionStatutUtTraitementActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.cge01.avant.outilsfonctionnels.TraitementDureeConsommableAvant;
import fr.unedic.cali.asu.cge01.avant.outilsfonctionnels.TraitementPeriodesAvant;
import fr.unedic.cali.asu.cge01.avant.outilsfonctionnels.TraitementUtAvant;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Spec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieAppliquerISLR;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieISLR;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FormuleDelaiReportSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieAppliquerISLRSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieFormuleISLRSpec;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaireMayotte;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.dom.cge01.AttributionAssuranceCgeSpec;
import fr.unedic.cali.asu.liquidation.outilsfonctionnels.DeterminationMontant;
import fr.unedic.cali.asu.liquidation.outilsfonctionnels.RechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.outilsfonctionnels.ConstitutionISLR;
import fr.unedic.cali.asu.outilsfonctionnels.ConstitutionPMC;
import fr.unedic.cali.asu.outilsfonctionnels.OutilCarence;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsRevisions;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsTrancheCalcul;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.BaseDelaiReport;
import fr.unedic.cali.asu.produits.liquidation.dom.CarenceIccp;
import fr.unedic.cali.asu.produits.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.produits.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.asu.produits.liquidation.dom.Differe;
import fr.unedic.cali.asu.produits.liquidation.dom.ElementChomageSansRupture;
import fr.unedic.cali.asu.produits.liquidation.dom.Poursuite;
import fr.unedic.cali.asu.produits.liquidation.dom.PreavisLegal;
import fr.unedic.cali.asu.produits.liquidation.dom.PreavisMesureConservatoireIndemnisable;
import fr.unedic.cali.asu.produits.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ElementChomageSansRuptureSpec;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.autresdoms.ga.dom.ActionFormation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.TravailNonSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.PeriodeGaecSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.autresdoms.ga.mapping.MapperPeriodesCalcul;
import fr.unedic.cali.avant.FacadeAvantProduitAbstraite;
import fr.unedic.cali.avant.FacadeAvantProduitFactory;
import fr.unedic.cali.avant.FacadeAvantProduitSpec;
import fr.unedic.cali.calcul.FacadeCalculProduitFactory;
import fr.unedic.cali.calcul.FacadeCalculProduitSpec;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.TraitementPeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvantSpec;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.UniteTraitementForcee;
import fr.unedic.cali.calcul.dom.periode.DsmMaladie;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeDisponibilite;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravail;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoBlocageM12;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeArretCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeBlocagePerteActiviteConservee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationPMVS;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeSuspensionIslr;
import fr.unedic.cali.calcul.outilsfonctionnels.DecoupageProratisation;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminationActiviteConserveeReprise;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminerJustificatifsRevenusAR;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSanctions;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ResultatActiviteReduite;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodePrimeCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPAEC;
import fr.unedic.cali.calcul.outilsfonctionnels.proratisation.PeriodeProratisationFactory;
import fr.unedic.cali.calcul.pbjc.dom.IndividuPbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.OdAssuranceSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.RevisionSpec;
import fr.unedic.cali.dom.affectation.GammeAsuSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.LigneSpec;
import fr.unedic.cali.dom.affectation.ProduitAbstrait;
import fr.unedic.cali.dom.affectation.ProduitAsuAbstrait;
import fr.unedic.cali.dom.affectation.ProduitAsuDelegueSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuMay17P02;
import fr.unedic.cali.dom.affectation.ProduitAsuMay17P03;
import fr.unedic.cali.dom.affectation.ProduitForDelegueSpec;
import fr.unedic.cali.dom.affectation.ProduitForRfp04P01;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontant;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.cali.fabriques.FabriqueStrategieQuantiteAffiliationHeureAvecCachet;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.cali.outilsfonctionnels.RechercherPeriodeIndemnisation;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreConflitGaec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePansCalcul;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieQuantiteAffiliationHeureAvecCachetSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.cali.util.ObjetChronoPeriodeConcreteCarence;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreTemporel;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.ObjetChronoPeriodeConcrete;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import fr.unedic.util.temps.UniteDuree;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import java.util.Set;

public class FacadeAvantLigneImpl
  extends FacadeAvantProduitAbstraite
{
  protected static final int CENT = 100;
  private static final int DUREE_PERTE_ACTIVITE_CONSERVE = 122;
  private static final int DUREE_DA = 7;
  
  public ResultatAvant executerAvant(AttributionSpec attribution, boolean avecPriseEnCompteEvenement, Damj dateEtude, boolean executionPersistante)
    throws CoucheLogiqueException
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
    ElementChomageSansRupture elementChomageSansRupture = null;
    elementChomageSansRupture = tranche.getElementChomageSansRupture();
    if ((dateEtude != null) && (elementChomageSansRupture != null) && (elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension()) && (elementChomageSansRupture.estUnContexteDeRupturePendantSuspension()) && (dateEtude.estApresOuCoincideAvec(elementChomageSansRupture.getDateRepriseActivite()))) {
      return executionDeLAvant(attribution, avecPriseEnCompteEvenement, null, tranche, executionPersistante);
    }
    if ((elementChomageSansRupture != null) && (elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension()))
    {
      ArrayList listCarrence = new ArrayList();
      Collection carences = tranche.getListeDelaisReports();
      Iterator it = carences.iterator();
      while (it.hasNext())
      {
        CarencePrefixeAFixer carence = (CarencePrefixeAFixer)it.next();
        carence.setReliquat(carence.getQuantiteInitial());
        if (!(carence instanceof Differe)) {
          carence.setOrigineReliquat(new ObjetChronoPeriodeConcreteCarence(carence.getOrigine().getDateDebut(), carence.getDateFinPeriodeOrigine()));
        }
        listCarrence.add(carence);
      }
      return new ResultatAvant(attribution.getDateAttribution(), listCarrence, false);
    }
    return executionDeLAvant(attribution, avecPriseEnCompteEvenement, dateEtude, tranche, executionPersistante);
  }
  
  public ResultatAvant executerAvant(IndividuSpec individu, Damj dateAttribution, ProduitSpec produit, Collection delaisReport, Collection pcarences)
    throws CoucheLogiqueException
  {
    ResultatAvant resultatAvant = null;
    Damj pji = null;
    Damj pjiTheorique = null;
    Damj debutDiffere = null;
    Iterator iterateurDelaisReport = null;
    int quantiteDelaisReport = 0;
    boolean differeEntame = true;
    int etat = 0;
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    Qualification qualification = new Qualification();
    ChronologiePeriodes periodesSuspensives = null;
    Damj dernierJourAvant = null;
    
    Differe differe = getDiffere(pcarences);
    Collection carences = getCarencesValides(pcarences, dateAttribution);
    
    chronologiePeriodes = OutillagePeriodes.recupererPeriodesGAEC(individu, dateAttribution, dateAttribution);
    
    periodesSuspensives = qualification.qualificationPeriodesSuspensivesPourAvant(chronologiePeriodes, dateAttribution);
    
    debutDiffere = rechercheDebutDiffere(carences, periodesSuspensives, dateAttribution);
    if (delaisReport != null)
    {
      iterateurDelaisReport = delaisReport.iterator();
      if (iterateurDelaisReport.hasNext()) {
        differe = (Differe)iterateurDelaisReport.next();
      }
    }
    if (differe == null) {
      differe = new Differe(0);
    } else {
      carences.add(differe);
    }
    quantiteDelaisReport = differe.getQuantiteInitial().getValeurEntiere();
    Periode periodeDiffere = new Periode(debutDiffere, quantiteDelaisReport);
    
    dernierJourAvant = periodeDiffere.getFin();
    pjiTheorique = dernierJourAvant.lendemain();
    pji = pjiTheorique;
    
    resultatAvant = new ResultatAvant(pji, (List)carences, differeEntame);
    resultatAvant.setEtat(etat);
    resultatAvant.setPremierJourAvant(dateAttribution);
    resultatAvant.setDernierJourAvant(dernierJourAvant);
    
    return resultatAvant;
  }
  
  private ResultatAvant executionDeLAvant(AttributionSpec attribution, boolean avecPriseEnCompteEvenement, Damj dateEtude, TrancheExecutable tranche, boolean executionPersistante)
    throws CoucheLogiqueException
  {
    ResultatAvant resultatAvant = null;
    Damj pji = null;
    Collection carencesEffectives = new ArrayList();
    ObjetChronoPeriodePriseEnCharge periodePEC = null;
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSansConflitGAEC = new ChronologiePeriodes();
    Collection listeCarrence = tranche.getListeDelaisReports();
    if ((attribution instanceof Poursuite)) {
      listeCarrence = construireCarencesPoursuite(attribution);
    }
    int etat = 0;
    Periode periodeUtAvant = null;
    Damj dateDebutUtAvant = null;
    Damj dateFinUtAvant = null;
    Damj finPEC = null;
    CalendrierExecutionAvant calendrierAvant = new CalendrierExecutionAvant();
    calendrierAvant.setPremierJourAvant(rechercherDateDebutAvant((Attribution)attribution, tranche));
    calendrierAvant.setEtatExecutionAvant(1);
    dateDebutUtAvant = calendrierAvant.getPremierJourAvant().getDebutMois();
    dateFinUtAvant = dateDebutUtAvant.getFinMois();
    Damj dateAttribOuPjp = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
    if (avecPriseEnCompteEvenement)
    {
      chronologiePeriodes = recuperationDeToutesLesDesPeriodes(attribution.getDemandeur(), attribution, dateAttribOuPjp, null);
      periodePEC = OutillagePeriodes.recupererPeriodePECContenant(attribution.getDemandeur(), dateAttribOuPjp);
      if ((periodePEC == null) || (estContexteDeRevisionSurPecArce(attribution, periodePEC)))
      {
        if ((!(attribution instanceof RevisionSpec)) && (!"ASU_17".equals(attribution.getTypeExamen())) && (!"ASU_25".equals(attribution.getTypeExamen())) && (!"ASU_19".equals(attribution.getTypeExamen())) && (((!"ASU_22".equals(attribution.getTypeExamen())) && (!"ASU_23".equals(attribution.getTypeExamen()))) || ((attribution instanceof Poursuite)))) {
          throw new CoucheLogiqueException("HG_PR_CALI_L_PAS_DE_PEC_POUR_EXECUTION_AVANT", "Attention lors de l'execution de l'avant, impossible de retrouver une periode de prise en charge.", null);
        }
        resultatAvant = new ResultatAvant(pji, mettreAJourCarrenceSurRevisionHorsPec(listeCarrence, attribution.getDateAttribution()), false);
        resultatAvant.setDernierJourAvant(attribution.getDateAttribution());
        resultatAvant.setEtat(1);
        return resultatAvant;
      }
      finPEC = periodePEC.getDateFin();
    }
    else
    {
      chronologiePeriodes = (ChronologiePeriodes)recuperationDeToutesLesDesPeriodes(attribution.getDemandeur(), attribution, dateAttribOuPjp, dateAttribOuPjp).copier(new FiltreChevauchePeriode(new Periode(dateAttribOuPjp, dateAttribOuPjp)));
      
      chronologiePeriodesSansConflitGAEC = (ChronologiePeriodes)chronologiePeriodes.copier(new FiltreNegation(new FiltreConflitGaec()));
      
      chronologiePeriodes = chronologiePeriodesSansConflitGAEC;
      Qualification qualification = new Qualification();
      QualificationPeriodes periodesQualifie = new QualificationPeriodes();
      periodesQualifie = qualification.qualificationPeriodesPourAvant(chronologiePeriodes, attribution);
      
      chronologiePeriodes = periodesQualifie.getPeriodesSuspensives();
      chronologiePeriodes.ajouter(periodesQualifie.getPeriodesInterruptives());
    }
    IndividuSpec individu = attribution.getDemandeur();
    if (dateEtude != null) {
      chronologiePeriodes.ajouter(new ObjetChronoPeriodeArretCalcul(dateEtude.lendemain()));
    }
    while ((calendrierAvant.getEtatExecutionAvant() != 3) && (!listeCarrence.isEmpty()))
    {
      periodeUtAvant = new Periode(dateDebutUtAvant, dateFinUtAvant);
      if ((individu != null) && (individu.getDateNaissance() != null) && (periodeUtAvant.getDebut().estApres(individu.getDateNaissance().deplacerVersAvant(new DureeCalendaire(100))))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(new Damj("2200, 01, 01"))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(Damj.FIN_DES_TEMPS)) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { attribution.getDateAttribution() });
      }
      dateDebutUtAvant = dateFinUtAvant.getDebutMoisSuivant();
      dateFinUtAvant = dateDebutUtAvant.getFinMois();
      if (Log.isTraceActive(FacadeAvantLigneImpl.class, Niveau.DEBUG)) {
        Log.ecritTrace(Niveau.DEBUG, FacadeAvantLigneImpl.class, "executerAvant", "Calcul: UT Avant [" + periodeUtAvant.getDebut() + " - " + periodeUtAvant.getFin() + "]");
      }
      etat = TraitementUtAvant.executerUtAvant(attribution, calendrierAvant, periodeUtAvant, chronologiePeriodes);
    }
    if (etat == 0) {
      pji = calendrierAvant.getDernierJourAvant().lendemain();
    }
    if ((avecPriseEnCompteEvenement) && 
      (finPEC != null) && (pji != null) && (finPEC.estAvantOuCoincideAvec(calendrierAvant.getDernierJourAvant()))) {
      if (OutillagePEC.estPecSuivanteAutreEtatMembreCoordination(attribution.getDemandeur(), finPEC))
      {
        Chronologie chronologiePecEuropeenne = OutillagePEC.getPeriodesPecAutreEtatMembreCoordinationDebutApresDate(attribution.getDemandeur(), finPEC);
        ObjetChronoPeriodePriseEnCharge pec = (ObjetChronoPeriodePriseEnCharge)chronologiePecEuropeenne.premierElement();
        if (pec.getDateDebut().estContenueDans(calendrierAvant.getPeriode()))
        {
          FacadeCalculProduitSpec facadeCalculProduit = FacadeCalculProduitFactory.getInstance().getInstanceGestionnaireCalculProduit(attribution.getProduitExecution());
          
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, pji, 31, 0, true, null, facadeCalculProduit, null);
        }
      }
    }
    if (!listeCarrence.isEmpty())
    {
      if (executionPersistante) {
        attribution.setCalendrierExecutionAvant(calendrierAvant);
      }
      mettreAJour(calendrierAvant, (Attribution)attribution, carencesEffectives);
      
      resultatAvant = new ResultatAvant(pji, new ArrayList(carencesEffectives), calendrierAvant.getEtatAuDernierJourAvant().isDelaiAttenteEntame());
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(calendrierAvant.getDateDebut());
      resultatAvant.setDernierJourAvant(calendrierAvant.getDateFin());
      resultatAvant.setCalendrierExecutionAvantCalcul(calendrierAvant);
      resultatAvant.setPeriodePECEvenementReducteur(calendrierAvant.getEtatAuDernierJourAvant().getPeriodePECEvenementReducteur());
    }
    else
    {
      attribution.setCalendrierExecutionAvant(null);
      if ((attribution instanceof Poursuite))
      {
        Damj pjiPoursuite = ((Poursuite)attribution).getSaisieAntecedent().getPremierJourIndemnisable();
        resultatAvant = new ResultatAvant(pjiPoursuite, new ArrayList(carencesEffectives), false);
        resultatAvant.setEtat(etat);
        resultatAvant.setPremierJourAvant(attribution.getDateAttribution());
        resultatAvant.setDernierJourAvant(pjiPoursuite.veille());
      }
      else
      {
        resultatAvant = new ResultatAvant(attribution.getDateAttribution(), new ArrayList(carencesEffectives), false);
        resultatAvant.setEtat(etat);
        resultatAvant.setPremierJourAvant(attribution.getDateAttribution());
        resultatAvant.setDernierJourAvant(attribution.getDateAttribution());
      }
    }
    if (etat == 1) {
      resultatAvant.setMessageErreur("Impossible de determiner le PJI : Un événement interruptif est survenu avant la fin du différé.");
    }
    return resultatAvant;
  }
  
  protected Damj rechercherDateDebutAvant(Attribution attribution, TrancheExecutable tranche)
    throws CoucheLogiqueException
  {
    ElementChomageSansRupture elementChomageSansRupture = null;
    Collection carences = null;
    if ((attribution instanceof Poursuite)) {
      carences = getCarencesValides(construireCarencesPoursuite(attribution), attribution.getDateAttribution());
    } else {
      carences = getCarencesValides(tranche.getListeDelaisReports(), attribution.getDateAttribution());
    }
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(carences);
    PreavisLegal preavisLegal = getPreavisLegalAConsommer(carences);
    CarenceIccp differeStandard = getDiffereStandardAConsommer(carences);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(carences);
    
    elementChomageSansRupture = tranche.getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension()) && (elementChomageSansRupture.estUnContexteDeRupturePendantSuspension()) && (elementChomageSansRupture.getDateRepriseActivite() != null)) {
      return Damj.max(elementChomageSansRupture.getDateRepriseActivite(), attribution.getDateAttribution());
    }
    if (pmc != null)
    {
      if ((pmc.getOrigine() instanceof ActiviteSalarie)) {
        return ConstitutionPMC.determinerDateDebutPMC((ActiviteSalarie)pmc.getOrigine());
      }
      return pmc.getDateFinPeriodeOrigine().lendemain();
    }
    if (preavisLegal != null) {
      return preavisLegal.getDateFinPeriodeOrigine().lendemain();
    }
    if (differeStandard != null) {
      return differeStandard.getDateFinPeriodeOrigine().lendemain();
    }
    if (differeSpecifique != null) {
      return differeSpecifique.getDateFinPeriodeOrigine().lendemain();
    }
    return OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
  }
  
  protected static Collection construireCarencesPoursuite(AttributionSpec attrib)
  {
    Collection toutesLesCarences = new ArrayList();
    Poursuite attribution = (Poursuite)attrib;
    if (attribution.getUniteTraitementAvant() != null)
    {
      if (attribution.getUniteTraitementAvant().getDureePmc() != null)
      {
        PreavisMesureConservatoireNonIndemnisable pmc = new PreavisMesureConservatoireNonIndemnisable();
        pmc.setReliquat(new QuantiteJour(attribution.getUniteTraitementAvant().getDureePmc().toString()));
        pmc.setPeriodeApplicationCarence(attribution.getUniteTraitementAvant().getPeriode());
        pmc.setDateFinPeriodeOrigine(attribution.getUniteTraitementAvant().getPeriode().getDebut());
        pmc.setQuantiteInitial(new QuantiteJour(attribution.getUniteTraitementAvant().getDureePmc().toString()));
        toutesLesCarences.add(pmc);
      }
      if (attribution.getUniteTraitementAvant().getDureeIccp() != null)
      {
        CarenceIccp carenceICCP = new CarenceIccp();
        carenceICCP.setReliquat(new QuantiteJour(attribution.getUniteTraitementAvant().getDureeIccp().toString()));
        carenceICCP.setPeriodeApplicationCarence(attribution.getUniteTraitementAvant().getPeriode());
        carenceICCP.setDateFinPeriodeOrigine(attribution.getUniteTraitementAvant().getPeriode().getDebut());
        carenceICCP.setQuantiteInitial(new QuantiteJour(attribution.getUniteTraitementAvant().getDureeIccp().toString()));
        toutesLesCarences.add(carenceICCP);
      }
      if (attribution.getUniteTraitementAvant().getDureeIslr() != null)
      {
        CarenceIslr carenceISLR = new CarenceIslr();
        carenceISLR.setReliquat(new QuantiteJour(attribution.getUniteTraitementAvant().getDureeIslr().toString()));
        carenceISLR.setPeriodeApplicationCarence(attribution.getUniteTraitementAvant().getPeriode());
        carenceISLR.setDateFinPeriodeOrigine(attribution.getUniteTraitementAvant().getPeriode().getDebut());
        carenceISLR.setQuantiteInitial(new QuantiteJour(attribution.getUniteTraitementAvant().getDureeIslr().toString()));
        toutesLesCarences.add(carenceISLR);
      }
      if (attribution.getUniteTraitementAvant().getDureeDelaiAttente() != null)
      {
        Differe delaiAttente = new Differe();
        delaiAttente.setReliquat(new QuantiteJour(attribution.getUniteTraitementAvant().getDureeDelaiAttente().toString()));
        delaiAttente.setPeriodeApplicationCarence(attribution.getUniteTraitementAvant().getPeriode());
        delaiAttente.setDateFinPeriodeOrigine(attribution.getUniteTraitementAvant().getPeriode().getDebut());
        delaiAttente.setQuantiteInitial(new QuantiteJour(attribution.getUniteTraitementAvant().getDureeDelaiAttente().toString()));
        toutesLesCarences.add(delaiAttente);
      }
    }
    return toutesLesCarences;
  }
  
  protected ChronologiePeriodes recuperationDeToutesLesDesPeriodes(IndividuSpec individu, AttributionSpec attribution, Damj dateDebut, Damj dateFin)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodesGAEC = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesPEC = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSanctions = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesPourAttribution = new ChronologiePeriodes();
    ChronologiePeriodes chronologieRetraite = new ChronologiePeriodes();
    ChronologiePeriodes chronologieDemandeExpresse = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodeInterProduit = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodeSP = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesISLR = new ChronologiePeriodes();
    
    ChronologiePeriodes chronologiePeriodeEvtActualisation = new ChronologiePeriodes();
    Collection collectionPeriodesPourAttribution = new LinkedList();
    Collection decisionsSuivi = null;
    
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(chronologiePeriodeSP, attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(chronologiePeriodeSP, attribution);
    chronologiePeriodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(individu, dateDebut, dateFin);
    decisionsSuivi = OutillagePeriodes.recupererDecisionsSuivi(individu);
    chronologiePeriodesSanctions = GestionSanctions.recupererSanctions(decisionsSuivi);
    chronologiePeriodesPEC = OutillagePeriodes.recupererRadiations(individu);
    ObjetChronoPeriodeRetraite chronoRetraite = OutillagePeriodes.genererPeriodeRetraite(individu);
    chronologieRetraite.ajouter(chronoRetraite);
    chronologieDemandeExpresse = (ChronologiePeriodes)RechercheDecisionsInterruptives.rechercher(individu, dateDebut, attribution);
    
    chronologiePeriodeEvtActualisation = OutillagePeriodes.recupererPeriodesEvtActualisation(individu);
    
    chronologiePeriodeInterProduit = recuperationObjetPeriodeInterProduit(individu, "ASU", attribution, 1);
    
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesGAEC.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesPEC.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesSanctions.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologieRetraite.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologieDemandeExpresse.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeInterProduit.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeSP.mapperVersCollection());
    
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeEvtActualisation.mapperVersCollection());
    
    collectionPeriodesPourAttribution.addAll(getPeriodesInterProduitsSurAvantPourArce(individu, attribution));
    
    collectionPeriodesPourAttribution.addAll(getPeriodesInterProduitsSurAvantPourRfpe(individu, attribution));
    if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)attribution.getDemande(), 2)) {
      chronologiePeriodesPourAttribution.ajouter(new ObjetChronoPeriodeLimiteIndemnisationPMVS(((Attribution)attribution).getDateLimiteIndemnisation().lendemain(), attribution.getRsod()));
    }
    if (individu.getDateBlocageIndemnisation() != null)
    {
      PeriodeBlocageIndemnisation periodeBlocageIndemnisation = new PeriodeBlocageIndemnisation(individu.getDateBlocageIndemnisation().lendemain());
      
      collectionPeriodesPourAttribution.add(periodeBlocageIndemnisation);
    }
    chronologiePeriodesISLR = recupererPeriodeISLRAAjouter(individu, attribution);
    if ((chronologiePeriodesISLR != null) && (!chronologiePeriodesISLR.estVide())) {
      collectionPeriodesPourAttribution.addAll(chronologiePeriodesISLR.mapperVersCollection());
    }
    collectionPeriodesPourAttribution.addAll(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(attribution).mapperVersCollection());
    chronologiePeriodesPourAttribution.ajouter(collectionPeriodesPourAttribution);
    
    detectionActiviteConserve(attribution, chronologiePeriodesPourAttribution, dateDebut);
    
    enrichirPeriodeDisponibilite(attribution, individu);
    
    return chronologiePeriodesPourAttribution;
  }
  
  public void enrichirPeriodeDisponibilite(AttributionSpec attribution, IndividuSpec individu)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(individu, attribution.getDateAttribution(), null);
    
    periodesGAEC.iterer();
    while (periodesGAEC.encoreSuivant())
    {
      ObjetChronoPeriode periode = (ObjetChronoPeriode)periodesGAEC.elementSuivant();
      if ((periode instanceof PeriodeDisponibilite))
      {
        ActiviteSalarie ae = (ActiviteSalarie)rechercherPeriodePasseProfessionnel(individu, ((PeriodeDisponibilite)periode).getIdContratTravail());
        if ((ae != null) && (ae.estUneFct()) && (ae.estAtteste()))
        {
          ((PeriodeDisponibilite)periode).setEstFctPresente(true);
          ((PeriodeDisponibilite)periode).setDateFCT(ae.getDateFin());
        }
        ((PeriodeDisponibilite)periode).setEstPeriodeEnCours(attribution.getDateAttribution().estApres(((PeriodeDisponibilite)periode).getDateDebut()));
      }
    }
  }
  
  public PeriodeGaecSpec rechercherPeriodePasseProfessionnel(IndividuSpec individu, String identifiantPeriode)
  {
    Iterator iter;
    if (identifiantPeriode != null)
    {
      ChronologiePeriodes chronoPasseProfessionnelCourante = individu.getChronoPeriodePasseProfessionnel();
      if ((chronoPasseProfessionnelCourante != null) && (!chronoPasseProfessionnelCourante.estVide())) {
        for (iter = chronoPasseProfessionnelCourante.iterer(); iter.hasNext();)
        {
          PeriodeGaecSpec periodePasseProfessionnelRecherchee = (PeriodeGaecSpec)iter.next();
          if (periodePasseProfessionnelRecherchee.getIdentifiant().contains(identifiantPeriode)) {
            return periodePasseProfessionnelRecherchee;
          }
        }
      }
    }
    return null;
  }
  
  private void detectionActiviteConserve(AttributionSpec attribution, ChronologiePeriodes chronologiePeriodesPourAttribution, Damj dateAttribOuPjp)
    throws CoucheLogiqueException
  {
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(dateAttribOuPjp);
    FabriqueStrategieConvention2014 fabriqueAre14 = FabriqueStrategieConvention2014.getInstance();
    StrategieConventionARE14Spec strategieARE14 = (StrategieConventionARE14Spec)fabriqueAre14.getStrategie(critere);
    if (strategieARE14.estApresConventionARE14())
    {
      Iterator ite = ((AttributionAssuranceSpec)attribution).getListeActiviteConservee().iterer();
      while (ite.hasNext())
      {
        TravailSpec activite = (TravailSpec)ite.next();
        if ((!(activite instanceof TravailNonSalarie)) && (activite.getDateFin().estContenueDans(new Periode(dateAttribOuPjp, Damj.FIN_DES_TEMPS))))
        {
          boolean estSup122jours = activite.getPeriode().getDuree() >= 122;
          if ((estSup122jours) && (RechercheConditionChomageInvolontaire.getInstance().determinerChomageNonLegitime(activite)) && (!estDecisionneeSuiteActiviteConserveePerdue(activite, attribution)))
          {
            chronologiePeriodesPourAttribution.ajouter(new ObjetChronoBlocageM12(activite.getDateFin(), attribution.getRsod()));
            chronologiePeriodesPourAttribution.ajouter(new ObjetChronoPeriodeBlocagePerteActiviteConservee(activite.getDateFin().lendemain(), attribution.getRsod()));
            
            genererEnqueteSuiteOrdonnancementExamen(attribution, activite.getDateFin());
          }
        }
      }
    }
  }
  
  private boolean genererEnqueteSuiteOrdonnancementExamen(AttributionSpec attribution, Damj dateFCT)
    throws CoucheLogiqueException
  {
    boolean resultat = false;
    if (dateFCT.estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Ordonnancement examen")))
    {
      GestionSuivi.enregistrerEnquetePbjcNcpSurAvant(attribution, dateFCT, 48, 0, true, null);
      
      resultat = true;
    }
    return resultat;
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec attribution, ObjetChronoPeriode periode, PeriodeAnalyseSpec pa, ArretProduitAvecRaison arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    if (((periode instanceof ObjetChronoBlocageM12)) && ((periode.getDateDebut().estAvant(pa.getDateFin())) || ((periode.getDateDebut().coincideAvec(pa.getDateFin())) && (arretProduitAvecRaison.getPeriodesInterruptivesDefinitives().size() == 1) && (estBlocageM12(arretProduitAvecRaison)) && (periode.getDateDebut().lendemain().coincideAvec(arretProduitAvecRaison.recupereLendemainDateArret())) && ((arretProduitAvecRaison.recupererLendemainDateArretIndemnisation() == null) || (!periode.getDateDebut().lendemain().coincideAvec(arretProduitAvecRaison.recupererLendemainDateArretIndemnisation())))))) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M12", periode.getDateDebut(), ""), attribution.getDemandeur());
    }
  }
  
  private static boolean estBlocageM12(ArretProduitAvecRaison arretProduitAvecRaison)
  {
    for (Object o : arretProduitAvecRaison.getPeriodesInterruptivesDefinitives()) {
      if ((o instanceof ObjetChronoPeriodeBlocagePerteActiviteConservee)) {
        return true;
      }
    }
    return false;
  }
  
  public boolean estDecisionneeSuiteActiviteConserveePerdue(TravailSpec p_activite, AttributionSpec attribution)
  {
    Map<TravailSpec, DemandeSpec> maps = OutilsRevisions.getMapFctsAssociees(attribution.getDemandeur());
    DemandeSpec demande = (DemandeSpec)maps.get(p_activite);
    return (demande != null) && (demande.estDecisionnee());
  }
  
  public boolean estContexteDeRevisionSurPecArce(AttributionSpec attribution, ObjetChronoPeriodePriseEnCharge periodePEC)
  {
    return ((attribution instanceof RevisionSpec)) && (periodePEC.estDeTypeArce());
  }
  
  protected static void mettreAJour(CalendrierExecutionAvant calendrierExecutionAvant, Attribution attribution, Collection listeCarences)
  {
    boolean estUnePoursuite = false;
    Chronologie uts = calendrierExecutionAvant.getChronologieUnitesTraitements();
    UniteTraitementAvant derniereUtAvant = (UniteTraitementAvant)uts.dernierElement();
    DureeConsommableAvant duree = null;
    
    ObjetChronoPeriode periodeOrigineReliquat = null;
    
    Collection carences = null;
    if ((attribution instanceof Poursuite))
    {
      carences = getCarencesValides(construireCarencesPoursuite(attribution), attribution.getDateAttribution());
      derniereUtAvant = ((Poursuite)attribution).getUniteTraitementAvant();
      estUnePoursuite = true;
    }
    else
    {
      Collection listeCarrences = null;
      if (OutilsTrancheCalcul.estTrancheActive(attribution))
      {
        TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
        listeCarrences = tranche.getListeDelaisReports();
      }
      else
      {
        listeCarrences = attribution.getListeCarences();
      }
      carences = getCarencesValides(listeCarrences, attribution.getDateAttribution());
    }
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(carences);
    PreavisLegal preavisLegal = getPreavisLegalAConsommer(carences);
    CarenceIccp differeStandard = getDiffereStandardAConsommer(carences);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(carences);
    Differe delaiAttente = getDelaiAttenteAConsommer(carences);
    if (pmc != null)
    {
      if ((derniereUtAvant != null) && (!estUnePoursuite))
      {
        duree = derniereUtAvant.getDureePmcEnFinUT();
        pmc.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        pmc.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          pmc.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(pmc.getOrigine().getDateDebut(), calendrierExecutionAvant.getDernierJourAvant());
          pmc.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      listeCarences.add(pmc);
    }
    if (preavisLegal != null)
    {
      if ((derniereUtAvant != null) && (!estUnePoursuite))
      {
        duree = derniereUtAvant.getDureePreavisLegalEnFinUT();
        preavisLegal.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        preavisLegal.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          preavisLegal.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(preavisLegal.getOrigine().getDateDebut(), calendrierExecutionAvant.getDernierJourAvant());
          preavisLegal.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      listeCarences.add(preavisLegal);
    }
    if (differeStandard != null)
    {
      if ((derniereUtAvant != null) && (!estUnePoursuite))
      {
        duree = derniereUtAvant.getDureeDiffereStandardEnFinUT();
        differeStandard.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        differeStandard.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          differeStandard.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(differeStandard.getOrigine().getDateDebut(), calendrierExecutionAvant.getDernierJourAvant());
          differeStandard.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      listeCarences.add(differeStandard);
    }
    if (differeSpecifique != null)
    {
      if ((derniereUtAvant != null) && (!estUnePoursuite))
      {
        duree = derniereUtAvant.getDureeDiffereSpecifiqueEnFinUT();
        differeSpecifique.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        differeSpecifique.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          differeSpecifique.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(differeSpecifique.getOrigine().getDateDebut(), Damj.max(calendrierExecutionAvant.getDernierJourAvant(), differeSpecifique.getOrigine().getDateFin()));
          differeSpecifique.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      listeCarences.add(differeSpecifique);
    }
    if (delaiAttente != null)
    {
      if ((derniereUtAvant != null) && (!estUnePoursuite))
      {
        duree = derniereUtAvant.getDureeDelaiAttenteEnFinUT();
        delaiAttente.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        delaiAttente.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          delaiAttente.setReliquat(duree.getQuantiteInitial());
        }
      }
      listeCarences.add(delaiAttente);
    }
  }
  
  public static Collection getCarencesValides(Collection carences, Damj dateAttribution)
  {
    HashMap mapCarencesParPeriodeOrigine = new HashMap();
    HashMap mapDatesFinPmcEtStandardEtSpecifique = new HashMap();
    
    Damj dateFinPmcEtStandardEtSpecifiqueMax = null;
    Collection listeCarencesParPeriodeOrigineMax = null;
    
    Iterator iterator = carences.iterator();
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if (!(carence instanceof Differe))
      {
        Collection listeCarencesParPeriodeOrigine = null;
        if ((carence instanceof PreavisMesureConservatoireIndemnisable))
        {
          if ((carence.getOrigine() instanceof ActiviteSalarie)) {
            listeCarencesParPeriodeOrigine = (Collection)mapCarencesParPeriodeOrigine.get(ConstitutionPMC.determinerDateDebutPMC((ActiviteSalarie)carence.getOrigine()));
          } else {
            listeCarencesParPeriodeOrigine = (Collection)mapCarencesParPeriodeOrigine.get(carence.getDateFinPeriodeOrigine().lendemain());
          }
        }
        else if ((carence.getOrigine() instanceof ActiviteSalarie)) {
          listeCarencesParPeriodeOrigine = (Collection)mapCarencesParPeriodeOrigine.get(((ActiviteSalarie)carence.getOrigine()).getIdentifiant());
        } else {
          listeCarencesParPeriodeOrigine = (Collection)mapCarencesParPeriodeOrigine.get(carence.getOrigine());
        }
        if (listeCarencesParPeriodeOrigine == null)
        {
          listeCarencesParPeriodeOrigine = new ArrayList();
          if ((carence.getOrigine() instanceof ActiviteSalarie)) {
            mapCarencesParPeriodeOrigine.put(((ActiviteSalarie)carence.getOrigine()).getIdentifiant(), listeCarencesParPeriodeOrigine);
          } else {
            mapCarencesParPeriodeOrigine.put(carence.getOrigine(), listeCarencesParPeriodeOrigine);
          }
        }
        listeCarencesParPeriodeOrigine.add(carence);
      }
    }
    Iterator iteratorEnsembleCarences = mapCarencesParPeriodeOrigine.keySet().iterator();
    while (iteratorEnsembleCarences.hasNext())
    {
      Object objetChronoPeriode = iteratorEnsembleCarences.next();
      Collection listeCarencesParPeriodeOrigine = (Collection)mapCarencesParPeriodeOrigine.get(objetChronoPeriode);
      
      Iterator iteratorCarences = listeCarencesParPeriodeOrigine.iterator();
      while (iteratorCarences.hasNext())
      {
        CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iteratorCarences.next();
        
        Damj dateFinPmcEtStandardEtSpecifique = (Damj)mapDatesFinPmcEtStandardEtSpecifique.get(carence.getOrigine());
        if (dateFinPmcEtStandardEtSpecifique == null) {
          dateFinPmcEtStandardEtSpecifique = carence.getDateFinPeriodeOrigine();
        }
        dateFinPmcEtStandardEtSpecifique = dateFinPmcEtStandardEtSpecifique.deplacerVersAvant(new DureeCalendaire(0, 0, carence.getQuantiteInitial().getValeurEntiere()));
        
        mapDatesFinPmcEtStandardEtSpecifique.put(carence.getOrigine(), dateFinPmcEtStandardEtSpecifique);
        if ((dateFinPmcEtStandardEtSpecifiqueMax == null) || (dateFinPmcEtStandardEtSpecifique.estApres(dateFinPmcEtStandardEtSpecifiqueMax)))
        {
          dateFinPmcEtStandardEtSpecifiqueMax = dateFinPmcEtStandardEtSpecifique;
          listeCarencesParPeriodeOrigineMax = listeCarencesParPeriodeOrigine;
        }
      }
    }
    if (listeCarencesParPeriodeOrigineMax == null) {
      listeCarencesParPeriodeOrigineMax = new ArrayList();
    }
    Differe delaiAttente = getDelaiAttenteAConsommer(carences);
    if (delaiAttente != null) {
      if ((delaiAttente.getQuantiteInitial().getValeurEntiere() == 7) || (dateFinPmcEtStandardEtSpecifiqueMax == null))
      {
        listeCarencesParPeriodeOrigineMax.add(delaiAttente);
      }
      else if (dateFinPmcEtStandardEtSpecifiqueMax != null)
      {
        Damj dateFinDelaiAttente = dateAttribution.deplacerVersAvant(new DureeCalendaire(0, 0, delaiAttente.getQuantiteInitial().getValeurEntiere()));
        if (dateFinDelaiAttente.estApresOuCoincideAvec(dateFinPmcEtStandardEtSpecifiqueMax))
        {
          listeCarencesParPeriodeOrigineMax = new ArrayList();
          listeCarencesParPeriodeOrigineMax.add(delaiAttente);
        }
      }
    }
    return listeCarencesParPeriodeOrigineMax;
  }
  
  private static Damj rechercheDebutDiffere(Collection carences, ChronologiePeriodes chronoPeriodes, Damj dateOd)
  {
    Damj dateDebutDiffere = dateOd;
    Damj dateFinCarences = rechercheDateFinCarences(carences);
    ChronologiePeriodes chronologiePeriodeMaladie = new ChronologiePeriodes();
    if ((dateFinCarences != null) && (dateOd.compareTo(dateFinCarences) <= 0)) {
      dateDebutDiffere = dateFinCarences.lendemain();
    }
    chronoPeriodes.iterer();
    while (chronoPeriodes.encoreSuivant())
    {
      ObjetChronoPeriode periode = (ObjetChronoPeriode)chronoPeriodes.elementSuivant();
      if (((periode instanceof PeriodeEvenementPersonnel)) || ((periode instanceof PeriodeFormation)) || ((periode instanceof PeriodeInterStageFormation)) || ((periode instanceof PeriodeAbsenceAuPointage))) {
        chronologiePeriodeMaladie.ajouter(periode);
      }
    }
    dateDebutDiffere = rechercheTrouMaladie(dateDebutDiffere, chronologiePeriodeMaladie);
    return dateDebutDiffere;
  }
  
  private static Damj rechercheDateFinCarences(Collection carences)
  {
    Damj dateFinCarences = null;
    Iterator iterator = carences.iterator();
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if (!(carence instanceof Differe))
      {
        if (dateFinCarences == null) {
          dateFinCarences = carence.getDateFinPeriodeOrigine();
        }
        dateFinCarences = dateFinCarences.deplacerVersAvant(new DureeCalendaire(0, 0, carence.getQuantiteInitial().getValeurEntiere()));
      }
    }
    return dateFinCarences;
  }
  
  private static Damj rechercheTrouMaladie(Damj dateDebutDiffere, ChronologiePeriodes chronoPeriodesMaladie)
  {
    chronoPeriodesMaladie.iterer();
    while (chronoPeriodesMaladie.encoreSuivant())
    {
      ObjetChronoPeriode periodeMaladie = (ObjetChronoPeriode)chronoPeriodesMaladie.elementSuivant();
      if ((periodeMaladie.getDateDebut().estAvantOuCoincideAvec(dateDebutDiffere)) && (periodeMaladie.getDateFin().estApresOuCoincideAvec(dateDebutDiffere))) {
        return rechercheTrouMaladie(periodeMaladie.getDateFin().lendemain(), chronoPeriodesMaladie);
      }
    }
    return dateDebutDiffere;
  }
  
  protected ChronologiePeriodes recuperationObjetPeriodeInterProduit(IndividuSpec individu, String gamme, AttributionSpec attrib, int typeDateDebutPeriodeInterProduits)
    throws CoucheLogiqueException
  {
    Iterator iterateur = null;
    AttributionSpec attribution = null;
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    ChronologiePeriodes listePeriodesInterProduit = new ChronologiePeriodes();
    
    iterateur = individu.getListeAttributionsExecutables().iterator();
    while (iterateur.hasNext())
    {
      attribution = (AttributionSpec)iterateur.next();
      if ((attribution.getDemande() != null) && 
        (attribution.getGamme().getNomUnique().equals(gamme)) && (attribution != attrib))
      {
        objetChronoPeriodeInterProduits = getPeriodeInterProduit(typeDateDebutPeriodeInterProduits, attribution);
        if (objetChronoPeriodeInterProduits != null) {
          listePeriodesInterProduit.ajouter(objetChronoPeriodeInterProduits);
        }
      }
    }
    return listePeriodesInterProduit;
  }
  
  protected Collection getPeriodesInterProduitsSurAvantPourArce(IndividuSpec individu, AttributionSpec attrib)
  {
    Iterator iterateur = null;
    AttributionSpec attribution = null;
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    List listePeriodesInterProduit = new ArrayList();
    Damj dateDepart = null;
    
    iterateur = individu.getListeAttributionsExecutables().iterator();
    while (iterateur.hasNext())
    {
      attribution = (AttributionSpec)iterateur.next();
      if ((attribution.estValidee()) && (!attribution.estEnReexamen()) && (attribution.getProduitExecution().getNomUnique().equals("INR_RCE04_01")) && (attribution != attrib) && (attribution.getDateEffet() != null))
      {
        dateDepart = attribution.getDateEffet();
        objetChronoPeriodeInterProduits = new ObjetChronoPeriodeInterProduits(dateDepart, dateDepart, 1, attribution);
        if (objetChronoPeriodeInterProduits != null) {
          listePeriodesInterProduit.add(objetChronoPeriodeInterProduits);
        }
      }
    }
    return listePeriodesInterProduit;
  }
  
  protected Collection getPeriodesInterProduitsSurAvantPourRfpe(IndividuSpec individu, AttributionSpec attrib)
  {
    Iterator iterateur = null;
    AttributionSpec attribution = null;
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    List listePeriodesInterProduit = new ArrayList();
    
    iterateur = individu.getListeAttributionsExecutables().iterator();
    while (iterateur.hasNext())
    {
      attribution = (AttributionSpec)iterateur.next();
      if ((attribution.estValidee()) && (!attribution.estEnReexamen()) && (attribution.getProduitExecution().getNomUnique().equals("FOR_RFP04_01")) && (attribution != attrib) && (attribution.getDateEffet() != null))
      {
        ProduitAbstrait produitRFPE = ProduitForRfp04P01.getInstance();
        ProduitForDelegueSpec produitDelegueRFPE = (ProduitForDelegueSpec)produitRFPE.getProduitDelegue();
        ActionFormation actionFormation = produitDelegueRFPE.getActionFormation(attribution);
        if (actionFormation != null)
        {
          objetChronoPeriodeInterProduits = new ObjetChronoPeriodeInterProduits(actionFormation.getDateDebut(), actionFormation.getDateFin(), 7, attribution);
          if (objetChronoPeriodeInterProduits != null) {
            listePeriodesInterProduit.add(objetChronoPeriodeInterProduits);
          }
        }
      }
    }
    return listePeriodesInterProduit;
  }
  
  private ObjetChronoPeriodeInterProduits getPeriodeInterProduit(int typeDateDebutPeriodeInterProduits, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    Damj dateDepart = null;
    Damj dateFin = Damj.FIN_DES_TEMPS;
    switch (typeDateDebutPeriodeInterProduits)
    {
    case 1: 
      dateDepart = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
      dateFin = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
      break;
    case 2: 
      dateDepart = attribution.getPji();
      break;
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_UT_TYPE_PER_INTER_PROD_INCONNU", "Type de période inter-produit inconnu", null);
    }
    objetChronoPeriodeInterProduits = new ObjetChronoPeriodeInterProduits(dateDepart, dateFin, typeDateDebutPeriodeInterProduits, attribution);
    
    return objetChronoPeriodeInterProduits;
  }
  
  protected Damj rechercherDateDebutAvant(AttributionAssuranceCgeSpec attribution)
    throws CoucheLogiqueException
  {
    ElementChomageSansRuptureSpec elementChomageSansRupture = null;
    Collection carences = null;
    if ((attribution instanceof Poursuite)) {
      carences = getCarencesValides(construireCarencesPoursuite(attribution), attribution.getDateAttribution());
    } else {
      carences = getCarencesValides(attribution.getListeCarences(), attribution.getDateAttribution());
    }
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(carences);
    PreavisLegal preavisLegal = getPreavisLegalAConsommer(carences);
    CarenceIccp differeStandard = getDiffereStandardAConsommer(carences);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(carences);
    
    elementChomageSansRupture = attribution.getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension()) && (elementChomageSansRupture.estUnContexteDeRupturePendantSuspension()) && (elementChomageSansRupture.getDateRepriseActivite() != null)) {
      return Damj.max(elementChomageSansRupture.getDateRepriseActivite(), attribution.getDateAttribution());
    }
    if (pmc != null)
    {
      if ((pmc.getOrigine() instanceof ActiviteSalarie)) {
        return ConstitutionPMC.determinerDateDebutPMC((ActiviteSalarie)pmc.getOrigine());
      }
      return pmc.getDateFinPeriodeOrigine().lendemain();
    }
    if (preavisLegal != null) {
      return preavisLegal.getDateFinPeriodeOrigine().lendemain();
    }
    if (differeStandard != null) {
      return differeStandard.getDateFinPeriodeOrigine().lendemain();
    }
    if (differeSpecifique != null) {
      return differeSpecifique.getDateFinPeriodeOrigine().lendemain();
    }
    return OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
  }
  
  public static PreavisMesureConservatoireNonIndemnisable getPmcAConsommer(Collection carences)
  {
    Iterator iterator = carences.iterator();
    PreavisMesureConservatoireNonIndemnisable pmc = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof PreavisMesureConservatoireNonIndemnisable)) {
        pmc = (PreavisMesureConservatoireNonIndemnisable)carence;
      }
    }
    return pmc;
  }
  
  public static PreavisLegal getPreavisLegalAConsommer(Collection carences)
  {
    Iterator iterator = carences.iterator();
    PreavisLegal preavisLegal = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof PreavisLegal)) {
        preavisLegal = (PreavisLegal)carence;
      }
    }
    return preavisLegal;
  }
  
  public static CarenceIccp getDiffereStandardAConsommer(Collection carences)
  {
    Iterator iterator = carences.iterator();
    CarenceIccp differeStandard = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof CarenceIccp)) {
        differeStandard = (CarenceIccp)carence;
      }
    }
    return differeStandard;
  }
  
  public static CarenceIslr getDiffereSpecifiqueAConsommer(Collection carences)
  {
    Iterator iterator = carences.iterator();
    CarenceIslr differeSpecifique = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof CarenceIslr)) {
        differeSpecifique = (CarenceIslr)carence;
      }
    }
    return differeSpecifique;
  }
  
  public static Differe getDelaiAttenteAConsommer(Collection carences)
  {
    return (Differe)OutilCarence.trouverCarence(carences, "Différé");
  }
  
  public ResultatAvant postTraitementResultatDeterminationEtatAvant(AttributionSpec attribution)
  {
    CalendrierExecutionAvantSpec calendrierAvant = attribution.getCalendrierExecutionAvant();
    Damj dernierJourAvant = calendrierAvant.getDernierJourAvant();
    Collection carencesEffectives = new ArrayList();
    ObjetChronoPeriode periodeOrigineReliquat = new ObjetChronoPeriodeConcrete(dernierJourAvant, dernierJourAvant);
    EtatAuDernierJourAvant etatAuDernierJourAvant = calendrierAvant.getEtatAuDernierJourAvant();
    if (etatAuDernierJourAvant.getReliquatPMC() != null)
    {
      PreavisMesureConservatoireNonIndemnisable pmc = new PreavisMesureConservatoireNonIndemnisable();
      pmc.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatPMC().toString()));
      pmc.setOrigineReliquat(periodeOrigineReliquat);
      pmc.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationPMC());
      pmc.setQuantiteInitial(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialePMC().toString()));
      carencesEffectives.add(pmc);
    }
    if (etatAuDernierJourAvant.getReliquatICCP() != null)
    {
      CarenceIccp carenceICCP = new CarenceIccp();
      carenceICCP.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatICCP().toString()));
      carenceICCP.setOrigineReliquat(periodeOrigineReliquat);
      carenceICCP.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationICCP());
      carenceICCP.setQuantiteInitial(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialeICCP().toString()));
      carencesEffectives.add(carenceICCP);
    }
    if (etatAuDernierJourAvant.getReliquatISLR() != null)
    {
      CarenceIslr carenceISLR = new CarenceIslr();
      carenceISLR.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatISLR().toString()));
      carenceISLR.setOrigineReliquat(periodeOrigineReliquat);
      carenceISLR.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationISLR());
      carenceISLR.setQuantiteInitial(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialeISLR().toString()));
      carencesEffectives.add(carenceISLR);
    }
    if (etatAuDernierJourAvant.getReliquatDelaiAttente() != null)
    {
      Differe delaiAttente = new Differe();
      delaiAttente.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatDelaiAttente().toString()));
      delaiAttente.setOrigineReliquat(periodeOrigineReliquat);
      delaiAttente.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationDelaiAttente());
      delaiAttente.setQuantiteInitial(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialeDelaiAttente().toString()));
      carencesEffectives.add(delaiAttente);
    }
    ResultatAvant resultat = new ResultatAvant(dernierJourAvant.lendemain(), (List)carencesEffectives, etatAuDernierJourAvant.isDelaiAttenteEntame());
    resultat.setPeriodePECEvenementReducteur(calendrierAvant.getEtatAuDernierJourAvant().getPeriodePECEvenementReducteur());
    resultat.setEtat(etatAuDernierJourAvant.getEtat());
    
    resultat.setPremierJourAvant(calendrierAvant.getPremierJourAvant());
    resultat.setDernierJourAvant(calendrierAvant.getDernierJourAvant());
    return resultat;
  }
  
  public ArrayList mettreAJourCarrenceSurRevisionHorsPec(Collection pCarences, Damj pDernierJourAvant)
  {
    ArrayList listeCarence = new ArrayList();
    
    ObjetChronoPeriode periodeOrigineReliquat = null;
    
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(pCarences);
    PreavisLegal preavisLegal = getPreavisLegalAConsommer(pCarences);
    CarenceIccp differeStandard = getDiffereStandardAConsommer(pCarences);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(pCarences);
    Differe delaiAttente = getDelaiAttenteAConsommer(pCarences);
    if (pmc != null)
    {
      pmc.setReliquat(pmc.getQuantiteInitial());
      periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(pmc.getOrigine().getDateDebut(), pmc.getDateFinPeriodeOrigine());
      pmc.setOrigineReliquat(periodeOrigineReliquat);
      listeCarence.add(pmc);
    }
    if (preavisLegal != null)
    {
      preavisLegal.setReliquat(preavisLegal.getQuantiteInitial());
      periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(preavisLegal.getOrigine().getDateDebut(), preavisLegal.getDateFinPeriodeOrigine());
      preavisLegal.setOrigineReliquat(periodeOrigineReliquat);
      listeCarence.add(preavisLegal);
    }
    if (differeStandard != null)
    {
      differeStandard.setReliquat(differeStandard.getQuantiteInitial());
      periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(differeStandard.getOrigine().getDateDebut(), differeStandard.getDateFinPeriodeOrigine());
      differeStandard.setOrigineReliquat(periodeOrigineReliquat);
      listeCarence.add(differeStandard);
    }
    if (differeSpecifique != null)
    {
      differeSpecifique.setReliquat(differeSpecifique.getQuantiteInitial());
      periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(differeSpecifique.getOrigine().getDateDebut(), differeSpecifique.getDateFinPeriodeOrigine());
      differeSpecifique.setOrigineReliquat(periodeOrigineReliquat);
      listeCarence.add(differeSpecifique);
    }
    if (delaiAttente != null)
    {
      delaiAttente.setReliquat(delaiAttente.getQuantiteInitial());
      listeCarence.add(delaiAttente);
    }
    return listeCarence;
  }
  
  private static Differe getDiffere(Collection carences)
  {
    return (Differe)OutilCarence.trouverCarence(carences, "Différé");
  }
  
  private ObjetChronoPeriodeSuspensionIslr creerObjetSuspensionIslr(ObjetChronoPeriodeSuspensionIslr periodeIslr, ProduitSpec produit)
    throws CoucheLogiqueException
  {
    if (FabriqueStrategieAppliquerISLR.getInstance().recupererDateApplication().estAvantOuCoincideAvec(periodeIslr.getDateFct()))
    {
      QuantiteEuro montant = ConstitutionISLR.getInstance().calculeISLR(periodeIslr.getActivite().getListeIndemnites(), periodeIslr.getActivite().getCodeMotifFin(), periodeIslr.getActivite().getCategorieEmploiParticulier(), periodeIslr.getDateFct());
      if ((montant != null) && (montant.getValeur().signum() == 1))
      {
        CritereStrategie critere = new CritereStrategie();
        critere.setDatePivot(periodeIslr.getDateFct());
        critere.setProduit(produit);
        StrategieSpec strategie = FabriqueStrategieISLR.getInstance().getStrategie(critere);
        FormuleDelaiReportSpec formuleCarenceIslr = ((StrategieFormuleISLRSpec)strategie).getFormuleISLR();
        
        BaseDelaiReport bdr = new BaseDelaiReport();
        bdr.setDateFg(periodeIslr.getDateFct());
        bdr.setQuantiteEuroIslr(montant);
        bdr.setMotifRupture(periodeIslr.getActivite().getCodeMotifFin());
        
        QuantiteJour jours = (QuantiteJour)formuleCarenceIslr.appliquerFormule(bdr);
        if ((jours != null) && (jours.getNombreJours() > 0))
        {
          periodeIslr.setDateFin(periodeIslr.getDateDebut().deplacerVersAvant(new DureeCalendaire(0, 0, jours.getNombreJours() - 1)));
          ObjetChronoPeriode periodeGlobaleAAjouter = (ObjetChronoPeriode)periodeIslr.copie();
          periodeIslr.setPeriodeGlobaleSuspensionISLR((ObjetChronoPeriodeSuspensionIslr)periodeGlobaleAAjouter);
          return periodeIslr;
        }
      }
    }
    return null;
  }
  
  public ChronologiePeriodes recupererPeriodeISLRAAjouter(IndividuSpec individu, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodesActiviteCalcul = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
    ChronologiePeriodes chronoPeriodesIndemnisation = RechercherPeriodeIndemnisation.getListePeriodesIndemnisationAssurance(individu, attribution.getDateAttribution());
    ChronologiePeriodes chronoPeriodesISLRAAjouter = new ChronologiePeriodes();
    ChronologiePeriodes chronoFctAvecIslr = MapperPeriodesCalcul.recupererFctIslr(chronologiePeriodesActiviteCalcul, Damj.FIN_DES_TEMPS);
    chronoFctAvecIslr.iterer();
    while (chronoFctAvecIslr.encoreSuivant())
    {
      ObjetChronoPeriodeSuspensionIslr islr = (ObjetChronoPeriodeSuspensionIslr)chronoFctAvecIslr.elementSuivant();
      if (islr.getDateFct().estApresOuCoincideAvec(attribution.getDateAttribution()))
      {
        ObjetChronoPeriodeSuspensionIslr periodeIslrAjouter = creerObjetSuspensionIslr(islr, attribution.getProduit());
        if (periodeIslrAjouter != null) {
          chronoPeriodesISLRAAjouter.ajouter(periodeIslrAjouter);
        }
      }
      else
      {
        CritereStrategie critere = new CritereStrategie();
        critere.setDatePivot(islr.getDateFct());
        StrategieAppliquerISLRSpec strategieISLR = (StrategieAppliquerISLRSpec)FabriqueStrategieAppliquerISLR.getInstance().getStrategie(critere);
        if (!strategieISLR.doitAppliquerISLR(chronoPeriodesIndemnisation, islr.getDateFct()))
        {
          ObjetChronoPeriodeSuspensionIslr periodeIslrAjouter = creerObjetSuspensionIslr(islr, attribution.getProduit());
          if (periodeIslrAjouter != null) {
            chronoPeriodesISLRAAjouter.ajouter(periodeIslrAjouter);
          }
        }
      }
    }
    return chronoPeriodesISLRAAjouter;
  }
  
  public Collection<?> recupererCarrence(AttributionSpec attribution)
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
    Collection listeCarrence = tranche.getListeDelaisReports();
    if ((attribution instanceof Poursuite)) {
      listeCarrence = construireCarencesPoursuite(attribution);
    }
    return listeCarrence;
  }
  
  public Damj rechercherPremierJourAvant(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
    return rechercherDateDebutAvant((Attribution)attribution, tranche);
  }
  
  public ChronologiePeriodes recupererPeriodeGAEC(IndividuSpec individu, AttributionSpec attribution, Damj dateDebut, Damj dateFin)
    throws CoucheLogiqueException
  {
    return recuperationDeToutesLesDesPeriodes(attribution.getDemandeur(), attribution, dateDebut, dateFin);
  }
  
  public QualificationPeriodes qualificationPeriodesPourAvant(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Qualification qualification = new Qualification();
    return qualification.qualificationPeriodesPourAvant(chronologiePeriodes, attribution);
  }
  
  public void mettreAJourCarencesSurResultatAvant(CalendrierExecutionAvant calendrierExecutionAvant, AttributionSpec attribution, Collection listeCarences)
  {
    mettreAJour(calendrierExecutionAvant, (Attribution)attribution, listeCarences);
  }
  
  public Damj determinerPJIPoursuite(AttributionSpec attribution)
  {
    return ((Poursuite)attribution).getSaisieAntecedent().getPremierJourIndemnisable();
  }
  
  public boolean estUnContexteDeChomageEnCoursDeSuspensionAvecRupture(AttributionSpec attribution, Damj dateEtude)
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
    ElementChomageSansRupture elementChomageSansRupture = null;
    elementChomageSansRupture = tranche.getElementChomageSansRupture();
    return (dateEtude != null) && (elementChomageSansRupture != null) && (elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension()) && (elementChomageSansRupture.estUnContexteDeRupturePendantSuspension()) && (dateEtude.estApresOuCoincideAvec(elementChomageSansRupture.getDateRepriseActivite()));
  }
  
  public boolean estUnContexteDeChomageEnCoursDeSuspension(AttributionSpec attribution)
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
    ElementChomageSansRupture elementChomageSansRupture = null;
    elementChomageSansRupture = tranche.getElementChomageSansRupture();
    return (elementChomageSansRupture != null) && (elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension());
  }
  
  public ResultatAvant construireResultatAvantPourChomageSansRupture(AttributionSpec attribution, Collection listeCarence)
  {
    ArrayList listCarrence = new ArrayList();
    Collection carences = listeCarence;
    Iterator it = carences.iterator();
    while (it.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)it.next();
      carence.setReliquat(carence.getQuantiteInitial());
      if (!(carence instanceof Differe)) {
        carence.setOrigineReliquat(new ObjetChronoPeriodeConcreteCarence(carence.getOrigine().getDateDebut(), carence.getDateFinPeriodeOrigine()));
      }
      listCarrence.add(carence);
    }
    return new ResultatAvant(attribution.getDateAttribution(), listCarrence, false);
  }
  
  public boolean estUnProduitGerantLaRefonte()
  {
    return true;
  }
  
  public void convertionCachets(ChronologiePeriodes chronologiePeriodes)
  {
    if ((chronologiePeriodes != null) && (!chronologiePeriodes.estVide()))
    {
      PeriodeActiviteEmploiCalcul periodeActivite = null;
      Chronologie chronoPeriodesPAEC = chronologiePeriodes.copier(new FiltrePeriodeTravailCalculPAEC());
      if ((chronoPeriodesPAEC != null) && (!chronoPeriodesPAEC.estVide()))
      {
        chronoPeriodesPAEC.iterer();
        while (chronoPeriodesPAEC.encoreSuivant())
        {
          periodeActivite = (PeriodeActiviteEmploiCalcul)chronoPeriodesPAEC.elementSuivant();
          if ((periodeActivite.getQuantiteAffiliationCachets() != null) && (periodeActivite.getCachets() != null))
          {
            periodeActivite.setNombreHeures(periodeActivite.getNombreHeuresDeCompletude());
            
            CritereStrategie strategieHeureCachets = new CritereStrategie();
            strategieHeureCachets.setDatePivot(periodeActivite.getDateDebut());
            StrategieQuantiteAffiliationHeureAvecCachetSpec strategieHeureAvecCachet = (StrategieQuantiteAffiliationHeureAvecCachetSpec)FabriqueStrategieQuantiteAffiliationHeureAvecCachet.getInstance().getStrategie(strategieHeureCachets);
            
            strategieHeureAvecCachet.determinerQuantiteAffiliationHeureAvecCachet(periodeActivite, periodeActivite.getQuantiteAffiliationCachets());
          }
        }
      }
    }
  }
  
  public Damj determinerDateDepartAttribution(AttributionSpec attribution)
  {
    Damj dateDepartAttribution = attribution.getDateAttribution();
    if ((attribution instanceof Poursuite)) {
      dateDepartAttribution = ((Poursuite)attribution).getPjp();
    }
    return dateDepartAttribution;
  }
  
  public ChronologiePeriodes traitementPeriodesSegmentantes(Periode periode, UniteTraitementAvant utAvant, ChronologiePeriodes periodesSegmentantes)
    throws CoucheLogiqueException
  {
    return TraitementPeriodesAvant.traitementPeriodesSegmentantes(periode, utAvant, periodesSegmentantes);
  }
  
  public void creerDureeIndemnisation(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant)
  {
    DureeConsommableAvant dureePmc = new DureeConsommableAvant(0, new QuantiteJour("0"));
    DureeConsommableAvant dureePreavisLegal = new DureeConsommableAvant(4, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereStandard = new DureeConsommableAvant(1, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereSpecifique = new DureeConsommableAvant(2, new QuantiteJour("0"));
    DureeConsommableAvant dureeDelaiAttente = new DureeConsommableAvant(3, new QuantiteJour("0"));
    
    Collection carences = getCarencesValides(((AttributionAssuranceSpec)attribution).getListeCarences(), attribution.getDateAttribution());
    if ((attribution instanceof Poursuite)) {
      carences = getCarencesValides(construireCarencesPoursuite(attribution), attribution.getDateAttribution());
    }
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(carences);
    if (pmc != null) {
      dureePmc.setQuantiteInitial(pmc.getQuantiteInitial());
    }
    PreavisLegal preavisLegal = getPreavisLegalAConsommer(carences);
    if (preavisLegal != null) {
      dureePreavisLegal.setQuantiteInitial(preavisLegal.getQuantiteInitial());
    }
    CarenceIccp differeStandard = getDiffereStandardAConsommer(carences);
    if (differeStandard != null) {
      dureeDiffereStandard.setQuantiteInitial(differeStandard.getQuantiteInitial());
    }
    CarenceIslr differeIslr = getDiffereSpecifiqueAConsommer(carences);
    if (differeIslr != null) {
      dureeDiffereSpecifique.setQuantiteInitial(differeIslr.getQuantiteInitial());
    }
    Differe delaiAttente = getDelaiAttenteAConsommer(carences);
    if (delaiAttente != null) {
      dureeDelaiAttente.setQuantiteInitial(delaiAttente.getQuantiteInitial());
    }
    dureePmc.activer();
    if (dureePmc.getQuantiteInitial().getValeurEntiere() > 0)
    {
      Periode p = new Periode(calendrierAvant.getPremierJourAvant());
      utAvant.getConsommationPeriodes().setPeriodePmc(p);
    }
    utAvant.setDureePmcEnDebutUT(dureePmc);
    utAvant.setDureePreavisLegalEnDebutUT(dureePreavisLegal);
    utAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
    utAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
    utAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
  }
  
  public ArretProduitAvecRaison traitementPeriodesInterruptivesDefinitives(PeriodesPriseEnCompte periodesPriseEnCompte, UniteTraitementAvant utAvant, AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriode objetChronoPeriode = null;
    ListIterator iterator = null;
    ArretProduitAvecRaison retour = new ArretProduitAvecRaison();
    Damj dateDebutPremierePeriodeTraitee = null;
    ChronologiePeriodes periodesInterruptivesDefinitives = utAvant.getQualificationPeriodes().getPeriodesInterruptivesDefinitives();
    iterator = periodesInterruptivesDefinitives.iterer();
    while (iterator.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
      if ((dateDebutPremierePeriodeTraitee == null) || (objetChronoPeriode.getDateDebut().equals(dateDebutPremierePeriodeTraitee)))
      {
        dateDebutPremierePeriodeTraitee = objetChronoPeriode.getDateDebut();
        
        retour.ajoutePeriodeInterruptiveDefinitive(objetChronoPeriode);
        
        periodesPriseEnCompte.tronquePeriodesPriseEnCompteEnFin(objetChronoPeriode.getDateDebut().veille());
      }
      if ((estUneAEDVApresDispositif(objetChronoPeriode, attribution)) && (objetChronoPeriode.getDateFin().estApresOuCoincideAvec(attribution.getDateAttribution())) && (!estUneAttributionAREM(attribution)))
      {
        if (!estDemandeApresAEDv(objetChronoPeriode.getDateDebut(), attribution))
        {
          gestionEnqueteDrv(attribution, objetChronoPeriode);
          if (attribution.getDemandeur().getIndividuPbjcNcp() == null) {
            attribution.getDemandeur().setIndividuPbjcNcp(new IndividuPbjcNcp());
          }
          attribution.getDemandeur().getIndividuPbjcNcp().setDateAtteinteMoisNonPaye(objetChronoPeriode.getDateDebut().veille());
        }
        calendrierAvant.setDateDrv(objetChronoPeriode.getDateDebut());
      }
    }
    return retour;
  }
  
  private static boolean estDemandeApresAEDv(Damj dateAeDV, AttributionSpec attribution)
  {
    return OutilRecherche.rechercherDemandeSuivante(attribution.getDemande().getChronologieDemandesAssuranceSansCourante(), dateAeDV.veille(), null) != null;
  }
  
  private static boolean estUneAttributionAREM(AttributionSpec attribution)
  {
    return (attribution.getProduitExecution().getNomUnique().equals("ASU_MAY17_02")) || (attribution.getProduitExecution().getNomUnique().equals("ASU_MAY17_03"));
  }
  
  private static boolean estUneAEDVApresDispositif(ObjetChronoPeriode objetChrono, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return ((objetChrono instanceof ObjetChronoPeriodeAEDV)) && (objetChrono.getDateDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Application du nouveau dispositif sur les DRV"))) && (!((AttributionAssuranceSpec)attribution).estMaintenue());
  }
  
  private static void gestionEnqueteDrv(AttributionSpec attribution, ObjetChronoPeriode objetChronoPeriode)
  {
    if (attribution.getRsod() != null)
    {
      int rangEnquete = GestionSuivi.determinerRangEnqueteDRV(attribution, objetChronoPeriode);
      
      GestionSuivi.enregistrerEnquetePbjcNcpSurAvant(attribution, objetChronoPeriode.getDateDebut(), 39, rangEnquete, true, null);
    }
  }
  
  public boolean traitementPeriodesSuspensivesPourDebutConsommationDelaiAttente(PeriodeAnalyseSpec pa, QualificationPeriodes qualificationPeriodes, Damj dateDebutConsommationDelaiAttente)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesSuspensivesSurPa = (ChronologiePeriodes)qualificationPeriodes.getPeriodesSuspensives().copier(new FiltreChevauchePeriode(pa.getPeriode()));
    
    periodesSuspensivesSurPa.ajouter((ChronologiePeriodes)qualificationPeriodes.getPeriodesInterruptives().copier(new FiltreChevauchePeriode(pa.getPeriode())));
    ChronologiePeriodes chronologiePeriodesSuspensivesSurPeriode = new ChronologiePeriodes();
    FabriqueStrategieConvention2014 fab = new FabriqueStrategieConvention2014();
    CritereStrategie cs = new CritereStrategie();
    cs.setDatePivot(pa.getDateDebut());
    StrategieConventionARE14Spec strat = (StrategieConventionARE14Spec)fab.getStrategie(cs);
    
    periodesSuspensivesSurPa.iterer();
    while (periodesSuspensivesSurPa.encoreSuivant())
    {
      Temporel periode = periodesSuspensivesSurPa.elementSuivant();
      if (strat.estAvantConventionARE14())
      {
        if (periode.getDateDebut().estAvantOuCoincideAvec(dateDebutConsommationDelaiAttente)) {
          if ((periode instanceof DsmMaladie)) {
            chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
          } else if ((periode instanceof PeriodeEvenementPersonnel)) {
            chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
          } else if ((periode instanceof PeriodeAbsenceAuPointage)) {
            chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
          }
        }
        if ((periode instanceof ObjetChronoPeriodeSuspensionIndemnisation)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        }
      }
      else if (new Periode(dateDebutConsommationDelaiAttente, dateDebutConsommationDelaiAttente).chevauche(new Periode(periode.getDateDebut(), periode.getDateFin())))
      {
        if ((periode instanceof DsmMaladie)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        } else if ((periode instanceof PeriodeEvenementPersonnel)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        } else if ((periode instanceof PeriodeAbsenceAuPointage)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        } else if ((periode instanceof ObjetChronoPeriodeSuspensionIslr)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        } else if ((periode instanceof ObjetChronoPeriodeSuspensionIndemnisation)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        }
      }
      if ((periode instanceof PeriodeFormation)) {
        chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
      } else if ((periode instanceof PeriodeInterStageFormation)) {
        chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
      }
    }
    if (!chronologiePeriodesSuspensivesSurPeriode.estVide()) {
      return true;
    }
    return false;
  }
  
  public Quantite simulerImputationEtImputerLaQuantite(Quantite quantiteAImputer, DureeConsommableAvant dureeConcommableAvant, UniteTraitementAvant utAvant, Damj dateDebutConsommation)
    throws CoucheLogiqueException
  {
    return TraitementDureeConsommableAvant.simulerImputationEtImputerLaQuantite(quantiteAImputer, null, dureeConcommableAvant, utAvant, dateDebutConsommation, null);
  }
  
  public void simulerImputationEtImputerLaQuantiteEtTerminerProduit(Quantite quantiteAImputer, PeriodeAnalyseSpec pa, DureeConsommableAvant dureeConcommableAvant, UniteTraitementAvant utAvant, Damj dateDebutConsommation, ArretProduitAvecRaison arretProduitAvecRaison, Damj dateAttribution)
    throws CoucheLogiqueException
  {
    TraitementDureeConsommableAvant.simulerImputationEtImputerLaQuantiteEtTerminerProduit(quantiteAImputer, pa, dureeConcommableAvant, utAvant, dateDebutConsommation, arretProduitAvecRaison, dateAttribution);
  }
  
  public boolean estUnCarenceGereeParLeProduit(DureeConsommableAvant dureeAvant)
  {
    return (dureeAvant.getTypeDureeConsommable() == 0) || (dureeAvant.getTypeDureeConsommable() == 4) || (dureeAvant.getTypeDureeConsommable() == 1) || (dureeAvant.getTypeDureeConsommable() == 2) || (dureeAvant.getTypeDureeConsommable() == 3);
  }
  
  public boolean estCarenceTerminantProduit(DureeConsommableAvant dureeAvant)
  {
    return dureeAvant.getTypeDureeConsommable() == 3;
  }
  
  public Quantite traitementActiviteReduiteSurUt(UniteTraitementAvant utAvant, ChronologiePeriodes chronoPeriodesAnalyse, Damj dateDebutConsoSurPa, AttributionSpec attribution, QualificationPeriodes qualificationPeriodes, DureeConsommableAvant dureeDelaiAttente)
    throws CoucheLogiqueException
  {
    Periode periodePriseEnCompteSurUT = null;
    Quantite qteDec = new QuantiteJour("0");
    PeriodeAnalyseSpec pa = null;
    
    Periode periodeDebutConsoUtTheorique = new Periode(dateDebutConsoSurPa, utAvant.getDateFin());
    utAvant.setDateDebutConsoDATheorique(utAvant.getDateDebutConsoDATheorique() == null ? periodeDebutConsoUtTheorique.getDebut() : Damj.min(periodeDebutConsoUtTheorique.getDebut(), utAvant.getDateDebutConsoDATheorique()));
    Iterator ite = chronoPeriodesAnalyse.iterer();
    while (ite.hasNext())
    {
      pa = (PeriodeAnalyseSpec)ite.next();
      Periode paAvecDateDebutConso = new Periode(dateDebutConsoSurPa, pa.getDateFin());
      
      periodePriseEnCompteSurUT = recupererPeriodePriseEnCompte(attribution, pa.getPeriode());
      boolean estPecValide = (periodePriseEnCompteSurUT != null) && (periodePriseEnCompteSurUT.getDebut().estContenueDans(utAvant.getPeriode()));
      
      Periode periodeRestante = new Periode(Damj.max(periodeDebutConsoUtTheorique.getDebut(), periodePriseEnCompteSurUT.getDebut()), periodePriseEnCompteSurUT.getFin());
      Quantite quantiteRestante = new QuantiteJour(BigDecimal.valueOf(periodeRestante.getDuree()));
      ChronologiePeriodes chronoDecalage = DecoupageProratisation.decoupageEtProratisationPeriodesActivites(periodePriseEnCompteSurUT, qualificationPeriodes.getPeriodesDecalantes());
      if ((estUtAvantStatutDefinitif(chronoDecalage, attribution, utAvant)) || (estProduitASP(attribution)))
      {
        chronoDecalage = majQualification(utAvant, attribution, qualificationPeriodes, periodePriseEnCompteSurUT);
        
        chronoDecalage = recupererPeriodesJustifiees(chronoDecalage, attribution, utAvant);
        
        UniteTraitementForcee uniteTraitementForcee = GestionForcage.getUniteTraitementForcee(attribution.getDemande(), utAvant.getDateDebut(), utAvant.getDateFin(), false);
        
        boolean quantiteForceSurUt = (uniteTraitementForcee != null) && (uniteTraitementForcee.isCreditDecalageForce());
        
        boolean traitementAR = !chronoDecalage.estVide();
        boolean delaiAttentePresentEtNonActif = (dureeDelaiAttente.getEtat() != 1) && (dureeDelaiAttente.getQuantiteInitial() != null) && (dureeDelaiAttente.getQuantiteInitial().getValeurEntiere() == 7);
        if ((quantiteForceSurUt) && (dureeDelaiAttente.getEtat() != 1) && (utAvant.getDateDebut().estApresOuCoincideAvec(FabriqueStrategieConvention2014.DATE_APPLICATION)))
        {
          qteDec = uniteTraitementForcee.getCreditDecalage();
          utAvant.setQuantiteDecale(qteDec);
          utAvant.setTraitementArEffectue(true);
          utAvant.setDebutPeriodePECEvenementReducteurs(Damj.max(OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution), utAvant.getDateDebutConsoDATheorique().getDebutMois()));
        }
        else if ((estPecValide) && (traitementAR) && (delaiAttentePresentEtNonActif))
        {
          qteDec = traitementARSurPeriodeAvant(pa.getPeriode(), paAvecDateDebutConso, qualificationPeriodes, chronoDecalage, quantiteRestante, attribution);
          utAvant.setQuantiteDecale(utAvant.getQuantiteDecale() != null ? utAvant.getQuantiteDecale().ajouter(qteDec) : qteDec);
          utAvant.setTraitementArEffectue(true);
          utAvant.setDebutPeriodePECEvenementReducteurs(Damj.max(OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution), utAvant.getDateDebutConsoDATheorique().getDebutMois()));
        }
      }
      else if (estPecValide)
      {
        utAvant.setQuantiteDecale(new Quantite(paAvecDateDebutConso.getDuree(), UniteDuree.JOUR));
        utAvant.setTraitementArEffectue(true);
        utAvant.setDebutPeriodePECEvenementReducteurs(Damj.max(OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution), utAvant.getDateDebutConsoDATheorique().getDebutMois()));
      }
    }
    return utAvant.getQuantiteDecale() != null ? utAvant.getQuantiteDecale() : qteDec;
  }
  
  private ChronologiePeriodes majQualification(UniteTraitementAvant utAvant, AttributionSpec attribution, QualificationPeriodes qualificationPeriodes, Periode periodePriseEnCompteSurUT)
    throws CoucheLogiqueException
  {
    FacadeAvantProduitSpec facadeAvant = FacadeAvantProduitFactory.getInstance().getInstanceFacadeAvantProduit(attribution.getProduitExecution());
    facadeAvant.postTraitementQualification(utAvant, qualificationPeriodes);
    ChronologiePeriodes chronoDecalage = DecoupageProratisation.decoupageEtProratisationPeriodesActivites(periodePriseEnCompteSurUT, qualificationPeriodes.getPeriodesDecalantes());
    
    return chronoDecalage;
  }
  
  private static Periode recupererPeriodePriseEnCompte(AttributionSpec attribution, Periode periodePa)
  {
    Damj dateAttribOuPjp = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
    Damj dateDebutPriseEnCompte = periodePa.getDebut();
    Damj dateFinPriseEnCompte = periodePa.getFin();
    Damj dateOuvertureDroitAttribution = ((AttributionAssuranceSpec)attribution).getOuvertureDroit().getDateAttribution();
    Periode utPeriodePa = new Periode(periodePa.getDebut().getDebutMois(), periodePa.getDebut().getFinMois());
    if ((((AttributionAssuranceSpec)attribution).estDemandeSuiteFinDeDroit()) && (!(attribution instanceof RepriseSpec)) && (utPeriodePa.contient(dateOuvertureDroitAttribution)) && (!dateOuvertureDroitAttribution.coincideAvec(utPeriodePa.getDebut())))
    {
      dateDebutPriseEnCompte = utPeriodePa.getFin().lendemain();
      return new Periode(dateDebutPriseEnCompte, dateDebutPriseEnCompte);
    }
    dateDebutPriseEnCompte = Damj.max(dateDebutPriseEnCompte, dateAttribOuPjp);
    
    Chronologie periodesPEC = OutillagePEC.getChronologiePecsDemandeurEmploiSurPeriode(attribution.getDemandeur(), periodePa);
    periodesPEC.iterer();
    while (periodesPEC.encoreSuivant())
    {
      ObjetChronoPeriodePriseEnCharge pec = (ObjetChronoPeriodePriseEnCharge)periodesPEC.elementSuivant();
      Periode periodePec = new Periode(pec.getDateDebut(), pec.getDateFin());
      if (periodePec.contient(dateAttribOuPjp)) {
        dateFinPriseEnCompte = Damj.min(dateFinPriseEnCompte, periodePec.getFin());
      }
    }
    return new Periode(dateDebutPriseEnCompte, dateFinPriseEnCompte);
  }
  
  private static boolean estUtAvantStatutDefinitif(ChronologiePeriodes chronoPeriode, AttributionSpec attribution, UniteTraitementAvant utAvant)
    throws CoucheLogiqueException
  {
    int statutUT = DefinitionStatutUtTraitementActiviteReduite.definirStatutUtPourCasGeneral(chronoPeriode, utAvant.getPeriode(), attribution);
    
    utAvant.setStatut(statutUT);
    if ((statutUT == 3) || (statutUT == 8)) {
      return true;
    }
    UniteTraitementForcee uniteTraitementForcee = GestionForcage.getUniteTraitementForcee(attribution.getDemande(), utAvant.getDateDebut(), utAvant.getDateFin(), false);
    
    boolean statutForceSurUt = (uniteTraitementForcee != null) && (uniteTraitementForcee.isStatutForce());
    if (statutForceSurUt) {
      utAvant.setStatut(uniteTraitementForcee.getStatut());
    }
    return (statutForceSurUt) && (uniteTraitementForcee.getStatut() == 3);
  }
  
  private static ChronologiePeriodes recupererPeriodesJustifiees(ChronologiePeriodes chronoPeriode, AttributionSpec attribution, UniteTraitementAvant utAvant)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronoPeriodeJustifiee = new ChronologiePeriodes();
    PeriodeTravail periodeCourante = null;
    PeriodePrime prime = null;
    
    Chronologie periodesEmploiCourantes = chronoPeriode.copier(new FiltrePeriodeTravailCalcul());
    periodesEmploiCourantes = periodesEmploiCourantes.copier(new FiltreChevauchePeriode(utAvant.getPeriode()));
    Chronologie periodesPrime = chronoPeriode.copier(new FiltrePeriodePrimeCalcul());
    periodesPrime = periodesPrime.copier(new FiltreChevauchePeriode(utAvant.getPeriode()));
    
    periodesPrime.iterer();
    while (periodesPrime.encoreSuivant())
    {
      prime = (PeriodePrime)periodesPrime.elementSuivant();
      chronoPeriodeJustifiee.ajouter(prime);
    }
    periodesEmploiCourantes.iterer();
    while (periodesEmploiCourantes.encoreSuivant())
    {
      periodeCourante = (PeriodeTravail)periodesEmploiCourantes.elementSuivant();
      if (!(periodeCourante instanceof DsmTravail)) {
        chronoPeriodeJustifiee.ajouter(periodeCourante);
      }
    }
    return filtrerActiviteConserveeSurJustifiee(chronoPeriodeJustifiee, attribution);
  }
  
  private static Quantite traitementARSurPeriodeAvant(Periode periodePa, Periode paAvecDateDebutConso, QualificationPeriodes qualificationPeriodes, ChronologiePeriodes chronoDecalage, Quantite quantite, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Damj dateCalculMontant = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
    dateCalculMontant = Damj.max(dateCalculMontant, paAvecDateDebutConso.getDebut());
    Quantite quantiteRestante = quantite;
    Periode periodePriseEncompteSuspensif = new Periode(Damj.max(periodePa.getDebut(), paAvecDateDebutConso.getDebut()), paAvecDateDebutConso.getFin());
    
    ChronologiePeriodes chronologiePeriodesSuspensivesSurPeriode = PeriodeProratisationFactory.decoupeEtProratiseParDefaut(qualificationPeriodes.getPeriodesSuspensives(), periodePriseEncompteSuspensif);
    
    ChronologiePeriodes chronologiePeriodesSegmentanteSurPeriode = PeriodeProratisationFactory.decoupeEtProratiseParDefaut(qualificationPeriodes.getPeriodesSegmentantes(), periodePa);
    
    Quantite quantiteSuspensive = TraitementPeriodes.getQuantiteSuspensive(periodePriseEncompteSuspensif, new QuantiteJour(new BigDecimal(paAvecDateDebutConso.getDuree())), chronologiePeriodesSuspensivesSurPeriode);
    
    quantiteRestante = quantiteRestante.soustraire(quantiteSuspensive);
    
    DeterminerJustificatifsRevenusAR.traitementRevenusBS(chronoDecalage, periodePa.getDebut(), attribution);
    
    Chronologie periodesEmploiCourantes = chronoDecalage.copier(new FiltrePeriodeTravailCalcul());
    Chronologie periodesPrime = chronoDecalage.copier(new FiltrePeriodePrimeCalcul());
    BigDecimal cumulGainPrimes = BigDecimal.ZERO;
    BigDecimal cumulGainPA = BigDecimal.ZERO;
    PeriodePrime prime = null;
    
    DonneesEntreesRecuperationMontant donneesEntrees = ((GammeAsuSpec)attribution.getGamme()).mapperDonneesEntreesRecuperationMontant(attribution);
    donneesEntrees.setDateCalculMontant(dateCalculMontant);
    
    traiterPeriodeSegmentante(donneesEntrees, chronologiePeriodesSegmentanteSurPeriode);
    if (estUneAttributionMayotte(attribution)) {
      affecterProduitContexteMayotte(donneesEntrees, attribution);
    }
    MontantAsuSpec montantAAttribution = DeterminationMontant.determinerMontant(donneesEntrees);
    
    periodesPrime.iterer();
    while (periodesPrime.encoreSuivant())
    {
      prime = (PeriodePrime)periodesPrime.elementSuivant();
      cumulGainPrimes = cumulGainPrimes.add(prime.getMontant().getValeur());
    }
    cumulGainPA = calculerGainRetenu(periodesEmploiCourantes);
    cumulGainPA = cumulGainPA.add(cumulGainPrimes);
    
    ResultatActiviteReduite res = null;
    Sjr sjrRevalorise = null;
    if (estUneAttributionMayotte(attribution))
    {
      if (attribution.getProduitExecution().getNom().equals("ASU_MAY17_02"))
      {
        res = new ResultatActiviteReduite();
        res.setQuantiteIndemnise(BigDecimal.ZERO);
      }
      else
      {
        sjrRevalorise = RevalorisationSalaireMayotte.revaloriserSjrMayotte((AttributionAssuranceSpec)attribution, dateCalculMontant);
        res = ActiviteReduite.calculActiviteReduite(montantAAttribution.getMontantBrut().getValeur(), cumulGainPA, montantAAttribution.getMontantBrut().getValeur().multiply(quantiteRestante.getValeur()), sjrRevalorise.getSalaire(), montantAAttribution.getJustificationCalculMontant(), periodePa);
      }
    }
    else
    {
      sjrRevalorise = RevalorisationSalaire.revalorisationSjr((AttributionAssuranceSpec)attribution, dateCalculMontant);
      ProduitAsuAbstrait produit = (ProduitAsuAbstrait)attribution.getProduit();
      ProduitAsuDelegueSpec produitDelegue = (ProduitAsuDelegueSpec)produit.getProduitDelegue();
      res = produitDelegue.calculActiviteReduite(montantAAttribution.getMontantBrut().getValeur(), cumulGainPA, montantAAttribution.getMontantBrut().getValeur().multiply(quantiteRestante.getValeur()), sjrRevalorise.getSalaire(), montantAAttribution.getJustificationCalculMontant(), periodePa);
    }
    Quantite qteDec = quantiteRestante.soustraire(new QuantiteJour(res.getQuantiteIndemnise()));
    
    return qteDec;
  }
  
  private static ChronologiePeriodes filtrerActiviteConserveeSurJustifiee(ChronologiePeriodes chronoJustifiee, AttributionSpec attribution)
  {
    ChronologiePeriodes chronoPeriodeJustifieeFiltree = new ChronologiePeriodes();
    chronoJustifiee.iterer();
    ObjetChronoPeriodeCalcul periodeCourante = null;
    while (chronoJustifiee.encoreSuivant())
    {
      periodeCourante = (ObjetChronoPeriodeCalcul)chronoJustifiee.elementSuivant();
      boolean periodeAIgnorer = DeterminationActiviteConserveeReprise.determinerTypeActivitePourAvant(((AttributionAssuranceSpec)attribution).getListeActiviteConservee(), periodeCourante, attribution);
      if (!periodeAIgnorer) {
        chronoPeriodeJustifieeFiltree.ajouter(periodeCourante);
      }
    }
    return chronoPeriodeJustifieeFiltree;
  }
  
  private static void traiterPeriodeSegmentante(DonneesEntreesRecuperationMontant donneesEntrees, ChronologiePeriodes chronoPeriodeSegmentante)
  {
    Iterator ite = chronoPeriodeSegmentante.iterer();
    while (ite.hasNext())
    {
      ObjetChronoPeriode periode = (ObjetChronoPeriode)ite.next();
      if (((periode instanceof PeriodeFormation)) && (((PeriodeFormation)periode).estEffective())) {
        donneesEntrees.getDonneesCalculMontant().setContexteFormation(true);
      }
    }
  }
  
  private static boolean estUneAttributionMayotte(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return attribution.getProduitExecution().getLigne().getNomUnique().equals("ASU_MAY17");
  }
  
  private static void affecterProduitContexteMayotte(DonneesEntreesRecuperationMontant donneesEntrees, AttributionSpec attribution)
  {
    if (attribution.getProduitExecution().getNom().equals("ASU_MAY17_02")) {
      donneesEntrees.getDonneesCalculMontant().setProduit(ProduitAsuMay17P02.getInstance());
    } else {
      donneesEntrees.getDonneesCalculMontant().setProduit(ProduitAsuMay17P03.getInstance());
    }
  }
  
  private static BigDecimal calculerGainRetenu(Chronologie periodesEmploi)
  {
    BigDecimal gainRetenu = BigDecimal.ZERO;
    Chronologie chronoFiltree = periodesEmploi.copier(new FiltrePeriodeTravailCalcul());
    PeriodeTravail periodeCourante = null;
    chronoFiltree.iterer();
    while (chronoFiltree.encoreSuivant())
    {
      periodeCourante = (PeriodeTravail)chronoFiltree.elementSuivant();
      
      gainRetenu = gainRetenu.add(periodeCourante.getGain());
    }
    return gainRetenu;
  }
  
  public boolean doitTraiterLAR()
  {
    return true;
  }
  
  public fr.unedic.cali.calcul.dom.EvenementFinQuantiteDroit creerEvtFinQteDroit(Damj dateFinQuantiteDroit, QuantiteDroitSpec quantiteDroitAImputer)
  {
    return new fr.unedic.cali.asu.calcul.dom.EvenementFinQuantiteDroit(dateFinQuantiteDroit, quantiteDroitAImputer);
  }
  
  private boolean estProduitASP(AttributionSpec attribution)
  {
    return (attribution.getProduitExecution().getNomUnique().equals("ASU_CAA14_02")) || (attribution.getProduitExecution().getNomUnique().equals("ASU_CVA10_02")) || (attribution.getProduitExecution().getNomUnique().equals("ASU_CAA14_03")) || (attribution.getProduitExecution().getNomUnique().equals("ASU_CVA10_03"));
  }
  
  public FiltreTemporel ajouterFiltrePeriodeSurUT()
  {
    return new FiltreNegation(new FiltrePansCalcul());
  }
}

/* Location:
 * Qualified Name:     FacadeAvantLigneImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */