package fr.unedic.cali.asu.cge01.avant.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.EvenementFinQuantiteDroit;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EvenementLendemainFinQuantiteDroit;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.dom.ImputationSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class TraitementDureeConsommableAvant
{
  public static Quantite simulerImputationEtImputerLaQuantite(Quantite p_quantiteAImputer, PeriodeAnalyseSpec p_pa, DureeConsommableAvant p_dureeConcommableAvant, UniteTraitementAvant p_utAvant, Damj p_dateDebutConsommation, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    QuantiteDroitSpec quantiteDroitAImputer = null;
    Quantite quantiteAImputer = null;
    Quantite quantiteRestantAImputer = null;
    
    quantiteRestantAImputer = p_quantiteAImputer;
    
    quantiteAImputer = p_quantiteAImputer;
    quantiteDroitAImputer = determinerQuantiteDroitAImputer(p_dureeConcommableAvant, p_quantiteAImputer);
    if (quantiteDroitAImputer != null) {
      quantiteAImputer = quantiteDroitAImputer.getQuantiteCourante();
    }
    p_dureeConcommableAvant.imputer(quantiteAImputer);
    if (p_dureeConcommableAvant.getQuantiteCourante().getValeur().compareTo(new BigDecimal(0)) == 0)
    {
      p_dureeConcommableAvant.epuiser();
      
      DureeCalendaire d = new DureeCalendaire(0, 0, quantiteAImputer.getValeurEntiere());
      Damj dateFinQuantiteDroit = p_dateDebutConsommation.deplacerVersAvant(d).veille();
      Periode p = p_utAvant.getConsommationPeriodes().getPeriodesParTypologie(p_dureeConcommableAvant.getTypeDureeConsommable());
      if (p != null) {
        p.setFin(dateFinQuantiteDroit);
      }
    }
    quantiteRestantAImputer = quantiteRestantAImputer.soustraire(quantiteAImputer);
    
    return quantiteRestantAImputer;
  }
  
  public static Quantite simulerImputationEtImputerLaQuantiteEtTerminerProduit(Quantite p_quantiteAImputer, PeriodeAnalyseSpec p_pa, DureeConsommableAvant p_dureeConcommableAvant, UniteTraitementAvant p_utAvant, Damj p_dateDebutConsommation, ArretProduitAvecRaison p_arretProduitAvecRaison, Damj p_dateAttribution)
    throws CoucheLogiqueException
  {
    QuantiteDroitSpec quantiteDroitAImputer = null;
    Quantite quantiteAImputer = null;
    Quantite quantiteRestantAImputer = null;
    boolean finDeProduit = false;
    boolean finDeQuantiteDroitDansPeriodeAnalyse = false;
    Damj dateDebutQuantiteDroit = null;
    Damj dateFinQuantiteDroit = null;
    
    quantiteRestantAImputer = p_quantiteAImputer;
    
    dateDebutQuantiteDroit = p_dateDebutConsommation;
    
    finDeQuantiteDroitDansPeriodeAnalyse = detecterFinQuantiteDansPeriodeAnalyse(p_dureeConcommableAvant, quantiteRestantAImputer);
    while ((quantiteRestantAImputer.getValeur().compareTo(new BigDecimal(0)) > 0) && (!finDeProduit))
    {
      quantiteDroitAImputer = determinerQuantiteDroitAImputer(p_dureeConcommableAvant, quantiteRestantAImputer);
      
      quantiteAImputer = quantiteRestantAImputer;
      if (quantiteDroitAImputer != null) {
        quantiteAImputer = quantiteDroitAImputer.getQuantiteCourante();
      }
      if (finDeQuantiteDroitDansPeriodeAnalyse)
      {
        if (dateFinQuantiteDroit != null)
        {
          dateDebutQuantiteDroit = dateFinQuantiteDroit.lendemain();
          dateFinQuantiteDroit = p_pa.getDateFin();
        }
        if (quantiteDroitAImputer != null)
        {
          DureeCalendaire d = new DureeCalendaire(0, 0, quantiteDroitAImputer.getQuantiteCourante().getValeurEntiere());
          dateFinQuantiteDroit = dateDebutQuantiteDroit.deplacerVersAvant(d).veille();
          
          p_pa.addEvenement(new EvenementFinQuantiteDroit(dateFinQuantiteDroit, quantiteDroitAImputer));
        }
      }
      finDeProduit = imputerLaQuantite(p_pa, p_dureeConcommableAvant, quantiteAImputer, dateFinQuantiteDroit, p_arretProduitAvecRaison);
      
      quantiteRestantAImputer = quantiteRestantAImputer.soustraire(quantiteAImputer);
      if (finDeProduit)
      {
        p_pa.setProduitATerminerApresUT(true);
        
        DureeCalendaire d = new DureeCalendaire(0, 0, quantiteAImputer.getValeurEntiere());
        dateFinQuantiteDroit = p_dateDebutConsommation.deplacerVersAvant(d).veille();
        Periode p = p_utAvant.getConsommationPeriodes().getPeriodesParTypologie(p_dureeConcommableAvant.getTypeDureeConsommable());
        if (p != null) {
          p.setFin(dateFinQuantiteDroit);
        }
        p_pa.setQuantiteNonIndemnisee(p_pa.getQuantiteNonIndemnisee().ajouter(quantiteRestantAImputer));
        
        EvenementLendemainFinQuantiteDroit evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(Damj.max(dateFinQuantiteDroit.lendemain(), p_dateAttribution), p_dureeConcommableAvant);
        
        evtLendemainFinQuantiteDroit.setEstCauseFinProduit(finDeProduit);
        
        p_arretProduitAvecRaison.ajouteLendemainFinQuantiteDroitArretCalcul(evtLendemainFinQuantiteDroit);
      }
    }
    return quantiteRestantAImputer;
  }
  
  private static boolean detecterFinQuantiteDansPeriodeAnalyse(DureeConsommableAvant p_quantiteActive, Quantite p_quantiteAImputer)
  {
    ImputationSpec quantiteImputee = null;
    boolean finDeQuantiteDroitDansPeriodeAnalyse = false;
    
    quantiteImputee = p_quantiteActive.simulerImputer(p_quantiteAImputer);
    if ((quantiteImputee.estImpute()) && 
      (quantiteImputee.getResteAImputer().getValeur().compareTo(new BigDecimal(0)) <= 0)) {
      finDeQuantiteDroitDansPeriodeAnalyse = true;
    }
    return finDeQuantiteDroitDansPeriodeAnalyse;
  }
  
  private static QuantiteDroitSpec determinerQuantiteDroitAImputer(DureeConsommableAvant p_dureeIndemnisation, Quantite p_quantiteAImputer)
  {
    ImputationSpec imputationImputee = null;
    QuantiteDroitSpec quantiteDroitAImputer = null;
    
    imputationImputee = p_dureeIndemnisation.simulerImputer(p_quantiteAImputer);
    if ((imputationImputee.estImpute()) && (imputationImputee.getResteAImputer().getValeur().compareTo(new BigDecimal(0)) <= 0)) {
      quantiteDroitAImputer = imputationImputee.getQuantiteDroit();
    }
    return quantiteDroitAImputer;
  }
  
  private static boolean imputerLaQuantite(PeriodeAnalyseSpec p_pa, DureeConsommableAvant p_dureeIndemnisationActive, Quantite p_quantiteAImputer, Damj p_dateFinQuantiteDroit, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    boolean finDeProduit = false;
    
    p_dureeIndemnisationActive.imputer(p_quantiteAImputer);
    if (p_dureeIndemnisationActive.getQuantiteCourante().getValeur().compareTo(new BigDecimal(0)) == 0)
    {
      p_dureeIndemnisationActive.epuiser();
      finDeProduit = true;
    }
    return finDeProduit;
  }
}

/* Location:
 * Qualified Name:     TraitementDureeConsommableAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */