package fr.unedic.cali.asu.cge01.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsu;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.calcul.FacadeCalculGammeImpl;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteAsu;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteGamme;
import fr.unedic.cali.asu.calcul.dom.DureeProlongation;
import fr.unedic.cali.asu.calcul.dom.EtatAuDjiGamme;
import fr.unedic.cali.asu.calcul.dom.temps.ObjectChronoFinChomageSansRct;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDVMayotte;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAssDemandeExpresse;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeCarences;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeDebutPec;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeFinDureeMaintienDroit;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodePreavis;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDRV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDVFilEau;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetRevision;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.ActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.DefinitionStatutUtTraitementActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.cge01.antecedent.GestionPoursuiteCalcul;
import fr.unedic.cali.asu.cge01.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.calcul.dom.FormuleMontantAREF;
import fr.unedic.cali.asu.cge01.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Maintien;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.MajCi;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.MajCiTranche;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.PostTraitements;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Spec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieAppliquerISLR;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieISLR;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FormuleDelaiReportSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieAppliquerISLRSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieFormuleISLRSpec;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.CarenceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.OdAssuranceSpec;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.fabriques.FabriqueConventionTransitoireCalcul2014;
import fr.unedic.cali.asu.liquidation.outilsfonctionnels.RechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.mnt.dom.DureeDetectionMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetection100TMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetectionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeMaintien;
import fr.unedic.cali.asu.outilsfonctionnels.ConstitutionISLR;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilCarence;
import fr.unedic.cali.asu.outilsfonctionnels.OutilFinDroit;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsRevisions;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsTrancheCalcul;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGenerationEnqueteCumulARSpec;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGestionDRVSpec;
import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.BaseDelaiReport;
import fr.unedic.cali.asu.produits.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.asu.produits.liquidation.dom.Differe;
import fr.unedic.cali.asu.produits.liquidation.dom.ElementChomageSansRupture;
import fr.unedic.cali.asu.produits.liquidation.dom.Poursuite;
import fr.unedic.cali.asu.produits.liquidation.dom.Reprise;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.autresdoms.cohab.dom.PeriodeSousPensionInvaliditeChainee;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.TravailNonSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.autresdoms.ga.mapping.MapperPeriodesCalcul;
import fr.unedic.cali.calcul.OutillageCalculADate;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.TraitementPeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EvenementChangementParametre;
import fr.unedic.cali.calcul.dom.EvenementFinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.EvenementLendemainFinQuantiteDroit;
import fr.unedic.cali.calcul.dom.EvenementLimiteIndemnisationChomageSansRCT;
import fr.unedic.cali.calcul.dom.EvenementLimiteIndemnisationPMVS;
import fr.unedic.cali.calcul.dom.EvenementMaintien;
import fr.unedic.cali.calcul.dom.EvenementMaintienEuropeenDJI;
import fr.unedic.cali.calcul.dom.EvenementPeriodesSuspensivesDisponibilite;
import fr.unedic.cali.calcul.dom.EvenementRejetDv;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvaliditeChainee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.Pans;
import fr.unedic.cali.calcul.dom.periode.PansMensuel;
import fr.unedic.cali.calcul.dom.periode.PansMensuelNonRemuneree;
import fr.unedic.cali.calcul.dom.periode.PansSupraMensuel;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeDisponibilite;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnomalieI04;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoBlocageM12;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeBlocagePerteActiviteConservee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationPMVS;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeSuspensionIslr;
import fr.unedic.cali.calcul.outilsfonctionnels.DecoupageProratisation;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationAvantageVieillesseAvantPJI;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationSanctionReduction;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT.ElementContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ElementBaseIndemnisationFacade;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyse;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.pbjc.dom.EnquetePbjcNcp;
import fr.unedic.cali.calcul.pbjc.dom.IndividuPbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantAREFSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.QuantiteDroit;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.RevisionSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSolSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.outilsfonctionnels.RechercherPeriodeIndemnisation;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePansCalcul;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.parcours.ResultatCalcul;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDemandePourERE;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.FiltreTemporel;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class FacadeCalculLigneImpl
  extends FacadeCalculGammeImpl
{
  protected static final int DIX = 10;
  private static final int DELAI_ATTENTE = 7;
  private static final int DATE_ATTRIBUTION_MINIMALE_JOUR = 1;
  private static final int DATE_ATTRIBUTION_MINIMALE_MOIS = 7;
  private static final int DATE_ATTRIBUTION_MINIMALE_ANNEE = 2001;
  private static final Damj DATE_ATTRIBUTION_MINIMALE = new Damj(2001, 7, 1);
  private static final DureeCalendaire DUREE_6_MOIS = new DureeCalendaire(0, 6, 1);
  private static final String COEFFICIENT_IMPUTATION_FORMATION = "10";
  private static final int LIMITATION_IMPUTATION_FORMATION = 30;
  protected static final int AGE_50_ANS = 50;
  protected static final int DUREE_CSR = 182;
  private static final int DUREE_PERTE_ACTIVITE_CONSERVE = 122;
  private static final int SEUIL_MOIS_NI = 3;
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(p_attribution);
    ElementChomageSansRupture elementChomageSansRupture = tranche.getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (estDemandeEnContexteDeChomageEnCoursDeSuspension(p_attribution))) {
      return creationConstituantsIndemnisationCsr(p_attribution);
    }
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    Collection collectionDurees = null;
    if ((p_attribution instanceof Poursuite)) {
      collectionDurees = new ArrayList(((Poursuite)p_attribution).getUniteTraitement().getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit());
    } else {
      collectionDurees = OutilsTrancheCalcul.getListeDurees((Attribution)p_attribution);
    }
    constituantsIndemnisation.setCollectionQuantiteDroit(collectionDurees);
    
    return constituantsIndemnisation;
  }
  
  public ConstituantsCalculActiviteReduiteSpec creationConstituantsCalculActiviteReduite(AttributionSpec attributionSpec, ContexteUT contexteUT, ConstituantsIndemnisation constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    int cumulAR = 0;
    int cumulMoisNi = 0;
    Attribution attribution = (Attribution)attributionSpec;
    if ((attribution instanceof Poursuite))
    {
      cumulAR = ((Poursuite)attribution).getUniteTraitement().getConstituantsCalculActiviteReduiteEnFinUT().getCumul();
      cumulMoisNi = ((Poursuite)attribution).getUniteTraitement().getConstituantsCalculActiviteReduiteEnFinUT().getCumulMoisNonIndemnise();
    }
    else
    {
      AttributionSpec attributionPrecedente = null;
      boolean aTrouveAttributionNonRadieePendantAvant = false;
      if (((attribution instanceof RepriseSpec)) || ((attribution instanceof RevisionSpec)))
      {
        attributionPrecedente = attribution.getAttributionPrecedente();
        if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable().lendemain().coincideAvec(attribution.getDateAttribution())) && (!attribution.estDemandeDrv()))
        {
          EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
          if ((etatAuDji != null) && (((etatAuDji.getCumulMoisnonIndemnise() < 3) && ((attribution instanceof RepriseSpec))) || ((attribution instanceof RevisionSpec)))) {
            cumulMoisNi = etatAuDji.getCumulMoisnonIndemnise();
          }
        }
        AttributionSpec attributionPrecedenteAUtiliserPourCumulAR = attributionPrecedente;
        if ((attributionPrecedente.getTypeExamen().equals("ASU_17")) || ((attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_25")) && (!(attributionPrecedente instanceof RepriseSpec)))) {
          attributionPrecedenteAUtiliserPourCumulAR = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
        } else if (attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_25")) {
          attributionPrecedenteAUtiliserPourCumulAR = ((Attribution)attributionPrecedente).getAttributionPrecedente();
        }
        while (!aTrouveAttributionNonRadieePendantAvant) {
          if ((attributionPrecedenteAUtiliserPourCumulAR != null) && (attributionPrecedenteAUtiliserPourCumulAR.getCalendrierExecutionCalcul() != null) && (attributionPrecedenteAUtiliserPourCumulAR.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
          {
            aTrouveAttributionNonRadieePendantAvant = true;
            EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedenteAUtiliserPourCumulAR.getCalendrierExecutionCalcul().getEtatAuDJI();
            cumulAR = etatAuDji.getCumulMoisActiviteReduite();
            
            boolean existeAttributionPrecedenteAvecCumulAr = existeAttributionPrecedenteAvecCumulAr(attribution, contexteUT);
            if (existeAttributionPrecedenteAvecCumulAr) {
              cumulAR--;
            }
          }
          else if (!(attributionPrecedenteAUtiliserPourCumulAR instanceof OdSpec))
          {
            attributionPrecedenteAUtiliserPourCumulAR = ((Attribution)attributionPrecedenteAUtiliserPourCumulAR).getAttributionPrecedente();
          }
          else
          {
            aTrouveAttributionNonRadieePendantAvant = true;
          }
        }
      }
      BigDecimal cumulMoisARMigre = ((AttributionAssuranceSpec)attributionSpec).getCumulMoisActiviteReduite();
      if (cumulMoisARMigre != null) {
        cumulAR = cumulMoisARMigre.intValue();
      }
    }
    Sjc sjc = null;
    Sjr sjr = null;
    if ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant() != null)
    {
      sjc = ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjcInitial();
      sjr = ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjrInitial();
    }
    else
    {
      TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attributionSpec);
      sjc = tranche.getSjc();
      sjr = tranche.getSjr();
    }
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduite = new ConstituantsCalculActiviteReduiteAsu(cumulAR, sjr, sjc);
    constituantsCalculActiviteReduite.setCumulMoisNonIndemnise(cumulMoisNi);
    
    return constituantsCalculActiviteReduite;
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    if (p_constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      Attribution attribution = (Attribution)p_attribution;
      ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
      
      TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(p_attribution);
      
      elementBaseIndemnisationCourant.setCompetenceAdministrative(tranche.getCompetenceAdministrative());
      elementBaseIndemnisationCourant.setDureeInitialeMaintien(tranche.getDuree(1));
      elementBaseIndemnisationCourant.setDureeIndemnisationEffective(tranche.getDuree(2));
      elementBaseIndemnisationCourant.setListeCarences(tranche.getListDelaisReports());
      elementBaseIndemnisationCourant.setConventionGestion(tranche.getConventionGestion());
      elementBaseIndemnisationCourant.setCapitalRetenuCourant(tranche.isCapitalRetenuCourant());
      elementBaseIndemnisationCourant.setMontantRetenuCourant(tranche.isMontantRetenuCourant());
      if ((OutilsTrancheCalcul.getListeDurees((Attribution)p_attribution) != null) && (!OutilsTrancheCalcul.getListeDurees((Attribution)p_attribution).isEmpty()))
      {
        ArrayList listeDuree = new ArrayList();
        elementBaseIndemnisationCourant.setListeDurees(listeDuree);
        
        QuantiteDroit duree = null;
        Iterator iterDuree = OutilsTrancheCalcul.getListeDurees((Attribution)p_attribution).iterator();
        while (iterDuree.hasNext())
        {
          duree = (QuantiteDroit)iterDuree.next();
          listeDuree.add(duree.copie());
        }
      }
      elementBaseIndemnisationCourant.setDureeProlongationTheorique(tranche.getDuree(3));
      elementBaseIndemnisationCourant.setElementChomageSansRupture(tranche.getElementChomageSansRupture());
      elementBaseIndemnisationCourant.setProduitMontantRetenu((ProduitAsuSpec)Parametres.getProduit(tranche.getProduitMontantRetenu()));
      elementBaseIndemnisationCourant.setSeuilMensuelPansConservees(tranche.getSeuilMensuelPansConservees());
      elementBaseIndemnisationCourant.setMaintienEuropeen(tranche.getMaintienEuropeen());
      if (tranche.getCoefficientSaisonnier() != null) {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(tranche.getCoefficientSaisonnier());
      } else {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(BigDecimal.ONE);
      }
      if (tranche.getCoefficientTempsPartiel() != null) {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(tranche.getCoefficientTempsPartiel());
      } else {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(BigDecimal.ONE);
      }
      elementBaseIndemnisationCourant.setSjr((Sjr)tranche.getSjr().copie());
      elementBaseIndemnisationCourant.setSjc((Sjc)tranche.getSjc().copie());
      elementBaseIndemnisationCourant.setSjrInitial((Sjr)tranche.getSjr().copie());
      elementBaseIndemnisationCourant.setSjcInitial((Sjc)tranche.getSjc().copie());
      elementBaseIndemnisationCourant.setCoefficientSanctionReduction(new BigDecimal("1.00"));
      
      elementBaseIndemnisationCourant.setListePensionInvalidite(tranche.getListePensionsInvalidites());
      
      elementBaseIndemnisationCourant.setDateMaintienEuropeen(OutilsMaintienEuropeenEessiASU.rechercherDateMaintienEuropeen(p_attribution, p_periodeUT, p_constituantsIndemnisation));
      
      elementBaseIndemnisationCourant.setTypeCaractereSaisonnierRetenu(tranche.getNatureCoefficientSaisonnier());
      
      elementBaseIndemnisationCourant.setIsConditionCaractereSaisonnierParRythme(tranche.isA3ansActiviteEn5ans());
      
      determinerMontantPensionInvaliditeADeduire(elementBaseIndemnisationCourant, attribution.getDemandeur(), recupererPremierJourExecutableNcp(p_attribution).veille(), tranche.getDateAttribution());
      
      PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(attribution.getDemandeur(), recupererPremierJourExecutableNcp(p_attribution));
      
      BigDecimal montantAV = BigDecimal.ZERO;
      Damj dateRevalorisation = tranche.getDateAttribution();
      if (periodeAvCourante != null)
      {
        montantAV = periodeAvCourante.getQuantiteEuro().getValeur();
        elementBaseIndemnisationCourant.setDateEffetAV(recupererPremierJourExecutableNcp(p_attribution));
        dateRevalorisation = Damj.max(tranche.getDateAttribution(), periodeAvCourante.getDateDebut());
      }
      Sjr sjrrp = RevalorisationSalaire.revaloriserSjr(tranche.getSjr(), dateRevalorisation);
      BigDecimal coeffAV = montantAV.divide(sjrrp.getSalaire(), 10, 4);
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(coeffAV.multiply(sjrrp.getSalaire()));
      elementBaseIndemnisationCourant.setCompetenceFinanciere(tranche.getCompetenceFinanciere());
      elementBaseIndemnisationCourant.setReglementMontantRetenu(tranche.getReglementMontantRetenu());
      FormuleMontantSpec formuleMontant = null;
      ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = null;
      QuantiteIndemnisationSpec duree = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
      if (duree != null) {
        formuleMontant = p_attribution.getFormuleMontant(duree.getCodeFormuleMontant());
      } else {
        formuleMontant = p_attribution.getFormuleMontant(p_constituantsIndemnisation.getCodeFormuleMontant());
      }
      if ((formuleMontant instanceof FormuleMontantAREFSpec))
      {
        elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
        p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
      }
      Reglement reglementApplicable = tranche.getReglement();
      if (reglementApplicable != null) {
        elementBaseIndemnisationCourant.setReglementApplicable(reglementApplicable);
      }
      Quantite affiliationRequisePourPRA = tranche.getAffiliationRequisePourPRA();
      if (affiliationRequisePourPRA != null) {
        elementBaseIndemnisationCourant.setAffiliationRequisePourPRA(affiliationRequisePourPRA);
      }
      SalaireReference salaireReference = tranche.getSalaireReferenceInitialSpectacle();
      if (salaireReference != null) {
        elementBaseIndemnisationCourant.setSalaireReference(salaireReference);
      }
      BigDecimal nombreHeureTravaillesEtendu = tranche.getNombreHeuresTravailleesEtendu();
      if (nombreHeureTravaillesEtendu != null) {
        elementBaseIndemnisationCourant.setNombreHeureTravaillesEtendu(nombreHeureTravaillesEtendu);
      }
      BigDecimal nombreHeuresTravailleesPlafonnees = tranche.getNombreHeuresTravailleesPlafonne();
      if (nombreHeuresTravailleesPlafonnees != null) {
        elementBaseIndemnisationCourant.setNombreHeuresTravailleesPlafonnees(nombreHeuresTravailleesPlafonnees);
      }
      Periode prc = tranche.getPrc();
      if (prc != null) {
        elementBaseIndemnisationCourant.setPrc(prc);
      }
      elementBaseIndemnisationCourant.setNbJoursEmploiSurPrc(tranche.getNombreJoursEmploiDansPRC());
      elementBaseIndemnisationCourant.setCoefficientHoraireJour(tranche.getCoefficientHoraireJour());
      
      p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
    }
    else
    {
      ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).setEstMontantAZero(false);
    }
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date, ChronologiePeriodes p_chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    determinerMontantPensionInvaliditeADeduire(elementBaseIndemnisationCourant, p_attribution.getDemandeur(), p_date.veille(), p_attribution.getDateAttribution());
    
    elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(BigDecimal.ZERO);
    elementBaseIndemnisationCourant.setMontantAvantageVieillesse(BigDecimal.ZERO);
    
    PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(((Attribution)p_attribution).getDemandeur(), p_date.veille());
    if (periodeAvCourante != null)
    {
      Damj dateDepart = Damj.max(p_attribution.getDateAttribution(), periodeAvCourante.getDateDebut());
      
      Sjr sjrDepart = RevalorisationSalaire.revaloriserSjrTranche((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant(), dateDepart);
      
      BigDecimal coeffAV = periodeAvCourante.getQuantiteEuro().getValeur().divide(sjrDepart.getSalaire(), 10, 4);
      
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      
      Sjr sjrCourant = RevalorisationSalaire.revaloriserSjrTranche((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant(), p_date.veille());
      
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(coeffAV.multiply(sjrCourant.getSalaire()));
      
      elementBaseIndemnisationCourant.setDateEffetAV(p_date.veille());
    }
    elementBaseIndemnisationCourant.setCoefficientSanctionReduction(RecuperationSanctionReduction.recuperationCoefficientSanctionReductionADate(p_chronologiePeriodesSanctions, p_date));
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAjourConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, Damj p_dateDeMiseAjour, ConstituantsIndemnisation p_constituantIndemnisation)
    throws CoucheLogiqueException
  {
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduiteProduit = (ConstituantsCalculActiviteReduiteAsu)p_constituantsCalculActiviteReduite;
    
    ElementBaseIndemnisation ebi = OutilsTrancheCalcul.recupererEBICalcul(p_constituantIndemnisation);
    
    constituantsCalculActiviteReduiteProduit.setSjr(RevalorisationSalaire.revaloriserSjrTranche(p_attribution, p_dateDeMiseAjour));
    
    constituantsCalculActiviteReduiteProduit.setSjc(RevalorisationSalaire.revaloriserSjc(ebi.getSjcInitial(), p_dateDeMiseAjour));
    return constituantsCalculActiviteReduiteProduit;
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ElementChomageSansRupture elementChomageSansRupture = null;
    elementChomageSansRupture = OutilsTrancheCalcul.recupererTrancheInitiale((Attribution)p_attribution).getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (estDemandeEnContexteDeChomageEnCoursDeSuspension(p_attribution)) && (!elementChomageSansRupture.estUnContexteDeRupturePendantSuspension())) {
      return recupererDateFinDroitTheoriqueCsr(p_calendrierExecutionCalcul, p_attribution);
    }
    if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)p_attribution.getDemande(), 2)) {
      return ((Attribution)p_attribution).getDateLimiteIndemnisation();
    }
    Damj dateFinDroitTheorique = null;
    EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)p_calendrierExecutionCalcul.getEtatAuDJI();
    BigDecimal reliquatDureeIndemnisation = null;
    if (etatAuDji != null)
    {
      if ((etatAuDji.getReliquatDureeIndemnisation() != null) && (etatAuDji.getReliquatDureeIndemnisation().getValeur() != null))
      {
        reliquatDureeIndemnisation = etatAuDji.getReliquatDureeIndemnisation().getValeur();
        dateFinDroitTheorique = p_calendrierExecutionCalcul.getDernierJourIndemnisable().deplacerVersAvant(new DureeCalendaire(0, 0, reliquatDureeIndemnisation.intValue()));
      }
      else
      {
        dateFinDroitTheorique = p_calendrierExecutionCalcul.getDernierJourIndemnisable();
      }
    }
    else
    {
      Attribution attribution = (Attribution)p_attribution;
      dateFinDroitTheorique = p_attribution.getPji().deplacerVersAvant(new DureeCalendaire(0, 0, attribution.getDureeIndemnisationTheorique().getValeurEntiere() - 1));
    }
    return dateFinDroitTheorique;
  }
  
  private Damj recupererDateFinDroitTheoriqueCsr(CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(p_attribution);
    ElementChomageSansRupture element = null;
    element = tranche.getElementChomageSansRupture();
    Quantite dureeProlongationTheorique = null;
    dureeProlongationTheorique = tranche.getDuree(3);
    
    Damj dateFinDroitTheorique = p_attribution.getPji().deplacerVersAvant(new DureeCalendaire(0, 0, dureeProlongationTheorique.getValeurEntiere() - 1));
    if (element.getDecisionProlongation())
    {
      if ((element.getDateMaxIndeminisation() != null) && (element.getDateMaxIndeminisation().estAvant(dateFinDroitTheorique))) {
        dateFinDroitTheorique = element.getDateMaxIndeminisation();
      }
    }
    else if (dureeProlongationTheorique != null) {
      dateFinDroitTheorique = p_attribution.getPji().deplacerVersAvant(new DureeCalendaire(0, 0, dureeProlongationTheorique.getValeurEntiere() - 1));
    }
    if ((element.getDateRepriseActivite() != null) && (element.getDateRepriseActivite().estAvant(dateFinDroitTheorique))) {
      dateFinDroitTheorique = element.getDateRepriseActivite();
    }
    boolean positionnementEffectue = false;
    if (((CalendrierExecutionCalculPeriodique)p_calendrierExecutionCalcul).getChronologieUnitesTraitements() != null)
    {
      Iterator iterateurUT = ((CalendrierExecutionCalculPeriodique)p_calendrierExecutionCalcul).getChronologieUnitesTraitements().iterer();
      while ((iterateurUT.hasNext()) && (!positionnementEffectue))
      {
        fr.unedic.cali.calcul.dom.UniteTraitement ut = (fr.unedic.cali.calcul.dom.UniteTraitement)iterateurUT.next();
        if (dateFinDroitTheorique.estContenueDans(ut.getPeriode()))
        {
          ut.ajouterEvenement(new EvenementLimiteIndemnisationChomageSansRCT(dateFinDroitTheorique));
          positionnementEffectue = true;
        }
      }
    }
    return dateFinDroitTheorique;
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = null;
    IndividuSpec individu = null;
    
    periodesIndividuelles = new ChronologiePeriodes();
    individu = p_attribution.getDemandeur();
    
    enrichirPeriodeDisponibilite(p_attribution, individu);
    
    ChronologiePeriodes chronologiePeriodesISLR = recupererPeriodeISLRAAjouter(individu, p_attribution);
    if ((chronologiePeriodesISLR != null) && (!chronologiePeriodesISLR.estVide())) {
      periodesIndividuelles.ajouter(chronologiePeriodesISLR);
    }
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(periodesIndividuelles, p_attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(periodesIndividuelles, p_attribution);
    if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)p_attribution.getDemande(), 2)) {
      periodesIndividuelles.ajouter(new ObjetChronoPeriodeLimiteIndemnisationPMVS(((Attribution)p_attribution).getDateLimiteIndemnisation().lendemain(), p_attribution.getRsod()));
    }
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(p_attribution);
    ElementChomageSansRupture elementChomageSansRupture = tranche.getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (estDemandeEnContexteDeChomageEnCoursDeSuspension(p_attribution))) {
      return recupererPeriodesProduitCsr(p_attribution, periodesIndividuelles);
    }
    return periodesIndividuelles;
  }
  
  private ConstituantsIndemnisation creationConstituantsIndemnisationCsr(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(p_attribution);
    Iterator iterator = null;
    QuantiteDroitSpec duree = null;
    Collection collectionDurees = OutilsTrancheCalcul.getListeDurees((Attribution)p_attribution);
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    boolean estUnContexteDeRupturePendantSuspension = estUnContexteDeRupturePendantSuspension(p_attribution);
    
    iterator = collectionDurees.iterator();
    while (iterator.hasNext())
    {
      duree = (QuantiteDroitSpec)iterator.next();
      if ((!(duree instanceof DureeProlongation)) || (!estUnContexteDeRupturePendantSuspension))
      {
        List listeDureeProlongation = new ArrayList();
        listeDureeProlongation.add(duree);
        constituantsIndemnisation.ajouterQuantiteDroit(listeDureeProlongation, duree);
      }
    }
    if (((p_attribution instanceof Reprise)) && (!estUnContexteDeRupturePendantSuspension))
    {
      Attribution attribution = (Attribution)p_attribution;
      AttributionAssuranceSpec attributionPrecedente = attribution.getAttributionPrecedente();
      
      boolean estUneAttributionPrecedenteAvecContexteDeCSR = estDemandeEnContexteDeChomageEnCoursDeSuspension(attributionPrecedente);
      
      ElementChomageSansRupture elementChomageSansRupture = null;
      elementChomageSansRupture = tranche.getElementChomageSansRupture();
      if ((elementChomageSansRupture != null) && (!elementChomageSansRupture.getDecisionProlongation())) {
        if ((elementChomageSansRupture.getDateRepriseActivite() != null) && (p_attribution.getDateAttribution().estAvant(elementChomageSansRupture.getDateRepriseActivite())))
        {
          EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
          if ((etatAuDji != null) && (estUneAttributionPrecedenteAvecContexteDeCSR) && (etatAuDji.getReliquatDureeProlongation().getValeurEntiere() != 0))
          {
            List listeDureeProlongation = new ArrayList();
            DureeProlongation dureeProlongation = new DureeProlongation(etatAuDji.getReliquatDureeProlongation().getValeurEntiere());
            listeDureeProlongation.add(dureeProlongation);
            constituantsIndemnisation.ajouterQuantiteDroit(listeDureeProlongation, dureeProlongation);
          }
          else if (etatAuDji != null)
          {
            List listeDureeProlongation = new ArrayList();
            DureeProlongation dureeProlongation = new DureeProlongation(Math.min(182, etatAuDji.getReliquatDureeIndemnisationAvecMaintien().getValeurEntiere()));
            listeDureeProlongation.add(dureeProlongation);
            constituantsIndemnisation.ajouterQuantiteDroit(listeDureeProlongation, dureeProlongation);
          }
        }
      }
    }
    return constituantsIndemnisation;
  }
  
  protected ChronologiePeriodes recupererPeriodesProduitCsr(AttributionSpec p_attribution, ChronologiePeriodes p_periodesIndividuelles)
    throws CoucheLogiqueException
  {
    boolean contexteRupturePendantSuspension = false;
    TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(p_attribution);
    ElementChomageSansRupture elementChomageSansRupture = null;
    elementChomageSansRupture = tranche.getElementChomageSansRupture();
    if (!estUnContexteDeRupturePendantSuspension(p_attribution))
    {
      if (elementChomageSansRupture != null) {
        contexteRupturePendantSuspension = elementChomageSansRupture.estUnContexteDeRupturePendantSuspension();
      }
      if (elementChomageSansRupture != null)
      {
        Damj dateFinProduit = null;
        
        Damj dateRepriseActivite = elementChomageSansRupture.getDateRepriseActivite();
        if (dateRepriseActivite != null) {
          dateFinProduit = dateRepriseActivite;
        }
        boolean estDecisionProlongation = elementChomageSansRupture.getDecisionProlongation();
        if (estDecisionProlongation)
        {
          Damj dateDecisionProlongation = elementChomageSansRupture.getDateMaxIndeminisation();
          if ((dateRepriseActivite == null) || ((dateDecisionProlongation != null) && (dateDecisionProlongation.lendemain().estAvant(dateRepriseActivite)))) {
            dateFinProduit = dateDecisionProlongation.lendemain();
          }
        }
        if ((dateFinProduit != null) && (!contexteRupturePendantSuspension)) {
          p_periodesIndividuelles.ajouter(new ObjectChronoFinChomageSansRct(dateFinProduit));
        }
      }
    }
    else
    {
      Collection listeDelaiReport = tranche.getListeDelaisReports();
      if ((listeDelaiReport != null) && (!listeDelaiReport.isEmpty()))
      {
        CarencePrefixeAFixer pmc = (CarencePrefixeAFixer)OutilCarence.trouverCarence(listeDelaiReport, "PMC_NI");
        CarencePrefixeAFixer islr = (CarencePrefixeAFixer)OutilCarence.trouverCarence(listeDelaiReport, "ISLR");
        CarencePrefixeAFixer differe = (CarencePrefixeAFixer)OutilCarence.trouverCarence(listeDelaiReport, "Différé");
        if (pmc != null)
        {
          pmc.setPeriodeApplicationCarence(new Periode(pmc.getDateFinPeriodeOrigine().lendemain(), pmc.getQuantiteInitial().getValeurEntiere()));
          if (islr != null)
          {
            islr.setPeriodeApplicationCarence(new Periode(pmc.getPeriodeApplicationCarence().getFin().lendemain(), islr.getQuantiteInitial().getValeurEntiere()));
            if (differe != null) {
              differe.setPeriodeApplicationCarence(new Periode(islr.getPeriodeApplicationCarence().getFin().lendemain(), differe.getQuantiteInitial().getValeurEntiere()));
            }
          }
          else if (differe != null)
          {
            differe.setPeriodeApplicationCarence(new Periode(pmc.getPeriodeApplicationCarence().getFin().lendemain(), differe.getQuantiteInitial().getValeurEntiere()));
          }
        }
        else if (islr != null)
        {
          islr.setPeriodeApplicationCarence(new Periode(islr.getDateFinPeriodeOrigine().lendemain(), islr.getQuantiteInitial().getValeurEntiere()));
          if (differe != null) {
            differe.setPeriodeApplicationCarence(new Periode(islr.getPeriodeApplicationCarence().getFin().lendemain(), differe.getQuantiteInitial().getValeurEntiere()));
          }
        }
        else if (differe != null)
        {
          differe.setPeriodeApplicationCarence(new Periode(OutilsChomageSansRCT.getDateFinSuspension((DemandeAssuranceSpec)p_attribution.getDemande()).lendemain(), differe.getQuantiteInitial().getValeurEntiere()));
        }
        Iterator itListeDelaiReports = listeDelaiReport.iterator();
        while (itListeDelaiReports.hasNext())
        {
          CarenceSpec carence = (CarenceSpec)itListeDelaiReports.next();
          if ("Différé".equals(carence.getTypeCarence()))
          {
            Periode periodeCarence = ((Differe)carence).getPeriodeApplicationCarence();
            int nbJoursDiffere = ((Differe)carence).getQuantiteInitial().getValeurEntiere();
            if ((periodeCarence != null) && (nbJoursDiffere > 0))
            {
              ChronologiePeriodes chronologiePeriodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(p_attribution.getDemandeur(), p_attribution.getDateAttribution(), null);
              Qualification qualification = new Qualification();
              QualificationPeriodes periodesQualifie = qualification.qualificationPeriodesPourAvant(chronologiePeriodesGAEC, p_attribution);
              ChronologiePeriodes chronologiePeriodeMaladie = (ChronologiePeriodes)periodesQualifie.getPeriodesSuspensives().copier(new FiltrePeriodeEvenementPersonnel());
              
              Damj dateDebutDiffere = periodeCarence.getDebut();
              dateDebutDiffere = rechercheTrouMaladie(dateDebutDiffere, chronologiePeriodeMaladie);
              
              DureeCalendaire decalage = new DureeCalendaire(0, 0, nbJoursDiffere - 1);
              p_periodesIndividuelles.ajouter(new ObjetChronoPeriodeCarences(dateDebutDiffere, dateDebutDiffere.deplacerVersAvant(decalage), 1));
            }
          }
          else if ("ISLR".equals(carence.getTypeCarence()))
          {
            Periode periodeCarence = ((CarencePrefixeAFixer)carence).getPeriodeApplicationCarence();
            if (periodeCarence != null) {
              p_periodesIndividuelles.ajouter(new ObjetChronoPeriodeCarences(periodeCarence.getDebut(), periodeCarence.getFin(), 2));
            }
          }
          else if ("PMC_NI".equals(carence.getTypeCarence()))
          {
            Periode periodeCarence = ((CarencePrefixeAFixer)carence).getPeriodeApplicationCarence();
            if (periodeCarence != null) {
              p_periodesIndividuelles.ajouter(new ObjetChronoPeriodePreavis(periodeCarence.getDebut(), periodeCarence.getFin()));
            }
          }
        }
      }
    }
    return p_periodesIndividuelles;
  }
  
  protected boolean estDemandeEnContexteDeChomageEnCoursDeSuspension(AttributionSpec p_attribution)
  {
    ElementChomageSansRupture elementChomageSansRupture = null;
    if (!OutilsTrancheCalcul.estTrancheActive(p_attribution)) {
      elementChomageSansRupture = ((Attribution)p_attribution).getElementChomageSansRupture();
    } else {
      elementChomageSansRupture = OutilsTrancheCalcul.recupererTrancheInitiale((Attribution)p_attribution).getElementChomageSansRupture();
    }
    if (elementChomageSansRupture != null) {
      return elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension();
    }
    return false;
  }
  
  protected boolean estUnContexteDeRupturePendantSuspension(AttributionSpec p_attribution)
  {
    ElementChomageSansRupture elementChomageSansRupture = null;
    if (!OutilsTrancheCalcul.estTrancheActive(p_attribution)) {
      elementChomageSansRupture = ((Attribution)p_attribution).getElementChomageSansRupture();
    } else {
      elementChomageSansRupture = OutilsTrancheCalcul.recupererTrancheInitiale((Attribution)p_attribution).getElementChomageSansRupture();
    }
    if (elementChomageSansRupture != null) {
      return elementChomageSansRupture.estUnContexteDeRupturePendantSuspension();
    }
    return false;
  }
  
  public fr.unedic.cali.calcul.dom.UniteTraitement creerUT(Periode p_periodeUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return new fr.unedic.cali.asu.calcul.dom.UniteTraitement(Unite.get("jour"), p_periodeUT);
  }
  
  public Quantite getQuantiteIndemnisableTheorique(Periode p_periode, AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUt)
  {
    return new QuantiteJour(new BigDecimal(p_periode.getDuree()));
  }
  
  public Damj getDateFinQuantiteDroit(Periode p_periode, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroit, ChronologiePeriodes p_chronologieRemplissage, Quantite p_quantiteAImputer, Damj p_dateDebutQuantiteDroit)
  {
    return OutillageCalculADate.remplirTrousChronologieParIndemnisation(p_chronologieRemplissage, p_quantiteAImputer, p_periode);
  }
  
  public Damj getDateFinProduit(AttributionSpec p_attribution, QuantiteDroitSpec p_quantite, Damj p_dateFinQuantite)
  {
    return p_dateFinQuantite;
  }
  
  protected void determinerMontantPensionInvaliditeADeduire(ElementBaseIndemnisation p_ebi, IndividuSpec p_individu, Damj p_date, Damj p_dateAttribution)
    throws CoucheLogiqueException
  {
    p_ebi.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChainees(p_ebi, p_individu, p_date, p_dateAttribution));
  }
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws ApplicativeException
  {
    Iterator iterator = null;
    QuantiteDroitSpec duree = null;
    Collection collectionDurees = null;
    
    collectionDurees = p_constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        duree = (QuantiteDroitSpec)iterator.next();
        if (((duree instanceof DureeIndemnisation)) || ((duree instanceof DureeProlongation)))
        {
          duree.activer();
          initialiseElementBaseIndemnisationCourante(p_constituantsIndemnisation, p_attribution, p_periodeUT);
        }
      }
    }
  }
  
  public boolean epuisementQuantiteDroit(Damj p_dateEpuisementQuantite, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroitEpuisee, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws ApplicativeException
  {
    boolean finDeProduit = false;
    if ((p_quantiteDroitEpuisee instanceof DureeDetectionMaintien))
    {
      if ((Maintien.getInstance().evaluerConditionAge(p_attribution, p_dateEpuisementQuantite)) && 
        (Maintien.getInstance().evaluerConditionReliquat(p_constituantsIndemnisation))) {
        Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)p_attribution, p_dateEpuisementQuantite.lendemain(), p_constituantsIndemnisation);
      }
    }
    else if ((p_quantiteDroitEpuisee instanceof QuantiteIndemnisationSpec))
    {
      Attribution attribution = (Attribution)p_attribution;
      if (!attribution.estMaintenue()) {
        finDeProduit = true;
      } else {
        p_constituantsIndemnisation.setCodeFormuleMontant(((QuantiteIndemnisationSpec)p_quantiteDroitEpuisee).getCodeFormuleMontant());
      }
    }
    ElementChomageSansRupture elementChomageSansRupture = ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (!elementChomageSansRupture.estUnContexteDeRupturePendantSuspension()) && 
      (!finDeProduit) && 
      ((p_quantiteDroitEpuisee instanceof DureeProlongation))) {
      if (elementChomageSansRupture.getDecisionProlongation())
      {
        Damj dateProlongation = elementChomageSansRupture.getDateMaxIndeminisation();
        if ((dateProlongation != null) && (dateProlongation.estAvant(p_dateEpuisementQuantite))) {
          finDeProduit = true;
        }
      }
      else
      {
        finDeProduit = true;
        if ((elementChomageSansRupture.estAccordCp()) && (elementChomageSansRupture.estSinistreOuCalamite())) {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, p_dateEpuisementQuantite, 26, 0, true, null, this, p_constituantsIndemnisation);
        }
      }
    }
    return finDeProduit;
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    if (OutilsTrancheCalcul.estTrancheActive(attribution)) {
      return MajCiTranche.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
    }
    return MajCi.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAJourCumulAR(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, ContexteUT p_contexteUT, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduite = (ConstituantsCalculActiviteReduiteAsu)p_constituantsCalculActiviteReduite;
    
    int cumulActiviteReduite = constituantsCalculActiviteReduite.getCumul();
    boolean existeAttributionPrecedenteAvecCumulAr = false;
    boolean individuPossedeCesSurUt = false;
    boolean individuPossedeCaeSurUt = false;
    boolean individuPossedeCaeCuiSurUt = false;
    
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(p_ut.getDateDebut());
    FabriqueConventionTransitoireCalcul2014 fabrique = FabriqueConventionTransitoireCalcul2014.getInstance();
    StrategieGenerationEnqueteCumulARSpec strategie = (StrategieGenerationEnqueteCumulARSpec)fabrique.getStrategie(critere);
    
    FabriqueConventionTransitoireCalcul2014 fabriqueDRV = FabriqueConventionTransitoireCalcul2014.getInstance();
    StrategieGestionDRVSpec strategieGestionDRVARE14Apres = fabriqueDRV.getStrategieGestionDRV(critere);
    
    ConstituantsIndemnisation constituantIndemnisation = p_ut.getConstituantsIndemnisationEnDebutUT();
    if ((strategieGestionDRVARE14Apres.mettreAjourCumulMoisNonIndemnise()) && (constituantsCalculActiviteReduite != null) && (!((AttributionAssuranceSpec)p_attribution).estMaintenue()) && (p_ut.getDateDebut().estAvant(GestionnaireDateApplication.getInstance().recupererDateApplication("Fin application de l'ancien dispositif DRV")))) {
      miseAjourNombreMoisNonIndemnise(p_attribution, p_ut, constituantsCalculActiviteReduite, p_contexteUT, p_arretProduitAvecRaison);
    }
    if ((((p_attribution instanceof RepriseSpec)) || ((p_attribution instanceof RevisionSpec))) && (p_attribution.getPji().estContenueDans(p_ut.getPeriode()))) {
      existeAttributionPrecedenteAvecCumulAr = existeAttributionPrecedenteAvecCumulAr(p_attribution, p_contexteUT);
    }
    if (existeAttributionPrecedenteAvecCumulAr) {
      constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite + 1);
    }
    if (!existeAttributionPrecedenteAvecCumulAr)
    {
      Iterator iterateurPeriode = p_ut.getQualificationPeriodes().getPeriodesDecalantes().iterer();
      while (iterateurPeriode.hasNext())
      {
        ObjetChronoPeriode periodeActivite = (ObjetChronoPeriode)iterateurPeriode.next();
        if ((periodeActivite instanceof PeriodeActiviteEmploiCalcul))
        {
          if (7 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
            individuPossedeCesSurUt = true;
          }
          if (14 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
            individuPossedeCaeSurUt = true;
          }
          if (23 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
            individuPossedeCaeCuiSurUt = true;
          }
        }
      }
      boolean decalageSurPa = false;
      Iterator<PeriodeAnalyseSpec> ite = p_ut.getListePeriodesAnalyse().iterer();
      while (ite.hasNext())
      {
        PeriodeAnalyse pa = (PeriodeAnalyse)ite.next();
        if ((pa.getQuantiteDecalee() != null) && (pa.getQuantiteDecalee().getValeurEntiere() >= 0)) {
          decalageSurPa = true;
        }
      }
      if ((!individuPossedeCesSurUt) && (!individuPossedeCaeSurUt) && (!individuPossedeCaeCuiSurUt) && (!p_ut.isNeutralisee()) && (((p_ut.getCreditDecalage() != null) && (p_ut.getCreditDecalage().getValeur() != null) && (p_ut.getCreditDecalage().getValeur().intValue() >= 0)) || ((decalageSurPa) && (p_ut.getQuantiteIndemnisee() != null) && (p_ut.getQuantiteIndemnisee().getValeur() != null) && (p_ut.getQuantiteIndemnisee().getValeur().intValue() >= 1))))
      {
        cumulActiviteReduite++;
        constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite);
        
        Reglement reglementOdCourante = ((ElementBaseIndemnisation)constituantIndemnisation.getElementBaseIndemnisationCourant()).getReglementMontantRetenu();
        if ((!reglementOdCourante.equals(p_attribution.getProduit().getReglement("A4"))) && (cumulActiviteReduite == 13) && (p_attribution.getDemandeur().getAgeALaDate(p_ut.getDateDebut()).getAnnees() < 50) && (strategie != null) && (strategie.genererEnqueteCumulAR())) {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, p_ut.getDateFin(), 11, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
        }
        if ((cumulActiviteReduite == 1) && (p_ut.getStatut() != 5)) {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, Damj.max(p_ut.getDateDebut(), p_attribution.getPji()), 4, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
    return constituantsCalculActiviteReduite;
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes p_chronologiePeriodes, AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(p_chronologiePeriodes, p_attribution);
  }
  
  public ChronologiePeriodes decoupageEtProratisationPeriodesActivites(PeriodesPriseEnCompte p_periodesPriseEnCompte, int p_typePeriodeDeReference, ChronologiePeriodes p_chronologieDePeriodesAProratiser, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    Periode periodeDeReference = null;
    Iterator iterator = null;
    ChronologiePeriodes chronologie = null;
    ObjetChronoPeriode objetChronoPeriode = null;
    iterator = p_periodesPriseEnCompte.getPeriodesParTypologie(p_typePeriodeDeReference).iterer();
    chronologie = new ChronologiePeriodes();
    while (iterator.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
      periodeDeReference = new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin());
      chronologie.ajouter(DecoupageProratisation.decoupageEtProratisationPeriodesActivites(periodeDeReference, p_chronologieDePeriodesAProratiser));
    }
    Iterator<?> ite = chronologie.iterer();
    while (ite.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)ite.next();
      if (((objetChronoPeriode instanceof Pans)) && (objetChronoPeriode.getDateDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Prise en compte des ANS mensuel et supra M")))) {
        ite.remove();
      }
    }
    return chronologie;
  }
  
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT p_contexteUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    
    Collection collectionPeriode = p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourGamme(p_attribution, "ASU");
    
    List liste = p_contexteUT.getListeAttributions();
    if (liste != null)
    {
      Iterator iterator = liste.iterator();
      while (iterator.hasNext())
      {
        AttributionSpec attribution = (AttributionSpec)iterator.next();
        if (attribution.getGamme().getNomUnique().equals("SOL")) {
          if (((attribution.getProduit().getNomUnique().equals("SOL_AER05_01")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_02")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_03"))) && (attribution.getCalendrierExecutionCalcul() != null) && ((attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 1) || (attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 2)))
          {
            Damj djiTheoriqueAER = ((ProduitSolSpec)attribution.getProduit()).getDjiTheoriqueAER(attribution);
            chronologiePeriodes.ajouter(new ObjetChronoPeriodeInterProduits(djiTheoriqueAER.lendemain(), djiTheoriqueAER.lendemain(), 5, attribution));
          }
        }
      }
    }
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_01"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_02"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_03"));
    
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourProduit(p_attribution, "INR_RCE04_01"));
    
    chronologiePeriodes.ajouter(collectionPeriode);
    if (!((AttributionAssuranceSpec)p_attribution).estMaintenue())
    {
      chronologiePeriodes.ajouter(Maintien.getInstance().genererEvenementAgeDetection(p_attribution));
      if (Maintien.getInstance().estDate100TConnue((AttributionAssuranceSpec)p_attribution)) {
        chronologiePeriodes.ajouter(Maintien.getInstance().genererEvenement100TDetection(p_attribution));
      }
    }
    else if (((Attribution)p_attribution).getDemandeMaintien() != null)
    {
      chronologiePeriodes.ajouter(Maintien.getInstance().genererEvenementMaintien(p_attribution));
    }
    chronologiePeriodes.ajouter(RechercheDecisionsInterruptives.rechercher(p_attribution.getDemandeur(), OutilGestionPoursuite.getInstance().recupererPremierJourExecutableNcp(p_attribution), p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsPeriodesLieuSurUTPourGammeRBF(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTIndemnisationRfpe(p_attribution));
    
    chronologiePeriodes.ajouter(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "RET_ACO01_01"));
    
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(p_contexteUT.getPeriodeUT().getDebut());
    FabriqueStrategieConvention2014 fabriqueAre14 = FabriqueStrategieConvention2014.getInstance();
    StrategieConventionARE14Spec strategieARE14 = (StrategieConventionARE14Spec)fabriqueAre14.getStrategie(critere);
    if (strategieARE14.estApresConventionARE14())
    {
      Iterator ite = ((AttributionAssuranceSpec)p_attribution).getListeActiviteConservee().iterer();
      while (ite.hasNext())
      {
        TravailSpec activite = (TravailSpec)ite.next();
        if ((!(activite instanceof TravailNonSalarie)) && (activite.getDateFin().estContenueDans(p_contexteUT.getPeriodeUT())))
        {
          boolean estSup122jours = activite.getPeriode().getDuree() >= 122;
          if ((estSup122jours) && (RechercheConditionChomageInvolontaire.getInstance().determinerChomageNonLegitime(activite)))
          {
            if (!estDecisionneeSuiteActiviteConserveePerdue(activite, p_attribution))
            {
              chronologiePeriodes.ajouter(new ObjetChronoBlocageM12(activite.getDateFin(), p_attribution.getRsod()));
              chronologiePeriodes.ajouter(new ObjetChronoPeriodeBlocagePerteActiviteConservee(activite.getDateFin().lendemain(), p_attribution.getRsod()));
              
              genererEnqueteSuiteOrdonnancementExamen(p_attribution, activite.getDateFin());
            }
          }
          else if ((!estDecisionneeSuiteActiviteConserveePerdue(activite, p_attribution)) && (!estDemandeApresActiviteConserveePerdue(activite.getDateFin(), p_attribution)) && (!genererEnqueteSuiteOrdonnancementExamen(p_attribution, activite.getDateFin()))) {
            chronologiePeriodes.ajouter(new ObjetChronoAnomalieI04(activite.getDateFin(), p_attribution.getRsod()));
          }
        }
      }
    }
    return chronologiePeriodes;
  }
  
  private boolean genererEnqueteSuiteOrdonnancementExamen(AttributionSpec attribution, Damj dateFCT)
    throws CoucheLogiqueException
  {
    boolean resultat = false;
    if (dateFCT.estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Ordonnancement examen")))
    {
      GestionSuivi.enregistrerEnquetePbjcNcp(attribution, dateFCT, 48, 0, true, null, this, null);
      
      resultat = true;
    }
    return resultat;
  }
  
  public boolean estDecisionneeSuiteActiviteConserveePerdue(TravailSpec p_activite, AttributionSpec p_attribution)
  {
    Map<TravailSpec, DemandeSpec> maps = OutilsRevisions.getMapFctsAssociees(p_attribution.getDemandeur());
    DemandeSpec demande = (DemandeSpec)maps.get(p_activite);
    return (demande != null) && (demande.estDecisionnee());
  }
  
  private boolean estDemandeApresActiviteConserveePerdue(Damj dateFct, AttributionSpec attribution)
  {
    return OutilRecherche.rechercherDemandeSuivante(attribution.getDemande().getChronologieDemandesAssuranceSansCourante(), dateFct.veille(), new FiltreDemandePourERE("ASU_28")) != null;
  }
  
  public void determinerStatutUT(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    boolean absenceAuPointage = false;
    if (p_ut.getQualificationPeriodes().getPeriodesGelantes() != null)
    {
      ChronologiePeriodes periodesGelantes = p_ut.getQualificationPeriodes().getPeriodesGelantes();
      periodesGelantes.iterer();
      while (periodesGelantes.encoreSuivant()) {
        if ((periodesGelantes.elementSuivant() instanceof PeriodeAbsenceAuPointage))
        {
          p_ut.setStatut(6);
          absenceAuPointage = true;
        }
      }
    }
    if ((!absenceAuPointage) && 
      (!GestionForcage.appliquerForcageStatut(p_attribution.getDemande(), p_ut)))
    {
      p_ut.setStatut(DefinitionStatutUtTraitementActiviteReduite.definirStatutUt(p_attribution, p_periodesDecalantes, ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).getNbMoisEnPPA(), estEnFormation(p_ut), p_ut, p_arretProduitAvecRaison, this));
      if ((p_ut.getStatut() == 5) || (p_ut.getStatut() == 9))
      {
        int nbMoisEnPPA = ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).getNbMoisEnPPA();
        ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).setNbMoisEnPPA(nbMoisEnPPA + 1);
      }
    }
  }
  
  public void traitementPeriodesGelantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesGelantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesGelantes(p_attribution, p_periodesGelantes, p_constituantsCalculActiviteReduite, p_ut);
  }
  
  public void traitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesDecalantes(p_attribution, p_periodesDecalantes, p_constituantsCalculActiviteReduite, p_ut);
  }
  
  public void traitementPeriodesSuspensives(AttributionSpec p_attribution, ChronologiePeriodes p_periodesSuspensives, PeriodeAnalyseSpec p_pa)
    throws CoucheLogiqueException
  {
    Quantite quantiteSuspensive = TraitementPeriodes.getQuantiteSuspensive(p_pa.getPeriode(), p_pa.getQuantiteIndemnisable(), p_periodesSuspensives);
    
    p_pa.setQuantiteNonIndemnisee(p_pa.getQuantiteNonIndemnisee().ajouter(quantiteSuspensive));
  }
  
  public void traitementPeriodeSegmentante(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison, ChronologiePeriodes p_periodesAnalyses)
    throws ApplicativeException
  {
    if (((p_periode instanceof PeriodeSousPensionInvaliditeChainee)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().add(((PeriodeSousPensionInvaliditeChainee)p_periode).getMontant().getValeur()));
    }
    else if (((p_periode instanceof FinPeriodePensionInvaliditeChainee)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().subtract(((FinPeriodePensionInvaliditeChainee)p_periode).getQuantiteEuro().getValeur()));
      
      p_ut.ajouterEvenement(new EvenementFinPeriodePensionInvalidite(p_periode.getDateDebut().veille()));
    }
    else
    {
      if (OutilsMaintienEuropeenEessiASU.controlerContexteMaintienEuropeen(p_attribution.getDemandeur(), p_periode.getDateDebut())) {
        if ((p_periode instanceof PeriodeFormation))
        {
          if (((PeriodeFormation)p_periode).estEffective()) {
            passerEnIndemnisationAvecFormation(p_periode, p_constituantsIndemnisation);
          } else {
            passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
          }
        }
        else if ((p_periode instanceof ObjetChronoPeriodeDetectionAgeMaintien))
        {
          if (!((AttributionAssuranceSpec)p_attribution).estMaintenue()) {
            if (Maintien.getInstance().controlerConditionsDetectionHorsAge((AttributionAssuranceSpec)p_attribution, p_constituantsIndemnisation, p_periode.getDateDebut(), p_ut)) {
              Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)p_attribution, p_periode.getDateDebut(), p_constituantsIndemnisation);
            }
          }
        }
        else if ((p_periode instanceof ObjetChronoPeriodeDetection100TMaintien))
        {
          if (!((AttributionAssuranceSpec)p_attribution).estMaintenue()) {
            if (Maintien.getInstance().controlerConditionsDetectionHors100T((AttributionAssuranceSpec)p_attribution, p_constituantsIndemnisation, p_periode.getDateDebut(), p_ut)) {
              Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)p_attribution, p_periode.getDateDebut(), p_constituantsIndemnisation);
            }
          }
        }
        else if ((p_periode instanceof ObjetChronoPeriodeMaintien))
        {
          if (((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC() != null) {
            Maintien.getInstance().detecter((AttributionAssuranceSpec)p_attribution, ((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC(), false, p_constituantsIndemnisation);
          } else {
            Maintien.getInstance().detecter((AttributionAssuranceSpec)p_attribution, p_periode.getDateDebut(), false, p_constituantsIndemnisation);
          }
          if (((AttributionAssuranceSpec)p_attribution).estMaintenue()) {
            if (((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC() != null) {
              p_ut.ajouterEvenement(new EvenementMaintien(((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC()));
            } else {
              p_ut.ajouterEvenement(new EvenementMaintien(p_periode.getDateDebut()));
            }
          }
        }
      }
      if (((p_periode instanceof PeriodeInterStageFormation)) || ((p_periode instanceof FinActionFormation)))
      {
        passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
      }
      else if ((p_periode instanceof PeriodeSanctionReductionMontant))
      {
        ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
        if (((PeriodeSanctionReductionMontant)p_periode).getCodeSanction().equals("R1")) {
          elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("0.80"));
        } else if (((PeriodeSanctionReductionMontant)p_periode).getCodeSanction().equals("R2")) {
          elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("0.50"));
        }
      }
      else if (((p_periode instanceof FinPeriodeSanctionReductionMontant)) && (((p_pa != null) && (p_pa.getDateDebut().estContenueDans(((FinPeriodeSanctionReductionMontant)p_periode).getPeriode()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
      {
        ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
        
        elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("1.00"));
      }
      else if (((p_periode instanceof PeriodePensionInvalidite)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
      {
        ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
        
        elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().add(((PeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
      }
      else if (((p_periode instanceof PeriodeAvantageVieillesse)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
      {
        ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
        
        BigDecimal montantAv = null;
        if ((elementBaseIndemnisation.getDateEffetAV() == null) || (elementBaseIndemnisation.getDateEffetAV().estAvant(p_periode.getDateDebut())))
        {
          montantAv = ((PeriodeAvantageVieillesse)p_periode).getQuantiteEuro().getValeur();
          elementBaseIndemnisation.setDateEffetAV(p_periode.getDateDebut());
        }
        else if (elementBaseIndemnisation.getDateEffetAV().coincideAvec(p_periode.getDateDebut()))
        {
          montantAv = elementBaseIndemnisation.getMontantAvantageVieillesse().add(((PeriodeAvantageVieillesse)p_periode).getQuantiteEuro().getValeur());
        }
        if (montantAv != null)
        {
          elementBaseIndemnisation.setMontantAvantageVieillesse(montantAv);
          if ((elementBaseIndemnisation.getSjr() != null) && (elementBaseIndemnisation.getSjr().getSalaire() != null) && (!elementBaseIndemnisation.getSjr().getSalaire().equals(new BigDecimal("0.00"))))
          {
            BigDecimal coeffAV = montantAv.divide(elementBaseIndemnisation.getSjr().getSalaire(), 10, 4);
            
            elementBaseIndemnisation.setCoefficientAvantageVieillesse(coeffAV);
          }
        }
      }
      else if (((p_periode instanceof FinPeriodeAvantageVieillesse)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
      {
        ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
        
        elementBaseIndemnisation.setCoefficientAvantageVieillesse(BigDecimal.ZERO);
        elementBaseIndemnisation.setMontantAvantageVieillesse(BigDecimal.ZERO);
      }
      else if (((p_periode instanceof FinPeriodePensionInvalidite)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
      {
        ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
        elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().subtract(((FinPeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
      }
      else if (((p_periode instanceof FinPeriodeFormationNonIndemnisee)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
      {
        if (((Attribution)p_attribution).getDureeInitiale().getValeurEntiere() > ((ProduitAsuSpec)p_attribution.getProduit()).getDureeMinimumPourImputationFormation()) {
          imputerQuantiteIndemnisationADate(p_ut, p_periode, p_pa, p_constituantsIndemnisation, p_arretProduitAvecRaison, p_attribution);
        }
      }
      else if (((p_periode instanceof PeriodeSuspensionDDTEAvecImputation)) && (p_pa != null) && (((PeriodeSuspensionDDTEAvecImputation)p_periode).getPeriodeInitiale().getDebut().coincideAvec(p_pa.getDateDebut())))
      {
        PeriodeSuspensionDDTEAvecImputation periode = (PeriodeSuspensionDDTEAvecImputation)p_periode.copie();
        
        Damj finPeriodesAnalyse = null;
        ObjetChronoPeriode periodesAnalyse = (ObjetChronoPeriode)p_periodesAnalyses.dernierElement();
        finPeriodesAnalyse = periodesAnalyse.getDateFin();
        if ((finPeriodesAnalyse != null) && (((PeriodeSuspensionDDTEAvecImputation)p_periode).getPeriodeInitiale().getFin().estApres(finPeriodesAnalyse))) {
          periode.setDateFin(finPeriodesAnalyse);
        }
        imputerQuantiteIndemnisationDuAuxSanctions(p_attribution, p_ut, periode, p_constituantsIndemnisation, p_arretProduitAvecRaison);
      }
      else if ((p_periode instanceof ObjetChronoPeriodeDebutPec))
      {
        OutilsMaintienEuropeenEessiASU.controlerEtEmettreEnqueteMaintienEuropeen(p_attribution, p_constituantsIndemnisation, p_periode.getDateDebut(), this, null, p_ut);
        passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
      }
    }
  }
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    FormuleMontantSpec fm = null;
    if (FormuleMontantAREF.getCode().equals(p_code)) {
      fm = new FormuleMontantAREF();
    } else if (FormuleMontantRegimeGeneral.getCode().equals(p_code)) {
      fm = new FormuleMontantRegimeGeneral();
    }
    return fm;
  }
  
  private void passerEnIndemnisationSansFormation(ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    }
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant().copie();
    
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisation);
  }
  
  private void passerEnIndemnisationAvecFormation(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantAREF.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantAREF.getCode());
    }
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant());
    if ((p_periode instanceof PeriodeFormation)) {
      elementBaseIndemnisationAREF.setEffectif(((PeriodeFormation)p_periode).estEffective());
    }
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
  }
  
  public boolean verifierConditionExecutionEtEventuelAbandon(AttributionSpec p_attribution, ContexteUT p_contexteUT, Periode p_periodeUT, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    if (((AttributionAssuranceSpec)p_attribution).estTopeeRenoncement())
    {
      p_calendrierExecutionCalcul.setEtatAttribution(6);
      return false;
    }
    if (!p_attribution.estPjiEffectif())
    {
      p_calendrierExecutionCalcul.setEtatAttribution(4);
      return false;
    }
    return true;
  }
  
  public boolean verifierImputationDuree(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    boolean retour = true;
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    if ((!p_ut.isNeutralisee()) && (elementBaseIndemnisation.estMontantAZero()) && (p_ut.getDateDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("PI à 0 suite INC0399669")))) {
      retour = false;
    }
    return retour;
  }
  
  public void controlerAttribution(AttributionSpec p_attribution)
    throws ContexteException
  {
    Attribution attribution = (Attribution)p_attribution;
    
    Damj dateARE = DATE_ATTRIBUTION_MINIMALE;
    if (attribution.getDateEffet().estAvant(dateARE)) {
      throw new ContexteException("HG_PR_CALI_L_ERR_CONTEXTE", "La date de l'Ouverture de Droit doit etre posterieure au 01/07/2001", null);
    }
  }
  
  public ResultatCalcul postTraitementResultatDetaille(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetaille(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDetailleNotification(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetailleNotification(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDeterminationEtatDroit(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, Damj p_dateEtatDroit)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDeterminationEtatDroit(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul, p_dateEtatDroit);
  }
  
  protected void traitementFDD(PeriodesPriseEnCompte periodesPriseEnCompte, Periode periodeUT, ContexteUT contexteUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    appliquerFiltreSurFDDSuiteEpuismentOuDateAnniverssaire(periodesPriseEnCompte, periodeUT, contexteUT, attribution);
  }
  
  public void controlerAPosterioriContexteUT(AttributionSpec attribution, ContexteUT contexteUT, fr.unedic.cali.calcul.dom.UniteTraitement ut, ArretProduitAvecRaison arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronoDecalante = ut.getQualificationPeriodes().getPeriodesDecalantes();
    chronoDecalante.iterer();
    while (chronoDecalante.encoreSuivant())
    {
      ObjetChronoPeriodeCalcul periodeDecalante = (ObjetChronoPeriodeCalcul)chronoDecalante.elementSuivant();
      if (((periodeDecalante instanceof PansMensuel)) || ((periodeDecalante instanceof PansSupraMensuel)) || ((periodeDecalante instanceof PansMensuelNonRemuneree)))
      {
        EnquetePbjcNcp enqueteCourrierKC6Q = GestionSuivi.retourneEnqueteEnPersistance(attribution.getDemandeur().getListEnquetesPbjcNcp(), Integer.parseInt(attribution.getRsod()), 47);
        if (enqueteCourrierKC6Q == null) {
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, periodeDecalante.getDateDebut(), 47, 0, true, attribution.determinerCodeSousProduitPourSigma(), this, ut.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
  }
  
  public AttributionSpec rechercherAttributionPrecedenteSurLUT(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return ((AttributionAssuranceSpec)p_attribution).getAttributionPrecedente();
  }
  
  public ElementBaseIndemnisationFacade mapperUTVersElementBaseIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution)
  {
    ElementBaseIndemnisationFacade elt = new ElementBaseIndemnisationFacade();
    ElementBaseIndemnisation eltBase = null;
    eltBase = (ElementBaseIndemnisation)p_ut.getConstituantsIndemnisationEnFinUT().getElementBaseIndemnisationCourant();
    
    elt.setCoefficientAvantageVieillesse(eltBase.getCoefficientAvantageVieillesse().toString());
    if (eltBase.getCoefficientSaisonnier() != null) {
      elt.setCoefficientSaisonnier(eltBase.getCoefficientSaisonnier().toString());
    }
    if (eltBase.getCoefficientTempsPartiel() != null) {
      elt.setCoefficientTempsPartiel(eltBase.getCoefficientTempsPartiel().toString());
    }
    if (eltBase.getMontantPensionInvaliditeADeduire() != null) {
      elt.setMontantPensionInvaliditeADeduire(eltBase.getMontantPensionInvaliditeADeduire().toString());
    }
    if (eltBase.getMontantAvantageVieillesse() != null) {
      elt.setMontantAvantageVieillesse(eltBase.getMontantAvantageVieillesse().toString());
    }
    if (eltBase.getSjc().getSalaire() != null) {
      elt.setSjc(eltBase.getSjc().getSalaire().toString());
    }
    if (eltBase.getSjr().getSalaire() != null) {
      elt.setSjr(eltBase.getSjr().getSalaire().toString());
    }
    if (eltBase.getTauxAvantageVieillesse() != null) {
      elt.setTauxAvantageVieillesse(elt.getTauxAvantageVieillesse());
    }
    return elt;
  }
  
  public CalendrierExecutionCalculSpec creerCalendrierExecutionCalcul(AttributionSpec p_attribution)
  {
    return new fr.unedic.cali.asu.calcul.dom.CalendrierExecutionCalcul();
  }
  
  public Collection getEvtsChangementParametre(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date)
  {
    List evtsRetour = new ArrayList();
    EvenementParametre evtParam = ParametresIndemnisation.getParametresIndemnisation().getElementActif(p_date);
    Sjr sjr = ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjr();
    if ((evtParam.isNouveauRevalorisationSjr()) && 
      (!sjr.getDateDepart().deplacerVersAvant(DUREE_6_MOIS).estApres(p_date)))
    {
      EvenementChangementParametre evt = new EvenementChangementParametre("REVALORISATION", evtParam.getDateEvenement());
      
      evtsRetour.add(evt);
    }
    return evtsRetour;
  }
  
  public MontantBaseSpec calculMontant(FormuleMontantSpec p_formuleMontant, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    return p_formuleMontant.calculer(p_constituantsIndemnisation, p_dateCalcul);
  }
  
  public void imputerQuantiteIndemnisationDuAuxPNDS(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {}
  
  public void imputerQuantiteIndemnisationDuAuxSanctions(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeSuspensionDDTEAvecImputation p_periodeSuspensionDDTEAvecImputation, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    QuantiteIndemnisationSpec dureeIndemnisation = null;
    Quantite nouvelleDureeIndemnisation = null;
    Quantite ancienneDureeIndemnisation = null;
    EvenementLendemainFinQuantiteDroit evtLendemainFinQuantiteDroit = null;
    
    dureeIndemnisation = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    
    Quantite quantiteDecalage = new Quantite(new BigDecimal(p_ut.getDuree() < p_periodeSuspensionDDTEAvecImputation.getDuree() ? p_ut.getDuree() : p_periodeSuspensionDDTEAvecImputation.getDuree()), p_ut.getUniteParDefautQuantites());
    if (quantiteDecalage != null) {
      if (p_ut.getCreditDecalageSanctions() != null) {
        p_ut.setCreditDecalageSanctions(quantiteDecalage.ajouter(p_ut.getCreditDecalageSanctions()));
      } else {
        p_ut.setCreditDecalageSanctions(quantiteDecalage);
      }
    }
    if ((dureeIndemnisation != null) && (quantiteDecalage != null))
    {
      nouvelleDureeIndemnisation = dureeIndemnisation.getQuantiteCourante().soustraire(quantiteDecalage);
      ancienneDureeIndemnisation = dureeIndemnisation.getQuantiteCourante();
      
      dureeIndemnisation.setQuantiteCourante(nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? new QuantiteJour(BigDecimal.ZERO) : nouvelleDureeIndemnisation);
    }
    if ((dureeIndemnisation != null) && (dureeIndemnisation.getQuantiteCourante().getValeurEntiere() == 0))
    {
      if ((quantiteDecalage != null) && (ancienneDureeIndemnisation != null))
      {
        Damj dateDebutImputation = p_ut.getDateDebut();
        if (dateDebutImputation.estAvant(p_attribution.getPji())) {
          dateDebutImputation = p_attribution.getPji();
        }
        if (p_periodeSuspensionDDTEAvecImputation.getPeriodeInitiale().getDebut().estApres(dateDebutImputation)) {
          dateDebutImputation = p_periodeSuspensionDDTEAvecImputation.getPeriodeInitiale().getDebut();
        }
        evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(dateDebutImputation.deplacerVersAvant(new DureeCalendaire(0, 0, quantiteDecalage.min(ancienneDureeIndemnisation).getValeurEntiere())), dureeIndemnisation);
      }
      else
      {
        evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(p_ut.getDateFin().lendemain(), dureeIndemnisation);
      }
      evtLendemainFinQuantiteDroit.setEstCauseFinProduit(true);
      p_arretProduitAvecRaison.ajouteLendemainFinQuantiteDroitArretCalcul(evtLendemainFinQuantiteDroit);
    }
  }
  
  public void forcerImputationQuantiteIndemnisation(PeriodeAnalyseSpec p_pa, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {}
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec attribution, fr.unedic.cali.calcul.dom.UniteTraitement ut, ObjetChronoPeriode objetChronoPeriode, ArretProduitAvecRaison arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    if ((objetChronoPeriode instanceof ObjetChronoPeriodeAssDemandeExpresse))
    {
      arretProduitAvecRaison.setProduitAEteindre(true);
    }
    else if ((objetChronoPeriode instanceof PeriodeExclusionDefinitiveDDTE))
    {
      arretProduitAvecRaison.setProduitAEteindre(true);
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeAEDV))
    {
      boolean contientDejaInterruptifAmemeDate = verifiePresenceIntAvantOuMemeJourHorsDV(ut, objetChronoPeriode);
      if (!contientDejaInterruptifAmemeDate)
      {
        int rangEnquete = GestionSuivi.determinerRangEnqueteDRV(attribution, objetChronoPeriode);
        
        GestionSuivi.enregistrerEnquetePbjcNcp(attribution, objetChronoPeriode.getDateDebut(), 39, rangEnquete, true, null, this, null);
        if (attribution.getDemandeur().getIndividuPbjcNcp() == null) {
          attribution.getDemandeur().setIndividuPbjcNcp(new IndividuPbjcNcp());
        }
        attribution.getDemandeur().getIndividuPbjcNcp().setDateAtteinteMoisNonPaye(objetChronoPeriode.getDateDebut().veille());
        calendrier.setDateDrv(objetChronoPeriode.getDateDebut());
        ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
      }
    }
    else if ((objetChronoPeriode instanceof PeriodeFormationNonIndemniseeAbsenceHeure))
    {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M06", objetChronoPeriode.getDateDebut(), ""), attribution.getDemandeur());
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeFinDureeMaintienDroit))
    {
      ut.ajouterEvenement(new EvenementMaintienEuropeenDJI(objetChronoPeriode.getDateDebut().veille()));
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeLimiteIndemnisationPMVS))
    {
      ut.ajouterEvenement(new EvenementLimiteIndemnisationPMVS(objetChronoPeriode.getDateDebut().veille()));
    }
    else if ((objetChronoPeriode instanceof PeriodeDisponibilite))
    {
      ut.ajouterEvenement(new EvenementPeriodesSuspensivesDisponibilite(objetChronoPeriode.getDateDebut().veille(), ((PeriodeDisponibilite)objetChronoPeriode).getLibelle()));
      if (((PeriodeDisponibilite)objetChronoPeriode).doitCreerEnquete()) {
        GestionSuivi.enregistrerEnquetePbjcNcp(attribution, objetChronoPeriode.getDateDebut().veille(), 50, 0, true, null, this, null);
      }
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeRejetDRV))
    {
      if (((ObjetChronoPeriodeRejetDRV)objetChronoPeriode).isEstRejetDV()) {
        ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
      }
    }
    else if (((objetChronoPeriode instanceof ObjetChronoPeriodeRejetRevision)) && 
      (((ObjetChronoPeriodeRejetRevision)objetChronoPeriode).isEstRejetDV()))
    {
      ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
    }
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    Damj finDeProduit = null;
    ArretProduitAvecRaison arretProduitAvecRaison = null;
    arretProduitAvecRaison = p_ut.getArretProduitAvecRaison();
    if (arretProduitAvecRaison.isRaisonsContientRaison(1)) {
      if (!arretProduitAvecRaison.getLendemainFinQuantiteIndemnisationArretCalcul().isEmpty())
      {
        finDeProduit = ((Temporel)arretProduitAvecRaison.getLendemainFinQuantiteIndemnisationArretCalcul().iterator().next()).getDateDebut().veille();
        if (!p_contexteUT.existeAERenFinASU(finDeProduit))
        {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, finDeProduit, 5, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
          
          CritereStrategie critere = new CritereStrategie();
          critere.setDatePivot(p_contexteUT.getPeriodeUT().getDebut());
          FabriqueStrategieConvention2014 fabriqueAre14 = FabriqueStrategieConvention2014.getInstance();
          StrategieConventionARE14Spec strategieARE14 = (StrategieConventionARE14Spec)fabriqueAre14.getStrategie(critere);
          if (strategieARE14.estApresConventionARE14()) {
            GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, finDeProduit, 38, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
          }
        }
      }
    }
  }
  
  private boolean estEnFormation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
  {
    ChronologiePeriodes periodesSegmentantes = p_ut.getQualificationPeriodes().getPeriodesSegmentantes();
    periodesSegmentantes.iterer();
    while (periodesSegmentantes.encoreSuivant()) {
      if ((periodesSegmentantes.elementSuivant() instanceof PeriodeFormation)) {
        return true;
      }
    }
    return false;
  }
  
  public ResultatCalcul postTraitementResultatMigrationCalcul(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatMigrationCalcul(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public EtatAuDji renseignerEtatAuDji(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT, CalendrierExecutionCalculPeriodique p_calendrier, AttributionSpec p_attribution, EtatAuDji p_etatAuDji)
    throws CoucheLogiqueException
  {
    int reliquatCumulAR = 0;
    EtatAuDjiGamme etatAuDji = new EtatAuDjiGamme();
    Quantite reliquatDureeIndemnisation = null;
    etatAuDji.setMontant(p_etatAuDji.getMontant());
    reliquatCumulAR = ((ConstituantsCalculActiviteReduiteGamme)p_derniereUT.getConstituantsCalculActiviteReduiteEnFinUT()).getCumul();
    etatAuDji.setCumulMoisActiviteReduite(reliquatCumulAR);
    reliquatDureeIndemnisation = recupererReliquatDureeIndemnisation(p_derniereUT);
    if (reliquatDureeIndemnisation != null)
    {
      etatAuDji.setReliquatDureeIndemnisation(new Quantite(reliquatDureeIndemnisation.getValeur().setScale(0), reliquatDureeIndemnisation.getUnite()));
      
      etatAuDji.setReliquatDureeIndemnisationAvecMaintien(etatAuDji.getReliquatDureeIndemnisation());
    }
    if (((AttributionAssuranceSpec)p_attribution).estMaintenue())
    {
      Damj retraite = OutillagePeriodes.genererPeriodeRetraite(p_attribution.getDemandeur()).getDateEffet();
      int dureeMaintien = retraite.joursEntre(p_calendrier.getDernierJourIndemnisable());
      etatAuDji.setReliquatDureeIndemnisationAvecMaintien(new Quantite(new BigDecimal(Integer.toString(dureeMaintien)), DureeIndemnisation.UNITE_DEFAUT));
    }
    etatAuDji.setNbJourAREF(p_derniereUT.getNbJoursFormationEnFinDUT());
    etatAuDji.setNbMoisIndemniseAsu(p_derniereUT.getNbMoisIndemniseAsu());
    etatAuDji.setEstNbMoisIndemniseAsu(p_derniereUT.isEstNbMoisIndemniseAsu());
    etatAuDji.setCumulMoisnonIndemnise(p_derniereUT.getConstituantsCalculActiviteReduiteEnFinUT().getCumulMoisNonIndemnise());
    
    ElementChomageSansRupture elementChomageSansRupture = ((ElementBaseIndemnisation)p_derniereUT.getConstituantsIndemnisationEnFinUT().getElementBaseIndemnisationCourant()).getElementChomageSansRupture();
    if ((elementChomageSansRupture != null) && (!estUnContexteDeRupturePendantSuspension(p_attribution)))
    {
      QuantiteDroitSpec reliquat = p_derniereUT.getConstituantsIndemnisationEnFinUT().getDureeProlongation();
      if (reliquat != null) {
        etatAuDji.setReliquatDureeProlongation(((QuantiteDroit)reliquat).getQuantiteCourante());
      } else {
        etatAuDji.setReliquatDureeProlongation(new Quantite("0", DureeProlongation.UNITE_DEFAUT));
      }
    }
    return etatAuDji;
  }
  
  private Quantite recupererReliquatDureeIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT)
  {
    Quantite reliquatDureeIndemnisation = null;
    Collection collectionQuantiteDroit = p_derniereUT.getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit();
    QuantiteIndemnisationSpec quantiteIndemnisation = null;
    if (collectionQuantiteDroit != null)
    {
      Iterator iterator = collectionQuantiteDroit.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroitSpec quantiteDroit = (QuantiteDroitSpec)iterator.next();
        if ((quantiteDroit instanceof QuantiteIndemnisationSpec))
        {
          quantiteIndemnisation = (QuantiteIndemnisationSpec)quantiteDroit;
          if (quantiteDroit.getEtat() == 1) {
            break;
          }
        }
      }
    }
    if (quantiteIndemnisation != null)
    {
      if (quantiteIndemnisation.getEtat() == 1) {
        reliquatDureeIndemnisation = quantiteIndemnisation.getQuantiteCourante();
      } else if (quantiteIndemnisation.getEtat() == 2) {
        reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
      }
    }
    else {
      reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
    }
    return reliquatDureeIndemnisation;
  }
  
  public void miseAJourMontantSurSommes(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {}
  
  public int initialiserCompteurFormation(AttributionSpec p_attribution)
  {
    int nbJourFormation = 0;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      nbJourFormation = ((Poursuite)attribution).getUniteTraitement().getNbJoursFormationEnFinDUT();
    }
    else if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attribution.getAttributionPrecedente() != null) && ((attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_17")) || (attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_25")))) {
        attributionPrecedente = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
      }
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
        nbJourFormation = etatAuDji.getNbJourAREF();
      }
    }
    return nbJourFormation;
  }
  
  public ChronologiePeriodes filtrerFormationsEffectives(ChronologiePeriodes p_chronologiePeriodesGAEC, ChronologiePeriodes p_chronologiePeriodesPECSansFiltre)
    throws CoucheLogiqueException
  {
    return p_chronologiePeriodesGAEC;
  }
  
  public Collection filtrerRadiationSegmentante(Collection p_collectionPeriodesPourAttribution, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return p_collectionPeriodesPourAttribution;
  }
  
  public boolean estEnActiviteConservee(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_uTraitement)
    throws CoucheLogiqueException
  {
    if (((Attribution)p_attribution).getListeActiviteConservee() != null)
    {
      Iterator ite = ((Attribution)p_attribution).getListeActiviteConservee().iterer();
      boolean aUneActiviteEncoreConserve = false;
      while (ite.hasNext())
      {
        TravailSpec activite = (TravailSpec)ite.next();
        if (activite.getDateFin().estApresOuCoincideAvec(p_uTraitement.getDateDebut())) {
          aUneActiviteEncoreConserve = true;
        }
      }
      return (!((Attribution)p_attribution).getListeActiviteConservee().estVide()) && (aUneActiviteEncoreConserve);
    }
    return false;
  }
  
  public void ajouterConstituantsIndemnisationFuturs(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {}
  
  public void imputerAvant(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    QuantiteIndemnisationSpec dureeIndemnisation = null;
    Quantite nouvelleDureeIndemnisation = null;
    BigDecimal dureeImputation = null;
    boolean calcul = false;
    dureeIndemnisation = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (((p_periode instanceof PeriodeSuspensionDDTEAvecImputation)) && ((((PeriodeSuspensionDDTEAvecImputation)p_periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTEAvecImputation)p_periode).getCodeSanction().equals("SE"))))
    {
      dureeImputation = new BigDecimal(((PeriodeSuspensionDDTEAvecImputation)p_periode).getDureeImputation());
      calcul = true;
    }
    else if (((p_periode instanceof FinPeriodeFormationNonIndemnisee)) && (((Attribution)p_attribution).getDureeInitiale().getValeurEntiere() > ((ProduitAsuSpec)p_attribution.getProduit()).getDureeMinimumPourImputationFormation()))
    {
      FinPeriodeFormationNonIndemnisee periode = (FinPeriodeFormationNonIndemnisee)p_periode;
      Quantite dureeFormation = ((FinPeriodeFormationNonIndemnisee)p_periode).getPeriodeFormationNonIndemnisee().getDureeTotale();
      Damj dateLendemainFaitGenerateur = null;
      if (((Demande)p_attribution.getDemande()).getDateFaitGenerateurOuDernierSinistre() != null) {
        dateLendemainFaitGenerateur = ((Demande)p_attribution.getDemande()).getDateFaitGenerateurOuDernierSinistre().lendemain();
      } else {
        dateLendemainFaitGenerateur = ((Demande)p_attribution.getDemande()).getDateFaitGenerateurOdPrecedente();
      }
      if ((((FinPeriodeFormationNonIndemnisee)p_periode).getDateDebutFormation().estAvant(p_attribution.getDateAttribution())) && (periode.getDateDebutFormation().estAvant(dateLendemainFaitGenerateur)))
      {
        BigDecimal prorata = Mathematiques.diviseASup(new BigDecimal(periode.getDateFinFormation().joursEntre(dateLendemainFaitGenerateur)), new BigDecimal(periode.getDateFinFormation().joursEntre(periode.getDateDebutFormation())), 2);
        
        dureeImputation = prorata.multiply(dureeFormation.getValeur());
      }
      else
      {
        dureeImputation = dureeFormation.getValeur();
      }
      dureeImputation = Mathematiques.diviseEntier(dureeImputation, new BigDecimal("10"));
      
      BigDecimal valeurMax = dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30 < 0 ? BigDecimal.ZERO : new BigDecimal(dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30);
      
      dureeImputation = dureeImputation.compareTo(valeurMax) == 1 ? valeurMax : dureeImputation;
      calcul = true;
    }
    if ((calcul) && (dureeIndemnisation != null))
    {
      nouvelleDureeIndemnisation = dureeIndemnisation.getQuantiteCourante().soustraire(new Quantite(dureeImputation, DureeIndemnisation.UNITE_DEFAUT));
      
      dureeIndemnisation.setQuantiteCourante(nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? new QuantiteJour(BigDecimal.ZERO) : nouvelleDureeIndemnisation);
    }
  }
  
  protected void imputerQuantiteIndemnisationADate(fr.unedic.cali.calcul.dom.UniteTraitement ut, ObjetChronoPeriode objetPeriode, PeriodeAnalyseSpec pa, ConstituantsIndemnisation constituantsIndemnisation, ArretProduitAvecRaison arretProduitAvecRaison, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    QuantiteIndemnisationSpec dureeIndemnisation = null;
    Quantite nouvelleDureeIndemnisation = null;
    Quantite quantiteAImputee = null;
    BigDecimal dureeImputation = null;
    EvenementLendemainFinQuantiteDroit evtLendemainFinQuantiteDroit = null;
    Damj dateLendemainFinQuantiteDroit = null;
    dureeIndemnisation = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(constituantsIndemnisation.getCollectionQuantiteDroit());
    if (dureeIndemnisation != null)
    {
      if ((objetPeriode instanceof FinPeriodeFormationNonIndemnisee)) {
        dureeImputation = imputationFinPeriodeFormationNonIndemnisee(objetPeriode, attribution, dureeIndemnisation);
      }
      nouvelleDureeIndemnisation = dureeIndemnisation.getQuantiteCourante().soustraire(new Quantite(dureeImputation, DureeIndemnisation.UNITE_DEFAUT));
      
      quantiteAImputee = nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? dureeIndemnisation.getQuantiteCourante() : new Quantite(dureeImputation, DureeIndemnisation.UNITE_DEFAUT);
      
      dureeIndemnisation.setQuantiteCourante(nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? new QuantiteJour(BigDecimal.ZERO) : nouvelleDureeIndemnisation);
      if (pa != null)
      {
        pa.setQuantiteImputeeNonIndemnisee(quantiteAImputee);
        dateLendemainFinQuantiteDroit = pa.getDateDebut().lendemain();
      }
      else
      {
        ut.setQuantiteImputeeNonIndemnisee(ut.getQuantiteImputeeNonIndemnisee().ajouter(quantiteAImputee));
        dateLendemainFinQuantiteDroit = objetPeriode.getDateDebut().lendemain();
      }
      if (dureeIndemnisation.getQuantiteCourante().getValeurEntiere() == 0)
      {
        evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(dateLendemainFinQuantiteDroit, dureeIndemnisation);
        evtLendemainFinQuantiteDroit.setEstCauseFinProduit(true);
        arretProduitAvecRaison.ajouteLendemainFinQuantiteDroitArretCalcul(evtLendemainFinQuantiteDroit);
      }
    }
  }
  
  private BigDecimal imputationFinPeriodeFormationNonIndemnisee(ObjetChronoPeriode objetPeriode, AttributionSpec attribution, QuantiteIndemnisationSpec dureeIndemnisation)
    throws CoucheLogiqueException
  {
    FinPeriodeFormationNonIndemnisee periode = (FinPeriodeFormationNonIndemnisee)objetPeriode;
    Quantite dureeFormation = ((FinPeriodeFormationNonIndemnisee)objetPeriode).getPeriodeFormationNonIndemnisee().getDureeTotale();
    
    Damj dateLendemainFaitGenerateur = ((Demande)((AttributionAssuranceSpec)attribution).getOuvertureDroitCapitalRetenu().getDemande()).getDateFaitGenerateurOuDernierSinistre().lendemain();
    BigDecimal dureeImputation;
    if ((((FinPeriodeFormationNonIndemnisee)objetPeriode).getDateDebutFormation().estAvant(attribution.getDateAttribution())) && (periode.getDateDebutFormation().estAvant(dateLendemainFaitGenerateur)))
    {
      BigDecimal prorata = Mathematiques.diviseASup(new BigDecimal(periode.getDateFinFormation().joursEntre(dateLendemainFaitGenerateur)), new BigDecimal(periode.getDateFinFormation().joursEntre(periode.getDateDebutFormation())), 2);
      
      dureeImputation = prorata.multiply(dureeFormation.getValeur());
    }
    else
    {
      dureeImputation = dureeFormation.getValeur();
    }
    BigDecimal dureeImputation = Mathematiques.diviseEntier(dureeImputation, new BigDecimal("10"));
    
    BigDecimal valeurMax = dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30 < 0 ? BigDecimal.ZERO : new BigDecimal(dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30);
    
    dureeImputation = dureeImputation.compareTo(valeurMax) == 1 ? valeurMax : dureeImputation;
    return dureeImputation;
  }
  
  public void controlerPjiAttribution(AttributionSpec p_attribution, Damj p_dateExecution)
    throws CoucheLogiqueException
  {}
  
  public void controlerDureeDetectionMaintien(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {}
  
  protected boolean existeAttributionPrecedenteAvecCumulAr(AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    AttributionSpec attributionPrecedente = ((Attribution)p_attribution).getAttributionPrecedente();
    if ((attributionPrecedente != null) && (fr.unedic.cali.asu.outilsfonctionnels.OutilDemande.estUneDemandeFinDroitAsr(attributionPrecedente.getDemande()))) {
      attributionPrecedente = (Attribution)OutilAsr.rechercherDernierDroitAsr(attributionPrecedente.getDemande());
    }
    if ((attributionPrecedente != null) && (attributionPrecedente.estNeutralise()) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (p_contexteUT.getPeriodeUT().contient(attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable()))) {
      return true;
    }
    while ((attributionPrecedente != null) && (p_contexteUT.getListeOrdonneeCandidats().contains(attributionPrecedente)))
    {
      ContexteUT.ElementContexteUT elementContexteUT = p_contexteUT.getElementContexteUT(attributionPrecedente);
      if ((elementContexteUT.getQuantiteIndemnisee() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur().intValue() >= 1) && (elementContexteUT.getCreditDecalageSurUT() != null)) {
        return true;
      }
      if (((attributionPrecedente instanceof RepriseSpec)) || ((attributionPrecedente instanceof RevisionSpec))) {
        attributionPrecedente = ((Attribution)attributionPrecedente).getAttributionPrecedente();
      } else {
        attributionPrecedente = null;
      }
    }
    return false;
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws ApplicativeException
  {
    if (((p_periode instanceof ObjetChronoBlocageM12)) && ((p_periode.getDateDebut().estAvant(p_pa.getDateFin())) || ((p_periode.getDateDebut().coincideAvec(p_pa.getDateFin())) && (p_arretProduitAvecRaison.getPeriodesInterruptivesDefinitives().size() == 1) && (estBlocageM12(p_arretProduitAvecRaison)) && (p_periode.getDateDebut().lendemain().coincideAvec(p_arretProduitAvecRaison.recupereLendemainDateArret())) && ((p_arretProduitAvecRaison.recupererLendemainDateArretIndemnisation() == null) || (!p_periode.getDateDebut().lendemain().coincideAvec(p_arretProduitAvecRaison.recupererLendemainDateArretIndemnisation())))))) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M12", p_periode.getDateDebut(), ""), p_attribution.getDemandeur());
    } else if (((p_periode instanceof ObjetChronoAnomalieI04)) && ((p_periode.getDateDebut().estAvant(p_pa.getDateFin())) || ((p_periode.getDateDebut().coincideAvec(p_pa.getDateFin())) && (p_arretProduitAvecRaison.getPeriodesInterruptivesDefinitives().isEmpty()) && (!p_arretProduitAvecRaison.isRaisonsContientRaison(1)) && (!p_arretProduitAvecRaison.isRaisonsContientRaison(2))))) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("I04", p_periode.getDateDebut(), ""), p_attribution.getDemandeur());
    }
  }
  
  private boolean estBlocageM12(ArretProduitAvecRaison p_arretProduitAvecRaison)
  {
    for (Object o : p_arretProduitAvecRaison.getPeriodesInterruptivesDefinitives()) {
      if ((o instanceof ObjetChronoPeriodeBlocagePerteActiviteConservee)) {
        return true;
      }
    }
    return false;
  }
  
  public void cumulerMontantGlobalServiAttribution(ConstituantsIndemnisation p_constituantsIndemnisation, Quantite p_nbJoursImputes, MontantBaseSpec p_montant, AttributionSpec p_attribution) {}
  
  public BigDecimal recupererPlafondGlobal(AttributionSpec p_attribution, Damj p_dateDebut)
  {
    return null;
  }
  
  public BigDecimal determinerCumulServiADate(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public String recupererCategorieAttribution(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public void incrementationNbMoisInactivite(ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite) {}
  
  public int calculerCompteurNombreJoursIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_cumulNombreJoursServi)
  {
    return 0;
  }
  
  public boolean neutralisationApplicableRetourUL961()
  {
    return true;
  }
  
  public void ajouterEvenementDebutImputation(PeriodeAnalyseSpec p_pa, List p_listeQuantiteDroitActives) {}
  
  public ChronologiePeriodes recupererPeriodeAPartirDesPECs(ChronologiePeriodes p_chronologiePeriodesPECSansFiltre, Periode p_periodeUT, Damj p_dateDJA)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public int calculerCompteurNombreMoisIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_nbMoisIndemniseEnDebutDUT)
  {
    int nbMoisIndemniseAsu = p_ut.getNbMoisIndemniseEnDebutDUT();
    
    Quantite quantiteIndemnise = p_ut.getQuantiteIndemnisee();
    if (quantiteIndemnise.getValeur().intValue() >= 1) {
      nbMoisIndemniseAsu += 1;
    }
    return nbMoisIndemniseAsu;
  }
  
  public int initialiserNombreMoisIndemnise(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    int nbMoisIndemniseAsu = 0;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      nbMoisIndemniseAsu = ((Poursuite)attribution).getUniteTraitement().getNbMoisIndemniseAsu();
    }
    else if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attributionPrecedente != null) && (fr.unedic.cali.outilsfonctionnels.OutilDemande.estUneDemandeFinDroit(attributionPrecedente.getDemande()))) {
        attributionPrecedente = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
      }
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
        if (etatAuDji.isEstNbMoisIndemniseAsu()) {
          nbMoisIndemniseAsu = etatAuDji.getNbMoisIndemniseAsu();
        }
        if ((attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable() != null) && (p_ut.getPeriode().contient(attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable()))) {
          if ((attributionPrecedente.estNeutralise()) || (!attributionPrecedente.estExecutable()))
          {
            nbMoisIndemniseAsu = Math.max(0, nbMoisIndemniseAsu--);
          }
          else
          {
            ContexteUT.ElementContexteUT elementContexteUT = p_contexteUT.getElementContexteUT(attributionPrecedente);
            if ((elementContexteUT.getQuantiteIndemnisee() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur().intValue() > 0) && (p_ut.getQuantiteIndemnisee() != null) && (p_ut.getQuantiteIndemnisee().getValeur() != null) && (p_ut.getQuantiteIndemnisee().getValeur().intValue() > 0)) {
              nbMoisIndemniseAsu--;
            }
          }
        }
      }
    }
    return nbMoisIndemniseAsu;
  }
  
  public boolean recuperationAlimentationNombreMoisIndemnise(AttributionSpec p_attribution)
  {
    boolean estAlimenteNbMoisIndemniseAsu = false;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      estAlimenteNbMoisIndemniseAsu = ((Poursuite)attribution).getUniteTraitement().getNbMoisIndemniseAsu() != 0;
    }
    else if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attribution.getAttributionPrecedente() != null) && (fr.unedic.cali.outilsfonctionnels.OutilDemande.estUneDemandeFinDroit(attributionPrecedente.getDemande()))) {
        attributionPrecedente = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
      }
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
        
        estAlimenteNbMoisIndemniseAsu = etatAuDji.isEstNbMoisIndemniseAsu();
      }
    }
    else if ((attribution instanceof OdSpec))
    {
      estAlimenteNbMoisIndemniseAsu = true;
    }
    else
    {
      estAlimenteNbMoisIndemniseAsu = false;
    }
    return estAlimenteNbMoisIndemniseAsu;
  }
  
  public void controleActiviteReduiteMaintienEuropeen(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    OutilsMaintienEuropeenEessiASU.controleActiviteReduiteMaintienEuropeen(p_attribution, p_ut, p_arretProduitAvecRaison, p_constituantsIndemnisation);
  }
  
  public Damj getIdeMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return OutilsMaintienEuropeenEessiASU.getIdeMaintienEuropeenDuDroit(p_attribution);
  }
  
  public Damj getPjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
  {
    return OutilsMaintienEuropeenEessiASU.getPjiMaintienEuropeenDuDroit(p_attribution);
  }
  
  public Damj getDjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return OutilsMaintienEuropeenEessiASU.getDjiMaintienEuropeenDuDroit(p_attribution, this);
  }
  
  public boolean enregistrerDroitPBJCNCP(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public boolean enregistrerEnquetePBJCNCP()
  {
    return true;
  }
  
  protected static Damj rechercheTrouMaladie(Damj p_dateDebutDiffere, ChronologiePeriodes p_chronoPeriodesMaladie)
  {
    p_chronoPeriodesMaladie.iterer();
    while (p_chronoPeriodesMaladie.encoreSuivant())
    {
      ObjetChronoPeriode periodeMaladie = (ObjetChronoPeriode)p_chronoPeriodesMaladie.elementSuivant();
      if ((periodeMaladie.getDateDebut().estAvantOuCoincideAvec(p_dateDebutDiffere)) && (periodeMaladie.getDateFin().estApresOuCoincideAvec(p_dateDebutDiffere))) {
        return rechercheTrouMaladie(periodeMaladie.getDateFin().lendemain(), p_chronoPeriodesMaladie);
      }
    }
    return p_dateDebutDiffere;
  }
  
  public void alimenterGrapheAntecedentCalcul(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    if ((p_attribution instanceof Poursuite)) {
      GestionPoursuiteCalcul.getInstance().alimenterGrapheCalcul(p_attribution);
    } else {
      GestionAntecedentCalculAsu.getInstance().alimenterGrapheCalcul(p_attribution);
    }
  }
  
  public Damj recupererPremierJourExecutableNcp(AttributionSpec p_attribution)
  {
    if ((p_attribution instanceof Poursuite))
    {
      if (((Poursuite)p_attribution).getUniteTraitementAvant() != null) {
        return p_attribution.getPji();
      }
      return ((Poursuite)p_attribution).getPjp();
    }
    return p_attribution.getPji();
  }
  
  public fr.unedic.cali.calcul.dom.EvenementFinQuantiteDroit creerEvenementFinQuantiteDroit(Damj p_dateEffet, QuantiteDroitSpec p_quantiteDroit)
  {
    return new fr.unedic.cali.asu.calcul.dom.EvenementFinQuantiteDroit(p_dateEffet, p_quantiteDroit);
  }
  
  public fr.unedic.cali.calcul.dom.periode.DsmTravail convertirDsmTravailVersDsmTravailProduit(fr.unedic.cali.calcul.dom.periode.DsmTravail p_dsmTravail)
  {
    return new fr.unedic.cali.asu.calcul.dom.periode.DsmTravail(p_dsmTravail);
  }
  
  public void postTraitementQualification(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, QualificationPeriodes p_qualificationPeriodes)
    throws CoucheLogiqueException
  {}
  
  public void traitementActiviteReduiteSurPa(PeriodeAnalyseSpec p_pa, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution, MontantBaseSpec p_montant, BigDecimal sjr)
    throws CoucheLogiqueException
  {
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(p_pa.getDateDebut());
    StrategieConventionARE14Spec strategie = (StrategieConventionARE14Spec)FabriqueStrategieConvention2014.getInstance().getStrategie(critere);
    if (strategie.estApresConventionARE14())
    {
      Quantite quantiteSansSusp = null;
      
      quantiteSansSusp = p_pa.getQuantiteIndemnisable().soustraire(p_pa.getQuantiteNonIndemnisee());
      if ((!p_ut.getChronoPeriodeDecalante().estVide()) && (!verifierTraitementARSurAvant(p_ut, p_attribution))) {
        ActiviteReduite.traitementActiviteReduiteSurPa(p_pa, p_ut.getChronoPeriodeDecalante(), p_attribution, p_montant, quantiteSansSusp, p_ut, sjr);
      }
    }
  }
  
  public BigDecimal recupererPlafondGlobal(AttributionSpec attribution, Damj dateDebut, BigDecimal sjr)
  {
    return null;
  }
  
  protected boolean verifierTraitementARSurAvant(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Damj pointDeDepartDA = null;
    boolean departDAsurMemeMoisPJI = false;
    Differe delaiAttente = (Differe)OutilsTrancheCalcul.recupererDelai(attribution, "Différé");
    if ((delaiAttente != null) && (delaiAttente.getPeriodeApplicationCarence() != null))
    {
      pointDeDepartDA = delaiAttente.getPeriodeApplicationCarence().getDebut();
      if ((pointDeDepartDA.estContenueDans(ut.getPeriode())) && (delaiAttente.getQuantiteInitial() != null) && (delaiAttente.getQuantiteInitial().getValeurEntiere() == 7))
      {
        FabriqueStrategieConvention2014 fab = new FabriqueStrategieConvention2014();
        CritereStrategie cs = new CritereStrategie();
        cs.setDatePivot(attribution.getDateAttribution());
        StrategieConventionARE14Spec strat = (StrategieConventionARE14Spec)fab.getStrategie(cs);
        if (strat.estApresConventionARE14()) {
          departDAsurMemeMoisPJI = true;
        }
      }
    }
    return departDAsurMemeMoisPJI;
  }
  
  public boolean verifierApplicationForcageSurUT(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return !verifierTraitementARSurAvant(ut, attribution);
  }
  
  public ObjetChronoPeriodeSuspensionIslr creerObjetSuspensionIslr(ObjetChronoPeriodeSuspensionIslr periodeIslr, ProduitSpec produit)
    throws CoucheLogiqueException
  {
    if (FabriqueStrategieAppliquerISLR.getInstance().recupererDateApplication().estAvantOuCoincideAvec(periodeIslr.getDateFct()))
    {
      QuantiteEuro montant = ConstitutionISLR.getInstance().calculeISLR(periodeIslr.getActivite().getListeIndemnites(), periodeIslr.getActivite().getCodeMotifFin(), periodeIslr.getActivite().getCategorieEmploiParticulier(), periodeIslr.getDateFct());
      if ((montant != null) && (montant.getValeur().signum() == 1))
      {
        CritereStrategie critere = new CritereStrategie();
        critere.setDatePivot(periodeIslr.getDateFct());
        critere.setProduit(produit);
        StrategieSpec strategie = FabriqueStrategieISLR.getInstance().getStrategie(critere);
        FormuleDelaiReportSpec formuleCarenceIslr = ((StrategieFormuleISLRSpec)strategie).getFormuleISLR();
        
        BaseDelaiReport bdr = new BaseDelaiReport();
        bdr.setDateFg(periodeIslr.getDateFct());
        bdr.setQuantiteEuroIslr(montant);
        bdr.setMotifRupture(periodeIslr.getActivite().getCodeMotifFin());
        
        QuantiteJour jours = (QuantiteJour)formuleCarenceIslr.appliquerFormule(bdr);
        if ((jours != null) && (jours.getNombreJours() > 0))
        {
          periodeIslr.setDateFin(periodeIslr.getDateDebut().deplacerVersAvant(new DureeCalendaire(0, 0, jours.getNombreJours() - 1)));
          ObjetChronoPeriode periodeGlobaleAAjouter = (ObjetChronoPeriode)periodeIslr.copie();
          periodeIslr.setPeriodeGlobaleSuspensionISLR((ObjetChronoPeriodeSuspensionIslr)periodeGlobaleAAjouter);
          return periodeIslr;
        }
      }
    }
    return null;
  }
  
  public ChronologiePeriodes recupererPeriodeISLRAAjouter(IndividuSpec individu, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodesActiviteCalcul = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
    ChronologiePeriodes chronoPeriodesIndemnisation = RechercherPeriodeIndemnisation.getListePeriodesIndemnisationAssurance(individu, attribution.getDateAttribution());
    ChronologiePeriodes chronoPeriodesISLRAAjouter = new ChronologiePeriodes();
    ChronologiePeriodes chronoFctAvecIslr = MapperPeriodesCalcul.recupererFctIslr(chronologiePeriodesActiviteCalcul, Damj.FIN_DES_TEMPS);
    chronoFctAvecIslr.iterer();
    while (chronoFctAvecIslr.encoreSuivant())
    {
      ObjetChronoPeriodeSuspensionIslr islr = (ObjetChronoPeriodeSuspensionIslr)chronoFctAvecIslr.elementSuivant();
      if (islr.getDateFct().estApresOuCoincideAvec(attribution.getDateAttribution()))
      {
        ObjetChronoPeriodeSuspensionIslr periodeIslrAjouter = creerObjetSuspensionIslr(islr, attribution.getProduit());
        if (periodeIslrAjouter != null) {
          chronoPeriodesISLRAAjouter.ajouter(periodeIslrAjouter);
        }
      }
      else
      {
        CritereStrategie critere = new CritereStrategie();
        critere.setDatePivot(islr.getDateFct());
        StrategieAppliquerISLRSpec strategieISLR = (StrategieAppliquerISLRSpec)FabriqueStrategieAppliquerISLR.getInstance().getStrategie(critere);
        if (!strategieISLR.doitAppliquerISLR(chronoPeriodesIndemnisation, islr.getDateFct()))
        {
          ObjetChronoPeriodeSuspensionIslr periodeIslrAjouter = creerObjetSuspensionIslr(islr, attribution.getProduit());
          if (periodeIslrAjouter != null) {
            chronoPeriodesISLRAAjouter.ajouter(periodeIslrAjouter);
          }
        }
      }
    }
    return chronoPeriodesISLRAAjouter;
  }
  
  protected boolean verifiePresenceIntAvantOuMemeJourHorsDV(fr.unedic.cali.calcul.dom.UniteTraitement ut, ObjetChronoPeriode objetChronoPeriode)
  {
    boolean contientDejaInterruptifAmemeDate = false;
    ChronologiePeriodes periodesInterruptivesDefinitives = ut.getQualificationPeriodes().getPeriodesInterruptivesDefinitives();
    ObjetChronoPeriode objet = null;
    Iterator<ObjetChronoPeriode> ite = periodesInterruptivesDefinitives.iterer();
    while (ite.hasNext())
    {
      objet = (ObjetChronoPeriode)ite.next();
      if ((objet.getDateDebut().estAvantOuCoincideAvec(objetChronoPeriode.getDateDebut())) && (!(objet instanceof ObjetChronoPeriodeAEDV)) && (!(objet instanceof ObjetChronoPeriodeRejetDVFilEau)) && (!(objet instanceof ObjetChronoPeriodeAEDVMayotte))) {
        contientDejaInterruptifAmemeDate = true;
      }
    }
    return contientDejaInterruptifAmemeDate;
  }
  
  public FiltreTemporel ajouterFiltrePeriodeSurUT()
  {
    return new FiltreNegation(new FiltrePansCalcul());
  }
}

/* Location:
 * Qualified Name:     FacadeCalculLigneImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */