package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.outilsfonctionnels.CreationPeriodeNonDeclareeSanction;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieActiviteReduitePansConservee;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieActiviteReduitePansConserveeSpec;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Spec;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.EvenementFinCumul;
import fr.unedic.cali.calcul.dom.SyntheseARsurUT;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.Pans;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminationActiviteConserveeReprise;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminerJustificatifsRevenusAR;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ResultatActiviteReduite;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodePANSConservee;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.UniteMonaitaire;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.UniteDuree;
import java.math.BigDecimal;
import java.util.Collection;

public class TraitementActiviteReduite
{
  private static final int NB_JOURS_DECALAGE_AJOUTE_PPA = 6;
  private static final double MULTIPLICATEUR_POUR_PPA = 0.8D;
  private static final int SEUIL_MOIS_NI = 3;
  
  public static void traitementPeriodesGelantes(AttributionSpec attribution, ChronologiePeriodes periodesGelantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement uniteTraitement)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesGelantesDeclareees = new ChronologiePeriodes();
    ChronologiePeriodes periodesGelantesJustifiees = new ChronologiePeriodes();
    
    boolean traitementActiviteReduite = preTraitementPeriodesGelantes(attribution, uniteTraitement, periodesGelantes, periodesGelantesDeclareees, periodesGelantesJustifiees);
    if ((traitementActiviteReduite) && (estAvantConventionARE14(uniteTraitement.getDateDebut())))
    {
      if (periodesGelantesJustifiees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(attribution, periodesGelantesJustifiees, constituantsCalculActiviteReduite, uniteTraitement, false);
        
        postTraitementPeriodesGelantes(uniteTraitement, resultatActiviteReduite);
      }
      if (periodesGelantesDeclareees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(attribution, periodesGelantesDeclareees, constituantsCalculActiviteReduite, uniteTraitement, false);
        
        postTraitementPeriodesGelantes(uniteTraitement, resultatActiviteReduite);
      }
    }
    if ((constituantsCalculActiviteReduite.getCumulMoisNonIndemnise() >= 3) && (attribution.getDemandeur().getDernierJourAtteste() != null) && (uniteTraitement.getDateDebut().estAvantOuCoincideAvec(attribution.getDemandeur().getDernierJourAtteste())) && (uniteTraitement.getDateDebut().estAvant(GestionnaireDateApplication.getInstance().recupererDateApplication("Fin application de l'ancien dispositif DRV"))))
    {
      CalendrierExecutionCalculPeriodique calendrierPeriodique = null;
      if (attribution.getCalendrierExecutionCalcul() != null) {
        calendrierPeriodique = (CalendrierExecutionCalculPeriodique)attribution.getCalendrierExecutionCalcul();
      }
      if ((!uniteTraitement.isNeutralisee()) || ((uniteTraitement.isNeutralisee()) && (calendrierPeriodique != null) && (calendrierPeriodique.getDateDrv() != null) && (calendrierPeriodique.getDateDrv().estAvantOuCoincideAvec(uniteTraitement.getDateDebut()))))
      {
        uniteTraitement.setNeutralisee(true);
        uniteTraitement.setTypeNeutralisation(11);
      }
    }
  }
  
  public static void traitementPeriodesDecalantes(AttributionSpec attribution, ChronologiePeriodes periodesDecalantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement uniteTraitement)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesDecalantesDeclarees = new ChronologiePeriodes();
    ChronologiePeriodes periodesDecalantesJustifiees = new ChronologiePeriodes();
    ChronologiePeriodes periodeNonDeclareeSanction = null;
    ObjetChronoPeriodeCalcul periodeTravailCalcul = null;
    
    boolean traitementActiviteReduite = preTraitementPeriodesDecalantes(attribution, periodesDecalantes, constituantsCalculActiviteReduite, uniteTraitement, periodesDecalantesDeclarees, periodesDecalantesJustifiees, periodeNonDeclareeSanction, periodeTravailCalcul);
    if (traitementActiviteReduite)
    {
      if (periodesDecalantesJustifiees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(attribution, periodesDecalantesJustifiees, constituantsCalculActiviteReduite, uniteTraitement, false);
        
        uniteTraitement.setChronoPeriodeDecalante(periodesDecalantesJustifiees);
        
        postTraitementPeriodesDecalantes(uniteTraitement, resultatActiviteReduite, attribution);
      }
      if (periodesDecalantesDeclarees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(attribution, periodesDecalantesDeclarees, constituantsCalculActiviteReduite, uniteTraitement, false);
        
        postTraitementPeriodesDecalantes(uniteTraitement, resultatActiviteReduite, attribution);
        
        uniteTraitement.setChronoPeriodeDecalante(periodesDecalantesDeclarees);
        appliquerRegleSurUTPP(uniteTraitement);
      }
    }
  }
  
  protected static ResultatActiviteReduite appelleActiviteReduite(AttributionSpec pattribution, ChronologiePeriodes periodesEmploi, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement uniteTraitement, boolean estPNDS)
    throws CoucheLogiqueException
  {
    BigDecimal salaireSjc = null;
    Attribution attribution = (Attribution)pattribution;
    
    DureeCalendaire age = pattribution.getDemandeur().getAgeALaDate(uniteTraitement.getDateFin());
    if (constituantsCalculActiviteReduite.getSjcProduit() != null) {
      salaireSjc = constituantsCalculActiviteReduite.getSjcProduit().getSalaire();
    }
    DeterminerJustificatifsRevenusAR.traitementRevenusBS(periodesEmploi, uniteTraitement.getDateDebut(), pattribution);
    
    return ActiviteReduite.genererEvenementActiviteReduite(uniteTraitement.getDateDebut(), periodesEmploi, age, ((Attribution)pattribution).isTopContratsRemuneresBaseSmic(), constituantsCalculActiviteReduite.getCumul(), attribution.getNomReglementApplicable(), constituantsCalculActiviteReduite.getSjrProduit().getSalaire(), salaireSjc, estPNDS, attribution);
  }
  
  protected static boolean preTraitementPeriodesDecalantes(AttributionSpec attribution, ChronologiePeriodes periodesDecalantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement uniteTraitement, ChronologiePeriodes periodesDecalantesDeclareees, ChronologiePeriodes pperiodesDecalantesJustifiees, ChronologiePeriodes periodeNonDeclareeSanction, ObjetChronoPeriodeCalcul periodeTravailCalcul)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesDecalantesJustifiees = new ChronologiePeriodes();
    boolean traitementActiviteReduite = false;
    BigDecimal gains = BigDecimal.ZERO;
    BigDecimal heures = BigDecimal.ZERO;
    BigDecimal totalNbJourTravail = BigDecimal.ZERO;
    
    Chronologie chronoPeriodesConserveesLiq = null;
    if ((((AttributionAssuranceSpec)attribution).getReglementApplicable().getReglement().getNomReglement().equalsIgnoreCase("A4")) && (estAvantConventionARE14(uniteTraitement.getDateDebut()))) {
      chronoPeriodesConserveesLiq = new ChronologiePeriodes();
    } else {
      chronoPeriodesConserveesLiq = ((Attribution)attribution).getListeActiviteConservee();
    }
    periodesDecalantes.iterer();
    while (periodesDecalantes.encoreSuivant())
    {
      periodeTravailCalcul = (ObjetChronoPeriodeCalcul)periodesDecalantes.elementSuivant();
      if (((periodeTravailCalcul instanceof PeriodeTravailJustifiee)) || ((periodeTravailCalcul instanceof PeriodePrime)))
      {
        boolean periodeAIgnorer = DeterminationActiviteConserveeReprise.determinerTypeActivite(chronoPeriodesConserveesLiq, uniteTraitement, periodeTravailCalcul, attribution);
        if (!periodeAIgnorer) {
          periodesDecalantesJustifiees.ajouter(periodeTravailCalcul);
        }
      }
      if (((periodeTravailCalcul instanceof DsmTravail)) && ((uniteTraitement.getStatut() == 5) || (uniteTraitement.getStatut() == 9))) {
        periodesDecalantesDeclareees.ajouter(periodeTravailCalcul);
      }
      if (((periodeTravailCalcul instanceof DsmTravail)) && (uniteTraitement.getStatut() == 4))
      {
        if (((DsmTravail)periodeTravailCalcul).getGain() != null) {
          gains = gains.add(((DsmTravail)periodeTravailCalcul).getGain());
        }
        if (((DsmTravail)periodeTravailCalcul).getNombreHeures() != null) {
          heures = heures.add(((DsmTravail)periodeTravailCalcul).getNombreHeures());
        }
        totalNbJourTravail = totalNbJourTravail.add(new BigDecimal(periodeTravailCalcul.getDuree()));
      }
    }
    boolean presencePansConservee = !periodesDecalantesJustifiees.copier(new FiltrePeriodePANSConservee()).estVide();
    switch (uniteTraitement.getStatut())
    {
    case 1: 
    case 2: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    case 3: 
    case 7: 
    case 8: 
      if (periodesDecalantesJustifiees.getTaille() != 0)
      {
        pperiodesDecalantesJustifiees.ajouter(periodesDecalantesJustifiees);
        traitementActiviteReduite = true;
      }
      periodeNonDeclareeSanction = CreationPeriodeNonDeclareeSanction.creerPeriodeNonDeclareeSanction(attribution.getDemandeur(), uniteTraitement.getDateDebut(), periodesDecalantes, false);
      if ((periodeNonDeclareeSanction != null) && (!periodeNonDeclareeSanction.estVide())) {
        uniteTraitement.getListePNDs().add(periodeNonDeclareeSanction);
      }
      break;
    case 4: 
      SyntheseARsurUT syntheseARsurUT = uniteTraitement.getSyntheseARsurUT();
      syntheseARsurUT.setTotalGainUtilisePourDecalage(new QuantiteEuro(gains));
      syntheseARsurUT.setTotalHeureUtilisePourDecalage(new QuantiteEuro(heures));
      syntheseARsurUT.setCumulJourDeTravailAR(new Quantite(totalNbJourTravail, uniteTraitement.getUniteParDefautQuantites()));
      break;
    case 6: 
      break;
    case 5: 
    case 9: 
      if (periodesDecalantesDeclareees.getTaille() != 0) {
        traitementActiviteReduite = true;
      }
      break;
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    }
    if ((!((Attribution)attribution).getNomReglementApplicable().equalsIgnoreCase("A4")) && (estAvantConventionARE14(uniteTraitement.getDateDebut())))
    {
      BigDecimal sjr = constituantsCalculActiviteReduite.getSjrProduit().getSalaire();
      BigDecimal sjc = constituantsCalculActiviteReduite.getSjcProduit().getSalaire();
      boolean apprenti = ((Attribution)attribution).isTopContratsRemuneresBaseSmic();
      if ((chronoPeriodesConserveesLiq != null) && (!chronoPeriodesConserveesLiq.estVide()))
      {
        BigDecimal cumulGainPansConservee = BigDecimal.ZERO;
        boolean estAMettreAJour = false;
        
        periodesDecalantesJustifiees.iterer();
        while (periodesDecalantesJustifiees.encoreSuivant())
        {
          ObjetChronoPeriodeCalcul periodeDecalanteCalcul = (ObjetChronoPeriodeCalcul)periodesDecalantesJustifiees.elementSuivant();
          if (((periodeDecalanteCalcul instanceof Pans)) && (((Pans)periodeDecalanteCalcul).getTypeActivite() == 1)) {
            cumulGainPansConservee = cumulGainPansConservee.add(((Pans)periodeDecalanteCalcul).getGain());
          }
        }
        CritereStrategie critere = new CritereStrategie();
        critere.setDatePivot(uniteTraitement.getDateDebut());
        FabriqueStrategieActiviteReduitePansConservee fabrique = new FabriqueStrategieActiviteReduitePansConservee();
        StrategieActiviteReduitePansConserveeSpec strategie = (StrategieActiviteReduitePansConserveeSpec)fabrique.getStrategie(critere);
        BigDecimal gainPansConserveeALaLiquidation = strategie.getGainPansConserveeALaLiquidation(attribution, cumulGainPansConservee);
        
        chronoPeriodesConserveesLiq.iterer();
        while ((chronoPeriodesConserveesLiq.encoreSuivant()) && (!estAMettreAJour))
        {
          TravailSpec periodeConserveeLiq = (TravailSpec)chronoPeriodesConserveesLiq.elementSuivant();
          if ((((Attribution)attribution).getTermePrcActiviteConservee() != null) && (periodeConserveeLiq.getDateDebut().estAvant(((Attribution)attribution).getTermePrcActiviteConservee()))) {
            estAMettreAJour = true;
          }
        }
        if (estAMettreAJour) {
          uniteTraitement.getSyntheseARsurUT().setSeuilRemunerationARAvecActConservee(new Quantite(ActiviteReduite.calculerSeuilMensuel(uniteTraitement.getDateDebut(), sjr, sjc, apprenti, true, gainPansConserveeALaLiquidation, presencePansConservee), uniteTraitement.getUniteParDefautQuantites()));
        }
      }
      else
      {
        uniteTraitement.getSyntheseARsurUT().setSeuilRemunerationAR(new Quantite(ActiviteReduite.calculerSeuilMensuel(uniteTraitement.getDateDebut(), sjr, sjc, apprenti, false, BigDecimal.ZERO, presencePansConservee), uniteTraitement.getUniteParDefautQuantites()));
      }
    }
    return traitementActiviteReduite;
  }
  
  protected static void postTraitementPeriodesDecalantes(UniteTraitement uniteTraitement, ResultatActiviteReduite resultatActiviteReduite, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if (resultatActiviteReduite.getSeuilRemuneration() != null) {
      uniteTraitement.getSyntheseARsurUT().setSeuilRemunerationAR(new Quantite(resultatActiviteReduite.getSeuilRemuneration(), uniteTraitement.getUniteParDefautQuantites()));
    }
    if (resultatActiviteReduite.getSeuilRemunerationAvecActConservee() != null) {
      uniteTraitement.getSyntheseARsurUT().setSeuilRemunerationARAvecActConservee(new Quantite(resultatActiviteReduite.getSeuilRemunerationAvecActConservee(), uniteTraitement.getUniteParDefautQuantites()));
    }
    uniteTraitement.getSyntheseARsurUT().setTotalGainUtilisePourDecalage(new Quantite(resultatActiviteReduite.getGainPrisEnCompte(), UniteMonaitaire.EUROS));
    
    uniteTraitement.getSyntheseARsurUT().setTotalHeureUtilisePourDecalage(new Quantite(resultatActiviteReduite.getNbHeuresPrisesEnCompte(), UniteDuree.HEURE));
    
    uniteTraitement.getSyntheseARsurUT().setTotalGainICCPConserves(new Quantite(resultatActiviteReduite.getCumulGainICCPConserves(), UniteMonaitaire.EUROS));
    
    uniteTraitement.getSyntheseARsurUT().setTotalGainICCPRepris(new Quantite(resultatActiviteReduite.getCumulGainICCPRepris(), UniteMonaitaire.EUROS));
    
    uniteTraitement.getSyntheseARsurUT().setRacAns(resultatActiviteReduite.getRacAns());
    uniteTraitement.getSyntheseARsurUT().setCumulJourDeTravailAR(new Quantite(resultatActiviteReduite.getCumulJourDeTravail(), UniteDuree.JOUR));
    uniteTraitement.getSyntheseARsurUT().setTotalGainActiviteReduiteJustifie(new Quantite(resultatActiviteReduite.getCumulGainJustifie(), UniteMonaitaire.EUROS));
    
    uniteTraitement.getSyntheseARsurUT().setTotalNbHeureActiviteReduiteJustifie(new Quantite(resultatActiviteReduite.getCumulNbHeuresJustifiees(), UniteDuree.HEURE));
    
    uniteTraitement.getSyntheseARsurUT().setTotalGainActiviteReprise(new Quantite(resultatActiviteReduite.getCumulGainReprise(), UniteMonaitaire.EUROS));
    
    uniteTraitement.getSyntheseARsurUT().setTotalNbHeureActiviteReprise(new Quantite(resultatActiviteReduite.getCumulNbHeuresReprise(), UniteDuree.HEURE));
    
    uniteTraitement.getSyntheseARsurUT().setEstForfaitPans(resultatActiviteReduite.getEstForfaitPans());
    uniteTraitement.getSyntheseARsurUT().setMontantPANS(resultatActiviteReduite.getMontantPANS());
    if (!resultatActiviteReduite.isNeutralise())
    {
      if (resultatActiviteReduite.getCreditDecalage() != null)
      {
        Quantite qteDecalage = new Quantite(resultatActiviteReduite.getCreditDecalage(), uniteTraitement.getUniteParDefautQuantites());
        uniteTraitement.setCreditDecalage(uniteTraitement.getCreditDecalage() == null ? qteDecalage : uniteTraitement.getCreditDecalage().ajouter(qteDecalage));
      }
    }
    else {
      uniteTraitement.setTypeNeutralisation(resultatActiviteReduite.getTypeNeutralisation());
    }
    BigDecimal decalageDuree = resultatActiviteReduite.getDecalageDuree();
    if (decalageDuree != null)
    {
      Quantite qteDecalageDuree = new Quantite(decalageDuree, uniteTraitement.getUniteParDefautQuantites());
      uniteTraitement.getSyntheseARsurUT().setDecalageDureeUT(qteDecalageDuree);
      Quantite qteDecalageDureeDureeCourant = uniteTraitement.getCreditDecalageDuree();
      if (qteDecalageDureeDureeCourant != null) {
        qteDecalageDuree = qteDecalageDuree.ajouter(qteDecalageDureeDureeCourant);
      }
      uniteTraitement.setCreditDecalageDuree(qteDecalageDuree);
    }
    uniteTraitement.getSyntheseARsurUT().setNomReglement(((Attribution)attribution).getNomReglementApplicable());
  }
  
  protected static boolean preTraitementPeriodesGelantes(AttributionSpec attribution, UniteTraitement uniteTraitement, ChronologiePeriodes periodesGelantes, ChronologiePeriodes periodesGelantesDeclareees, ChronologiePeriodes periodesGelantesJustifiees)
    throws CoucheLogiqueException
  {
    boolean traitementActiviteReduite = false;
    switch (uniteTraitement.getStatut())
    {
    case 1: 
    case 2: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    case 3: 
    case 7: 
    case 8: 
      periodesGelantes.iterer();
      while (periodesGelantes.encoreSuivant())
      {
        ObjetChronoPeriodeCalcul periodeTravailCalcul = (ObjetChronoPeriodeCalcul)periodesGelantes.elementSuivant();
        if (((periodeTravailCalcul instanceof PeriodeTravailJustifiee)) || ((periodeTravailCalcul instanceof PeriodePrime)))
        {
          Chronologie chronoPeriodesConserveesLiq = null;
          if ((((AttributionAssuranceSpec)attribution).getReglementApplicable().getReglement().getNomReglement().equalsIgnoreCase("A4")) && (estAvantConventionARE14(uniteTraitement.getDateDebut()))) {
            chronoPeriodesConserveesLiq = new ChronologiePeriodes();
          } else {
            chronoPeriodesConserveesLiq = ((Attribution)attribution).getListeActiviteConservee();
          }
          boolean periodeAIgnorer = DeterminationActiviteConserveeReprise.determinerTypeActivite(chronoPeriodesConserveesLiq, uniteTraitement, periodeTravailCalcul, attribution);
          if (!periodeAIgnorer) {
            periodesGelantesJustifiees.ajouter(periodeTravailCalcul);
          }
        }
      }
      if (periodesGelantesJustifiees.getTaille() != 0) {
        traitementActiviteReduite = true;
      }
      break;
    case 4: 
      uniteTraitement.setNeutralisee(true);
      uniteTraitement.setTypeNeutralisation(4);
      break;
    case 5: 
    case 9: 
      periodesGelantes.iterer();
      while (periodesGelantes.encoreSuivant())
      {
        ObjetChronoPeriodeCalcul periodeTravailCalcul = (ObjetChronoPeriodeCalcul)periodesGelantes.elementSuivant();
        if ((periodeTravailCalcul instanceof DsmTravail)) {
          periodesGelantesDeclareees.ajouter(periodeTravailCalcul);
        }
      }
      if (periodesGelantesDeclareees.getTaille() != 0) {
        traitementActiviteReduite = true;
      }
      break;
    case 6: 
      uniteTraitement.setNeutralisee(true);
      uniteTraitement.setTypeNeutralisation(8);
      break;
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    }
    return traitementActiviteReduite;
  }
  
  protected static void postTraitementPeriodesGelantes(UniteTraitement uniteTraitement, ResultatActiviteReduite resultatActiviteReduite)
  {
    uniteTraitement.setNeutralisee(resultatActiviteReduite.isNeutralise());
    uniteTraitement.setTypeNeutralisation(resultatActiviteReduite.getTypeNeutralisation());
    if (uniteTraitement.getTypeNeutralisation() == 3) {
      uniteTraitement.ajouterEvenement(new EvenementFinCumul(uniteTraitement.getDateDebut()));
    }
  }
  
  protected static void appliquerRegleSurUTPP(UniteTraitement uniteTraitement)
    throws CoucheLogiqueException
  {
    if (estAvantConventionARE14(uniteTraitement.getDateDebut()))
    {
      Quantite creditDecalageCalcule = uniteTraitement.getCreditDecalage() != null ? uniteTraitement.getCreditDecalage() : new Quantite(BigDecimal.ZERO, uniteTraitement.getUniteParDefautQuantites());
      if (!uniteTraitement.isNeutralisee())
      {
        Quantite creditDecalagePP = new Quantite(new BigDecimal(Math.floor(creditDecalageCalcule.getValeur().doubleValue() * 0.8D + 6.0D)), creditDecalageCalcule.getUnite());
        
        uniteTraitement.setCreditDecalage(creditDecalagePP);
      }
      else
      {
        uniteTraitement.setCreditDecalage(creditDecalageCalcule);
      }
    }
  }
  
  protected static boolean estAvantConventionARE14(Damj date)
    throws CoucheLogiqueException
  {
    FabriqueStrategieConvention2014 fab = new FabriqueStrategieConvention2014();
    CritereStrategie critereStrat = new CritereStrategie();
    critereStrat.setDatePivot(date);
    StrategieConventionARE14Spec strat = (StrategieConventionARE14Spec)fab.getStrategie(critereStrat);
    return strat.estAvantConventionARE14();
  }
}

/* Location:
 * Qualified Name:     TraitementActiviteReduite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */