package fr.unedic.cali.asu.cge01.liquidation.dom;

import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.DecorReglementaire;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.parcours.DomCali;
import fr.unedic.cali.parcours.DomCaliOptimise;
import fr.unedic.cali.parcours.DomTraitementOccasionnel;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteService;
import fr.unedic.util.temps.Damj;

public class DomSimulationSjrEtSjc
  extends DomCaliOptimise
  implements DomCali
{
  private IndividuSpec m_individu;
  private ContexteService m_contexteService;
  private ActiviteSalarie m_activiteSalarieRetenue;
  private ActiviteSalarie m_activiteSalarieFgd;
  private String m_periodeFct;
  private String m_periodeFgd;
  private DecorReglementaire m_decor;
  private ProduitAsuSpec m_produitAppelant;
  private int m_typeSimulation;
  private Damj m_dateExamen;
  private Damj m_dateFgd;
  private Damj m_dateFct;
  private Damj m_dateFgdOdPrecedente;
  private Damj m_dateTermePRC;
  private boolean m_estPrimoA3A4A5;
  private int m_typeCoordinationEuropeenne;
  private boolean m_estRevision;
  public static final int PAS_DE_COORDINATION_REGLEMENT_EUROPEENNE = 0;
  public static final int RESSORTISSANT_EUROPEEN = 1;
  public static final int NON_RESSORTISSANT_EUROPEEN = 2;
  
  public IndividuSpec getIndividu()
  {
    return m_individu;
  }
  
  public void setIndividu(IndividuSpec p_individu)
  {
    m_individu = p_individu;
  }
  
  public ContexteService getContexteService()
  {
    return m_contexteService;
  }
  
  public void setContexteService(ContexteService p_contexteService)
  {
    m_contexteService = p_contexteService;
  }
  
  public static ContexteService getContexteService(Contexte p_contexte)
  {
    return ((DomTraitementOccasionnel)p_contexte.getDonnees()).getContexteService();
  }
  
  public Damj getDateFgd()
  {
    return m_dateFgd;
  }
  
  public void setDateFgd(Damj p_date)
  {
    m_dateFgd = p_date;
  }
  
  public Damj getDateFct()
  {
    return m_dateFct;
  }
  
  public void setDateFct(Damj p_date)
  {
    m_dateFct = p_date;
  }
  
  public int getTypeCoordinationEuropeenne()
  {
    return m_typeCoordinationEuropeenne;
  }
  
  public void setTypeCoordinationEuropeenne(int p_typeCoordinationEuropeenne)
  {
    m_typeCoordinationEuropeenne = p_typeCoordinationEuropeenne;
  }
  
  public String getPeriodeFct()
  {
    return m_periodeFct;
  }
  
  public void setPeriodeFct(String p_string)
  {
    m_periodeFct = p_string;
  }
  
  public String getPeriodeFgd()
  {
    return m_periodeFgd;
  }
  
  public void setPeriodeFgd(String p_periodeFgd)
  {
    m_periodeFgd = p_periodeFgd;
  }
  
  public DecorReglementaire getDecor()
  {
    return m_decor;
  }
  
  public void setDecor(DecorReglementaire p_decor)
  {
    m_decor = p_decor;
  }
  
  public boolean isEstCoordCee()
  {
    boolean coordCee = false;
    switch (getTypeCoordinationEuropeenne())
    {
    case 1: 
    case 2: 
      coordCee = true;
      break;
    default: 
      coordCee = false;
    }
    return coordCee;
  }
  
  public ProduitAsuSpec getProduitAppelant()
  {
    return m_produitAppelant;
  }
  
  public void setProduitAppelant(ProduitAsuSpec p_produitAppelant)
  {
    m_produitAppelant = p_produitAppelant;
  }
  
  public int getTypeSimulation()
  {
    return m_typeSimulation;
  }
  
  public void setTypeSimulation(int p_typeSimulation)
  {
    m_typeSimulation = p_typeSimulation;
  }
  
  public Damj getDateExamen()
  {
    return m_dateExamen;
  }
  
  public void setDateExamen(Damj p_dateExamen)
  {
    m_dateExamen = p_dateExamen;
  }
  
  public Damj getDateFgdOdPrecedente()
  {
    return m_dateFgdOdPrecedente;
  }
  
  public void setDateFgdOdPrecedente(Damj p_dateFctOdPrecedente)
  {
    m_dateFgdOdPrecedente = p_dateFctOdPrecedente;
  }
  
  public Damj getDateTermePRC()
  {
    return m_dateTermePRC;
  }
  
  public void setDateTermePRC(Damj p_dateTermePRC)
  {
    m_dateTermePRC = p_dateTermePRC;
  }
  
  public boolean isEstPrimoA3A4A5()
  {
    return m_estPrimoA3A4A5;
  }
  
  public void setEstPrimoA3A4A5(boolean p_estPrimoA3A4A5)
  {
    m_estPrimoA3A4A5 = p_estPrimoA3A4A5;
  }
  
  public boolean isEstRevision()
  {
    return m_estRevision;
  }
  
  public void setEstRevision(boolean p_estRevision)
  {
    m_estRevision = p_estRevision;
  }
  
  public ActiviteSalarie getActiviteSalarieRetenue()
  {
    return m_activiteSalarieRetenue;
  }
  
  public void setActiviteSalarieRetenue(ActiviteSalarie p_activiteSalarieRetenue)
  {
    m_activiteSalarieRetenue = p_activiteSalarieRetenue;
  }
  
  public ActiviteSalarie getActiviteSalarieFgd()
  {
    return m_activiteSalarieFgd;
  }
  
  public void setActiviteSalarieFgd(ActiviteSalarie p_activiteSalarieFgd)
  {
    m_activiteSalarieFgd = p_activiteSalarieFgd;
  }
}

/* Location:
 * Qualified Name:     DomSimulationSjrEtSjc
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */