package fr.unedic.cali.asu.cge01.liquidation.dom;

import fr.unedic.cali.asu.cge01.liquidation.dom.gen.ObjectifExamenNovationGen;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisFinDeDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsReprise;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsRepriseCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectiveReprise;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectiveRepriseCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectiveReprisePmvs;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireRepriseAdhesionVolontaire;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireRepriseRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionPointDeDepartFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesReprise;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCondition28JoursSuspension;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionAccordCP;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionChomageInvolontaireReprise;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionCumulActiviteConserveeReprise;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursDetecterContributionParticuliereContexteEntreeCsp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.VerifierConditionSurFinDispositifReclassement;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursLiquidationDemandeSousJacenteCSPDroitCommun;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursObjectifNovation;
import fr.unedic.cali.asu.cge01.liquidation.parcours.cep02dureeRegl.asp.ConstitutionDureePostPrime;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursConstitutionReglementApplicable;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursConstitutionSjc;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursConstitutionSjr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.novation.ParcoursDeterminationConditionFaitGenerateur;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ObjectifExamenSpec;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateAttributionReprise;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBrutsReprise;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionAgeReprise;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionCumulPrestationFamiliale;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionDureeNonNulle;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionMontantProduitNonNul;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionRechercheEmploi;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionValiditeReliquat;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.parcours.ParcoursTraitementSatisfait;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import java.util.List;

public class ObjectifExamenNovation
  extends ObjectifExamenNovationGen
  implements ObjectifExamenSpec
{
  private static final long serialVersionUID = 1481665509020534572L;
  private List<ContexteDemandeSpec> contexteDemande;
  
  public ObjectifExamenNovation(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjectifExamenNovation() {}
  
  public ObjectifExamenNovation(List<ContexteDemandeSpec> contexteDemande)
  {
    this.contexteDemande = contexteDemande;
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenNovation copie = new ObjectifExamenNovation();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursCapitalAvecDureeEffective()
  {
    return null;
  }
  
  public Parcours creerParcoursCapitalDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return new ParcoursConstitutionCaractereSaisonnier();
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return new ParcoursConstitutionCoefficientSaisonnier();
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ParcoursConstitutionCoefficientTempsPartiel();
  }
  
  public Parcours creerParcoursCondition28JSuspension()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(contexteDemande)) {
      return new DeterminationCondition28JoursSuspension();
    }
    return new ParcoursTraitementSatisfait();
  }
  
  public Parcours creerParcoursConditionAge()
  {
    return new DeterminationConditionAgeReprise();
  }
  
  public Parcours creerParcoursConditionAnciennete()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "ARESJASPDC")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(contexteDemande, 9))) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionChomageInvolontaireReprise();
  }
  
  public Parcours creerParcoursConditionChomageTotal()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCsrAccordCp()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(contexteDemande)) {
      return new DeterminationConditionAccordCP();
    }
    return new ParcoursTraitementSatisfait();
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    if ((contexteDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null))) {
      return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionCumulActiviteConserveeReprise());
    }
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "ARESJASPDC")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(contexteDemande, 7))) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionCumulActiviteConserveeReprise();
  }
  
  public Parcours creerParcoursConditionCumulAvantageVieillesse()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    if ((contexteDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null))) {
      return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionCumulPrestationFamiliale());
    }
    if (OutilGestionContexteDemande.estContextePresentDansRegroupement(contexteDemande, 7)) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionCumulPrestationFamiliale();
  }
  
  public Parcours creerParcoursConditionDureeNonNulle()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null) {
      return new DeterminationConditionDureeNonNulle();
    }
    return null;
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    return new ParcoursDeterminationConditionFaitGenerateur();
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    if ((contexteDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null))) {
      return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionMontantProduitNonNul());
    }
    return new DeterminationConditionMontantProduitNonNul();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    if (contexteDemande != null)
    {
      if ((OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "ARESJASPDC"))) {
        return new ParcoursTraitementSatisfait();
      }
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "ARECOURCSP"))) {
        return getObjectifProduitActif().creerParcoursConditionRechercheEmploi();
      }
    }
    return new DeterminationConditionRechercheEmploi();
  }
  
  public Parcours creerParcoursConditionValiditeReliquat()
  {
    return new DeterminationConditionValiditeReliquat();
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    if (contexteDemande != null)
    {
      if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(contexteDemande)) {
        return new ConstitutionDateAttributionCsr();
      }
      if (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null) {
        return new ConstitutionDateAttributionFinDroit();
      }
    }
    return new ConstitutionDateAttributionReprise();
  }
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return new ConstitutionDateLimiteIndemnisation();
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    if (contexteDemande != null)
    {
      if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(contexteDemande)) {
        return new ConstitutionDelaisReportsRepriseCsr();
      }
      boolean estPapParlementaireOuPasPap = (!OutilGestionContexteDemande.estContextePresentDansRegroupement(contexteDemande, 10)) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "PAPPARLEM"));
      
      boolean estEntreeCspOuPapParlementaire = (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "AREENTRCSP")) && (estPapParlementaireOuPasPap);
      if (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null) {
        return new ConstitutionDelaisFinDeDroit();
      }
      if ((estEntreeCspOuPapParlementaire) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "ASPDC"))) {
        return null;
      }
    }
    return new ConstitutionDelaisReportsReprise();
  }
  
  public Parcours creerParcoursDetectionContributionParticuliere(Demande demande)
  {
    return new ParcoursDetecterContributionParticuliereContexteEntreeCsp();
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return new DeterminationCompetencesReprise();
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    Parcours parcours = null;
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(contexteDemande))
    {
      parcours = new ConstitutionDureeEffectiveRepriseCsr();
    }
    else
    {
      if (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 2) != null) {
        return new ConstitutionDureeEffectiveReprisePmvs();
      }
      parcours = new ConstitutionDureeEffectiveReprise();
    }
    return parcours;
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    if ((contexteDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "FINASPVOL")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "ACTIMPREL")))) {
      return new ConstitutionDureeReglementaireRepriseAdhesionVolontaire();
    }
    return new ConstitutionDureeReglementaireRepriseRevision();
  }
  
  public Parcours creerParcoursLiquidationDemandeAssociee()
  {
    Parcours parcours = null;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(contexteDemande, "AREENTRCSP")) && (OutilGestionContexteDemande.estContextePresentDansRegroupement(contexteDemande, 9))) {
      parcours = new ParcoursLiquidationDemandeSousJacenteCSPDroitCommun();
    }
    return parcours;
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBrutsReprise();
  }
  
  public Parcours creerParcoursMontantsEffectifs()
  {
    return null;
  }
  
  public Parcours creerParcoursNouvelleRevisionAutomatique()
  {
    return null;
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(contexteDemande, 5) != null) {
      return new ConstitutionPointDeDepartFinDroit();
    }
    return new ConstitutionPointDepartIndemnisation();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursReglementApplicable()
  {
    return new ParcoursConstitutionReglementApplicable();
  }
  
  public Parcours creerParcoursRevisionAutomatique()
  {
    return null;
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return new ParcoursConstitutionSjc();
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return new ParcoursConstitutionSjr();
  }
  
  public int getType()
  {
    return 5;
  }
  
  public Parcours creerParcoursObjectif()
  {
    return new ParcoursObjectifNovation();
  }
  
  public ObjectifExamen getObjectifSauvegarde()
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public void marquerGraphePersistant() {}
  
  public Parcours creerParcoursConstitutionDureePostPrime()
  {
    return new ConstitutionDureePostPrime();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenNovation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */