package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FabriqueOutilFonctionnelDeterminationSjrSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.OutilDonneesDeterminationSjrSpec;
import fr.unedic.cali.asu.cge01.parametres.Parametres;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.parametres.AccesPlafond;
import fr.unedic.cali.asu.parametres.AccesPlafondMayotte;
import fr.unedic.cali.asu.parametres.AccesSalaireForfaitaireJournalierCategorieA2B;
import fr.unedic.cali.asu.parametres.EvenementCategorieA2B;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationPrc;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationSr;
import fr.unedic.cali.asu.produits.liquidation.dom.Prc;
import fr.unedic.cali.asu.produits.liquidation.dom.conteneurs.DonneesResultatDeterminationSjr;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.PriseEnComptePrimoDemandeur;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.conteneurs.DonneeEntreeParametre;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeComplementairesDeterminationSjr;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeComportement;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeDemandeDeterminationSjr;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeDeterminationSjr;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeProduitDeterminationSjr;
import fr.unedic.cali.dom.conteneurs.DonneesResultatDeterminationSjc;
import fr.unedic.cali.dom.conteneurs.DonneesResultatSimplifieDeterminationSjr;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeComplementairesDeterminationSjrSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeComportementSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeDemandeDeterminationSjrSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeDeterminationSjrSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeProduitDeterminationSjrSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesResultatDeterminationSjcSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesResultatSimplifieDeterminationSjrSpec;
import fr.unedic.cali.parametres.AccesSmicMensuelBase35h;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Iterator;

public class OutilDonneesDeterminationSjr
  implements OutilDonneesDeterminationSjrSpec
{
  private static OutilDonneesDeterminationSjr instance = new OutilDonneesDeterminationSjr();
  
  public static OutilDonneesDeterminationSjr getInstance()
  {
    return instance;
  }
  
  public DonneesEntreeDeterminationSjrSpec initialiserDonneesEntreeAvecProduit()
  {
    DonneesEntreeDeterminationSjrSpec donneesEntreeDeterminationSjr = new DonneesEntreeDeterminationSjr();
    alimenterDonneesEntreeProduit(donneesEntreeDeterminationSjr);
    return donneesEntreeDeterminationSjr;
  }
  
  public DonneesEntreeDeterminationSjrSpec initialiserDonneesEntreeAvecDemande(Demande demande)
  {
    DonneesEntreeDeterminationSjrSpec donneesEntreeDeterminationSjr = new DonneesEntreeDeterminationSjr();
    alimenterDonneesEntreeDemande(donneesEntreeDeterminationSjr, demande);
    return donneesEntreeDeterminationSjr;
  }
  
  public DonneesEntreeDeterminationSjrSpec initialiserDonneesEntreeAvecDemandeEtProduit(Demande demande)
  {
    DonneesEntreeDeterminationSjrSpec donneesEntreeDeterminationSjr = new DonneesEntreeDeterminationSjr();
    alimenterDonneesEntreeProduit(donneesEntreeDeterminationSjr);
    alimenterDonneesEntreeDemande(donneesEntreeDeterminationSjr, demande);
    return donneesEntreeDeterminationSjr;
  }
  
  public DonneesEntreeDeterminationSjrSpec initialiserDonneesEntree(Demande demande, int typeTraitementAppelant, FabriqueOutilFonctionnelDeterminationSjrSpec fabriqueOutilFonctionnel, boolean justifierSjr)
  {
    DonneesEntreeDeterminationSjrSpec donneesEntreeDeterminationSjr = new DonneesEntreeDeterminationSjr();
    alimenterDonneesEntreeComportement(donneesEntreeDeterminationSjr, typeTraitementAppelant, fabriqueOutilFonctionnel, justifierSjr);
    alimenterDonneesEntreeProduit(donneesEntreeDeterminationSjr);
    alimenterDonneesEntreeDemande(donneesEntreeDeterminationSjr, demande);
    return donneesEntreeDeterminationSjr;
  }
  
  private void alimenterDonneesEntreeComportement(DonneesEntreeDeterminationSjrSpec donneesEntree, int typeTraitementAppelant, FabriqueOutilFonctionnelDeterminationSjrSpec fabriqueOutilFonctionnel, boolean justifierSjr)
  {
    DonneesEntreeComportementSpec donneesEntreeComportement = new DonneesEntreeComportement();
    donneesEntreeComportement.setTypeTraitementAppelant(typeTraitementAppelant);
    donneesEntreeComportement.setFabriqueOutilFonctionnel(fabriqueOutilFonctionnel);
    donneesEntreeComportement.setJustifierSjr(justifierSjr);
    
    donneesEntree.setDonneesEntreeComportement(donneesEntreeComportement);
  }
  
  private void alimenterDonneesEntreeDemande(DonneesEntreeDeterminationSjrSpec donneesEntree, Demande demande)
  {
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    DonneesEntreeDemandeDeterminationSjrSpec donneesEntreeDemande = new DonneesEntreeDemandeDeterminationSjr();
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demande.getListContexteDemande(), "AREMAYOTTE")) {
      donneesEntreeDemande.setContexteDemande("AREMAYOTTE");
    }
    donneesEntreeDemande.setDateAttribution(dossierExamenCourant.getDateAttribution());
    donneesEntreeDemande.setDateExamen(demande.getDateExamen());
    donneesEntreeDemande.setDateFaitGenerateurDroitCourant(dossierExamenCourant.getFaitGenerateur().getDateFaitGenerateur());
    
    Damj dateFaitGenerateurOdPrecedente = null;
    if ("ASU_07".equals(demande.getEvenementReferenceExamen().getTypeExamen()))
    {
      if (demande.getDateForceeFaitGenerateurOdPrecedente() != null)
      {
        dateFaitGenerateurOdPrecedente = demande.getDateForceeFaitGenerateurOdPrecedente();
      }
      else
      {
        OdSpec odPrecedente = demande.rechercherOuvertureDroitPrecedenteDuMemeType();
        Demande demandeOuvertureDroit = (Demande)odPrecedente.getDemande();
        dateFaitGenerateurOdPrecedente = demandeOuvertureDroit.getDateFaitGenerateurOdPrecedente();
      }
    }
    else {
      dateFaitGenerateurOdPrecedente = demande.getDateFaitGenerateurOdPrecedente();
    }
    donneesEntreeDemande.setDateFaitGenerateurDroitPrecedent(dateFaitGenerateurOdPrecedente);
    
    donneesEntreeDemande.setDonneeForceeSjr(demande.getDonneesTemporaires().getSjr());
    donneesEntreeDemande.setDonneeForceeSjrPerteActConservee(demande.getDonneesTemporaires().getSjrPerteActConservee());
    donneesEntreeDemande.setDonneeForceeSjc(demande.getDonneesTemporaires().getSjc());
    donneesEntreeDemande.setDonneeForceeSjcPerteActConservee(demande.getDonneesTemporaires().getSjcPerteActConservee());
    donneesEntreeDemande.setIndividu(demande.getDemandeur());
    Reglement reglementApplicable = dossierExamenCourant.getReglementApplicable().getReglement();
    donneesEntreeDemande.setReglementApplicable(reglementApplicable);
    if (demande.getSaisieAntecedent() != null) {
      donneesEntreeDemande.setCategorieA2bForcee(demande.getSaisieAntecedent().getCodeEmploiA2B());
    }
    if ((donneesEntree.getDonneesEntreeComportement() != null) && (1 == donneesEntree.getDonneesEntreeComportement().getTypeTraitementAppelant())) {
      donneesEntreeDemande.setListePlafonnementAffiliation(dossierExamenCourant.getListePlafonnementAffiliation());
    }
    boolean estPrimoDemandeurA3A4A5 = PriseEnComptePrimoDemandeur.estPrimoDemandeurA3A4A5((Attribution)demande.getAttribution(), reglementApplicable);
    
    donneesEntreeDemande.setPrimoDemandeurA3A4A5(estPrimoDemandeurA3A4A5);
    
    donneesEntreeDemande.setProduit(dossierExamenCourant.getDossierAffecte().getProduit());
    if (dossierExamenCourant.getConstitutionQuantiteAffiliation() != null) {
      donneesEntreeDemande.setQuantiteAppartenanceJoursPrincipale(dossierExamenCourant.getConstitutionQuantiteAffiliation().getQuantiteAcquise());
    }
    donneesEntreeDemande.setEstDemandeDeRechargement("ASU_29".equals(demande.getEvenementReferenceExamen().getTypeExamen()));
    donneesEntreeDemande.setDiviseurCasGeneralForcee(demande.getDonneesTemporaires().getDiviseurSjrForce());
    
    donneesEntree.setDonneesEntreeDemande(donneesEntreeDemande);
  }
  
  private void alimenterDonneesEntreeProduit(DonneesEntreeDeterminationSjrSpec donneesEntree)
  {
    DonneesEntreeProduitDeterminationSjrSpec donneesEntreeProduit = new DonneesEntreeProduitDeterminationSjr();
    
    chargerParametresPlafondSecuMensuel(donneesEntreeProduit);
    
    chargerParametresSmicMensuelBase35h(donneesEntreeProduit);
    
    chargerParametresSfjA2b(donneesEntreeProduit);
    
    donneesEntreeProduit.setParametrePlafondDiviseurPrc(Parametres.PLAFOND_DIVISEUR_PRC);
    
    donneesEntree.setDonneesEntreeProduit(donneesEntreeProduit);
  }
  
  public void chargerParametresPlafondSecuMensuel(DonneesEntreeProduitDeterminationSjrSpec donneesEntreeProduit)
  {
    Chronologie chronoParametresPlafondSecuMensuel = determinerChronoParametresPlafondSecuMensuel();
    Chronologie chronoParametresPlafondSecuMensuelMayotte = determinerChronoParametresPlafondSecuMensuelMayotte();
    
    alimenterParametrePlafondSecuMensuel(donneesEntreeProduit, "PLAFOND MENSUEL SR SJR", chronoParametresPlafondSecuMensuel);
    
    alimenterParametrePlafondSecuMensuel(donneesEntreeProduit, "PLAFOND MENSUEL SR SJR MAYOTTE", chronoParametresPlafondSecuMensuelMayotte);
  }
  
  private void alimenterParametrePlafondSecuMensuel(DonneesEntreeProduitDeterminationSjrSpec donneesEntreeProduit, String identifiantParam, Chronologie chronoParametrePlafondSecuMensuel)
  {
    boolean recupererPlafondMayotte = false;
    if ("PLAFOND MENSUEL SR SJR MAYOTTE".equals(identifiantParam)) {
      recupererPlafondMayotte = true;
    }
    fr.unedic.cali.asu.parametres.EvenementParametre parametrePlafondSecuMensuelCourant = null;
    Iterator it = chronoParametrePlafondSecuMensuel.iterer();
    while (it.hasNext())
    {
      parametrePlafondSecuMensuelCourant = (fr.unedic.cali.asu.parametres.EvenementParametre)it.next();
      BigDecimal plafond = recupererPlafondMayotte ? parametrePlafondSecuMensuelCourant.getPlafondMayotte() : parametrePlafondSecuMensuelCourant.getPlafond();
      
      donneesEntreeProduit.ajouterParametre(identifiantParam, new DonneeEntreeParametre(parametrePlafondSecuMensuelCourant.getDateEffet(), plafond));
    }
  }
  
  private void chargerParametresSmicMensuelBase35h(DonneesEntreeProduitDeterminationSjrSpec donneesEntreeProduit)
  {
    Chronologie chronoParametresSmicMensuelBase35h = determinerChronoParametresSmicMensuelBase35h();
    fr.unedic.cali.parametres.EvenementParametre parametreSmicMensuelBase35hCourant = null;
    Iterator it = chronoParametresSmicMensuelBase35h.iterer();
    while (it.hasNext())
    {
      parametreSmicMensuelBase35hCourant = (fr.unedic.cali.parametres.EvenementParametre)it.next();
      donneesEntreeProduit.ajouterParametre("SMIC MENSUEL BASE 35H", new DonneeEntreeParametre(parametreSmicMensuelBase35hCourant.getDateEffet(), parametreSmicMensuelBase35hCourant.getSmicMensuelBase35h()));
    }
  }
  
  private void chargerParametresSfjA2b(DonneesEntreeProduitDeterminationSjrSpec donneesEntreeProduit)
  {
    Chronologie chronoParametresSfjA2b = determinerChronoParametresSfjA2b();
    EvenementCategorieA2B parametreSfjA2bCourant = null;
    int indexCategorieCourant = 0;
    ArrayList listeSfjParCategorieCourante = null;
    String nomParametreCourant = null;
    Iterator it = chronoParametresSfjA2b.iterer();
    while (it.hasNext())
    {
      parametreSfjA2bCourant = (EvenementCategorieA2B)it.next();
      listeSfjParCategorieCourante = parametreSfjA2bCourant.getValeurs();
      for (indexCategorieCourant = 0; indexCategorieCourant < listeSfjParCategorieCourante.size(); indexCategorieCourant++)
      {
        nomParametreCourant = "SFJ A2B CATEGORIE " + (indexCategorieCourant + 1);
        donneesEntreeProduit.ajouterParametre(nomParametreCourant, new DonneeEntreeParametre(parametreSfjA2bCourant.getDateEffet(), (BigDecimal)listeSfjParCategorieCourante.get(indexCategorieCourant)));
      }
    }
  }
  
  public Chronologie determinerChronoParametresPlafondSecuMensuel()
  {
    return new AccesPlafond().getChronoValeursParametre();
  }
  
  public Chronologie determinerChronoParametresPlafondSecuMensuelMayotte()
  {
    return new AccesPlafondMayotte().getChronoValeursParametre();
  }
  
  public Chronologie determinerChronoParametresSfjA2b()
  {
    return AccesSalaireForfaitaireJournalierCategorieA2B.getInstance().getChronoValeursParametre();
  }
  
  public Chronologie determinerChronoParametresSmicMensuelBase35h()
  {
    return new AccesSmicMensuelBase35h().getChronoValeursParametre();
  }
  
  public void alimenterDonneesEntreeComplementaires(DonneesEntreeDeterminationSjrSpec donneesEntree, JustificationPrc justificationPrc, Chronologie chronoActiviteSalariePrc, Chronologie chronoActivitePourInappartenancePrc, Chronologie chronoPeriodeDeductiblePrc)
  {
    DonneesEntreeComplementairesDeterminationSjrSpec donneesEntreeComplementaires = new DonneesEntreeComplementairesDeterminationSjr();
    donneesEntreeComplementaires.setPeriodePrcInitiale(justificationPrc.getPeriodePrcInitiale());
    donneesEntreeComplementaires.setPeriodePrcBornee(justificationPrc.getPeriodePrcBornee());
    donneesEntreeComplementaires.setTypeBornagePrc(justificationPrc.getTypeBornagePrc());
    donneesEntreeComplementaires.setChronologieActiviteSalariePrc(chronoActiviteSalariePrc);
    donneesEntreeComplementaires.setChronologieActivitePourInappartenancePrc(chronoActivitePourInappartenancePrc);
    donneesEntreeComplementaires.setChronologiePeriodeDeductiblePrc(chronoPeriodeDeductiblePrc);
    
    donneesEntree.setDonneesEntreeComplementaires(donneesEntreeComplementaires);
  }
  
  public DonneesResultatDeterminationSjr initialiserDonneesResultatSjr(BigDecimal sjri, BigDecimal plafondSjr)
  {
    DonneesResultatDeterminationSjr donneesResultatDeterminationSjr = new DonneesResultatDeterminationSjr();
    donneesResultatDeterminationSjr.setSjri(sjri);
    donneesResultatDeterminationSjr.setPlafondSjr(plafondSjr);
    return donneesResultatDeterminationSjr;
  }
  
  public DonneesResultatDeterminationSjr initialiserDonneesResultatSjrAvecJustification(Prc prc)
  {
    DonneesResultatDeterminationSjr donneesResultatDeterminationSjr = new DonneesResultatDeterminationSjr();
    donneesResultatDeterminationSjr.setPrc(prc);
    donneesResultatDeterminationSjr.setJustificationSjr(JustificationSjr.createNonPersistent());
    
    donneesResultatDeterminationSjr.getJustificationSjr().getJustificationSr().setTotalSalairesRetenus(BigDecimal.ZERO);
    donneesResultatDeterminationSjr.getJustificationSjr().getJustificationSr().setTotalPrimesNormalesRetenues(BigDecimal.ZERO);
    donneesResultatDeterminationSjr.getJustificationSjr().getJustificationSr().setTotalPrimesExceptionnellesRetenues(BigDecimal.ZERO);
    donneesResultatDeterminationSjr.getJustificationSjr().getJustificationSr().setSalaireReferenceNonPlafonne(BigDecimal.ZERO);
    return donneesResultatDeterminationSjr;
  }
  
  public void completerDonneesResultatSjr(DonneesResultatDeterminationSjr donneesResultat, BigDecimal sjri, BigDecimal plafondSjr)
  {
    donneesResultat.setSjri(sjri);
    donneesResultat.setPlafondSjr(plafondSjr);
  }
  
  public DonneesEntreeDeterminationSjrSpec initialiserDonneesEntreeDeterminationSjrActiviteConservee(DonneesEntreeDeterminationSjrSpec donneesEntree, ActiviteSalarie activiteSalarieeConservee)
  {
    DonneesEntreeDeterminationSjrSpec donneesEntreeDeterminationSjrActiviteConservee = new DonneesEntreeDeterminationSjr();
    
    donneesEntreeDeterminationSjrActiviteConservee.setDonneesEntreeComportement(donneesEntree.getDonneesEntreeComportement());
    donneesEntreeDeterminationSjrActiviteConservee.setDonneesEntreeProduit(donneesEntree.getDonneesEntreeProduit());
    donneesEntreeDeterminationSjrActiviteConservee.setDonneesEntreeDemande(donneesEntree.getDonneesEntreeDemande().copier());
    donneesEntreeDeterminationSjrActiviteConservee.setDonneesEntreeComplementaires(donneesEntree.getDonneesEntreeComplementaires().copier());
    
    Reglement reglementApplicableCourant = activiteSalarieeConservee.getReglement();
    donneesEntreeDeterminationSjrActiviteConservee.getDonneesEntreeDemande().setReglementApplicable(reglementApplicableCourant);
    
    Chronologie chronoPeriodeActiviteConservee = new ChronologiePeriodes();
    chronoPeriodeActiviteConservee.ajouter(activiteSalarieeConservee);
    donneesEntreeDeterminationSjrActiviteConservee.getDonneesEntreeComplementaires().setChronologieActiviteSalariePrc(chronoPeriodeActiviteConservee);
    
    donneesEntreeDeterminationSjrActiviteConservee.getDonneesEntreeComplementaires().setChronologieActivitePourInappartenancePrc(chronoPeriodeActiviteConservee);
    
    donneesEntreeDeterminationSjrActiviteConservee.getDonneesEntreeComplementaires().setChronologiePeriodeDeductiblePrc(chronoPeriodeActiviteConservee);
    
    return donneesEntreeDeterminationSjrActiviteConservee;
  }
  
  public DonneesResultatDeterminationSjcSpec initialiserDonneesResultatSjc()
  {
    return new DonneesResultatDeterminationSjc();
  }
  
  public void completerDonneesResultatSjc(DonneesResultatDeterminationSjcSpec donneesResultat, BigDecimal sjci, ArrayList listeSjrActiviteConservee)
  {
    donneesResultat.setSjci(sjci);
    donneesResultat.setListeSjrActiviteConservee(listeSjrActiviteConservee);
  }
  
  public DonneesResultatSimplifieDeterminationSjrSpec mapperDonneesResultatSimplifieSjr(DonneesResultatDeterminationSjr donneesResultat)
  {
    DonneesResultatSimplifieDeterminationSjrSpec donneesResultatSimplifieDeterminationSjr = new DonneesResultatSimplifieDeterminationSjr();
    
    donneesResultatSimplifieDeterminationSjr.setSjri(donneesResultat.getSjri());
    
    donneesResultatSimplifieDeterminationSjr.setPlafondSjr(donneesResultat.getPlafondSjr());
    
    donneesResultatSimplifieDeterminationSjr.setListeAlertesNonBloquantes(donneesResultat.getListeAlertesNonBloquantes());
    if (donneesResultat.getPrc() != null)
    {
      donneesResultatSimplifieDeterminationSjr.setChronoActiviteSalarieParticipantSr(donneesResultat.getPrc().getChronoActiviteSalarieParticipantSr());
      
      donneesResultatSimplifieDeterminationSjr.setDiviseur(donneesResultat.getPrc().getDiviseur());
      donneesResultatSimplifieDeterminationSjr.setDroitCongesA4ouA5(donneesResultat.getPrc().getDroitCongesA4ouA5());
      donneesResultatSimplifieDeterminationSjr.setDureePrc(donneesResultat.getPrc().getDureePrc());
      donneesResultatSimplifieDeterminationSjr.setNombreHeuresA4ouA5(donneesResultat.getPrc().getNombreHeuresA4ouA5());
      donneesResultatSimplifieDeterminationSjr.setNombreHeuresTotal(donneesResultat.getPrc().getNombreHeuresTotal());
      donneesResultatSimplifieDeterminationSjr.setNombreJourAbsence(donneesResultat.getPrc().getNombreJourAbsence());
      donneesResultatSimplifieDeterminationSjr.setNombreJourDeductible(donneesResultat.getPrc().getNombreJourDeductible());
      donneesResultatSimplifieDeterminationSjr.setNombreJourInappartenance(donneesResultat.getPrc().getNombreJourInappartenance());
      donneesResultatSimplifieDeterminationSjr.setNombreJourTravailEffectif(donneesResultat.getPrc().getNombreJourTravailEffectif());
      donneesResultatSimplifieDeterminationSjr.setPrip(donneesResultat.getPrc().getPrip());
      donneesResultatSimplifieDeterminationSjr.setSrip(donneesResultat.getPrc().getSrip());
      donneesResultatSimplifieDeterminationSjr.setEstSripReduit(donneesResultat.getPrc().isEstSripReduit());
    }
    if (donneesResultat.getJustificationSjr() != null) {
      donneesResultatSimplifieDeterminationSjr.setSri(donneesResultat.getJustificationSjr().getJustificationSr().getSalaireReferenceNonPlafonne());
    }
    return donneesResultatSimplifieDeterminationSjr;
  }
}

/* Location:
 * Qualified Name:     OutilDonneesDeterminationSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */