package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.capachomageinvolontaire;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatRechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheReglementApplicable;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.spec.ConstructionPRASpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieeMotifDvNonLegitime;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreDebutAvantOuCoincideAvecDate;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreFinAvantDate;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.FiltreFinApresOuCoincideAvecDate;
import fr.unedic.util.temps.FiltresTemporel;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.Iterator;
import java.util.Map;

public class OutilConditionChomageInvolontaire
{
  public Chronologie determinerPeriodesActivitesChevauchantDv(Demande demande, TravailSpec dernierDv)
  {
    FiltresTemporel filtreChevauchePeriodeEtActiviteSalarie = new FiltresTemporel();
    filtreChevauchePeriodeEtActiviteSalarie.ajouterFiltre(new FiltreFinAvantDate(demande.getDateExamen()));
    
    filtreChevauchePeriodeEtActiviteSalarie.ajouterFiltre(new FiltreFinApresOuCoincideAvecDate(dernierDv.getDateFin()));
    filtreChevauchePeriodeEtActiviteSalarie.ajouterFiltre(new FiltreDebutAvantOuCoincideAvecDate(dernierDv.getDateFin()));
    filtreChevauchePeriodeEtActiviteSalarie.ajouterFiltre(new FiltreNegation(new FiltreActiviteSalarieeMotifDvNonLegitime()));
    
    Periode periodeChevauchementDV = new Periode(dernierDv.getDateFin(), dernierDv.getDateFin());
    Chronologie chronoParticipantes = determinerChronoParticipantesCalculAffiliation(demande, periodeChevauchementDV).copier(filtreChevauchePeriodeEtActiviteSalarie);
    
    return chronoParticipantes;
  }
  
  public Chronologie determinerChronoParticipantesCalculAffiliation(Demande demande, Periode delaiRechercheDv)
  {
    return RechercheReglementApplicable.getInstance().determinerActivitesParticipantes(demande, delaiRechercheDv, false);
  }
  
  public ResultatRechercheConditionChomageInvolontaire etudierJurisprudence(Demande demande, Reglement reglement, TravailSpec dernierDv, ResultatRechercheConditionChomageInvolontaire resultatRechercheConditionChomageInvolontaire)
    throws ApplicativeException
  {
    ResultatRechercheConditionChomageInvolontaire resultatConditionAffiliation = new ResultatRechercheConditionChomageInvolontaire();
    Chronologie periodesActivitesChevauchantDv = determinerPeriodesActivitesChevauchantDv(demande, dernierDv);
    if (!periodesActivitesChevauchantDv.estVide())
    {
      ProduitAsuSpec produit = (ProduitAsuSpec)demande.getDossierAffectation().getProduit();
      Pra pra = (Pra)produit.getOutilConstructionPRA().determinerPraCouvertureSuiteDV(reglement.getNomReglement());
      Iterator<ActiviteSalarie> iter = periodesActivitesChevauchantDv.iterer();
      while ((iter.hasNext()) && (!resultatConditionAffiliation.isConditionAffiliationVerifiee()))
      {
        ObjetChronoPeriode activiteCourante = (ObjetChronoPeriode)iter.next();
        if ((activiteCourante instanceof ActiviteSalarie))
        {
          ActiviteSalarie activiteSalariee = (ActiviteSalarie)activiteCourante;
          Chronologie chronologieParticipanteCalculAffi = new ChronologiePeriodes();
          chronologieParticipanteCalculAffi.ajouter(activiteSalariee);
          
          pra.setDebut(activiteSalariee.getDateDebut());
          pra.setFin(activiteSalariee.getDateFin());
          
          resultatConditionAffiliation = RechercheConditionChomageInvolontaire.verifierConditionAffiliation(demande, pra, chronologieParticipanteCalculAffi, false, true, true, false);
          
          resultatRechercheConditionChomageInvolontaire.getAffiliationPrincipaleConcomitante().put(activiteSalariee, resultatConditionAffiliation.getQuantiteAffiliationPrincipaleCalculee());
          
          resultatRechercheConditionChomageInvolontaire.getAffiliationSecondaireConcomitante().put(activiteSalariee, resultatConditionAffiliation.getQuantiteAffiliationSecondaireCalculee());
        }
      }
    }
    return resultatConditionAffiliation;
  }
}

/* Location:
 * Qualified Name:     OutilConditionChomageInvolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */