package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieIslrARE14;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieIslrApresARE17;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieIslrAvantARE14;
import fr.unedic.cali.asu.fabriques.FabriqueConventionTransitoire2014;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P02;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P04;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P05;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P06;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P6B;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P01;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P02;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P03;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P04;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P05;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P5B;
import fr.unedic.cali.dom.affectation.ProduitAsuExp03P01;
import fr.unedic.cali.dom.affectation.ProduitAsuMay17P02;
import fr.unedic.cali.dom.affectation.ProduitAsuMay17P03;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.util.ArrayList;
import java.util.List;

public class FabriqueStrategieISLR
  extends FabriqueConventionTransitoire2014
{
  private static FabriqueStrategieISLR instance = new FabriqueStrategieISLR();
  private static List<Integer> listeCodeProduitAvantARE17;
  
  protected FabriqueStrategieISLR()
  {
    initialiserListeCodeProduitAvantARE17();
  }
  
  public static FabriqueStrategieISLR getInstance()
  {
    return instance;
  }
  
  private static void initialiserListeCodeProduitAvantARE17()
  {
    listeCodeProduitAvantARE17 = new ArrayList();
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCge01P02.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCge01P03.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCge01P04.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCge01P05.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCge01P6B.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCge01P06.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuExp03P01.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCsa06P01.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCsa06P02.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCsa06P03.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCsa06P04.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCsa06P5B.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuCsa06P05.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuMay17P02.getInstance().getCode()));
    listeCodeProduitAvantARE17.add(Integer.valueOf(ProduitAsuMay17P03.getInstance().getCode()));
  }
  
  public StrategieSpec getStrategie(CritereStrategie critereStrategie)
    throws CoucheLogiqueException
  {
    Damj datePivot = critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieISLR : la date pivot est null.");
    }
    StrategieSpec retour;
    StrategieSpec retour;
    if (datePivot.estAvant(DATE_APPLICATION))
    {
      retour = getStrategieAvantARE2014();
    }
    else
    {
      ProduitSpec produitCourant = critereStrategie.getProduit();
      StrategieSpec retour;
      if ((produitCourant != null) && (!listeCodeProduitAvantARE17.contains(Integer.valueOf(produitCourant.getCode())))) {
        retour = getStrategieApresARE2017();
      } else {
        retour = getStrategieARE2014();
      }
    }
    return retour;
  }
  
  protected StrategieSpec getStrategieAvantARE2014()
  {
    return new StrategieIslrAvantARE14();
  }
  
  protected StrategieSpec getStrategieARE2014()
  {
    return new StrategieIslrARE14();
  }
  
  protected StrategieSpec getStrategieApresARE2017()
  {
    return new StrategieIslrApresARE17();
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieISLR
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */