package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ConstitutionQuantiteAffiliationGen;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationAffiliation;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.dom.ConstitutionDroitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Periode;

public class ConstitutionQuantiteAffiliation
  extends ConstitutionQuantiteAffiliationGen
  implements ConstitutionDroitSpec
{
  private static final long serialVersionUID = 451339875781566438L;
  public static final String ARTICLE3_A = "a";
  public static final String ARTICLE3_B = "b";
  public static final String ARTICLE3_C = "c";
  private transient Quantite m_quantiteAffiliationAcquiseSecondaire;
  private transient Quantite m_quantiteAssimilationAcquiseSecondaire;
  public transient Pra m_praComplete;
  private transient boolean m_estEnConflit;
  private transient JustificationAffiliation m_justificationAffi;
  
  public ConstitutionQuantiteAffiliation() {}
  
  public ConstitutionQuantiteAffiliation(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public Quantite getQuantiteAcquise()
  {
    return super.getQuantiteAffiliationAcquise().ajouter(super.getQuantiteAssimilationAcquise());
  }
  
  public Quantite getQuantiteAcquiseSecondaire()
  {
    Quantite qte = m_quantiteAffiliationAcquiseSecondaire;
    if (m_quantiteAssimilationAcquiseSecondaire != null) {
      qte = m_quantiteAffiliationAcquiseSecondaire.ajouter(m_quantiteAssimilationAcquiseSecondaire);
    }
    return qte;
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
    if (getDureeInitiale() != null)
    {
      sb.append("Durée : ");
      sb.append(getDureeInitiale().getValeurEntiere());
    }
    sb.append(" - Affi. acquise : ");
    sb.append(getQuantiteAffiliationAcquise());
    sb.append(" - Assimi. acquise : ");
    sb.append(getQuantiteAssimilationAcquise());
    sb.append(" - Article : ");
    sb.append(getArticle3());
    return sb.toString();
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public void jdoPreStore() {}
  
  public ObjetMetierSpec copie()
  {
    ConstitutionQuantiteAffiliation copie = new ConstitutionQuantiteAffiliation();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionQuantiteAffiliation copie = (ConstitutionQuantiteAffiliation)p_copie;
    
    copie.setArticle3(getArticle3());
    copie.setDureeInitiale(getDureeInitiale());
    copie.setEnConflit(estEnConflit());
    copie.setPeriodePRA(getPeriodePRA() != null ? new Periode(getPeriodePRA().getDebut(), getPeriodePRA().getFin()) : null);
    
    copie.setQuantiteAffiliationAcquise(getQuantiteAffiliationAcquise());
    copie.setQuantiteAssimilationAcquise(getQuantiteAssimilationAcquise());
    
    copie.setJustificationAffiliation(getJustificationAffiliation());
    copie.setQuantiteAffiliationAcquiseSecondaire(getQuantiteAffiliationAcquiseSecondaire());
    copie.setQuantiteAssimilationAcquiseSecondaire(getQuantiteAssimilationAcquiseSecondaire());
  }
  
  public boolean estEnConflit()
  {
    return m_estEnConflit;
  }
  
  public void setEnConflit(boolean p_estEnConflit)
  {
    m_estEnConflit = p_estEnConflit;
  }
  
  public JustificationAffiliation getJustificationAffiliation()
  {
    return m_justificationAffi;
  }
  
  public void setJustificationAffiliation(JustificationAffiliation p_justificationAffi)
  {
    m_justificationAffi = p_justificationAffi;
  }
  
  public Quantite getQuantiteAffiliationAcquiseSecondaire()
  {
    return m_quantiteAffiliationAcquiseSecondaire;
  }
  
  public void setQuantiteAffiliationAcquiseSecondaire(Quantite p_quantiteAffiliationAcquiseSecondaire)
  {
    m_quantiteAffiliationAcquiseSecondaire = p_quantiteAffiliationAcquiseSecondaire;
  }
  
  public Quantite getQuantiteAssimilationAcquiseSecondaire()
  {
    return m_quantiteAssimilationAcquiseSecondaire;
  }
  
  public void setQuantiteAssimilationAcquiseSecondaire(Quantite p_quantiteAssimilationAcquiseSecondaire)
  {
    m_quantiteAssimilationAcquiseSecondaire = p_quantiteAssimilationAcquiseSecondaire;
  }
}

/* Location:
 * Qualified Name:     ConstitutionQuantiteAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */