package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.liquidation.parcours.VerifierConditionSurFinDispositifReclassement;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ObjectifExamenRepriseGen;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionCapitalAvecDureeEffective;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDateAttributionFinDroit;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDateAttributionPourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDelaiReportPourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDelaisFinDeDroit;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDureeEffectivePourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDureePourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionDureeReglementaireRepriseAdhesionVolontaire;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionPointDeDepart;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ConstitutionPointDeDepartFinDroit;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationCompetenceAdministrativePourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationConditionAgePourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationConditionChomageInvolontairePourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationConditionCumulPrestationFamiliale;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationConditionMontantNonNulPourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationConditionRechercheEmploiPourReprise;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.DeterminationConditionValiditeReliquat;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.ParcoursDetecterContributionParticuliereContexteEntreeCsp;
import fr.unedic.cali.asu.cge01.p02.liquidation.parcours.cep02dureeRegl.asp.ConstitutionDureePostPrime;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.parcours.ParcoursObjectifReprise;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.parcours.ParcoursTraitementSatisfait;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;
import java.util.List;

public class ObjectifExamenReprise
  extends ObjectifExamenRepriseGen
  implements ObjectifExamenSpec
{
  protected List<ContexteDemandeSpec> m_contexteDemande = null;
  private static final long serialVersionUID = 7539397574470131848L;
  
  public ObjectifExamenReprise() {}
  
  public ObjectifExamenReprise(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjectifExamenReprise(List<ContexteDemandeSpec> contexteDemande)
  {
    m_contexteDemande = contexteDemande;
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanciereDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetenceAdministrativeDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetenceAdministrative()
  {
    return new DeterminationCompetenceAdministrativePourReprise();
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return null;
  }
  
  public int getType()
  {
    return 2;
  }
  
  public Parcours creerParcoursObjectif()
  {
    return new ParcoursObjectifReprise();
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "ARESJASPDC")) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionRechercheEmploiPourReprise();
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageTotal()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionAge()
  {
    return new DeterminationConditionAgePourReprise();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionDureeNonNulle()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "ARESJASPDC")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(m_contexteDemande, 9))) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionChomageInvolontairePourReprise();
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulAvantageVieillesse()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(m_contexteDemande, 5) != null) {
      return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionCumulPrestationFamiliale());
    }
    if (OutilGestionContexteDemande.estContextePresentDansRegroupement(m_contexteDemande, 7)) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionCumulPrestationFamiliale();
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(m_contexteDemande, 5) != null) {
      return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionMontantNonNulPourReprise());
    }
    return new DeterminationConditionMontantNonNulPourReprise();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    if ((m_contexteDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "FINASPVOL")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "ACTIMPREL")))) {
      return new ConstitutionDureeReglementaireRepriseAdhesionVolontaire();
    }
    return new ConstitutionDureePourReprise();
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBruts();
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return null;
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(m_contexteDemande, 5) != null) {
      return new ConstitutionDelaisFinDeDroit();
    }
    if (((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "AREENTRCSP")) && (!OutilGestionContexteDemande.estContextePresentDansRegroupement(m_contexteDemande, 10))) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "ASPDC"))) {
      return null;
    }
    return new ConstitutionDelaiReportPourReprise();
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return null;
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return null;
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return null;
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return null;
  }
  
  public Parcours creerParcoursReglementApplicable()
  {
    return null;
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(m_contexteDemande, 5) != null) {
      return new ConstitutionDateAttributionFinDroit();
    }
    return new ConstitutionDateAttributionPourReprise();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(m_contexteDemande, 5) != null) {
      return new ConstitutionPointDeDepartFinDroit();
    }
    return new ConstitutionPointDeDepart();
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    return new ConstitutionDureeEffectivePourReprise();
  }
  
  public Parcours creerParcoursCapitalAvecDureeEffective()
  {
    return new ConstitutionCapitalAvecDureeEffective();
  }
  
  public Parcours creerParcoursConditionValiditeReliquat()
  {
    return new DeterminationConditionValiditeReliquat();
  }
  
  public ObjectifExamen getObjectifSauvegarde()
  {
    ObjectifExamen objectif = null;
    objectif = (ObjectifExamen)copie();
    return objectif;
  }
  
  public void jdoPreDelete()
  {
    super.jdoPreDelete();
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenReprise copie = new ObjectifExamenReprise();
    copieElements(copie);
    return copie;
  }
  
  public void marquerGraphePersistant() {}
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return new ConstitutionDateLimiteIndemnisation();
  }
  
  public Parcours creerParcoursDetectionContributionParticuliere(Demande pDemande)
  {
    return new ParcoursDetecterContributionParticuliereContexteEntreeCsp();
  }
  
  public Parcours creerParcoursLiquidationDemandeAssociee()
  {
    return null;
  }
  
  public Parcours creerParcoursConstitutionDureePostPrime()
  {
    return new ConstitutionDureePostPrime();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */