package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConditionChomageInvolontairePC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class ConditionChomageInvolontaireGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionChomageInvolontairePC;
  private ResultatElementDroit m_resultatElementDroit;
  private String m_identifiantActivitePortantDV;
  private Quantite m_intensiteHoraireSalarieAeDv;
  private Quantite m_quantiteAffiliationPrincipaleInopposabilite;
  private Quantite m_quantiteAffiliationSecondaireInopposabilite;
  
  public ConditionChomageInvolontaireGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionChomageInvolontaireGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionChomageInvolontairePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionChomageInvolontairePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionChomageInvolontairePC)
  {
    m_conditionChomageInvolontairePC = p_conditionChomageInvolontairePC;
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionChomageInvolontairePC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionChomageInvolontairePC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionChomageInvolontairePC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  protected int rawGetSituationConditionChomageInvolontaire()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getSituationConditionChomageInvolontaire();
  }
  
  public int getSituationConditionChomageInvolontaire()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getSituationConditionChomageInvolontaire();
  }
  
  public void setSituationConditionChomageInvolontaire(int p_situationConditionChomageInvolontaire)
  {
    ((ConditionChomageInvolontairePC)getPC()).setSituationConditionChomageInvolontaire(p_situationConditionChomageInvolontaire);
  }
  
  protected String rawGetIdentifiantActivitePortantDV()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getIdentifiantActivitePortantDV();
  }
  
  public String getIdentifiantActivitePortantDV()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getIdentifiantActivitePortantDV();
  }
  
  public void setIdentifiantActivitePortantDV(String p_identifiantActivitePortantDV)
  {
    if ((m_identifiantActivitePortantDV == null) || (p_identifiantActivitePortantDV == null))
    {
      m_identifiantActivitePortantDV = p_identifiantActivitePortantDV;
      ((ConditionChomageInvolontairePC)getPC()).setIdentifiantActivitePortantDV(p_identifiantActivitePortantDV);
    }
    else if ((m_identifiantActivitePortantDV != null) && (p_identifiantActivitePortantDV != null) && (!p_identifiantActivitePortantDV.equals(m_identifiantActivitePortantDV)))
    {
      m_identifiantActivitePortantDV = p_identifiantActivitePortantDV;
      ((ConditionChomageInvolontairePC)getPC()).setIdentifiantActivitePortantDV(p_identifiantActivitePortantDV);
    }
  }
  
  protected int rawGetDureeAeDv()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getDureeAeDvConditionChomageInvolontaire();
  }
  
  public int getDureeAeDv()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getDureeAeDvConditionChomageInvolontaire();
  }
  
  public void setDureeAeDv(int p_dureeAeDv)
  {
    ((ConditionChomageInvolontairePC)getPC()).setDureeAeDvConditionChomageInvolontaire(p_dureeAeDv);
  }
  
  protected Quantite rawGetIntensiteHoraireSalarieAeDv()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getIntensiteHoraireSalarieAeDvConditionChomageInvolontaire();
  }
  
  public Quantite getIntensiteHoraireSalarieAeDv()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getIntensiteHoraireSalarieAeDvConditionChomageInvolontaire();
  }
  
  public void setIntensiteHoraireSalarieAeDv(Quantite p_intensiteHoraireSalarieAeDv)
  {
    if ((m_intensiteHoraireSalarieAeDv == null) || (p_intensiteHoraireSalarieAeDv == null))
    {
      m_intensiteHoraireSalarieAeDv = p_intensiteHoraireSalarieAeDv;
      ((ConditionChomageInvolontairePC)getPC()).setIntensiteHoraireSalarieAeDvConditionChomageInvolontaire(p_intensiteHoraireSalarieAeDv);
    }
    else if ((m_intensiteHoraireSalarieAeDv != null) && (p_intensiteHoraireSalarieAeDv != null) && (!p_intensiteHoraireSalarieAeDv.equals(m_intensiteHoraireSalarieAeDv)))
    {
      m_intensiteHoraireSalarieAeDv = p_intensiteHoraireSalarieAeDv;
      ((ConditionChomageInvolontairePC)getPC()).setIntensiteHoraireSalarieAeDvConditionChomageInvolontaire(p_intensiteHoraireSalarieAeDv);
    }
  }
  
  protected Quantite rawGetQuantiteAffiliationPrincipaleInopposabilite()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getQuantiteAffiliationPrincipaleInopposabiliteConditionChomageInvolontaire();
  }
  
  public Quantite getQuantiteAffiliationPrincipaleInopposabilite()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getQuantiteAffiliationPrincipaleInopposabiliteConditionChomageInvolontaire();
  }
  
  public void setQuantiteAffiliationPrincipaleInopposabilite(Quantite p_quantiteAffiliationPrincipaleInopposabilite)
  {
    if ((m_quantiteAffiliationPrincipaleInopposabilite == null) || (p_quantiteAffiliationPrincipaleInopposabilite == null))
    {
      m_quantiteAffiliationPrincipaleInopposabilite = p_quantiteAffiliationPrincipaleInopposabilite;
      ((ConditionChomageInvolontairePC)getPC()).setQuantiteAffiliationPrincipaleInopposabiliteConditionChomageInvolontaire(p_quantiteAffiliationPrincipaleInopposabilite);
    }
    else if ((m_quantiteAffiliationPrincipaleInopposabilite != null) && (p_quantiteAffiliationPrincipaleInopposabilite != null) && (!p_quantiteAffiliationPrincipaleInopposabilite.equals(m_quantiteAffiliationPrincipaleInopposabilite)))
    {
      m_quantiteAffiliationPrincipaleInopposabilite = p_quantiteAffiliationPrincipaleInopposabilite;
      ((ConditionChomageInvolontairePC)getPC()).setQuantiteAffiliationPrincipaleInopposabiliteConditionChomageInvolontaire(p_quantiteAffiliationPrincipaleInopposabilite);
    }
  }
  
  protected Quantite rawGetQuantiteAffiliationSecondaireInopposabilite()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getQuantiteAffiliationSecondaireInopposabiliteConditionChomageInvolontaire();
  }
  
  public Quantite getQuantiteAffiliationSecondaireInopposabilite()
  {
    return ((ConditionChomageInvolontairePC)getPC()).getQuantiteAffiliationSecondaireInopposabiliteConditionChomageInvolontaire();
  }
  
  public void setQuantiteAffiliationSecondaireInopposabilite(Quantite p_quantiteAffiliationSecondaireInopposabilite)
  {
    if ((m_quantiteAffiliationSecondaireInopposabilite == null) || (p_quantiteAffiliationSecondaireInopposabilite == null))
    {
      m_quantiteAffiliationSecondaireInopposabilite = p_quantiteAffiliationSecondaireInopposabilite;
      ((ConditionChomageInvolontairePC)getPC()).setQuantiteAffiliationSecondaireInopposabiliteConditionChomageInvolontaire(p_quantiteAffiliationSecondaireInopposabilite);
    }
    else if ((m_quantiteAffiliationSecondaireInopposabilite != null) && (p_quantiteAffiliationSecondaireInopposabilite != null) && (!p_quantiteAffiliationSecondaireInopposabilite.equals(m_quantiteAffiliationSecondaireInopposabilite)))
    {
      m_quantiteAffiliationSecondaireInopposabilite = p_quantiteAffiliationSecondaireInopposabilite;
      ((ConditionChomageInvolontairePC)getPC()).setQuantiteAffiliationSecondaireInopposabiliteConditionChomageInvolontaire(p_quantiteAffiliationSecondaireInopposabilite);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionChomageInvolontaireGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */