package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConditionValiditeReliquatPC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConditionValiditeReliquatGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionValiditeReliquatPC;
  private ResultatElementDroit m_resultatElementDroit;
  private Damj m_dateDecheance;
  
  public ConditionValiditeReliquatGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionValiditeReliquatGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionValiditeReliquatPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionValiditeReliquatPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionValiditeReliquatPC)
  {
    m_conditionValiditeReliquatPC = p_conditionValiditeReliquatPC;
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionValiditeReliquatPC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionValiditeReliquatPC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionValiditeReliquatPC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  protected Damj rawGetDateDecheance()
  {
    return ((ConditionValiditeReliquatPC)getPC()).getDateDecheance();
  }
  
  public Damj getDateDecheance()
  {
    return ((ConditionValiditeReliquatPC)getPC()).getDateDecheance();
  }
  
  public void setDateDecheance(Damj p_dateDecheance)
  {
    if ((m_dateDecheance == null) || (p_dateDecheance == null))
    {
      m_dateDecheance = p_dateDecheance;
      ((ConditionValiditeReliquatPC)getPC()).setDateDecheance(p_dateDecheance);
    }
    else if ((m_dateDecheance != null) && (p_dateDecheance != null) && (!p_dateDecheance.equals(m_dateDecheance)))
    {
      m_dateDecheance = p_dateDecheance;
      ((ConditionValiditeReliquatPC)getPC()).setDateDecheance(p_dateDecheance);
    }
  }
  
  protected int rawGetMotifNonValidite()
  {
    return ((ConditionValiditeReliquatPC)getPC()).getMotifNonValidite();
  }
  
  public int getMotifNonValidite()
  {
    return ((ConditionValiditeReliquatPC)getPC()).getMotifNonValidite();
  }
  
  public void setMotifNonValidite(int p_motifNonValidite)
  {
    ((ConditionValiditeReliquatPC)getPC()).setMotifNonValidite(p_motifNonValidite);
  }
  
  protected int rawGetCauseExtinction()
  {
    return ((ConditionValiditeReliquatPC)getPC()).getCauseExtinction();
  }
  
  public int getCauseExtinction()
  {
    return ((ConditionValiditeReliquatPC)getPC()).getCauseExtinction();
  }
  
  public void setCauseExtinction(int p_causeExtinction)
  {
    ((ConditionValiditeReliquatPC)getPC()).setCauseExtinction(p_causeExtinction);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionValiditeReliquatGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */