package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConstitutionCaractereSaisonnierPC;
import fr.unedic.cali.asu.dom.PeriodeChomageSaisonnier;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class ConstitutionCaractereSaisonnierGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionCaractereSaisonnierPC;
  private Periode m_periodeReferenceSaisonnier = null;
  private Periode m_periodeRechercheActiviteSaisonniere = null;
  private Collection m_listePeriodesChomageSaisonnier = null;
  
  public ConstitutionCaractereSaisonnierGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionCaractereSaisonnierGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionCaractereSaisonnierPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionCaractereSaisonnierPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionCaractereSaisonnierPC)
  {
    m_constitutionCaractereSaisonnierPC = p_constitutionCaractereSaisonnierPC;
  }
  
  protected boolean rawIsCaractereSaisonnierRetenu()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).isCaractereSaisonnierRetenu();
  }
  
  public boolean isCaractereSaisonnierRetenu()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).isCaractereSaisonnierRetenu();
  }
  
  public void setCaractereSaisonnierRetenu(boolean p_caractereSaisonnierRetenu)
  {
    ((ConstitutionCaractereSaisonnierPC)getPC()).setCaractereSaisonnierRetenu(p_caractereSaisonnierRetenu);
  }
  
  protected int rawGetTypeCaractereSaisonnierRetenu()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).getTypeCaractereSaisonnierRetenu();
  }
  
  public int getTypeCaractereSaisonnierRetenu()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).getTypeCaractereSaisonnierRetenu();
  }
  
  public void setTypeCaractereSaisonnierRetenu(int p_typeCaractereSaisonnierRetenu)
  {
    ((ConstitutionCaractereSaisonnierPC)getPC()).setTypeCaractereSaisonnierRetenu(p_typeCaractereSaisonnierRetenu);
  }
  
  protected Periode rawGetPeriodeReferenceSaisonnier()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).getPeriodeReferenceSaisonnier();
  }
  
  public Periode getPeriodeReferenceSaisonnier()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).getPeriodeReferenceSaisonnier();
  }
  
  public void setPeriodeReferenceSaisonnier(Periode p_periodeReferenceSaisonnier)
  {
    if ((m_periodeReferenceSaisonnier == null) || (p_periodeReferenceSaisonnier == null))
    {
      m_periodeReferenceSaisonnier = p_periodeReferenceSaisonnier;
      ((ConstitutionCaractereSaisonnierPC)getPC()).setPeriodeReferenceSaisonnier(p_periodeReferenceSaisonnier);
    }
    else if ((m_periodeReferenceSaisonnier != null) && (p_periodeReferenceSaisonnier != null) && (!p_periodeReferenceSaisonnier.equals(m_periodeReferenceSaisonnier)))
    {
      m_periodeReferenceSaisonnier = p_periodeReferenceSaisonnier;
      ((ConstitutionCaractereSaisonnierPC)getPC()).setPeriodeReferenceSaisonnier(p_periodeReferenceSaisonnier);
    }
  }
  
  protected Periode rawGetPeriodeRechercheActiviteSaisonniere()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).getPeriodeRechercheActiviteSaisonniere();
  }
  
  public Periode getPeriodeRechercheActiviteSaisonniere()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).getPeriodeRechercheActiviteSaisonniere();
  }
  
  public void setPeriodeRechercheActiviteSaisonniere(Periode p_periodeRechercheActiviteSaisonniere)
  {
    if ((m_periodeRechercheActiviteSaisonniere == null) || (p_periodeRechercheActiviteSaisonniere == null))
    {
      m_periodeRechercheActiviteSaisonniere = p_periodeRechercheActiviteSaisonniere;
      ((ConstitutionCaractereSaisonnierPC)getPC()).setPeriodeRechercheActiviteSaisonniere(p_periodeRechercheActiviteSaisonniere);
    }
    else if ((m_periodeRechercheActiviteSaisonniere != null) && (p_periodeRechercheActiviteSaisonniere != null) && (!p_periodeRechercheActiviteSaisonniere.equals(m_periodeRechercheActiviteSaisonniere)))
    {
      m_periodeRechercheActiviteSaisonniere = p_periodeRechercheActiviteSaisonniere;
      ((ConstitutionCaractereSaisonnierPC)getPC()).setPeriodeRechercheActiviteSaisonniere(p_periodeRechercheActiviteSaisonniere);
    }
  }
  
  protected boolean rawIsActivite3Sur5()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).isActivite3Sur5();
  }
  
  public boolean isActivite3Sur5()
  {
    return ((ConstitutionCaractereSaisonnierPC)getPC()).isActivite3Sur5();
  }
  
  public void setActivite3Sur5(boolean p_activite3Sur5)
  {
    ((ConstitutionCaractereSaisonnierPC)getPC()).setActivite3Sur5(p_activite3Sur5);
  }
  
  private final Collection getCollectionModifiablePeriodeChomageSaisonnier()
  {
    Iterator itCollectionPC;
    if (m_listePeriodesChomageSaisonnier == null)
    {
      m_listePeriodesChomageSaisonnier = new ArrayList();
      for (itCollectionPC = ((ConstitutionCaractereSaisonnierPC)getPC()).getCollectionPeriodeChomageSaisonnier().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listePeriodesChomageSaisonnier.add(currentOM);
      }
    }
    return m_listePeriodesChomageSaisonnier;
  }
  
  public Collection getCollectionPeriodeChomageSaisonnier()
  {
    return Collections.unmodifiableCollection(getCollectionModifiablePeriodeChomageSaisonnier());
  }
  
  public List getListPeriodeChomageSaisonnier()
  {
    return Collections.unmodifiableList((List)getCollectionModifiablePeriodeChomageSaisonnier());
  }
  
  public void remplacerCollectionPeriodeChomageSaisonnier(Collection p_collectionACopier)
  {
    clearCollectionPeriodeChomageSaisonnier();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      PeriodeChomageSaisonnier objet = (PeriodeChomageSaisonnier)i.next();
      ajouterPeriodeChomageSaisonnier(objet);
    }
  }
  
  public void supprimerSousCollectionPeriodeChomageSaisonnier(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      PeriodeChomageSaisonnier objet = (PeriodeChomageSaisonnier)i.next();
      supprimerPeriodeChomageSaisonnier(objet);
    }
  }
  
  public void ajouterPeriodeChomageSaisonnier(PeriodeChomageSaisonnier p_periodesChomageSaisonnier)
    throws NullPointerException
  {
    if (p_periodesChomageSaisonnier == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesChomageSaisonnier ne devrait pas être nul.", p_periodesChomageSaisonnier);
    }
    getCollectionModifiablePeriodeChomageSaisonnier().add(p_periodesChomageSaisonnier);
    ((ConstitutionCaractereSaisonnierPC)getPC()).ajouterPeriodeChomageSaisonnier(p_periodesChomageSaisonnier.getPC());
  }
  
  public void supprimerPeriodeChomageSaisonnier(PeriodeChomageSaisonnier p_periodesChomageSaisonnier)
    throws NullPointerException
  {
    if (p_periodesChomageSaisonnier == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesChomageSaisonnier ne devrait pas être nul.", p_periodesChomageSaisonnier);
    }
    getCollectionModifiablePeriodeChomageSaisonnier().remove(p_periodesChomageSaisonnier);
    ((ConstitutionCaractereSaisonnierPC)getPC()).supprimerPeriodeChomageSaisonnier(p_periodesChomageSaisonnier.getPC());
  }
  
  public void recopierCollectionPeriodeChomageSaisonnierVers(ObjetMetierSpec p_copie)
  {
    ConstitutionCaractereSaisonnierGen copie = (ConstitutionCaractereSaisonnierGen)p_copie;
    Collection listeACopier = getCollectionPeriodeChomageSaisonnier();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterPeriodeChomageSaisonnier((PeriodeChomageSaisonnier)objet);
    }
  }
  
  public void clearCollectionPeriodeChomageSaisonnier()
  {
    getCollectionModifiablePeriodeChomageSaisonnier().clear();
    ((ConstitutionCaractereSaisonnierPC)getPC()).getCollectionPeriodeChomageSaisonnier().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionPeriodeChomageSaisonnier().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionCaractereSaisonnierGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */