package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.JustificationSjr;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConstitutionSjrPC;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;

public abstract class ConstitutionSjrGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionSjrPC;
  private Sjrip m_sjrip;
  private Sjr m_sjrrp;
  private JustificationSjr m_justificationSjr;
  protected BigDecimal m_sommeMontantRevision;
  
  public ConstitutionSjrGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionSjrGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionSjrPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionSjrPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionSjrPC)
  {
    m_constitutionSjrPC = p_constitutionSjrPC;
  }
  
  public Sjrip getSjrip()
  {
    if (m_sjrip == null)
    {
      DomPCSpec sjripPC = ((ConstitutionSjrPC)getPC()).getSjrip();
      if (sjripPC != null) {
        m_sjrip = ((Sjrip)sjripPC.createOM());
      }
    }
    return m_sjrip;
  }
  
  public void setSjrip(Sjrip p_sjrip)
  {
    if (p_sjrip == null)
    {
      ((ConstitutionSjrPC)getPC()).setSjrip(null);
      m_sjrip = p_sjrip;
    }
    else if (!p_sjrip.equals(m_sjrip))
    {
      ((ConstitutionSjrPC)getPC()).setSjrip(p_sjrip.getPC());
      m_sjrip = p_sjrip;
    }
  }
  
  protected Sjr rawGetSjrrp()
  {
    return ((ConstitutionSjrPC)getPC()).getSjrrp();
  }
  
  public Sjr getSjrrp()
  {
    return ((ConstitutionSjrPC)getPC()).getSjrrp();
  }
  
  public void setSjrrp(Sjr p_sjrrp)
  {
    if ((m_sjrrp == null) || (p_sjrrp == null))
    {
      m_sjrrp = p_sjrrp;
      ((ConstitutionSjrPC)getPC()).setSjrrp(p_sjrrp);
    }
    else if ((m_sjrrp != null) && (p_sjrrp != null) && (!p_sjrrp.equals(m_sjrrp)))
    {
      m_sjrrp = p_sjrrp;
      ((ConstitutionSjrPC)getPC()).setSjrrp(p_sjrrp);
    }
  }
  
  public JustificationSjr getJustificationSjr()
  {
    if (m_justificationSjr == null)
    {
      DomPCSpec justificationSjrPC = ((ConstitutionSjrPC)getPC()).getJustificationSjr();
      if (justificationSjrPC != null) {
        m_justificationSjr = ((JustificationSjr)justificationSjrPC.createOM());
      }
    }
    return m_justificationSjr;
  }
  
  public void setJustificationSjr(JustificationSjr p_justificationSjr)
  {
    if (p_justificationSjr == null)
    {
      ((ConstitutionSjrPC)getPC()).setJustificationSjr(null);
      m_justificationSjr = p_justificationSjr;
    }
    else if (!p_justificationSjr.equals(m_justificationSjr))
    {
      ((ConstitutionSjrPC)getPC()).setJustificationSjr(p_justificationSjr.getPC());
      m_justificationSjr = p_justificationSjr;
    }
  }
  
  protected int rawGetCodeEmploiA2b()
  {
    return ((ConstitutionSjrPC)getPC()).getCodeEmploiA2b();
  }
  
  public int getCodeEmploiA2b()
  {
    return ((ConstitutionSjrPC)getPC()).getCodeEmploiA2b();
  }
  
  public void setCodeEmploiA2b(int p_codeEmploiA2b)
  {
    ((ConstitutionSjrPC)getPC()).setCodeEmploiA2b(p_codeEmploiA2b);
  }
  
  protected BigDecimal rawGetSommeMontantRevision()
  {
    return ((ConstitutionSjrPC)getPC()).getSommeMontantRevision();
  }
  
  public BigDecimal getSommeMontantRevision()
  {
    return ((ConstitutionSjrPC)getPC()).getSommeMontantRevision();
  }
  
  public void setSommeMontantRevision(BigDecimal p_sommeMontantRevision)
  {
    if ((m_sommeMontantRevision == null) || (p_sommeMontantRevision == null))
    {
      m_sommeMontantRevision = p_sommeMontantRevision;
      ((ConstitutionSjrPC)getPC()).setSommeMontantRevision(p_sommeMontantRevision);
    }
    else if ((m_sommeMontantRevision != null) && (p_sommeMontantRevision != null) && (!p_sommeMontantRevision.equals(m_sommeMontantRevision)))
    {
      m_sommeMontantRevision = p_sommeMontantRevision;
      ((ConstitutionSjrPC)getPC()).setSommeMontantRevision(p_sommeMontantRevision);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object sjrip = getSjrip();
    if ((sjrip != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(sjrip))) {
      DomManager.supprimer(getSjrip(), p_contexteSuppression);
    }
    Object justificationSjr = getJustificationSjr();
    if ((justificationSjr != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(justificationSjr))) {
      DomManager.supprimer(getJustificationSjr(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionSjrGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */