package fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc;

import fr.unedic.cali.asu.dom.pc.ContributionParticuliereAbstraitPC;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenementDebutPC;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public abstract class DossierExamenPC
  extends ObjetChronoEvenementDebutPC
  implements DomPCSpec, PersistenceCapable
{
  protected DomPCSpec m_dossierAffecte;
  protected ConditionsAttributionAdmissionPC m_conditionsAttributionAdmission;
  protected ConstitutionElementsAdmissionPC m_constitutionElementsAdmission;
  protected ConditionsAttributionReprisePC m_conditionsAttributionReprise;
  protected ConstitutionElementsReprisePC m_constitutionElementsReprise;
  protected int m_motifRejetNotifie;
  protected CompetencePC m_competence;
  protected ContributionParticuliereAbstraitPC m_contributionParticuliere;
  protected int m_contexteDdeExpresse;
  private String m_typeContributionParticuliere;
  public CompetencePC m_competenceSousJacente;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_dateEvenement", "m_dossierAffecte", "m_conditionsAttributionAdmission", "m_constitutionElementsAdmission", "m_conditionsAttributionReprise", "m_constitutionElementsReprise", "m_motifRejetNotifie", "m_competence", "m_contributionParticuliere", "m_contexteDdeExpresse", "m_typeContributionParticuliere", "m_competenceSousJacente" };
  private static Class[] jdoFieldTypes = { Damj.class, DomPCSpec.class, ConditionsAttributionAdmissionPC.class, ConstitutionElementsAdmissionPC.class, ConditionsAttributionReprisePC.class, ConstitutionElementsReprisePC.class, Integer.TYPE, CompetencePC.class, ContributionParticuliereAbstraitPC.class, Integer.TYPE, String.class, CompetencePC.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  static final long serialVersionUID = 1787799460461025502L;
  
  public abstract Object createOM();
  
  public DomPCSpec getDossierAffecte()
  {
    return jdoGetm_dossierAffecte(this);
  }
  
  public final void setDossierAffecte(DomPCSpec p_dossierAffecte)
  {
    jdoSetm_dossierAffecte(this, p_dossierAffecte);
  }
  
  public DomPCSpec getConditionsAttributionAdmission()
  {
    return jdoGetm_conditionsAttributionAdmission(this);
  }
  
  public final void setConditionsAttributionAdmission(DomPCSpec p_conditionsAttributionAdmission)
  {
    jdoSetm_conditionsAttributionAdmission(this, (ConditionsAttributionAdmissionPC)p_conditionsAttributionAdmission);
  }
  
  public DomPCSpec getConstitutionElementsAdmission()
  {
    return jdoGetm_constitutionElementsAdmission(this);
  }
  
  public final void setConstitutionElementsAdmission(DomPCSpec p_constitutionElementsAdmission)
  {
    jdoSetm_constitutionElementsAdmission(this, (ConstitutionElementsAdmissionPC)p_constitutionElementsAdmission);
  }
  
  public DomPCSpec getConditionsAttributionReprise()
  {
    return jdoGetm_conditionsAttributionReprise(this);
  }
  
  public final void setConditionsAttributionReprise(DomPCSpec p_conditionsAttributionReprise)
  {
    jdoSetm_conditionsAttributionReprise(this, (ConditionsAttributionReprisePC)p_conditionsAttributionReprise);
  }
  
  public DomPCSpec getConstitutionElementsReprise()
  {
    return jdoGetm_constitutionElementsReprise(this);
  }
  
  public final void setConstitutionElementsReprise(DomPCSpec p_constitutionElementsReprise)
  {
    jdoSetm_constitutionElementsReprise(this, (ConstitutionElementsReprisePC)p_constitutionElementsReprise);
  }
  
  public int getMotifRejetNotifie()
  {
    return jdoGetm_motifRejetNotifie(this);
  }
  
  public final void setMotifRejetNotifie(int p_motifRejetNotifie)
  {
    jdoSetm_motifRejetNotifie(this, p_motifRejetNotifie);
  }
  
  public DomPCSpec getCompetence()
  {
    return jdoGetm_competence(this);
  }
  
  public final void setCompetence(DomPCSpec p_competence)
  {
    jdoSetm_competence(this, (CompetencePC)p_competence);
  }
  
  public DomPCSpec getContributionParticuliere()
  {
    return jdoGetm_contributionParticuliere(this);
  }
  
  public final void setContributionParticuliere(DomPCSpec p_contributionParticuliere)
  {
    jdoSetm_contributionParticuliere(this, (ContributionParticuliereAbstraitPC)p_contributionParticuliere);
  }
  
  public int getContexteDdeExpresse()
  {
    return jdoGetm_contexteDdeExpresse(this);
  }
  
  public final void setContexteDdeExpresse(int p_contexteDdeExpresse)
  {
    jdoSetm_contexteDdeExpresse(this, p_contexteDdeExpresse);
  }
  
  public String getTypeContributionParticuliere()
  {
    return jdoGetm_typeContributionParticuliere(this);
  }
  
  public final void setTypeContributionParticuliere(String p_typeContributionParticuliere)
  {
    jdoSetm_typeContributionParticuliere(this, p_typeContributionParticuliere);
  }
  
  public DomPCSpec getCompetenceSousJacente()
  {
    return jdoGetm_competenceSousJacente(this);
  }
  
  public final void setCompetenceSousJacente(DomPCSpec p_competenceSousJacente)
  {
    jdoSetm_competenceSousJacente(this, (CompetencePC)p_competenceSousJacente);
  }
  
  static
  {
    JDOImplHelper.registerClass(DossierExamenPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, null);
  }
  
  protected static final Damj jdoGetm_dateEvenement(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dateEvenement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_dateEvenement;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement);
    }
    return m_dateEvenement;
  }
  
  protected static final DomPCSpec jdoGetm_dossierAffecte(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dossierAffecte;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_dossierAffecte;
      }
      return (DomPCSpec)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_dossierAffecte);
    }
    return m_dossierAffecte;
  }
  
  protected static final ConditionsAttributionAdmissionPC jdoGetm_conditionsAttributionAdmission(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_conditionsAttributionAdmission;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_conditionsAttributionAdmission;
      }
      return (ConditionsAttributionAdmissionPC)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_conditionsAttributionAdmission);
    }
    return m_conditionsAttributionAdmission;
  }
  
  protected static final ConstitutionElementsAdmissionPC jdoGetm_constitutionElementsAdmission(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_constitutionElementsAdmission;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_constitutionElementsAdmission;
      }
      return (ConstitutionElementsAdmissionPC)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_constitutionElementsAdmission);
    }
    return m_constitutionElementsAdmission;
  }
  
  protected static final ConditionsAttributionReprisePC jdoGetm_conditionsAttributionReprise(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_conditionsAttributionReprise;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_conditionsAttributionReprise;
      }
      return (ConditionsAttributionReprisePC)sm.getObjectField(pc, jdoInheritedFieldCount + 4, m_conditionsAttributionReprise);
    }
    return m_conditionsAttributionReprise;
  }
  
  protected static final ConstitutionElementsReprisePC jdoGetm_constitutionElementsReprise(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_constitutionElementsReprise;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_constitutionElementsReprise;
      }
      return (ConstitutionElementsReprisePC)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_constitutionElementsReprise);
    }
    return m_constitutionElementsReprise;
  }
  
  protected static final int jdoGetm_motifRejetNotifie(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_motifRejetNotifie;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_motifRejetNotifie;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 6, m_motifRejetNotifie);
    }
    return m_motifRejetNotifie;
  }
  
  protected static final CompetencePC jdoGetm_competence(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_competence;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_competence;
      }
      return (CompetencePC)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_competence);
    }
    return m_competence;
  }
  
  protected static final ContributionParticuliereAbstraitPC jdoGetm_contributionParticuliere(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_contributionParticuliere;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_contributionParticuliere;
      }
      return (ContributionParticuliereAbstraitPC)sm.getObjectField(pc, jdoInheritedFieldCount + 8, m_contributionParticuliere);
    }
    return m_contributionParticuliere;
  }
  
  protected static final int jdoGetm_contexteDdeExpresse(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_contexteDdeExpresse;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_contexteDdeExpresse;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 9, m_contexteDdeExpresse);
    }
    return m_contexteDdeExpresse;
  }
  
  private static final String jdoGetm_typeContributionParticuliere(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_typeContributionParticuliere;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_typeContributionParticuliere;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 10, m_typeContributionParticuliere);
    }
    return m_typeContributionParticuliere;
  }
  
  public static final CompetencePC jdoGetm_competenceSousJacente(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_competenceSousJacente;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 11)) {
        return m_competenceSousJacente;
      }
      return (CompetencePC)sm.getObjectField(pc, jdoInheritedFieldCount + 11, m_competenceSousJacente);
    }
    return m_competenceSousJacente;
  }
  
  protected static final void jdoSetm_dateEvenement(DossierExamenPC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_dateEvenement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement, newValue);
    } else {
      m_dateEvenement = newValue;
    }
  }
  
  protected static final void jdoSetm_dossierAffecte(DossierExamenPC pc, DomPCSpec newValue)
  {
    if (jdoFlags == 0)
    {
      m_dossierAffecte = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_dossierAffecte, newValue);
    } else {
      m_dossierAffecte = newValue;
    }
  }
  
  protected static final void jdoSetm_conditionsAttributionAdmission(DossierExamenPC pc, ConditionsAttributionAdmissionPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_conditionsAttributionAdmission = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_conditionsAttributionAdmission, newValue);
    } else {
      m_conditionsAttributionAdmission = newValue;
    }
  }
  
  protected static final void jdoSetm_constitutionElementsAdmission(DossierExamenPC pc, ConstitutionElementsAdmissionPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_constitutionElementsAdmission = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_constitutionElementsAdmission, newValue);
    } else {
      m_constitutionElementsAdmission = newValue;
    }
  }
  
  protected static final void jdoSetm_conditionsAttributionReprise(DossierExamenPC pc, ConditionsAttributionReprisePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_conditionsAttributionReprise = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 4, m_conditionsAttributionReprise, newValue);
    } else {
      m_conditionsAttributionReprise = newValue;
    }
  }
  
  protected static final void jdoSetm_constitutionElementsReprise(DossierExamenPC pc, ConstitutionElementsReprisePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_constitutionElementsReprise = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_constitutionElementsReprise, newValue);
    } else {
      m_constitutionElementsReprise = newValue;
    }
  }
  
  protected static final void jdoSetm_motifRejetNotifie(DossierExamenPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_motifRejetNotifie = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 6, m_motifRejetNotifie, newValue);
    } else {
      m_motifRejetNotifie = newValue;
    }
  }
  
  protected static final void jdoSetm_competence(DossierExamenPC pc, CompetencePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_competence = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_competence, newValue);
    } else {
      m_competence = newValue;
    }
  }
  
  protected static final void jdoSetm_contributionParticuliere(DossierExamenPC pc, ContributionParticuliereAbstraitPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_contributionParticuliere = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 8, m_contributionParticuliere, newValue);
    } else {
      m_contributionParticuliere = newValue;
    }
  }
  
  protected static final void jdoSetm_contexteDdeExpresse(DossierExamenPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_contexteDdeExpresse = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 9, m_contexteDdeExpresse, newValue);
    } else {
      m_contexteDdeExpresse = newValue;
    }
  }
  
  private static final void jdoSetm_typeContributionParticuliere(DossierExamenPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_typeContributionParticuliere = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 10, m_typeContributionParticuliere, newValue);
    } else {
      m_typeContributionParticuliere = newValue;
    }
  }
  
  public static final void jdoSetm_competenceSousJacente(DossierExamenPC pc, CompetencePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_competenceSousJacente = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 11, m_competenceSousJacente, newValue);
    } else {
      m_competenceSousJacente = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dateEvenement);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dossierAffecte);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_conditionsAttributionAdmission);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_constitutionElementsAdmission);
      break;
    case 4: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_conditionsAttributionReprise);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_constitutionElementsReprise);
      break;
    case 6: 
      jdoStateManager.providedIntField(this, fieldNumber, m_motifRejetNotifie);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_competence);
      break;
    case 8: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_contributionParticuliere);
      break;
    case 9: 
      jdoStateManager.providedIntField(this, fieldNumber, m_contexteDdeExpresse);
      break;
    case 10: 
      jdoStateManager.providedStringField(this, fieldNumber, m_typeContributionParticuliere);
      break;
    case 11: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_competenceSousJacente);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_dateEvenement = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_dossierAffecte = ((DomPCSpec)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_conditionsAttributionAdmission = ((ConditionsAttributionAdmissionPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_constitutionElementsAdmission = ((ConstitutionElementsAdmissionPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_conditionsAttributionReprise = ((ConditionsAttributionReprisePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 5: 
      m_constitutionElementsReprise = ((ConstitutionElementsReprisePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 6: 
      m_motifRejetNotifie = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 7: 
      m_competence = ((CompetencePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_contributionParticuliere = ((ContributionParticuliereAbstraitPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 9: 
      m_contexteDdeExpresse = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 10: 
      m_typeContributionParticuliere = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 11: 
      m_competenceSousJacente = ((CompetencePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    // Byte code:
    //   0: new 116	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 492
    //   7: invokespecial 399	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierExamenPC
    //   0	12	1	sm	StateManager
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    // Byte code:
    //   0: new 116	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 492
    //   7: invokespecial 399	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierExamenPC
    //   0	12	1	sm	StateManager
    //   0	12	2	oid	Object
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 12;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof DossierExamenPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    DossierExamenPC other = (DossierExamenPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_dateEvenement = m_dateEvenement;
        break;
      case 1: 
        m_dossierAffecte = m_dossierAffecte;
        break;
      case 2: 
        m_conditionsAttributionAdmission = m_conditionsAttributionAdmission;
        break;
      case 3: 
        m_constitutionElementsAdmission = m_constitutionElementsAdmission;
        break;
      case 4: 
        m_conditionsAttributionReprise = m_conditionsAttributionReprise;
        break;
      case 5: 
        m_constitutionElementsReprise = m_constitutionElementsReprise;
        break;
      case 6: 
        m_motifRejetNotifie = m_motifRejetNotifie;
        break;
      case 7: 
        m_competence = m_competence;
        break;
      case 8: 
        m_contributionParticuliere = m_contributionParticuliere;
        break;
      case 9: 
        m_contexteDdeExpresse = m_contexteDdeExpresse;
        break;
      case 10: 
        m_typeContributionParticuliere = m_typeContributionParticuliere;
        break;
      case 11: 
        m_competenceSousJacente = m_competenceSousJacente;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     DossierExamenPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */