package fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjcip;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenementDebutPC;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class SjcipPC
  extends ObjetChronoEvenementDebutPC
  implements DomPCSpec, PersistenceCapable
{
  private transient Sjcip m_sjcipOM;
  protected QuantiteEuro m_plafond;
  protected QuantiteEuro m_sjcInitial;
  protected Collection m_listeSjrActiviteConservee;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_dateEvenement", "m_plafond", "m_sjcInitial", "m_listeSjrActiviteConservee" };
  private static Class[] jdoFieldTypes = { Damj.class, QuantiteEuro.class, QuantiteEuro.class, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  static final long serialVersionUID = -7137506624549417437L;
  
  public Object createOM()
  {
    if (m_sjcipOM == null) {
      m_sjcipOM = new Sjcip(this);
    }
    return m_sjcipOM;
  }
  
  public QuantiteEuro getPlafond()
  {
    return jdoGetm_plafond(this);
  }
  
  public final void setPlafond(QuantiteEuro p_plafond)
  {
    jdoSetm_plafond(this, p_plafond);
  }
  
  public QuantiteEuro getSjcInitial()
  {
    return jdoGetm_sjcInitial(this);
  }
  
  public final void setSjcInitial(QuantiteEuro p_sjcInitial)
  {
    jdoSetm_sjcInitial(this, p_sjcInitial);
  }
  
  public final Collection getCollectionSjrActiviteConservee()
  {
    if (jdoGetm_listeSjrActiviteConservee(this) == null) {
      jdoSetm_listeSjrActiviteConservee(this, new ArrayList());
    }
    return jdoGetm_listeSjrActiviteConservee(this);
  }
  
  public final void ajouterSjrActiviteConservee(DomPCSpec p_sjrActiviteConservee)
    throws NullPointerException
  {
    if (p_sjrActiviteConservee == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_sjrActiviteConservee ne devrait pas être nul.", p_sjrActiviteConservee);
    }
    getCollectionSjrActiviteConservee().add(p_sjrActiviteConservee);
  }
  
  public final void supprimerSjrActiviteConservee(DomPCSpec p_sjrActiviteConservee)
    throws NullPointerException
  {
    if (p_sjrActiviteConservee == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_sjrActiviteConservee ne devrait pas être nul.", p_sjrActiviteConservee);
    }
    getCollectionSjrActiviteConservee().remove(p_sjrActiviteConservee);
  }
  
  static
  {
    JDOImplHelper.registerClass(SjcipPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new SjcipPC());
  }
  
  protected static final Damj jdoGetm_dateEvenement(SjcipPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dateEvenement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_dateEvenement;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement);
    }
    return m_dateEvenement;
  }
  
  protected static final QuantiteEuro jdoGetm_plafond(SjcipPC pc)
  {
    if (jdoFlags <= 0) {
      return m_plafond;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_plafond;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_plafond);
    }
    return m_plafond;
  }
  
  protected static final QuantiteEuro jdoGetm_sjcInitial(SjcipPC pc)
  {
    if (jdoFlags <= 0) {
      return m_sjcInitial;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_sjcInitial;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_sjcInitial);
    }
    return m_sjcInitial;
  }
  
  protected static final Collection jdoGetm_listeSjrActiviteConservee(SjcipPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_listeSjrActiviteConservee;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_listeSjrActiviteConservee);
    }
    return m_listeSjrActiviteConservee;
  }
  
  protected static final void jdoSetm_dateEvenement(SjcipPC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_dateEvenement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement, newValue);
    } else {
      m_dateEvenement = newValue;
    }
  }
  
  protected static final void jdoSetm_plafond(SjcipPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_plafond = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_plafond, newValue);
    } else {
      m_plafond = newValue;
    }
  }
  
  protected static final void jdoSetm_sjcInitial(SjcipPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_sjcInitial = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_sjcInitial, newValue);
    } else {
      m_sjcInitial = newValue;
    }
  }
  
  protected static final void jdoSetm_listeSjrActiviteConservee(SjcipPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_listeSjrActiviteConservee, newValue);
    } else {
      m_listeSjrActiviteConservee = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dateEvenement);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_plafond);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_sjcInitial);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listeSjrActiviteConservee);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_dateEvenement = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_plafond = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_sjcInitial = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_listeSjrActiviteConservee = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    SjcipPC pc = new SjcipPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    SjcipPC pc = new SjcipPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 4;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof SjcipPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    SjcipPC other = (SjcipPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_dateEvenement = m_dateEvenement;
        break;
      case 1: 
        m_plafond = m_plafond;
        break;
      case 2: 
        m_sjcInitial = m_sjcInitial;
        break;
      case 3: 
        m_listeSjrActiviteConservee = m_listeSjrActiviteConservee;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     SjcipPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */