package fr.unedic.cali.asu.cge01.p02.migration.graphes;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionActiviteConservee;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionAge;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionChomageTotal;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionCumulPrestationFamiliale;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionMontantNonNul;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionRechercheEmploi;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Decision;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Rejet;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.autresdoms.cohab.dom.CodesErreursMigration;
import fr.unedic.cali.dom.ConditionAttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cohabitation.sigma.migration.dom.DecisionMigreeAsuV1;
import fr.unedic.cohabitation.sigma.migration.dom.DemandeMigreeAsuV1;
import fr.unedic.cohabitation.sigma.migration.dom.DemandeMigreeV1;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import java.util.ArrayList;
import java.util.Collection;

public class GrapheRejet
  extends GrapheDecision
{
  protected void creerCaps(DossierExamen p_dossierExamen)
  {
    ConditionsAttributionAdmission caps = new ConditionsAttributionAdmission();
    
    p_dossierExamen.setConditionsAttributionAdmission(caps);
  }
  
  protected void creerCeps(DossierExamen p_dossierExamen) {}
  
  protected Decision creerDecision(int p_natureDecision)
  {
    Decision nouvelleDecision = null;
    
    nouvelleDecision = new Rejet();
    nouvelleDecision.setNatureDecision(16);
    
    return nouvelleDecision;
  }
  
  protected DossierAffectation creerDossierAffectation()
  {
    DossierAffectation dossierAffectation = new DossierAffecte(1);
    
    return dossierAffectation;
  }
  
  protected ObjectifExamen creerObjectifDecision(DemandeMigreeAsuV1 p_demandeTemporaireSource)
  {
    ObjectifExamen objectifExamen = null;
    
    ProduitAsuSpec produitAsu = (ProduitAsuSpec)Parametres.getProduit(p_demandeTemporaireSource.getCodeProduit());
    
    objectifExamen = (ObjectifExamen)produitAsu.creerObjectifExamen(10, null);
    objectifExamen.setEtat(22);
    
    return objectifExamen;
  }
  
  protected Collection getListRecalcule()
  {
    return new ArrayList();
  }
  
  protected void alimenterValidationProduit(DemandeMigreeAsuV1 p_demandeTemporaireSource, Decision p_decision)
  {
    DecisionMigreeAsuV1 decisionTemporaireSource = p_demandeTemporaireSource.getDecision();
    switch (decisionTemporaireSource.getCodeRejet())
    {
    case 91: 
    case 92: 
    case 93: 
      ((DossierAffectation)p_decision.getDossierAffecte()).setValidationProduit(new ValidationProduit());
      
      super.alimenterValidationProduit(p_demandeTemporaireSource, p_decision);
      break;
    default: 
      ((DossierAffecte)p_decision.getDossierAffecte()).setProduitSecours(Parametres.getProduit(p_demandeTemporaireSource.getCodeProduit()));
    }
  }
  
  protected void alimenterCaps(DecisionMigreeAsuV1 p_decisionTemporaireSource, DossierExamen p_dossierExamen)
  {
    ConditionsAttributionAdmission caps = p_dossierExamen.getConditionsAttributionAdmission();
    ConditionAttributionSpec capEchec = null;
    
    p_dossierExamen.getDemande().setCodeMotifEchecPourSigma(Integer.valueOf(p_decisionTemporaireSource.getCodeRejet()).toString());
    switch (p_decisionTemporaireSource.getCodeRejet())
    {
    case 11: 
      capEchec = new ConditionRechercheEmploi();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionRechercheEmploi((ConditionRechercheEmploi)capEchec);
      break;
    case 21: 
      break;
    case 41: 
    case 42: 
    case 43: 
    case 44: 
    case 45: 
      capEchec = new ConditionFaitGenerateur();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionFaitGenerateur((ConditionFaitGenerateur)capEchec);
      break;
    case 51: 
      capEchec = new ConditionChomageTotal();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionChomageTotal((ConditionChomageTotal)capEchec);
      break;
    case 61: 
    case 62: 
    case 63: 
    case 64: 
    case 625: 
      capEchec = new ConditionAge();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionAge((ConditionAge)capEchec);
      break;
    case 71: 
      capEchec = new ConditionQuantiteAffiliation();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionQuantiteAffiliation((ConditionQuantiteAffiliation)capEchec);
      
      p_dossierExamen.getDemande().setCodeMotifEchecPourSigma(Integer.valueOf(p_decisionTemporaireSource.getCodeRejet()).toString());
      ConditionQuantiteAffiliation capaQteAffi = (ConditionQuantiteAffiliation)capEchec;
      alimenterQuantiteAffiliationEchec(capaQteAffi, p_decisionTemporaireSource);
      break;
    case 91: 
    case 92: 
      capEchec = new ConditionChomageInvolontaire();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionChomageInvolontaire((ConditionChomageInvolontaire)capEchec);
      
      capEchec = new ConditionFaitGenerateur();
      capEchec.setEtatSatisfait(true);
      caps.setConditionFaitGenerateur((ConditionFaitGenerateur)capEchec);
      alimenterConditionFaitGenerateur(p_decisionTemporaireSource, p_dossierExamen);
      
      capEchec = new ConditionQuantiteAffiliation();
      capEchec.setEtatSatisfait(true);
      caps.setConditionQuantiteAffiliation((ConditionQuantiteAffiliation)capEchec);
      
      break;
    case 93: 
      capEchec = new ConditionChomageInvolontaire();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionChomageInvolontaire((ConditionChomageInvolontaire)capEchec);
      
      Demande demande = (Demande)p_dossierExamen.getDemande();
      demande.getDonneesTemporaires().setAvisCommissionParitaire((short)2);
      
      capEchec = new ConditionFaitGenerateur();
      capEchec.setEtatSatisfait(true);
      caps.setConditionFaitGenerateur((ConditionFaitGenerateur)capEchec);
      alimenterConditionFaitGenerateur(p_decisionTemporaireSource, p_dossierExamen);
      
      capEchec = new ConditionQuantiteAffiliation();
      capEchec.setEtatSatisfait(true);
      caps.setConditionQuantiteAffiliation((ConditionQuantiteAffiliation)capEchec);
      
      break;
    case 121: 
    case 122: 
      capEchec = new ConditionActiviteConservee();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionActiviteConservee((ConditionActiviteConservee)capEchec);
      break;
    case 171: 
    case 172: 
      capEchec = new ConditionCumulPrestationFamiliale();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionCumulPrestationFamiliale((ConditionCumulPrestationFamiliale)capEchec);
      break;
    case 181: 
      capEchec = new ConditionMontantNonNul();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(p_decisionTemporaireSource.getCodeRejet());
      caps.setConditionMontantNonNul((ConditionMontantNonNul)capEchec);
      break;
    default: 
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_MOTIF_REJET"));
    }
  }
  
  protected void alimenterQuantiteAffiliationEchec(ConditionQuantiteAffiliation p_conditionQuantiteAffiliation, DecisionMigreeAsuV1 p_decisionTemporaireSource)
  {
    if (p_decisionTemporaireSource.getQteAffiliation1() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_QTE_AFFI_1"));
    }
    if (p_decisionTemporaireSource.getUniteAffiliation1() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_1"));
    }
    if ((p_decisionTemporaireSource.getQteAffiliation1() != null) && (p_decisionTemporaireSource.getUniteAffiliation1() != null))
    {
      Unite uniteAffiliation1 = null;
      try
      {
        uniteAffiliation1 = Unite.getParCode(p_decisionTemporaireSource.getUniteAffiliation1());
      }
      catch (NullPointerException e) {}
      if (uniteAffiliation1 == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_1", p_decisionTemporaireSource.getUniteAffiliation1()));
      } else {
        p_conditionQuantiteAffiliation.setQuantiteAppartenance(new Quantite(p_decisionTemporaireSource.getQteAffiliation1(), uniteAffiliation1));
      }
    }
    if (p_decisionTemporaireSource.getQteAffiliation2() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_QTE_AFFI_2"));
    }
    if (p_decisionTemporaireSource.getUniteAffiliation2() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_UNITE_AFFI_2"));
    }
    if ((p_decisionTemporaireSource.getQteAffiliation2() != null) && (p_decisionTemporaireSource.getUniteAffiliation2() != null))
    {
      Unite uniteAffiliation2 = null;
      try
      {
        uniteAffiliation2 = Unite.getParCode(p_decisionTemporaireSource.getUniteAffiliation2());
      }
      catch (NullPointerException e) {}
      if (uniteAffiliation2 == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_2"));
      } else {
        p_conditionQuantiteAffiliation.setQuantiteAppartenanceSecondaire(new Quantite(p_decisionTemporaireSource.getQteAffiliation2(), uniteAffiliation2));
      }
    }
  }
  
  protected void alimenterCeps(DecisionMigreeAsuV1 p_decisionTemporaireSource, DossierExamen p_dossierExamen) {}
  
  protected void alimenterIdentifiant(DecisionMigreeAsuV1 p_decisionTemporaireSource, Decision p_decisionInstallee) {}
  
  protected void alimenterDonneesImposees(DemandeMigreeV1 p_demandeV1, DemandeSpec p_demande) {}
  
  public DemandeMigreeV1 lireDonnees(DemandeSpec p_demande)
  {
    DemandeMigreeAsuV1 demandeLue = (DemandeMigreeAsuV1)super.lireDonnees(p_demande);
    
    DecisionMigreeAsuV1 decisionLue = demandeLue.getDecision();
    
    Demande demandeAsu = (Demande)p_demande;
    Decision decision = (Decision)demandeAsu.getDossierAffectation().getDossierExamen();
    
    lireValidationProduit(decision, decisionLue);
    
    lireDecision(decision, decisionLue);
    
    lireDonneesSimples(decision, decisionLue);
    
    lireCompetences(decision, decisionLue);
    
    return demandeLue;
  }
  
  protected void lireValidationProduit(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue)
  {
    ProduitSpec produitSpec = ((DossierAffecte)p_decision.getDossierAffecte()).getProduitSecours();
    p_decisionLue.getDemandeMigree().setCodeProduit(produitSpec.getNomUnique());
  }
  
  protected void lireIdentifiant(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue) {}
  
  protected void lireCaps(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue) {}
  
  protected void lireCeps(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue) {}
}

/* Location:
 * Qualified Name:     GrapheRejet
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */