package fr.unedic.cali.asu.cge01.p03.antecedent;

import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsu;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.CalendrierExecutionCalcul;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Poursuite;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;

public class GestionPoursuiteCalcul
  extends GestionAntecedentCalculAsu
{
  public static GestionAntecedentCalculAsuSpec getInstance()
  {
    return new GestionPoursuiteCalcul();
  }
  
  public void alimenterGrapheCalcul(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    AttributionAssuranceSpec poursuite = (AttributionAssuranceSpec)p_attribution;
    SaisieAntecedent saisieAntecedent = ((Poursuite)poursuite).getSaisieAntecedent();
    
    alimenterUtCalculAvant(saisieAntecedent);
    
    alimenterUtCalculPendant(poursuite, saisieAntecedent);
  }
  
  protected void alimenterUtCalculAvant(SaisieAntecedent p_saisieAntecedent)
    throws CoucheLogiqueException
  {
    CalendrierExecutionAvant calendrierAvant = alimenterUtAvant(p_saisieAntecedent);
    if (calendrierAvant.getEtatAuDernierJourAvant().getEtat() == 1) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_POURSUITE_SUR_ANTERIORITE_NON_GEREE");
    }
  }
  
  protected void alimenterUtCalculPendant(AttributionAssuranceSpec p_poursuite, SaisieAntecedent p_saisieAntecedent)
  {
    ((Poursuite)p_poursuite).setUniteTraitement(alimenterUtPendant(p_poursuite, p_saisieAntecedent));
  }
  
  protected fr.unedic.cali.calcul.dom.UniteTraitement alimenterUtPendant(AttributionAssuranceSpec p_poursuite, SaisieAntecedent p_saisieAntecedent)
  {
    fr.unedic.cali.calcul.dom.UniteTraitement utPendant = super.alimenterUtPendant(p_poursuite, p_saisieAntecedent);
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    DureeIndemnisation dureeIndemnisation = new DureeIndemnisation();
    Collection collectionDurees = null;
    ArrayList listeDurees = new ArrayList();
    constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    if (p_saisieAntecedent.getReliquatDuree() != null)
    {
      dureeIndemnisation.setQuantiteCourante(p_saisieAntecedent.getReliquatDuree());
      dureeIndemnisation.setQuantiteInitial(p_saisieAntecedent.getReliquatDuree());
    }
    listeDurees.add(dureeIndemnisation);
    collectionDurees = new ArrayList(listeDurees);
    dureeIndemnisation.setCodeFormuleMontant(constituantsIndemnisation.getCodeFormuleMontant());
    constituantsIndemnisation.setDureeIndemnisation(dureeIndemnisation);
    constituantsIndemnisation.setCollectionQuantiteDroit(collectionDurees);
    utPendant.setConstituantsIndemnisationEnFinUT(constituantsIndemnisation);
    return utPendant;
  }
  
  protected CalendrierExecutionCalculPeriodique instancierCalendrierExecutionCalcul()
  {
    return new CalendrierExecutionCalcul();
  }
  
  protected fr.unedic.cali.calcul.dom.UniteTraitement instancierUniteTraitement(Unite p_uniteParDefautQuantites, Periode p_periode)
  {
    return new fr.unedic.cali.asu.cge01.p03.calcul.dom.UniteTraitement(p_uniteParDefautQuantites, p_periode);
  }
}

/* Location:
 * Qualified Name:     GestionPoursuiteCalcul
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */