package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionElementsAbstrait;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionProduitResultant;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionReglementApplicable;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.pc.ConstitutionElementsAdmissionPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.ApplicativeRuntimeException;

public abstract class ConstitutionElementsAdmissionGen
  extends ConstitutionElementsAbstrait
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAdmissionPC;
  private transient ConstitutionDurees m_constitutionDurees = null;
  private transient ConstitutionSjr m_constitutionSjr = null;
  private transient ConstitutionDelais m_constitutionDelais = null;
  private transient ConstitutionSjc m_constitutionSjc = null;
  private transient ConstitutionQuantiteAffiliation m_constitutionQuantiteAffiliation = null;
  private transient ConstitutionReglementApplicable m_constitutionReglementApplicable = null;
  private transient ConstitutionDateAttribution m_constitutionDateAttribution = null;
  private transient ConstitutionMontantsBruts m_constitutionMontantsBruts = null;
  private transient ConstitutionPointDepartIndemnisation m_constitutionPointDepartIndemnisation = null;
  private transient ConstitutionCaractereSaisonnier m_constitutionCaractereSaisonnier = null;
  private transient ConstitutionCoefficientSaisonnier m_constitutionCoefficientSaisonnier = null;
  private transient ConstitutionCoefficientTempsPartiel m_constitutionCoefficientTempsPartiel = null;
  private transient ConstitutionProduitResultant m_constitutionProduitResultant = null;
  
  public ConstitutionElementsAdmissionGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionElementsAdmissionGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionElementsAdmissionPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAdmissionPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAdmissionPC)
  {
    m_constitutionElementsAdmissionPC = p_constitutionElementsAdmissionPC;
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    if (getConstitutionDurees() != null)
    {
      getConstitutionDurees().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionDurees = null;
    }
    if (getConstitutionSjr() != null)
    {
      getConstitutionSjr().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionSjr = null;
    }
    if (getConstitutionDelais() != null)
    {
      getConstitutionDelais().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionDelais = null;
    }
    if (getConstitutionSjc() != null)
    {
      getConstitutionSjc().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionSjc = null;
    }
    if (getConstitutionQuantiteAffiliation() != null)
    {
      getConstitutionQuantiteAffiliation().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionQuantiteAffiliation = null;
    }
    if (getConstitutionReglementApplicable() != null)
    {
      getConstitutionReglementApplicable().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionReglementApplicable = null;
    }
    if (getConstitutionDateAttribution() != null)
    {
      getConstitutionDateAttribution().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionDateAttribution = null;
    }
    if (getConstitutionMontantsBruts() != null)
    {
      getConstitutionMontantsBruts().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionMontantsBruts = null;
    }
    if (getConstitutionPointDepartIndemnisation() != null)
    {
      getConstitutionPointDepartIndemnisation().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionPointDepartIndemnisation = null;
    }
    if (getConstitutionCaractereSaisonnier() != null)
    {
      getConstitutionCaractereSaisonnier().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionCaractereSaisonnier = null;
    }
    if (getConstitutionCoefficientSaisonnier() != null)
    {
      getConstitutionCoefficientSaisonnier().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionCoefficientSaisonnier = null;
    }
    if (getConstitutionCoefficientTempsPartiel() != null)
    {
      getConstitutionCoefficientTempsPartiel().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionCoefficientTempsPartiel = null;
    }
    if (getConstitutionProduitResultant() != null)
    {
      getConstitutionProduitResultant().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionProduitResultant = null;
    }
  }
  
  public ConstitutionDurees getConstitutionDurees()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionDurees()) && (m_constitutionDurees == null)) {
      m_constitutionDurees = new ConstitutionDurees(getPC(), 0);
    }
    return m_constitutionDurees;
  }
  
  public ConstitutionDurees createConstitutionDurees()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionDurees(true);
    if (m_constitutionDurees == null) {
      m_constitutionDurees = new ConstitutionDurees(getPC(), 0);
    }
    try
    {
      m_constitutionDurees.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionDurees;
  }
  
  public void removeConstitutionDurees()
  {
    try
    {
      m_constitutionDurees.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionDurees(false);
  }
  
  public ConstitutionSjr getConstitutionSjr()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionSjr()) && (m_constitutionSjr == null)) {
      m_constitutionSjr = new ConstitutionSjr(getPC());
    }
    return m_constitutionSjr;
  }
  
  public ConstitutionSjr createConstitutionSjr()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionSjr(true);
    if (m_constitutionSjr == null) {
      m_constitutionSjr = new ConstitutionSjr(getPC());
    }
    try
    {
      m_constitutionSjr.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionSjr;
  }
  
  public void removeConstitutionSjr()
  {
    try
    {
      m_constitutionSjr.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionSjr(false);
  }
  
  public ConstitutionDelais getConstitutionDelais()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionDelais()) && (m_constitutionDelais == null)) {
      m_constitutionDelais = new ConstitutionDelais(getPC());
    }
    return m_constitutionDelais;
  }
  
  public ConstitutionDelais createConstitutionDelais()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionDelais(true);
    if (m_constitutionDelais == null) {
      m_constitutionDelais = new ConstitutionDelais(getPC());
    }
    try
    {
      m_constitutionDelais.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionDelais;
  }
  
  public void removeConstitutionDelais()
  {
    try
    {
      m_constitutionDelais.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionDelais(false);
  }
  
  public ConstitutionSjc getConstitutionSjc()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionSjc()) && (m_constitutionSjc == null)) {
      m_constitutionSjc = new ConstitutionSjc(getPC());
    }
    return m_constitutionSjc;
  }
  
  public ConstitutionSjc createConstitutionSjc()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionSjc(true);
    if (m_constitutionSjc == null) {
      m_constitutionSjc = new ConstitutionSjc(getPC());
    }
    try
    {
      m_constitutionSjc.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionSjc;
  }
  
  public void removeConstitutionSjc()
  {
    try
    {
      m_constitutionSjc.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionSjc(false);
  }
  
  public ConstitutionQuantiteAffiliation getConstitutionQuantiteAffiliation()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionQuantiteAffiliation()) && (m_constitutionQuantiteAffiliation == null)) {
      m_constitutionQuantiteAffiliation = new ConstitutionQuantiteAffiliation(getPC());
    }
    return m_constitutionQuantiteAffiliation;
  }
  
  public ConstitutionQuantiteAffiliation createConstitutionQuantiteAffiliation()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionQuantiteAffiliation(true);
    if (m_constitutionQuantiteAffiliation == null) {
      m_constitutionQuantiteAffiliation = new ConstitutionQuantiteAffiliation(getPC());
    }
    try
    {
      m_constitutionQuantiteAffiliation.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionQuantiteAffiliation;
  }
  
  public void removeConstitutionQuantiteAffiliation()
  {
    try
    {
      m_constitutionQuantiteAffiliation.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionQuantiteAffiliation(false);
  }
  
  public ConstitutionReglementApplicable getConstitutionReglementApplicable()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionReglementApplicable()) && (m_constitutionReglementApplicable == null)) {
      m_constitutionReglementApplicable = new ConstitutionReglementApplicable(getPC());
    }
    return m_constitutionReglementApplicable;
  }
  
  public ConstitutionReglementApplicable createConstitutionReglementApplicable()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionReglementApplicable(true);
    if (m_constitutionReglementApplicable == null) {
      m_constitutionReglementApplicable = new ConstitutionReglementApplicable(getPC());
    }
    try
    {
      m_constitutionReglementApplicable.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionReglementApplicable;
  }
  
  public void removeConstitutionReglementApplicable()
  {
    try
    {
      m_constitutionReglementApplicable.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionReglementApplicable(false);
  }
  
  public ConstitutionDateAttribution getConstitutionDateAttribution()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionDateAttribution()) && (m_constitutionDateAttribution == null)) {
      m_constitutionDateAttribution = new ConstitutionDateAttribution(getPC());
    }
    return m_constitutionDateAttribution;
  }
  
  public ConstitutionDateAttribution createConstitutionDateAttribution()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionDateAttribution(true);
    if (m_constitutionDateAttribution == null) {
      m_constitutionDateAttribution = new ConstitutionDateAttribution(getPC());
    }
    try
    {
      m_constitutionDateAttribution.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionDateAttribution;
  }
  
  public void removeConstitutionDateAttribution()
  {
    try
    {
      m_constitutionDateAttribution.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionDateAttribution(false);
  }
  
  public ConstitutionMontantsBruts getConstitutionMontantsBruts()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionMontantsBruts()) && (m_constitutionMontantsBruts == null)) {
      m_constitutionMontantsBruts = new ConstitutionMontantsBruts(getPC(), 1);
    }
    return m_constitutionMontantsBruts;
  }
  
  public ConstitutionMontantsBruts createConstitutionMontantsBruts()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionMontantsBruts(true);
    if (m_constitutionMontantsBruts == null) {
      m_constitutionMontantsBruts = new ConstitutionMontantsBruts(getPC(), 1);
    }
    try
    {
      m_constitutionMontantsBruts.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionMontantsBruts;
  }
  
  public void removeConstitutionMontantsBruts()
  {
    try
    {
      m_constitutionMontantsBruts.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionMontantsBruts(false);
  }
  
  public ConstitutionPointDepartIndemnisation getConstitutionPointDepartIndemnisation()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionPointDepartIndemnisation()) && (m_constitutionPointDepartIndemnisation == null)) {
      m_constitutionPointDepartIndemnisation = new ConstitutionPointDepartIndemnisation(getPC());
    }
    return m_constitutionPointDepartIndemnisation;
  }
  
  public ConstitutionPointDepartIndemnisation createConstitutionPointDepartIndemnisation()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionPointDepartIndemnisation(true);
    if (m_constitutionPointDepartIndemnisation == null) {
      m_constitutionPointDepartIndemnisation = new ConstitutionPointDepartIndemnisation(getPC());
    }
    try
    {
      m_constitutionPointDepartIndemnisation.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionPointDepartIndemnisation;
  }
  
  public void removeConstitutionPointDepartIndemnisation()
  {
    try
    {
      m_constitutionPointDepartIndemnisation.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionPointDepartIndemnisation(false);
  }
  
  public ConstitutionCaractereSaisonnier getConstitutionCaractereSaisonnier()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionCaractereSaisonnier()) && (m_constitutionCaractereSaisonnier == null)) {
      m_constitutionCaractereSaisonnier = new ConstitutionCaractereSaisonnier(getPC());
    }
    return m_constitutionCaractereSaisonnier;
  }
  
  public ConstitutionCaractereSaisonnier createConstitutionCaractereSaisonnier()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionCaractereSaisonnier(true);
    if (m_constitutionCaractereSaisonnier == null) {
      m_constitutionCaractereSaisonnier = new ConstitutionCaractereSaisonnier(getPC());
    }
    try
    {
      m_constitutionCaractereSaisonnier.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionCaractereSaisonnier;
  }
  
  public void removeConstitutionCaractereSaisonnier()
  {
    try
    {
      m_constitutionCaractereSaisonnier.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionCaractereSaisonnier(false);
  }
  
  public ConstitutionCoefficientSaisonnier getConstitutionCoefficientSaisonnier()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionCoefficientSaisonnier()) && (m_constitutionCoefficientSaisonnier == null)) {
      m_constitutionCoefficientSaisonnier = new ConstitutionCoefficientSaisonnier(getPC());
    }
    return m_constitutionCoefficientSaisonnier;
  }
  
  public ConstitutionCoefficientSaisonnier createConstitutionCoefficientSaisonnier()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionCoefficientSaisonnier(true);
    if (m_constitutionCoefficientSaisonnier == null) {
      m_constitutionCoefficientSaisonnier = new ConstitutionCoefficientSaisonnier(getPC());
    }
    try
    {
      m_constitutionCoefficientSaisonnier.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionCoefficientSaisonnier;
  }
  
  public void removeConstitutionCoefficientSaisonnier()
  {
    try
    {
      m_constitutionCoefficientSaisonnier.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionCoefficientSaisonnier(false);
  }
  
  public ConstitutionCoefficientTempsPartiel getConstitutionCoefficientTempsPartiel()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionCoefficientTempsPartiel()) && (m_constitutionCoefficientTempsPartiel == null)) {
      m_constitutionCoefficientTempsPartiel = new ConstitutionCoefficientTempsPartiel(getPC());
    }
    return m_constitutionCoefficientTempsPartiel;
  }
  
  public ConstitutionCoefficientTempsPartiel createConstitutionCoefficientTempsPartiel()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionCoefficientTempsPartiel(true);
    if (m_constitutionCoefficientTempsPartiel == null) {
      m_constitutionCoefficientTempsPartiel = new ConstitutionCoefficientTempsPartiel(getPC());
    }
    try
    {
      m_constitutionCoefficientTempsPartiel.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionCoefficientTempsPartiel;
  }
  
  public void removeConstitutionCoefficientTempsPartiel()
  {
    try
    {
      m_constitutionCoefficientTempsPartiel.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionCoefficientTempsPartiel(false);
  }
  
  public ConstitutionProduitResultant getConstitutionProduitResultant()
  {
    if ((((ConstitutionElementsAdmissionPC)getPC()).isPresenceDonneesConstitutionProduitResultant()) && (m_constitutionProduitResultant == null)) {
      m_constitutionProduitResultant = new ConstitutionProduitResultant(getPC());
    }
    return m_constitutionProduitResultant;
  }
  
  public ConstitutionProduitResultant createConstitutionProduitResultant()
  {
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionProduitResultant(true);
    if (m_constitutionProduitResultant == null) {
      m_constitutionProduitResultant = new ConstitutionProduitResultant(getPC());
    }
    try
    {
      m_constitutionProduitResultant.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionProduitResultant;
  }
  
  public void removeConstitutionProduitResultant()
  {
    try
    {
      m_constitutionProduitResultant.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsAdmissionPC)getPC()).setPresenceDonneesConstitutionProduitResultant(false);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionElementsAdmissionGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */