package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DureeReglementaire;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class DureeIndemnisationGen
  extends DureeReglementaire
  implements DomGenSpec
{
  public static final int FLAG_CONSTITUTION_PRODUIT_RESULTANT = 0;
  public static final int FLAG_CONSTITUTION_DUREES = 1;
  private Quantite m_dureeTheorique;
  private Quantite m_dureeImputation;
  private Quantite m_quantiteJourImputationForce;
  private Quantite m_quantiteTotalJourImputation;
  private Quantite m_dureePostPrimeCspConstitutionDurees;
  private Integer m_dureeImputationPostPrime;
  
  public DureeIndemnisationGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DureeIndemnisationGen() {}
  
  protected Quantite rawGetDureeTheorique()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeTheoriqueConstitutionDurees();
  }
  
  public Quantite getDureeTheorique()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeTheoriqueConstitutionDurees();
  }
  
  public void setDureeTheorique(Quantite p_dureeTheorique)
  {
    if ((m_dureeTheorique == null) || (p_dureeTheorique == null))
    {
      m_dureeTheorique = p_dureeTheorique;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeTheoriqueConstitutionDurees(p_dureeTheorique);
    }
    else if ((m_dureeTheorique != null) && (p_dureeTheorique != null) && (!p_dureeTheorique.equals(m_dureeTheorique)))
    {
      m_dureeTheorique = p_dureeTheorique;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeTheoriqueConstitutionDurees(p_dureeTheorique);
    }
  }
  
  protected Quantite rawGetDureeImputation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeImputationConstitutionDurees();
  }
  
  public Quantite getDureeImputation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeImputationConstitutionDurees();
  }
  
  public void setDureeImputation(Quantite p_dureeImputation)
  {
    if ((m_dureeImputation == null) || (p_dureeImputation == null))
    {
      m_dureeImputation = p_dureeImputation;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeImputationConstitutionDurees(p_dureeImputation);
    }
    else if ((m_dureeImputation != null) && (p_dureeImputation != null) && (!p_dureeImputation.equals(m_dureeImputation)))
    {
      m_dureeImputation = p_dureeImputation;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeImputationConstitutionDurees(p_dureeImputation);
    }
  }
  
  protected Quantite rawGetQuantiteJourImputationForce()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteJourImputationForceConstitutionDurees();
  }
  
  public Quantite getQuantiteJourImputationForce()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteJourImputationForceConstitutionDurees();
  }
  
  public void setQuantiteJourImputationForce(Quantite p_quantiteJourImputationForce)
  {
    if ((m_quantiteJourImputationForce == null) || (p_quantiteJourImputationForce == null))
    {
      m_quantiteJourImputationForce = p_quantiteJourImputationForce;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteJourImputationForceConstitutionDurees(p_quantiteJourImputationForce);
    }
    else if ((m_quantiteJourImputationForce != null) && (p_quantiteJourImputationForce != null) && (!p_quantiteJourImputationForce.equals(m_quantiteJourImputationForce)))
    {
      m_quantiteJourImputationForce = p_quantiteJourImputationForce;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteJourImputationForceConstitutionDurees(p_quantiteJourImputationForce);
    }
  }
  
  protected Quantite rawGetQuantiteTotalJourImputation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteTotalJourImputationConstitutionDurees();
  }
  
  public Quantite getQuantiteTotalJourImputation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteTotalJourImputationConstitutionDurees();
  }
  
  public void setQuantiteTotalJourImputation(Quantite p_quantiteTotalJourImputation)
  {
    if ((m_quantiteTotalJourImputation == null) || (p_quantiteTotalJourImputation == null))
    {
      m_quantiteTotalJourImputation = p_quantiteTotalJourImputation;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteTotalJourImputationConstitutionDurees(p_quantiteTotalJourImputation);
    }
    else if ((m_quantiteTotalJourImputation != null) && (p_quantiteTotalJourImputation != null) && (!p_quantiteTotalJourImputation.equals(m_quantiteTotalJourImputation)))
    {
      m_quantiteTotalJourImputation = p_quantiteTotalJourImputation;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteTotalJourImputationConstitutionDurees(p_quantiteTotalJourImputation);
    }
  }
  
  protected Quantite rawGetDureePostPrimeCspConstitutionDurees()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureePostPrimeCspConstitutionDurees();
  }
  
  public Quantite getDureePostPrimeCspConstitutionDurees()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureePostPrimeCspConstitutionDurees();
  }
  
  public void setDureePostPrimeCspConstitutionDurees(Quantite p_dureePostPrimeCspConstitutionDurees)
  {
    if ((m_dureePostPrimeCspConstitutionDurees == null) || (p_dureePostPrimeCspConstitutionDurees == null))
    {
      m_dureePostPrimeCspConstitutionDurees = p_dureePostPrimeCspConstitutionDurees;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureePostPrimeCspConstitutionDurees(p_dureePostPrimeCspConstitutionDurees);
    }
    else if ((m_dureePostPrimeCspConstitutionDurees != null) && (p_dureePostPrimeCspConstitutionDurees != null) && (!p_dureePostPrimeCspConstitutionDurees.equals(m_dureePostPrimeCspConstitutionDurees)))
    {
      m_dureePostPrimeCspConstitutionDurees = p_dureePostPrimeCspConstitutionDurees;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureePostPrimeCspConstitutionDurees(p_dureePostPrimeCspConstitutionDurees);
    }
  }
  
  protected Integer rawGetDureeImputationPostPrime()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeImputationPostPrime();
  }
  
  public Integer getDureeImputationPostPrime()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeImputationPostPrime();
  }
  
  public void setDureeImputationPostPrime(Integer p_dureeImputationPostPrime)
  {
    if ((m_dureeImputationPostPrime == null) || (p_dureeImputationPostPrime == null))
    {
      m_dureeImputationPostPrime = p_dureeImputationPostPrime;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeImputationPostPrime(p_dureeImputationPostPrime);
    }
    else if ((m_dureeImputationPostPrime != null) && (p_dureeImputationPostPrime != null) && (!p_dureeImputationPostPrime.equals(m_dureeImputationPostPrime)))
    {
      m_dureeImputationPostPrime = p_dureeImputationPostPrime;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeImputationPostPrime(p_dureeImputationPostPrime);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    super.initEnProfondeur();
    
    setDureeTheorique(null);
    setDureeImputation(null);
    setQuantiteJourImputationForce(null);
    setQuantiteTotalJourImputation(null);
    setDureePostPrimeCspConstitutionDurees(null);
    setDureeImputationPostPrime(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     DureeIndemnisationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */