package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;

public abstract class JustificationSrGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private BigDecimal m_salaireReferenceNonPlafonne;
  private BigDecimal m_totalPrimesExceptionnellesRetenues;
  private BigDecimal m_totalPrimesNormalesRetenues;
  private BigDecimal m_totalSalairesRetenus;
  
  public JustificationSrGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public JustificationSrGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected BigDecimal rawGetSalaireReferenceNonPlafonne()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSalaireReferenceNonPlafonneConstitutionSjr();
  }
  
  public BigDecimal getSalaireReferenceNonPlafonne()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSalaireReferenceNonPlafonneConstitutionSjr();
  }
  
  public void setSalaireReferenceNonPlafonne(BigDecimal p_salaireReferenceNonPlafonne)
  {
    if ((m_salaireReferenceNonPlafonne == null) || (p_salaireReferenceNonPlafonne == null))
    {
      m_salaireReferenceNonPlafonne = p_salaireReferenceNonPlafonne;
      ((ConstitutionElementsAbstraitPC)getPC()).setSalaireReferenceNonPlafonneConstitutionSjr(p_salaireReferenceNonPlafonne);
    }
    else if ((m_salaireReferenceNonPlafonne != null) && (p_salaireReferenceNonPlafonne != null) && (!p_salaireReferenceNonPlafonne.equals(m_salaireReferenceNonPlafonne)))
    {
      m_salaireReferenceNonPlafonne = p_salaireReferenceNonPlafonne;
      ((ConstitutionElementsAbstraitPC)getPC()).setSalaireReferenceNonPlafonneConstitutionSjr(p_salaireReferenceNonPlafonne);
    }
  }
  
  protected BigDecimal rawGetTotalPrimesExceptionnellesRetenues()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTotalPrimesExceptionnellesRetenuesConstitutionSjr();
  }
  
  public BigDecimal getTotalPrimesExceptionnellesRetenues()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTotalPrimesExceptionnellesRetenuesConstitutionSjr();
  }
  
  public void setTotalPrimesExceptionnellesRetenues(BigDecimal p_totalPrimesExceptionnellesRetenues)
  {
    if ((m_totalPrimesExceptionnellesRetenues == null) || (p_totalPrimesExceptionnellesRetenues == null))
    {
      m_totalPrimesExceptionnellesRetenues = p_totalPrimesExceptionnellesRetenues;
      ((ConstitutionElementsAbstraitPC)getPC()).setTotalPrimesExceptionnellesRetenuesConstitutionSjr(p_totalPrimesExceptionnellesRetenues);
    }
    else if ((m_totalPrimesExceptionnellesRetenues != null) && (p_totalPrimesExceptionnellesRetenues != null) && (!p_totalPrimesExceptionnellesRetenues.equals(m_totalPrimesExceptionnellesRetenues)))
    {
      m_totalPrimesExceptionnellesRetenues = p_totalPrimesExceptionnellesRetenues;
      ((ConstitutionElementsAbstraitPC)getPC()).setTotalPrimesExceptionnellesRetenuesConstitutionSjr(p_totalPrimesExceptionnellesRetenues);
    }
  }
  
  protected BigDecimal rawGetTotalPrimesNormalesRetenues()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTotalPrimesNormalesRetenuesConstitutionSjr();
  }
  
  public BigDecimal getTotalPrimesNormalesRetenues()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTotalPrimesNormalesRetenuesConstitutionSjr();
  }
  
  public void setTotalPrimesNormalesRetenues(BigDecimal p_totalPrimesNormalesRetenues)
  {
    if ((m_totalPrimesNormalesRetenues == null) || (p_totalPrimesNormalesRetenues == null))
    {
      m_totalPrimesNormalesRetenues = p_totalPrimesNormalesRetenues;
      ((ConstitutionElementsAbstraitPC)getPC()).setTotalPrimesNormalesRetenuesConstitutionSjr(p_totalPrimesNormalesRetenues);
    }
    else if ((m_totalPrimesNormalesRetenues != null) && (p_totalPrimesNormalesRetenues != null) && (!p_totalPrimesNormalesRetenues.equals(m_totalPrimesNormalesRetenues)))
    {
      m_totalPrimesNormalesRetenues = p_totalPrimesNormalesRetenues;
      ((ConstitutionElementsAbstraitPC)getPC()).setTotalPrimesNormalesRetenuesConstitutionSjr(p_totalPrimesNormalesRetenues);
    }
  }
  
  protected BigDecimal rawGetTotalSalairesRetenus()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTotalSalairesRetenusConstitutionSjr();
  }
  
  public BigDecimal getTotalSalairesRetenus()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTotalSalairesRetenusConstitutionSjr();
  }
  
  public void setTotalSalairesRetenus(BigDecimal p_totalSalairesRetenus)
  {
    if ((m_totalSalairesRetenus == null) || (p_totalSalairesRetenus == null))
    {
      m_totalSalairesRetenus = p_totalSalairesRetenus;
      ((ConstitutionElementsAbstraitPC)getPC()).setTotalSalairesRetenusConstitutionSjr(p_totalSalairesRetenus);
    }
    else if ((m_totalSalairesRetenus != null) && (p_totalSalairesRetenus != null) && (!p_totalSalairesRetenus.equals(m_totalSalairesRetenus)))
    {
      m_totalSalairesRetenus = p_totalSalairesRetenus;
      ((ConstitutionElementsAbstraitPC)getPC()).setTotalSalairesRetenusConstitutionSjr(p_totalSalairesRetenus);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setSalaireReferenceNonPlafonne(null);
    setTotalPrimesExceptionnellesRetenues(null);
    setTotalPrimesNormalesRetenues(null);
    setTotalSalairesRetenus(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     JustificationSrGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */