package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.EnsembleCarences;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.pc.PreavisMesureConservatoireIndemnisablePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public abstract class PreavisMesureConservatoireIndemnisableGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_preavisMesureConservatoireIndemnisablePC;
  private String m_identifiantPeriodeOrigine = null;
  private Periode m_periodeApplicationPMC = null;
  private Quantite m_quantiteInitial;
  private Damj m_dateFinPeriodeOrigine;
  private EnsembleCarences m_ensembleCarences;
  
  public PreavisMesureConservatoireIndemnisableGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public PreavisMesureConservatoireIndemnisableGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new PreavisMesureConservatoireIndemnisablePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_preavisMesureConservatoireIndemnisablePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_preavisMesureConservatoireIndemnisablePC)
  {
    m_preavisMesureConservatoireIndemnisablePC = p_preavisMesureConservatoireIndemnisablePC;
  }
  
  protected String rawGetIdentifiantPeriodeOrigine()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getIdentifiantPeriodeOrigine();
  }
  
  public String getIdentifiantPeriodeOrigine()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getIdentifiantPeriodeOrigine();
  }
  
  public void setIdentifiantPeriodeOrigine(String p_identifiantPeriodeOrigine)
  {
    if ((m_identifiantPeriodeOrigine == null) || (p_identifiantPeriodeOrigine == null))
    {
      m_identifiantPeriodeOrigine = p_identifiantPeriodeOrigine;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setIdentifiantPeriodeOrigine(p_identifiantPeriodeOrigine);
    }
    else if ((m_identifiantPeriodeOrigine != null) && (p_identifiantPeriodeOrigine != null) && (!p_identifiantPeriodeOrigine.equals(m_identifiantPeriodeOrigine)))
    {
      m_identifiantPeriodeOrigine = p_identifiantPeriodeOrigine;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setIdentifiantPeriodeOrigine(p_identifiantPeriodeOrigine);
    }
  }
  
  protected Periode rawGetPeriodeApplicationPMC()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getPeriodeApplicationPMC();
  }
  
  public Periode getPeriodeApplicationPMC()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getPeriodeApplicationPMC();
  }
  
  public void setPeriodeApplicationPMC(Periode p_periodeApplicationPMC)
  {
    if ((m_periodeApplicationPMC == null) || (p_periodeApplicationPMC == null))
    {
      m_periodeApplicationPMC = p_periodeApplicationPMC;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setPeriodeApplicationPMC(p_periodeApplicationPMC);
    }
    else if ((m_periodeApplicationPMC != null) && (p_periodeApplicationPMC != null) && (!p_periodeApplicationPMC.equals(m_periodeApplicationPMC)))
    {
      m_periodeApplicationPMC = p_periodeApplicationPMC;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setPeriodeApplicationPMC(p_periodeApplicationPMC);
    }
  }
  
  protected Quantite rawGetQuantiteInitial()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getQuantiteInitial();
  }
  
  public Quantite getQuantiteInitial()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getQuantiteInitial();
  }
  
  public void setQuantiteInitial(Quantite p_quantiteInitial)
  {
    if ((m_quantiteInitial == null) || (p_quantiteInitial == null))
    {
      m_quantiteInitial = p_quantiteInitial;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setQuantiteInitial(p_quantiteInitial);
    }
    else if ((m_quantiteInitial != null) && (p_quantiteInitial != null) && (!p_quantiteInitial.equals(m_quantiteInitial)))
    {
      m_quantiteInitial = p_quantiteInitial;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setQuantiteInitial(p_quantiteInitial);
    }
  }
  
  protected Damj rawGetDateFinPeriodeOrigine()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getDateFinPeriodeOrigine();
  }
  
  public Damj getDateFinPeriodeOrigine()
  {
    return ((PreavisMesureConservatoireIndemnisablePC)getPC()).getDateFinPeriodeOrigine();
  }
  
  public void setDateFinPeriodeOrigine(Damj p_dateFinPeriodeOrigine)
  {
    if ((m_dateFinPeriodeOrigine == null) || (p_dateFinPeriodeOrigine == null))
    {
      m_dateFinPeriodeOrigine = p_dateFinPeriodeOrigine;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setDateFinPeriodeOrigine(p_dateFinPeriodeOrigine);
    }
    else if ((m_dateFinPeriodeOrigine != null) && (p_dateFinPeriodeOrigine != null) && (!p_dateFinPeriodeOrigine.equals(m_dateFinPeriodeOrigine)))
    {
      m_dateFinPeriodeOrigine = p_dateFinPeriodeOrigine;
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setDateFinPeriodeOrigine(p_dateFinPeriodeOrigine);
    }
  }
  
  public EnsembleCarences getEnsembleCarences()
  {
    if (m_ensembleCarences == null)
    {
      DomPCSpec ensembleCarencesPC = ((PreavisMesureConservatoireIndemnisablePC)getPC()).getEnsembleCarences();
      if (ensembleCarencesPC != null) {
        m_ensembleCarences = ((EnsembleCarences)ensembleCarencesPC.createOM());
      }
    }
    return m_ensembleCarences;
  }
  
  public void setEnsembleCarences(EnsembleCarences p_ensembleCarences)
  {
    if (p_ensembleCarences == null)
    {
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setEnsembleCarences(null);
      m_ensembleCarences = p_ensembleCarences;
    }
    else if (!p_ensembleCarences.equals(m_ensembleCarences))
    {
      ((PreavisMesureConservatoireIndemnisablePC)getPC()).setEnsembleCarences(p_ensembleCarences.getPC());
      m_ensembleCarences = p_ensembleCarences;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     PreavisMesureConservatoireIndemnisableGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */