package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.CodesMotifsEchec;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionsAttributionReprise;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionsAttributionRevision;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Decision;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Rejet;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Reprise;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Revision;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjcip;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.CompetenceSpec;
import fr.unedic.cali.asu.dom.DecisionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.Metier;
import fr.unedic.cali.autresdoms.ga.dom.spec.ConstantesRegimeRetraite;
import fr.unedic.cali.dom.ComparateurDecisionSpec;
import fr.unedic.cali.dom.ConditionAttributionSpec;
import fr.unedic.cali.dom.DecisionSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.ElementDroitSpec;
import fr.unedic.cali.dom.NaturesDecisions;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ComparateurDecision
  extends fr.unedic.cali.asu.liquidation.outilsfonctionnels.ComparateurDecision
  implements ComparateurDecisionSpec, OutilFonctionnel
{
  public static boolean estEgal(DecisionSpec decisionAvant, DecisionSpec decisionApres)
  {
    boolean estEgal = false;
    if ((decisionAvant != null) && (decisionApres != null)) {
      estEgal = (produitEgal(decisionAvant, decisionApres)) && (decisionEgal((Decision)decisionAvant, (Decision)decisionApres)) && (revisionsPossedeAttributionPrecedente((Decision)decisionAvant, (Decision)decisionApres)) && (reprise1PossedeAttributionPrecedente((Decision)decisionAvant, (Decision)decisionApres)) && (dureeEffectiveEgale((Decision)decisionAvant, (Decision)decisionApres)) && (pjiEgal((Decision)decisionAvant, (Decision)decisionApres)) && (reglementEgal((Decision)decisionAvant, (Decision)decisionApres)) && (motifRejetEgal((Decision)decisionAvant, (Decision)decisionApres)) && (montantBrutEgal((Decision)decisionAvant, (Decision)decisionApres)) && (sjrEgal((Decision)decisionAvant, (Decision)decisionApres)) && (sjcEgal((Decision)decisionAvant, (Decision)decisionApres)) && (coefSaisonnierEgal((Decision)decisionAvant, (Decision)decisionApres)) && (coefTempsPartielEgal((Decision)decisionAvant, (Decision)decisionApres)) && (dateAttributionEgal((Decision)decisionAvant, (Decision)decisionApres)) && (topAlsaceMoselleEgal((Decision)decisionAvant, (Decision)decisionApres)) && (regimeSecuEgal((Decision)decisionAvant, (Decision)decisionApres)) && (competenceAdministrativeEgale((Decision)decisionAvant, (Decision)decisionApres)) && (dureePostPrimeEgale((DecisionAssuranceSpec)decisionAvant, (DecisionAssuranceSpec)decisionApres)) && (dateLimiteIndemnisationEgale(decisionAvant, decisionApres));
    }
    return estEgal;
  }
  
  private static boolean produitEgal(DecisionSpec decision1, DecisionSpec decision2)
  {
    boolean estEgal = false;
    if ((decision1 != null) && (decision2 != null)) {
      estEgal = decision1.getDossierAffecte().getProduit().getNomUnique().equals(decision2.getDossierAffecte().getProduit().getNomUnique());
    }
    return estEgal;
  }
  
  private static boolean revisionsPossedeAttributionPrecedente(DecisionSpec decision1, DecisionSpec decision2)
  {
    boolean possede = false;
    if (((decision1 != null) && ((decision1 instanceof Revision))) || ((decision2 != null) && ((decision2 instanceof Revision))))
    {
      if ((((Demande)decision1.getDemande()).getDemandeOrigine().getAttribution() != null) && (((Demande)decision2.getDemande()).getDemandeOrigine().getAttribution() != null)) {
        possede = true;
      } else {
        possede = false;
      }
    }
    else {
      possede = true;
    }
    return possede;
  }
  
  private static boolean reprise1PossedeAttributionPrecedente(DecisionSpec decision1, DecisionSpec decision2)
  {
    boolean possede = false;
    if ((decision1 != null) && ((decision1 instanceof Reprise)) && (decision2 != null) && ((decision2 instanceof Reprise)))
    {
      if ((((Demande)decision1.getDemande()).getDemandeOrigine().getAttribution() != null) && (((Demande)decision2.getDemande()).getDemandeOrigine().getAttribution() != null)) {
        possede = true;
      } else {
        possede = false;
      }
    }
    else {
      possede = true;
    }
    return possede;
  }
  
  private static boolean dureeEffectiveEgale(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      Quantite dureeInitialDecision1 = ((AttributionAssuranceSpec)decision1).getDureeIndemnisationEffective();
      
      Quantite dureeInitialDecision2 = ((AttributionAssuranceSpec)decision2).getDureeIndemnisationEffective();
      
      return dureeInitialDecision1.equals(dureeInitialDecision2);
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean pjiEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      Attribution attributionDecision1 = (Attribution)decision1;
      Attribution attributionDecision2 = (Attribution)decision2;
      
      return attributionDecision1.getConstitutionPointDepartIndemnisation().getPji().equals(attributionDecision2.getConstitutionPointDepartIndemnisation().getPji());
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean reglementEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution))) {
      return decision1.getReglementApplicable().getReglement().estNomReglementIdentique(decision2.getReglementApplicable().getReglement().getNomReglement());
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean motifRejetEgal(Decision decision1, Decision decision2)
  {
    int typeObjectifDecision1 = getTypeObjectifParDecision(decision1);
    int typeObjectifDecision2 = getTypeObjectifParDecision(decision2);
    List listElementDroitDecision1 = null;
    List listElementDroitDecision2 = null;
    if (((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet)))
    {
      if (typeObjectifDecision1 != typeObjectifDecision2) {
        return false;
      }
      DossierExamen dossierExamenDecision1 = getDossierExamenParDecision(decision1);
      DossierExamen dossierExamenDecision2 = getDossierExamenParDecision(decision2);
      if ((typeObjectifDecision1 == 2) || (typeObjectifDecision1 == 5) || (typeObjectifDecision1 == 6))
      {
        listElementDroitDecision1 = dossierExamenDecision1.getConditionsAttributionReprise().getListeConditionsAttribution();
        listElementDroitDecision2 = dossierExamenDecision2.getConditionsAttributionReprise().getListeConditionsAttribution();
      }
      else if (typeObjectifDecision1 == 1)
      {
        listElementDroitDecision1 = dossierExamenDecision1.getConditionsAttributionAdmission().getListeConditionsAttribution();
        listElementDroitDecision2 = dossierExamenDecision2.getConditionsAttributionAdmission().getListeConditionsAttribution();
      }
      else if (typeObjectifDecision1 == 4)
      {
        DossierExamen revision1 = dossierExamenDecision1;
        listElementDroitDecision1 = revision1.getConditionsAttributionRevision().getListeConditionsAttribution();
        DossierExamen revision2 = dossierExamenDecision2;
        listElementDroitDecision2 = revision2.getConditionsAttributionRevision().getListeConditionsAttribution();
      }
      return compareCodeMotifEchecParDecision(listElementDroitDecision1, listElementDroitDecision2);
    }
    return ((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution));
  }
  
  private static boolean montantBrutEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      Quantite montantBrutIndemnisationDecision1 = decision1.getConstitutionMontantsBruts() != null ? decision1.getConstitutionMontantsBruts().getMontantJournalierBrut() : null;
      
      Quantite montantBrutIndemnisationDecision2 = decision2.getConstitutionMontantsBruts() != null ? decision2.getConstitutionMontantsBruts().getMontantJournalierBrut() : null;
      
      return montantBrutIndemnisationDecision1.equals(montantBrutIndemnisationDecision2);
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean sjrEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      BigDecimal sjrAvant = null;
      BigDecimal sjrApres = null;
      
      Sjrip sjrpDecision1 = decision1.getConstitutionSjr() != null ? decision1.getConstitutionSjr().getSjrip() : null;
      Sjrip sjrpDecision2 = decision2.getConstitutionSjr() != null ? decision2.getConstitutionSjr().getSjrip() : null;
      
      sjrAvant = sjrpDecision1.getSjrip();
      sjrApres = sjrpDecision2.getSjrip();
      return sjrAvant.compareTo(sjrApres) == 0;
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean competenceAdministrativeEgale(Decision decision1, Decision decision2)
  {
    CompetenceSpec competenceAvant = decision1.getCompetence();
    CompetenceSpec competenceApres = decision2.getCompetence();
    if (((competenceAvant != null) && (competenceApres == null)) || ((competenceAvant == null) && (competenceApres != null))) {
      return false;
    }
    if ((competenceAvant != null) && (competenceApres != null)) {
      return competenceAvant.getCompetenceAdministrative() == competenceApres.getCompetenceAdministrative();
    }
    return true;
  }
  
  private static boolean sjcEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      BigDecimal sjcAvant = null;
      BigDecimal sjcApres = null;
      
      Sjcip sjcpDecision1 = decision1.getConstitutionSjc() != null ? decision1.getConstitutionSjc().getSjcip() : null;
      Sjcip sjcpDecision2 = decision2.getConstitutionSjc() != null ? decision2.getConstitutionSjc().getSjcip() : null;
      if (sjcpDecision1 != null) {
        sjcAvant = sjcpDecision1.getSjcip();
      }
      if (sjcpDecision2 != null) {
        sjcApres = sjcpDecision2.getSjcip();
      }
      if (sjcAvant == null) {
        return (sjcApres == null) || (sjcApres.doubleValue() == 0.0D);
      }
      if (sjcApres == null) {
        return false;
      }
      return sjcAvant.compareTo(sjcApres) == 0;
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean coefSaisonnierEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      ConstitutionCoefficientSaisonnier constitutionCoefficientSaisonnierDecision1 = getDossierExamenParDecision(decision1).getConstitutionCoefficientSaisonnier();
      
      ConstitutionCoefficientSaisonnier constitutionCoefficientSaisonnierDecision2 = getDossierExamenParDecision(decision2).getConstitutionCoefficientSaisonnier();
      
      BigDecimal coefficientSaisonnierDemande1 = null;
      BigDecimal coefficientSaisonnierDemande2 = null;
      if (constitutionCoefficientSaisonnierDecision1 != null) {
        coefficientSaisonnierDemande1 = constitutionCoefficientSaisonnierDecision1.getCoefficientSaisonnierRetenu();
      }
      if (constitutionCoefficientSaisonnierDecision2 != null) {
        coefficientSaisonnierDemande2 = constitutionCoefficientSaisonnierDecision2.getCoefficientSaisonnierRetenu();
      }
      return coefficientsEgaux(coefficientSaisonnierDemande1, coefficientSaisonnierDemande2);
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean coefTempsPartielEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      BigDecimal coefficientTempsPartielDemande1 = getDossierExamenParDecision(decision1).getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu();
      
      BigDecimal coefficientTempsPartielDemande2 = getDossierExamenParDecision(decision2).getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu();
      
      return coefficientsEgaux(coefficientTempsPartielDemande1, coefficientTempsPartielDemande2);
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean dateAttributionEgal(Decision decision1, Decision decision2)
  {
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution))) {
      return decision1.getDateAttribution().equals(decision2.getDateAttribution());
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean topAlsaceMoselleEgal(Decision decision1, Decision decision2)
  {
    boolean estAlsaceMoselleAvant = false;
    boolean estAlsaceMoselleApres = false;
    ValidationProduit validationProduitAvant = null;
    ValidationProduit validationProduitApres = null;
    ActiviteSalarie periodeValidationProduitAvant = null;
    ActiviteSalarie periodeValidationProduitApres = null;
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      if ((decision1 instanceof Reprise))
      {
        OdSpec odOrigineAvant = ((AttributionAssuranceSpec)decision1).getOuvertureDroit();
        if (odOrigineAvant != null) {
          validationProduitAvant = ((DossierAffectation)odOrigineAvant.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitAvant = ((DossierAffectation)decision1.getDossierAffecte()).getValidationProduit();
      }
      if ((decision2 instanceof Reprise))
      {
        OdSpec odOrigineApres = ((AttributionAssuranceSpec)decision2).getOuvertureDroit();
        if (odOrigineApres != null) {
          validationProduitApres = ((DossierAffectation)odOrigineApres.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitApres = ((DossierAffectation)decision2.getDossierAffecte()).getValidationProduit();
      }
      if ((validationProduitAvant != null) && (validationProduitAvant.isEstProduitValide()))
      {
        periodeValidationProduitAvant = validationProduitAvant.getPeriodeValidationProduit();
        if (periodeValidationProduitAvant != null) {
          estAlsaceMoselleAvant = periodeValidationProduitAvant.isRegimeAlsaceMoselle();
        }
      }
      if ((validationProduitApres != null) && (validationProduitApres.isEstProduitValide()))
      {
        periodeValidationProduitApres = validationProduitApres.getPeriodeValidationProduit();
        if (periodeValidationProduitApres != null) {
          estAlsaceMoselleApres = periodeValidationProduitApres.isRegimeAlsaceMoselle();
        }
      }
      return estAlsaceMoselleAvant == estAlsaceMoselleApres;
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static boolean regimeSecuEgal(Decision decision1, Decision decision2)
  {
    int regimeSecuAvant = 0;
    int regimeSecuApres = 0;
    ValidationProduit validationProduitAvant = null;
    ValidationProduit validationProduitApres = null;
    ActiviteSalarie periodeValidationProduitAvant = null;
    ActiviteSalarie periodeValidationProduitApres = null;
    if (((decision1 instanceof Attribution)) && ((decision2 instanceof Attribution)))
    {
      if ((decision1 instanceof Reprise))
      {
        OdSpec odOrigineAvant = ((AttributionAssuranceSpec)decision1).getOuvertureDroit();
        if (odOrigineAvant != null) {
          validationProduitAvant = ((DossierAffectation)odOrigineAvant.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitAvant = ((DossierAffectation)decision1.getDossierAffecte()).getValidationProduit();
      }
      if ((decision2 instanceof Reprise))
      {
        OdSpec odOrigineApres = ((AttributionAssuranceSpec)decision2).getOuvertureDroit();
        if (odOrigineApres != null) {
          validationProduitApres = ((DossierAffectation)odOrigineApres.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitApres = ((DossierAffectation)decision2.getDossierAffecte()).getValidationProduit();
      }
      if ((validationProduitAvant != null) && (validationProduitAvant.isEstProduitValide()))
      {
        periodeValidationProduitAvant = validationProduitAvant.getPeriodeValidationProduit();
        if (periodeValidationProduitAvant != null) {
          regimeSecuAvant = periodeValidationProduitAvant.getMetier().getRegimeSecu();
        }
      }
      if ((validationProduitApres != null) && (validationProduitApres.isEstProduitValide()))
      {
        periodeValidationProduitApres = validationProduitApres.getPeriodeValidationProduit();
        if (periodeValidationProduitApres != null) {
          regimeSecuApres = periodeValidationProduitApres.getMetier().getRegimeSecu();
        }
      }
      return regimeSecuAvant == regimeSecuApres;
    }
    return ((decision1 instanceof Rejet)) && ((decision2 instanceof Rejet));
  }
  
  private static DossierExamen getDossierExamenParDecision(Decision decision)
  {
    Demande demandeDecision = (Demande)decision.getDemande();
    return (DossierExamen)demandeDecision.getDossierExamen();
  }
  
  private static int getTypeObjectifParDecision(Decision decision)
  {
    DossierExamen dossierExamenDecision = getDossierExamenParDecision(decision);
    Demande demande = (Demande)dossierExamenDecision.getDemande();
    return demande.getObjectifDecisionne().getType();
  }
  
  private static boolean compareCodeMotifEchecParDecision(List listElementDroitDecision1, List listElementDroitDecision2)
  {
    Iterator itConditionAttributionDecision1 = listElementDroitDecision1.iterator();
    Iterator itConditionAttributionDecision2 = listElementDroitDecision2.iterator();
    boolean estEgal = true;
    do
    {
      ElementDroitSpec elementDroitDecision1 = (ElementDroitSpec)itConditionAttributionDecision1.next();
      ElementDroitSpec elementDroitDecision2 = (ElementDroitSpec)itConditionAttributionDecision2.next();
      if ((elementDroitDecision1 != null) && (elementDroitDecision2 != null) && (elementDroitDecision1.getCodeMotifEchec() != elementDroitDecision2.getCodeMotifEchec())) {
        estEgal = false;
      }
    } while ((itConditionAttributionDecision1.hasNext()) && (estEgal));
    return estEgal;
  }
  
  public static ArrayList rechercheDifferencesComparaisonDecision(DecisionSpec decision1, DecisionSpec decision2)
  {
    ArrayList listeDifferences = new ArrayList();
    if (!estEgal(decision1, decision2)) {
      if (produitEgal(decision1, decision2))
      {
        boolean revisionsPossedeAttributionPrecedente = revisionsPossedeAttributionPrecedente(decision1, decision2);
        boolean reprise1PossedeAttributionPrecedente = reprise1PossedeAttributionPrecedente(decision1, decision2);
        if (decisionEgal(decision1, decision2))
        {
          if ((reprise1PossedeAttributionPrecedente) && (revisionsPossedeAttributionPrecedente))
          {
            Decision decisionAvant = (Decision)decision1;
            Decision decisionApres = (Decision)decision2;
            if (!dureeEffectiveEgale(decisionAvant, decisionApres)) {
              alimenterDureeComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!pjiEgal(decisionAvant, decisionApres)) {
              alimenterPjiComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!reglementEgal(decisionAvant, decisionApres)) {
              alimenterReglementComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!motifRejetEgal(decisionAvant, decisionApres)) {
              alimenterMotifsRejetComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!montantBrutEgal(decisionAvant, decisionApres)) {
              alimenterMontantComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!sjrEgal(decisionAvant, decisionApres)) {
              alimenterSjrComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!sjcEgal(decisionAvant, decisionApres)) {
              alimenterSjcComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!coefSaisonnierEgal(decisionAvant, decisionApres)) {
              alimenterCoefSaisonnierComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!coefTempsPartielEgal(decisionAvant, decisionApres)) {
              alimenterCoefTempsPartielComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!dateAttributionEgal(decisionAvant, decisionApres)) {
              alimenterDateAttributionComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!topAlsaceMoselleEgal(decisionAvant, decisionApres)) {
              alimenterAlsaceLorraineComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!regimeSecuEgal(decisionAvant, decisionApres)) {
              alimenterRegimeSecuComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!competenceAdministrativeEgale(decisionAvant, decisionApres)) {
              alimenterCompetenceAdministrativeComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!dureePostPrimeEgale(decisionAvant, decisionApres)) {
              alimenterDureePostPrime(decisionAvant, decisionApres, listeDifferences);
            }
            if (!dateLimiteIndemnisationEgale(decisionAvant, decisionApres)) {
              alimenterDateLimiteIndemnisation(decisionAvant, decisionApres, listeDifferences);
            }
          }
          else if (!reprise1PossedeAttributionPrecedente)
          {
            alimenterAttribPrecRepriseComparaisonDecision(decision2, listeDifferences);
          }
          else if (!revisionsPossedeAttributionPrecedente)
          {
            alimenterAttribPrecRevisionComparaisonDecision(decision1, decision2, listeDifferences);
          }
        }
        else {
          alimenterDecisionComparaisonDecision(decision1, decision2, listeDifferences);
        }
      }
      else if ((decision1 != null) && (decision2 != null))
      {
        alimenterProduitComparaisonDecision(decision1, decision2, listeDifferences);
        if (!decisionEgal(decision1, decision2)) {
          alimenterDecisionComparaisonDecision(decision1, decision2, listeDifferences);
        }
      }
    }
    return listeDifferences;
  }
  
  private static void alimenterProduitComparaisonDecision(DecisionSpec decisionAvant, DecisionSpec decisionApres, ArrayList liste)
  {
    String libelleElement = "Produit Proposé";
    String produitAvant = null;
    String produitApres = null;
    if (decisionAvant.getDossierAffecte().getProduit() != null) {
      produitAvant = decisionAvant.getDossierAffecte().getProduit().getLibelleLong();
    }
    if (decisionApres.getDossierAffecte().getProduit() != null) {
      produitApres = decisionApres.getDossierAffecte().getProduit().getLibelleLong();
    }
    alimenterDifferences(produitAvant, produitApres, libelleElement, liste);
  }
  
  private static void alimenterAttribPrecRepriseComparaisonDecision(DecisionSpec decisionApres, ArrayList liste)
  {
    String libelleElement = "Attribution précédente";
    String natureDecision2 = "";
    if ((decisionApres instanceof Decision))
    {
      AttributionAssuranceSpec attributionPrecDecisionDeux = ((Demande)decisionApres.getDemande()).getDemandeOrigine().getAttribution();
      if (attributionPrecDecisionDeux != null) {
        natureDecision2 = (String)NaturesDecisions.s_libelleObjectifDecision.get(new BigDecimal(attributionPrecDecisionDeux.getNatureDecision()));
      }
    }
    alimenterDifferences("Sans Objet", String.valueOf(natureDecision2), libelleElement, liste);
  }
  
  private static void alimenterDureeComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Durée Effective";
    BigDecimal dureeAvant = null;
    BigDecimal dureeApres = null;
    if ((decisionAvant.getConstitutionDurees() != null) && 
      (decisionAvant.getConstitutionDurees().getDureeIndemnisation().getDureeEffective() != null))
    {
      Quantite dureeInitialDecision1 = ((AttributionAssuranceSpec)decisionAvant).getDureeIndemnisationEffective();
      if (dureeInitialDecision1 != null) {
        dureeAvant = dureeInitialDecision1.getValeur();
      }
    }
    if ((decisionApres.getConstitutionDurees() != null) && 
      (decisionApres.getConstitutionDurees().getDureeIndemnisation().getDureeEffective() != null))
    {
      Quantite dureeInitialDecision2 = ((AttributionAssuranceSpec)decisionApres).getDureeIndemnisationEffective();
      if (dureeInitialDecision2 != null) {
        dureeApres = dureeInitialDecision2.getValeur();
      }
    }
    if ((dureeAvant != null) || (dureeApres != null)) {
      alimenterDifferences(dureeAvant, dureeApres, libelleElement, liste);
    }
  }
  
  private static void alimenterPjiComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Pji";
    Damj pjiAvant = null;
    Damj pjiApres = null;
    if ((decisionAvant instanceof Attribution))
    {
      Attribution attributionDecisionAvant = (Attribution)decisionAvant;
      pjiAvant = attributionDecisionAvant.getPji();
    }
    if ((decisionApres instanceof Attribution))
    {
      Attribution attributionDecisionApres = (Attribution)decisionApres;
      pjiApres = attributionDecisionApres.getPji();
    }
    if ((pjiAvant != null) || (pjiApres != null)) {
      alimenterDifferences(pjiAvant, pjiApres, libelleElement, liste);
    }
  }
  
  private static void alimenterReglementComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Réglement Applicable";
    String reglementAvant = null;
    String reglementApres = null;
    if ((decisionAvant.getReglementApplicable() != null) && 
      (decisionAvant.getReglementApplicable().getReglement() != null)) {
      reglementAvant = decisionAvant.getReglementApplicable().getReglement().getLibelle();
    }
    if ((decisionApres.getReglementApplicable() != null) && 
      (decisionApres.getReglementApplicable().getReglement() != null)) {
      reglementApres = decisionApres.getReglementApplicable().getReglement().getLibelle();
    }
    if ((reglementAvant != null) || (reglementApres != null)) {
      alimenterDifferences(reglementAvant, reglementApres, libelleElement, liste);
    }
  }
  
  private static void alimenterCompetenceAdministrativeComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Compétence administrative";
    
    String libelleCompetenceAdministrativeAvant = null;
    String libelleCompetenceAdministrativeApres = null;
    if (decisionAvant.getCompetence() != null) {
      libelleCompetenceAdministrativeAvant = decisionAvant.getCompetence().donnerLibelleCompetence(decisionAvant.getCompetence().getCompetenceAdministrative());
    }
    if (decisionApres.getCompetence() != null) {
      libelleCompetenceAdministrativeApres = decisionApres.getCompetence().donnerLibelleCompetence(decisionApres.getCompetence().getCompetenceAdministrative());
    }
    if ((libelleCompetenceAdministrativeAvant != null) || (libelleCompetenceAdministrativeApres != null)) {
      alimenterDifferences(libelleCompetenceAdministrativeAvant, libelleCompetenceAdministrativeApres, libelleElement, liste);
    }
  }
  
  private static void alimenterAttribPrecRevisionComparaisonDecision(DecisionSpec decisionAvant, DecisionSpec decisionApres, ArrayList liste)
  {
    String libelleElement = "Attribution précédente";
    String natureDecision1 = "";
    String natureDecision2 = "";
    if ((decisionAvant instanceof Decision))
    {
      AttributionAssuranceSpec attribPrecDecisionAvant = ((Demande)decisionAvant.getDemande()).getDemandeOrigine().getAttribution();
      if (attribPrecDecisionAvant != null) {
        natureDecision1 = (String)NaturesDecisions.s_libelleObjectifDecision.get(new BigDecimal(attribPrecDecisionAvant.getNatureDecision()));
      } else {
        natureDecision1 = "Sans Objet";
      }
    }
    if ((decisionApres instanceof Decision))
    {
      AttributionAssuranceSpec attribPrecDecisionApres = ((Demande)decisionApres.getDemande()).getDemandeOrigine().getAttribution();
      if (attribPrecDecisionApres != null) {
        natureDecision2 = (String)NaturesDecisions.s_libelleObjectifDecision.get(new BigDecimal(attribPrecDecisionApres.getNatureDecision()));
      } else {
        natureDecision2 = "Sans Objet";
      }
    }
    alimenterDifferences(String.valueOf(natureDecision1), String.valueOf(natureDecision2), libelleElement, liste);
  }
  
  private static void alimenterDecisionComparaisonDecision(DecisionSpec decisionAvant, DecisionSpec decisionApres, ArrayList liste)
  {
    String libelleElement = "Libellé Décision";
    String typeDecisionAvant = null;
    String typeDecisionApres = null;
    String libelleDecisionAvant = null;
    String libelleDecisionApres = null;
    if (decisionAvant != null)
    {
      typeDecisionAvant = Integer.toString(decisionAvant.getNatureDecision());
      libelleDecisionAvant = (String)NaturesDecisions.s_libelleObjectifDecision.get(new BigDecimal(typeDecisionAvant));
    }
    if (decisionApres != null)
    {
      typeDecisionApres = Integer.toString(decisionApres.getNatureDecision());
      libelleDecisionApres = (String)NaturesDecisions.s_libelleObjectifDecision.get(new BigDecimal(typeDecisionApres));
    }
    alimenterDifferences(libelleDecisionAvant, libelleDecisionApres, libelleElement, liste);
  }
  
  private static void alimenterMotifsRejetComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Motifs de rejet";
    int typeObjectifDecisionAvant = getTypeObjectifParDecision(decisionAvant);
    int typeObjectifDecisionApres = getTypeObjectifParDecision(decisionApres);
    DossierExamen dossierExamenDecisionAvant = getDossierExamenParDecision(decisionAvant);
    DossierExamen dossierExamenDecisionApres = getDossierExamenParDecision(decisionApres);
    List listElementDroitDecisionAvant = null;
    List listElementDroitDecisionApres = null;
    String motifRejetAvant = null;
    String motifRejetApres = null;
    if ((decisionAvant instanceof Rejet)) {
      if ((typeObjectifDecisionAvant == 2) && (typeObjectifDecisionAvant == typeObjectifDecisionApres))
      {
        if (dossierExamenDecisionAvant.getConditionsAttributionReprise().getListeConditionsAttribution() != null)
        {
          listElementDroitDecisionAvant = dossierExamenDecisionAvant.getConditionsAttributionReprise().getListeConditionsAttribution();
          ConditionAttributionSpec conditionAttributionAvant = (ConditionAttributionSpec)listElementDroitDecisionAvant.get(0);
          motifRejetAvant = (String)CodesMotifsEchec.getLibelleEchecCap().get(new BigDecimal(conditionAttributionAvant.getCodeMotifEchec()));
        }
      }
      else if ((typeObjectifDecisionAvant == 1) && (typeObjectifDecisionAvant == typeObjectifDecisionApres) && 
        (dossierExamenDecisionAvant.getConditionsAttributionAdmission().getListeConditionsAttribution() != null))
      {
        listElementDroitDecisionAvant = dossierExamenDecisionAvant.getConditionsAttributionAdmission().getListeConditionsAttribution();
        
        Iterator itMotifRejet = listElementDroitDecisionAvant.iterator();
        while (itMotifRejet.hasNext())
        {
          ConditionAttributionSpec conditionAttributionAvant = (ConditionAttributionSpec)itMotifRejet.next();
          if ((conditionAttributionAvant != null) && (!conditionAttributionAvant.estSatisfait()))
          {
            motifRejetAvant = (String)CodesMotifsEchec.getLibelleEchecCap().get(new BigDecimal(conditionAttributionAvant.getCodeMotifEchec()));
            
            break;
          }
        }
      }
    }
    if ((decisionApres instanceof Rejet)) {
      if ((typeObjectifDecisionApres == 2) && (typeObjectifDecisionAvant == typeObjectifDecisionApres))
      {
        if (dossierExamenDecisionApres.getConditionsAttributionReprise().getListeConditionsAttribution() != null)
        {
          listElementDroitDecisionApres = dossierExamenDecisionApres.getConditionsAttributionReprise().getListeConditionsAttribution();
          ConditionAttributionSpec conditionAttributionApres = (ConditionAttributionSpec)listElementDroitDecisionApres.get(0);
          motifRejetApres = (String)CodesMotifsEchec.getLibelleEchecCap().get(new BigDecimal(conditionAttributionApres.getCodeMotifEchec()));
        }
      }
      else if ((typeObjectifDecisionApres == 1) && (typeObjectifDecisionAvant == typeObjectifDecisionApres) && 
        (dossierExamenDecisionApres.getConditionsAttributionAdmission().getListeConditionsAttribution() != null))
      {
        listElementDroitDecisionApres = dossierExamenDecisionApres.getConditionsAttributionAdmission().getListeConditionsAttribution();
        
        Iterator itMotifRejet = listElementDroitDecisionApres.iterator();
        while (itMotifRejet.hasNext())
        {
          ConditionAttributionSpec conditionAttributionApres = (ConditionAttributionSpec)itMotifRejet.next();
          if ((conditionAttributionApres != null) && (!conditionAttributionApres.estSatisfait()))
          {
            motifRejetApres = (String)CodesMotifsEchec.getLibelleEchecCap().get(new BigDecimal(conditionAttributionApres.getCodeMotifEchec()));
            
            break;
          }
        }
      }
    }
    if ((motifRejetAvant != null) || (motifRejetApres != null)) {
      alimenterDifferences(motifRejetAvant, motifRejetApres, libelleElement, liste);
    }
  }
  
  private static void alimenterMontantComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Montant brut";
    BigDecimal montantBrutAvant = null;
    BigDecimal montantBrutApres = null;
    if ((decisionAvant.getConstitutionMontantsBruts() != null) && 
      (decisionAvant.getConstitutionMontantsBruts().getMontantJournalierBrut() != null)) {
      montantBrutAvant = decisionAvant.getConstitutionMontantsBruts().getMontantJournalierBrut().getValeur();
    }
    if ((decisionApres.getConstitutionMontantsBruts() != null) && 
      (decisionApres.getConstitutionMontantsBruts().getMontantJournalierBrut() != null)) {
      montantBrutApres = decisionApres.getConstitutionMontantsBruts().getMontantJournalierBrut().getValeur();
    }
    if ((montantBrutAvant != null) || (montantBrutApres != null)) {
      alimenterDifferences(montantBrutAvant, montantBrutApres, libelleElement, liste);
    }
  }
  
  private static void alimenterSjrComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Sjr";
    BigDecimal sjrAvant = null;
    BigDecimal sjrApres = null;
    if ((decisionAvant.getConstitutionSjr() != null) && 
      (decisionAvant.getConstitutionSjr().getSjrip() != null)) {
      sjrAvant = decisionAvant.getConstitutionSjr().getSjrip().getSjrip();
    }
    if ((decisionApres.getConstitutionSjr() != null) && 
      (decisionApres.getConstitutionSjr().getSjrip() != null)) {
      sjrApres = decisionApres.getConstitutionSjr().getSjrip().getSjrip();
    }
    if ((sjrAvant != null) || (sjrApres != null)) {
      alimenterDifferences(sjrAvant, sjrApres, libelleElement, liste);
    }
  }
  
  private static void alimenterSjcComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Sjc";
    BigDecimal sjcAvant = null;
    BigDecimal sjcApres = null;
    if ((decisionAvant.getConstitutionSjc() != null) && 
      (decisionAvant.getConstitutionSjc().getSjcip() != null)) {
      sjcAvant = decisionAvant.getConstitutionSjc().getSjcip().getSjcip();
    }
    if ((decisionApres.getConstitutionSjc() != null) && 
      (decisionApres.getConstitutionSjc().getSjcip() != null)) {
      sjcApres = decisionApres.getConstitutionSjc().getSjcip().getSjcip();
    }
    if ((sjcAvant != null) || (sjcApres != null)) {
      alimenterDifferences(sjcAvant, sjcApres, libelleElement, liste);
    }
  }
  
  private static void alimenterCoefSaisonnierComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Coefficient Saisonnier";
    DossierExamen dossierExamenAvant = getDossierExamenParDecision(decisionAvant);
    DossierExamen dossierExamenApres = getDossierExamenParDecision(decisionApres);
    BigDecimal coefficientSaisonnierAvant = null;
    BigDecimal coefficientSaisonnierApres = null;
    if ((dossierExamenAvant.getConstitutionCoefficientSaisonnier() != null) && 
      (dossierExamenAvant.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu() != null)) {
      coefficientSaisonnierAvant = dossierExamenAvant.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu();
    }
    if ((dossierExamenApres.getConstitutionCoefficientSaisonnier() != null) && 
      (dossierExamenApres.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu() != null)) {
      coefficientSaisonnierApres = dossierExamenApres.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu();
    }
    if ((coefficientSaisonnierAvant != null) || (coefficientSaisonnierApres != null)) {
      alimenterDifferences(coefficientSaisonnierAvant, coefficientSaisonnierApres, libelleElement, liste);
    }
  }
  
  private static void alimenterCoefTempsPartielComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Coefficient Temps Partiel";
    DossierExamen dossierExamenAvant = getDossierExamenParDecision(decisionAvant);
    DossierExamen dossierExamenApres = getDossierExamenParDecision(decisionApres);
    BigDecimal coefficientTempsPartielAvant = null;
    BigDecimal coefficientTempsPartielApres = null;
    if ((dossierExamenAvant.getConstitutionCoefficientTempsPartiel() != null) && 
      (dossierExamenAvant.getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu() != null)) {
      coefficientTempsPartielAvant = dossierExamenAvant.getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu();
    }
    if ((dossierExamenApres.getConstitutionCoefficientTempsPartiel() != null) && 
      (dossierExamenApres.getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu() != null)) {
      coefficientTempsPartielApres = dossierExamenApres.getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu();
    }
    if ((coefficientTempsPartielAvant != null) || (coefficientTempsPartielApres != null)) {
      alimenterDifferences(coefficientTempsPartielAvant, coefficientTempsPartielApres, libelleElement, liste);
    }
  }
  
  private static void alimenterDateAttributionComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Date Attribution";
    Damj dateAttributionAvant = null;
    Damj dateAttributionApres = null;
    if (decisionAvant != null) {
      dateAttributionAvant = decisionAvant.getDateAttribution();
    }
    if (decisionApres != null) {
      dateAttributionApres = decisionApres.getDateAttribution();
    }
    if ((dateAttributionAvant != null) || (dateAttributionApres != null)) {
      alimenterDifferences(dateAttributionAvant, dateAttributionApres, libelleElement, liste);
    }
  }
  
  private static void alimenterAlsaceLorraineComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Top Alsace/Moselle";
    Boolean topAlsaceLorraineAvant = null;
    Boolean topAlsaceLorraineApres = null;
    ActiviteSalarie periodeValidationProduitAvant = null;
    ActiviteSalarie periodeValidationProduitApres = null;
    ValidationProduit validationProduitAvant = null;
    ValidationProduit validationProduitApres = null;
    if (((decisionAvant instanceof Attribution)) && ((decisionApres instanceof Attribution)))
    {
      if ((decisionAvant instanceof Reprise))
      {
        OdSpec odOrigineAvant = ((AttributionAssuranceSpec)decisionAvant).getOuvertureDroit();
        if (odOrigineAvant != null) {
          validationProduitAvant = ((DossierAffectation)odOrigineAvant.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitAvant = ((DossierAffectation)decisionAvant.getDossierAffecte()).getValidationProduit();
      }
      if ((decisionApres instanceof Reprise))
      {
        OdSpec odOrigineApres = ((AttributionAssuranceSpec)decisionApres).getOuvertureDroit();
        if (odOrigineApres != null) {
          validationProduitApres = ((DossierAffectation)odOrigineApres.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitApres = ((DossierAffectation)decisionApres.getDossierAffecte()).getValidationProduit();
      }
    }
    if ((validationProduitAvant != null) && (validationProduitAvant.isEstProduitValide()))
    {
      periodeValidationProduitAvant = validationProduitAvant.getPeriodeValidationProduit();
      if (periodeValidationProduitAvant != null) {
        topAlsaceLorraineAvant = Boolean.valueOf(periodeValidationProduitAvant.isRegimeAlsaceMoselle());
      }
    }
    if ((validationProduitApres != null) && (validationProduitApres.isEstProduitValide()))
    {
      periodeValidationProduitApres = validationProduitApres.getPeriodeValidationProduit();
      if (periodeValidationProduitApres != null) {
        topAlsaceLorraineApres = Boolean.valueOf(periodeValidationProduitApres.isRegimeAlsaceMoselle());
      }
    }
    if ((topAlsaceLorraineAvant != null) || (topAlsaceLorraineApres != null)) {
      alimenterDifferences(topAlsaceLorraineAvant, topAlsaceLorraineApres, libelleElement, liste);
    }
  }
  
  private static void alimenterRegimeSecuComparaisonDecision(Decision decisionAvant, Decision decisionApres, ArrayList liste)
  {
    String libelleElement = "Caisse spéciale de sécurité sociale";
    String regimeSecuAvant = null;
    String regimeSecuApres = null;
    ValidationProduit validationProduitAvant = null;
    ValidationProduit validationProduitApres = null;
    ActiviteSalarie periodeValidationProduitAvant = null;
    ActiviteSalarie periodeValidationProduitApres = null;
    if (((decisionAvant instanceof Attribution)) && ((decisionApres instanceof Attribution)))
    {
      if ((decisionAvant instanceof Reprise))
      {
        OdSpec odOrigineAvant = ((AttributionAssuranceSpec)decisionAvant).getOuvertureDroit();
        if (odOrigineAvant != null) {
          validationProduitAvant = ((DossierAffectation)odOrigineAvant.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitAvant = ((DossierAffectation)decisionAvant.getDossierAffecte()).getValidationProduit();
      }
      if ((decisionApres instanceof Reprise))
      {
        OdSpec odOrigineApres = ((AttributionAssuranceSpec)decisionApres).getOuvertureDroit();
        if (odOrigineApres != null) {
          validationProduitApres = ((DossierAffectation)odOrigineApres.getDossierAffecte()).getValidationProduit();
        }
      }
      else
      {
        validationProduitApres = ((DossierAffectation)decisionApres.getDossierAffecte()).getValidationProduit();
      }
    }
    if ((validationProduitAvant != null) && (validationProduitAvant.isEstProduitValide()))
    {
      periodeValidationProduitAvant = validationProduitAvant.getPeriodeValidationProduit();
      if (periodeValidationProduitAvant != null)
      {
        int codeRegimeAvant = periodeValidationProduitAvant.getMetier().getRegimeSecu();
        regimeSecuAvant = ConstantesRegimeRetraite.getCaisseRegime(new BigDecimal(codeRegimeAvant));
      }
    }
    if ((validationProduitApres != null) && (validationProduitApres.isEstProduitValide()))
    {
      periodeValidationProduitApres = validationProduitApres.getPeriodeValidationProduit();
      if (periodeValidationProduitApres != null)
      {
        int codeRegimeApres = periodeValidationProduitApres.getMetier().getRegimeSecu();
        regimeSecuApres = ConstantesRegimeRetraite.getCaisseRegime(new BigDecimal(codeRegimeApres));
      }
    }
    if ((regimeSecuAvant != null) || (regimeSecuApres != null)) {
      alimenterDifferences(regimeSecuAvant, regimeSecuApres, libelleElement, liste);
    }
  }
  
  private static boolean coefficientsEgaux(BigDecimal coeff1, BigDecimal coeff2)
  {
    if (coeff1 == null) {
      return coeff2 == null;
    }
    if (coeff2 == null) {
      return false;
    }
    return coeff1.compareTo(coeff2) == 0;
  }
}

/* Location:
 * Qualified Name:     ComparateurDecision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */