package fr.unedic.cali.asu.cge01.p05.liquidation.dom;

import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionFinancementBasculeCrpCtp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisFinDeDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReports;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsFinancement;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffective;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectiveCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectivePmvs;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireFinAtp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireFinAtpBasculeCrpCtp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireFinancement;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireFinancementBasculeCrpCtp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionPointDeDepartFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionRevisionAutomatiqueAreSousJacent;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionRevisionAutomatiqueExamenIPR;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionRevisionAutomatiqueFinAsp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionRevisionAutomatiqueFinAtp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitCourant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCondition28JoursSuspension;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionAccordCP;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionCumulActiviteConservee;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionFaitGenerateurFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionQuantiteAffiliationFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjc;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursDetecterContributionParticuliere;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursDetecterContributionParticuliereContexteEntreeCsp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.VerifierConditionSurFinDispositifReclassement;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursLiquidationDemandeSousJacenteCSPDroitCommun;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursObjectifAdmissionEntreeCspDC;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursObjectifCSPSousJacent;
import fr.unedic.cali.asu.cge01.liquidation.parcours.cep02dureeRegl.asp.ConstitutionDureePostPrime;
import fr.unedic.cali.asu.cge01.liquidation.parcours.revision.ConstitutionNouvelleRevisionAutomatiqueAreSousJacent;
import fr.unedic.cali.asu.cge01.liquidation.parcours.revision.ConstitutionNouvelleRevisionAutomatiqueExamenIPR;
import fr.unedic.cali.asu.cge01.liquidation.parcours.revision.ConstitutionNouvelleRevisionAutomatiqueFinAsp;
import fr.unedic.cali.asu.cge01.p05.liquidation.dom.gen.ObjectifExamenAdmissionGen;
import fr.unedic.cali.asu.cge01.p05.liquidation.parcours.ConstitutionDureeReglementaire;
import fr.unedic.cali.asu.cge01.p05.liquidation.parcours.ConstitutionDureeReglementaireFinAsp;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.parcours.ParcoursObjectifAdmission;
import fr.unedic.cali.asu.parcours.ParcoursObjectifFinancement;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateAttribution;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionDureeNonNulle;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.parcours.ParcoursTraitementSatisfait;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;
import java.util.List;

public class ObjectifExamenAdmission
  extends ObjectifExamenAdmissionGen
  implements fr.unedic.cali.asu.cge01.liquidation.dom.ObjectifExamenSpec
{
  private static final long serialVersionUID = 3757935742506822397L;
  
  public ObjectifExamenAdmission(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjectifExamenAdmission() {}
  
  public ObjectifExamenAdmission(List<ContexteDemandeSpec> contexteDemande)
  {
    listeContextesDemande = contexteDemande;
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenAdmission copie = new ObjectifExamenAdmission();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursObjectif()
  {
    Parcours parcours = null;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) && (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      parcours = new ParcoursObjectifAdmissionEntreeCspDC();
    } else if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ASPSJACENT")) {
      parcours = new ParcoursObjectifCSPSousJacent();
    } else if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATP")) {
      parcours = new ParcoursObjectifFinancement();
    } else if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATPB")) {
      parcours = new ParcoursObjectifFinancement();
    } else {
      parcours = new ParcoursObjectifAdmission();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    Parcours parcours = null;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null))
    {
      parcours = new DeterminationConditionFaitGenerateurFinDroit();
    }
    else if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ASPSJACENT"))
    {
      parcours = new fr.unedic.cali.asu.cge01.liquidation.parcours.asp.DeterminationConditionFaitGenerateur();
    }
    else
    {
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) {
        return getObjectifProduitActif().creerParcoursConditionFaitGenerateur();
      }
      parcours = new fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionFaitGenerateur();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionDureeNonNulle()
  {
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) {
      return new ParcoursTraitementSatisfait();
    }
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null)) {
      return new DeterminationConditionDureeNonNulle();
    }
    return super.creerParcoursConditionDureeNonNulle();
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    if ((listeContextesDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null))) {
      return new ConstitutionPointDeDepartFinDroit();
    }
    return super.creerParcoursPointDeDepart();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) {
      return new DeterminationConditionQuantiteAffiliationFinDroit();
    }
    return new DeterminationConditionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJASPDC")) {
      return new ParcoursTraitementSatisfait();
    }
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionChomageInvolontaire();
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    if ((listeContextesDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null))) {
      return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionCumulActiviteConservee());
    }
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJASPDC")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV"))) {
      return new ParcoursTraitementSatisfait();
    }
    return new DeterminationConditionCumulActiviteConservee();
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      return new ParcoursTraitementSatisfait();
    }
    if ((listeContextesDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null))) {
      return new VerifierConditionSurFinDispositifReclassement(super.creerParcoursConditionCumulPrestationFamiliale());
    }
    return super.creerParcoursConditionCumulPrestationFamiliale();
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) {
      return new ParcoursTraitementSatisfait();
    }
    if ((listeContextesDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null))) {
      return new VerifierConditionSurFinDispositifReclassement(super.creerParcoursConditionMontant());
    }
    return super.creerParcoursConditionMontant();
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return new ParcoursConstitutionSjr();
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return new ConstitutionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return new ParcoursConstitutionSjc();
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ConstitutionCoefficientTempsPartiel();
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return new ConstitutionCoefficientSaisonnier();
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return new ConstitutionCaractereSaisonnier();
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      return new ConstitutionDureeEffectiveCsr();
    }
    if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 2) != null) {
      return new ConstitutionDureeEffectivePmvs();
    }
    return new ConstitutionDureeEffective();
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return new DeterminationCompetencesProduitCourant();
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return new DeterminationCompetencesProduitResultant();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    if (listeContextesDemande != null)
    {
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) {
        return new ConstitutionDureeReglementaireFinAtp();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) {
        return new ConstitutionDureeReglementaireFinAtpBasculeCrpCtp();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATP")) {
        return new ConstitutionDureeReglementaireFinancement();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATPB")) {
        return new ConstitutionDureeReglementaireFinancementBasculeCrpCtp();
      }
      if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) {
        return new ConstitutionDureeReglementaireFinAsp();
      }
    }
    return new ConstitutionDureeReglementaire();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    Parcours parcours = null;
    if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) {
      parcours = new ConstitutionProduitResultantFinDroit();
    } else if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      parcours = new ConstitutionProduitResultantCsr();
    } else {
      parcours = new ConstitutionProduitResultant();
    }
    return parcours;
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    if (listeContextesDemande != null)
    {
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATP")) {
        return new ConstitutionDelaisReportsFinancement();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATPB")) {
        return new ConstitutionDelaisReportsFinancement();
      }
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC"))) {
        return new ConstitutionDelaisFinDeDroit();
      }
      if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
        return new ConstitutionDelaisReportsCsr();
      }
      if (((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) && (!OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 10))) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJASPDC"))) {
        return null;
      }
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ASPDC")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "PAPPARLEM"))) {
        return null;
      }
    }
    return new ConstitutionDelaisReports();
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBruts();
  }
  
  public Parcours creerParcoursRevisionAutomatique()
  {
    if (listeContextesDemande != null)
    {
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) {
        return new ConstitutionRevisionAutomatiqueFinAtp();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) {
        return new ConstitutionRevisionAutomatiqueFinAtp();
      }
      if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) {
        return new ConstitutionRevisionAutomatiqueFinAsp();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJASPDC")) {
        return new ConstitutionRevisionAutomatiqueAreSousJacent();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "EXAMENIPR")) {
        return new ConstitutionRevisionAutomatiqueExamenIPR();
      }
    }
    return null;
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    if (listeContextesDemande != null)
    {
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATPB")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJASPDC")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV"))) {
        return null;
      }
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARECOURCSP"))) {
        return getObjectifProduitActif().creerParcoursConditionRechercheEmploi();
      }
    }
    return super.creerParcoursConditionRechercheEmploi();
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    if (listeContextesDemande != null)
    {
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATP")) || (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINATPBASC"))) {
        return new ConstitutionDateAttributionFinDroit();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "FINANCATPB")) {
        return new ConstitutionDateAttributionFinancementBasculeCrpCtp();
      }
      if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
        return new ConstitutionDateAttributionCsr();
      }
    }
    return new ConstitutionDateAttribution();
  }
  
  public Parcours creerParcoursConditionCsrAccordCp()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      return new DeterminationConditionAccordCP();
    }
    return new ParcoursTraitementSatisfait();
  }
  
  public Parcours creerParcoursCondition28JSuspension()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      return new DeterminationCondition28JoursSuspension();
    }
    return new ParcoursTraitementSatisfait();
  }
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return new ConstitutionDateLimiteIndemnisation();
  }
  
  public Parcours creerParcoursDetectionContributionParticuliere(Demande pDemande)
  {
    Parcours resultat = null;
    if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(pDemande, "AREENTRCSP")) {
      resultat = new ParcoursDetecterContributionParticuliereContexteEntreeCsp();
    } else {
      resultat = new ParcoursDetecterContributionParticuliere();
    }
    return resultat;
  }
  
  public Parcours creerParcoursNouvelleRevisionAutomatique()
  {
    if (listeContextesDemande != null)
    {
      if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) {
        return new ConstitutionNouvelleRevisionAutomatiqueFinAsp();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJASPDC")) {
        return new ConstitutionNouvelleRevisionAutomatiqueAreSousJacent();
      }
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "EXAMENIPR")) {
        return new ConstitutionNouvelleRevisionAutomatiqueExamenIPR();
      }
    }
    return null;
  }
  
  public Parcours creerParcoursLiquidationDemandeAssociee()
  {
    Parcours parcours = null;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) && (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      parcours = new ParcoursLiquidationDemandeSousJacenteCSPDroitCommun();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConstitutionDureePostPrime()
  {
    return new ConstitutionDureePostPrime();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenAdmission
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */