package fr.unedic.cali.asu.cge01.p06;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.CalculAppartenance;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilSimulationAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheValiditeProduit;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation.OutilCalculAppartenance;
import fr.unedic.cali.asu.cge01.p06.occasionnel.FabriqueExecutionPopulation;
import fr.unedic.cali.asu.cge01.p06.occasionnel.FabriqueTraitementPopulation;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.outilsfonctionnels.DetectionContexteParticulierLiquidation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DomSimulationAffiliation;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.ResultatSimulationAffiliation;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P06;
import fr.unedic.cali.dom.affectation.ValidationProduitSpec;
import fr.unedic.cali.dom.spec.CalculAppartenanceSpec;
import fr.unedic.cali.occasionnel.outilsfonctionnels.CriteresExecutionPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.CriteresTraitementPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.ExecutionPopulationSpec;
import fr.unedic.cali.occasionnel.outilsfonctionnels.ResultatTraitementPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.TraitementPopulationSpec;
import fr.unedic.cali.outilsfonctionnels.TracesBouchon;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ProduitDelegue
  extends fr.unedic.cali.asu.cge01.p6b.ProduitDelegue
{
  protected FabriqueExecutionPopulation fabriqueExecutionPopulation;
  
  public boolean estReexecutable(CriteresExecutionPopulation criteres)
  {
    ExecutionPopulationSpec outil = getFabriqueExecutionPopulation().getInstance(criteres.getNomPopulation());
    if (outil != null) {
      return outil.estExecutable(criteres);
    }
    return false;
  }
  
  private FabriqueExecutionPopulation getFabriqueExecutionPopulation()
  {
    if (fabriqueExecutionPopulation == null) {
      fabriqueExecutionPopulation = new FabriqueExecutionPopulation();
    }
    return fabriqueExecutionPopulation;
  }
  
  public ResultatTraitementPopulation effectuerTraitementOccasionnel(CriteresTraitementPopulation criteres)
    throws ApplicativeException
  {
    FabriqueTraitementPopulation fabrique = new FabriqueTraitementPopulation();
    TraitementPopulationSpec traitement = fabrique.getInstance(criteres.getNomPopulation());
    if (traitement != null) {
      return traitement.effectuerTraitement(criteres);
    }
    return null;
  }
  
  public Resultat executerSimulationAffiliation(DomSimulationAffiliation domSimulationAffiliation)
    throws ApplicativeException
  {
    domSimulationAffiliation.setProduitAppelant(ProduitAsuCge01P06.getInstance());
    Resultat result = OutilSimulationAffiliation.calculAffi(domSimulationAffiliation);
    if (result != null)
    {
      ((ResultatSimulationAffiliation)result).setProduit(ProduitAsuCge01P06.getInstance());
      ((ResultatSimulationAffiliation)result).setProduitPropose(ProduitAsuCge01P06.getInstance().getLibelleCourt());
    }
    return result;
  }
  
  public CalculAppartenanceSpec getOutilCalculAppartenance(DemandeSpec demande)
  {
    TracesBouchon.ecrireTrace("A terme la notion de stratégie doit disparaître. Elle ne doit exister que pour la phase de tests");
    if ("justifCGENouveauModele".equals(determinerStrategieCalculAffiliation(demande))) {
      return new OutilCalculAppartenance(ProduitAsuCge01P06.getInstance());
    }
    return CalculAppartenance.getInstance();
  }
  
  public ValidationProduitSpec obtenirValidationProduit(ActiviteSalarie activiteSalarie, IndividuSpec individu, DemandeSpec demande, boolean avecPeriodeNonAttestee)
    throws ApplicativeException
  {
    DossierAffectation dossierAffectationCourant = (DossierAffectation)demande.getDossierAffectation();
    
    DetectionContexteParticulierLiquidation.getInstance().detectionContexteEnCoursPmvs((DemandeAssuranceSpec)demande, dossierAffectationCourant.getSinistre(), demande.getDateExamen());
    if (((Demande)demande).estUneDemandeFinancement()) {
      return RechercheValiditeProduit.validerProduitFinancement(activiteSalarie, (DemandeAssuranceSpec)demande, avecPeriodeNonAttestee, ProduitAsuCge01P06.getInstance());
    }
    return RechercheValiditeProduit.validerProduit(activiteSalarie, (DemandeAssuranceSpec)demande, avecPeriodeNonAttestee, ProduitAsuCge01P06.getInstance());
  }
  
  public boolean estForcerTempsPleinPourPeriodeA8A10(Damj dateExamen)
  {
    return true;
  }
}

/* Location:
 * Qualified Name:     ProduitDelegue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */