package fr.unedic.cali.asu.cge01.p07.liquidation.dom;

import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReports;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffective;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectiveCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectivePmvs;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionRevisionAutomatiqueExamenIPR;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitCourant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCondition28JoursSuspension;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionAccordCP;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionCumulActiviteConservee;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjc;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursDetecterContributionParticuliere;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursDetecterContributionParticuliereContexteEntreeCsp;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursLiquidationDemandeSousJacenteCSPDroitCommun;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursObjectifAdmissionEntreeCspDC;
import fr.unedic.cali.asu.cge01.liquidation.parcours.asp.ParcoursObjectifCSPSousJacent;
import fr.unedic.cali.asu.cge01.liquidation.parcours.cep02dureeRegl.asp.ConstitutionDureePostPrime;
import fr.unedic.cali.asu.cge01.liquidation.parcours.revision.ConstitutionNouvelleRevisionAutomatiqueExamenIPR;
import fr.unedic.cali.asu.cge01.liquidation.parcours.revision.ConstitutionNouvelleRevisionAutomatiqueFinAsp;
import fr.unedic.cali.asu.cge01.p07.liquidation.dom.gen.ObjectifExamenAdmissionGen;
import fr.unedic.cali.asu.cge01.p07.liquidation.parcours.ConstitutionDureeReglementaire;
import fr.unedic.cali.asu.cge01.p07.liquidation.parcours.ParcoursObjectifAdmission;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateAttribution;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBruts;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.parcours.ParcoursTraitementSatisfait;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;
import java.util.List;

public class ObjectifExamenAdmission
  extends ObjectifExamenAdmissionGen
  implements fr.unedic.cali.asu.cge01.liquidation.dom.ObjectifExamenSpec
{
  private static final long serialVersionUID = 3757935742506822397L;
  
  public ObjectifExamenAdmission(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjectifExamenAdmission() {}
  
  public ObjectifExamenAdmission(List<ContexteDemandeSpec> contexteDemande)
  {
    listeContextesDemande = contexteDemande;
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenAdmission copie = new ObjectifExamenAdmission();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursObjectif()
  {
    Parcours parcours;
    Parcours parcours;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) && (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9)))
    {
      parcours = new ParcoursObjectifAdmissionEntreeCspDC();
    }
    else
    {
      Parcours parcours;
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ASPSJACENT")) {
        parcours = new ParcoursObjectifCSPSousJacent();
      } else {
        parcours = new ParcoursObjectifAdmission();
      }
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ASPSJACENT"))
    {
      parcours = new fr.unedic.cali.asu.cge01.liquidation.parcours.asp.DeterminationConditionFaitGenerateur();
    }
    else
    {
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) {
        return getObjectifProduitActif().creerParcoursConditionFaitGenerateur();
      }
      parcours = new fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionFaitGenerateur();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionDureeNonNulle()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) {
      parcours = new ParcoursTraitementSatisfait();
    } else {
      parcours = super.creerParcoursConditionDureeNonNulle();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return new DeterminationConditionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    Parcours parcours;
    Parcours parcours;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      parcours = new ParcoursTraitementSatisfait();
    } else {
      parcours = new DeterminationConditionChomageInvolontaire();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) {
      parcours = new ParcoursTraitementSatisfait();
    } else {
      parcours = new DeterminationConditionCumulActiviteConservee();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    Parcours parcours;
    Parcours parcours;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) || (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      parcours = new ParcoursTraitementSatisfait();
    } else {
      parcours = super.creerParcoursConditionCumulPrestationFamiliale();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) {
      parcours = new ParcoursTraitementSatisfait();
    } else {
      parcours = super.creerParcoursConditionMontant();
    }
    return parcours;
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return new ParcoursConstitutionSjr();
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return new ConstitutionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return new ParcoursConstitutionSjc();
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ConstitutionCoefficientTempsPartiel();
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return new ConstitutionCoefficientSaisonnier();
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return new ConstitutionCaractereSaisonnier();
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande))
    {
      parcours = new ConstitutionDureeEffectiveCsr();
    }
    else
    {
      Parcours parcours;
      if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 2) != null) {
        parcours = new ConstitutionDureeEffectivePmvs();
      } else {
        parcours = new ConstitutionDureeEffective();
      }
    }
    return parcours;
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return new DeterminationCompetencesProduitCourant();
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return new DeterminationCompetencesProduitResultant();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    return new ConstitutionDureeReglementaire();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      parcours = new ConstitutionProduitResultantCsr();
    } else {
      parcours = new ConstitutionProduitResultant();
    }
    return parcours;
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    Parcours parcours = new ConstitutionDelaisReports();
    boolean estUnContexteAspDcSurAreOuAreSousJacentRevision = (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ASPDC"));
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      parcours = new ConstitutionDelaisReportsCsr();
    } else if ((estUnContexteAreSousJacentAspPap()) || (estUnContexteAspDcSurAreOuAreSousJacentRevision) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "PAPPARLEM"))) {
      parcours = null;
    }
    return parcours;
  }
  
  private boolean estUnContexteAreSousJacentAspPap()
  {
    return (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) && (!OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 10));
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBruts();
  }
  
  public Parcours creerParcoursRevisionAutomatique()
  {
    Parcours parcours = null;
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "EXAMENIPR")) {
      parcours = new ConstitutionRevisionAutomatiqueExamenIPR();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    Parcours parcours;
    Parcours parcours;
    if (estContexteAreSousJacentPourRevision())
    {
      parcours = null;
    }
    else
    {
      Parcours parcours;
      if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARECOURCSP"))) {
        parcours = getObjectifProduitActif().creerParcoursConditionRechercheEmploi();
      } else {
        parcours = super.creerParcoursConditionRechercheEmploi();
      }
    }
    return parcours;
  }
  
  private boolean estContexteAreSousJacentPourRevision()
  {
    return OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "ARESJREV");
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      parcours = new ConstitutionDateAttributionCsr();
    } else {
      parcours = new ConstitutionDateAttribution();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConditionCsrAccordCp()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      parcours = new DeterminationConditionAccordCP();
    } else {
      parcours = new ParcoursTraitementSatisfait();
    }
    return parcours;
  }
  
  public Parcours creerParcoursCondition28JSuspension()
  {
    Parcours parcours;
    Parcours parcours;
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(listeContextesDemande)) {
      parcours = new DeterminationCondition28JoursSuspension();
    } else {
      parcours = new ParcoursTraitementSatisfait();
    }
    return parcours;
  }
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return new ConstitutionDateLimiteIndemnisation();
  }
  
  public Parcours creerParcoursDetectionContributionParticuliere(Demande pDemande)
  {
    Parcours resultat;
    Parcours resultat;
    if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(pDemande, "AREENTRCSP")) {
      resultat = new ParcoursDetecterContributionParticuliereContexteEntreeCsp();
    } else {
      resultat = new ParcoursDetecterContributionParticuliere();
    }
    return resultat;
  }
  
  public Parcours creerParcoursNouvelleRevisionAutomatique()
  {
    Parcours parcours = null;
    if (OutilGestionContexteDemande.trouverUnContextePresent(listeContextesDemande, 5) != null) {
      parcours = new ConstitutionNouvelleRevisionAutomatiqueFinAsp();
    } else if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "EXAMENIPR")) {
      parcours = new ConstitutionNouvelleRevisionAutomatiqueExamenIPR();
    }
    return parcours;
  }
  
  public Parcours creerParcoursLiquidationDemandeAssociee()
  {
    Parcours parcours = null;
    if ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(listeContextesDemande, "AREENTRCSP")) && (OutilGestionContexteDemande.estContextePresentDansRegroupement(listeContextesDemande, 9))) {
      parcours = new ParcoursLiquidationDemandeSousJacenteCSPDroitCommun();
    }
    return parcours;
  }
  
  public Parcours creerParcoursConstitutionDureePostPrime()
  {
    return new ConstitutionDureePostPrime();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenAdmission
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */