package fr.unedic.cali.asu.cge01.p07.liquidation.outilsfonctionnels.cep.sjr;

import fr.pe.cali.reglementaire.dom.impl.CriteresFabriqueReglementaire;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.dom.DonneesEntreeCalculAffiliationJoursTravailles;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.dom.ResultatCalculAffiliationJoursTravailles;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.dom.SemaineCivile;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.fabrique.FabriqueCorpsRegleCalculAffiliationJoursTravailles;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.outils.spec.IOutilCalculAffiliationJoursTravailles;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.outils.spec.IOutilFonctionnelAffiliationJoursTravailles;
import fr.pe.cali.reglementaire.regles.assurance.cep.sjr.diviseur.dom.DonneesEntreesCalculDiviseur;
import fr.pe.cali.reglementaire.regles.assurance.cep.sjr.diviseur.dom.ResultatCalculDiviseur;
import fr.pe.cali.reglementaire.regles.assurance.cep.sjr.diviseur.fabrique.FabriqueCorpsRegleCalculDiviseur;
import fr.pe.cali.reglementaire.regles.assurance.cep.sjr.diviseur.outils.spec.IOutilRegleCalculDiviseur;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationSrPrc;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FabriqueStrategieDeterminationDiviseurSjrSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationDiviseurSjrA3;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationDiviseurSjrA5;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieDeterminationDiviseurSjrCasGeneralSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieDeterminationDiviseurSjrSpec;
import fr.unedic.cali.asu.cge01.p07.liquidation.outilsfonctionnels.affiliation.OutilFonctionnelAffiliationJoursTravailles;
import fr.unedic.cali.asu.cge01.p07.liquidation.outilsfonctionnels.fabriques.sjr.FabriqueStrategieDeterminationDiviseurSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationDiviseur;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.Prc;
import fr.unedic.cali.asu.produits.liquidation.dom.conteneurs.DonneesResultatDeterminationSjr;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeDemandeDeterminationSjrSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeDeterminationSjrSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class OutilDeterminationSrPrcConvention2017
  extends OutilDeterminationSrPrc
{
  public void determinerDiviseur(DonneesEntreeDeterminationSjrSpec donneesEntree, DonneesResultatDeterminationSjr donneesResultat)
    throws CoucheLogiqueException
  {
    donneesResultat.getPrc().setNombreJourTravailEffectif(BigDecimal.ZERO);
    
    Reglement reglementApplicable = donneesEntree.getDonneesEntreeDemande().getReglementApplicable();
    if (estReglementPourCasGeneral(reglementApplicable.getNomReglement()))
    {
      determinerDiviseurCasGeneral(donneesEntree, donneesResultat);
    }
    else
    {
      StrategieDeterminationDiviseurSjrSpec strategie = recupererStrategieDiviseur(reglementApplicable);
      strategie.determinerDiviseur(donneesEntree, donneesResultat);
    }
  }
  
  protected void determinerDiviseurCasGeneral(DonneesEntreeDeterminationSjrSpec donneesEntree, DonneesResultatDeterminationSjr donneesResultat)
    throws CoucheLogiqueException
  {
    if ((!donneesEntree.getDonneesEntreeDemande().isPrimoDemandeurA3A4A5()) && (donneesEntree.getDonneesEntreeDemande().getDiviseurCasGeneralForcee() != null))
    {
      if (donneesResultat.getJustificationSjr() != null) {
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setDiviseur(donneesEntree.getDonneesEntreeDemande().getDiviseurCasGeneralForcee());
      }
      donneesResultat.getPrc().setDiviseur(donneesEntree.getDonneesEntreeDemande().getDiviseurCasGeneralForcee());
    }
    else
    {
      FabriqueCorpsRegleCalculAffiliationJoursTravailles fabrique = FabriqueCorpsRegleCalculAffiliationJoursTravailles.getInstance();
      CriteresFabriqueReglementaire criteres = new CriteresFabriqueReglementaire();
      criteres.setCodeProduit(donneesEntree.getDonneesEntreeDemande().getProduit().getNomUnique());
      criteres.setDate(donneesEntree.getDonneesEntreeDemande().getDateExamen());
      IOutilCalculAffiliationJoursTravailles outil = fabrique.recupererOutilCorpsRegle(criteres);
      DonneesEntreeCalculAffiliationJoursTravailles donneesEntreeCalculAffi = new DonneesEntreeCalculAffiliationJoursTravailles();
      donneesEntreeCalculAffi.setAssimilerSuspensionNonAssimilables(true);
      donneesEntreeCalculAffi.setDateExamen(donneesEntree.getDonneesEntreeDemande().getDateExamen());
      donneesEntreeCalculAffi.setListeContexte(donneesEntree.getDonneesEntreeDemande().getListeContexteDemande());
      IOutilFonctionnelAffiliationJoursTravailles outilFonctionnel = new OutilFonctionnelAffiliationJoursTravailles(donneesEntree.getDonneesEntreeDemande().getIndividu());
      donneesEntreeCalculAffi.setOutilFonctionnel(outilFonctionnel);
      donneesEntreeCalculAffi.setPasseProfessionnel(donneesEntree.getDonneesEntreeDemande().getIndividu().getChronoPeriodePasseProfessionnelLiquidation());
      donneesEntreeCalculAffi.setPeriodeRecherche(donneesResultat.getPrc().getPeriode());
      donneesEntreeCalculAffi.setPnds(donneesEntree.getDonneesEntreeDemande().getIndividu().getListePNDSIndividu());
      donneesEntreeCalculAffi.setIgnorerAssimiliation(true);
      
      donneesEntreeCalculAffi.setIgnorerPNDS(true);
      ResultatCalculAffiliationJoursTravailles resultatCalculAffi = outil.calculer(donneesEntreeCalculAffi);
      int nombreJoursEmploi = determinerNombreJoursEmploi(resultatCalculAffi.getJustificationSemaineCivile());
      if (donneesResultat.getJustificationSjr() != null)
      {
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setJustificationJoursTravailles(resultatCalculAffi.getJustificationSemaineCivile());
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setNombreJourEmploi(nombreJoursEmploi);
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setNombreJoursContratPlafonnes(resultatCalculAffi.getNombreJoursAffiliation());
      }
      StrategieDeterminationDiviseurSjrCasGeneralSpec strategieCasGeneral = recupererFabriqueStrategieDeterminationDiviseurSjr().getStrategieCasGeneral();
      strategieCasGeneral.determinerDureePrc(donneesResultat.getPrc(), donneesEntree.getDonneesEntreeProduit());
      BigDecimal nombreJoursAbsence = strategieCasGeneral.calculerNombreJourAbsence(donneesEntree, donneesResultat);
      IOutilRegleCalculDiviseur outilCalculDiviseur = FabriqueCorpsRegleCalculDiviseur.getInstance().recupererOutilCorpsRegle(criteres);
      DonneesEntreesCalculDiviseur donneesEntreesDiviseur = new DonneesEntreesCalculDiviseur();
      donneesEntreesDiviseur.setNombreJoursAbsence(nombreJoursAbsence);
      donneesEntreesDiviseur.setNombreJoursContratPlafonnes(resultatCalculAffi.getNombreJoursAffiliation());
      donneesEntreesDiviseur.setNombreJoursEmploi(nombreJoursEmploi);
      ResultatCalculDiviseur resultatDiviseur = outilCalculDiviseur.calculerDiviseur(donneesEntreesDiviseur);
      if (donneesResultat.getJustificationSjr() != null)
      {
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setNombreJoursAbsence(nombreJoursAbsence);
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setCoefficientAbsence(resultatDiviseur.getCoefficientAbsence());
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setDiviseur(resultatDiviseur.getDiviseur());
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setDiviseurTravaille(resultatDiviseur.getDiviseurTravaille());
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setFormuleCoefficientAbsence(resultatDiviseur.getFormuleCalculCoefficientAbsence());
        donneesResultat.getJustificationSjr().getJustificationDiviseur().setFormuleDiviseur(resultatDiviseur.getFormuleCalculDiviseur());
      }
      donneesResultat.getPrc().setDiviseur(resultatDiviseur.getDiviseur());
    }
  }
  
  protected FabriqueStrategieDeterminationDiviseurSjrSpec recupererFabriqueStrategieDeterminationDiviseurSjr()
  {
    return FabriqueStrategieDeterminationDiviseurSjr.getInstance();
  }
  
  protected int determinerNombreJoursEmploi(List<SemaineCivile> semainesCiviles)
  {
    int nombreJoursEmploi = 0;
    for (SemaineCivile semaineCourante : semainesCiviles) {
      nombreJoursEmploi += semaineCourante.getNombreJoursEmploi();
    }
    return nombreJoursEmploi;
  }
  
  protected StrategieDeterminationDiviseurSjrSpec recupererStrategieDiviseur(Reglement reglementApplicable)
  {
    StrategieDeterminationDiviseurSjrSpec strategie = null;
    if (reglementApplicable.estNomReglementIdentique("A3")) {
      strategie = new StrategieDeterminationDiviseurSjrA3();
    } else if (reglementApplicable.estNomReglementIdentique("A5")) {
      strategie = new StrategieDeterminationDiviseurSjrA5();
    }
    return strategie;
  }
  
  private boolean estReglementPourCasGeneral(String reglement)
  {
    Collection<String> listeReglements = new ArrayList();
    
    listeReglements.add("A8");
    listeReglements.add("A10");
    listeReglements.add("RG");
    listeReglements.add("OP");
    listeReglements.add("A1");
    listeReglements.add("A2a");
    listeReglements.add("A6");
    listeReglements.add("A9A");
    listeReglements.add("A9B");
    
    return listeReglements.contains(reglement);
  }
}

/* Location:
 * Qualified Name:     OutilDeterminationSrPrcConvention2017
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */