package fr.unedic.cali.asu.cge01.revision.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatRechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.capachomageinvolontaire.OutilConditionChomageInvolontaire;
import fr.unedic.cali.asu.dom.ConditionChomageInvolontaireSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsRevisions;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionChomageInvolontaire;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import java.util.Iterator;
import java.util.List;

public final class RechercheConditionChomageInvolontaire
{
  public static ConditionChomageInvolontaireSpec rechercheConditionChomageInvolontaire(Demande demande)
    throws ApplicativeException
  {
    List<DemandeAssuranceSpec> listeDemandeAssociees = OutilsRevisions.getListeDemandesAssociees(demande);
    
    ConditionChomageInvolontaireSpec conditionSousJacente = null;
    ConditionChomageInvolontaireSpec premiereConditionSousJacente = null;
    Iterator<DemandeAssuranceSpec> iterateur = listeDemandeAssociees.iterator();
    while (iterateur.hasNext())
    {
      DemandeAssuranceSpec demandeAssurance = (DemandeAssuranceSpec)iterateur.next();
      
      DossierExamenAssuranceSpec dossierExamen = (DossierExamenAssuranceSpec)demandeAssurance.getDossierExamen();
      conditionSousJacente = dossierExamen.getConditionChomageInvolontaire();
      if ((conditionSousJacente != null) && (premiereConditionSousJacente == null)) {
        premiereConditionSousJacente = conditionSousJacente;
      }
      if ((conditionSousJacente != null) && (conditionSousJacente.estSatisfait())) {
        return conditionSousJacente;
      }
    }
    return retournerConditionJurisprudenceDv(demande, listeDemandeAssociees, premiereConditionSousJacente);
  }
  
  public static ConditionChomageInvolontaireSpec retournerConditionJurisprudenceDv(Demande demande, List<DemandeAssuranceSpec> listeDemandeAssociees, ConditionChomageInvolontaireSpec conditionSousJacenteKo)
    throws ApplicativeException
  {
    ConditionChomageInvolontaireSpec retour = conditionSousJacenteKo;
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierExamen();
    DossierAffecte dossierAffecte = (DossierAffecte)dossierExamen.getDossierAffecte();
    ValidationProduit validationProduit = dossierAffecte.getValidationProduit();
    FaitGenerateurSpec conditionFaitGenerateur = dossierExamen.getConditionFaitGenerateur();
    ActiviteSalarie faitGenerateur = conditionFaitGenerateur.getPeriodeFaitGenerateur();
    
    OutilConditionChomageInvolontaire outilChomageInvolontaire = new OutilConditionChomageInvolontaire();
    ResultatRechercheConditionChomageInvolontaire resultatConditionChomageInvolontaire = new ResultatRechercheConditionChomageInvolontaire();
    ResultatRechercheConditionChomageInvolontaire resultatConditionAffiliation = outilChomageInvolontaire.etudierJurisprudence(demande, validationProduit.getReglementApplicable(), faitGenerateur, resultatConditionChomageInvolontaire);
    if (resultatConditionAffiliation.isConditionAffiliationVerifiee()) {
      retour = retournerConditionValide(demande);
    }
    return retour;
  }
  
  private static ConditionChomageInvolontaireSpec retournerConditionValide(Demande demande)
  {
    DossierAffectation dossierAffectation = (DossierAffectation)demande.getDossierAffectation();
    DossierExamen dossierExamen = (DossierExamen)dossierAffectation.getDossierExamen();
    
    ConditionChomageInvolontaire conditionChomageInvolontaire = dossierExamen.createConditionChomageInvolontaire();
    conditionChomageInvolontaire.setEtatSatisfait(true);
    
    return conditionChomageInvolontaire;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionChomageInvolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */