package fr.unedic.cali.asu.cge01.revision.outilsfonctionnels.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartielRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjcRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjrRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.conteneurs.ConteneurParcoursRevisionAutomatique;
import fr.unedic.cali.asu.cge01.revision.outilsfonctionnels.strategies.spec.StrategieRevisionAutomatiqueSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.EreRevisionSuitePerteActiviteConservee;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.PensionInvaliditeChainee;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionMontantRevise;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionMontantRevise;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBrutsRevision;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieeMotifDvNonLegitime;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDecisionneeSurDemande;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDemandePourERE;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class StrategieRevisionAutomatiqueAvantARE2014
  implements StrategieRevisionAutomatiqueSpec
{
  public Demande creerDemandeAReviser(ConteneurParcoursRevisionAutomatique conteneur)
    throws CoucheLogiqueException
  {
    Demande demandeAReviserTemporaire = (Demande)conteneur.getDemandeCourante().copie();
    demandeAReviserTemporaire.setDemandeLiquidee(true);
    demandeAReviserTemporaire.setDemandeOrigine(conteneur.getDemandeOrigine());
    EreRevisionSuitePerteActiviteConservee ereRevisionPerteActiviteConservee = new EreRevisionSuitePerteActiviteConservee();
    demandeAReviserTemporaire.setEvenementReferenceExamen(ereRevisionPerteActiviteConservee);
    
    ConstitutionDateAttribution constitutionDateAttributionElementAdmission = ((DossierExamen)demandeAReviserTemporaire.getDossierExamen()).getConstitutionElementsActifs().getConstitutionDateAttribution();
    
    ConstitutionDurees constitutionConstitutionDureesAdmission = ((DossierExamen)demandeAReviserTemporaire.getDossierExamen()).getConstitutionElementsActifs().getConstitutionDurees();
    
    demandeAReviserTemporaire.getDossierExamen().changerEtat(30);
    demandeAReviserTemporaire.getObjectifCourant().setType(30);
    
    ConstitutionDateAttribution constitutionDateAttributionElementRevision = ((DossierExamen)demandeAReviserTemporaire.getDossierExamen()).getConstitutionElementsActifs().createConstitutionDateAttribution();
    
    ConstitutionDurees constitutionConstitutionDureesRevision = ((DossierExamen)demandeAReviserTemporaire.getDossierExamen()).getConstitutionElementsActifs().createConstitutionDurees();
    
    constitutionDateAttributionElementAdmission.copieElements(constitutionDateAttributionElementRevision);
    constitutionConstitutionDureesAdmission.copieElements(constitutionConstitutionDureesRevision);
    return demandeAReviserTemporaire;
  }
  
  public void mettreAJourDemandeRevision(ConteneurParcoursRevisionAutomatique conteneur) {}
  
  public void alimenterDonneesForceesDemandeAReviser(ConteneurParcoursRevisionAutomatique conteneur)
  {
    DonneesTemporaires donneesForceesDemandeAReviserTemporaire = conteneur.getDemandeRevision().getDonneesTemporaires();
    donneesForceesDemandeAReviserTemporaire.setIdentifiantPeriodeActiviteConserveePerdue(conteneur.getActiviteConserveeAReviser().getIdentifiant());
    
    Demande demandeRevision = trouverDemandeRevisionAssociee(conteneur.getDemandeRevision(), conteneur.getActiviteConserveeAReviser().getIdentifiant());
    if (demandeRevision != null)
    {
      DonneesTemporaires donneesForcees = demandeRevision.getDonneesTemporaires();
      donneesForceesDemandeAReviserTemporaire.setSjrPerteActConservee(donneesForcees.getSjrPerteActConservee());
      donneesForceesDemandeAReviserTemporaire.setSjcPerteActConservee(donneesForcees.getSjcPerteActConservee());
      donneesForceesDemandeAReviserTemporaire.setCoefficientTempsPartielActConservee(donneesForcees.getCoefficientTempsPartielActConservee());
    }
  }
  
  private Demande trouverDemandeRevisionAssociee(Demande demandeAReviserTemporaire, String identifiantActiviteConservee)
  {
    FiltreET filtreRevisions = new FiltreET();
    filtreRevisions.ajouterFiltre(new FiltreDemandePourERE("ASU_07"));
    filtreRevisions.ajouterFiltre(new FiltreDecisionneeSurDemande());
    
    Chronologie chronologiesRevision = OutilRecherche.rechercherDemandesPrecedentes(demandeAReviserTemporaire.getChronologieDemandesAssuranceSansCourante(), Damj.FIN_DES_TEMPS, filtreRevisions);
    
    chronologiesRevision.iterer();
    while (chronologiesRevision.encoreSuivant())
    {
      Demande demandeRevision = (Demande)chronologiesRevision.elementSuivant();
      if (identifiantActiviteConservee.equals(demandeRevision.getDonneesTemporaires().getIdentifiantPeriodeActiviteConserveePerdue())) {
        return demandeRevision;
      }
    }
    return null;
  }
  
  public Contexte creerContextePourRevision(ConteneurParcoursRevisionAutomatique conteneur)
  {
    Contexte contexteAReviser = new Contexte();
    DomLiquidationAssurance domLiquidationAssuranceAReviser = new DomLiquidationAssurance();
    domLiquidationAssuranceAReviser.setDemande(conteneur.getDemandeRevision());
    contexteAReviser.setDonnees(domLiquidationAssuranceAReviser);
    return contexteAReviser;
  }
  
  public void reviserActiviteConservee(ConteneurParcoursRevisionAutomatique conteneur)
    throws ApplicativeException
  {
    Damj dateExamenRevision = conteneur.getActiviteConserveeAReviser().getDateFin().lendemain();
    conteneur.getDemandeRevision().getEvenementReferenceExamen().setDateEvenement(dateExamenRevision);
    reviserSjr(conteneur.getContexteRevision());
    
    ConstitutionDateAttribution constitutionDateAttribution = ((DossierExamen)conteneur.getDemandeRevision().getDossierExamen()).getConstitutionElementsActifs().getConstitutionDateAttribution();
    
    Damj dateAttributionSauvegardee = constitutionDateAttribution.getDateAttribution();
    constitutionDateAttribution.setDateAttribution(dateExamenRevision);
    reviserSjc(conteneur.getContexteRevision());
    constitutionDateAttribution.setDateAttribution(dateAttributionSauvegardee);
    
    reviserCoefTp(conteneur.getContexteRevision());
    reviserMontantBrut(conteneur.getContexteRevision());
    
    conteneur.getDemandeRevision().setDemandeOrigine(conteneur.getDemandeCourante());
    ConditionMontantRevise conditionMontantRevise = RechercheConditionMontantRevise.getInstance().rechercherConditionMontantRevise(conteneur.getDemandeRevision());
    if (conditionMontantRevise.estSatisfait())
    {
      copierCepaRevisees(conteneur.getDemandeRevision(), conteneur.getAttributionAReviser());
      
      conteneur.getAttributionAReviser().getConstitutionElementsActifs().getConstitutionSjr().setSjrRevise(Boolean.TRUE);
      
      conteneur.getAttributionAReviser().setElementBaseIndemnisation(null);
    }
  }
  
  private void copierCepaRevisees(Demande demandeAReviserTemporaire, Attribution attributionFinAsr)
  {
    ArrayList<PensionInvaliditeChainee> pensionsInvalidites = new ArrayList();
    if (attributionFinAsr.getListePensionInvalidite() != null)
    {
      Iterator it = attributionFinAsr.getListePensionInvalidite().iterator();
      while (it.hasNext())
      {
        PensionInvaliditeChainee element = (PensionInvaliditeChainee)it.next();
        pensionsInvalidites.add((PensionInvaliditeChainee)element.copie());
      }
    }
    ConstitutionSjr constitutionSjrFinAsrRevise = attributionFinAsr.getConstitutionElementsActifs().createConstitutionSjr();
    ConstitutionSjc constitutionSjcFinAsrRevise = attributionFinAsr.getConstitutionElementsActifs().createConstitutionSjc();
    ConstitutionCoefficientTempsPartiel constitutionCoefficientTPFinAsrRevise = attributionFinAsr.getConstitutionElementsActifs().createConstitutionCoefficientTempsPartiel();
    
    ConstitutionMontantsBruts constitutionMontantBrutFinAsrRevise = attributionFinAsr.getConstitutionElementsActifs().createConstitutionMontantsBruts();
    
    DossierExamen dossierExamenRevise = (DossierExamen)demandeAReviserTemporaire.getDossierExamen();
    dossierExamenRevise.getConstitutionSjr().copieElements(constitutionSjrFinAsrRevise);
    if (dossierExamenRevise.getConstitutionSjc() != null) {
      dossierExamenRevise.getConstitutionSjc().copieElements(constitutionSjcFinAsrRevise);
    }
    dossierExamenRevise.getConstitutionCoefficientTempsPartiel().copieElements(constitutionCoefficientTPFinAsrRevise);
    dossierExamenRevise.getConstitutionMontantsBruts().copieElements(constitutionMontantBrutFinAsrRevise);
    
    constitutionMontantBrutFinAsrRevise.setListePensionInvalidite(pensionsInvalidites);
  }
  
  private void reviserSjr(Contexte contexte)
    throws ApplicativeException
  {
    Parcours parcours = new ParcoursConstitutionSjrRevision();
    parcours.effectuerParcours(contexte);
  }
  
  private void reviserSjc(Contexte contexte)
    throws ApplicativeException
  {
    Parcours parcours = new ParcoursConstitutionSjcRevision();
    parcours.effectuerParcours(contexte);
  }
  
  private void reviserCoefTp(Contexte contexte)
    throws ApplicativeException
  {
    Parcours parcours = new ConstitutionCoefficientTempsPartielRevision();
    parcours.effectuerParcours(contexte);
  }
  
  private void reviserMontantBrut(Contexte contexte)
    throws ApplicativeException
  {
    Parcours parcours = new ConstitutionMontantsBrutsRevision();
    parcours.effectuerParcours(contexte);
  }
  
  public boolean estFCTATraiter(ConteneurParcoursRevisionAutomatique conteneur)
  {
    return (!conteneur.isNouvelleRevisionDroit()) && (estFCTNonDv(conteneur.getActiviteConserveeAReviser()));
  }
  
  private boolean estFCTNonDv(TravailSpec activite)
  {
    FiltreNegation filtreNonDV = new FiltreNegation(new FiltreActiviteSalarieeMotifDvNonLegitime());
    return filtreNonDV.accepter(activite);
  }
}

/* Location:
 * Qualified Name:     StrategieRevisionAutomatiqueAvantARE2014
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */