package fr.unedic.cali.asu.cva10.p01.calcul.pbjc;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.asu.mnt.dom.Accord;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.asu.mnt.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.Readmission;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.Somme;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.ActionFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationASR;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRadiation;
import fr.unedic.cali.calcul.pbjc.FacadePBJCProduitSpec;
import fr.unedic.cali.calcul.pbjc.dom.PbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.Prescription;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.outilsfonctionnels.OutilDemande;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class FacadePBJCProduitImpl
  extends fr.unedic.cali.asu.cge01.p04.calcul.pbjc.FacadePBJCProduitImpl
  implements FacadePBJCProduitSpec
{
  private void ajouterGroupeMontantAREF(PbjcNcp p_pbjcNcp, String p_nomProduit, Somme p_somme, UniteTraitement p_ut)
  {
    ChronologiePeriodes periodes = null;
    ObjetChronoPeriode objetChronoPeriode = null;
    PeriodeFormation periodeFormationCalcul = null;
    
    p_pbjcNcp.ajouterGroupeMontants(p_nomProduit, 1, new BigDecimal("0"), p_somme.getMontant().getMontantBrut().getValeur(), new BigDecimal("1"), p_somme.getMontant().getMontantBrut().getValeur(), "");
    
    periodes = p_ut.getQualificationPeriodes().getPeriodesSegmentantes();
    periodes.iterer();
    while (periodes.encoreSuivant())
    {
      objetChronoPeriode = (ObjetChronoPeriode)periodes.elementSuivant();
      if ((objetChronoPeriode instanceof PeriodeFormation))
      {
        if (objetChronoPeriode.getDateDebut().equals(p_pbjcNcp.getDateDebut())) {
          if (((PeriodeFormation)objetChronoPeriode).getIdentifiantPeriodeFormation() == 1) {
            p_pbjcNcp.ajouterComplementDeJustification("BF");
          } else {
            p_pbjcNcp.ajouterComplementDeJustification("BA");
          }
        }
        if (objetChronoPeriode.getDateFin().equals(p_pbjcNcp.getDateFin()))
        {
          p_pbjcNcp.ajouterComplementDeJustification("TH");
          p_pbjcNcp.ajouterComplementDeJustification("TD");
          
          p_pbjcNcp.setCodeRadiationLendemainPeriode("41");
        }
        if (p_pbjcNcp.chevauche(new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin())))
        {
          periodeFormationCalcul = (PeriodeFormation)objetChronoPeriode;
          p_pbjcNcp.setIdStageFormation(periodeFormationCalcul.getIdentifiantPeriodeFormation());
          p_pbjcNcp.setTypeMesurePourLEmploi(periodeFormationCalcul.getTypeMesureEmploi());
        }
      }
      else if (((objetChronoPeriode instanceof PeriodeInterStageFormation)) && 
        (objetChronoPeriode.getDateDebut().veille().equals(p_pbjcNcp.getDateFin())))
      {
        p_pbjcNcp.ajouterComplementDeJustification("TH");
        p_pbjcNcp.ajouterComplementDeJustification("TD");
      }
    }
    periodes = p_ut.getQualificationPeriodes().getPeriodesNonQualifiees();
    periodes.iterer();
    while (periodes.encoreSuivant())
    {
      objetChronoPeriode = (ObjetChronoPeriode)periodes.elementSuivant();
      if (((objetChronoPeriode instanceof ActionFormation)) && 
        (p_pbjcNcp.chevauche(new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin()))))
      {
        p_pbjcNcp.setIdPlanFormation(((ActionFormation)objetChronoPeriode).getIdentifiantActionFormation());
        
        p_pbjcNcp.setTypeDePlan(((ActionFormation)objetChronoPeriode).getTypePlan());
      }
    }
  }
  
  protected void ajouterGroupeMontantPCRC(PbjcNcp p_pbjcNcp, MontantBaseSpec p_montantBaseSpec)
  {
    MontantAsuSpec montant = (MontantAsuSpec)p_montantBaseSpec;
    
    p_pbjcNcp.ajouterGroupeMontants("PCRC", 0, montant.getSjrNonReduit(), montant.getBaseCalculCrc().setScale(2, 3), Mathematiques.arrondiASup(montant.getTauxCrc().multiply(new BigDecimal("100")), 2), Mathematiques.arrondiASup(montant.getCrc().getValeur(), 2), montant.getPositionExonerationCrc());
    if (montant.getPensionInvaliditeADeduirePriseEnCompte() != null) {
      p_pbjcNcp.setMontantPensionInvalidite(montant.getPensionInvaliditeADeduirePriseEnCompte().getValeur());
    }
  }
  
  public void ajouterGroupeMontantProduit(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, Somme p_somme, UniteTraitement p_ut)
  {
    if ((p_somme.getMontant().getType().equals("FORMATION EFFECTIVE")) || (p_somme.getMontant().getType().equals("FORMATION PREVISIONNELLE"))) {
      ajouterGroupeMontantAREF(p_pbjcNcp, p_attribution.getProduit().getNom(), p_somme, p_ut);
    } else {
      p_pbjcNcp.ajouterGroupeMontants(p_attribution.getProduit().getNom(), 0, new BigDecimal("0"), p_somme.getMontant().getMontantBrut().getValeur(), new BigDecimal("1"), p_somme.getMontant().getMontantBrut().getValeur(), "");
    }
    if (p_pbjcNcp.isTopApplicationCRC()) {
      ajouterGroupeMontantPCRC(p_pbjcNcp, p_somme.getMontant());
    }
  }
  
  public ChronologiePeriodes creerChronologiePBJCsAvant(AttributionSpec p_attribution, Damj p_dateGeneration, Damj p_dateBlocageActualisation, String p_libelleBlocageActualisation)
    throws ApplicativeException
  {
    return new ChronologiePeriodes();
  }
  
  public void positionnerJustificationFermetureDJI(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, UniteTraitement p_ut)
  {
    if (p_ut.getArretProduitAvecRaison().isRaisonsContientRaison(1))
    {
      p_pbjcNcp.ajouterComplementDeJustification("NF");
    }
    else
    {
      Iterator itID = p_ut.getArretProduitAvecRaison().getPeriodesInterruptivesDefinitives().iterator();
      while (itID.hasNext())
      {
        ObjetChronoPeriode periode = (ObjetChronoPeriode)itID.next();
        if ((periode instanceof ObjetChronoPeriodeLimiteIndemnisationASR)) {
          p_pbjcNcp.ajouterComplementDeJustification("NF");
        }
      }
    }
    super.positionnerJustificationFermetureDJI(p_pbjcNcp, p_attribution, p_ut);
  }
  
  public void traiterBlocageActuPourLAvant(PbjcNcp p_pbjcNcpAvant, Damj p_dateBlocageActualisation, String p_libelleBlocageActualisation) {}
  
  public Quantite retournerQuantiteIndemnisationInitialeDroit(AttributionSpec p_attribution, UniteTraitement ut)
  {
    Periode periodeIndemnisation = new Periode(p_attribution.getDateAttribution(), ((Attribution)p_attribution).getDateLimiteIndemnisation());
    return new QuantiteJour(new BigDecimal(periodeIndemnisation.getDuree()));
  }
  
  public void traiterPBJCsAPosteriori(ChronologiePeriodes p_chronoPBJCs, AttributionSpec p_attribution, Chronologie chronoUT)
    throws CoucheLogiqueException
  {
    PbjcNcp pbjcNcp = null;
    PbjcNcp pbjcNcpAvant = null;
    DossierExamen dossierExamen = null;
    Damj dateMaintien = null;
    boolean pbjcTrouvee = false;
    
    ChronologiePeriodes chronologiePeriodesRadiationPEC = OutillagePeriodes.recupererPecsRadiationSuiteEntreeFormation(p_attribution.getDemandeur());
    
    Chronologie demandes = p_attribution.getDemandeur().getChronoDemandeMaintien();
    demandes.iterer();
    while (demandes.encoreSuivant())
    {
      DemandeSpec demandeMaintien = (DemandeSpec)demandes.elementSuivant();
      if (((demandeMaintien instanceof DemandeMaintien)) && (!demandeMaintien.estEnReExamen()) && ((demandeMaintien.getClassementAdministratif() == null) || (((demandeMaintien.getClassementAdministratif() instanceof Prescription)) && (!((Prescription)demandeMaintien.getClassementAdministratif()).isValidite()))))
      {
        dossierExamen = ((DemandeMaintien)demandeMaintien).getDossierExamen();
        if ((dossierExamen != null) && ((dossierExamen instanceof Accord))) {
          dateMaintien = demandeMaintien.getDateEffet();
        }
      }
    }
    p_chronoPBJCs.iterer();
    while (p_chronoPBJCs.encoreSuivant())
    {
      pbjcNcp = (PbjcNcp)p_chronoPBJCs.elementSuivant();
      if ((dateMaintien != null) && (((AttributionAssuranceSpec)p_attribution).estMaintenue()))
      {
        if (pbjcNcp.getDateDebut().estApresOuCoincideAvec(dateMaintien))
        {
          if (pbjcNcp.getDateDebut().coincideAvec(dateMaintien)) {
            pbjcNcp.ajouterComplementDeJustification("B1");
          }
          pbjcTrouvee = true;
        }
        if (pbjcTrouvee) {
          pbjcNcp.setEtatReglementaireOd("5");
        }
      }
      chronologiePeriodesRadiationPEC.iterer();
      while (chronologiePeriodesRadiationPEC.encoreSuivant())
      {
        ObjetChronoPeriodeRadiation periodeRadiation = (ObjetChronoPeriodeRadiation)chronologiePeriodesRadiationPEC.elementSuivant();
        if (periodeRadiation.getDateDebut().veille().coincideAvec(pbjcNcp.getDateFin()))
        {
          pbjcNcp.ajouterComplementDeJustification("TD");
          
          pbjcNcp.setCodeRadiationLendemainPeriode("31");
        }
      }
      if (pbjcNcpAvant != null)
      {
        if (pbjcNcpAvant.getDateFin().coincideAvec(pbjcNcp.getDateDebut().veille()))
        {
          if (pbjcNcp.contientComplementDeJustification("FR")) {
            pbjcNcpAvant.ajouterComplementDeJustification("QF");
          }
          if ((pbjcNcp.getInterrupIndemParPensionInvalidite() != null) && (pbjcNcpAvant.getInterrupIndemParPensionInvalidite() != null))
          {
            if ((pbjcNcp.getInterrupIndemParPensionInvalidite().equals("O")) && 
              (pbjcNcpAvant.getInterrupIndemParPensionInvalidite().equals("N"))) {
              pbjcNcp.ajouterComplementDeJustification("FN");
            }
            if ((pbjcNcp.getInterrupIndemParPensionInvalidite().equals("N")) && 
              (pbjcNcpAvant.getInterrupIndemParPensionInvalidite().equals("O"))) {
              pbjcNcp.ajouterComplementDeJustification("FO");
            }
          }
        }
        if ((pbjcNcpAvant.getMontantCumuleRevaloriseAV() != null) && (pbjcNcpAvant.getMontantCumuleRevaloriseAV().compareTo(new BigDecimal("0")) > 0) && 
          (pbjcNcp.getMontantCumuleRevaloriseAV() != null) && (pbjcNcp.getMontantCumuleRevaloriseAV().compareTo(new BigDecimal("0")) > 0) && 
          (pbjcNcp.getMontantCumuleRevaloriseAV().compareTo(pbjcNcpAvant.getMontantCumuleRevaloriseAV()) != 0) && (!pbjcNcp.contientComplementDeJustification("DG"))) {
          pbjcNcp.ajouterComplementDeJustification("DH");
        }
      }
      if ((pbjcNcp.contientComplementDeJustification("FR")) && (pbjcNcp.getInterrupIndemParPensionInvalidite() != null) && (pbjcNcp.getInterrupIndemParPensionInvalidite().equals("O"))) {
        pbjcNcp.ajouterComplementDeJustification("FN");
      }
      if ((retournerQuantiteIndemnisationInitialeDroit(p_attribution, null).getValeurEntiere() == pbjcNcp.getReliquatDureeMax()) && (pbjcNcp.getNbJoursImputes() != 0)) {
        positionnerJustificationOuverturePJI(pbjcNcp, p_attribution);
      }
      if (pbjcNcpAvant != null) {
        pbjcNcp.setNbJoursAREF(pbjcNcpAvant.getNbJoursAREF());
      }
      if ((pbjcNcp.estEnAref()) && (pbjcNcp.getEtatIndemnisation().compareTo("AVANT") != 0)) {
        pbjcNcp.setNbJoursAREF(pbjcNcp.getNbJoursAREF() + pbjcNcp.getNbJoursImputes());
      }
      pbjcNcpAvant = pbjcNcp;
    }
  }
  
  public ChronologiePeriodes traitementPeriodesSuspensives(ChronologiePeriodes p_periodesSuspensives, UniteTraitement p_ut)
  {
    return p_periodesSuspensives;
  }
  
  public void positionnerJustificationOuverturePJI(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    if ((p_attribution instanceof Readmission)) {
      p_pbjcNcp.ajouterComplementDeJustification("BG");
    } else {
      p_pbjcNcp.ajouterComplementDeJustification("BB");
    }
    AttributionAssuranceSpec assurancePrecedente = ((AttributionAssuranceSpec)p_attribution).getAttributionPrecedente();
    if ((assurancePrecedente != null) && (OutilDemande.estUneDemandeFinDroitAsr(assurancePrecedente.getDemande()))) {
      p_pbjcNcp.ajouterComplementDeJustification("BV");
    }
    super.positionnerJustificationOuverturePJI(p_pbjcNcp, p_attribution);
  }
}

/* Location:
 * Qualified Name:     FacadePBJCProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */