package fr.unedic.cali.asu.cve13.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAssDemandeExpresse;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDVDemandeExpresse;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.DebutActionFormation;
import fr.unedic.cali.calcul.dom.periode.DsmAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.DsmMaladie;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteSalarieSansSalaire;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeClca;
import fr.unedic.cali.calcul.dom.periode.PeriodeClcaOuverte;
import fr.unedic.cali.calcul.dom.periode.PeriodeConflitGAEC;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementBloquant;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.periode.PeriodeInassiduiteFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire50Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire55Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoNonPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeAttributionSecteurPublic;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLendemainDja;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationATP;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodePEC;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodePJI;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRadiation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.outilsfonctionnels.QualificationAbstraite;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class Qualification
  extends QualificationAbstraite
{
  static final int SOIXANTE_ANS = 60;
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes p_chronologiePeriodes, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    QualificationPeriodes qualificationPeriodes = super.qualificationPeriodes(p_chronologiePeriodes, p_attribution);
    return qualificationPeriodes;
  }
  
  protected boolean estTypeAPrendreEnCompte(ObjetChronoPeriode periode)
  {
    return periode instanceof PeriodeActiviteSalarieSansSalaire;
  }
  
  protected boolean qualifierUnePeriodeAlertante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    return false;
  }
  
  protected boolean qualifierUnePeriodeDecalante(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
  {
    if (((p_periode instanceof PeriodeTravailJustifiee)) || ((p_periode instanceof DsmTravail)) || ((p_periode instanceof PeriodePrime))) {
      p_qualificationPeriodes.ajouterPeriodesDecalantes(p_periode);
    } else {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeGelante(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
  {
    if (((p_periode instanceof PeriodeTravailJustifiee)) || ((p_periode instanceof DsmTravail)) || ((p_periode instanceof PeriodePrime)) || ((p_periode instanceof PeriodeAbsenceAuPointage))) {
      p_qualificationPeriodes.ajouterPeriodesGelantes(p_periode);
    } else {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeInterruptives(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
  {
    return false;
  }
  
  protected boolean qualifierUnePeriodeInterruptivesDefinitives(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    if (((p_periode instanceof PeriodeClcaOuverte)) && (p_periode.getDateDebut().estApres(p_attribution.getDateAttribution())))
    {
      p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
    }
    else if ((p_periode instanceof PeriodeConflitGAEC))
    {
      if (!p_attribution.estNeutralise())
      {
        if ((p_attribution.getDateAttribution() != null) && (p_attribution.getDateAttribution().estApres(p_periode.getDateDebut()))) {
          if (p_attribution.getDateAttribution().coincideAvec(p_attribution.getDateAttribution().getFinMois()))
          {
            p_periode.setDateDebut(p_attribution.getDateAttribution().lendemain());
            p_periode.setDateFin(p_attribution.getDateAttribution().lendemain());
          }
          else
          {
            p_periode.setDateDebut(p_attribution.getDateAttribution().getFinMois());
            p_periode.setDateFin(p_attribution.getDateAttribution().getFinMois());
          }
        }
        p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
      }
    }
    else if ((p_periode instanceof PeriodeFormationNonIndemniseeAbsenceHeure))
    {
      if (!p_attribution.estNeutralise())
      {
        if ((p_attribution.getDateAttribution() != null) && (p_attribution.getDateAttribution().estApres(p_periode.getDateDebut()))) {
          p_periode.setDateDebut(p_attribution.getDateAttribution());
        }
        p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
      }
    }
    else if ((p_periode instanceof ObjetChronoPeriodeRadiation))
    {
      ObjetChronoPeriodePriseEnCharge periodePEC = OutillagePeriodes.recupererPeriodePECContenant(p_attribution.getDemandeur(), p_attribution.getDateEffet());
      if (((ObjetChronoPeriodeRadiation)p_periode).getPEC().getPeriode().coincideAvec(new Periode(periodePEC.getDateDebut(), periodePEC.getDateFin()))) {
        p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
      }
    }
    else if ((p_periode instanceof PeriodeBlocageIndemnisation))
    {
      p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
    }
    else if ((p_periode instanceof ObjetChronoPeriodeAssDemandeExpresse))
    {
      p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
    }
    else if ((p_periode instanceof ObjetChronoPeriodeRejetDVDemandeExpresse))
    {
      p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
    }
    else if (((p_periode instanceof ObjetChronoPeriodeAttributionSecteurPublic)) && (!p_attribution.equals(((ObjetChronoPeriodeAttributionSecteurPublic)p_periode).getAttribution())))
    {
      p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
    }
    else if ((p_periode instanceof ObjetChronoPeriodeLimiteIndemnisationATP))
    {
      if (((ObjetChronoPeriodeLimiteIndemnisationATP)p_periode).getRsod().compareTo(p_attribution.getRsod()) == 0) {
        p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
      }
    }
    else if ((p_periode instanceof ObjetChronoPeriodeInterProduits))
    {
      if ((((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("RET_ACO01_01")) && (((ObjetChronoPeriodeInterProduits)p_periode).getTypePeriode() == 2)) {
        p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
      }
    }
    else
    {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSegmentante(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
  {
    if ((p_periode instanceof fr.unedic.cali.calcul.dom.periode.PeriodeFormation))
    {
      if (((fr.unedic.cali.calcul.dom.periode.PeriodeFormation)p_periode).getActionFormation().estBasculeAutoriserEnContexteFormation())
      {
        ObjetChronoPeriodeCalcul periodeFormation = (ObjetChronoPeriodeCalcul)p_periode.copie();
        if ((p_periode.getDateDebut().estAvant(p_attribution.getPji())) && (p_periode.getDateFin().estApres(p_attribution.getPji()))) {
          periodeFormation.setDateDebut(p_attribution.getPji());
        }
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(periodeFormation);
      }
    }
    else if ((p_periode instanceof FinActionFormation))
    {
      IndividuSpec individu = p_attribution.getDemandeur();
      ObjetChronoPeriode periodeActivite = null;
      ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
      chronologiePeriodes.iterer();
      boolean estEncoreEnFormation = false;
      while ((chronologiePeriodes.encoreSuivant()) && (!estEncoreEnFormation))
      {
        periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
        if (((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation)) && (!((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).estAnnulee()) && (((FinActionFormation)p_periode).getActionFormation().getIdentifiantActionFormation() != Integer.parseInt(((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getIdentifiant())) && (p_periode.getDateFin().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin()))) && (p_periode.getDateFin().lendemain().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin())))) {
          estEncoreEnFormation = true;
        }
      }
      if (!estEncoreEnFormation) {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
    }
    else if ((p_periode instanceof DebutActionFormation))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof PeriodeInterStageFormation))
    {
      IndividuSpec individu = p_attribution.getDemandeur();
      Collection listePeriodeAQualifier = new ArrayList();
      ObjetChronoPeriode periodeActivite = null;
      Periode periodeFormation = null;
      ChronologiePeriodes listePeriodesFormations = null;
      
      listePeriodeAQualifier.add(p_periode);
      
      ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
      chronologiePeriodes.iterer();
      while (chronologiePeriodes.encoreSuivant())
      {
        periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
        if ((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation))
        {
          listePeriodesFormations = ((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getListePeriodeFormation();
          listePeriodesFormations.iterer();
          while (listePeriodesFormations.encoreSuivant())
          {
            periodeFormation = ((fr.unedic.cali.autresdoms.ga.dom.PeriodeFormation)listePeriodesFormations.elementSuivant()).getPeriodeEffective();
            if (periodeFormation != null) {
              if (new Periode(periodeFormation.getDebut(), periodeFormation.getFin()).contient(p_periode.getPeriode()))
              {
                listePeriodeAQualifier.remove(p_periode);
              }
              else if (p_periode.getPeriode().contient(new Periode(periodeFormation.getDebut(), periodeFormation.getFin())))
              {
                listePeriodeAQualifier.remove(p_periode);
                PeriodeInterStageFormation periodePremierDecoupage = new PeriodeInterStageFormation();
                if (p_periode.getDateDebut().estAvant(periodeFormation.getDebut().veille()))
                {
                  periodePremierDecoupage.setDateDebut(p_periode.getDateDebut());
                  periodePremierDecoupage.setDateFin(periodeFormation.getDebut().veille());
                  listePeriodeAQualifier.add(periodePremierDecoupage);
                }
                PeriodeInterStageFormation periodeDeuxiemeDecoupage = new PeriodeInterStageFormation();
                if (p_periode.getDateFin().estApres(periodeFormation.getFin().lendemain()))
                {
                  periodeDeuxiemeDecoupage.setDateDebut(periodeFormation.getFin().lendemain());
                  periodeDeuxiemeDecoupage.setDateFin(p_periode.getDateFin());
                  listePeriodeAQualifier.add(periodeDeuxiemeDecoupage);
                }
              }
              else if (p_periode.getPeriode().contient(periodeFormation.getDebut()))
              {
                p_periode.setDateFin(periodeFormation.getDebut().veille());
              }
              else if (p_periode.getPeriode().contient(periodeFormation.getFin()))
              {
                p_periode.setDateDebut(periodeFormation.getFin().lendemain());
              }
            }
          }
        }
      }
      Iterator iterateur = listePeriodeAQualifier.iterator();
      while (iterateur.hasNext())
      {
        ObjetChronoPeriodeCalcul periodeAAjouter = (ObjetChronoPeriodeCalcul)iterateur.next();
        if (periodeAAjouter.getDuree() > 15) {
          p_qualificationPeriodes.ajouterPeriodesSegmentantes(periodeAAjouter);
        }
      }
    }
    else if ((p_periode instanceof PeriodeEvenementBloquant))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof PeriodePensionInvalidite))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof FinPeriodePensionInvalidite))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof PeriodeAvantageVieillesse))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof FinPeriodeAvantageVieillesse))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if (((p_periode instanceof ObjetChronoPeriodeHomogene)) || ((p_periode instanceof ObjetChronoNonPeriodeHomogene)))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if (((p_periode instanceof ObjetChronoAnniversaire50Ans)) || ((p_periode instanceof ObjetChronoAnniversaire55Ans)) || ((p_periode instanceof ObjetChronoAnniversaire60Ans)))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof ObjetChronoPeriodeRetraite))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof ObjetChronoPeriodeLendemainDja))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else if ((p_periode instanceof ObjetChronoPeriodePJI))
    {
      p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
    }
    else
    {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSuspensives(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    if ((p_periode instanceof PeriodeClcaOuverte)) {
      return false;
    }
    if ((p_periode instanceof PeriodeClca))
    {
      if ((p_attribution != null) && (p_periode.getDateDebut().estApres(p_attribution.getDateAttribution()))) {
        p_qualificationPeriodes.ajouterPeriodesSuspensives(p_periode);
      }
    }
    else if (((p_periode instanceof PeriodeEvenementPersonnel)) || ((p_periode instanceof DsmMaladie)) || ((p_periode instanceof PeriodeInassiduiteFormation)) || ((p_periode instanceof DsmAbsenceAuPointage))) {
      p_qualificationPeriodes.ajouterPeriodesSuspensives(p_periode);
    } else {
      return false;
    }
    return true;
  }
}

/* Location:
 * Qualified Name:     Qualification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */