package fr.unedic.cali.asu.cve13.p01.liquidation.parcours;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.OdAssuranceSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.outilsfonctionnels.ContributionsParticulieres;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ContributionParticuliere;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.Indemnite;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.QuantiteMonnaie;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class ParcoursDetecterContributionParticuliere
  extends fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursDetecterContributionParticuliere
{
  public Resultat demarrer(Contexte p_contexte)
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    ContributionParticuliere contributionParticuliere = new ContributionParticuliere();
    if ((ContributionsParticulieres.estDecisionPourAppelDetecContribPart((OdAssuranceSpec)dossierExamenCourant)) && 
      (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demandeCourante.getListContexteDemande(), "IDEATP")))
    {
      ValidationProduit validationProduit = ((DossierAffectation)demandeCourante.getDossierAffectation()).getValidationProduit();
      if ((validationProduit != null) && (validationProduit.isEstProduitValide()) && (validationProduit.getPeriodeValidationProduit() != null))
      {
        Collection listeIndemnites = validationProduit.getPeriodeValidationProduit().getListeIndemnites();
        if (listeIndemnites != null)
        {
          Iterator it = listeIndemnites.iterator();
          while (it.hasNext())
          {
            Indemnite indemnitePeriode = (Indemnite)it.next();
            int typeIndemnite = indemnitePeriode.getTypeIndemnite();
            switch (typeIndemnite)
            {
            case 124: 
              if (indemnitePeriode.getMontant() != null)
              {
                contributionParticuliere.setTopDetectionContributionPreavis(true);
                contributionParticuliere.setMontantPreavisCtp(indemnitePeriode.getMontant().getValeurMontant());
              }
              break;
            case 126: 
              if (indemnitePeriode.getMontant() != null)
              {
                contributionParticuliere.setTopDetectionContributionDif(true);
                BigDecimal salaireHoraireDif = indemnitePeriode.getMontant().getValeurMontant();
                contributionParticuliere.setMontantFormationDifCtp(OutilAsr.calculerSommeAPayerDiff(validationProduit.getPeriodeValidationProduit().getPeriodeActiviteSalarieGaec().getNbHeuresDiff(), salaireHoraireDif));
              }
              break;
            }
          }
        }
      }
      if ((contributionParticuliere.isTopDetectionContributionPreavis()) && (contributionParticuliere.isTopDetectionContributionDif())) {
        contributionParticuliere.setTypeContributionParticuliere(9);
      } else if ((contributionParticuliere.isTopDetectionContributionPreavis()) && (!contributionParticuliere.isTopDetectionContributionDif())) {
        contributionParticuliere.setTypeContributionParticuliere(8);
      } else if ((contributionParticuliere.isTopDetectionContributionDif()) && (!contributionParticuliere.isTopDetectionContributionPreavis())) {
        contributionParticuliere.setTypeContributionParticuliere(10);
      } else {
        contributionParticuliere.setTypeContributionParticuliere(0);
      }
      dossierExamenCourant.setContributionParticuliere(contributionParticuliere);
    }
    OutilTrace.tracerFinParcours();
    return new Resultat();
  }
}

/* Location:
 * Qualified Name:     ParcoursDetecterContributionParticuliere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */