package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.pc.DemandePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ContexteDemandeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_demandePC;
  private String m_typeContexteDemande;
  private String m_sousTypeContexteDemande;
  private Damj m_dateDebutJustifContexte;
  private Damj m_dateFinJustifContexte;
  
  public ContexteDemandeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ContexteDemandeGen() {}
  
  public DomPCSpec getPC()
  {
    return m_demandePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_demandePC)
  {
    m_demandePC = p_demandePC;
  }
  
  protected String rawGetTypeContexteDemande()
  {
    return ((DemandePC)getPC()).getTypeContexteDemande();
  }
  
  public String getTypeContexteDemande()
  {
    return ((DemandePC)getPC()).getTypeContexteDemande();
  }
  
  public void setTypeContexteDemande(String p_typeContexteDemande)
  {
    if ((m_typeContexteDemande == null) || (p_typeContexteDemande == null))
    {
      m_typeContexteDemande = p_typeContexteDemande;
      ((DemandePC)getPC()).setTypeContexteDemande(p_typeContexteDemande);
    }
    else if ((m_typeContexteDemande != null) && (p_typeContexteDemande != null) && (!p_typeContexteDemande.equals(m_typeContexteDemande)))
    {
      m_typeContexteDemande = p_typeContexteDemande;
      ((DemandePC)getPC()).setTypeContexteDemande(p_typeContexteDemande);
    }
  }
  
  protected String rawGetSousTypeContexteDemande()
  {
    return ((DemandePC)getPC()).getSousTypeContexteDemande();
  }
  
  public String getSousTypeContexteDemande()
  {
    return ((DemandePC)getPC()).getSousTypeContexteDemande();
  }
  
  public void setSousTypeContexteDemande(String p_sousTypeContexteDemande)
  {
    if ((m_sousTypeContexteDemande == null) || (p_sousTypeContexteDemande == null))
    {
      m_sousTypeContexteDemande = p_sousTypeContexteDemande;
      ((DemandePC)getPC()).setSousTypeContexteDemande(p_sousTypeContexteDemande);
    }
    else if ((m_sousTypeContexteDemande != null) && (p_sousTypeContexteDemande != null) && (!p_sousTypeContexteDemande.equals(m_sousTypeContexteDemande)))
    {
      m_sousTypeContexteDemande = p_sousTypeContexteDemande;
      ((DemandePC)getPC()).setSousTypeContexteDemande(p_sousTypeContexteDemande);
    }
  }
  
  protected Damj rawGetDateDebutJustifContexte()
  {
    return ((DemandePC)getPC()).getDateDebutJustifContexte();
  }
  
  public Damj getDateDebutJustifContexte()
  {
    return ((DemandePC)getPC()).getDateDebutJustifContexte();
  }
  
  public void setDateDebutJustifContexte(Damj p_dateDebutJustifContexte)
  {
    if ((m_dateDebutJustifContexte == null) || (p_dateDebutJustifContexte == null))
    {
      m_dateDebutJustifContexte = p_dateDebutJustifContexte;
      ((DemandePC)getPC()).setDateDebutJustifContexte(p_dateDebutJustifContexte);
    }
    else if ((m_dateDebutJustifContexte != null) && (p_dateDebutJustifContexte != null) && (!p_dateDebutJustifContexte.equals(m_dateDebutJustifContexte)))
    {
      m_dateDebutJustifContexte = p_dateDebutJustifContexte;
      ((DemandePC)getPC()).setDateDebutJustifContexte(p_dateDebutJustifContexte);
    }
  }
  
  protected Damj rawGetDateFinJustifContexte()
  {
    return ((DemandePC)getPC()).getDateFinJustifContexte();
  }
  
  public Damj getDateFinJustifContexte()
  {
    return ((DemandePC)getPC()).getDateFinJustifContexte();
  }
  
  public void setDateFinJustifContexte(Damj p_dateFinJustifContexte)
  {
    if ((m_dateFinJustifContexte == null) || (p_dateFinJustifContexte == null))
    {
      m_dateFinJustifContexte = p_dateFinJustifContexte;
      ((DemandePC)getPC()).setDateFinJustifContexte(p_dateFinJustifContexte);
    }
    else if ((m_dateFinJustifContexte != null) && (p_dateFinJustifContexte != null) && (!p_dateFinJustifContexte.equals(m_dateFinJustifContexte)))
    {
      m_dateFinJustifContexte = p_dateFinJustifContexte;
      ((DemandePC)getPC()).setDateFinJustifContexte(p_dateFinJustifContexte);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setTypeContexteDemande(null);
    setSousTypeContexteDemande(null);
    setDateDebutJustifContexte(null);
    setDateFinJustifContexte(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ContexteDemandeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */