package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.SousPensionInvaliditeChainee;
import fr.unedic.cali.asu.dom.pc.PensionInvaliditeChaineePC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.ObjetChronoPeriodeCREM;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class PensionInvaliditeChaineeGen
  extends ObjetChronoPeriodeCREM
  implements DomGenSpec
{
  private String m_organismeFinanceur;
  public Collection m_listeSousPensionInvalidite;
  
  public PensionInvaliditeChaineeGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public PensionInvaliditeChaineeGen() {}
  
  protected DomPCSpec createPC()
  {
    return new PensionInvaliditeChaineePC();
  }
  
  protected String rawGetOrganismeFinanceur()
  {
    return ((PensionInvaliditeChaineePC)getPC()).getOrganismeFinanceur();
  }
  
  public String getOrganismeFinanceur()
  {
    return ((PensionInvaliditeChaineePC)getPC()).getOrganismeFinanceur();
  }
  
  public void setOrganismeFinanceur(String p_organismeFinanceur)
  {
    if ((m_organismeFinanceur == null) || (p_organismeFinanceur == null))
    {
      m_organismeFinanceur = p_organismeFinanceur;
      ((PensionInvaliditeChaineePC)getPC()).setOrganismeFinanceur(p_organismeFinanceur);
    }
    else if ((m_organismeFinanceur != null) && (p_organismeFinanceur != null) && (!p_organismeFinanceur.equals(m_organismeFinanceur)))
    {
      m_organismeFinanceur = p_organismeFinanceur;
      ((PensionInvaliditeChaineePC)getPC()).setOrganismeFinanceur(p_organismeFinanceur);
    }
  }
  
  protected int rawGetStatut()
  {
    return ((PensionInvaliditeChaineePC)getPC()).getStatut();
  }
  
  public int getStatut()
  {
    return ((PensionInvaliditeChaineePC)getPC()).getStatut();
  }
  
  public void setStatut(int p_statut)
  {
    ((PensionInvaliditeChaineePC)getPC()).setStatut(p_statut);
  }
  
  private final Collection getCollectionModifiableSousPensionInvalidite()
  {
    Iterator itCollectionPC;
    if (m_listeSousPensionInvalidite == null)
    {
      m_listeSousPensionInvalidite = new ArrayList();
      for (itCollectionPC = ((PensionInvaliditeChaineePC)getPC()).getCollectionSousPensionInvalidite().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listeSousPensionInvalidite.add(currentOM);
      }
    }
    return m_listeSousPensionInvalidite;
  }
  
  public Collection getCollectionSousPensionInvalidite()
  {
    return Collections.unmodifiableCollection(getCollectionModifiableSousPensionInvalidite());
  }
  
  public List getListSousPensionInvalidite()
  {
    return Collections.unmodifiableList((List)getCollectionModifiableSousPensionInvalidite());
  }
  
  public void remplacerCollectionSousPensionInvalidite(Collection p_collectionACopier)
  {
    clearCollectionSousPensionInvalidite();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      SousPensionInvaliditeChainee objet = (SousPensionInvaliditeChainee)i.next();
      ajouterSousPensionInvalidite(objet);
    }
  }
  
  public void supprimerSousCollectionSousPensionInvalidite(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      SousPensionInvaliditeChainee objet = (SousPensionInvaliditeChainee)i.next();
      supprimerSousPensionInvalidite(objet);
    }
  }
  
  public void ajouterSousPensionInvalidite(SousPensionInvaliditeChainee p_sousPensionInvalidite)
    throws NullPointerException
  {
    if (p_sousPensionInvalidite == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_sousPensionInvalidite ne devrait pas être nul.", p_sousPensionInvalidite);
    }
    getCollectionModifiableSousPensionInvalidite().add(p_sousPensionInvalidite);
    ((PensionInvaliditeChaineePC)getPC()).ajouterSousPensionInvalidite(p_sousPensionInvalidite.getPC());
  }
  
  public void supprimerSousPensionInvalidite(SousPensionInvaliditeChainee p_sousPensionInvalidite)
    throws NullPointerException
  {
    if (p_sousPensionInvalidite == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_sousPensionInvalidite ne devrait pas être nul.", p_sousPensionInvalidite);
    }
    getCollectionModifiableSousPensionInvalidite().remove(p_sousPensionInvalidite);
    ((PensionInvaliditeChaineePC)getPC()).supprimerSousPensionInvalidite(p_sousPensionInvalidite.getPC());
  }
  
  public void recopierCollectionSousPensionInvaliditeVers(ObjetMetierSpec p_copie)
  {
    PensionInvaliditeChaineeGen copie = (PensionInvaliditeChaineeGen)p_copie;
    Collection listeACopier = getCollectionSousPensionInvalidite();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterSousPensionInvalidite((SousPensionInvaliditeChainee)objet);
    }
  }
  
  public void clearCollectionSousPensionInvalidite()
  {
    getCollectionModifiableSousPensionInvalidite().clear();
    ((PensionInvaliditeChaineePC)getPC()).getCollectionSousPensionInvalidite().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
    for (Iterator iter = getCollectionSousPensionInvalidite().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     PensionInvaliditeChaineeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */