package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.pc.PeriodeElementairePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public abstract class PeriodeElementaireGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_periodeElementairePC;
  private Periode m_periodePE;
  private BigDecimal m_intensite;
  private Quantite m_quantiteInitialeHeure;
  private Quantite m_quantitePlafonnee;
  private Quantite m_quantiteRetenue;
  private String m_idPeriodeActivite;
  private String m_reglement;
  private String m_raisonSociale;
  private Periode m_periodeActiviteSalariee;
  
  public PeriodeElementaireGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public PeriodeElementaireGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new PeriodeElementairePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_periodeElementairePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_periodeElementairePC)
  {
    m_periodeElementairePC = p_periodeElementairePC;
  }
  
  protected Periode rawGetPeriodePE()
  {
    return ((PeriodeElementairePC)getPC()).getPeriodePE();
  }
  
  public Periode getPeriodePE()
  {
    return ((PeriodeElementairePC)getPC()).getPeriodePE();
  }
  
  public void setPeriodePE(Periode p_periodePE)
  {
    if ((m_periodePE == null) || (p_periodePE == null))
    {
      m_periodePE = p_periodePE;
      ((PeriodeElementairePC)getPC()).setPeriodePE(p_periodePE);
    }
    else if ((m_periodePE != null) && (p_periodePE != null) && (!p_periodePE.equals(m_periodePE)))
    {
      m_periodePE = p_periodePE;
      ((PeriodeElementairePC)getPC()).setPeriodePE(p_periodePE);
    }
  }
  
  protected BigDecimal rawGetIntensite()
  {
    return ((PeriodeElementairePC)getPC()).getIntensite();
  }
  
  public BigDecimal getIntensite()
  {
    return ((PeriodeElementairePC)getPC()).getIntensite();
  }
  
  public void setIntensite(BigDecimal p_intensite)
  {
    if ((m_intensite == null) || (p_intensite == null))
    {
      m_intensite = p_intensite;
      ((PeriodeElementairePC)getPC()).setIntensite(p_intensite);
    }
    else if ((m_intensite != null) && (p_intensite != null) && (!p_intensite.equals(m_intensite)))
    {
      m_intensite = p_intensite;
      ((PeriodeElementairePC)getPC()).setIntensite(p_intensite);
    }
  }
  
  protected int rawGetNature()
  {
    return ((PeriodeElementairePC)getPC()).getNature();
  }
  
  public int getNature()
  {
    return ((PeriodeElementairePC)getPC()).getNature();
  }
  
  public void setNature(int p_nature)
  {
    ((PeriodeElementairePC)getPC()).setNature(p_nature);
  }
  
  protected Quantite rawGetQuantiteInitialeHeure()
  {
    return ((PeriodeElementairePC)getPC()).getQuantiteInitialeHeure();
  }
  
  public Quantite getQuantiteInitialeHeure()
  {
    return ((PeriodeElementairePC)getPC()).getQuantiteInitialeHeure();
  }
  
  public void setQuantiteInitialeHeure(Quantite p_quantiteInitialeHeure)
  {
    if ((m_quantiteInitialeHeure == null) || (p_quantiteInitialeHeure == null))
    {
      m_quantiteInitialeHeure = p_quantiteInitialeHeure;
      ((PeriodeElementairePC)getPC()).setQuantiteInitialeHeure(p_quantiteInitialeHeure);
    }
    else if ((m_quantiteInitialeHeure != null) && (p_quantiteInitialeHeure != null) && (!p_quantiteInitialeHeure.equals(m_quantiteInitialeHeure)))
    {
      m_quantiteInitialeHeure = p_quantiteInitialeHeure;
      ((PeriodeElementairePC)getPC()).setQuantiteInitialeHeure(p_quantiteInitialeHeure);
    }
  }
  
  protected Quantite rawGetQuantitePlafonnee()
  {
    return ((PeriodeElementairePC)getPC()).getQuantitePlafonnee();
  }
  
  public Quantite getQuantitePlafonnee()
  {
    return ((PeriodeElementairePC)getPC()).getQuantitePlafonnee();
  }
  
  public void setQuantitePlafonnee(Quantite p_quantitePlafonnee)
  {
    if ((m_quantitePlafonnee == null) || (p_quantitePlafonnee == null))
    {
      m_quantitePlafonnee = p_quantitePlafonnee;
      ((PeriodeElementairePC)getPC()).setQuantitePlafonnee(p_quantitePlafonnee);
    }
    else if ((m_quantitePlafonnee != null) && (p_quantitePlafonnee != null) && (!p_quantitePlafonnee.equals(m_quantitePlafonnee)))
    {
      m_quantitePlafonnee = p_quantitePlafonnee;
      ((PeriodeElementairePC)getPC()).setQuantitePlafonnee(p_quantitePlafonnee);
    }
  }
  
  protected Quantite rawGetQuantiteRetenue()
  {
    return ((PeriodeElementairePC)getPC()).getQuantiteRetenue();
  }
  
  public Quantite getQuantiteRetenue()
  {
    return ((PeriodeElementairePC)getPC()).getQuantiteRetenue();
  }
  
  public void setQuantiteRetenue(Quantite p_quantiteRetenue)
  {
    if ((m_quantiteRetenue == null) || (p_quantiteRetenue == null))
    {
      m_quantiteRetenue = p_quantiteRetenue;
      ((PeriodeElementairePC)getPC()).setQuantiteRetenue(p_quantiteRetenue);
    }
    else if ((m_quantiteRetenue != null) && (p_quantiteRetenue != null) && (!p_quantiteRetenue.equals(m_quantiteRetenue)))
    {
      m_quantiteRetenue = p_quantiteRetenue;
      ((PeriodeElementairePC)getPC()).setQuantiteRetenue(p_quantiteRetenue);
    }
  }
  
  protected String rawGetIdPeriodeActivite()
  {
    return ((PeriodeElementairePC)getPC()).getIdPeriodeActivite();
  }
  
  public String getIdPeriodeActivite()
  {
    return ((PeriodeElementairePC)getPC()).getIdPeriodeActivite();
  }
  
  public void setIdPeriodeActivite(String p_idPeriodeActivite)
  {
    if ((m_idPeriodeActivite == null) || (p_idPeriodeActivite == null))
    {
      m_idPeriodeActivite = p_idPeriodeActivite;
      ((PeriodeElementairePC)getPC()).setIdPeriodeActivite(p_idPeriodeActivite);
    }
    else if ((m_idPeriodeActivite != null) && (p_idPeriodeActivite != null) && (!p_idPeriodeActivite.equals(m_idPeriodeActivite)))
    {
      m_idPeriodeActivite = p_idPeriodeActivite;
      ((PeriodeElementairePC)getPC()).setIdPeriodeActivite(p_idPeriodeActivite);
    }
  }
  
  protected String rawGetReglement()
  {
    return ((PeriodeElementairePC)getPC()).getReglement();
  }
  
  public String getReglement()
  {
    return ((PeriodeElementairePC)getPC()).getReglement();
  }
  
  public void setReglement(String p_reglement)
  {
    if ((m_reglement == null) || (p_reglement == null))
    {
      m_reglement = p_reglement;
      ((PeriodeElementairePC)getPC()).setReglement(p_reglement);
    }
    else if ((m_reglement != null) && (p_reglement != null) && (!p_reglement.equals(m_reglement)))
    {
      m_reglement = p_reglement;
      ((PeriodeElementairePC)getPC()).setReglement(p_reglement);
    }
  }
  
  protected String rawGetRaisonSociale()
  {
    return ((PeriodeElementairePC)getPC()).getRaisonSociale();
  }
  
  public String getRaisonSociale()
  {
    return ((PeriodeElementairePC)getPC()).getRaisonSociale();
  }
  
  public void setRaisonSociale(String p_raisonSociale)
  {
    if ((m_raisonSociale == null) || (p_raisonSociale == null))
    {
      m_raisonSociale = p_raisonSociale;
      ((PeriodeElementairePC)getPC()).setRaisonSociale(p_raisonSociale);
    }
    else if ((m_raisonSociale != null) && (p_raisonSociale != null) && (!p_raisonSociale.equals(m_raisonSociale)))
    {
      m_raisonSociale = p_raisonSociale;
      ((PeriodeElementairePC)getPC()).setRaisonSociale(p_raisonSociale);
    }
  }
  
  protected Periode rawGetPeriodeActiviteSalariee()
  {
    return ((PeriodeElementairePC)getPC()).getPeriodeActiviteSalariee();
  }
  
  public Periode getPeriodeActiviteSalariee()
  {
    return ((PeriodeElementairePC)getPC()).getPeriodeActiviteSalariee();
  }
  
  public void setPeriodeActiviteSalariee(Periode p_periodeActiviteSalariee)
  {
    if ((m_periodeActiviteSalariee == null) || (p_periodeActiviteSalariee == null))
    {
      m_periodeActiviteSalariee = p_periodeActiviteSalariee;
      ((PeriodeElementairePC)getPC()).setPeriodeActiviteSalariee(p_periodeActiviteSalariee);
    }
    else if ((m_periodeActiviteSalariee != null) && (p_periodeActiviteSalariee != null) && (!p_periodeActiviteSalariee.equals(m_periodeActiviteSalariee)))
    {
      m_periodeActiviteSalariee = p_periodeActiviteSalariee;
      ((PeriodeElementairePC)getPC()).setPeriodeActiviteSalariee(p_periodeActiviteSalariee);
    }
  }
  
  protected boolean rawIsEstSanctionnee()
  {
    return ((PeriodeElementairePC)getPC()).isEstSanctionnee();
  }
  
  public boolean isEstSanctionnee()
  {
    return ((PeriodeElementairePC)getPC()).isEstSanctionnee();
  }
  
  public void setEstSanctionnee(boolean p_estSanctionnee)
  {
    ((PeriodeElementairePC)getPC()).setEstSanctionnee(p_estSanctionnee);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     PeriodeElementaireGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */