package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.ElementSemaineCivile;
import fr.unedic.cali.asu.dom.pc.SemaineCivilePC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class SemaineCivileGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_semaineCivilePC;
  private Periode m_periode;
  public Collection m_elementSemaineCivile;
  
  public SemaineCivileGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public SemaineCivileGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new SemaineCivilePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_semaineCivilePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_semaineCivilePC)
  {
    m_semaineCivilePC = p_semaineCivilePC;
  }
  
  protected int rawGetQuantiteRetenue()
  {
    return ((SemaineCivilePC)getPC()).getQuantiteRetenue();
  }
  
  public int getQuantiteRetenue()
  {
    return ((SemaineCivilePC)getPC()).getQuantiteRetenue();
  }
  
  public void setQuantiteRetenue(int p_quantiteRetenue)
  {
    ((SemaineCivilePC)getPC()).setQuantiteRetenue(p_quantiteRetenue);
  }
  
  protected int rawGetTotalJoursTravailles()
  {
    return ((SemaineCivilePC)getPC()).getTotalJoursTravailles();
  }
  
  public int getTotalJoursTravailles()
  {
    return ((SemaineCivilePC)getPC()).getTotalJoursTravailles();
  }
  
  public void setTotalJoursTravailles(int p_totalJoursTravailles)
  {
    ((SemaineCivilePC)getPC()).setTotalJoursTravailles(p_totalJoursTravailles);
  }
  
  protected int rawGetNombreJoursEmploi()
  {
    return ((SemaineCivilePC)getPC()).getNombreJoursEmploi();
  }
  
  public int getNombreJoursEmploi()
  {
    return ((SemaineCivilePC)getPC()).getNombreJoursEmploi();
  }
  
  public void setNombreJoursEmploi(int p_nombreJoursEmploi)
  {
    ((SemaineCivilePC)getPC()).setNombreJoursEmploi(p_nombreJoursEmploi);
  }
  
  protected boolean rawIsEstSanctionne()
  {
    return ((SemaineCivilePC)getPC()).isEstSanctionne();
  }
  
  public boolean isEstSanctionne()
  {
    return ((SemaineCivilePC)getPC()).isEstSanctionne();
  }
  
  public void setEstSanctionne(boolean p_estSanctionne)
  {
    ((SemaineCivilePC)getPC()).setEstSanctionne(p_estSanctionne);
  }
  
  protected Periode rawGetPeriode()
  {
    return ((SemaineCivilePC)getPC()).getPeriode();
  }
  
  public Periode getPeriode()
  {
    return ((SemaineCivilePC)getPC()).getPeriode();
  }
  
  public void setPeriode(Periode p_periode)
  {
    if ((m_periode == null) || (p_periode == null))
    {
      m_periode = p_periode;
      ((SemaineCivilePC)getPC()).setPeriode(p_periode);
    }
    else if ((m_periode != null) && (p_periode != null) && (!p_periode.equals(m_periode)))
    {
      m_periode = p_periode;
      ((SemaineCivilePC)getPC()).setPeriode(p_periode);
    }
  }
  
  private final Collection getCollectionModifiableElementSemaineCivile()
  {
    Iterator itCollectionPC;
    if (m_elementSemaineCivile == null)
    {
      m_elementSemaineCivile = new ArrayList();
      for (itCollectionPC = ((SemaineCivilePC)getPC()).getCollectionElementSemaineCivile().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_elementSemaineCivile.add(currentOM);
      }
    }
    return m_elementSemaineCivile;
  }
  
  public Collection getCollectionElementSemaineCivile()
  {
    return Collections.unmodifiableCollection(getCollectionModifiableElementSemaineCivile());
  }
  
  public List getListElementSemaineCivile()
  {
    return Collections.unmodifiableList((List)getCollectionModifiableElementSemaineCivile());
  }
  
  public void remplacerCollectionElementSemaineCivile(Collection p_collectionACopier)
  {
    clearCollectionElementSemaineCivile();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      ElementSemaineCivile objet = (ElementSemaineCivile)i.next();
      ajouterElementSemaineCivile(objet);
    }
  }
  
  public void supprimerSousCollectionElementSemaineCivile(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      ElementSemaineCivile objet = (ElementSemaineCivile)i.next();
      supprimerElementSemaineCivile(objet);
    }
  }
  
  public void ajouterElementSemaineCivile(ElementSemaineCivile p_elementSemaineCivile)
    throws NullPointerException
  {
    if (p_elementSemaineCivile == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_elementSemaineCivile ne devrait pas être nul.", p_elementSemaineCivile);
    }
    getCollectionModifiableElementSemaineCivile().add(p_elementSemaineCivile);
    ((SemaineCivilePC)getPC()).ajouterElementSemaineCivile(p_elementSemaineCivile.getPC());
  }
  
  public void supprimerElementSemaineCivile(ElementSemaineCivile p_elementSemaineCivile)
    throws NullPointerException
  {
    if (p_elementSemaineCivile == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_elementSemaineCivile ne devrait pas être nul.", p_elementSemaineCivile);
    }
    getCollectionModifiableElementSemaineCivile().remove(p_elementSemaineCivile);
    ((SemaineCivilePC)getPC()).supprimerElementSemaineCivile(p_elementSemaineCivile.getPC());
  }
  
  public void recopierCollectionElementSemaineCivileVers(ObjetMetierSpec p_copie)
  {
    SemaineCivileGen copie = (SemaineCivileGen)p_copie;
    Collection listeACopier = getCollectionElementSemaineCivile();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterElementSemaineCivile((ElementSemaineCivile)objet);
    }
  }
  
  public void clearCollectionElementSemaineCivile()
  {
    getCollectionModifiableElementSemaineCivile().clear();
    ((SemaineCivilePC)getPC()).getCollectionElementSemaineCivile().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionElementSemaineCivile().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     SemaineCivileGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */