package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.JustificationAffiliation;
import fr.unedic.cali.asu.dom.JustificationAffiliationJoursTravailles;
import fr.unedic.cali.asu.dom.pc.ValidationProduitPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public abstract class ValidationProduitGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_validationProduitPC;
  private String m_identifiantPeriodeValidationProduit;
  private Quantite m_qteAcquise;
  private String m_nomReglementApplicable;
  private Damj m_dateFinPeriode;
  private String m_motifFinPeriode;
  private Damj m_djtpPeriode;
  private Periode m_periodePra;
  public JustificationAffiliation m_justificationCalculAffiliation;
  public JustificationAffiliationJoursTravailles m_justificationAffiliationJoursTravailles;
  
  public ValidationProduitGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ValidationProduitGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ValidationProduitPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_validationProduitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_validationProduitPC)
  {
    m_validationProduitPC = p_validationProduitPC;
  }
  
  protected String rawGetIdentifiantPeriodeValidationProduit()
  {
    return ((ValidationProduitPC)getPC()).getIdentifiantPeriodeValidationProduit();
  }
  
  public String getIdentifiantPeriodeValidationProduit()
  {
    return ((ValidationProduitPC)getPC()).getIdentifiantPeriodeValidationProduit();
  }
  
  public void setIdentifiantPeriodeValidationProduit(String p_identifiantPeriodeValidationProduit)
  {
    if ((m_identifiantPeriodeValidationProduit == null) || (p_identifiantPeriodeValidationProduit == null))
    {
      m_identifiantPeriodeValidationProduit = p_identifiantPeriodeValidationProduit;
      ((ValidationProduitPC)getPC()).setIdentifiantPeriodeValidationProduit(p_identifiantPeriodeValidationProduit);
    }
    else if ((m_identifiantPeriodeValidationProduit != null) && (p_identifiantPeriodeValidationProduit != null) && (!p_identifiantPeriodeValidationProduit.equals(m_identifiantPeriodeValidationProduit)))
    {
      m_identifiantPeriodeValidationProduit = p_identifiantPeriodeValidationProduit;
      ((ValidationProduitPC)getPC()).setIdentifiantPeriodeValidationProduit(p_identifiantPeriodeValidationProduit);
    }
  }
  
  protected Quantite rawGetQteAcquise()
  {
    return ((ValidationProduitPC)getPC()).getQteAcquise();
  }
  
  public Quantite getQteAcquise()
  {
    return ((ValidationProduitPC)getPC()).getQteAcquise();
  }
  
  public void setQteAcquise(Quantite p_qteAcquise)
  {
    if ((m_qteAcquise == null) || (p_qteAcquise == null))
    {
      m_qteAcquise = p_qteAcquise;
      ((ValidationProduitPC)getPC()).setQteAcquise(p_qteAcquise);
    }
    else if ((m_qteAcquise != null) && (p_qteAcquise != null) && (!p_qteAcquise.equals(m_qteAcquise)))
    {
      m_qteAcquise = p_qteAcquise;
      ((ValidationProduitPC)getPC()).setQteAcquise(p_qteAcquise);
    }
  }
  
  protected String rawGetNomReglementApplicable()
  {
    return ((ValidationProduitPC)getPC()).getNomReglementApplicable();
  }
  
  public String getNomReglementApplicable()
  {
    return ((ValidationProduitPC)getPC()).getNomReglementApplicable();
  }
  
  public void setNomReglementApplicable(String p_nomReglementApplicable)
  {
    if ((m_nomReglementApplicable == null) || (p_nomReglementApplicable == null))
    {
      m_nomReglementApplicable = p_nomReglementApplicable;
      ((ValidationProduitPC)getPC()).setNomReglementApplicable(p_nomReglementApplicable);
    }
    else if ((m_nomReglementApplicable != null) && (p_nomReglementApplicable != null) && (!p_nomReglementApplicable.equals(m_nomReglementApplicable)))
    {
      m_nomReglementApplicable = p_nomReglementApplicable;
      ((ValidationProduitPC)getPC()).setNomReglementApplicable(p_nomReglementApplicable);
    }
  }
  
  protected Damj rawGetDateFinPeriode()
  {
    return ((ValidationProduitPC)getPC()).getDateFinPeriode();
  }
  
  public Damj getDateFinPeriode()
  {
    return ((ValidationProduitPC)getPC()).getDateFinPeriode();
  }
  
  public void setDateFinPeriode(Damj p_dateFinPeriode)
  {
    if ((m_dateFinPeriode == null) || (p_dateFinPeriode == null))
    {
      m_dateFinPeriode = p_dateFinPeriode;
      ((ValidationProduitPC)getPC()).setDateFinPeriode(p_dateFinPeriode);
    }
    else if ((m_dateFinPeriode != null) && (p_dateFinPeriode != null) && (!p_dateFinPeriode.equals(m_dateFinPeriode)))
    {
      m_dateFinPeriode = p_dateFinPeriode;
      ((ValidationProduitPC)getPC()).setDateFinPeriode(p_dateFinPeriode);
    }
  }
  
  protected String rawGetMotifFinPeriode()
  {
    return ((ValidationProduitPC)getPC()).getMotifFinPeriode();
  }
  
  public String getMotifFinPeriode()
  {
    return ((ValidationProduitPC)getPC()).getMotifFinPeriode();
  }
  
  public void setMotifFinPeriode(String p_motifFinPeriode)
  {
    if ((m_motifFinPeriode == null) || (p_motifFinPeriode == null))
    {
      m_motifFinPeriode = p_motifFinPeriode;
      ((ValidationProduitPC)getPC()).setMotifFinPeriode(p_motifFinPeriode);
    }
    else if ((m_motifFinPeriode != null) && (p_motifFinPeriode != null) && (!p_motifFinPeriode.equals(m_motifFinPeriode)))
    {
      m_motifFinPeriode = p_motifFinPeriode;
      ((ValidationProduitPC)getPC()).setMotifFinPeriode(p_motifFinPeriode);
    }
  }
  
  protected Damj rawGetDjtpPeriode()
  {
    return ((ValidationProduitPC)getPC()).getDjtpPeriode();
  }
  
  public Damj getDjtpPeriode()
  {
    return ((ValidationProduitPC)getPC()).getDjtpPeriode();
  }
  
  public void setDjtpPeriode(Damj p_djtpPeriode)
  {
    if ((m_djtpPeriode == null) || (p_djtpPeriode == null))
    {
      m_djtpPeriode = p_djtpPeriode;
      ((ValidationProduitPC)getPC()).setDjtpPeriode(p_djtpPeriode);
    }
    else if ((m_djtpPeriode != null) && (p_djtpPeriode != null) && (!p_djtpPeriode.equals(m_djtpPeriode)))
    {
      m_djtpPeriode = p_djtpPeriode;
      ((ValidationProduitPC)getPC()).setDjtpPeriode(p_djtpPeriode);
    }
  }
  
  protected int rawGetCodeProduitValide()
  {
    return ((ValidationProduitPC)getPC()).getCodeProduitValide();
  }
  
  public int getCodeProduitValide()
  {
    return ((ValidationProduitPC)getPC()).getCodeProduitValide();
  }
  
  public void setCodeProduitValide(int p_codeProduitValide)
  {
    ((ValidationProduitPC)getPC()).setCodeProduitValide(p_codeProduitValide);
  }
  
  protected Periode rawGetPeriodePra()
  {
    return ((ValidationProduitPC)getPC()).getPeriodePra();
  }
  
  public Periode getPeriodePra()
  {
    return ((ValidationProduitPC)getPC()).getPeriodePra();
  }
  
  public void setPeriodePra(Periode p_periodePra)
  {
    if ((m_periodePra == null) || (p_periodePra == null))
    {
      m_periodePra = p_periodePra;
      ((ValidationProduitPC)getPC()).setPeriodePra(p_periodePra);
    }
    else if ((m_periodePra != null) && (p_periodePra != null) && (!p_periodePra.equals(m_periodePra)))
    {
      m_periodePra = p_periodePra;
      ((ValidationProduitPC)getPC()).setPeriodePra(p_periodePra);
    }
  }
  
  protected int rawGetCatEmploiPart()
  {
    return ((ValidationProduitPC)getPC()).getCatEmploiPart();
  }
  
  public int getCatEmploiPart()
  {
    return ((ValidationProduitPC)getPC()).getCatEmploiPart();
  }
  
  public void setCatEmploiPart(int p_catEmploiPart)
  {
    ((ValidationProduitPC)getPC()).setCatEmploiPart(p_catEmploiPart);
  }
  
  protected int rawGetPopOccHorsFrance()
  {
    return ((ValidationProduitPC)getPC()).getPopOccHorsFrance();
  }
  
  public int getPopOccHorsFrance()
  {
    return ((ValidationProduitPC)getPC()).getPopOccHorsFrance();
  }
  
  public void setPopOccHorsFrance(int p_popOccHorsFrance)
  {
    ((ValidationProduitPC)getPC()).setPopOccHorsFrance(p_popOccHorsFrance);
  }
  
  public JustificationAffiliation getJustificationCalculAffiliation()
  {
    if (m_justificationCalculAffiliation == null)
    {
      DomPCSpec justificationCalculAffiliationPC = ((ValidationProduitPC)getPC()).getJustificationCalculAffiliation();
      if (justificationCalculAffiliationPC != null) {
        m_justificationCalculAffiliation = ((JustificationAffiliation)justificationCalculAffiliationPC.createOM());
      }
    }
    return m_justificationCalculAffiliation;
  }
  
  public void setJustificationCalculAffiliation(JustificationAffiliation p_justificationCalculAffiliation)
  {
    if (p_justificationCalculAffiliation == null)
    {
      ((ValidationProduitPC)getPC()).setJustificationCalculAffiliation(null);
      m_justificationCalculAffiliation = p_justificationCalculAffiliation;
    }
    else if (!p_justificationCalculAffiliation.equals(m_justificationCalculAffiliation))
    {
      ((ValidationProduitPC)getPC()).setJustificationCalculAffiliation(p_justificationCalculAffiliation.getPC());
      m_justificationCalculAffiliation = p_justificationCalculAffiliation;
    }
  }
  
  public JustificationAffiliationJoursTravailles getJustificationAffiliationJoursTravailles()
  {
    if (m_justificationAffiliationJoursTravailles == null)
    {
      DomPCSpec justificationAffiliationJoursTravaillesPC = ((ValidationProduitPC)getPC()).getJustificationAffiliationJoursTravailles();
      if (justificationAffiliationJoursTravaillesPC != null) {
        m_justificationAffiliationJoursTravailles = ((JustificationAffiliationJoursTravailles)justificationAffiliationJoursTravaillesPC.createOM());
      }
    }
    return m_justificationAffiliationJoursTravailles;
  }
  
  public void setJustificationAffiliationJoursTravailles(JustificationAffiliationJoursTravailles p_justificationAffiliationJoursTravailles)
  {
    if (p_justificationAffiliationJoursTravailles == null)
    {
      ((ValidationProduitPC)getPC()).setJustificationAffiliationJoursTravailles(null);
      m_justificationAffiliationJoursTravailles = p_justificationAffiliationJoursTravailles;
    }
    else if (!p_justificationAffiliationJoursTravailles.equals(m_justificationAffiliationJoursTravailles))
    {
      ((ValidationProduitPC)getPC()).setJustificationAffiliationJoursTravailles(p_justificationAffiliationJoursTravailles.getPC());
      m_justificationAffiliationJoursTravailles = p_justificationAffiliationJoursTravailles;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object justificationCalculAffiliation = getJustificationCalculAffiliation();
    if ((justificationCalculAffiliation != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(justificationCalculAffiliation))) {
      DomManager.supprimer(getJustificationCalculAffiliation(), p_contexteSuppression);
    }
    Object justificationAffiliationJoursTravailles = getJustificationAffiliationJoursTravailles();
    if ((justificationAffiliationJoursTravailles != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(justificationAffiliationJoursTravailles))) {
      DomManager.supprimer(getJustificationAffiliationJoursTravailles(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ValidationProduitGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */