package fr.unedic.cali.asu.dom.pc;

import fr.unedic.transverse.dom.spec.DomPCSpec;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public abstract class DossierAffectationPC
  implements DomPCSpec, PersistenceCapable
{
  protected DemandePC m_demande;
  protected ValidationProduitPC m_validationProduit;
  protected String m_identifiantSinistre;
  protected DelaiRechercheProduitPC m_delaiRecherche;
  protected String m_idDecorReglementaire;
  protected int m_codeProduitSecours;
  protected int m_justificationAffectation;
  protected int m_typeDossier;
  private String m_typeDossierExamen;
  protected int m_codeProduitExecutable;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_demande", "m_validationProduit", "m_identifiantSinistre", "m_delaiRecherche", "m_idDecorReglementaire", "m_codeProduitSecours", "m_justificationAffectation", "m_typeDossier", "m_typeDossierExamen", "m_codeProduitExecutable" };
  private static Class[] jdoFieldTypes = { DemandePC.class, ValidationProduitPC.class, String.class, DelaiRechercheProduitPC.class, String.class, Integer.TYPE, Integer.TYPE, Integer.TYPE, String.class, Integer.TYPE };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public DossierAffectationPC()
  {
    jdoSetm_validationProduit(this, null);
    jdoSetm_identifiantSinistre(this, null);
    jdoSetm_delaiRecherche(this, null);
    
    jdoSetm_justificationAffectation(this, -1);
    jdoSetm_typeDossier(this, 1);
    jdoSetm_typeDossierExamen(this, null);
  }
  
  public abstract Object createOM();
  
  public DomPCSpec getDemande()
  {
    return jdoGetm_demande(this);
  }
  
  public final void setDemande(DomPCSpec p_demande)
  {
    jdoSetm_demande(this, (DemandePC)p_demande);
  }
  
  public DomPCSpec getValidationProduit()
  {
    return jdoGetm_validationProduit(this);
  }
  
  public final void setValidationProduit(DomPCSpec p_validationProduit)
  {
    jdoSetm_validationProduit(this, (ValidationProduitPC)p_validationProduit);
  }
  
  public String getIdentifiantSinistre()
  {
    return jdoGetm_identifiantSinistre(this);
  }
  
  public final void setIdentifiantSinistre(String p_identifiantSinistre)
  {
    jdoSetm_identifiantSinistre(this, p_identifiantSinistre);
  }
  
  public DomPCSpec getDelaiRecherche()
  {
    return jdoGetm_delaiRecherche(this);
  }
  
  public final void setDelaiRecherche(DomPCSpec p_delaiRecherche)
  {
    jdoSetm_delaiRecherche(this, (DelaiRechercheProduitPC)p_delaiRecherche);
  }
  
  public String getIdDecorReglementaire()
  {
    return jdoGetm_idDecorReglementaire(this);
  }
  
  public final void setIdDecorReglementaire(String p_idDecorReglementaire)
  {
    jdoSetm_idDecorReglementaire(this, p_idDecorReglementaire);
  }
  
  public int getCodeProduitSecours()
  {
    return jdoGetm_codeProduitSecours(this);
  }
  
  public final void setCodeProduitSecours(int p_codeProduitSecours)
  {
    jdoSetm_codeProduitSecours(this, p_codeProduitSecours);
  }
  
  public int getJustificationAffectation()
  {
    return jdoGetm_justificationAffectation(this);
  }
  
  public final void setJustificationAffectation(int p_justificationAffectation)
  {
    jdoSetm_justificationAffectation(this, p_justificationAffectation);
  }
  
  public int getTypeDossier()
  {
    return jdoGetm_typeDossier(this);
  }
  
  public final void setTypeDossier(int p_typeDossier)
  {
    jdoSetm_typeDossier(this, p_typeDossier);
  }
  
  public String getTypeDossierExamen()
  {
    return jdoGetm_typeDossierExamen(this);
  }
  
  public final void setTypeDossierExamen(String p_typeDossierExamen)
  {
    jdoSetm_typeDossierExamen(this, p_typeDossierExamen);
  }
  
  public int getCodeProduitExecutable()
  {
    return jdoGetm_codeProduitExecutable(this);
  }
  
  public final void setCodeProduitExecutable(int p_codeProduitExecutable)
  {
    jdoSetm_codeProduitExecutable(this, p_codeProduitExecutable);
  }
  
  static
  {
    JDOImplHelper.registerClass(DossierAffectationPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, null);
  }
  
  protected static final DemandePC jdoGetm_demande(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_demande;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_demande;
      }
      return (DemandePC)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_demande);
    }
    return m_demande;
  }
  
  protected static final ValidationProduitPC jdoGetm_validationProduit(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_validationProduit;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_validationProduit;
      }
      return (ValidationProduitPC)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_validationProduit);
    }
    return m_validationProduit;
  }
  
  protected static final String jdoGetm_identifiantSinistre(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_identifiantSinistre;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_identifiantSinistre;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 2, m_identifiantSinistre);
    }
    return m_identifiantSinistre;
  }
  
  protected static final DelaiRechercheProduitPC jdoGetm_delaiRecherche(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_delaiRecherche;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_delaiRecherche;
      }
      return (DelaiRechercheProduitPC)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_delaiRecherche);
    }
    return m_delaiRecherche;
  }
  
  protected static final String jdoGetm_idDecorReglementaire(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_idDecorReglementaire;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_idDecorReglementaire;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 4, m_idDecorReglementaire);
    }
    return m_idDecorReglementaire;
  }
  
  protected static final int jdoGetm_codeProduitSecours(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeProduitSecours;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_codeProduitSecours;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 5, m_codeProduitSecours);
    }
    return m_codeProduitSecours;
  }
  
  protected static final int jdoGetm_justificationAffectation(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_justificationAffectation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_justificationAffectation;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 6, m_justificationAffectation);
    }
    return m_justificationAffectation;
  }
  
  protected static final int jdoGetm_typeDossier(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_typeDossier;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_typeDossier;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 7, m_typeDossier);
    }
    return m_typeDossier;
  }
  
  private static final String jdoGetm_typeDossierExamen(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_typeDossierExamen;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_typeDossierExamen;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 8, m_typeDossierExamen);
    }
    return m_typeDossierExamen;
  }
  
  protected static final int jdoGetm_codeProduitExecutable(DossierAffectationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeProduitExecutable;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_codeProduitExecutable;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 9, m_codeProduitExecutable);
    }
    return m_codeProduitExecutable;
  }
  
  protected static final void jdoSetm_demande(DossierAffectationPC pc, DemandePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_demande = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_demande, newValue);
    } else {
      m_demande = newValue;
    }
  }
  
  protected static final void jdoSetm_validationProduit(DossierAffectationPC pc, ValidationProduitPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_validationProduit = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_validationProduit, newValue);
    } else {
      m_validationProduit = newValue;
    }
  }
  
  protected static final void jdoSetm_identifiantSinistre(DossierAffectationPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_identifiantSinistre = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 2, m_identifiantSinistre, newValue);
    } else {
      m_identifiantSinistre = newValue;
    }
  }
  
  protected static final void jdoSetm_delaiRecherche(DossierAffectationPC pc, DelaiRechercheProduitPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_delaiRecherche = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_delaiRecherche, newValue);
    } else {
      m_delaiRecherche = newValue;
    }
  }
  
  protected static final void jdoSetm_idDecorReglementaire(DossierAffectationPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_idDecorReglementaire = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 4, m_idDecorReglementaire, newValue);
    } else {
      m_idDecorReglementaire = newValue;
    }
  }
  
  protected static final void jdoSetm_codeProduitSecours(DossierAffectationPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeProduitSecours = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 5, m_codeProduitSecours, newValue);
    } else {
      m_codeProduitSecours = newValue;
    }
  }
  
  protected static final void jdoSetm_justificationAffectation(DossierAffectationPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_justificationAffectation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 6, m_justificationAffectation, newValue);
    } else {
      m_justificationAffectation = newValue;
    }
  }
  
  protected static final void jdoSetm_typeDossier(DossierAffectationPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_typeDossier = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 7, m_typeDossier, newValue);
    } else {
      m_typeDossier = newValue;
    }
  }
  
  private static final void jdoSetm_typeDossierExamen(DossierAffectationPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_typeDossierExamen = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 8, m_typeDossierExamen, newValue);
    } else {
      m_typeDossierExamen = newValue;
    }
  }
  
  protected static final void jdoSetm_codeProduitExecutable(DossierAffectationPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeProduitExecutable = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 9, m_codeProduitExecutable, newValue);
    } else {
      m_codeProduitExecutable = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_demande);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_validationProduit);
      break;
    case 2: 
      jdoStateManager.providedStringField(this, fieldNumber, m_identifiantSinistre);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_delaiRecherche);
      break;
    case 4: 
      jdoStateManager.providedStringField(this, fieldNumber, m_idDecorReglementaire);
      break;
    case 5: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeProduitSecours);
      break;
    case 6: 
      jdoStateManager.providedIntField(this, fieldNumber, m_justificationAffectation);
      break;
    case 7: 
      jdoStateManager.providedIntField(this, fieldNumber, m_typeDossier);
      break;
    case 8: 
      jdoStateManager.providedStringField(this, fieldNumber, m_typeDossierExamen);
      break;
    case 9: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeProduitExecutable);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_demande = ((DemandePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_validationProduit = ((ValidationProduitPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_identifiantSinistre = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 3: 
      m_delaiRecherche = ((DelaiRechercheProduitPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_idDecorReglementaire = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 5: 
      m_codeProduitSecours = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 6: 
      m_justificationAffectation = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 7: 
      m_typeDossier = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 8: 
      m_typeDossierExamen = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 9: 
      m_codeProduitExecutable = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    // Byte code:
    //   0: new 101	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 420
    //   7: invokespecial 327	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierAffectationPC
    //   0	12	1	sm	StateManager
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    // Byte code:
    //   0: new 101	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 420
    //   7: invokespecial 327	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierAffectationPC
    //   0	12	1	sm	StateManager
    //   0	12	2	oid	Object
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 10;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof DossierAffectationPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    DossierAffectationPC other = (DossierAffectationPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_demande = m_demande;
        break;
      case 1: 
        m_validationProduit = m_validationProduit;
        break;
      case 2: 
        m_identifiantSinistre = m_identifiantSinistre;
        break;
      case 3: 
        m_delaiRecherche = m_delaiRecherche;
        break;
      case 4: 
        m_idDecorReglementaire = m_idDecorReglementaire;
        break;
      case 5: 
        m_codeProduitSecours = m_codeProduitSecours;
        break;
      case 6: 
        m_justificationAffectation = m_justificationAffectation;
        break;
      case 7: 
        m_typeDossier = m_typeDossier;
        break;
      case 8: 
        m_typeDossierExamen = m_typeDossierExamen;
        break;
      case 9: 
        m_codeProduitExecutable = m_codeProduitExecutable;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     DossierAffectationPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */