package fr.unedic.cali.asu.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.JustificationAffiliationJoursTravailles;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class JustificationAffiliationJoursTravaillesPC
  implements DomPCSpec, PersistenceCapable
{
  private transient JustificationAffiliationJoursTravailles m_justificationAffiliationJoursTravaillesOM;
  private int m_nombreJoursAppartenance;
  private int m_nombreJoursAffiliation;
  private int m_nombreJoursAssimilation;
  private Periode m_periodeRechercheAffiliation;
  private int m_plafondAssimilation;
  private boolean m_affiliationPlafonnee;
  public Collection m_plafonnementAffiliation;
  public Collection m_periodeAssimilation;
  public Collection m_semaineAffiliation;
  public Collection m_affiliationSupplementaire;
  public Collection m_periodeElementaire;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_nombreJoursAppartenance", "m_nombreJoursAffiliation", "m_nombreJoursAssimilation", "m_periodeRechercheAffiliation", "m_plafondAssimilation", "m_affiliationPlafonnee", "m_plafonnementAffiliation", "m_periodeAssimilation", "m_semaineAffiliation", "m_affiliationSupplementaire", "m_periodeElementaire" };
  private static Class[] jdoFieldTypes = { Integer.TYPE, Integer.TYPE, Integer.TYPE, Periode.class, Integer.TYPE, Boolean.TYPE, Collection.class, Collection.class, Collection.class, Collection.class, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_justificationAffiliationJoursTravaillesOM == null) {
      m_justificationAffiliationJoursTravaillesOM = new JustificationAffiliationJoursTravailles(this);
    }
    return m_justificationAffiliationJoursTravaillesOM;
  }
  
  public int getNombreJoursAppartenance()
  {
    return jdoGetm_nombreJoursAppartenance(this);
  }
  
  public final void setNombreJoursAppartenance(int p_nombreJoursAppartenance)
  {
    jdoSetm_nombreJoursAppartenance(this, p_nombreJoursAppartenance);
  }
  
  public int getNombreJoursAffiliation()
  {
    return jdoGetm_nombreJoursAffiliation(this);
  }
  
  public final void setNombreJoursAffiliation(int p_nombreJoursAffiliation)
  {
    jdoSetm_nombreJoursAffiliation(this, p_nombreJoursAffiliation);
  }
  
  public int getNombreJoursAssimilation()
  {
    return jdoGetm_nombreJoursAssimilation(this);
  }
  
  public final void setNombreJoursAssimilation(int p_nombreJoursAssimilation)
  {
    jdoSetm_nombreJoursAssimilation(this, p_nombreJoursAssimilation);
  }
  
  public Periode getPeriodeRechercheAffiliation()
  {
    return jdoGetm_periodeRechercheAffiliation(this);
  }
  
  public final void setPeriodeRechercheAffiliation(Periode p_periodeRechercheAffiliation)
  {
    jdoSetm_periodeRechercheAffiliation(this, p_periodeRechercheAffiliation);
  }
  
  public int getPlafondAssimilation()
  {
    return jdoGetm_plafondAssimilation(this);
  }
  
  public final void setPlafondAssimilation(int p_plafondAssimilation)
  {
    jdoSetm_plafondAssimilation(this, p_plafondAssimilation);
  }
  
  public boolean isAffiliationPlafonnee()
  {
    return jdoGetm_affiliationPlafonnee(this);
  }
  
  public final void setAffiliationPlafonnee(boolean p_affiliationPlafonnee)
  {
    jdoSetm_affiliationPlafonnee(this, p_affiliationPlafonnee);
  }
  
  public final Collection getCollectionPlafonnementAffiliation()
  {
    if (jdoGetm_plafonnementAffiliation(this) == null) {
      jdoSetm_plafonnementAffiliation(this, new ArrayList());
    }
    return jdoGetm_plafonnementAffiliation(this);
  }
  
  public final void ajouterPlafonnementAffiliation(DomPCSpec p_plafonnementAffiliation)
    throws NullPointerException
  {
    if (p_plafonnementAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_plafonnementAffiliation ne devrait pas être nul.", p_plafonnementAffiliation);
    }
    getCollectionPlafonnementAffiliation().add(p_plafonnementAffiliation);
  }
  
  public final void supprimerPlafonnementAffiliation(DomPCSpec p_plafonnementAffiliation)
    throws NullPointerException
  {
    if (p_plafonnementAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_plafonnementAffiliation ne devrait pas être nul.", p_plafonnementAffiliation);
    }
    getCollectionPlafonnementAffiliation().remove(p_plafonnementAffiliation);
  }
  
  public final Collection getCollectionPeriodeAssimilation()
  {
    if (jdoGetm_periodeAssimilation(this) == null) {
      jdoSetm_periodeAssimilation(this, new ArrayList());
    }
    return jdoGetm_periodeAssimilation(this);
  }
  
  public final void ajouterPeriodeAssimilation(DomPCSpec p_periodeAssimilation)
    throws NullPointerException
  {
    if (p_periodeAssimilation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeAssimilation ne devrait pas être nul.", p_periodeAssimilation);
    }
    getCollectionPeriodeAssimilation().add(p_periodeAssimilation);
  }
  
  public final void supprimerPeriodeAssimilation(DomPCSpec p_periodeAssimilation)
    throws NullPointerException
  {
    if (p_periodeAssimilation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeAssimilation ne devrait pas être nul.", p_periodeAssimilation);
    }
    getCollectionPeriodeAssimilation().remove(p_periodeAssimilation);
  }
  
  public final Collection getCollectionSemaineAffiliation()
  {
    if (jdoGetm_semaineAffiliation(this) == null) {
      jdoSetm_semaineAffiliation(this, new ArrayList());
    }
    return jdoGetm_semaineAffiliation(this);
  }
  
  public final void ajouterSemaineAffiliation(DomPCSpec p_semaineAffiliation)
    throws NullPointerException
  {
    if (p_semaineAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_semaineAffiliation ne devrait pas être nul.", p_semaineAffiliation);
    }
    getCollectionSemaineAffiliation().add(p_semaineAffiliation);
  }
  
  public final void supprimerSemaineAffiliation(DomPCSpec p_semaineAffiliation)
    throws NullPointerException
  {
    if (p_semaineAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_semaineAffiliation ne devrait pas être nul.", p_semaineAffiliation);
    }
    getCollectionSemaineAffiliation().remove(p_semaineAffiliation);
  }
  
  public final Collection getCollectionAffiliationSupplementaire()
  {
    if (jdoGetm_affiliationSupplementaire(this) == null) {
      jdoSetm_affiliationSupplementaire(this, new ArrayList());
    }
    return jdoGetm_affiliationSupplementaire(this);
  }
  
  public final void ajouterAffiliationSupplementaire(DomPCSpec p_affiliationSupplementaire)
    throws NullPointerException
  {
    if (p_affiliationSupplementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationSupplementaire ne devrait pas être nul.", p_affiliationSupplementaire);
    }
    getCollectionAffiliationSupplementaire().add(p_affiliationSupplementaire);
  }
  
  public final void supprimerAffiliationSupplementaire(DomPCSpec p_affiliationSupplementaire)
    throws NullPointerException
  {
    if (p_affiliationSupplementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationSupplementaire ne devrait pas être nul.", p_affiliationSupplementaire);
    }
    getCollectionAffiliationSupplementaire().remove(p_affiliationSupplementaire);
  }
  
  public final Collection getCollectionPeriodeElementaire()
  {
    if (jdoGetm_periodeElementaire(this) == null) {
      jdoSetm_periodeElementaire(this, new ArrayList());
    }
    return jdoGetm_periodeElementaire(this);
  }
  
  public final void ajouterPeriodeElementaire(DomPCSpec p_periodeElementaire)
    throws NullPointerException
  {
    if (p_periodeElementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeElementaire ne devrait pas être nul.", p_periodeElementaire);
    }
    getCollectionPeriodeElementaire().add(p_periodeElementaire);
  }
  
  public final void supprimerPeriodeElementaire(DomPCSpec p_periodeElementaire)
    throws NullPointerException
  {
    if (p_periodeElementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeElementaire ne devrait pas être nul.", p_periodeElementaire);
    }
    getCollectionPeriodeElementaire().remove(p_periodeElementaire);
  }
  
  static
  {
    JDOImplHelper.registerClass(JustificationAffiliationJoursTravaillesPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new JustificationAffiliationJoursTravaillesPC());
  }
  
  private static final int jdoGetm_nombreJoursAppartenance(JustificationAffiliationJoursTravaillesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nombreJoursAppartenance;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_nombreJoursAppartenance;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 0, m_nombreJoursAppartenance);
    }
    return m_nombreJoursAppartenance;
  }
  
  private static final int jdoGetm_nombreJoursAffiliation(JustificationAffiliationJoursTravaillesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nombreJoursAffiliation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_nombreJoursAffiliation;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 1, m_nombreJoursAffiliation);
    }
    return m_nombreJoursAffiliation;
  }
  
  private static final int jdoGetm_nombreJoursAssimilation(JustificationAffiliationJoursTravaillesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nombreJoursAssimilation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_nombreJoursAssimilation;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 2, m_nombreJoursAssimilation);
    }
    return m_nombreJoursAssimilation;
  }
  
  private static final Periode jdoGetm_periodeRechercheAffiliation(JustificationAffiliationJoursTravaillesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periodeRechercheAffiliation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_periodeRechercheAffiliation;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_periodeRechercheAffiliation);
    }
    return m_periodeRechercheAffiliation;
  }
  
  private static final int jdoGetm_plafondAssimilation(JustificationAffiliationJoursTravaillesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_plafondAssimilation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_plafondAssimilation;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 4, m_plafondAssimilation);
    }
    return m_plafondAssimilation;
  }
  
  private static final boolean jdoGetm_affiliationPlafonnee(JustificationAffiliationJoursTravaillesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_affiliationPlafonnee;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_affiliationPlafonnee;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 5, m_affiliationPlafonnee);
    }
    return m_affiliationPlafonnee;
  }
  
  public static final Collection jdoGetm_plafonnementAffiliation(JustificationAffiliationJoursTravaillesPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_plafonnementAffiliation;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 6, m_plafonnementAffiliation);
    }
    return m_plafonnementAffiliation;
  }
  
  public static final Collection jdoGetm_periodeAssimilation(JustificationAffiliationJoursTravaillesPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_periodeAssimilation;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_periodeAssimilation);
    }
    return m_periodeAssimilation;
  }
  
  public static final Collection jdoGetm_semaineAffiliation(JustificationAffiliationJoursTravaillesPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_semaineAffiliation;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 8, m_semaineAffiliation);
    }
    return m_semaineAffiliation;
  }
  
  public static final Collection jdoGetm_affiliationSupplementaire(JustificationAffiliationJoursTravaillesPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_affiliationSupplementaire;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 9, m_affiliationSupplementaire);
    }
    return m_affiliationSupplementaire;
  }
  
  public static final Collection jdoGetm_periodeElementaire(JustificationAffiliationJoursTravaillesPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_periodeElementaire;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 10, m_periodeElementaire);
    }
    return m_periodeElementaire;
  }
  
  private static final void jdoSetm_nombreJoursAppartenance(JustificationAffiliationJoursTravaillesPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nombreJoursAppartenance = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 0, m_nombreJoursAppartenance, newValue);
    } else {
      m_nombreJoursAppartenance = newValue;
    }
  }
  
  private static final void jdoSetm_nombreJoursAffiliation(JustificationAffiliationJoursTravaillesPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nombreJoursAffiliation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 1, m_nombreJoursAffiliation, newValue);
    } else {
      m_nombreJoursAffiliation = newValue;
    }
  }
  
  private static final void jdoSetm_nombreJoursAssimilation(JustificationAffiliationJoursTravaillesPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nombreJoursAssimilation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 2, m_nombreJoursAssimilation, newValue);
    } else {
      m_nombreJoursAssimilation = newValue;
    }
  }
  
  private static final void jdoSetm_periodeRechercheAffiliation(JustificationAffiliationJoursTravaillesPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periodeRechercheAffiliation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_periodeRechercheAffiliation, newValue);
    } else {
      m_periodeRechercheAffiliation = newValue;
    }
  }
  
  private static final void jdoSetm_plafondAssimilation(JustificationAffiliationJoursTravaillesPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_plafondAssimilation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 4, m_plafondAssimilation, newValue);
    } else {
      m_plafondAssimilation = newValue;
    }
  }
  
  private static final void jdoSetm_affiliationPlafonnee(JustificationAffiliationJoursTravaillesPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_affiliationPlafonnee = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 5, m_affiliationPlafonnee, newValue);
    } else {
      m_affiliationPlafonnee = newValue;
    }
  }
  
  public static final void jdoSetm_plafonnementAffiliation(JustificationAffiliationJoursTravaillesPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 6, m_plafonnementAffiliation, newValue);
    } else {
      m_plafonnementAffiliation = newValue;
    }
  }
  
  public static final void jdoSetm_periodeAssimilation(JustificationAffiliationJoursTravaillesPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_periodeAssimilation, newValue);
    } else {
      m_periodeAssimilation = newValue;
    }
  }
  
  public static final void jdoSetm_semaineAffiliation(JustificationAffiliationJoursTravaillesPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 8, m_semaineAffiliation, newValue);
    } else {
      m_semaineAffiliation = newValue;
    }
  }
  
  public static final void jdoSetm_affiliationSupplementaire(JustificationAffiliationJoursTravaillesPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 9, m_affiliationSupplementaire, newValue);
    } else {
      m_affiliationSupplementaire = newValue;
    }
  }
  
  public static final void jdoSetm_periodeElementaire(JustificationAffiliationJoursTravaillesPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 10, m_periodeElementaire, newValue);
    } else {
      m_periodeElementaire = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nombreJoursAppartenance);
      break;
    case 1: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nombreJoursAffiliation);
      break;
    case 2: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nombreJoursAssimilation);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeRechercheAffiliation);
      break;
    case 4: 
      jdoStateManager.providedIntField(this, fieldNumber, m_plafondAssimilation);
      break;
    case 5: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_affiliationPlafonnee);
      break;
    case 6: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_plafonnementAffiliation);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeAssimilation);
      break;
    case 8: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_semaineAffiliation);
      break;
    case 9: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_affiliationSupplementaire);
      break;
    case 10: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeElementaire);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_nombreJoursAppartenance = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 1: 
      m_nombreJoursAffiliation = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 2: 
      m_nombreJoursAssimilation = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 3: 
      m_periodeRechercheAffiliation = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_plafondAssimilation = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 5: 
      m_affiliationPlafonnee = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 6: 
      m_plafonnementAffiliation = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 7: 
      m_periodeAssimilation = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_semaineAffiliation = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 9: 
      m_affiliationSupplementaire = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 10: 
      m_periodeElementaire = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    JustificationAffiliationJoursTravaillesPC pc = new JustificationAffiliationJoursTravaillesPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    JustificationAffiliationJoursTravaillesPC pc = new JustificationAffiliationJoursTravaillesPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 11;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof JustificationAffiliationJoursTravaillesPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    JustificationAffiliationJoursTravaillesPC other = (JustificationAffiliationJoursTravaillesPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_nombreJoursAppartenance = m_nombreJoursAppartenance;
        break;
      case 1: 
        m_nombreJoursAffiliation = m_nombreJoursAffiliation;
        break;
      case 2: 
        m_nombreJoursAssimilation = m_nombreJoursAssimilation;
        break;
      case 3: 
        m_periodeRechercheAffiliation = m_periodeRechercheAffiliation;
        break;
      case 4: 
        m_plafondAssimilation = m_plafondAssimilation;
        break;
      case 5: 
        m_affiliationPlafonnee = m_affiliationPlafonnee;
        break;
      case 6: 
        m_plafonnementAffiliation = m_plafonnementAffiliation;
        break;
      case 7: 
        m_periodeAssimilation = m_periodeAssimilation;
        break;
      case 8: 
        m_semaineAffiliation = m_semaineAffiliation;
        break;
      case 9: 
        m_affiliationSupplementaire = m_affiliationSupplementaire;
        break;
      case 10: 
        m_periodeElementaire = m_periodeElementaire;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     JustificationAffiliationJoursTravaillesPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */