package fr.unedic.cali.asu.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.JustificationAffiliation;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class JustificationAffiliationPC
  implements DomPCSpec, PersistenceCapable
{
  private transient JustificationAffiliation m_justificationAffiliationOM;
  private Periode m_periodeRechercheAffiliation;
  private Quantite m_quantiteAffiliation;
  private Quantite m_quantiteAssimilation;
  private Quantite m_quantiteDernierJourFevrier;
  private Quantite m_plafondAssimilation;
  private boolean m_topConflits;
  private boolean m_estAffiliationPlafonnee;
  private Quantite m_quantiteImputee;
  public Collection m_periodeElementaire;
  public Collection m_zoneMemeExercice;
  public Collection m_affiliationSupplementaire;
  public Collection m_affiliationAssimilee;
  public Collection m_plafonnementAffiliation;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_periodeRechercheAffiliation", "m_quantiteAffiliation", "m_quantiteAssimilation", "m_quantiteDernierJourFevrier", "m_plafondAssimilation", "m_topConflits", "m_estAffiliationPlafonnee", "m_quantiteImputee", "m_periodeElementaire", "m_zoneMemeExercice", "m_affiliationSupplementaire", "m_affiliationAssimilee", "m_plafonnementAffiliation" };
  private static Class[] jdoFieldTypes = { Periode.class, Quantite.class, Quantite.class, Quantite.class, Quantite.class, Boolean.TYPE, Boolean.TYPE, Quantite.class, Collection.class, Collection.class, Collection.class, Collection.class, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_justificationAffiliationOM == null) {
      m_justificationAffiliationOM = new JustificationAffiliation(this);
    }
    return m_justificationAffiliationOM;
  }
  
  public Periode getPeriodeRechercheAffiliation()
  {
    return jdoGetm_periodeRechercheAffiliation(this);
  }
  
  public final void setPeriodeRechercheAffiliation(Periode p_periodeRechercheAffiliation)
  {
    jdoSetm_periodeRechercheAffiliation(this, p_periodeRechercheAffiliation);
  }
  
  public Quantite getQuantiteAffiliation()
  {
    return jdoGetm_quantiteAffiliation(this);
  }
  
  public final void setQuantiteAffiliation(Quantite p_quantiteAffiliation)
  {
    jdoSetm_quantiteAffiliation(this, p_quantiteAffiliation);
  }
  
  public Quantite getQuantiteAssimilation()
  {
    return jdoGetm_quantiteAssimilation(this);
  }
  
  public final void setQuantiteAssimilation(Quantite p_quantiteAssimilation)
  {
    jdoSetm_quantiteAssimilation(this, p_quantiteAssimilation);
  }
  
  public Quantite getQuantiteDernierJourFevrier()
  {
    return jdoGetm_quantiteDernierJourFevrier(this);
  }
  
  public final void setQuantiteDernierJourFevrier(Quantite p_quantiteDernierJourFevrier)
  {
    jdoSetm_quantiteDernierJourFevrier(this, p_quantiteDernierJourFevrier);
  }
  
  public Quantite getPlafondAssimilation()
  {
    return jdoGetm_plafondAssimilation(this);
  }
  
  public final void setPlafondAssimilation(Quantite p_plafondAssimilation)
  {
    jdoSetm_plafondAssimilation(this, p_plafondAssimilation);
  }
  
  public boolean isTopConflits()
  {
    return jdoGetm_topConflits(this);
  }
  
  public final void setTopConflits(boolean p_topConflits)
  {
    jdoSetm_topConflits(this, p_topConflits);
  }
  
  public boolean isEstAffiliationPlafonnee()
  {
    return jdoGetm_estAffiliationPlafonnee(this);
  }
  
  public final void setEstAffiliationPlafonnee(boolean p_estAffiliationPlafonnee)
  {
    jdoSetm_estAffiliationPlafonnee(this, p_estAffiliationPlafonnee);
  }
  
  public Quantite getQuantiteImputee()
  {
    return jdoGetm_quantiteImputee(this);
  }
  
  public final void setQuantiteImputee(Quantite p_quantiteImputee)
  {
    jdoSetm_quantiteImputee(this, p_quantiteImputee);
  }
  
  public final Collection getCollectionPeriodeElementaire()
  {
    if (jdoGetm_periodeElementaire(this) == null) {
      jdoSetm_periodeElementaire(this, new ArrayList());
    }
    return jdoGetm_periodeElementaire(this);
  }
  
  public final void ajouterPeriodeElementaire(DomPCSpec p_periodeElementaire)
    throws NullPointerException
  {
    if (p_periodeElementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeElementaire ne devrait pas être nul.", p_periodeElementaire);
    }
    getCollectionPeriodeElementaire().add(p_periodeElementaire);
  }
  
  public final void supprimerPeriodeElementaire(DomPCSpec p_periodeElementaire)
    throws NullPointerException
  {
    if (p_periodeElementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeElementaire ne devrait pas être nul.", p_periodeElementaire);
    }
    getCollectionPeriodeElementaire().remove(p_periodeElementaire);
  }
  
  public final Collection getCollectionZoneMemeExercice()
  {
    if (jdoGetm_zoneMemeExercice(this) == null) {
      jdoSetm_zoneMemeExercice(this, new ArrayList());
    }
    return jdoGetm_zoneMemeExercice(this);
  }
  
  public final void ajouterZoneMemeExercice(DomPCSpec p_zoneMemeExercice)
    throws NullPointerException
  {
    if (p_zoneMemeExercice == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_zoneMemeExercice ne devrait pas être nul.", p_zoneMemeExercice);
    }
    getCollectionZoneMemeExercice().add(p_zoneMemeExercice);
  }
  
  public final void supprimerZoneMemeExercice(DomPCSpec p_zoneMemeExercice)
    throws NullPointerException
  {
    if (p_zoneMemeExercice == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_zoneMemeExercice ne devrait pas être nul.", p_zoneMemeExercice);
    }
    getCollectionZoneMemeExercice().remove(p_zoneMemeExercice);
  }
  
  public final Collection getCollectionAffiliationSupplementaire()
  {
    if (jdoGetm_affiliationSupplementaire(this) == null) {
      jdoSetm_affiliationSupplementaire(this, new ArrayList());
    }
    return jdoGetm_affiliationSupplementaire(this);
  }
  
  public final void ajouterAffiliationSupplementaire(DomPCSpec p_affiliationSupplementaire)
    throws NullPointerException
  {
    if (p_affiliationSupplementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationSupplementaire ne devrait pas être nul.", p_affiliationSupplementaire);
    }
    getCollectionAffiliationSupplementaire().add(p_affiliationSupplementaire);
  }
  
  public final void supprimerAffiliationSupplementaire(DomPCSpec p_affiliationSupplementaire)
    throws NullPointerException
  {
    if (p_affiliationSupplementaire == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationSupplementaire ne devrait pas être nul.", p_affiliationSupplementaire);
    }
    getCollectionAffiliationSupplementaire().remove(p_affiliationSupplementaire);
  }
  
  public final Collection getCollectionAffiliationAssimilee()
  {
    if (jdoGetm_affiliationAssimilee(this) == null) {
      jdoSetm_affiliationAssimilee(this, new ArrayList());
    }
    return jdoGetm_affiliationAssimilee(this);
  }
  
  public final void ajouterAffiliationAssimilee(DomPCSpec p_affiliationAssimilee)
    throws NullPointerException
  {
    if (p_affiliationAssimilee == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationAssimilee ne devrait pas être nul.", p_affiliationAssimilee);
    }
    getCollectionAffiliationAssimilee().add(p_affiliationAssimilee);
  }
  
  public final void supprimerAffiliationAssimilee(DomPCSpec p_affiliationAssimilee)
    throws NullPointerException
  {
    if (p_affiliationAssimilee == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationAssimilee ne devrait pas être nul.", p_affiliationAssimilee);
    }
    getCollectionAffiliationAssimilee().remove(p_affiliationAssimilee);
  }
  
  public final Collection getCollectionPlafonnementAffiliation()
  {
    if (jdoGetm_plafonnementAffiliation(this) == null) {
      jdoSetm_plafonnementAffiliation(this, new ArrayList());
    }
    return jdoGetm_plafonnementAffiliation(this);
  }
  
  public final void ajouterPlafonnementAffiliation(DomPCSpec p_plafonnementAffiliation)
    throws NullPointerException
  {
    if (p_plafonnementAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_plafonnementAffiliation ne devrait pas être nul.", p_plafonnementAffiliation);
    }
    getCollectionPlafonnementAffiliation().add(p_plafonnementAffiliation);
  }
  
  public final void supprimerPlafonnementAffiliation(DomPCSpec p_plafonnementAffiliation)
    throws NullPointerException
  {
    if (p_plafonnementAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_plafonnementAffiliation ne devrait pas être nul.", p_plafonnementAffiliation);
    }
    getCollectionPlafonnementAffiliation().remove(p_plafonnementAffiliation);
  }
  
  static
  {
    JDOImplHelper.registerClass(JustificationAffiliationPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new JustificationAffiliationPC());
  }
  
  private static final Periode jdoGetm_periodeRechercheAffiliation(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periodeRechercheAffiliation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_periodeRechercheAffiliation;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_periodeRechercheAffiliation);
    }
    return m_periodeRechercheAffiliation;
  }
  
  private static final Quantite jdoGetm_quantiteAffiliation(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteAffiliation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_quantiteAffiliation;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_quantiteAffiliation);
    }
    return m_quantiteAffiliation;
  }
  
  private static final Quantite jdoGetm_quantiteAssimilation(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteAssimilation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_quantiteAssimilation;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_quantiteAssimilation);
    }
    return m_quantiteAssimilation;
  }
  
  private static final Quantite jdoGetm_quantiteDernierJourFevrier(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteDernierJourFevrier;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_quantiteDernierJourFevrier;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_quantiteDernierJourFevrier);
    }
    return m_quantiteDernierJourFevrier;
  }
  
  private static final Quantite jdoGetm_plafondAssimilation(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_plafondAssimilation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_plafondAssimilation;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 4, m_plafondAssimilation);
    }
    return m_plafondAssimilation;
  }
  
  private static final boolean jdoGetm_topConflits(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_topConflits;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_topConflits;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 5, m_topConflits);
    }
    return m_topConflits;
  }
  
  private static final boolean jdoGetm_estAffiliationPlafonnee(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_estAffiliationPlafonnee;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_estAffiliationPlafonnee;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 6, m_estAffiliationPlafonnee);
    }
    return m_estAffiliationPlafonnee;
  }
  
  private static final Quantite jdoGetm_quantiteImputee(JustificationAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteImputee;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_quantiteImputee;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_quantiteImputee);
    }
    return m_quantiteImputee;
  }
  
  public static final Collection jdoGetm_periodeElementaire(JustificationAffiliationPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_periodeElementaire;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 8, m_periodeElementaire);
    }
    return m_periodeElementaire;
  }
  
  public static final Collection jdoGetm_zoneMemeExercice(JustificationAffiliationPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_zoneMemeExercice;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 9, m_zoneMemeExercice);
    }
    return m_zoneMemeExercice;
  }
  
  public static final Collection jdoGetm_affiliationSupplementaire(JustificationAffiliationPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_affiliationSupplementaire;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 10, m_affiliationSupplementaire);
    }
    return m_affiliationSupplementaire;
  }
  
  public static final Collection jdoGetm_affiliationAssimilee(JustificationAffiliationPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 11)) {
        return m_affiliationAssimilee;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 11, m_affiliationAssimilee);
    }
    return m_affiliationAssimilee;
  }
  
  public static final Collection jdoGetm_plafonnementAffiliation(JustificationAffiliationPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 12)) {
        return m_plafonnementAffiliation;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 12, m_plafonnementAffiliation);
    }
    return m_plafonnementAffiliation;
  }
  
  private static final void jdoSetm_periodeRechercheAffiliation(JustificationAffiliationPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periodeRechercheAffiliation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_periodeRechercheAffiliation, newValue);
    } else {
      m_periodeRechercheAffiliation = newValue;
    }
  }
  
  private static final void jdoSetm_quantiteAffiliation(JustificationAffiliationPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteAffiliation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_quantiteAffiliation, newValue);
    } else {
      m_quantiteAffiliation = newValue;
    }
  }
  
  private static final void jdoSetm_quantiteAssimilation(JustificationAffiliationPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteAssimilation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_quantiteAssimilation, newValue);
    } else {
      m_quantiteAssimilation = newValue;
    }
  }
  
  private static final void jdoSetm_quantiteDernierJourFevrier(JustificationAffiliationPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteDernierJourFevrier = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_quantiteDernierJourFevrier, newValue);
    } else {
      m_quantiteDernierJourFevrier = newValue;
    }
  }
  
  private static final void jdoSetm_plafondAssimilation(JustificationAffiliationPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_plafondAssimilation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 4, m_plafondAssimilation, newValue);
    } else {
      m_plafondAssimilation = newValue;
    }
  }
  
  private static final void jdoSetm_topConflits(JustificationAffiliationPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_topConflits = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 5, m_topConflits, newValue);
    } else {
      m_topConflits = newValue;
    }
  }
  
  private static final void jdoSetm_estAffiliationPlafonnee(JustificationAffiliationPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_estAffiliationPlafonnee = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 6, m_estAffiliationPlafonnee, newValue);
    } else {
      m_estAffiliationPlafonnee = newValue;
    }
  }
  
  private static final void jdoSetm_quantiteImputee(JustificationAffiliationPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteImputee = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_quantiteImputee, newValue);
    } else {
      m_quantiteImputee = newValue;
    }
  }
  
  public static final void jdoSetm_periodeElementaire(JustificationAffiliationPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 8, m_periodeElementaire, newValue);
    } else {
      m_periodeElementaire = newValue;
    }
  }
  
  public static final void jdoSetm_zoneMemeExercice(JustificationAffiliationPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 9, m_zoneMemeExercice, newValue);
    } else {
      m_zoneMemeExercice = newValue;
    }
  }
  
  public static final void jdoSetm_affiliationSupplementaire(JustificationAffiliationPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 10, m_affiliationSupplementaire, newValue);
    } else {
      m_affiliationSupplementaire = newValue;
    }
  }
  
  public static final void jdoSetm_affiliationAssimilee(JustificationAffiliationPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 11, m_affiliationAssimilee, newValue);
    } else {
      m_affiliationAssimilee = newValue;
    }
  }
  
  public static final void jdoSetm_plafonnementAffiliation(JustificationAffiliationPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 12, m_plafonnementAffiliation, newValue);
    } else {
      m_plafonnementAffiliation = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeRechercheAffiliation);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteAffiliation);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteAssimilation);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteDernierJourFevrier);
      break;
    case 4: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_plafondAssimilation);
      break;
    case 5: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_topConflits);
      break;
    case 6: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_estAffiliationPlafonnee);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteImputee);
      break;
    case 8: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeElementaire);
      break;
    case 9: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_zoneMemeExercice);
      break;
    case 10: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_affiliationSupplementaire);
      break;
    case 11: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_affiliationAssimilee);
      break;
    case 12: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_plafonnementAffiliation);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_periodeRechercheAffiliation = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_quantiteAffiliation = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_quantiteAssimilation = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_quantiteDernierJourFevrier = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_plafondAssimilation = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 5: 
      m_topConflits = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 6: 
      m_estAffiliationPlafonnee = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 7: 
      m_quantiteImputee = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_periodeElementaire = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 9: 
      m_zoneMemeExercice = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 10: 
      m_affiliationSupplementaire = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 11: 
      m_affiliationAssimilee = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 12: 
      m_plafonnementAffiliation = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    JustificationAffiliationPC pc = new JustificationAffiliationPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    JustificationAffiliationPC pc = new JustificationAffiliationPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 13;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof JustificationAffiliationPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    JustificationAffiliationPC other = (JustificationAffiliationPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_periodeRechercheAffiliation = m_periodeRechercheAffiliation;
        break;
      case 1: 
        m_quantiteAffiliation = m_quantiteAffiliation;
        break;
      case 2: 
        m_quantiteAssimilation = m_quantiteAssimilation;
        break;
      case 3: 
        m_quantiteDernierJourFevrier = m_quantiteDernierJourFevrier;
        break;
      case 4: 
        m_plafondAssimilation = m_plafondAssimilation;
        break;
      case 5: 
        m_topConflits = m_topConflits;
        break;
      case 6: 
        m_estAffiliationPlafonnee = m_estAffiliationPlafonnee;
        break;
      case 7: 
        m_quantiteImputee = m_quantiteImputee;
        break;
      case 8: 
        m_periodeElementaire = m_periodeElementaire;
        break;
      case 9: 
        m_zoneMemeExercice = m_zoneMemeExercice;
        break;
      case 10: 
        m_affiliationSupplementaire = m_affiliationSupplementaire;
        break;
      case 11: 
        m_affiliationAssimilee = m_affiliationAssimilee;
        break;
      case 12: 
        m_plafonnementAffiliation = m_plafonnementAffiliation;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     JustificationAffiliationPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */