package fr.unedic.cali.asu.fds12.p02;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.fds12.p02.liquidation.dom.FabriqueObjectifExamen;
import fr.unedic.cali.asu.fds12.p02.liquidation.outilsAffiliation.ParametresAffiliation;
import fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.ComparateurDecision;
import fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.DeterminationDateMinPraPrcPrs;
import fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.RecuperationFormuleMontant;
import fr.unedic.cali.asu.fds12.p02.liquidation.parcours.DeterminationConditionBeneficeAutreProduit;
import fr.unedic.cali.asu.fds12.p02.parametres.AccesMontantForfaitaire;
import fr.unedic.cali.asu.fds12.p02.parametres.EvenementParametre;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.FabriqueObjectifExamenSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Pra;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ValidationProduit;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.ComparateurDecisionSpeSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DecisionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.JustificationAppelGaecReduit;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.dom.affectation.DelaiRechercheProduitSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuFds12P02;
import fr.unedic.cali.dom.affectation.ValidationProduitSpec;
import fr.unedic.cali.dom.echange.Decision;
import fr.unedic.cali.dom.pivot.DemandePivot;
import fr.unedic.cali.migration.GrapheLiquidationSpec;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.CalculDelais;
import fr.unedic.util.temps.ChronologieStandard;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.List;

public class ProduitDelegue
  extends fr.unedic.cali.asu.fps.ProduitDelegue
{
  private static final String DATE = "Date";
  private static final String ALLOC_FORFAIT_JOURNALIER = "forfaitJournalier";
  
  public Object creerObjectifExamen(int sousType, List<ContexteDemandeSpec> contexteDemande)
  {
    FabriqueObjectifExamenSpec fabrique = FabriqueObjectifExamen.getInstance();
    return fabrique.creerObjectif(sousType, contexteDemande);
  }
  
  public void alimenterBaseEchangesProduit(DossierExamenSpec dossierExamen, Decision demandeEchange)
    throws CoucheLogiqueException
  {
    super.alimenterBaseEchangesProduit(dossierExamen, demandeEchange);
  }
  
  public void alimenterBasePivotProduit(DossierExamenSpec dossierExamen, DemandePivot demandePivot)
    throws ApplicativeException, CoucheLogiqueException
  {
    fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.AlimentationBasePivot.getInstance().alimenterDonneesProduit(dossierExamen, demandePivot);
  }
  
  public ArrayList alimenterDecisionsReexamen(Contexte contexte)
    throws CoucheLogiqueException
  {
    if ((contexte != null) && (contexte.getDonnees() != null))
    {
      DomLiquidationAssurance domCourant = (DomLiquidationAssurance)contexte.getDonnees();
      DecisionSpec decisionAvantReexamen = (DecisionSpec)domCourant.getDemandeAvantReexamen().getDossierAffectation().getDossierExamen();
      DecisionSpec decisionApresReexamen = (DecisionSpec)domCourant.getDemande().getDossierAffectation().getDossierExamen();
      ComparateurDecisionSpeSpec comparateur = ComparateurDecision.getInstance();
      return comparateur.rechercheDifferencesComparaisonDecision(decisionAvantReexamen, decisionApresReexamen);
    }
    return null;
  }
  
  public boolean comparerDecisions(DecisionSpec decision1, DecisionSpec decision2)
  {
    ComparateurDecisionSpeSpec comparateur = ComparateurDecision.getInstance();
    return comparateur.estEgal(decision1, decision2);
  }
  
  public Resultat constituerDelaisReports(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat constituerNbHeuresTravaillees(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat constituerSalaireJournalierDeReference(Contexte contexte)
    throws ApplicativeException
  {
    return null;
  }
  
  public GrapheLiquidationSpec creerGraphe(int natureDecision, boolean classement)
  {
    return super.creerGraphe(natureDecision, classement);
  }
  
  public Periode determinerPraLaPlusLongue(DemandeSpec demandeCourante, ActiviteSalarie periodeFctCourante)
    throws CoucheLogiqueException
  {
    Periode periodePra = CalculDelais.determinerDelaiCalendaire(periodeFctCourante.getDateFin(), ParametresAffiliation.DUREE_PRA);
    return new Pra(periodePra);
  }
  
  public Quantite determinerReliquatHorsMaintien(AttributionSpec attribution, Damj dateCalcul)
    throws ApplicativeException
  {
    return super.determinerReliquatHorsMaintien(attribution, dateCalcul);
  }
  
  protected Resultat effectuerParcours(Parcours parcours, Contexte contexte)
    throws ApplicativeException
  {
    return super.effectuerParcours(parcours, contexte);
  }
  
  public Quantite getDureeAServirEffective(AttributionSpec pAttribution)
  {
    Attribution attribution = (Attribution)pAttribution;
    if ((attribution != null) && (attribution.getConstitutionDurees() != null)) {
      return attribution.getConstitutionDurees().getDureeEffective();
    }
    return null;
  }
  
  public FormuleMontantSpec getFormuleMontant(String code)
  {
    return RecuperationFormuleMontant.getInstanceFormuleMontant(code);
  }
  
  public ArrayList getParametres()
  {
    AccesMontantForfaitaire allocForfait = new AccesMontantForfaitaire();
    
    ChronologieStandard allocForfaitC = allocForfait.getChronoValeursParametre();
    
    ChronologieStandard asuC = (ChronologieStandard)allocForfaitC.copier();
    
    ajouterChrono(asuC, allocForfaitC);
    
    return retourneArrayList(asuC);
  }
  
  private void ajouterChrono(ChronologieStandard cg01C, ChronologieStandard chrono)
  {
    chrono.iterer();
    while (chrono.encoreSuivant())
    {
      EvenementParametre evtPf = (EvenementParametre)chrono.elementSuivant();
      ajouterEvenement(cg01C, evtPf);
    }
  }
  
  private void ajouterEvenement(ChronologieStandard cg01C, EvenementParametre evtParam)
  {
    Damj damjParam = evtParam.getDateEffet();
    boolean trouve = false;
    cg01C.iterer();
    while ((cg01C.encoreSuivant()) && (!trouve))
    {
      EvenementParametre evtAsu = (EvenementParametre)cg01C.elementSuivant();
      Damj damjAsu = evtAsu.getDateEffet();
      if (damjParam.equals(damjAsu))
      {
        evtAsu.repercuter(evtParam);
        trouve = true;
      }
    }
    if (!trouve) {
      cg01C.ajouter(evtParam);
    }
  }
  
  private ArrayList retourneArrayList(ChronologieStandard asuC)
  {
    ArrayList resultat = new ArrayList();
    
    asuC.iterer();
    while (asuC.encoreSuivant())
    {
      EvenementParametre evtAsu = (EvenementParametre)asuC.elementSuivant();
      Damj damjAsu = evtAsu.getDateEffet();
      
      Hashtable params = new Hashtable();
      
      params.put("Date", damjAsu);
      BigDecimal pc = evtAsu.getMontantForfaitaire(false);
      if (pc != null) {
        params.put("forfaitJournalier", pc);
      }
      resultat.add(params);
    }
    return resultat;
  }
  
  public void miseAJourDossierExamen(DossierExamenSpec dossier, AttributionSpec attribution)
  {
    super.miseAJourDossierExamen(dossier, attribution);
  }
  
  public DelaiRechercheProduitSpec obtenirDelaiRechercheProduit(DossierAffectationSpec dossierAffectation, DureeCalendaire delaiAllongement)
    throws CoucheLogiqueException
  {
    return super.obtenirDelaiRechercheProduit(dossierAffectation, delaiAllongement);
  }
  
  public ValidationProduitSpec obtenirValidationProduit(ActiviteSalarie activiteSalarie, IndividuSpec individu, DemandeSpec demande, boolean avecPeriodeNonAttestee)
    throws ApplicativeException
  {
    ValidationProduit validationProduit = new ValidationProduit();
    validationProduit.setProduitValide(ProduitAsuFds12P02.getInstance());
    validationProduit.setEstProduitValide(true);
    return validationProduit;
  }
  
  public Damj recupererDJIParEpuisement(DemandeSpec demande, AttributionSpec attribution, boolean verifierEpuisementHPec)
    throws ApplicativeException
  {
    return super.recupererDJIParEpuisement(demande, attribution, verifierEpuisementHPec);
  }
  
  public Resultat traiterReliquat(ResultatExecutionCalculSpec resultatExecutionCalcul, Damj dateEtude)
    throws ApplicativeException
  {
    return fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.OutilTraitementReliquat.getInstance().traiterReliquat(resultatExecutionCalcul, dateEtude);
  }
  
  public Resultat verifierConditionMontant(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionBeneficeAutreProduit(Contexte contexte)
    throws ApplicativeException
  {
    Parcours parcoursBeneficeAutreProduit = new DeterminationConditionBeneficeAutreProduit();
    return parcoursBeneficeAutreProduit.effectuerParcours(contexte);
  }
  
  public SalaireJournalierSpec revaloriserSalaireJournalier(ElementBaseIndemnisationSpec ebi, Damj date)
  {
    return null;
  }
  
  public JustificationAppelGaecReduit calculerDateMinimum(DemandeSpec demande)
  {
    if (demande != null) {
      return DeterminationDateMinPraPrcPrs.calculerDateMinimum(demande);
    }
    return null;
  }
  
  public Resultat creerGrapheDemandeAntecedent(Contexte contexte)
    throws CoucheLogiqueException
  {
    fr.unedic.cali.asu.fds12.p02.antecedent.GrapheAntecedent.getInstance().alimenterGrapheDecisionAntecedent(contexte);
    return new Resultat(0);
  }
  
  public boolean estProduitGerantPensionInvalidite()
  {
    return false;
  }
  
  public Collection determinerPensionInvaliditeDroitCourant(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return new ArrayList();
  }
  
  public Collection determinerPensionInvaliditeDroitResultant(AttributionSpec attribution)
  {
    return new ArrayList();
  }
}

/* Location:
 * Qualified Name:     ProduitDelegue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */