package fr.unedic.cali.asu.fds12.p02.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeFinDureeMaintienDroit;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.fds12.p02.antecedent.GestionAntecedentCalcul;
import fr.unedic.cali.asu.fds12.p02.calcul.dom.FormuleMontantAFDF;
import fr.unedic.cali.asu.fds12.p02.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.fds12.p02.calcul.outisfonctionnels.Qualification;
import fr.unedic.cali.asu.fds12.p02.calcul.outisfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.spe02.p03.calcul.dom.ConstituantsCalculActiviteReduiteProduit;
import fr.unedic.cali.asu.spe02.p03.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EvenementMaintienEuropeenDJI;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationSanctionReduction;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.ProduitSolSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends fr.unedic.cali.asu.spe02.p03.calcul.FacadeCalculProduitImpl
{
  public MontantBaseSpec calculMontant(FormuleMontantSpec p_formuleMontant, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    return p_formuleMontant.calculer(p_constituantsIndemnisation, p_dateCalcul);
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    return constituantsIndemnisation;
  }
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    FormuleMontantSpec fm = null;
    if (FormuleMontantRegimeGeneral.getCode().equals(p_code)) {
      fm = new FormuleMontantRegimeGeneral();
    } else if (FormuleMontantAFDF.getCode().equals(p_code)) {
      fm = new FormuleMontantAFDF();
    }
    return fm;
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes p_chronologiePeriodes, AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(p_chronologiePeriodes, p_attribution);
  }
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec p_attribution, UniteTraitement p_ut, ObjetChronoPeriode p_objetChronoPeriode, ArretProduitAvecRaison p_arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    if ((p_objetChronoPeriode instanceof PeriodeExclusionDefinitiveDDTE)) {
      p_arretProduitAvecRaison.setProduitAEteindre(true);
    } else if ((p_objetChronoPeriode instanceof ObjetChronoPeriodeFinDureeMaintienDroit)) {
      p_ut.ajouterEvenement(new EvenementMaintienEuropeenDJI(p_objetChronoPeriode.getDateDebut().veille()));
    }
  }
  
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT p_contexteUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    
    Collection collectionPeriode = p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourGamme(p_attribution, "ASU");
    List liste = p_contexteUT.getListeAttributions();
    if (liste != null)
    {
      Iterator iterator = liste.iterator();
      while (iterator.hasNext())
      {
        AttributionSpec attribution = (AttributionSpec)iterator.next();
        if (attribution.getGamme().getNomUnique().equals("SOL")) {
          if (((attribution.getProduit().getNomUnique().equals("SOL_AER05_01")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_02")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_03"))) && (attribution.getCalendrierExecutionCalcul() != null) && ((attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 1) || (attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 2)))
          {
            Damj djiTheoriqueAER = ((ProduitSolSpec)attribution.getProduit()).getDjiTheoriqueAER(attribution);
            chronologiePeriodes.ajouter(new ObjetChronoPeriodeInterProduits(djiTheoriqueAER.lendemain(), djiTheoriqueAER.lendemain(), 5, attribution));
          }
        }
      }
    }
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_01"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_02"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_03"));
    
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourProduit(p_attribution, "SOL_CGE01_01"));
    
    chronologiePeriodes.ajouter(collectionPeriode);
    
    chronologiePeriodes.ajouter(RechercheDecisionsInterruptives.rechercher(p_attribution.getDemandeur(), p_attribution.getPji(), p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsPeriodesLieuSurUTPourGammeRBF(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTIndemnisationRfpe(p_attribution));
    
    chronologiePeriodes.ajouter(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "RET_ACO01_01"));
    
    return chronologiePeriodes;
  }
  
  public void traitementPeriodeSegmentante(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison, ChronologiePeriodes p_periodesAnalyses)
    throws ApplicativeException
  {
    if ((OutilsMaintienEuropeenEessiASU.controlerContexteMaintienEuropeen(p_attribution.getDemandeur(), p_periode.getDateDebut())) && 
      ((p_periode instanceof PeriodeFormation))) {
      if (((PeriodeFormation)p_periode).estEffective()) {
        passerEnIndemnisationAvecFormation(p_periode, p_constituantsIndemnisation);
      } else {
        passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
      }
    }
    if (((p_periode instanceof PeriodeInterStageFormation)) || ((p_periode instanceof FinActionFormation))) {
      passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
    }
    traitementPeriodeSegmentanteHorsFormation(p_attribution, p_periode, p_constituantsIndemnisation, p_ut, p_pa, p_arretProduitAvecRaison, p_periodesAnalyses);
  }
  
  private void passerEnIndemnisationAvecFormation(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantAFDF.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantAFDF.getCode());
    }
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF();
    ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).copieElements(elementBaseIndemnisationAREF);
    if ((p_periode instanceof PeriodeFormation)) {
      elementBaseIndemnisationAREF.setEffectif(((PeriodeFormation)p_periode).estEffective());
    }
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAJourCumulAR(UniteTraitement p_ut, AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, ContexteUT p_contexteUT, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    return (ConstituantsCalculActiviteReduiteProduit)p_constituantsCalculActiviteReduite;
  }
  
  public void traitementPeriodesGelantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduiteSpec, UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite traitementAR = new TraitementActiviteReduite();
    
    traitementPeriodesGelantes(p_attribution, p_periodes, p_ut, traitementAR);
  }
  
  public void traitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduiteSpec, UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite traitementAR = new TraitementActiviteReduite();
    
    traitementPeriodesDecalantes(p_attribution, p_periodes, p_ut, traitementAR);
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    if (p_constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
      
      elementBaseIndemnisationCourant.setCoefficientSanctionReduction(new BigDecimal("1.00"));
      
      elementBaseIndemnisationCourant.setAvecPrecompteCRC(Boolean.FALSE);
      
      elementBaseIndemnisationCourant.setDateMaintienEuropeen(OutilsMaintienEuropeenEessiASU.rechercherDateMaintienEuropeen(p_attribution, p_periodeUT, p_constituantsIndemnisation));
      
      p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
      
      FormuleMontantSpec formuleMontant = null;
      ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = null;
      
      QuantiteIndemnisationSpec duree = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
      if (duree != null) {
        formuleMontant = p_attribution.getFormuleMontant(duree.getCodeFormuleMontant());
      } else {
        formuleMontant = p_attribution.getFormuleMontant(p_constituantsIndemnisation.getCodeFormuleMontant());
      }
      if ((formuleMontant instanceof FormuleMontantAFDF))
      {
        elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
        p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
      }
    }
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date, ChronologiePeriodes p_chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    elementBaseIndemnisationCourant.setCoefficientSanctionReduction(RecuperationSanctionReduction.recuperationCoefficientSanctionReductionADate(p_chronologiePeriodesSanctions, p_date));
  }
  
  public void alimenterGrapheAntecedentCalcul(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    GestionAntecedentCalcul.getInstance().alimenterGrapheCalcul(p_attribution);
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec p_attribution, UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {}
  
  public void traitementPeriodeSegmentanteHorsFormation(AttributionSpec attribution, ObjetChronoPeriode periode, ConstituantsIndemnisation constituantsIndemnisation, UniteTraitement ut, PeriodeAnalyseSpec pa, ArretProduitAvecRaison arretProduitAvecRaison, ChronologiePeriodes periodesAnalyses)
    throws ApplicativeException
  {
    if ((!(periode instanceof PeriodeAvantageVieillesse)) && (!(periode instanceof ObjetChronoAnniversaire60Ans))) {
      super.traitementPeriodeSegmentanteHorsFormation(attribution, periode, constituantsIndemnisation, ut, pa, arretProduitAvecRaison, periodesAnalyses);
    }
  }
  
  public boolean verifierEligibilitePaiementParAvance(UniteTraitement ut)
  {
    ut.setRaisonStatut(1);
    return false;
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */