package fr.unedic.cali.asu.fds12.p03.calcul.pbjc;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDVDemandeExpresse;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EvenementParametre;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.periode.ActionFormation;
import fr.unedic.cali.calcul.dom.periode.DsmAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.DsmMaladie;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.parametres.AccesTauxCotisationAccidentTravail;
import fr.unedic.cali.calcul.pbjc.dom.PbjcNcp;
import fr.unedic.cali.calcul.pbjc.outilsfonctionnels.GenerateurPBJCs;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreAttributionSurDecisions;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDecisionPourProduit;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreOU;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ChronologieStandard;
import fr.unedic.util.temps.ComparateurTemporelsSurDateDebut;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class FacadePBJCProduitImpl
  extends fr.unedic.cali.asu.fds12.p02.calcul.pbjc.FacadePBJCProduitImpl
{
  public ChronologiePeriodes creerChronologiePBJCsAvant(AttributionSpec attributionParam, Damj dateGeneration, Damj dateBlocageActualisation, String libelleBlocageActualisation)
    throws ApplicativeException
  {
    ChronologiePeriodes pbjcsAvant = new ChronologiePeriodes();
    IndividuSpec individu = attributionParam.getDemandeur();
    Periode periodeAvant = null;
    ObjetChronoPeriodePriseEnCharge periodePEC = null;
    ResultatAvant resultatAvant = null;
    PbjcNcp pbjcNcpAvant = null;
    ChronologiePeriodes periodesFormation = new ChronologiePeriodes();
    ChronologiePeriodes actionsFormation = new ChronologiePeriodes();
    ObjetChronoPeriode periode = null;
    AccesTauxCotisationAccidentTravail acces = new AccesTauxCotisationAccidentTravail();
    ChronologieStandard valeursParametre = null;
    List datesChgtTauxCADT = new ArrayList();
    Damj dateChtTaux = null;
    ObjetChronoPeriode laPeriodeInterruptive = null;
    List datesDeDecoupageDesPBJCs = null;
    periodePEC = OutillagePeriodes.recupererPeriodePECContenant(individu, attributionParam.getDateEffet());
    resultatAvant = retournerResultatCalculAvant(attributionParam, periodePEC);
    
    CalendrierExecutionAvant calendrierAvant = (CalendrierExecutionAvant)attributionParam.getCalendrierExecutionAvant();
    if (calendrierAvant == null) {
      return pbjcsAvant;
    }
    periodeAvant = calendrierAvant.getPeriode();
    periodeAvant.setDebut(attributionParam.getDateAttribution());
    
    valeursParametre = acces.getChronoValeursParametre();
    valeursParametre.iterer();
    while (valeursParametre.encoreSuivant())
    {
      dateChtTaux = ((EvenementParametre)valeursParametre.elementSuivant()).getDateEvenement();
      if (dateChtTaux.estStrictementContenueDans(periodeAvant)) {
        datesChgtTauxCADT.add(dateChtTaux);
      }
    }
    Collection periodesAER = new ArrayList();
    Damj datePivot = periodeAvant.getFin();
    while (datePivot.estApres(attributionParam.getDateAttribution()))
    {
      FiltreET filtreCali = new FiltreET();
      filtreCali.ajouterFiltre(new FiltreAttributionSurDecisions());
      FiltreOU filtreProduit = new FiltreOU();
      filtreProduit.ajouterFiltre(new FiltreDecisionPourProduit(12));
      filtreProduit.ajouterFiltre(new FiltreDecisionPourProduit(52));
      filtreProduit.ajouterFiltre(new FiltreDecisionPourProduit(55));
      filtreCali.ajouterFiltre(filtreProduit);
      AttributionSpec attribution = (AttributionSpec)OutilRecherche.rechercherDecisionPrecedente(attributionParam.getDemandeur().getChronoDemandesNonTriees(), datePivot, filtreCali);
      if (attribution != null)
      {
        Periode periodeAER = new Periode(attribution.getPji(), attribution.getPji().deplacerVersAvant(new DureeCalendaire(1, 0, 0)));
        if (periodeAER.chevauche(periodeAvant))
        {
          periodesAER.add(periodeAER);
          datePivot = attribution.getDateAttribution().veille();
          if (periodeAER.getDebut().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periodeAER.getDebut());
          }
          if (periodeAER.getFin().lendemain().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periodeAER.getFin().lendemain());
          }
        }
        else
        {
          datePivot = Damj.NUIT_DES_TEMPS;
        }
      }
      else
      {
        datePivot = Damj.NUIT_DES_TEMPS;
      }
    }
    ChronologiePeriodes periodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(individu, attributionParam.getDateAttribution(), attributionParam.getPji());
    
    periodesGAEC.iterer();
    while (periodesGAEC.encoreSuivant())
    {
      periode = (ObjetChronoPeriode)periodesGAEC.elementSuivant();
      if ((periode instanceof PeriodeFormation))
      {
        PeriodeFormation periodeFormationCalcul = (PeriodeFormation)periode;
        if ((periodeFormationCalcul.getPeriodeEffectiveInitiale() != null) && (periodeFormationCalcul.getPeriodeEffectiveInitiale().chevauche(periodeAvant)))
        {
          periodesFormation.ajouter(periode);
          if (periodeFormationCalcul.getPeriodeEffectiveInitiale().getDebut().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periode.getDateDebut());
          }
          if (periodeFormationCalcul.getPeriodeEffectiveInitiale().getFin().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periode.getDateFin().lendemain());
          }
        }
      }
      else if ((periode instanceof ActionFormation))
      {
        ActionFormation actionFormationCalcul = (ActionFormation)periode;
        if ((actionFormationCalcul.getPeriode() != null) && (actionFormationCalcul.getPeriode().chevauche(periodeAvant))) {
          actionsFormation.ajouter(periode);
        }
      }
    }
    if ((resultatAvant.getListeCarencesEffectives().size() > 0) || (resultatAvant.estPresenceFranchise())) {
      traiterLesPBJCsSurLAvant(attributionParam, periodeAvant, datesDeDecoupageDesPBJCs, dateBlocageActualisation, datesChgtTauxCADT, periodesAER, periodesFormation, actionsFormation, dateGeneration, libelleBlocageActualisation, pbjcsAvant);
    }
    pbjcsAvant = GenerateurPBJCs.decouperEnPBJCsDisjointes(pbjcsAvant, true, false);
    if (!pbjcsAvant.estVide())
    {
      pbjcNcpAvant = (PbjcNcp)pbjcsAvant.dernierElement();
      if ((resultatAvant.getPji() == null) && (pbjcNcpAvant.getDateFin().coincideAvec(periodePEC.getDateFin())))
      {
        String motifRadiation = periodePEC.getMotifAnnulation();
        pbjcNcpAvant.setCodeRadiationLendemainPeriode(motifRadiation);
        pbjcNcpAvant.ajouterComplementDeJustification("TD");
        if ((motifRadiation != null) && (motifRadiation.equals("73"))) {
          pbjcNcpAvant.ajouterComplementDeJustification("OH");
        }
      }
      if ((laPeriodeInterruptive != null) && (laPeriodeInterruptive.getDateDebut().coincideAvec(pbjcNcpAvant.getDateFin().lendemain()))) {
        if ((laPeriodeInterruptive instanceof ObjetChronoPeriodeRetraite))
        {
          pbjcNcpAvant.ajouterComplementDeJustification("OD");
        }
        else if ((laPeriodeInterruptive instanceof PeriodeExclusionDefinitiveDDTE))
        {
          String codeSanction = ((PeriodeExclusionDefinitiveDDTE)laPeriodeInterruptive).getCodeSanction();
          if (codeSanction.equals("ED")) {
            pbjcNcpAvant.ajouterComplementDeJustification("SJ");
          } else if (codeSanction.equals("EX")) {
            pbjcNcpAvant.ajouterComplementDeJustification("SI");
          }
        }
        else if ((laPeriodeInterruptive instanceof ObjetChronoPeriodeRejetDVDemandeExpresse))
        {
          pbjcNcpAvant.ajouterComplementDeJustification("ST");
        }
        else if ((laPeriodeInterruptive instanceof PeriodeBlocageIndemnisation))
        {
          pbjcNcpAvant.ajouterComplementDeJustification("OM");
        }
      }
    }
    return pbjcsAvant;
  }
  
  public void traiterLesPBJCsSurLAvant(AttributionSpec attribution, Periode periodeAvant, List datesDeDecoupageDesPBJCs, Damj dateBlocageActualisation, List datesChgtTauxCADT, Collection periodesAER, ChronologiePeriodes periodesFormation, ChronologiePeriodes actionsFormation, Damj dateGeneration, String libelleBlocageActualisation, ChronologiePeriodes pbjcsAvant)
  {
    ChronologiePeriodes periodes = null;
    ChronologiePeriodes periodesInterruptives = null;
    ObjetChronoPeriode laPeriodeInterruptive = null;
    PbjcNcp pbjcsAvantSusp = null;
    
    List listePeriode = new ArrayList();
    List listeConstantesPBJC = new ArrayList();
    
    CalendrierExecutionAvant calendrierAvant = (CalendrierExecutionAvant)attribution.getCalendrierExecutionAvant();
    Chronologie listUtAvant = calendrierAvant.getChronologieUnitesTraitements();
    listUtAvant.iterer();
    while (listUtAvant.encoreSuivant())
    {
      UniteTraitementAvant utAvant = (UniteTraitementAvant)listUtAvant.elementSuivant();
      if ((attribution.getDateAttribution().estContenueDans(new Periode(utAvant.getDateDebut(), utAvant.getDateFin()))) || (attribution.getDateAttribution().estAvant(utAvant.getDateDebut())))
      {
        periodes = (ChronologiePeriodes)utAvant.getQualificationPeriodes().getPeriodesSuspensives().copier(new FiltreChevauchePeriode(periodeAvant));
        
        periodesInterruptives = utAvant.getQualificationPeriodes().getPeriodesInterruptives();
        periodesInterruptives.setComparateur(new ComparateurTemporelsSurDateDebut());
        periodes.iterer();
        while (periodes.encoreSuivant())
        {
          ObjetChronoPeriode periode = (ObjetChronoPeriode)periodes.elementSuivant().copie();
          if (periode.getDateDebut().estAvant(periodeAvant.getDebut())) {
            periode.setDateDebut(periodeAvant.getDebut());
          }
          if (periode.getDateFin().estApres(periodeAvant.getFin())) {
            periode.setDateFin(periodeAvant.getFin());
          }
          boolean peutAjouter = true;
          for (int i = 0; i < listePeriode.size(); i++)
          {
            ObjetChronoPeriode periodeTmp = (ObjetChronoPeriode)listePeriode.get(i);
            if ((periode.getDateDebut().coincideAvec(periodeTmp.getDateDebut())) && (periode.getDateFin().coincideAvec(periodeTmp.getDateFin()))) {
              peutAjouter = false;
            }
          }
          if (peutAjouter)
          {
            listePeriode.add(periode);
            if (((periode instanceof PeriodeEvenementPersonnel)) && (((PeriodeEvenementPersonnel)periode).getNature() == 38)) {
              listeConstantesPBJC.add("CA");
            } else if (((periode instanceof DsmMaladie)) || (((periode instanceof PeriodeEvenementPersonnel)) && (((PeriodeEvenementPersonnel)periode).getNature() != 38))) {
              listeConstantesPBJC.add("MA");
            } else if (((periode instanceof DsmAbsenceAuPointage)) || ((periode instanceof PeriodeAbsenceAuPointage))) {
              listeConstantesPBJC.add("AB");
            } else if (((periode instanceof PeriodeTravailJustifiee)) || ((periode instanceof PeriodeActiviteEmploiCalcul))) {
              listeConstantesPBJC.add("CT");
            } else if ((periode instanceof PeriodeSuspensionDDTEAvecImputation)) {
              listePeriode.remove(periode);
            } else {
              listeConstantesPBJC.add("CT");
            }
          }
        }
        DureeConsommableAvant dureeFranchiseCP = (DureeConsommableAvant)utAvant.getDureeFranchiseCPEnDebutUT().copie();
        DureeConsommableAvant dureeFranchiseSalaire = (DureeConsommableAvant)utAvant.getDureeFranchiseSalaireEnDebutUT().copie();
        DureeConsommableAvant dureeFranchiseCPFin = (DureeConsommableAvant)utAvant.getDureeFranchiseCPEnFinUT().copie();
        DureeConsommableAvant dureeFranchiseSalaireFin = (DureeConsommableAvant)utAvant.getDureeFranchiseSalaireEnFinUT().copie();
        ConsommationPeriodes consoPeriode = utAvant.getConsommationPeriodes();
        
        periodesInterruptives.iterer();
        if (periodesInterruptives.encoreSuivant()) {
          laPeriodeInterruptive = (ObjetChronoPeriode)periodesInterruptives.elementSuivant();
        }
        Periode periodeUtAvant = new Periode(Damj.max(utAvant.getDateDebut(), periodeAvant.getDebut()), utAvant.getDateFin());
        if ((consoPeriode.getPeriodeFranchiseCP() != null) && (consoPeriode.getPeriodeFranchiseCP().chevauche(periodeUtAvant)))
        {
          boolean positionJustifFermeture;
          boolean positionJustifFermeture;
          if ((dureeFranchiseCPFin.getQuantiteCourante() != null) && (!dureeFranchiseCPFin.getQuantiteCourante().getValeur().equals(BigDecimal.ZERO))) {
            positionJustifFermeture = false;
          } else {
            positionJustifFermeture = true;
          }
          boolean positionJustifOuverture;
          boolean positionJustifOuverture;
          if ((dureeFranchiseSalaire.getQuantiteCourante() != null) && (!dureeFranchiseSalaire.getQuantiteCourante().getValeur().equals(dureeFranchiseSalaire.getQuantiteInitial().getValeur()))) {
            positionJustifOuverture = false;
          } else {
            positionJustifOuverture = true;
          }
          traiterLesPBJCsAvant(dureeFranchiseSalaire, periodeAvant, datesDeDecoupageDesPBJCs, dateBlocageActualisation, datesChgtTauxCADT, attribution, periodesAER, periodesFormation, actionsFormation, dateGeneration, libelleBlocageActualisation, pbjcsAvant, consoPeriode.getPeriodeFranchiseCP(), false, positionJustifOuverture, positionJustifFermeture, periodesInterruptives, laPeriodeInterruptive);
        }
        if ((consoPeriode.getPeriodeFranchiseSalaire() != null) && (consoPeriode.getPeriodeFranchiseSalaire().chevauche(periodeUtAvant)))
        {
          boolean positionJustifFermeture;
          boolean positionJustifFermeture;
          if ((dureeFranchiseSalaireFin.getQuantiteCourante() != null) && (!dureeFranchiseSalaireFin.getQuantiteCourante().getValeur().equals(BigDecimal.ZERO))) {
            positionJustifFermeture = false;
          } else {
            positionJustifFermeture = true;
          }
          boolean positionJustifOuverture;
          boolean positionJustifOuverture;
          if ((dureeFranchiseCP.getQuantiteCourante() != null) && (!dureeFranchiseCP.getQuantiteCourante().getValeur().equals(dureeFranchiseCP.getQuantiteInitial().getValeur()))) {
            positionJustifOuverture = false;
          } else {
            positionJustifOuverture = true;
          }
          traiterLesPBJCsAvant(dureeFranchiseCP, periodeAvant, datesDeDecoupageDesPBJCs, dateBlocageActualisation, datesChgtTauxCADT, attribution, periodesAER, periodesFormation, actionsFormation, dateGeneration, libelleBlocageActualisation, pbjcsAvant, consoPeriode.getPeriodeFranchiseSalaire(), false, positionJustifOuverture, positionJustifFermeture, periodesInterruptives, laPeriodeInterruptive);
        }
        filtrerPbjcAvantPeriodesInterruptives(periodesInterruptives, pbjcsAvant);
      }
    }
  }
}

/* Location:
 * Qualified Name:     FacadePBJCProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */