package fr.unedic.cali.asu.may17.p02.avant;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.cge01.avant.FacadeAvantLigneImpl;
import fr.unedic.cali.asu.cge01.avant.FacadeAvantLigneSansTrancheImpl;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.may17.p02.avant.outilsfonctionnels.TraitementUtAvant;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.avant.FacadeAvantProduitFactory;
import fr.unedic.cali.avant.FacadeAvantProduitSpec;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.TraitementUTAvant;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.temps.ObjetChrono60AnsBlocageRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeArretCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSanctions;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.OutilRetraite;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreConflitGaec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;

public class FacadeAvantProduitImpl
  extends FacadeAvantLigneSansTrancheImpl
{
  private static final int CENT = 100;
  
  public ResultatAvant executerAvant(AttributionSpec p_attribution, boolean p_avecPriseEnCompteEvenement, Damj p_dateEtude, boolean p_executionPersistante)
    throws CoucheLogiqueException
  {
    return executionDeLAvant(p_attribution, p_avecPriseEnCompteEvenement, p_dateEtude, p_executionPersistante);
  }
  
  private ResultatAvant executionDeLAvant(AttributionSpec p_attribution, boolean p_avecPriseEnCompteEvenement, Damj p_dateEtude, boolean p_executionPersistante)
    throws CoucheLogiqueException
  {
    ResultatAvant resultatAvant = null;
    Damj pji = null;
    Collection carencesEffectives = new ArrayList();
    ObjetChronoPeriodePriseEnCharge periodePEC = null;
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSansConflitGAEC = new ChronologiePeriodes();
    Collection listeCarrence = ((Admission)p_attribution).getListeCarences();
    
    int etat = 0;
    
    Periode periodeUtAvant = null;
    Damj dateDebutUtAvant = null;
    Damj dateFinUtAvant = null;
    
    CalendrierExecutionAvant calendrierAvant = new CalendrierExecutionAvant();
    calendrierAvant.setPremierJourAvant(rechercherDateDebutAvant(((Admission)p_attribution).getAttributionAssurance()));
    calendrierAvant.setEtatExecutionAvant(1);
    
    dateDebutUtAvant = calendrierAvant.getPremierJourAvant().getDebutMois();
    dateFinUtAvant = dateDebutUtAvant.getFinMois();
    
    Damj dateAttribOuPjp = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(p_attribution);
    if (p_avecPriseEnCompteEvenement)
    {
      chronologiePeriodes = recuperationDeToutesLesDesPeriodes(p_attribution.getDemandeur(), p_attribution, dateAttribOuPjp, null);
      
      periodePEC = OutillagePeriodes.recupererPeriodePECContenant(p_attribution.getDemandeur(), dateAttribOuPjp);
      if (periodePEC == null)
      {
        resultatAvant = new ResultatAvant(pji, new ArrayList(), true);
        resultatAvant.setDernierJourAvant(p_attribution.getDateAttribution());
        resultatAvant.setEtat(1);
        return resultatAvant;
      }
    }
    else
    {
      chronologiePeriodes = (ChronologiePeriodes)recuperationDeToutesLesDesPeriodes(p_attribution.getDemandeur(), p_attribution, dateAttribOuPjp, dateAttribOuPjp).copier(new FiltreChevauchePeriode(new Periode(dateAttribOuPjp, dateAttribOuPjp)));
      
      chronologiePeriodesSansConflitGAEC = (ChronologiePeriodes)chronologiePeriodes.copier(new FiltreNegation(new FiltreConflitGaec()));
      
      chronologiePeriodes = chronologiePeriodesSansConflitGAEC;
      
      fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification qualification = new fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification();
      QualificationPeriodes periodesQualifie = new QualificationPeriodes();
      periodesQualifie = qualification.qualificationPeriodesPourAvant(chronologiePeriodes, p_attribution);
      
      chronologiePeriodes = periodesQualifie.getPeriodesSuspensives();
      chronologiePeriodes.ajouter(periodesQualifie.getPeriodesInterruptives());
    }
    IndividuSpec individu = p_attribution.getDemandeur();
    if (p_dateEtude != null) {
      chronologiePeriodes.ajouter(new ObjetChronoPeriodeArretCalcul(p_dateEtude.lendemain()));
    }
    while ((calendrierAvant.getEtatExecutionAvant() != 3) && (!listeCarrence.isEmpty()))
    {
      periodeUtAvant = new Periode(dateDebutUtAvant, dateFinUtAvant);
      if ((individu != null) && (individu.getDateNaissance() != null) && (periodeUtAvant.getDebut().estApres(individu.getDateNaissance().deplacerVersAvant(new DureeCalendaire(100))))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { p_attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(new Damj("2200, 01, 01"))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { p_attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(Damj.FIN_DES_TEMPS)) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { p_attribution.getDateAttribution() });
      }
      dateDebutUtAvant = dateFinUtAvant.getDebutMoisSuivant();
      dateFinUtAvant = dateDebutUtAvant.getFinMois();
      if (Log.isTraceActive(FacadeAvantLigneImpl.class, Niveau.DEBUG)) {
        Log.ecritTrace(Niveau.DEBUG, FacadeAvantLigneImpl.class, "executerAvant", "Calcul: UT Avant [" + periodeUtAvant.getDebut() + " - " + periodeUtAvant.getFin() + "]");
      }
      etat = TraitementUtAvant.executerUtAvant(((Admission)p_attribution).getAttributionAssurance(), calendrierAvant, periodeUtAvant, chronologiePeriodes);
    }
    if (etat == 0) {
      pji = calendrierAvant.getDernierJourAvant().lendemain();
    }
    if (!listeCarrence.isEmpty())
    {
      if (p_executionPersistante) {
        p_attribution.setCalendrierExecutionAvant(calendrierAvant);
      }
      mettreAJour(calendrierAvant, ((Admission)p_attribution).getAttributionAssurance(), carencesEffectives);
      
      resultatAvant = new ResultatAvant(pji, new ArrayList(carencesEffectives), calendrierAvant.getEtatAuDernierJourAvant().isDelaiAttenteEntame());
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(calendrierAvant.getDateDebut());
      resultatAvant.setDernierJourAvant(calendrierAvant.getDateFin());
      resultatAvant.setCalendrierExecutionAvantCalcul(calendrierAvant);
    }
    else
    {
      p_attribution.setCalendrierExecutionAvant(null);
      
      resultatAvant = new ResultatAvant(p_attribution.getDateAttribution(), new ArrayList(), false);
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(p_attribution.getDateAttribution());
      resultatAvant.setDernierJourAvant(p_attribution.getDateAttribution());
    }
    if (etat == 1) {
      resultatAvant.setMessageErreur("Impossible de determiner le PJI : Un événement interruptif est survenu avant la fin du différé.");
    }
    return resultatAvant;
  }
  
  protected ChronologiePeriodes recuperationDeToutesLesDesPeriodes(IndividuSpec p_individu, AttributionSpec p_attribution, Damj dateDebut, Damj dateFin)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodesGAEC = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesPEC = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSanctions = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesPourAttribution = new ChronologiePeriodes();
    ChronologiePeriodes chronologieRetraite = new ChronologiePeriodes();
    ChronologiePeriodes chronologieDemandeExpresse = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodeInterProduit = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodeSP = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodeEvtActualisation = new ChronologiePeriodes();
    Collection collectionPeriodesPourAttribution = new LinkedList();
    Collection decisionsSuivi = null;
    ChronologiePeriodes chronologiePeriodesISLR = new ChronologiePeriodes();
    
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(chronologiePeriodeSP, p_attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(chronologiePeriodeSP, p_attribution);
    chronologiePeriodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(p_individu, dateDebut, dateFin);
    decisionsSuivi = OutillagePeriodes.recupererDecisionsSuivi(p_individu);
    chronologiePeriodesSanctions = GestionSanctions.recupererSanctions(decisionsSuivi);
    chronologiePeriodesPEC = OutillagePeriodes.recupererRadiations(p_individu);
    if (p_individu.getDateLiquidationRetraite() != null)
    {
      ObjetChronoPeriodeRetraite chronoRetraite = OutillagePeriodes.genererPeriodeRetraite(p_individu);
      chronologieRetraite.ajouter(chronoRetraite);
    }
    chronologieDemandeExpresse = (ChronologiePeriodes)RechercheDecisionsInterruptives.rechercher(p_individu, dateDebut, p_attribution);
    
    chronologiePeriodeEvtActualisation = OutillagePeriodes.recupererPeriodesEvtActualisation(p_individu);
    
    chronologiePeriodeInterProduit = recuperationObjetPeriodeInterProduit(p_individu, "ASU", p_attribution, 1);
    
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesGAEC.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesPEC.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesSanctions.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologieRetraite.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologieDemandeExpresse.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeInterProduit.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeSP.mapperVersCollection());
    
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeEvtActualisation.mapperVersCollection());
    
    collectionPeriodesPourAttribution.addAll(getPeriodesInterProduitsSurAvantPourArce(p_individu, p_attribution));
    
    collectionPeriodesPourAttribution.addAll(getPeriodesInterProduitsSurAvantPourRfpe(p_individu, p_attribution));
    if (p_individu.getDateBlocageIndemnisation() != null)
    {
      PeriodeBlocageIndemnisation periodeBlocageIndemnisation = new PeriodeBlocageIndemnisation(p_individu.getDateBlocageIndemnisation().lendemain());
      
      collectionPeriodesPourAttribution.add(periodeBlocageIndemnisation);
    }
    ObjetChrono60AnsBlocageRetraite objetChrono60AnsBlocageRetraite = OutilRetraite.genererBlocageRetraite60Ans(p_individu);
    if (objetChrono60AnsBlocageRetraite != null) {
      if (objetChrono60AnsBlocageRetraite.getDateEffet().estAvantOuCoincideAvec(p_attribution.getDateAttribution())) {
        collectionPeriodesPourAttribution.add(new ObjetChrono60AnsBlocageRetraite(p_attribution.getDateAttribution()));
      } else {
        collectionPeriodesPourAttribution.add(objetChrono60AnsBlocageRetraite);
      }
    }
    chronologiePeriodesISLR = recupererPeriodeISLRAAjouter(p_individu, p_attribution);
    if ((chronologiePeriodesISLR != null) && (!chronologiePeriodesISLR.estVide())) {
      collectionPeriodesPourAttribution.addAll(chronologiePeriodesISLR.mapperVersCollection());
    }
    collectionPeriodesPourAttribution.addAll(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(((Admission)p_attribution).getAttributionAssurance()).mapperVersCollection());
    
    chronologiePeriodesPourAttribution.ajouter(collectionPeriodesPourAttribution);
    
    return chronologiePeriodesPourAttribution;
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec attribution, ObjetChronoPeriode periode, PeriodeAnalyseSpec pa, ArretProduitAvecRaison arretProduitAvecRaison)
    throws CoucheLogiqueException
  {}
  
  public Collection<?> recupererCarrence(AttributionSpec attribution)
  {
    Collection listeCarrence = ((Admission)attribution).getAttributionAssurance().getListeCarences();
    return listeCarrence;
  }
  
  public Damj rechercherPremierJourAvant(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return rechercherDateDebutAvant(((Admission)attribution).getAttributionAssurance());
  }
  
  public boolean estUnContexteDeChomageEnCoursDeSuspensionAvecRupture(AttributionSpec attribution, Damj dateEtude)
  {
    return false;
  }
  
  public boolean estUnContexteDeChomageEnCoursDeSuspension(AttributionSpec attribution)
  {
    return false;
  }
  
  public int executerUtAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode periodeUtAvant, ChronologiePeriodes chronologiePeriodes)
    throws CoucheLogiqueException
  {
    FacadeAvantProduitSpec facadeAvant = FacadeAvantProduitFactory.getInstance().getInstanceFacadeAvantProduit(attribution.getProduitExecution());
    return TraitementUTAvant.executerUtAvant(((Admission)attribution).getAttributionAssurance(), calendrierAvant, periodeUtAvant, chronologiePeriodes, facadeAvant);
  }
  
  public void mettreAJourCarencesSurResultatAvant(CalendrierExecutionAvant calendrierExecutionAvant, AttributionSpec attribution, Collection listeCarences)
  {
    mettreAJour(calendrierExecutionAvant, ((Admission)attribution).getAttributionAssurance(), listeCarences);
  }
  
  public QualificationPeriodes qualificationPeriodesPourAvant(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels.Qualification qualification = new fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels.Qualification();
    return qualification.qualificationPeriodesPourAvant(chronologiePeriodes, attribution);
  }
}

/* Location:
 * Qualified Name:     FacadeAvantProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */