package fr.unedic.cali.asu.may17.p02.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteAsu;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteGamme;
import fr.unedic.cali.asu.calcul.dom.EtatAuDjiGamme;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDVMayotte;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeDebutPec;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.ActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.cge01.calcul.FacadeCalculLigneSansTrancheImpl;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Maintien;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaireMayotte;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.fabriques.FabriqueConventionTransitoireCalcul2014;
import fr.unedic.cali.asu.may17.p02.calcul.dom.CalendrierExecutionCalcul;
import fr.unedic.cali.asu.may17.p02.calcul.dom.DureeIndemnisationPremiereTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.DureeIndemnisationSecondeTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.DureeIndemnisationTroisiemeTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantAREMFSpec;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantPremiereTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantPremiereTrancheF;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantSecondeTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantSecondeTrancheF;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantTroisiemeTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantTroisiemeTrancheF;
import fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels.PostTraitement;
import fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetection100TMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetectionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeMaintien;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsTrancheCalcul;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGenerationEnqueteCumulARSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.Differe;
import fr.unedic.cali.autresdoms.cohab.dom.PeriodeSousPensionInvaliditeChainee;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EvenementDegressivite;
import fr.unedic.cali.calcul.dom.EvenementFinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.EvenementMaintien;
import fr.unedic.cali.calcul.dom.EvenementRejetDv;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvaliditeChainee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChrono60AnsBlocageRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationAvantageVieillesseAvantPJI;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyse;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.pbjc.dom.IndividuPbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DureeIndemnisationAbstraite;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.RevisionSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSolSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.outilsfonctionnels.OutilRetraite;
import fr.unedic.cali.outilsfonctionnels.OutilRetraiteMayotte;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.parcours.ResultatCalcul;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends FacadeCalculLigneSansTrancheImpl
{
  private static final int DIX = 10;
  private static final int DATE_ATTRIBUTION_MINIMALE_JOUR = 1;
  private static final int DATE_ATTRIBUTION_MINIMALE_MOIS = 7;
  private static final int DATE_ATTRIBUTION_MINIMALE_ANNEE = 2001;
  private static final Damj DATE_ATTRIBUTION_MINIMALE = new Damj(2001, 7, 1);
  
  public CalendrierExecutionCalculSpec creerCalendrierExecutionCalcul(AttributionSpec attribution)
  {
    return new CalendrierExecutionCalcul();
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAJourCumulAR(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, ConstituantsCalculActiviteReduiteSpec pconstituantsCalculActiviteReduite, ContexteUT contexteUT, ArretProduitAvecRaison arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    fr.unedic.cali.calcul.dom.UniteTraitementForcee utForcee = GestionForcage.getUniteTraitementForcee(attribution.getDemande(), ut.getDateDebut(), ut.getDateFin(), false);
    if ((utForcee == null) || (!utForcee.isCumulAR()))
    {
      ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduite = (ConstituantsCalculActiviteReduiteAsu)pconstituantsCalculActiviteReduite;
      
      int cumulActiviteReduite = constituantsCalculActiviteReduite.getCumul();
      boolean existeAttributionPrecedenteAvecCumulAr = false;
      boolean individuPossedeCesSurUt = false;
      boolean individuPossedeCaeSurUt = false;
      boolean individuPossedeCaeCuiSurUt = false;
      
      CritereStrategie critere = new CritereStrategie();
      critere.setDatePivot(ut.getDateDebut());
      FabriqueConventionTransitoireCalcul2014 fabrique = FabriqueConventionTransitoireCalcul2014.getInstance();
      StrategieGenerationEnqueteCumulARSpec strategie = (StrategieGenerationEnqueteCumulARSpec)fabrique.getStrategie(critere);
      
      ConstituantsIndemnisation constituantIndemnisation = ut.getConstituantsIndemnisationEnDebutUT();
      if ((((((Admission)attribution).getAttributionAssurance() instanceof RepriseSpec)) || ((((Admission)attribution).getAttributionAssurance() instanceof RevisionSpec))) && (((Admission)attribution).getAttributionAssurance().getPji().estContenueDans(ut.getPeriode()))) {
        existeAttributionPrecedenteAvecCumulAr = existeAttributionPrecedenteAvecCumulAr(((Admission)attribution).getAttributionAssurance(), contexteUT);
      }
      if (existeAttributionPrecedenteAvecCumulAr) {
        constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite + 1);
      }
      if (!existeAttributionPrecedenteAvecCumulAr)
      {
        Iterator<?> iterateurPeriode = ut.getQualificationPeriodes().getPeriodesDecalantes().iterer();
        while (iterateurPeriode.hasNext())
        {
          ObjetChronoPeriode periodeActivite = (ObjetChronoPeriode)iterateurPeriode.next();
          if ((periodeActivite instanceof PeriodeActiviteEmploiCalcul))
          {
            if (7 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
              individuPossedeCesSurUt = true;
            }
            if (14 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
              individuPossedeCaeSurUt = true;
            }
            if (23 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
              individuPossedeCaeCuiSurUt = true;
            }
          }
        }
        boolean decalageSurPa = false;
        Iterator<PeriodeAnalyseSpec> ite = ut.getListePeriodesAnalyse().iterer();
        while (ite.hasNext())
        {
          PeriodeAnalyse pa = (PeriodeAnalyse)ite.next();
          if ((pa.getQuantiteDecalee() != null) && (pa.getQuantiteDecalee().getValeurEntiere() >= 0)) {
            decalageSurPa = true;
          }
        }
        if ((!individuPossedeCesSurUt) && (!individuPossedeCaeSurUt) && (!individuPossedeCaeCuiSurUt) && (!ut.isNeutralisee()) && (((ut.getCreditDecalage() != null) && (ut.getCreditDecalage().getValeur() != null) && (ut.getCreditDecalage().getValeur().intValue() >= 0)) || ((decalageSurPa) && (ut.getQuantiteIndemnisee() != null) && (ut.getQuantiteIndemnisee().getValeur() != null) && (ut.getQuantiteIndemnisee().getValeur().intValue() >= 1))))
        {
          cumulActiviteReduite++;
          constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite);
          
          Reglement reglementOdCourante = ((ElementBaseIndemnisation)constituantIndemnisation.getElementBaseIndemnisationCourant()).getReglementMontantRetenu();
          if ((!reglementOdCourante.equals(((Admission)attribution).getAttributionAssurance().getProduit().getReglement("A4"))) && (cumulActiviteReduite == 13) && (((Admission)attribution).getAttributionAssurance().getDemandeur().getAgeALaDate(ut.getDateDebut()).getAnnees() < 50) && (strategie != null) && (strategie.genererEnqueteCumulAR())) {
            GestionSuivi.enregistrerEnquetePbjcNcp(((Admission)attribution).getAttributionAssurance(), ut.getDateFin(), 11, 0, true, null, this, ut.getConstituantsIndemnisationEnFinUT());
          }
          if (cumulActiviteReduite == 1) {
            GestionSuivi.enregistrerEnquetePbjcNcp(((Admission)attribution).getAttributionAssurance(), Damj.max(ut.getDateDebut(), ((Admission)attribution).getAttributionAssurance().getPji()), 4, 0, true, null, this, ut.getConstituantsIndemnisationEnFinUT());
          }
        }
      }
      return constituantsCalculActiviteReduite;
    }
    return pconstituantsCalculActiviteReduite;
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = null;
    IndividuSpec individu = null;
    
    periodesIndividuelles = new ChronologiePeriodes();
    individu = attribution.getDemandeur();
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    if (individu.getDateLiquidationRetraite() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    }
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(periodesIndividuelles, attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(periodesIndividuelles, attribution);
    
    ObjetChrono60AnsBlocageRetraite objetChrono60AnsBlocageRetraite = OutilRetraite.genererBlocageRetraite60Ans(individu);
    if (objetChrono60AnsBlocageRetraite != null) {
      if (objetChrono60AnsBlocageRetraite.getDateEffet().estAvantOuCoincideAvec(attribution.getDateAttribution())) {
        periodesIndividuelles.ajouter(new ObjetChrono60AnsBlocageRetraite(attribution.getDateAttribution()));
      } else {
        periodesIndividuelles.ajouter(objetChrono60AnsBlocageRetraite);
      }
    }
    ChronologiePeriodes chronologiePeriodesISLR = recupererPeriodeISLRAAjouter(individu, attribution);
    if ((chronologiePeriodesISLR != null) && (!chronologiePeriodesISLR.estVide())) {
      periodesIndividuelles.ajouter(chronologiePeriodesISLR);
    }
    return periodesIndividuelles;
  }
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attribution, Periode periodeUT)
    throws ApplicativeException
  {
    Iterator iterator = null;
    QuantiteDroitSpec duree = null;
    Collection collectionDurees = null;
    
    collectionDurees = constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        duree = (QuantiteDroitSpec)iterator.next();
        if (((duree instanceof DureeIndemnisationPremiereTranche)) && (duree.getQuantiteInitial().getValeurEntiere() != 0))
        {
          duree.activer();
          constituantsIndemnisation.setDureeIndemnisation((DureeIndemnisationAbstraite)duree);
          initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attribution, periodeUT);
        }
        else if (((duree instanceof DureeIndemnisationSecondeTranche)) && (duree.getQuantiteInitial().getValeurEntiere() != 0))
        {
          duree.activer();
          constituantsIndemnisation.setDureeIndemnisation((DureeIndemnisationAbstraite)duree);
          initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attribution, periodeUT);
        }
        else if (((duree instanceof DureeIndemnisationTroisiemeTranche)) && (duree.getQuantiteInitial().getValeurEntiere() != 0))
        {
          duree.activer();
          constituantsIndemnisation.setDureeIndemnisation((DureeIndemnisationAbstraite)duree);
          initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attribution, periodeUT);
        }
      }
    }
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attribution, Periode periodeUT)
    throws CoucheLogiqueException
  {
    super.initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, ((Admission)attribution).getAttributionAssurance(), periodeUT);
    FormuleMontantSpec formuleMontant = null;
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = null;
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    QuantiteIndemnisationSpec duree = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      formuleMontant = attribution.getFormuleMontant(duree.getCodeFormuleMontant());
    } else {
      formuleMontant = attribution.getFormuleMontant(constituantsIndemnisation.getCodeFormuleMontant());
    }
    if (estUndroitAREM2016(attribution))
    {
      BigDecimal montantPI = RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChaineesSurEBI(((Admission)attribution).getElementBaseIndemnisation(), recupererPremierJourExecutableNcp(attribution).veille(), attribution.getDateAttribution());
      if (montantPI.compareTo(BigDecimal.ZERO) == 0) {
        montantPI = RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(attribution.getDemandeur(), recupererPremierJourExecutableNcp(attribution).veille());
      }
      elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(montantPI);
    }
    if ((formuleMontant instanceof FormuleMontantAREMFSpec))
    {
      elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
      constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
    }
    ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).setProduitMontantRetenu(((Admission)attribution).getAttributionAssurance().getProduitMontantRetenu());
  }
  
  protected PeriodeAvantageVieillesse recupererPeriodeAv(AttributionSpec attribution, Damj date)
    throws CoucheLogiqueException
  {
    if (date != null) {
      return RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvMayotteADate(((AttributionAssuranceSpec)attribution).getDemandeur(), date);
    }
    return RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvMayotteADate(((AttributionAssuranceSpec)attribution).getDemandeur(), recupererPremierJourExecutableNcp(attribution));
  }
  
  public boolean verifierConditionExecutionEtEventuelAbandon(AttributionSpec attribution, ContexteUT contexteUT, Periode periodeUT, CalendrierExecutionCalculSpec calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    if (!attribution.estPjiEffectif())
    {
      calendrierExecutionCalcul.setEtatAttribution(4);
      return false;
    }
    return true;
  }
  
  public int initialiserCompteurFormation(AttributionSpec attribution)
  {
    return 0;
  }
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    constituantsIndemnisation.setCollectionQuantiteDroit(((Admission)attribution).getListeDurees());
    return constituantsIndemnisation;
  }
  
  public ConstituantsCalculActiviteReduiteSpec creationConstituantsCalculActiviteReduite(AttributionSpec pattribution, ContexteUT contexteUT, ConstituantsIndemnisation constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    int cumulAR = 0;
    Admission attribution = (Admission)pattribution;
    return new ConstituantsCalculActiviteReduiteAsu(cumulAR, attribution.getElementBaseIndemnisation().getSjr(), attribution.getElementBaseIndemnisation().getSjc());
  }
  
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT contexteUT, AttributionSpec pattribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    
    Collection<?> collectionPeriode = contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourGamme(pattribution, "ASU");
    
    List<?> liste = contexteUT.getListeAttributions();
    if (liste != null)
    {
      Iterator<?> iterator = liste.iterator();
      while (iterator.hasNext())
      {
        AttributionSpec attribution = (AttributionSpec)iterator.next();
        if (attribution.getGamme().getNomUnique().equals("SOL")) {
          if (((attribution.getProduit().getNomUnique().equals("SOL_AER05_01")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_02")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_03"))) && (attribution.getCalendrierExecutionCalcul() != null) && ((attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 1) || (attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 2)))
          {
            Damj djiTheoriqueAER = ((ProduitSolSpec)attribution.getProduit()).getDjiTheoriqueAER(attribution);
            chronologiePeriodes.ajouter(new ObjetChronoPeriodeInterProduits(djiTheoriqueAER.lendemain(), djiTheoriqueAER.lendemain(), 5, attribution));
          }
        }
      }
    }
    collectionPeriode.addAll(contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(pattribution, "SOL_AER05_01"));
    collectionPeriode.addAll(contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(pattribution, "SOL_AER05_02"));
    collectionPeriode.addAll(contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(pattribution, "SOL_AER05_03"));
    
    collectionPeriode.addAll(contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourProduit(pattribution, "INR_RCE04_01"));
    
    chronologiePeriodes.ajouter(collectionPeriode);
    
    chronologiePeriodes.ajouter(RechercheDecisionsInterruptives.rechercher(pattribution.getDemandeur(), OutilGestionPoursuite.getInstance().recupererPremierJourExecutableNcp(pattribution), pattribution));
    
    chronologiePeriodes.ajouter(contexteUT.getPeriodesInterProduitsPeriodesLieuSurUTPourGammeRBF(pattribution));
    
    chronologiePeriodes.ajouter(contexteUT.getPeriodesInterProduitsSurUTIndemnisationRfpe(pattribution));
    
    chronologiePeriodes.ajouter(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(((Admission)pattribution).getAttributionAssurance()));
    
    chronologiePeriodes.ajouter(contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(pattribution, "RET_ACO01_01"));
    
    return chronologiePeriodes;
  }
  
  public void controlerAttribution(AttributionSpec pattribution)
    throws ContexteException
  {
    Admission attribution = (Admission)pattribution;
    
    Damj dateARE = DATE_ATTRIBUTION_MINIMALE;
    if (attribution.getDateEffet().estAvant(dateARE)) {
      throw new ContexteException("HG_PR_CALI_L_ERR_CONTEXTE", "La date de l'Ouverture de Droit doit etre posterieure au 01/07/2001", null);
    }
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAjourConstituantsCalculActiviteReduite(AttributionSpec pattribution, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, Damj dateDeMiseAjour, ConstituantsIndemnisation constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    Admission attribution = (Admission)pattribution;
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduiteProduit = (ConstituantsCalculActiviteReduiteAsu)constituantsCalculActiviteReduite;
    
    constituantsCalculActiviteReduiteProduit.setSjr(RevalorisationSalaireMayotte.revaloriserSjrMayotte(attribution.getAttributionAssurance(), dateDeMiseAjour));
    if (attribution.getAttributionAssurance().getElementBaseIndemnisation().getSjc() != null) {
      constituantsCalculActiviteReduiteProduit.setSjc(RevalorisationSalaire.revaloriserSjc(attribution.getAttributionAssurance().getElementBaseIndemnisation().getSjc(), dateDeMiseAjour));
    }
    return constituantsCalculActiviteReduiteProduit;
  }
  
  public void filtrePriseEnComptePeriodesActiviteSurUT(PeriodesPriseEnCompte periodesPriseEnCompte, Periode periodeUT, ContexteUT contexteUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    super.filtrePriseEnComptePeriodesActiviteSurUT(periodesPriseEnCompte, periodeUT, contexteUT, ((Admission)attribution).getAttributionAssurance());
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    return super.miseAJourConstituantsIndemnisation(ut, ((Admission)attribution).getAttributionAssurance(), constituantsIndemnisation, dateDeMiseAjour, periode);
  }
  
  public boolean epuisementQuantiteDroit(Damj dateEpuisementQuantite, AttributionSpec attribution, QuantiteDroitSpec quantiteDroitEpuisee, ConstituantsIndemnisation constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement ut)
    throws ApplicativeException
  {
    QuantiteDroitSpec duree = null;
    Collection<?> collectionDurees = constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      Iterator<?> iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        duree = (QuantiteDroitSpec)iterator.next();
        if (((quantiteDroitEpuisee instanceof DureeIndemnisationPremiereTranche)) && ((duree instanceof DureeIndemnisationSecondeTranche)) && 
          (estActiveDuree(duree)))
        {
          FormuleMontantSpec formuleMontant = attribution.getFormuleMontant(((DureeIndemnisationPremiereTranche)quantiteDroitEpuisee).getCodeFormuleMontant());
          if ((formuleMontant instanceof FormuleMontantAREMFSpec)) {
            ((DureeIndemnisationSecondeTranche)duree).setCodeFormuleMontant(FormuleMontantSecondeTrancheF.getCode());
          }
          duree.activer();
          ut.ajouterEvenement(new EvenementDegressivite(dateEpuisementQuantite.lendemain()));
          constituantsIndemnisation.setDureeIndemnisation((DureeIndemnisationAbstraite)duree);
          return false;
        }
        if (((quantiteDroitEpuisee instanceof DureeIndemnisationSecondeTranche)) && ((duree instanceof DureeIndemnisationTroisiemeTranche)) && 
          (estActiveDuree(duree)))
        {
          FormuleMontantSpec formuleMontant = attribution.getFormuleMontant(((DureeIndemnisationSecondeTranche)quantiteDroitEpuisee).getCodeFormuleMontant());
          if ((formuleMontant instanceof FormuleMontantAREMFSpec)) {
            ((DureeIndemnisationTroisiemeTranche)duree).setCodeFormuleMontant(FormuleMontantTroisiemeTrancheF.getCode());
          }
          duree.activer();
          ut.ajouterEvenement(new EvenementDegressivite(dateEpuisementQuantite.lendemain()));
          constituantsIndemnisation.setDureeIndemnisation((DureeIndemnisationAbstraite)duree);
          return false;
        }
      }
    }
    return true;
  }
  
  private boolean estActiveDuree(QuantiteDroitSpec quantiteDroit)
  {
    return quantiteDroit.getQuantiteInitial().getValeurEntiere() > 0;
  }
  
  public boolean recuperationAlimentationNombreMoisIndemnise(AttributionSpec attribution)
  {
    return true;
  }
  
  public int initialiserNombreMoisIndemnise(AttributionSpec attribution, fr.unedic.cali.calcul.dom.UniteTraitement ut, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    return 0;
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj date, ChronologiePeriodes chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    super.miseAJourConstituantsIndemnisationADate(((Admission)attribution).getAttributionAssurance(), constituantsIndemnisation, date, chronologiePeriodesSanctions);
    if (estUndroitAREM2016(attribution))
    {
      ElementBaseIndemnisation ebi = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      BigDecimal montantPI = RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChaineesSurEBI(((Admission)attribution).getElementBaseIndemnisation(), recupererPremierJourExecutableNcp(attribution).veille(), attribution.getDateAttribution());
      if (montantPI.compareTo(BigDecimal.ZERO) == 0) {
        montantPI = RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(attribution.getDemandeur(), recupererPremierJourExecutableNcp(attribution).veille());
      }
      if (ebi.getMontantPensionInvaliditeADeduire() != null) {
        ebi.setMontantPensionInvaliditeADeduire(ebi.getMontantPensionInvaliditeADeduire().add(montantPI));
      }
    }
  }
  
  public EtatAuDji renseignerEtatAuDji(fr.unedic.cali.calcul.dom.UniteTraitement derniereUT, CalendrierExecutionCalculPeriodique calendrier, AttributionSpec attribution, EtatAuDji petatAuDji)
    throws CoucheLogiqueException
  {
    int reliquatCumulAR = 0;
    EtatAuDjiGamme etatAuDji = new EtatAuDjiGamme();
    Quantite reliquatDureeIndemnisation = null;
    etatAuDji.setMontant(petatAuDji.getMontant());
    reliquatCumulAR = ((ConstituantsCalculActiviteReduiteGamme)derniereUT.getConstituantsCalculActiviteReduiteEnFinUT()).getCumul();
    etatAuDji.setCumulMoisActiviteReduite(reliquatCumulAR);
    reliquatDureeIndemnisation = recupererReliquatDureeIndemnisation(derniereUT);
    if (reliquatDureeIndemnisation != null)
    {
      etatAuDji.setReliquatDureeIndemnisation(new Quantite(reliquatDureeIndemnisation.getValeur().setScale(0), reliquatDureeIndemnisation.getUnite()));
      
      etatAuDji.setReliquatDureeIndemnisationAvecMaintien(etatAuDji.getReliquatDureeIndemnisation());
    }
    etatAuDji.setNbJourAREF(derniereUT.getNbJoursFormationEnFinDUT());
    etatAuDji.setNbMoisIndemniseAsu(derniereUT.getNbMoisIndemniseAsu());
    etatAuDji.setEstNbMoisIndemniseAsu(derniereUT.isEstNbMoisIndemniseAsu());
    
    return etatAuDji;
  }
  
  private Quantite recupererReliquatDureeIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement derniereUT)
  {
    Quantite reliquatDureeIndemnisation = null;
    Collection<?> collectionQuantiteDroit = derniereUT.getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit();
    QuantiteIndemnisationSpec quantiteIndemnisation = null;
    if (collectionQuantiteDroit != null)
    {
      Iterator<?> iterator = collectionQuantiteDroit.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroitSpec quantiteDroit = (QuantiteDroitSpec)iterator.next();
        if ((quantiteDroit instanceof QuantiteIndemnisationSpec))
        {
          quantiteIndemnisation = (QuantiteIndemnisationSpec)quantiteDroit;
          if (quantiteDroit.getEtat() == 1) {
            break;
          }
        }
      }
    }
    if (quantiteIndemnisation != null)
    {
      if (quantiteIndemnisation.getEtat() == 1) {
        reliquatDureeIndemnisation = quantiteIndemnisation.getQuantiteCourante();
      } else if (quantiteIndemnisation.getEtat() == 2) {
        reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
      }
    }
    else {
      reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
    }
    return reliquatDureeIndemnisation;
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec calendrierExecutionCalcul, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Damj dateFinDroitTheorique = null;
    EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)calendrierExecutionCalcul.getEtatAuDJI();
    BigDecimal reliquatDureeIndemnisation = null;
    if (etatAuDji != null) {
      if ((etatAuDji.getReliquatDureeIndemnisation() != null) && (etatAuDji.getReliquatDureeIndemnisation().getValeur() != null))
      {
        reliquatDureeIndemnisation = etatAuDji.getReliquatDureeIndemnisation().getValeur();
        dateFinDroitTheorique = calendrierExecutionCalcul.getDernierJourIndemnisable().deplacerVersAvant(new DureeCalendaire(0, 0, reliquatDureeIndemnisation.intValue()));
      }
      else
      {
        dateFinDroitTheorique = calendrierExecutionCalcul.getDernierJourIndemnisable();
      }
    }
    return dateFinDroitTheorique;
  }
  
  public Damj getIdeMaintienEuropeenDuDroit(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return super.getIdeMaintienEuropeenDuDroit(((Admission)attribution).getAttributionAssurance());
  }
  
  public Damj getPjiMaintienEuropeenDuDroit(AttributionSpec attribution)
  {
    return super.getPjiMaintienEuropeenDuDroit(((Admission)attribution).getAttributionAssurance());
  }
  
  public Damj getDjiMaintienEuropeenDuDroit(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return super.getDjiMaintienEuropeenDuDroit(((Admission)attribution).getAttributionAssurance());
  }
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec attribution, fr.unedic.cali.calcul.dom.UniteTraitement ut, ObjetChronoPeriode objetChronoPeriode, ArretProduitAvecRaison arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    super.traiterPeriodeInterruptiveDefinitive(attribution, ut, objetChronoPeriode, arretProduitAvecRaison, calendrier);
    if ((objetChronoPeriode instanceof ObjetChrono60AnsBlocageRetraite))
    {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M11", objetChronoPeriode.getDateDebut(), ""), attribution.getDemandeur());
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeAEDVMayotte))
    {
      if ((!GestionForcage.appliquerForcagePoursuiteIndemnisationMayotte(attribution.getDemande(), ut)) && (!GestionForcage.appliquerForcageRejetndemnisationMayotte(attribution.getDemande(), ut)))
      {
        boolean contientDejaInterruptifAmemeDate = verifiePresenceIntAvantOuMemeJourHorsDV(ut, objetChronoPeriode);
        if (!contientDejaInterruptifAmemeDate)
        {
          if (attribution.getDemandeur().getIndividuPbjcNcp() == null) {
            attribution.getDemandeur().setIndividuPbjcNcp(new IndividuPbjcNcp());
          }
          attribution.getDemandeur().getIndividuPbjcNcp().setDateAtteinteMoisNonPaye(objetChronoPeriode.getDateDebut().veille());
          ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
          GestionAnomalies.ajouteAnomalie(new Anomalie("M13", ut.getDateDebut(), ""), attribution.getDemandeur());
        }
      }
      if (!GestionForcage.appliquerForcageRejetndemnisationMayotte(attribution.getDemande(), ut)) {
        ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
      }
    }
  }
  
  public void traitementPeriodesGelantes(AttributionSpec attribution, ChronologiePeriodes periodesGelantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesGelantes(attribution, periodesGelantes, constituantsCalculActiviteReduite, ut);
  }
  
  public void traitementPeriodesDecalantes(AttributionSpec attribution, ChronologiePeriodes periodesDecalantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement ut, ConstituantsIndemnisation constituantsIndemnisation, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesDecalantes(attribution, periodesDecalantes, constituantsCalculActiviteReduite, ut);
  }
  
  public fr.unedic.cali.calcul.dom.UniteTraitement creerUT(Periode periodeUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return new fr.unedic.cali.asu.may17.p02.calcul.dom.UniteTraitement(Unite.get("jour"), periodeUT);
  }
  
  public fr.unedic.cali.calcul.dom.UniteTraitementForcee creerUniteTraitementForcee(Damj dateDebut, Damj dateFin)
  {
    return new fr.unedic.cali.ari.calcul.dom.UniteTraitementForcee(dateDebut, dateFin);
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(chronologiePeriodes, attribution);
  }
  
  public void ajouterConstituantsIndemnisationFuturs(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attribution, fr.unedic.cali.calcul.dom.UniteTraitement ut)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisationOrigine = null;
    Iterator<?> iteratorCollectionOrigine = null;
    QuantiteDroitSpec quantiteOrigine = null;
    boolean quantiteConnue = false;
    
    constituantsIndemnisationOrigine = creationConstituantsIndemnisation(attribution);
    if ((constituantsIndemnisationOrigine != null) && (constituantsIndemnisationOrigine.getCollectionQuantiteDroit() != null))
    {
      iteratorCollectionOrigine = constituantsIndemnisationOrigine.getCollectionQuantiteDroit().iterator();
      while (iteratorCollectionOrigine.hasNext())
      {
        quantiteConnue = false;
        quantiteOrigine = (QuantiteDroitSpec)iteratorCollectionOrigine.next();
        if (((quantiteOrigine instanceof DureeIndemnisationSecondeTranche)) && 
          ((constituantsIndemnisation.getDureeIndemnisation() instanceof DureeIndemnisationPremiereTranche)))
        {
          Iterator<?> iteratorCollection = constituantsIndemnisation.getCollectionQuantiteDroit().iterator();
          while (iteratorCollection.hasNext())
          {
            QuantiteDroitSpec quantite = (QuantiteDroitSpec)iteratorCollection.next();
            if ((quantite instanceof DureeIndemnisationSecondeTranche)) {
              quantiteConnue = true;
            }
          }
          if (!quantiteConnue) {
            constituantsIndemnisation.getCollectionQuantiteDroit().add(quantiteOrigine);
          }
        }
        if (((quantiteOrigine instanceof DureeIndemnisationTroisiemeTranche)) && (
          ((constituantsIndemnisation.getDureeIndemnisation() instanceof DureeIndemnisationPremiereTranche)) || ((constituantsIndemnisation.getDureeIndemnisation() instanceof DureeIndemnisationSecondeTranche))))
        {
          Iterator iteratorCollection = constituantsIndemnisation.getCollectionQuantiteDroit().iterator();
          while (iteratorCollection.hasNext())
          {
            QuantiteDroitSpec quantite = (QuantiteDroitSpec)iteratorCollection.next();
            if ((quantite instanceof DureeIndemnisationTroisiemeTranche)) {
              quantiteConnue = true;
            }
          }
          if (!quantiteConnue) {
            constituantsIndemnisation.getCollectionQuantiteDroit().add(quantiteOrigine);
          }
        }
      }
    }
  }
  
  public void traitementPeriodeSegmentante(AttributionSpec attribution, ObjetChronoPeriode pperiode, ConstituantsIndemnisation constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement ut, PeriodeAnalyseSpec pa, ArretProduitAvecRaison arretProduitAvecRaison, ChronologiePeriodes periodesAnalyses)
    throws ApplicativeException
  {
    if (((pperiode instanceof PeriodeSousPensionInvaliditeChainee)) && (pperiode.getDateDebut().estApresOuCoincideAvec(attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().add(((PeriodeSousPensionInvaliditeChainee)pperiode).getMontant().getValeur()));
    }
    else if (((pperiode instanceof FinPeriodePensionInvaliditeChainee)) && (((pa != null) && (pa.getDateDebut().equals(pperiode.getDateDebut()))) || ((pa == null) && (pperiode.getDateDebut().estContenueDans(ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().subtract(((FinPeriodePensionInvaliditeChainee)pperiode).getQuantiteEuro().getValeur()));
      
      ut.ajouterEvenement(new EvenementFinPeriodePensionInvalidite(pperiode.getDateDebut().veille()));
    }
    if (OutilsMaintienEuropeenEessiASU.controlerContexteMaintienEuropeen(attribution.getDemandeur(), pperiode.getDateDebut())) {
      if ((pperiode instanceof PeriodeFormation))
      {
        if (((PeriodeFormation)pperiode).estEffective()) {
          passerEnIndemnisationAvecFormation(pperiode, constituantsIndemnisation);
        } else {
          passerEnIndemnisationSansFormation(constituantsIndemnisation);
        }
      }
      else if ((pperiode instanceof ObjetChronoPeriodeDetectionAgeMaintien))
      {
        if (!((AttributionAssuranceSpec)attribution).estMaintenue()) {
          if (Maintien.getInstance().controlerConditionsDetectionHorsAge((AttributionAssuranceSpec)attribution, constituantsIndemnisation, pperiode.getDateDebut(), ut)) {
            Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)attribution, pperiode.getDateDebut(), constituantsIndemnisation);
          }
        }
      }
      else if ((pperiode instanceof ObjetChronoPeriodeDetection100TMaintien))
      {
        if (!((AttributionAssuranceSpec)attribution).estMaintenue()) {
          if (Maintien.getInstance().controlerConditionsDetectionHors100T((AttributionAssuranceSpec)attribution, constituantsIndemnisation, pperiode.getDateDebut(), ut)) {
            Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)attribution, pperiode.getDateDebut(), constituantsIndemnisation);
          }
        }
      }
      else if ((pperiode instanceof ObjetChronoPeriodeMaintien))
      {
        if (((ObjetChronoPeriodeMaintien)pperiode).getDateMaintienHorsPEC() != null) {
          Maintien.getInstance().detecter((AttributionAssuranceSpec)attribution, ((ObjetChronoPeriodeMaintien)pperiode).getDateMaintienHorsPEC(), false, constituantsIndemnisation);
        } else {
          Maintien.getInstance().detecter((AttributionAssuranceSpec)attribution, pperiode.getDateDebut(), false, constituantsIndemnisation);
        }
        if (((AttributionAssuranceSpec)attribution).estMaintenue()) {
          if (((ObjetChronoPeriodeMaintien)pperiode).getDateMaintienHorsPEC() != null) {
            ut.ajouterEvenement(new EvenementMaintien(((ObjetChronoPeriodeMaintien)pperiode).getDateMaintienHorsPEC()));
          } else {
            ut.ajouterEvenement(new EvenementMaintien(pperiode.getDateDebut()));
          }
        }
      }
    }
    if (((pperiode instanceof PeriodeInterStageFormation)) || ((pperiode instanceof FinActionFormation)))
    {
      passerEnIndemnisationSansFormation(constituantsIndemnisation);
    }
    else if ((pperiode instanceof PeriodeSanctionReductionMontant))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      if (((PeriodeSanctionReductionMontant)pperiode).getCodeSanction().equals("R1")) {
        elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("0.80"));
      } else if (((PeriodeSanctionReductionMontant)pperiode).getCodeSanction().equals("R2")) {
        elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("0.50"));
      }
    }
    else if (((pperiode instanceof FinPeriodeSanctionReductionMontant)) && (((pa != null) && (pa.getDateDebut().estContenueDans(((FinPeriodeSanctionReductionMontant)pperiode).getPeriode()))) || ((pa == null) && (pperiode.getDateDebut().estContenueDans(ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("1.00"));
    }
    else if (((pperiode instanceof PeriodeAvantageVieillesse)) && (pperiode.getDateDebut().estApresOuCoincideAvec(attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      BigDecimal montantAv = null;
      if ((elementBaseIndemnisation.getDateEffetAV() == null) || (elementBaseIndemnisation.getDateEffetAV().estAvant(pperiode.getDateDebut())))
      {
        montantAv = ((PeriodeAvantageVieillesse)pperiode).getQuantiteEuro().getValeur();
        elementBaseIndemnisation.setDateEffetAV(pperiode.getDateDebut());
      }
      else if (elementBaseIndemnisation.getDateEffetAV().coincideAvec(pperiode.getDateDebut()))
      {
        montantAv = elementBaseIndemnisation.getMontantAvantageVieillesse().add(((PeriodeAvantageVieillesse)pperiode).getQuantiteEuro().getValeur());
      }
      if (montantAv != null)
      {
        elementBaseIndemnisation.setMontantAvantageVieillesse(montantAv);
        if ((elementBaseIndemnisation.getSjr() != null) && (elementBaseIndemnisation.getSjr().getSalaire() != null) && (!elementBaseIndemnisation.getSjr().getSalaire().equals(new BigDecimal("0.00"))))
        {
          BigDecimal coeffAV = montantAv.divide(elementBaseIndemnisation.getSjr().getSalaire(), 10, 4);
          
          elementBaseIndemnisation.setCoefficientAvantageVieillesse(coeffAV);
        }
      }
    }
    else if ((pperiode instanceof ObjetChronoAnniversaire60Ans))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvMayotteADate(attribution.getDemandeur(), pperiode.getDateDebut());
      
      BigDecimal montantAV = new BigDecimal(0);
      if ((periodeAvCourante != null) && (!pperiode.getDateDebut().coincideAvec(periodeAvCourante.getDateDebut())))
      {
        montantAV = periodeAvCourante.getQuantiteEuro().getValeur();
        
        elementBaseIndemnisation.setDateEffetAV(pperiode.getDateDebut());
        Damj dateDepart = Damj.max(periodeAvCourante.getDateDebut(), attribution.getDateAttribution());
        Sjr sjrrp = RevalorisationSalaire.revaloriserSjr(((Admission)attribution).getAttributionAssurance().getElementBaseIndemnisation(), ((Admission)attribution).getAttributionAssurance().getProduitMontantRetenu(), dateDepart);
        
        BigDecimal coeffAV = montantAV.divide(sjrrp.getSalaire(), 10, 4);
        elementBaseIndemnisation.setCoefficientAvantageVieillesse(coeffAV);
        
        elementBaseIndemnisation.setMontantAvantageVieillesse(coeffAV.multiply(elementBaseIndemnisation.getSjr().getSalaire()));
      }
    }
    else if (((pperiode instanceof FinPeriodeAvantageVieillesse)) && (((pa != null) && (pa.getDateDebut().equals(pperiode.getDateDebut()))) || ((pa == null) && (pperiode.getDateDebut().estContenueDans(ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setCoefficientAvantageVieillesse(new BigDecimal("0"));
      elementBaseIndemnisation.setMontantAvantageVieillesse(new BigDecimal("0"));
    }
    else if (((pperiode instanceof FinPeriodeFormationNonIndemnisee)) && (((pa != null) && (pa.getDateDebut().equals(pperiode.getDateDebut()))) || ((pa == null) && (pperiode.getDateDebut().estContenueDans(ut.getPeriode())))))
    {
      if (((Admission)attribution).getAttributionAssurance().getDureeInitiale().getValeurEntiere() > ((Admission)attribution).getAttributionAssurance().getProduitMontantRetenu().getDureeMinimumPourImputationFormation()) {
        imputerQuantiteIndemnisationADate(ut, pperiode, pa, constituantsIndemnisation, arretProduitAvecRaison, attribution);
      }
    }
    else if (((pperiode instanceof PeriodeSuspensionDDTEAvecImputation)) && (pa != null) && (((PeriodeSuspensionDDTEAvecImputation)pperiode).getPeriodeInitiale().getDebut().coincideAvec(pa.getDateDebut())))
    {
      PeriodeSuspensionDDTEAvecImputation periode = (PeriodeSuspensionDDTEAvecImputation)pperiode.copie();
      
      Damj finPeriodesAnalyse = null;
      ObjetChronoPeriode periodesAnalyse = (ObjetChronoPeriode)periodesAnalyses.dernierElement();
      finPeriodesAnalyse = periodesAnalyse.getDateFin();
      if ((finPeriodesAnalyse != null) && (((PeriodeSuspensionDDTEAvecImputation)pperiode).getPeriodeInitiale().getFin().estApres(finPeriodesAnalyse))) {
        periode.setDateFin(finPeriodesAnalyse);
      }
      imputerQuantiteIndemnisationDuAuxSanctions(attribution, ut, periode, constituantsIndemnisation, arretProduitAvecRaison);
    }
    else if ((pperiode instanceof ObjetChronoPeriodeDebutPec))
    {
      OutilsMaintienEuropeenEessiASU.controlerEtEmettreEnqueteMaintienEuropeen(attribution, constituantsIndemnisation, pperiode.getDateDebut(), this, null, ut);
      passerEnIndemnisationSansFormation(constituantsIndemnisation);
    }
  }
  
  private void passerEnIndemnisationSansFormation(ConstituantsIndemnisation constituantsIndemnisation)
  {
    QuantiteDroitSpec quantite = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(constituantsIndemnisation.getCollectionQuantiteDroit());
    if (quantite != null) {
      if ((quantite instanceof DureeIndemnisationPremiereTranche)) {
        ((DureeIndemnisationPremiereTranche)quantite).setCodeFormuleMontant(FormuleMontantPremiereTranche.getCode());
      } else if ((quantite instanceof DureeIndemnisationSecondeTranche)) {
        ((DureeIndemnisationSecondeTranche)quantite).setCodeFormuleMontant(FormuleMontantSecondeTranche.getCode());
      } else if ((quantite instanceof DureeIndemnisationTroisiemeTranche)) {
        ((DureeIndemnisationTroisiemeTranche)quantite).setCodeFormuleMontant(FormuleMontantTroisiemeTranche.getCode());
      }
    }
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant().copie();
    constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisation);
  }
  
  private void passerEnIndemnisationAvecFormation(ObjetChronoPeriode periode, ConstituantsIndemnisation constituantsIndemnisation)
  {
    QuantiteDroitSpec quantite = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(constituantsIndemnisation.getCollectionQuantiteDroit());
    if (quantite != null) {
      if ((quantite instanceof DureeIndemnisationPremiereTranche)) {
        ((DureeIndemnisationPremiereTranche)quantite).setCodeFormuleMontant(FormuleMontantPremiereTrancheF.getCode());
      } else if ((quantite instanceof DureeIndemnisationSecondeTranche)) {
        ((DureeIndemnisationSecondeTranche)quantite).setCodeFormuleMontant(FormuleMontantSecondeTrancheF.getCode());
      } else if ((quantite instanceof DureeIndemnisationTroisiemeTranche)) {
        ((DureeIndemnisationTroisiemeTranche)quantite).setCodeFormuleMontant(FormuleMontantTroisiemeTrancheF.getCode());
      }
    }
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant());
    if ((periode instanceof PeriodeFormation)) {
      elementBaseIndemnisationAREF.setEffectif(((PeriodeFormation)periode).estEffective());
    }
    constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
  }
  
  public void determinerStatutUT(AttributionSpec attribution, ChronologiePeriodes periodesDecalantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement ut, ArretProduitAvecRaison arretProduitAvecRaison, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    super.determinerStatutUT(((Admission)attribution).getAttributionAssurance(), periodesDecalantes, constituantsCalculActiviteReduite, ut, arretProduitAvecRaison, contexteUT);
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec attribution, fr.unedic.cali.calcul.dom.UniteTraitement ut, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    Damj finDeProduit = null;
    ArretProduitAvecRaison arretProduitAvecRaison = null;
    arretProduitAvecRaison = ut.getArretProduitAvecRaison();
    if (arretProduitAvecRaison.isRaisonsContientRaison(1)) {
      if (!arretProduitAvecRaison.getLendemainFinQuantiteIndemnisationArretCalcul().isEmpty())
      {
        finDeProduit = ((Temporel)arretProduitAvecRaison.getLendemainFinQuantiteIndemnisationArretCalcul().iterator().next()).getDateDebut().veille();
        if (!contexteUT.existeAERenFinASU(finDeProduit)) {
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, finDeProduit, 5, 0, true, null, this, ut.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
  }
  
  public void traitementActiviteReduiteSurPa(PeriodeAnalyseSpec pa, fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, MontantBaseSpec montant, BigDecimal sjr)
    throws CoucheLogiqueException
  {
    if (pa.getDateDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Application des règles métropole pour Mayotte")))
    {
      Quantite quantiteSansSusp = null;
      
      quantiteSansSusp = pa.getQuantiteIndemnisable().soustraire(pa.getQuantiteNonIndemnisee());
      
      Damj pointDeDepartDA = null;
      boolean departDAsurMemeMoisPJI = false;
      Differe delaiAttente = (Differe)OutilsTrancheCalcul.recupererDelai(((Admission)attribution).getAttributionAssurance(), "Différé");
      if ((delaiAttente != null) && (delaiAttente.getDateFinPeriodeOrigine() != null))
      {
        pointDeDepartDA = delaiAttente.getDateFinPeriodeOrigine().lendemain();
        if ((pointDeDepartDA.estContenueDans(ut.getPeriode())) && 
          (attribution.getDateAttribution().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Application des règles métropole pour Mayotte")))) {
          departDAsurMemeMoisPJI = true;
        }
      }
      if ((!ut.getChronoPeriodeDecalante().estVide()) && (!departDAsurMemeMoisPJI)) {
        ActiviteReduite.traitementActiviteReduiteSurPa(pa, ut.getChronoPeriodeDecalante(), attribution, montant, quantiteSansSusp, ut, sjr);
      }
    }
  }
  
  public boolean verifierApplicationForcageSurUT(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if ((attribution instanceof Admission)) {
      return !verifierTraitementARSurAvant(ut, ((Admission)attribution).getAttributionAssurance());
    }
    return !verifierTraitementARSurAvant(ut, attribution);
  }
  
  private boolean estUndroitAREM2016(AttributionSpec attribution)
  {
    return attribution.getProduitExecution().getNom().equals("ASU_MAY17_03");
  }
  
  public ResultatCalcul postTraitementResultatDeterminationEtatDroit(AttributionSpec attribution, CalendrierExecutionCalculSpec calendrierExecutionCalcul, Damj dateEtatDroit)
    throws CoucheLogiqueException
  {
    return PostTraitement.postTraitementResultatDeterminationEtatDroit(attribution, (CalendrierExecutionCalcul)calendrierExecutionCalcul, dateEtatDroit);
  }
  
  public void miseAjourPeriodeAV(ChronologiePeriodes chronoPeriode, IndividuSpec individu)
    throws CoucheLogiqueException
  {
    OutilRetraiteMayotte outilRetraite = OutilRetraiteMayotte.getInstance();
    if ((chronoPeriode != null) && (!chronoPeriode.estVide()))
    {
      chronoPeriode.iterer();
      while (chronoPeriode.encoreSuivant())
      {
        ObjetChronoPeriode periode = (ObjetChronoPeriode)chronoPeriode.elementSuivant();
        if (((periode instanceof PeriodeAvantageVieillesse)) && ((((PeriodeAvantageVieillesse)periode).getCodeNature().equals("1")) || (((PeriodeAvantageVieillesse)periode).getCodeNature().equals("M")))) {
          periode.setDateDebut(Damj.max(periode.getDateDebut(), individu.getDateNaissance().deplacerVersAvant(outilRetraite.getAgeMinDepartRetraite(individu))));
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */