package fr.unedic.cali.asu.may17.p02.calcul.pbjc;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.calcul.pbjc.FacadePBJCLigneSansTrancheImpl;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.AttributionAssuranceMayotte;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.Poursuite;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.calcul.OutillageCalculADate;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EvenementParametre;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.periode.ActionFormation;
import fr.unedic.cali.calcul.dom.periode.DsmMaladie;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementActualisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChrono60AnsBlocageRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRadiation;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.parametres.AccesTauxCotisationAccidentTravail;
import fr.unedic.cali.calcul.pbjc.dom.PbjcNcp;
import fr.unedic.cali.calcul.pbjc.outilsfonctionnels.GenerateurPBJCs;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DureeIndemnisationAbstraite;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreAttributionSurDecisions;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDecisionPourProduit;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreOU;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ChronologieStandard;
import fr.unedic.util.temps.ComparateurTemporelsSurDateDebut;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.ObjetChronoPeriodeConcrete;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadePBJCProduitImpl
  extends FacadePBJCLigneSansTrancheImpl
{
  public String retournerReglementApplicable(AttributionSpec p_attribution)
  {
    if ((p_attribution instanceof AttributionAssuranceMayotte)) {
      return super.retournerReglementApplicable(p_attribution);
    }
    return super.retournerReglementApplicable(((Admission)p_attribution).getAttributionAssurance());
  }
  
  public void positionnerComplementJustification(PbjcNcp p_pbjcNcp, UniteTraitement p_ut, AttributionSpec p_attribution)
  {
    super.positionnerComplementJustification(p_pbjcNcp, p_ut, ((Admission)p_attribution).getAttributionAssurance());
  }
  
  public void positionnerInfoConventionGestion(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution)
  {
    if ((p_attribution instanceof AttributionAssuranceMayotte)) {
      super.positionnerInfoConventionGestion(p_pbjcNcp, p_attribution);
    } else {
      super.positionnerInfoConventionGestion(p_pbjcNcp, ((Admission)p_attribution).getAttributionAssurance());
    }
    p_pbjcNcp.ajouterTypeSousTypePopulation("MA", null);
    
    p_pbjcNcp.setTopApplicationCRC(false);
  }
  
  public void positionnerCoefficientTempsPartiel(PbjcNcp p_pbjcNcp, UniteTraitement p_ut, AttributionSpec p_attribution)
  {
    super.positionnerCoefficientTempsPartiel(p_pbjcNcp, p_ut, p_attribution);
  }
  
  public Quantite retournerQuantiteIndemnisationInitialeDroit(AttributionSpec p_attribution, UniteTraitement ut)
  {
    return super.retournerQuantiteIndemnisationInitialeDroit(((Admission)p_attribution).getAttributionAssurance(), ut);
  }
  
  public void traiterPBJCsAPosteriori(ChronologiePeriodes p_chronoPBJCs, AttributionSpec p_attribution, Chronologie chronoUT)
    throws CoucheLogiqueException
  {
    PbjcNcp pbjcNcp = null;
    PbjcNcp pbjcNcpAvant = null;
    
    ChronologiePeriodes chronologiePeriodesRadiationPEC = OutillagePeriodes.recupererPecsRadiationSuiteEntreeFormation(p_attribution.getDemandeur());
    
    p_chronoPBJCs.iterer();
    while (p_chronoPBJCs.encoreSuivant())
    {
      pbjcNcp = (PbjcNcp)p_chronoPBJCs.elementSuivant();
      
      chronologiePeriodesRadiationPEC.iterer();
      while (chronologiePeriodesRadiationPEC.encoreSuivant())
      {
        ObjetChronoPeriodeRadiation periodeRadiation = (ObjetChronoPeriodeRadiation)chronologiePeriodesRadiationPEC.elementSuivant();
        if (periodeRadiation.getDateDebut().veille().coincideAvec(pbjcNcp.getDateFin()))
        {
          pbjcNcp.ajouterComplementDeJustification("TD");
          
          pbjcNcp.setCodeRadiationLendemainPeriode("31");
        }
      }
      if (pbjcNcpAvant != null)
      {
        if (pbjcNcpAvant.getDateFin().coincideAvec(pbjcNcp.getDateDebut().veille()))
        {
          if (pbjcNcp.contientComplementDeJustification("FR")) {
            pbjcNcpAvant.ajouterComplementDeJustification("QF");
          }
          if ((pbjcNcp.getInterrupIndemParPensionInvalidite() != null) && (pbjcNcpAvant.getInterrupIndemParPensionInvalidite() != null))
          {
            if ((pbjcNcp.getInterrupIndemParPensionInvalidite().equals("O")) && 
              (pbjcNcpAvant.getInterrupIndemParPensionInvalidite().equals("N"))) {
              pbjcNcp.ajouterComplementDeJustification("FN");
            }
            if ((pbjcNcp.getInterrupIndemParPensionInvalidite().equals("N")) && 
              (pbjcNcpAvant.getInterrupIndemParPensionInvalidite().equals("O"))) {
              pbjcNcp.ajouterComplementDeJustification("FO");
            }
          }
        }
        if ((pbjcNcpAvant.getMontantCumuleRevaloriseAV() != null) && (pbjcNcpAvant.getMontantCumuleRevaloriseAV().compareTo(new BigDecimal("0")) > 0) && 
          (pbjcNcp.getMontantCumuleRevaloriseAV() != null) && (pbjcNcp.getMontantCumuleRevaloriseAV().compareTo(new BigDecimal("0")) > 0) && 
          (pbjcNcp.getMontantCumuleRevaloriseAV().compareTo(pbjcNcpAvant.getMontantCumuleRevaloriseAV()) != 0) && (!pbjcNcp.contientComplementDeJustification("DG"))) {
          pbjcNcp.ajouterComplementDeJustification("DH");
        }
      }
      if ((pbjcNcp.contientComplementDeJustification("FR")) && (pbjcNcp.getInterrupIndemParPensionInvalidite() != null) && (pbjcNcp.getInterrupIndemParPensionInvalidite().equals("O"))) {
        pbjcNcp.ajouterComplementDeJustification("FN");
      }
      if ((((Admission)p_attribution).getDureeIndemnisationInitiale().intValue() == pbjcNcp.getReliquatDureeMax()) && (pbjcNcp.getNbJoursImputes() != 0)) {
        positionnerJustificationOuverturePJI(pbjcNcp, p_attribution);
      }
      if (p_attribution.getDateAttribution().coincideAvec(pbjcNcp.getDateDebut())) {
        pbjcNcp.ajouterComplementDeJustification("BB");
      }
      if (pbjcNcpAvant != null) {
        pbjcNcp.setNbJoursAREF(pbjcNcpAvant.getNbJoursAREF());
      }
      if ((pbjcNcp.estEnAref()) && (pbjcNcp.getEtatIndemnisation().compareTo("AVANT") != 0)) {
        pbjcNcp.setNbJoursAREF(pbjcNcp.getNbJoursAREF() + pbjcNcp.getNbJoursImputes());
      }
      pbjcNcpAvant = pbjcNcp;
    }
  }
  
  public void positionnerJustificationFermetureDJI(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, UniteTraitement p_ut)
  {
    super.positionnerJustificationFermetureDJI(p_pbjcNcp, p_attribution, p_ut);
    if (p_ut.getArretProduitAvecRaison().isRaisonsContientRaison(4))
    {
      Iterator iterateurPeriodesInterruptives = p_ut.getArretProduitAvecRaison().getPeriodesInterruptivesDefinitives().iterator();
      while (iterateurPeriodesInterruptives.hasNext())
      {
        ObjetChronoPeriode objetChronoPeriode = (ObjetChronoPeriode)iterateurPeriodesInterruptives.next();
        if ((objetChronoPeriode instanceof ObjetChrono60AnsBlocageRetraite)) {
          p_pbjcNcp.ajouterComplementDeJustification("OD");
        }
      }
    }
  }
  
  public int retournerReliquatDureeMax(UniteTraitement p_ut, ChronologiePeriodes p_chronoPBJCs, AttributionSpec p_attributionSpec)
  {
    int reliquatARetourner = 0;
    if (p_chronoPBJCs.estVide())
    {
      Collection collectionQuantite = p_ut.getConstituantsIndemnisationEnDebutUT().getCollectionQuantiteDroit();
      if ((collectionQuantite != null) && (!collectionQuantite.isEmpty()))
      {
        Iterator iter = collectionQuantite.iterator();
        while (iter.hasNext())
        {
          DureeIndemnisationAbstraite duree = (DureeIndemnisationAbstraite)iter.next();
          if (duree.getEtat() == 1) {
            reliquatARetourner += duree.getQuantiteCourante().getValeurEntiere();
          }
          if (duree.getEtat() == 0) {
            reliquatARetourner += duree.getQuantiteInitial().getValeurEntiere();
          }
        }
      }
    }
    else
    {
      PbjcNcp pbjcNcp = (PbjcNcp)p_chronoPBJCs.dernierElement();
      reliquatARetourner = pbjcNcp.getReliquatDureeMax() - pbjcNcp.getNbJoursImputes();
    }
    return reliquatARetourner;
  }
  
  public ChronologiePeriodes creerChronologiePBJCsAvant(AttributionSpec p_attribution, Damj p_dateGeneration, Damj p_dateBlocageActualisation, String p_libelleBlocageActualisation)
    throws ApplicativeException
  {
    ChronologiePeriodes pbjcsAvant = new ChronologiePeriodes();
    IndividuSpec individu = p_attribution.getDemandeur();
    Periode periodeAvant = null;
    ObjetChronoPeriodePriseEnCharge periodePEC = null;
    ResultatAvant resultatAvant = null;
    PbjcNcp pbjcNcpAvant = null;
    ChronologiePeriodes periodesFormation = new ChronologiePeriodes();
    ChronologiePeriodes actionsFormation = new ChronologiePeriodes();
    ObjetChronoPeriode periode = null;
    List datesDeDecoupageDesPBJCs = null;
    AccesTauxCotisationAccidentTravail acces = new AccesTauxCotisationAccidentTravail();
    ChronologieStandard valeursParametre = null;
    List datesChgtTauxCADT = new ArrayList();
    Damj dateChtTaux = null;
    ObjetChronoPeriode laPeriodeInterruptive = null;
    Damj dateAttribution = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(p_attribution);
    
    periodePEC = OutillagePeriodes.recupererPeriodePECContenant(individu, dateAttribution);
    resultatAvant = super.retournerResultatCalculAvant(p_attribution, periodePEC);
    
    CalendrierExecutionAvant calendrierAvant = (CalendrierExecutionAvant)p_attribution.getCalendrierExecutionAvant();
    if (calendrierAvant == null) {
      return pbjcsAvant;
    }
    periodeAvant = calendrierAvant.getPeriode();
    periodeAvant.setDebut(dateAttribution);
    
    valeursParametre = acces.getChronoValeursParametre();
    valeursParametre.iterer();
    while (valeursParametre.encoreSuivant())
    {
      dateChtTaux = ((EvenementParametre)valeursParametre.elementSuivant()).getDateEvenement();
      if (dateChtTaux.estStrictementContenueDans(periodeAvant)) {
        datesChgtTauxCADT.add(dateChtTaux);
      }
    }
    Collection periodesAER = new ArrayList();
    Damj datePivot = periodeAvant.getFin();
    while (datePivot.estApres(dateAttribution))
    {
      FiltreET filtreCali = new FiltreET();
      filtreCali.ajouterFiltre(new FiltreAttributionSurDecisions());
      FiltreOU filtreProduit = new FiltreOU();
      filtreProduit.ajouterFiltre(new FiltreDecisionPourProduit(12));
      filtreProduit.ajouterFiltre(new FiltreDecisionPourProduit(52));
      filtreProduit.ajouterFiltre(new FiltreDecisionPourProduit(55));
      filtreCali.ajouterFiltre(filtreProduit);
      AttributionSpec attribution = (AttributionSpec)OutilRecherche.rechercherDecisionPrecedente(p_attribution.getDemandeur().getChronoDemandesNonTriees(), datePivot, filtreCali);
      if (attribution != null)
      {
        Periode periodeAER = new Periode(attribution.getPji(), attribution.getPji().deplacerVersAvant(new DureeCalendaire(1, 0, 0)));
        if (periodeAER.chevauche(periodeAvant))
        {
          periodesAER.add(periodeAER);
          datePivot = dateAttribution.veille();
          if (periodeAER.getDebut().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periodeAER.getDebut());
          }
          if (periodeAER.getFin().lendemain().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periodeAER.getFin().lendemain());
          }
        }
        else
        {
          datePivot = Damj.NUIT_DES_TEMPS;
        }
      }
      else
      {
        datePivot = Damj.NUIT_DES_TEMPS;
      }
    }
    ChronologiePeriodes periodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(individu, dateAttribution, p_attribution.getPji());
    
    periodesGAEC.iterer();
    while (periodesGAEC.encoreSuivant())
    {
      periode = (ObjetChronoPeriode)periodesGAEC.elementSuivant();
      if ((periode instanceof PeriodeFormation))
      {
        PeriodeFormation periodeFormationCalcul = (PeriodeFormation)periode;
        if ((periodeFormationCalcul.getPeriodeEffectiveInitiale() != null) && (periodeFormationCalcul.getPeriodeEffectiveInitiale().chevauche(periodeAvant)))
        {
          periodesFormation.ajouter(periode);
          if (periodeFormationCalcul.getPeriodeEffectiveInitiale().getDebut().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periode.getDateDebut());
          }
          if (periodeFormationCalcul.getPeriodeEffectiveInitiale().getFin().estStrictementContenueDans(periodeAvant)) {
            datesChgtTauxCADT.add(periode.getDateFin().lendemain());
          }
        }
      }
      else if ((periode instanceof ActionFormation))
      {
        ActionFormation actionFormationCalcul = (ActionFormation)periode;
        if ((actionFormationCalcul.getPeriode() != null) && (actionFormationCalcul.getPeriode().chevauche(periodeAvant))) {
          actionsFormation.ajouter(periode);
        }
      }
    }
    if (resultatAvant.getListeCarencesEffectives().size() > 0) {
      traiterLesPBJCsSurLAvant(p_attribution, periodeAvant, datesDeDecoupageDesPBJCs, p_dateBlocageActualisation, datesChgtTauxCADT, periodesAER, periodesFormation, actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, pbjcsAvant);
    }
    pbjcsAvant = GenerateurPBJCs.decouperEnPBJCsDisjointes(pbjcsAvant, true, false);
    if (!pbjcsAvant.estVide())
    {
      pbjcNcpAvant = (PbjcNcp)pbjcsAvant.dernierElement();
      if ((resultatAvant.getPji() == null) && (pbjcNcpAvant.getDateFin().coincideAvec(periodePEC.getDateFin())))
      {
        String motifRadiation = periodePEC.getMotifAnnulation();
        pbjcNcpAvant.setCodeRadiationLendemainPeriode(motifRadiation);
        pbjcNcpAvant.ajouterComplementDeJustification("TD");
        if ((motifRadiation != null) && (motifRadiation.equals("73"))) {
          pbjcNcpAvant.ajouterComplementDeJustification("OH");
        }
      }
    }
    Chronologie chronologiePeriodesEvtActualisation = OutillagePeriodes.recupererPeriodesEvtActualisation(p_attribution.getDemandeur());
    if (chronologiePeriodesEvtActualisation != null)
    {
      chronologiePeriodesEvtActualisation.iterer();
      while (chronologiePeriodesEvtActualisation.encoreSuivant())
      {
        PeriodeEvenementActualisation periodeAbsenceAuPointage = (PeriodeEvenementActualisation)chronologiePeriodesEvtActualisation.elementSuivant();
        if ((periodeAbsenceAuPointage instanceof PeriodeAbsenceAuPointage))
        {
          pbjcsAvant.iterer();
          while (pbjcsAvant.encoreSuivant())
          {
            PbjcNcp pbjcNcpAvantAb = (PbjcNcp)pbjcsAvant.elementSuivant();
            if (pbjcNcpAvantAb.chevauche(periodeAbsenceAuPointage.getPeriode())) {
              pbjcNcpAvantAb.setNaturePBJC("AB");
            }
          }
        }
      }
    }
    return pbjcsAvant;
  }
  
  private void traiterLesPBJCsSurLAvant(AttributionSpec p_attribution, Periode p_periodeAvant, List p_datesDeDecoupageDesPBJCs, Damj p_dateBlocageActualisation, List p_datesChgtTauxCADT, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_dateGeneration, String p_libelleBlocageActualisation, ChronologiePeriodes p_pbjcsAvant)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodes = null;
    ChronologiePeriodes periodesInterruptives = null;
    ObjetChronoPeriode laPeriodeInterruptive = null;
    PbjcNcp pbjcsAvantDec = null;
    PbjcNcp pbjcsAvantSusp = null;
    
    Damj dateAttribution = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(p_attribution);
    List listePeriode = new ArrayList();
    List listeConstantesPBJC = new ArrayList();
    
    CalendrierExecutionAvant calendrierAvant = (CalendrierExecutionAvant)p_attribution.getCalendrierExecutionAvant();
    Chronologie listUtAvant = calendrierAvant.getChronologieUnitesTraitements();
    listUtAvant.iterer();
    while (listUtAvant.encoreSuivant())
    {
      UniteTraitementAvant utAvant = (UniteTraitementAvant)listUtAvant.elementSuivant();
      if ((dateAttribution.estContenueDans(new Periode(utAvant.getDateDebut(), utAvant.getDateFin()))) || (dateAttribution.estAvant(utAvant.getDateDebut())))
      {
        periodes = utAvant.getQualificationPeriodes().getPeriodesSuspensives();
        periodesInterruptives = utAvant.getQualificationPeriodes().getPeriodesInterruptives();
        periodesInterruptives.setComparateur(new ComparateurTemporelsSurDateDebut());
        periodes.iterer();
        while (periodes.encoreSuivant())
        {
          ObjetChronoPeriode periode = (ObjetChronoPeriode)periodes.elementSuivant().copie();
          if ((periode.getDateDebut().estApresOuCoincideAvec(dateAttribution)) || (periode.getDateFin().estApresOuCoincideAvec(dateAttribution)))
          {
            if (periode.getDateDebut().estAvant(dateAttribution)) {
              periode.setDateDebut(dateAttribution);
            }
            boolean peutAjouter = true;
            for (int i = 0; i < listePeriode.size(); i++)
            {
              ObjetChronoPeriode periodeTmp = (ObjetChronoPeriode)listePeriode.get(i);
              if ((periode.getDateDebut().coincideAvec(periodeTmp.getDateDebut())) && (periode.getDateFin().coincideAvec(periodeTmp.getDateFin()))) {
                peutAjouter = false;
              }
            }
            if (peutAjouter)
            {
              listePeriode.add(periode);
              if (((periode instanceof PeriodeEvenementPersonnel)) && (((PeriodeEvenementPersonnel)periode).getNature() == 38)) {
                listeConstantesPBJC.add("CA");
              } else if (((periode instanceof DsmMaladie)) || (((periode instanceof PeriodeEvenementPersonnel)) && (((PeriodeEvenementPersonnel)periode).getNature() != 38))) {
                listeConstantesPBJC.add("MA");
              } else if (((periode instanceof PeriodeTravailJustifiee)) || ((periode instanceof PeriodeActiviteEmploiCalcul))) {
                listeConstantesPBJC.add("CT");
              } else if ((periode instanceof PeriodeSuspensionDDTEAvecImputation)) {
                listePeriode.remove(periode);
              } else {
                listeConstantesPBJC.add("CT");
              }
            }
          }
        }
        listePeriode = super.filtrerPeriodesSuspensivesPeriodesInterruptives(listePeriode, periodesInterruptives);
        for (int i = 0; i < listePeriode.size(); i++)
        {
          ObjetChronoPeriode periode = (ObjetChronoPeriode)listePeriode.get(i);
          if (periode.chevauche(new Periode(utAvant.getDateDebut(), Damj.min(utAvant.getDateFin(), calendrierAvant.getDernierJourAvant()))))
          {
            Damj dateFinPeriodeSusp = Damj.min(Damj.min(periode.getDateFin(), utAvant.getDateFin()), calendrierAvant.getDernierJourAvant());
            pbjcsAvantSusp = super.creerPBJCSuspensivePourLAvant(Damj.max(periode.getDateDebut(), utAvant.getDateDebut()), dateFinPeriodeSusp, periode, ((Admission)p_attribution).getAttributionAssurance(), (String)listeConstantesPBJC.get(i));
            super.ajouterPBJCSurLAvant(p_pbjcsAvant, pbjcsAvantSusp, p_dateGeneration);
          }
        }
        DureeConsommableAvant dureePmc = (DureeConsommableAvant)utAvant.getDureePmcEnDebutUT().copie();
        DureeConsommableAvant dureeDiffereStandard = (DureeConsommableAvant)utAvant.getDureeDiffereStandardEnDebutUT().copie();
        DureeConsommableAvant dureeDiffereSpecifique = (DureeConsommableAvant)utAvant.getDureeDiffereSpecifiqueEnDebutUT().copie();
        DureeConsommableAvant dureeDelaiAttente = (DureeConsommableAvant)utAvant.getDureeDelaiAttenteEnDebutUT().copie();
        DureeConsommableAvant dureePmcFin = (DureeConsommableAvant)utAvant.getDureePmcEnFinUT().copie();
        DureeConsommableAvant dureeDiffereStandardFin = (DureeConsommableAvant)utAvant.getDureeDiffereStandardEnFinUT().copie();
        DureeConsommableAvant dureeDiffereSpecifiqueFin = (DureeConsommableAvant)utAvant.getDureeDiffereSpecifiqueEnFinUT().copie();
        DureeConsommableAvant dureeDelaiAttenteFin = (DureeConsommableAvant)utAvant.getDureeDelaiAttenteEnFinUT().copie();
        ConsommationPeriodes consoPeriode = utAvant.getConsommationPeriodes();
        
        periodesInterruptives.iterer();
        if (periodesInterruptives.encoreSuivant()) {
          laPeriodeInterruptive = (ObjetChronoPeriode)periodesInterruptives.elementSuivant();
        }
        Periode periodeUtAvant = new Periode(Damj.max(utAvant.getDateDebut(), p_periodeAvant.getDebut()), utAvant.getDateFin());
        if ((consoPeriode.getPeriodePmc() != null) && (consoPeriode.getPeriodePmc().chevauche(periodeUtAvant)))
        {
          boolean positionJustifFermeture;
          boolean positionJustifFermeture;
          if ((dureePmcFin.getQuantiteCourante() != null) && (!dureePmcFin.getQuantiteCourante().getValeur().equals(ZERO))) {
            positionJustifFermeture = false;
          } else {
            positionJustifFermeture = true;
          }
          boolean positionJustifOuverture;
          boolean positionJustifOuverture;
          if ((dureePmc.getQuantiteCourante() != null) && (!dureePmc.getQuantiteCourante().getValeur().equals(dureePmc.getQuantiteInitial().getValeur()))) {
            positionJustifOuverture = false;
          } else {
            positionJustifOuverture = true;
          }
          traiterLesPBJCsAvant(dureePmc, p_periodeAvant, p_datesDeDecoupageDesPBJCs, p_dateBlocageActualisation, p_datesChgtTauxCADT, p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, p_pbjcsAvant, consoPeriode.getPeriodePmc(), false, positionJustifOuverture, positionJustifFermeture, periodesInterruptives, laPeriodeInterruptive);
        }
        if ((consoPeriode.getPeriodeDiffereSpecifique() != null) && (consoPeriode.getPeriodeDiffereSpecifique().chevauche(periodeUtAvant)))
        {
          boolean positionJustifFermeture;
          boolean positionJustifFermeture;
          if ((dureeDiffereSpecifiqueFin.getQuantiteCourante() != null) && (!dureeDiffereSpecifiqueFin.getQuantiteCourante().getValeur().equals(ZERO))) {
            positionJustifFermeture = false;
          } else {
            positionJustifFermeture = true;
          }
          boolean positionJustifOuverture;
          boolean positionJustifOuverture;
          if ((dureeDiffereSpecifique.getQuantiteCourante() != null) && (!dureeDiffereSpecifique.getQuantiteCourante().getValeur().equals(dureeDiffereSpecifique.getQuantiteInitial().getValeur()))) {
            positionJustifOuverture = false;
          } else {
            positionJustifOuverture = true;
          }
          traiterLesPBJCsAvant(dureeDiffereSpecifique, p_periodeAvant, p_datesDeDecoupageDesPBJCs, p_dateBlocageActualisation, p_datesChgtTauxCADT, p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, p_pbjcsAvant, consoPeriode.getPeriodeDiffereSpecifique(), false, positionJustifOuverture, positionJustifFermeture, periodesInterruptives, laPeriodeInterruptive);
        }
        if ((consoPeriode.getPeriodeDiffereStandard() != null) && (consoPeriode.getPeriodeDiffereStandard().chevauche(periodeUtAvant)))
        {
          boolean positionJustifFermeture;
          boolean positionJustifFermeture;
          if ((dureeDiffereStandardFin.getQuantiteCourante() != null) && (!dureeDiffereStandardFin.getQuantiteCourante().getValeur().equals(ZERO))) {
            positionJustifFermeture = false;
          } else {
            positionJustifFermeture = true;
          }
          boolean positionJustifOuverture;
          boolean positionJustifOuverture;
          if ((dureeDiffereStandard.getQuantiteCourante() != null) && (!dureeDiffereStandard.getQuantiteCourante().getValeur().equals(dureeDiffereStandard.getQuantiteInitial().getValeur()))) {
            positionJustifOuverture = false;
          } else {
            positionJustifOuverture = true;
          }
          traiterLesPBJCsAvant(dureeDiffereStandard, p_periodeAvant, p_datesDeDecoupageDesPBJCs, p_dateBlocageActualisation, p_datesChgtTauxCADT, p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, p_pbjcsAvant, consoPeriode.getPeriodeDiffereStandard(), false, positionJustifOuverture, positionJustifFermeture, periodesInterruptives, laPeriodeInterruptive);
        }
        if ((consoPeriode.getPeriodeDelaiAttente() != null) && (consoPeriode.getPeriodeDelaiAttente().chevauche(periodeUtAvant)))
        {
          boolean positionJustifFermeture;
          boolean positionJustifFermeture;
          if ((!consoPeriode.getPeriodeDelaiAttente().getFin().coincideAvec(p_periodeAvant.getFin())) && (dureeDelaiAttenteFin.getQuantiteCourante() != null) && (!dureeDelaiAttenteFin.getQuantiteCourante().getValeur().equals(ZERO))) {
            positionJustifFermeture = false;
          } else {
            positionJustifFermeture = true;
          }
          boolean positionJustifOuverture;
          boolean positionJustifOuverture;
          if ((dureeDelaiAttente.getQuantiteCourante() != null) && (!dureeDelaiAttente.getQuantiteCourante().getValeur().equals(dureeDelaiAttente.getQuantiteInitial().getValeur()))) {
            positionJustifOuverture = false;
          } else {
            positionJustifOuverture = true;
          }
          traiterLesPBJCsAvant(dureeDelaiAttente, p_periodeAvant, p_datesDeDecoupageDesPBJCs, p_dateBlocageActualisation, p_datesChgtTauxCADT, p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, p_pbjcsAvant, consoPeriode.getPeriodeDelaiAttente(), true, positionJustifOuverture, positionJustifFermeture, periodesInterruptives, laPeriodeInterruptive);
        }
        if ((utAvant.getQuantiteDecale() != null) && (utAvant.getQuantiteDecale().getValeurEntiere() > 0))
        {
          ChronologiePeriodes chronoPeriode = new ChronologiePeriodes();
          Iterator iterPbjc = p_pbjcsAvant.iterer();
          while (iterPbjc.hasNext())
          {
            PbjcNcp pbjcAvant = (PbjcNcp)iterPbjc.next();
            if (pbjcAvant.getDateDebut().estContenueDans(utAvant.getPeriode())) {
              chronoPeriode.ajouter(new ObjetChronoPeriodeConcrete(pbjcAvant.getDateDebut(), pbjcAvant.getDateFin()));
            }
          }
          ChronologiePeriodes chronoTrouPbjc = OutillageCalculADate.retourneLesTrous(chronoPeriode, ObjetChronoPeriodeConcrete.class, utAvant.getDateDebutConsoDATheorique(), Damj.min(utAvant.getDateFin(), calendrierAvant.getDernierJourAvant()));
          
          chronoTrouPbjc.iterer();
          while (chronoTrouPbjc.encoreSuivant())
          {
            ObjetChronoPeriodeConcrete objetChronoPeriodeConcrete = (ObjetChronoPeriodeConcrete)chronoTrouPbjc.elementSuivant();
            pbjcsAvantDec = creerPBJCDecalantePourLAvant(objetChronoPeriodeConcrete.getDateDebut(), objetChronoPeriodeConcrete.getDateFin(), ((Admission)p_attribution).getAttributionAssurance(), "CT", new QuantiteJour(new BigDecimal(objetChronoPeriodeConcrete.getDuree())));
            
            ajouterPBJCSurLAvant(p_pbjcsAvant, pbjcsAvantDec, p_dateGeneration);
          }
        }
        super.filtrerPbjcAvantPeriodesInterruptives(periodesInterruptives, p_pbjcsAvant);
      }
    }
  }
  
  private void traiterLesPBJCsAvant(DureeConsommableAvant p_duree, Periode p_periodeAvant, List p_dateDecoupagePBJC, Damj p_dateBlocageActualisation, List p_dateChgtTauxCADT, AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_dateGeneration, String p_libelleBlocageActualisation, ChronologiePeriodes p_pbjcsAvant, Periode p_periodeConso, boolean p_estDelaiAttente, boolean p_positionJustifOuverture, boolean p_positionJustifFermeture, ChronologiePeriodes p_periodesInterruptives, ObjetChronoPeriode p_periodeInterruptive)
  {
    if (p_estDelaiAttente) {
      traiterLesPBJCsAvantDelaiAttente(p_periodeAvant, p_dateDecoupagePBJC, p_dateBlocageActualisation, p_dateChgtTauxCADT, p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, p_pbjcsAvant, p_periodeConso, p_positionJustifOuverture, p_positionJustifFermeture, p_periodesInterruptives, p_periodeInterruptive);
    } else {
      traiterLesPBJCsAvantHorsDelaiAttente(p_duree, p_periodeAvant, p_dateDecoupagePBJC, p_dateBlocageActualisation, p_dateChgtTauxCADT, p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateGeneration, p_libelleBlocageActualisation, p_pbjcsAvant, p_periodeConso, p_positionJustifOuverture, p_positionJustifFermeture, p_periodesInterruptives, p_periodeInterruptive);
    }
  }
  
  private void traiterLesPBJCsAvantDelaiAttente(Periode p_periodeAvant, List p_dateDecoupagePBJC, Damj p_dateBlocageActualisation, List p_dateChgtTauxCADT, AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_dateGeneration, String p_libelleBlocageActualisation, ChronologiePeriodes p_pbjcsAvant, Periode p_periodeConso, boolean p_positionJustifOuverture, boolean p_positionJustifFermeture, ChronologiePeriodes p_periodesInterruptives, ObjetChronoPeriode p_periodeInterruptive)
  {
    Damj dateDebut = null;
    Damj date = null;
    Iterator iteratorDatesDecoupage = null;
    
    Periode periodeDiffere = new Periode(p_periodeConso.getDebut(), Damj.min(p_periodeConso.getFin(), p_periodeAvant.getFin()));
    
    p_dateDecoupagePBJC = retournerDatesDeRupturePBJCsAvant(p_dateChgtTauxCADT, periodeDiffere, p_dateBlocageActualisation);
    
    dateDebut = periodeDiffere.getDebut();
    iteratorDatesDecoupage = p_dateDecoupagePBJC.iterator();
    while (iteratorDatesDecoupage.hasNext())
    {
      date = (Damj)iteratorDatesDecoupage.next();
      dateDebut = creationPbjcAvantCarenceGestionMaintienEuropeen(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebut, date.veille(), null, p_periodesInterruptives, p_periodeInterruptive, p_dateBlocageActualisation, p_libelleBlocageActualisation, p_pbjcsAvant, p_dateGeneration, true, periodeDiffere, p_positionJustifOuverture, p_positionJustifFermeture);
    }
    creationPbjcAvantCarenceGestionMaintienEuropeen(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebut, periodeDiffere.getFin(), null, p_periodesInterruptives, p_periodeInterruptive, p_dateBlocageActualisation, p_libelleBlocageActualisation, p_pbjcsAvant, p_dateGeneration, true, periodeDiffere, p_positionJustifOuverture, p_positionJustifFermeture);
  }
  
  private void traiterLesPBJCsAvantHorsDelaiAttente(DureeConsommableAvant p_duree, Periode p_periodeAvant, List p_dateDecoupagePBJC, Damj p_dateBlocageActualisation, List p_dateChgtTauxCADT, AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_dateGeneration, String p_libelleBlocageActualisation, ChronologiePeriodes p_pbjcsAvant, Periode p_periodeConso, boolean p_positionJustifOuverture, boolean p_positionJustifFermeture, ChronologiePeriodes p_periodesInterruptives, ObjetChronoPeriode p_periodeInterruptive)
  {
    Damj dateDebut = null;
    Damj date = null;
    Iterator iteratorDatesDecoupage = null;
    Periode periodeDiff = new Periode(Damj.max(p_periodeConso.getDebut(), p_periodeAvant.getDebut()), Damj.min(p_periodeConso.getFin(), p_periodeAvant.getFin()));
    
    p_dateDecoupagePBJC = super.retournerDatesDeRupturePBJCsAvant(p_dateChgtTauxCADT, periodeDiff, p_dateBlocageActualisation);
    
    dateDebut = periodeDiff.getDebut();
    iteratorDatesDecoupage = p_dateDecoupagePBJC.iterator();
    while (iteratorDatesDecoupage.hasNext())
    {
      date = (Damj)iteratorDatesDecoupage.next();
      dateDebut = creationPbjcAvantCarenceGestionMaintienEuropeen(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebut, date.veille(), p_duree, p_periodesInterruptives, p_periodeInterruptive, p_dateBlocageActualisation, p_libelleBlocageActualisation, p_pbjcsAvant, p_dateGeneration, false, periodeDiff, p_positionJustifOuverture, p_positionJustifFermeture);
    }
    creationPbjcAvantCarenceGestionMaintienEuropeen(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebut, periodeDiff.getFin(), p_duree, p_periodesInterruptives, p_periodeInterruptive, p_dateBlocageActualisation, p_libelleBlocageActualisation, p_pbjcsAvant, p_dateGeneration, false, periodeDiff, p_positionJustifOuverture, p_positionJustifFermeture);
  }
  
  private Damj creationPbjcAvantCarenceGestionMaintienEuropeen(AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_dateDebut, Damj p_dateFin, DureeConsommableAvant p_duree, ChronologiePeriodes p_periodesInterruptives, ObjetChronoPeriode p_periodeInterruptive, Damj p_dateBlocageActualisation, String p_libelleBlocageActualisation, ChronologiePeriodes p_chronologiePbjcs, Damj p_dateGeneration, boolean p_isDiffere, Periode p_periodeCarence, boolean p_positionJustifOuverture, boolean p_positionJustifFermeture)
  {
    PbjcNcp pbjcNcpAvant = null;
    Damj dateRetournee = p_dateFin.lendemain();
    if (p_periodeInterruptive != null)
    {
      if (p_dateFin.estAvant(p_periodeInterruptive.getDateDebut()))
      {
        if (!p_isDiffere) {
          pbjcNcpAvant = creerPBJCAvantTypeCarence(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_dateFin, p_duree, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
        } else {
          pbjcNcpAvant = creerPBJCAvantTypeDiffere(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_dateFin, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
        }
        traiterBlocageActuPourLAvant(pbjcNcpAvant, p_dateBlocageActualisation, p_libelleBlocageActualisation);
        ajouterPBJCSurLAvant(p_chronologiePbjcs, pbjcNcpAvant, p_dateGeneration);
        dateRetournee = p_dateFin.lendemain();
      }
      else if ((p_dateFin.estAvantOuCoincideAvec(p_periodeInterruptive.getDateFin())) && (p_dateDebut.estAvantOuCoincideAvec(p_periodeInterruptive.getDateDebut().veille())))
      {
        if (p_periodeCarence.getFin().estApres(p_periodeInterruptive.getDateFin())) {
          p_positionJustifFermeture = false;
        }
        if (!p_isDiffere) {
          pbjcNcpAvant = creerPBJCAvantTypeCarence(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_periodeInterruptive.getDateDebut().veille(), p_duree, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
        } else {
          pbjcNcpAvant = creerPBJCAvantTypeDiffere(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_periodeInterruptive.getDateDebut().veille(), p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
        }
        traiterBlocageActuPourLAvant(pbjcNcpAvant, p_dateBlocageActualisation, p_libelleBlocageActualisation);
        ajouterPBJCSurLAvant(p_chronologiePbjcs, pbjcNcpAvant, p_dateGeneration);
        dateRetournee = p_dateFin.lendemain();
      }
      else if (p_dateFin.estApres(p_periodeInterruptive.getDateFin()))
      {
        if (p_dateDebut.estAvantOuCoincideAvec(p_periodeInterruptive.getDateDebut().veille()))
        {
          if (!p_isDiffere) {
            pbjcNcpAvant = creerPBJCAvantTypeCarence(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_periodeInterruptive.getDateDebut().veille(), p_duree, p_periodeCarence, p_positionJustifOuverture, false);
          } else {
            pbjcNcpAvant = creerPBJCAvantTypeDiffere(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_periodeInterruptive.getDateDebut().veille(), p_periodeCarence, p_positionJustifOuverture, false);
          }
          traiterBlocageActuPourLAvant(pbjcNcpAvant, p_dateBlocageActualisation, p_libelleBlocageActualisation);
          ajouterPBJCSurLAvant(p_chronologiePbjcs, pbjcNcpAvant, p_dateGeneration);
          
          p_positionJustifOuverture = false;
        }
        Damj dateDebutPbjcSup = p_periodeInterruptive.getDateFin().lendemain();
        
        ObjetChronoPeriode periodeInterruptive = null;
        if (p_periodesInterruptives.encoreSuivant()) {
          periodeInterruptive = (ObjetChronoPeriode)p_periodesInterruptives.elementSuivant();
        }
        while ((periodeInterruptive != null) && (p_dateFin.estApresOuCoincideAvec(periodeInterruptive.getDateDebut())))
        {
          if (p_dateFin.estAvant(periodeInterruptive.getDateFin())) {
            p_positionJustifFermeture = true;
          }
          if (!p_isDiffere) {
            pbjcNcpAvant = creerPBJCAvantTypeCarence(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebutPbjcSup, periodeInterruptive.getDateDebut().veille(), p_duree, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
          } else {
            pbjcNcpAvant = creerPBJCAvantTypeDiffere(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebutPbjcSup, periodeInterruptive.getDateDebut().veille(), p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
          }
          pbjcNcpAvant.ajouterComplementDeJustification("E9");
          
          dateDebutPbjcSup = periodeInterruptive.getDateFin().lendemain();
          if (p_periodesInterruptives.encoreSuivant()) {
            periodeInterruptive = (ObjetChronoPeriode)p_periodesInterruptives.elementSuivant();
          } else {
            periodeInterruptive = null;
          }
          traiterBlocageActuPourLAvant(pbjcNcpAvant, p_dateBlocageActualisation, p_libelleBlocageActualisation);
          ajouterPBJCSurLAvant(p_chronologiePbjcs, pbjcNcpAvant, p_dateGeneration);
        }
        dateDebutPbjcSup = Damj.max(dateDebutPbjcSup, p_dateDebut);
        if (dateDebutPbjcSup.estAvantOuCoincideAvec(p_dateFin))
        {
          if (!p_isDiffere) {
            pbjcNcpAvant = creerPBJCAvantTypeCarence(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebutPbjcSup, p_dateFin, p_duree, p_periodeCarence, p_positionJustifOuverture, true);
          } else {
            pbjcNcpAvant = creerPBJCAvantTypeDiffere(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, dateDebutPbjcSup, p_dateFin, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
          }
          pbjcNcpAvant.ajouterComplementDeJustification("E9");
          if ((periodeInterruptive != null) && (p_dateFin.estAvant(periodeInterruptive.getDateFin()))) {
            pbjcNcpAvant.ajouterComplementDeJustification("R9");
          }
          traiterBlocageActuPourLAvant(pbjcNcpAvant, p_dateBlocageActualisation, p_libelleBlocageActualisation);
          ajouterPBJCSurLAvant(p_chronologiePbjcs, pbjcNcpAvant, p_dateGeneration);
        }
        dateRetournee = p_dateFin.lendemain();
      }
    }
    else
    {
      if (!p_isDiffere) {
        pbjcNcpAvant = creerPBJCAvantTypeCarence(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_dateFin, p_duree, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
      } else {
        pbjcNcpAvant = creerPBJCAvantTypeDiffere(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_dateDebut, p_dateFin, p_periodeCarence, p_positionJustifOuverture, p_positionJustifFermeture);
      }
      traiterBlocageActuPourLAvant(pbjcNcpAvant, p_dateBlocageActualisation, p_libelleBlocageActualisation);
      ajouterPBJCSurLAvant(p_chronologiePbjcs, pbjcNcpAvant, p_dateGeneration);
      dateRetournee = p_dateFin.lendemain();
    }
    return dateRetournee;
  }
  
  private PbjcNcp creerPBJCAvantTypeDiffere(AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_debut, Damj p_fin, Periode p_periode, boolean p_positionJustifOuverture, boolean p_positionJustifFermeture)
  {
    PbjcNcp pbjcNcpAvant = creerPBJCAvant(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_debut, p_fin);
    
    pbjcNcpAvant.setEtatReglementaireOd("9");
    if ((p_debut.coincideAvec(p_periode.getDebut())) && (p_positionJustifOuverture)) {
      pbjcNcpAvant.ajouterComplementDeJustification("AF");
    }
    if ((p_fin.coincideAvec(p_periode.getFin())) && (p_positionJustifFermeture)) {
      pbjcNcpAvant.ajouterComplementDeJustification("MF");
    }
    return pbjcNcpAvant;
  }
  
  private PbjcNcp creerPBJCAvantTypeCarence(AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_debutPBJC, Damj p_finPBJC, DureeConsommableAvant p_duree, Periode p_periodeDuree, boolean p_positionJustifOuverture, boolean p_positionJustifFermeture)
  {
    Damj dateEffet = p_attribution.getDateEffet();
    if ((p_attribution instanceof Poursuite)) {
      dateEffet = ((Poursuite)p_attribution).getPjp();
    }
    PbjcNcp pbjcNcpAvant = creerPBJCAvant(p_attribution, p_periodesAER, p_periodesFormation, p_actionsFormation, p_debutPBJC, p_finPBJC);
    
    pbjcNcpAvant.setEtatReglementaireOd("3");
    if ((p_duree != null) && (p_duree.getTypeDureeConsommable() == 0))
    {
      pbjcNcpAvant.setEtatReglementaireOd("7");
    }
    else if ((p_duree != null) && (p_duree.getTypeDureeConsommable() == 2))
    {
      pbjcNcpAvant.setTypeCarence("IR");
      if (((p_debutPBJC.coincideAvec(p_periodeDuree.getDebut())) || (p_debutPBJC.coincideAvec(dateEffet))) && (p_positionJustifOuverture)) {
        pbjcNcpAvant.ajouterComplementDeJustification("AE");
      }
      if ((p_finPBJC.coincideAvec(p_periodeDuree.getFin())) && (p_positionJustifFermeture)) {
        pbjcNcpAvant.ajouterComplementDeJustification("ME");
      }
    }
    else if ((p_duree != null) && (p_duree.getTypeDureeConsommable() == 1))
    {
      pbjcNcpAvant.setTypeCarence("CP");
      if (((p_debutPBJC.coincideAvec(p_periodeDuree.getDebut())) || (p_debutPBJC.coincideAvec(dateEffet))) && (p_positionJustifOuverture)) {
        pbjcNcpAvant.ajouterComplementDeJustification("AD");
      }
      if ((p_finPBJC.coincideAvec(p_periodeDuree.getFin())) && (p_positionJustifFermeture)) {
        pbjcNcpAvant.ajouterComplementDeJustification("MP");
      }
    }
    return pbjcNcpAvant;
  }
  
  private PbjcNcp creerPBJCAvant(AttributionSpec p_attribution, Collection p_periodesAER, ChronologiePeriodes p_periodesFormation, ChronologiePeriodes p_actionsFormation, Damj p_dateDebut, Damj p_dateFin)
  {
    PbjcNcp pbjcNcp = null;
    ObjetChronoPeriodePriseEnCharge pec = null;
    PeriodeFormation periodeFormationCalcul = null;
    
    pbjcNcp = new PbjcNcp(p_dateDebut, p_dateFin);
    
    positionnerReferencesOuvertureDroit(pbjcNcp, p_attribution);
    
    pbjcNcp.setRefBaseCalculMontantBrut(retournerReferenceBaseCalcul(p_attribution));
    
    pbjcNcp.setProduit(p_attribution.getProduit().getNom());
    
    pbjcNcp.setNaturePBJC("CA");
    
    pbjcNcp.setEtatIndemnisation("AVANT");
    
    pbjcNcp.setEtatAdministratifOd("1");
    
    pbjcNcp.setRegimeApplicable(retournerReglementApplicable(p_attribution));
    
    pbjcNcp.setCodeMotifNonPaiement("00");
    
    pbjcNcp.setRangProlongation(0);
    
    pbjcNcp.setReliquatDureeMax(((Admission)p_attribution).getAttributionAssurance().getDureeIndemnisationTheorique().getValeurEntiere());
    
    pbjcNcp.setCumulCourant(retournerQuantiteIndemnisationInitialeDroit(p_attribution, null).getValeurEntiere() - pbjcNcp.getReliquatDureeMax());
    
    positionnerPriseEnChargeAER(pbjcNcp, p_periodesAER);
    
    pec = OutillagePeriodes.recupererPeriodePECContenant(p_attribution.getDemandeur(), p_dateDebut);
    if (pec != null) {
      pbjcNcp.setAleIndividu(pec.getAleIndividu());
    }
    positionnerInfoConventionGestion(pbjcNcp, p_attribution);
    
    p_periodesFormation.iterer();
    while (p_periodesFormation.encoreSuivant())
    {
      periodeFormationCalcul = (PeriodeFormation)p_periodesFormation.elementSuivant();
      if ((periodeFormationCalcul.getPeriodeEffectiveInitiale() != null) && 
        (periodeFormationCalcul.getPeriodeEffectiveInitiale().chevauche(new Periode(p_dateDebut, p_dateFin))))
      {
        super.ajouterGroupeMontantCGF(pbjcNcp, periodeFormationCalcul);
        pbjcNcp.setIdStageFormation(periodeFormationCalcul.getIdentifiantPeriodeFormation());
        pbjcNcp.setTypeMesurePourLEmploi(periodeFormationCalcul.getTypeMesureEmploi());
      }
    }
    p_actionsFormation.iterer();
    while (p_actionsFormation.encoreSuivant())
    {
      ActionFormation actionFormationCalcul = (ActionFormation)p_actionsFormation.elementSuivant();
      if (pbjcNcp.chevauche(new Periode(actionFormationCalcul.getDateDebut(), actionFormationCalcul.getDateFin())))
      {
        pbjcNcp.setIdPlanFormation(actionFormationCalcul.getIdentifiantActionFormation());
        
        pbjcNcp.setTypeDePlan(actionFormationCalcul.getTypePlan());
      }
    }
    pbjcNcp.setNbJoursAREF(initialiserCompteurFormation(p_attribution));
    
    return pbjcNcp;
  }
  
  private int initialiserCompteurFormation(AttributionSpec p_attribution)
  {
    int nbJourFormation = 0;
    return nbJourFormation;
  }
}

/* Location:
 * Qualified Name:     FacadePBJCProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */