package fr.unedic.cali.asu.mnt.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.mnt.dom.pc.ConditionDureeIndemnisationMaintienPC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConditionDureeIndemnisationMaintienGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionDureeIndemnisationMaintienPC;
  private Damj m_dateObtentionDureeIndemnisation;
  private ResultatElementDroit m_resultatElementDroit;
  
  public ConditionDureeIndemnisationMaintienGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionDureeIndemnisationMaintienGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionDureeIndemnisationMaintienPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionDureeIndemnisationMaintienPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionDureeIndemnisationMaintienPC)
  {
    m_conditionDureeIndemnisationMaintienPC = p_conditionDureeIndemnisationMaintienPC;
  }
  
  protected int rawGetNombreJoursDureeIndemnisationRequise()
  {
    return ((ConditionDureeIndemnisationMaintienPC)getPC()).getNombreJoursDureeIndemnisationRequise();
  }
  
  public int getNombreJoursDureeIndemnisationRequise()
  {
    return ((ConditionDureeIndemnisationMaintienPC)getPC()).getNombreJoursDureeIndemnisationRequise();
  }
  
  public void setNombreJoursDureeIndemnisationRequise(int p_nombreJoursDureeIndemnisationRequise)
  {
    ((ConditionDureeIndemnisationMaintienPC)getPC()).setNombreJoursDureeIndemnisationRequise(p_nombreJoursDureeIndemnisationRequise);
  }
  
  protected Damj rawGetDateObtentionDureeIndemnisation()
  {
    return ((ConditionDureeIndemnisationMaintienPC)getPC()).getDateObtentionDureeIndemnisation();
  }
  
  public Damj getDateObtentionDureeIndemnisation()
  {
    return ((ConditionDureeIndemnisationMaintienPC)getPC()).getDateObtentionDureeIndemnisation();
  }
  
  public void setDateObtentionDureeIndemnisation(Damj p_dateObtentionDureeIndemnisation)
  {
    if ((m_dateObtentionDureeIndemnisation == null) || (p_dateObtentionDureeIndemnisation == null))
    {
      m_dateObtentionDureeIndemnisation = p_dateObtentionDureeIndemnisation;
      ((ConditionDureeIndemnisationMaintienPC)getPC()).setDateObtentionDureeIndemnisation(p_dateObtentionDureeIndemnisation);
    }
    else if ((m_dateObtentionDureeIndemnisation != null) && (p_dateObtentionDureeIndemnisation != null) && (!p_dateObtentionDureeIndemnisation.equals(m_dateObtentionDureeIndemnisation)))
    {
      m_dateObtentionDureeIndemnisation = p_dateObtentionDureeIndemnisation;
      ((ConditionDureeIndemnisationMaintienPC)getPC()).setDateObtentionDureeIndemnisation(p_dateObtentionDureeIndemnisation);
    }
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionDureeIndemnisationMaintienPC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionDureeIndemnisationMaintienPC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionDureeIndemnisationMaintienPC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionDureeIndemnisationMaintienGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */