package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class OutilGestionContexteDemande
{
  private static HashMap<Integer, List<String>> groupeTypesContextes = new HashMap();
  
  static
  {
    List<String> listeTypeAsp = new ArrayList();
    
    listeTypeAsp.add("IDEASP");
    listeTypeAsp.add("ADHVOLARE");
    listeTypeAsp.add("ASPVOLSARE");
    groupeTypesContextes.put(Integer.valueOf(1), listeTypeAsp);
    
    List<String> listeTypeFinAsp = new ArrayList();
    listeTypeFinAsp.add("FINASP");
    listeTypeFinAsp.add("FINASPVOL");
    listeTypeFinAsp.add("FINASPVOLC");
    groupeTypesContextes.put(Integer.valueOf(5), listeTypeFinAsp);
    
    List<String> listeTypeAdhVol = new ArrayList();
    listeTypeAdhVol.add("ADHVOLARE");
    listeTypeAdhVol.add("ASPVOLSARE");
    listeTypeAdhVol.add("FINASPVOLC");
    groupeTypesContextes.put(Integer.valueOf(3), listeTypeAdhVol);
    
    List<String> listeEnCoursPmvs = new ArrayList();
    listeEnCoursPmvs.add("CRSPMVS");
    listeEnCoursPmvs.add("CRSPMVSREC");
    groupeTypesContextes.put(Integer.valueOf(2), listeEnCoursPmvs);
    
    List<String> listeCsr = new ArrayList();
    listeCsr.add("CSRSUSP");
    listeCsr.add("RUPCTRSUSP");
    groupeTypesContextes.put(Integer.valueOf(4), listeCsr);
    
    List<String> listeAspAre = new ArrayList();
    listeAspAre.add("AREENTRCSP");
    listeAspAre.add("ARECOURCSP");
    groupeTypesContextes.put(Integer.valueOf(6), listeAspAre);
    
    List<String> listeTypeProduitCsp = new ArrayList();
    listeTypeProduitCsp.add("ASPARE");
    listeTypeProduitCsp.add("ASPDC");
    listeTypeProduitCsp.add("PAPARE");
    listeTypeProduitCsp.add("PAPDC");
    groupeTypesContextes.put(Integer.valueOf(7), listeTypeProduitCsp);
    
    List<String> listeTypeProduitCspDC = new ArrayList();
    listeTypeProduitCspDC.add("ASPDC");
    listeTypeProduitCspDC.add("PAPDC");
    groupeTypesContextes.put(Integer.valueOf(9), listeTypeProduitCspDC);
    
    List<String> listeTypeProduitPap = new ArrayList();
    listeTypeProduitPap.add("PAPARE");
    listeTypeProduitPap.add("PAPDC");
    groupeTypesContextes.put(Integer.valueOf(10), listeTypeProduitPap);
    
    List<String> listeTypeCra = new ArrayList();
    listeTypeCra.add("ENTREECRA");
    listeTypeCra.add("ENCOURSCRA");
    groupeTypesContextes.put(Integer.valueOf(8), listeTypeCra);
    
    List<String> listeDisponibilite = new ArrayList();
    listeDisponibilite.add("COURSDISPO");
    listeDisponibilite.add("POSTDISPO");
    groupeTypesContextes.put(Integer.valueOf(11), listeDisponibilite);
  }
  
  public static List<String> recupererContextesPourRegroupement(int regroupementContextes)
  {
    return (List)groupeTypesContextes.get(Integer.valueOf(regroupementContextes));
  }
  
  public static void reprendreStockContexteDemande(Demande demande)
  {
    fr.unedic.cali.asu.dom.ContexteDemande contexteDemandeAsu = demande.getContexteDemande();
    if ((contexteDemandeAsu != null) && (contexteDemandeAsu.getTypeContexteDemande() != null) && (!"AUCUN".equals(contexteDemandeAsu.getTypeContexteDemande())) && (!"".equals(contexteDemandeAsu.getTypeContexteDemande())))
    {
      fr.unedic.cali.dom.ContexteDemande contexteDemandehg = new fr.unedic.cali.dom.ContexteDemande();
      contexteDemandehg.setDateDebutJustifContexte(contexteDemandeAsu.getDateDebutJustifContexte());
      contexteDemandehg.setDateFinJustifContexte(contexteDemandeAsu.getDateFinJustifContexte());
      contexteDemandehg.setSousTypeContexteDemande(contexteDemandeAsu.getSousTypeContexteDemande());
      contexteDemandehg.setTypeContexteDemande(contexteDemandeAsu.getTypeContexteDemande());
      contexteDemandehg.setAttributionAreAdhesionVolontaire(contexteDemandeAsu.getAttributionAreAdhesionVolontaire());
      contexteDemandehg.setAttributionLieeAFinDeDroit(contexteDemandeAsu.getAttributionLieeAFinDeDroit());
      contexteDemandehg.setDerniereAeCspVolontaire(contexteDemandeAsu.getDerniereAeCspVolontaire());
      contexteDemandehg.setIdPremiereDemandeCsrDansSuspension(contexteDemandeAsu.getIdPremiereDemandeCsrDansSuspension());
      demande.ajouterContexteDemande(contexteDemandehg);
      demande.removeContexteDemande();
    }
  }
  
  public static ContexteDemandeSpec trouverContexteDemandeAssurance(Demande demande, List<String> typeContexteDemande)
  {
    for (String contexte : typeContexteDemande)
    {
      ContexteDemandeSpec retour = trouverContexteDemandeAssurance(demande, contexte);
      if (retour != null) {
        return retour;
      }
    }
    return null;
  }
  
  public static ContexteDemandeSpec trouverContexteDemandeAssurance(Demande demande, String[] typeContexteDemande)
  {
    return trouverContexteDemandeAssurance(demande, Arrays.asList(typeContexteDemande));
  }
  
  public static boolean estContexteDemandeAssurancePresent(Demande demande, int regroupementContexteDemandeRecherche)
  {
    return trouverUnContexteDemandeAssurancePresent(demande, regroupementContexteDemandeRecherche) != null;
  }
  
  public static ContexteDemandeSpec trouverUnContexteDemandeAssurancePresent(Demande demande, int regroupementContexteDemandeRecherche)
  {
    List<String> listeContexte = recupererContextesPourRegroupement(regroupementContexteDemandeRecherche);
    if (listeContexte != null) {
      for (String contexte : listeContexte)
      {
        ContexteDemandeSpec contexteRetour = trouverContexteDemandeAssurance(demande, contexte);
        if (contexteRetour != null) {
          return contexteRetour;
        }
      }
    }
    return null;
  }
  
  public static ContexteDemandeSpec trouverContexteDemandeAssurance(Demande demande, String typeContexteDemande)
  {
    return trouverContexteDemande(demande.getListContexteDemande(), typeContexteDemande);
  }
  
  public static ContexteDemandeSpec trouverContexteDemande(List<ContexteDemandeSpec> contextes, String typeContexte)
  {
    ContexteDemandeSpec retour = null;
    if ((contextes != null) && (typeContexte != null)) {
      for (ContexteDemandeSpec p_contexte : contextes) {
        if ((p_contexte.getTypeContexteDemande() != null) && (p_contexte.getTypeContexteDemande().equals(typeContexte))) {
          return p_contexte;
        }
      }
    }
    return retour;
  }
  
  public static ContexteDemandeSpec trouverUnContextePresent(List<ContexteDemandeSpec> contextes, int typeRegroupementContexteDemandeRecherche)
  {
    ContexteDemandeSpec retour = null;
    List<String> listeContexte = recupererContextesPourRegroupement(typeRegroupementContexteDemandeRecherche);
    if (listeContexte != null) {
      for (String contexte : listeContexte)
      {
        retour = trouverContexteDemande(contextes, contexte);
        if (retour != null) {
          return retour;
        }
      }
    }
    return retour;
  }
  
  public static boolean estUnContexteDemandeAssurancePresent(Demande demande, List<String> typeContexteDemandeRecherche)
  {
    boolean retour = false;
    for (String context : typeContexteDemandeRecherche) {
      if (estContexteDemandeAssurancePresent(demande, context))
      {
        retour = true;
        break;
      }
    }
    return retour;
  }
  
  public static boolean estUnContexteDemandeAssurancePresent(Demande demande, String[] typeContexteDemandeRecherche)
  {
    return estUnContexteDemandeAssurancePresent(demande, Arrays.asList(typeContexteDemandeRecherche));
  }
  
  public static boolean estUnContexteDemandeAssurancePresent(List<ContexteDemandeSpec> contextes, String typeContexteDemandeRecherche)
  {
    return trouverContexteDemande(contextes, typeContexteDemandeRecherche) != null;
  }
  
  public static boolean estContexteDemandeAssurancePresent(Demande demande, String typeContexteDemandeRecherche)
  {
    return trouverContexteDemandeAssurance(demande, typeContexteDemandeRecherche) != null;
  }
  
  public static void supprimerContexteDemande(Demande demande, String contexteDemande)
  {
    fr.unedic.cali.dom.ContexteDemande contexteDemandeASupprimer = (fr.unedic.cali.dom.ContexteDemande)trouverContexteDemandeAssurance(demande, contexteDemande);
    while (contexteDemandeASupprimer != null)
    {
      demande.supprimerContexteDemande(contexteDemandeASupprimer);
      contexteDemandeASupprimer = (fr.unedic.cali.dom.ContexteDemande)trouverContexteDemandeAssurance(demande, contexteDemande);
    }
  }
  
  public static boolean estContextePresentDansRegroupement(List<ContexteDemandeSpec> contextes, int typeRegroupementContexteDemandeRecherche)
  {
    boolean retour = false;
    if (contextes != null)
    {
      List<String> listeContexteRegroupement = recupererContextesPourRegroupement(typeRegroupementContexteDemandeRecherche);
      for (String context : listeContexteRegroupement)
      {
        ContexteDemandeSpec contexteDemande = trouverContexteDemande(contextes, context);
        if (contexteDemande != null)
        {
          retour = true;
          break;
        }
      }
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     OutilGestionContexteDemande
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */