package fr.unedic.cali.asu.outilsfonctionnels.strategies;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.outilsfonctionnels.ConstitutionISLR;
import fr.unedic.cali.autresdoms.ga.dom.Indemnite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteMonnaie;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class StrategieIslrApresMEP08SI1
  extends ConstitutionISLR
  implements StrategieIslrSpec
{
  public QuantiteEuro calculeISLR(Collection p_listeIndemnites, int p_codeMotifRuptureCT, int p_categorieEmploiParticulier, Damj p_dateFaitGenerateurOuDernierSinistre)
    throws CoucheLogiqueException
  {
    QuantiteEuro retourISLR = new QuantiteEuro("0");
    if (p_listeIndemnites == null) {
      return retourISLR;
    }
    BigDecimal montantTOT = null;
    BigDecimal montantE = null;
    BigDecimal montantI = null;
    BigDecimal montantL = null;
    BigDecimal montantSL = null;
    BigDecimal montantC = null;
    BigDecimal montantT = null;
    BigDecimal montantRe = null;
    BigDecimal montantRs = null;
    BigDecimal montantFm = null;
    BigDecimal montantRi = null;
    BigDecimal montantRmat = null;
    BigDecimal montantRmar = null;
    BigDecimal montantRj = null;
    BigDecimal montantRvrp = null;
    BigDecimal montantRpnac = null;
    BigDecimal montantRapp = null;
    BigDecimal montantRail = null;
    BigDecimal montantRc = null;
    
    BigDecimal montantFCDouFMIouCNE = null;
    BigDecimal montantIcp = null;
    BigDecimal montantIcpEstime = null;
    BigDecimal montantIslicp = null;
    
    boolean presenceIndemnitesRuptureSpecifiquesHormisVRP = false;
    for (Iterator it = p_listeIndemnites.iterator(); it.hasNext();)
    {
      Indemnite indemnite = (Indemnite)it.next();
      int typeIndemnite = Integer.valueOf(indemnite.getTypeIndemnite()).intValue();
      if (indemnite.getMontant() != null) {
        switch (typeIndemnite)
        {
        case 1: 
          break;
        case 5: 
          montantTOT = indemnite.getMontant().getValeurMontant();
          break;
        case 7: 
          montantI = indemnite.getMontant().getValeurMontant();
          break;
        case 6: 
          montantE = indemnite.getMontant().getValeurMontant();
          break;
        case 3: 
          montantC = indemnite.getMontant().getValeurMontant();
          break;
        case 4: 
          montantT = indemnite.getMontant().getValeurMontant();
          break;
        case 101: 
          montantL = indemnite.getMontant().getValeurMontant();
          break;
        case 102: 
          montantSL = indemnite.getMontant().getValeurMontant();
          break;
        case 105: 
          if (p_codeMotifRuptureCT == 17) {
            montantRe = indemnite.getMontant().getValeurMontant();
          } else if (p_codeMotifRuptureCT == 18) {
            montantRs = indemnite.getMontant().getValeurMontant();
          }
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 106: 
          if (p_codeMotifRuptureCT == 24) {
            montantFm = indemnite.getMontant().getValeurMontant();
          }
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 107: 
          if (p_codeMotifRuptureCT == 26) {
            montantRi = indemnite.getMontant().getValeurMontant();
          }
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 108: 
          if (p_categorieEmploiParticulier == 22) {
            montantRmat = indemnite.getMontant().getValeurMontant();
          } else if (p_categorieEmploiParticulier == 37) {
            montantRmar = indemnite.getMontant().getValeurMontant();
          }
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 109: 
          if (p_categorieEmploiParticulier == 36) {
            montantRj = indemnite.getMontant().getValeurMontant();
          }
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 110: 
          if (p_categorieEmploiParticulier == 46) {
            montantRvrp = indemnite.getMontant().getValeurMontant();
          }
          break;
        case 111: 
          montantRpnac = indemnite.getMontant().getValeurMontant();
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 112: 
          montantRapp = indemnite.getMontant().getValeurMontant();
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 113: 
          montantRail = indemnite.getMontant().getValeurMontant();
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 123: 
          if (p_categorieEmploiParticulier == 22) {
            montantRmat = indemnite.getMontant().getValeurMontant();
          } else if (p_categorieEmploiParticulier == 37) {
            montantRmar = indemnite.getMontant().getValeurMontant();
          } else if (p_categorieEmploiParticulier == 41) {
            montantRpnac = indemnite.getMontant().getValeurMontant();
          } else if (p_codeMotifRuptureCT == 41) {
            montantRc = indemnite.getMontant().getValeurMontant();
          }
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 103: 
        case 104: 
        case 122: 
          montantFCDouFMIouCNE = indemnite.getMontant().getValeurMontant();
          presenceIndemnitesRuptureSpecifiquesHormisVRP = true;
          break;
        case 127: 
          montantIcp = indemnite.getMontant().getValeurMontant();
          break;
        case 128: 
          montantIcpEstime = indemnite.getMontant().getValeurMontant();
          break;
        default: 
          if (Log.isTraceActive(ConstitutionISLR.class, Niveau.DEBUG)) {
            Log.ecritTrace(Niveau.DEBUG, ConstitutionISLR.class, "calculeISLR", "Type indemnite non traité: " + indemnite.getTypeIndemnite());
          }
          break;
        }
      }
    }
    BigDecimal valeurZero = new BigDecimal("0");
    if (montantI != null)
    {
      if (montantTOT != null) {
        retourISLR = new QuantiteEuro(valeurZero.max(montantTOT.subtract(montantI)));
      } else {
        retourISLR = new QuantiteEuro("0");
      }
    }
    else
    {
      if (montantRmat != null) {
        retourISLR = calculeISLRUnitaireCasAssistanteMaternelle(montantE, montantTOT, montantRmat);
      } else if (montantRe != null) {
        retourISLR = calculeISLRUnitaireStandard(montantE, montantTOT, montantRe);
      } else if (montantRs != null) {
        retourISLR = calculeISLRUnitaireStandard(montantE, montantTOT, montantRs);
      } else if (montantFm != null) {
        retourISLR = calculeISLRUnitaireStandard(montantE, montantTOT, montantFm);
      } else if (montantRi != null) {
        retourISLR = calculeISLRUnitaireStandard(montantE, montantTOT, montantRi);
      } else if (montantRj != null) {
        retourISLR = calculeISLRUnitaireStandard(montantE, montantTOT, montantRj);
      } else if (montantRc != null) {
        retourISLR = calculeISLRUnitaireStandard(montantE, montantTOT, montantRc);
      } else if (montantFCDouFMIouCNE != null) {
        retourISLR = calculeISLRPourFCDouFMIouCNE(montantTOT, montantFCDouFMIouCNE);
      } else if (montantRmar != null) {
        retourISLR = calculeISLRUnitaireStandardSansE(montantTOT, montantRmar);
      } else if (montantRpnac != null) {
        retourISLR = calculeISLRUnitaireStandardSansE(montantTOT, montantRpnac);
      } else if (montantRapp != null) {
        retourISLR = calculeISLRUnitaireStandardSansE(montantTOT, montantRapp);
      } else if (montantRail != null) {
        retourISLR = calculeISLRUnitaireStandardSansE(montantTOT, montantRail);
      }
      if (!presenceIndemnitesRuptureSpecifiquesHormisVRP)
      {
        if ((montantTOT != null) && (montantTOT.intValue() > 0)) {
          if (montantE == null) {
            retourISLR = new QuantiteEuro(montantTOT);
          } else {
            retourISLR = new QuantiteEuro(valeurZero.max(montantTOT.subtract(montantE)));
          }
        }
        if (montantRvrp != null) {
          retourISLR = determinerMontantIslrVrp(montantTOT, montantE, montantL, montantSL, montantC, montantT, montantRvrp);
        } else if ((montantL != null) || (montantSL != null) || (montantC != null) || (montantT != null)) {
          retourISLR = determinerMontantIslrSurValeursMontantsLSLCT(montantE, montantL, montantSL, montantC, montantT, p_dateFaitGenerateurOuDernierSinistre);
        }
      }
    }
    montantIslicp = calculerISLICP(montantIcp, montantIcpEstime);
    
    retourISLR = new QuantiteEuro(retourISLR.getValeur().add(montantIslicp));
    return retourISLR;
  }
  
  private QuantiteEuro calculeISLRUnitaireStandardSansE(BigDecimal p_montantTotal, BigDecimal p_montantIndemniteSpecifique)
  {
    BigDecimal valeurZero = new BigDecimal("0");
    if (p_montantTotal == null) {
      return new QuantiteEuro("0");
    }
    return new QuantiteEuro(valeurZero.max(p_montantTotal.subtract(p_montantIndemniteSpecifique)));
  }
  
  private QuantiteEuro determinerMontantIslrVrp(BigDecimal p_montantTot, BigDecimal p_montantE, BigDecimal p_montantL, BigDecimal p_montantSL, BigDecimal p_montantC, BigDecimal p_montantT, BigDecimal p_montantRvrp)
  {
    BigDecimal valeurZero = new BigDecimal("0");
    QuantiteEuro retourISLR = new QuantiteEuro("0");
    BigDecimal montantTotalSansMontantVrp = null;
    BigDecimal montantSoustraitSansMontantVrp = null;
    if ((p_montantL == null) && (p_montantSL == null) && (p_montantC == null) && (p_montantT == null))
    {
      if ((p_montantTot != null) && (p_montantE != null)) {
        retourISLR = new QuantiteEuro(valeurZero.max(p_montantTot.subtract(p_montantE.add(p_montantRvrp))));
      }
    }
    else if ((p_montantL == null) && (p_montantSL == null) && (p_montantC == null) && (p_montantT != null))
    {
      retourISLR = new QuantiteEuro(p_montantT);
    }
    else if ((p_montantL == null) && (p_montantSL == null) && (p_montantC != null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantC;
      montantSoustraitSansMontantVrp = p_montantC;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL == null) && (p_montantSL == null) && (p_montantC != null) && (p_montantT != null))
    {
      montantTotalSansMontantVrp = p_montantC.add(p_montantT);
      montantSoustraitSansMontantVrp = p_montantC;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL == null) && (p_montantSL != null) && (p_montantC == null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantSL;
      montantSoustraitSansMontantVrp = p_montantSL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL == null) && (p_montantSL != null) && (p_montantC == null) && (p_montantT != null))
    {
      montantTotalSansMontantVrp = p_montantSL.add(p_montantT);
      montantSoustraitSansMontantVrp = p_montantSL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL == null) && (p_montantSL != null) && (p_montantC != null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantC;
      montantSoustraitSansMontantVrp = p_montantSL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL == null) && (p_montantSL != null) && (p_montantC != null) && (p_montantT != null))
    {
      montantTotalSansMontantVrp = p_montantC.add(p_montantT);
      montantSoustraitSansMontantVrp = p_montantSL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL == null) && (p_montantC == null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantL;
      montantSoustraitSansMontantVrp = p_montantL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL == null) && (p_montantC == null) && (p_montantT != null))
    {
      montantTotalSansMontantVrp = p_montantT.add(p_montantL);
      montantSoustraitSansMontantVrp = p_montantL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL == null) && (p_montantC != null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantC;
      montantSoustraitSansMontantVrp = p_montantL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL == null) && (p_montantC != null) && (p_montantT != null))
    {
      montantTotalSansMontantVrp = p_montantC.add(p_montantT);
      montantSoustraitSansMontantVrp = p_montantL;
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL != null) && (p_montantC == null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantL.add(p_montantSL);
      montantSoustraitSansMontantVrp = p_montantL.add(p_montantSL);
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL != null) && (p_montantC == null) && (p_montantT != null))
    {
      montantSoustraitSansMontantVrp = p_montantL.add(p_montantSL);
      montantTotalSansMontantVrp = p_montantT.add(montantSoustraitSansMontantVrp);
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL != null) && (p_montantC != null) && (p_montantT == null))
    {
      montantTotalSansMontantVrp = p_montantC;
      montantSoustraitSansMontantVrp = p_montantL.add(p_montantSL);
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    else if ((p_montantL != null) && (p_montantSL != null) && (p_montantC != null) && (p_montantT != null))
    {
      montantTotalSansMontantVrp = p_montantC.add(p_montantT);
      montantSoustraitSansMontantVrp = p_montantL.add(p_montantSL);
      retourISLR = calculeISLRUnitaireVrp(p_montantE, montantTotalSansMontantVrp, montantSoustraitSansMontantVrp, p_montantRvrp);
    }
    return retourISLR;
  }
  
  private QuantiteEuro calculeISLRUnitaireVrp(BigDecimal p_montantE, BigDecimal p_montantTotalSansVrp, BigDecimal p_montantAComparer, BigDecimal p_montantRvrp)
  {
    BigDecimal valeurZero = new BigDecimal("0");
    if (p_montantTotalSansVrp == null) {
      return new QuantiteEuro("0");
    }
    if (p_montantE == null) {
      return new QuantiteEuro(p_montantTotalSansVrp);
    }
    BigDecimal montantTotalAvecVrp = p_montantTotalSansVrp.add(p_montantRvrp);
    BigDecimal montantSoustrait = p_montantAComparer.add(p_montantRvrp);
    BigDecimal montantEsoustrait = p_montantE.add(p_montantRvrp);
    if (p_montantAComparer.compareTo(p_montantE) > 0) {
      return new QuantiteEuro(valeurZero.max(montantTotalAvecVrp.subtract(montantEsoustrait)));
    }
    return new QuantiteEuro(valeurZero.max(montantTotalAvecVrp.subtract(montantSoustrait)));
  }
}

/* Location:
 * Qualified Name:     StrategieIslrApresMEP08SI1
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */