package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.parcours.ParcoursObjectifRevisionAdmission;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.ObjectifExamenRevisionAdmissionGen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ObjectifExamenSpec;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionAge;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionCumulPrestationFamiliale;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionMontantProduitNonNul;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;

public class ObjectifExamenRevisionAdmission
  extends ObjectifExamenRevisionAdmissionGen
  implements ObjectifExamenSpec
{
  private static final long serialVersionUID = -6978872861986717464L;
  
  public Parcours creerParcoursDateLimiteIndemnisation()
  {
    return null;
  }
  
  public ObjectifExamenRevisionAdmission(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjectifExamenRevisionAdmission() {}
  
  public Parcours creerParcoursObjectif()
  {
    return new ParcoursObjectifRevisionAdmission();
  }
  
  public ObjectifExamen getObjectifSauvegarde()
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public int getType()
  {
    return 1;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenRevisionAdmission copie = new ObjectifExamenRevisionAdmission();
    copieElements(copie);
    return copie;
  }
  
  /**
   * @deprecated
   */
  public void marquerGraphePersistant() {}
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public Parcours creerParcoursCapitalAvecDureeEffective()
  {
    return null;
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return null;
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return null;
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionAge()
  {
    return new DeterminationConditionAge();
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionChomageTotal()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulAvantageVieillesse()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    return new DeterminationConditionCumulPrestationFamiliale();
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    return new DeterminationConditionMontantProduitNonNul();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionDureeNonNulle()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    return null;
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    return null;
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    return null;
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    return null;
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return null;
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    return new ConstitutionPointDepartIndemnisation();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return null;
  }
  
  public Parcours creerParcoursReglementApplicable()
  {
    return null;
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return null;
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionAnciennete()
  {
    return null;
  }
  
  public Parcours creerParcoursRevisionAutomatique()
  {
    return null;
  }
  
  public Parcours creerParcoursLiquidationDemandeAssociee()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCsrAccordCp()
  {
    return null;
  }
  
  public Parcours creerParcoursCondition28JSuspension()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionValiditeReliquat()
  {
    return null;
  }
  
  public Parcours creerParcoursCapitalDroitCourant()
  {
    return null;
  }
  
  public Parcours creerParcoursMontantsEffectifs()
  {
    return null;
  }
  
  public Parcours creerParcoursDetectionContributionParticuliere(Demande demande)
  {
    return null;
  }
  
  public Parcours creerParcoursNouvelleRevisionAutomatique()
  {
    return null;
  }
  
  public Parcours creerParcoursConstitutionDureePostPrime()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenRevisionAdmission
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */