package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.pc.CompetencePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class CompetenceGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_competencePC;
  private String m_libelleEmployeurCompetent;
  private String m_numeroConventionGestion;
  private String m_codeAffectationConvention;
  private String m_applicationDesAides;
  private String m_signataireConvention;
  private Damj m_debutValiditeConventionGestion;
  private Damj m_finValiditeConventionGestion;
  private String m_libelleAffectationConventionGestion;
  private String m_idExterneEmployeurSp;
  
  public CompetenceGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public CompetenceGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new CompetencePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_competencePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_competencePC)
  {
    m_competencePC = p_competencePC;
  }
  
  protected int rawGetDureeActiviteSecteurPrive()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPrive();
  }
  
  public int getDureeActiviteSecteurPrive()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPrive();
  }
  
  public void setDureeActiviteSecteurPrive(int p_dureeActiviteSecteurPrive)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPrive(p_dureeActiviteSecteurPrive);
  }
  
  protected int rawGetDureeActiviteSecteurPriveCaCae()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPriveCaCae();
  }
  
  public int getDureeActiviteSecteurPriveCaCae()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPriveCaCae();
  }
  
  public void setDureeActiviteSecteurPriveCaCae(int p_dureeActiviteSecteurPriveCaCae)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPriveCaCae(p_dureeActiviteSecteurPriveCaCae);
  }
  
  protected int rawGetDureeActiviteSecteurPublicAffilie()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAffilie();
  }
  
  public int getDureeActiviteSecteurPublicAffilie()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAffilie();
  }
  
  public void setDureeActiviteSecteurPublicAffilie(int p_dureeActiviteSecteurPublicAffilie)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPublicAffilie(p_dureeActiviteSecteurPublicAffilie);
  }
  
  protected int rawGetDureeActiviteSecteurPublicAutoAssurance()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAutoAssurance();
  }
  
  public int getDureeActiviteSecteurPublicAutoAssurance()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAutoAssurance();
  }
  
  public void setDureeActiviteSecteurPublicAutoAssurance(int p_dureeActiviteSecteurPublicAutoAssurance)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPublicAutoAssurance(p_dureeActiviteSecteurPublicAutoAssurance);
  }
  
  protected int rawGetDureeActiviteSecteurPublicConventionGestion()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicConventionGestion();
  }
  
  public int getDureeActiviteSecteurPublicConventionGestion()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicConventionGestion();
  }
  
  public void setDureeActiviteSecteurPublicConventionGestion(int p_dureeActiviteSecteurPublicConventionGestion)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPublicConventionGestion(p_dureeActiviteSecteurPublicConventionGestion);
  }
  
  protected int rawGetCompetenceAdministrative()
  {
    return ((CompetencePC)getPC()).getCompetenceAdministrative();
  }
  
  public int getCompetenceAdministrative()
  {
    return ((CompetencePC)getPC()).getCompetenceAdministrative();
  }
  
  public void setCompetenceAdministrative(int p_competenceAdministrative)
  {
    ((CompetencePC)getPC()).setCompetenceAdministrative(p_competenceAdministrative);
  }
  
  protected int rawGetCompetenceFinanciere()
  {
    return ((CompetencePC)getPC()).getCompetenceFinanciere();
  }
  
  public int getCompetenceFinanciere()
  {
    return ((CompetencePC)getPC()).getCompetenceFinanciere();
  }
  
  public void setCompetenceFinanciere(int p_competenceFinanciere)
  {
    ((CompetencePC)getPC()).setCompetenceFinanciere(p_competenceFinanciere);
  }
  
  protected String rawGetLibelleEmployeurCompetent()
  {
    return ((CompetencePC)getPC()).getLibelleEmployeurCompetent();
  }
  
  public String getLibelleEmployeurCompetent()
  {
    return ((CompetencePC)getPC()).getLibelleEmployeurCompetent();
  }
  
  public void setLibelleEmployeurCompetent(String p_libelleEmployeurCompetent)
  {
    if ((m_libelleEmployeurCompetent == null) || (p_libelleEmployeurCompetent == null))
    {
      m_libelleEmployeurCompetent = p_libelleEmployeurCompetent;
      ((CompetencePC)getPC()).setLibelleEmployeurCompetent(p_libelleEmployeurCompetent);
    }
    else if ((m_libelleEmployeurCompetent != null) && (p_libelleEmployeurCompetent != null) && (!p_libelleEmployeurCompetent.equals(m_libelleEmployeurCompetent)))
    {
      m_libelleEmployeurCompetent = p_libelleEmployeurCompetent;
      ((CompetencePC)getPC()).setLibelleEmployeurCompetent(p_libelleEmployeurCompetent);
    }
  }
  
  protected String rawGetNumeroConventionGestion()
  {
    return ((CompetencePC)getPC()).getNumeroConventionGestion();
  }
  
  public String getNumeroConventionGestion()
  {
    return ((CompetencePC)getPC()).getNumeroConventionGestion();
  }
  
  public void setNumeroConventionGestion(String p_numeroConventionGestion)
  {
    if ((m_numeroConventionGestion == null) || (p_numeroConventionGestion == null))
    {
      m_numeroConventionGestion = p_numeroConventionGestion;
      ((CompetencePC)getPC()).setNumeroConventionGestion(p_numeroConventionGestion);
    }
    else if ((m_numeroConventionGestion != null) && (p_numeroConventionGestion != null) && (!p_numeroConventionGestion.equals(m_numeroConventionGestion)))
    {
      m_numeroConventionGestion = p_numeroConventionGestion;
      ((CompetencePC)getPC()).setNumeroConventionGestion(p_numeroConventionGestion);
    }
  }
  
  protected String rawGetCodeAffectationConvention()
  {
    return ((CompetencePC)getPC()).getCodeAffectationConvention();
  }
  
  public String getCodeAffectationConvention()
  {
    return ((CompetencePC)getPC()).getCodeAffectationConvention();
  }
  
  public void setCodeAffectationConvention(String p_codeAffectationConvention)
  {
    if ((m_codeAffectationConvention == null) || (p_codeAffectationConvention == null))
    {
      m_codeAffectationConvention = p_codeAffectationConvention;
      ((CompetencePC)getPC()).setCodeAffectationConvention(p_codeAffectationConvention);
    }
    else if ((m_codeAffectationConvention != null) && (p_codeAffectationConvention != null) && (!p_codeAffectationConvention.equals(m_codeAffectationConvention)))
    {
      m_codeAffectationConvention = p_codeAffectationConvention;
      ((CompetencePC)getPC()).setCodeAffectationConvention(p_codeAffectationConvention);
    }
  }
  
  protected String rawGetApplicationDesAides()
  {
    return ((CompetencePC)getPC()).getApplicationDesAides();
  }
  
  public String getApplicationDesAides()
  {
    return ((CompetencePC)getPC()).getApplicationDesAides();
  }
  
  public void setApplicationDesAides(String p_applicationDesAides)
  {
    if ((m_applicationDesAides == null) || (p_applicationDesAides == null))
    {
      m_applicationDesAides = p_applicationDesAides;
      ((CompetencePC)getPC()).setApplicationDesAides(p_applicationDesAides);
    }
    else if ((m_applicationDesAides != null) && (p_applicationDesAides != null) && (!p_applicationDesAides.equals(m_applicationDesAides)))
    {
      m_applicationDesAides = p_applicationDesAides;
      ((CompetencePC)getPC()).setApplicationDesAides(p_applicationDesAides);
    }
  }
  
  protected boolean rawIsPrecompteCrc()
  {
    return ((CompetencePC)getPC()).isPrecompteCrc();
  }
  
  public boolean isPrecompteCrc()
  {
    return ((CompetencePC)getPC()).isPrecompteCrc();
  }
  
  public void setPrecompteCrc(boolean p_precompteCrc)
  {
    ((CompetencePC)getPC()).setPrecompteCrc(p_precompteCrc);
  }
  
  protected String rawGetSignataireConvention()
  {
    return ((CompetencePC)getPC()).getSignataireConvention();
  }
  
  public String getSignataireConvention()
  {
    return ((CompetencePC)getPC()).getSignataireConvention();
  }
  
  public void setSignataireConvention(String p_signataireConvention)
  {
    if ((m_signataireConvention == null) || (p_signataireConvention == null))
    {
      m_signataireConvention = p_signataireConvention;
      ((CompetencePC)getPC()).setSignataireConvention(p_signataireConvention);
    }
    else if ((m_signataireConvention != null) && (p_signataireConvention != null) && (!p_signataireConvention.equals(m_signataireConvention)))
    {
      m_signataireConvention = p_signataireConvention;
      ((CompetencePC)getPC()).setSignataireConvention(p_signataireConvention);
    }
  }
  
  protected Damj rawGetDebutValiditeConventionGestion()
  {
    return ((CompetencePC)getPC()).getDebutValiditeConventionGestion();
  }
  
  public Damj getDebutValiditeConventionGestion()
  {
    return ((CompetencePC)getPC()).getDebutValiditeConventionGestion();
  }
  
  public void setDebutValiditeConventionGestion(Damj p_debutValiditeConventionGestion)
  {
    if ((m_debutValiditeConventionGestion == null) || (p_debutValiditeConventionGestion == null))
    {
      m_debutValiditeConventionGestion = p_debutValiditeConventionGestion;
      ((CompetencePC)getPC()).setDebutValiditeConventionGestion(p_debutValiditeConventionGestion);
    }
    else if ((m_debutValiditeConventionGestion != null) && (p_debutValiditeConventionGestion != null) && (!p_debutValiditeConventionGestion.equals(m_debutValiditeConventionGestion)))
    {
      m_debutValiditeConventionGestion = p_debutValiditeConventionGestion;
      ((CompetencePC)getPC()).setDebutValiditeConventionGestion(p_debutValiditeConventionGestion);
    }
  }
  
  protected Damj rawGetFinValiditeConventionGestion()
  {
    return ((CompetencePC)getPC()).getFinValiditeConventionGestion();
  }
  
  public Damj getFinValiditeConventionGestion()
  {
    return ((CompetencePC)getPC()).getFinValiditeConventionGestion();
  }
  
  public void setFinValiditeConventionGestion(Damj p_finValiditeConventionGestion)
  {
    if ((m_finValiditeConventionGestion == null) || (p_finValiditeConventionGestion == null))
    {
      m_finValiditeConventionGestion = p_finValiditeConventionGestion;
      ((CompetencePC)getPC()).setFinValiditeConventionGestion(p_finValiditeConventionGestion);
    }
    else if ((m_finValiditeConventionGestion != null) && (p_finValiditeConventionGestion != null) && (!p_finValiditeConventionGestion.equals(m_finValiditeConventionGestion)))
    {
      m_finValiditeConventionGestion = p_finValiditeConventionGestion;
      ((CompetencePC)getPC()).setFinValiditeConventionGestion(p_finValiditeConventionGestion);
    }
  }
  
  protected String rawGetLibelleAffectationConventionGestion()
  {
    return ((CompetencePC)getPC()).getLibelleAffectationConventionGestion();
  }
  
  public String getLibelleAffectationConventionGestion()
  {
    return ((CompetencePC)getPC()).getLibelleAffectationConventionGestion();
  }
  
  public void setLibelleAffectationConventionGestion(String p_libelleAffectationConventionGestion)
  {
    if ((m_libelleAffectationConventionGestion == null) || (p_libelleAffectationConventionGestion == null))
    {
      m_libelleAffectationConventionGestion = p_libelleAffectationConventionGestion;
      ((CompetencePC)getPC()).setLibelleAffectationConventionGestion(p_libelleAffectationConventionGestion);
    }
    else if ((m_libelleAffectationConventionGestion != null) && (p_libelleAffectationConventionGestion != null) && (!p_libelleAffectationConventionGestion.equals(m_libelleAffectationConventionGestion)))
    {
      m_libelleAffectationConventionGestion = p_libelleAffectationConventionGestion;
      ((CompetencePC)getPC()).setLibelleAffectationConventionGestion(p_libelleAffectationConventionGestion);
    }
  }
  
  protected boolean rawIsEstAideArce()
  {
    return ((CompetencePC)getPC()).isEstAideArce();
  }
  
  public boolean isEstAideArce()
  {
    return ((CompetencePC)getPC()).isEstAideArce();
  }
  
  public void setEstAideArce(boolean p_estAideArce)
  {
    ((CompetencePC)getPC()).setEstAideArce(p_estAideArce);
  }
  
  protected boolean rawIsEstAideAdr()
  {
    return ((CompetencePC)getPC()).isEstAideAdr();
  }
  
  public boolean isEstAideAdr()
  {
    return ((CompetencePC)getPC()).isEstAideAdr();
  }
  
  public void setEstAideAdr(boolean p_estAideAdr)
  {
    ((CompetencePC)getPC()).setEstAideAdr(p_estAideAdr);
  }
  
  protected boolean rawIsEstAideCongeNonPaye()
  {
    return ((CompetencePC)getPC()).isEstAideCongeNonPaye();
  }
  
  public boolean isEstAideCongeNonPaye()
  {
    return ((CompetencePC)getPC()).isEstAideCongeNonPaye();
  }
  
  public void setEstAideCongeNonPaye(boolean p_estAideCongeNonPaye)
  {
    ((CompetencePC)getPC()).setEstAideCongeNonPaye(p_estAideCongeNonPaye);
  }
  
  protected boolean rawIsEstAideFinDroit()
  {
    return ((CompetencePC)getPC()).isEstAideFinDroit();
  }
  
  public boolean isEstAideFinDroit()
  {
    return ((CompetencePC)getPC()).isEstAideFinDroit();
  }
  
  public void setEstAideFinDroit(boolean p_estAideFinDroit)
  {
    ((CompetencePC)getPC()).setEstAideFinDroit(p_estAideFinDroit);
  }
  
  protected boolean rawIsEstAideAllocationDeces()
  {
    return ((CompetencePC)getPC()).isEstAideAllocationDeces();
  }
  
  public boolean isEstAideAllocationDeces()
  {
    return ((CompetencePC)getPC()).isEstAideAllocationDeces();
  }
  
  public void setEstAideAllocationDeces(boolean p_estAideAllocationDeces)
  {
    ((CompetencePC)getPC()).setEstAideAllocationDeces(p_estAideAllocationDeces);
  }
  
  protected String rawGetIdExterneEmployeurSp()
  {
    return ((CompetencePC)getPC()).getIdExterneEmployeurSp();
  }
  
  public String getIdExterneEmployeurSp()
  {
    return ((CompetencePC)getPC()).getIdExterneEmployeurSp();
  }
  
  public void setIdExterneEmployeurSp(String p_idExterneEmployeurSp)
  {
    if ((m_idExterneEmployeurSp == null) || (p_idExterneEmployeurSp == null))
    {
      m_idExterneEmployeurSp = p_idExterneEmployeurSp;
      ((CompetencePC)getPC()).setIdExterneEmployeurSp(p_idExterneEmployeurSp);
    }
    else if ((m_idExterneEmployeurSp != null) && (p_idExterneEmployeurSp != null) && (!p_idExterneEmployeurSp.equals(m_idExterneEmployeurSp)))
    {
      m_idExterneEmployeurSp = p_idExterneEmployeurSp;
      ((CompetencePC)getPC()).setIdExterneEmployeurSp(p_idExterneEmployeurSp);
    }
  }
  
  protected boolean rawIsEstPCRCForce()
  {
    return ((CompetencePC)getPC()).isEstPCRCForce();
  }
  
  public boolean isEstPCRCForce()
  {
    return ((CompetencePC)getPC()).isEstPCRCForce();
  }
  
  public void setEstPCRCForce(boolean p_estPCRCForce)
  {
    ((CompetencePC)getPC()).setEstPCRCForce(p_estPCRCForce);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     CompetenceGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */