package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class ConditionQuantiteAffiliationGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionsAttributionAbstraitPC;
  private Quantite m_quantiteAppartenance;
  private Quantite m_quantiteAppartenanceSecondaire;
  private String m_etatPndsPourCalculAffi;
  
  public ConditionQuantiteAffiliationGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionQuantiteAffiliationGen() {}
  
  public DomPCSpec getPC()
  {
    return m_conditionsAttributionAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionsAttributionAbstraitPC)
  {
    m_conditionsAttributionAbstraitPC = p_conditionsAttributionAbstraitPC;
  }
  
  protected int rawGetEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionQuantiteAffiliation();
  }
  
  public int getEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionQuantiteAffiliation();
  }
  
  public void setEtat(int p_etat)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setEtatConditionQuantiteAffiliation(p_etat);
  }
  
  protected int rawGetCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionQuantiteAffiliation();
  }
  
  public int getCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionQuantiteAffiliation();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCodeMotifEchecConditionQuantiteAffiliation(p_codeMotifEchec);
  }
  
  protected Quantite rawGetQuantiteAppartenance()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getQuantiteAppartenanceConditionQuantiteAffiliation();
  }
  
  public Quantite getQuantiteAppartenance()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getQuantiteAppartenanceConditionQuantiteAffiliation();
  }
  
  public void setQuantiteAppartenance(Quantite p_quantiteAppartenance)
  {
    if ((m_quantiteAppartenance == null) || (p_quantiteAppartenance == null))
    {
      m_quantiteAppartenance = p_quantiteAppartenance;
      ((ConditionsAttributionAbstraitPC)getPC()).setQuantiteAppartenanceConditionQuantiteAffiliation(p_quantiteAppartenance);
    }
    else if ((m_quantiteAppartenance != null) && (p_quantiteAppartenance != null) && (!p_quantiteAppartenance.equals(m_quantiteAppartenance)))
    {
      m_quantiteAppartenance = p_quantiteAppartenance;
      ((ConditionsAttributionAbstraitPC)getPC()).setQuantiteAppartenanceConditionQuantiteAffiliation(p_quantiteAppartenance);
    }
  }
  
  protected Quantite rawGetQuantiteAppartenanceSecondaire()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getQuantiteAppartenanceSecondaireConditionQuantiteAffiliation();
  }
  
  public Quantite getQuantiteAppartenanceSecondaire()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getQuantiteAppartenanceSecondaireConditionQuantiteAffiliation();
  }
  
  public void setQuantiteAppartenanceSecondaire(Quantite p_quantiteAppartenanceSecondaire)
  {
    if ((m_quantiteAppartenanceSecondaire == null) || (p_quantiteAppartenanceSecondaire == null))
    {
      m_quantiteAppartenanceSecondaire = p_quantiteAppartenanceSecondaire;
      ((ConditionsAttributionAbstraitPC)getPC()).setQuantiteAppartenanceSecondaireConditionQuantiteAffiliation(p_quantiteAppartenanceSecondaire);
    }
    else if ((m_quantiteAppartenanceSecondaire != null) && (p_quantiteAppartenanceSecondaire != null) && (!p_quantiteAppartenanceSecondaire.equals(m_quantiteAppartenanceSecondaire)))
    {
      m_quantiteAppartenanceSecondaire = p_quantiteAppartenanceSecondaire;
      ((ConditionsAttributionAbstraitPC)getPC()).setQuantiteAppartenanceSecondaireConditionQuantiteAffiliation(p_quantiteAppartenanceSecondaire);
    }
  }
  
  protected String rawGetEtatPndsPourCalculAffi()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatPndsPourCalculAffi();
  }
  
  public String getEtatPndsPourCalculAffi()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatPndsPourCalculAffi();
  }
  
  public void setEtatPndsPourCalculAffi(String p_etatPndsPourCalculAffi)
  {
    if ((m_etatPndsPourCalculAffi == null) || (p_etatPndsPourCalculAffi == null))
    {
      m_etatPndsPourCalculAffi = p_etatPndsPourCalculAffi;
      ((ConditionsAttributionAbstraitPC)getPC()).setEtatPndsPourCalculAffi(p_etatPndsPourCalculAffi);
    }
    else if ((m_etatPndsPourCalculAffi != null) && (p_etatPndsPourCalculAffi != null) && (!p_etatPndsPourCalculAffi.equals(m_etatPndsPourCalculAffi)))
    {
      m_etatPndsPourCalculAffi = p_etatPndsPourCalculAffi;
      ((ConditionsAttributionAbstraitPC)getPC()).setEtatPndsPourCalculAffi(p_etatPndsPourCalculAffi);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setEtat(0);
    setCodeMotifEchec(0);
    setQuantiteAppartenance(null);
    setQuantiteAppartenanceSecondaire(null);
    setEtatPndsPourCalculAffi(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionQuantiteAffiliationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */