package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.PensionInvaliditeChainee;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class ConstitutionMontantsBrutsGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Quantite m_montantJournalierBrut;
  private Quantite m_capitalInitialBrut;
  private Quantite m_montantMini;
  private Quantite m_montantPlancher;
  private Quantite m_montantPlafond;
  private Quantite m_montantBase;
  private Quantite m_pensionInvaliditeADeduirePriseEnCompte;
  private Quantite m_montantBrutSansPensionInvaliditeADeduire;
  private Quantite m_montantJournalierAvantageVieillesse;
  private Quantite m_montantJournalierAvantageVieillesseDeduit;
  private Quantite m_crc = null;
  private Quantite m_montantJournalierPreavis;
  private BigDecimal m_quatreVingtSjr;
  private BigDecimal m_quatreVingtMontantPreavis;
  private BigDecimal m_miniAREF;
  private String m_typeMontantRetenuDroitCourant;
  private Quantite m_montantDroitAssocie;
  private BigDecimal m_sjrMontantMaxAsp;
  private Collection m_listePensionInvalidite;
  
  public ConstitutionMontantsBrutsGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionMontantsBrutsGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected Quantite rawGetMontantJournalierBrut()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierBrutConstitutionMontantsBruts();
  }
  
  public Quantite getMontantJournalierBrut()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierBrutConstitutionMontantsBruts();
  }
  
  public void setMontantJournalierBrut(Quantite p_montantJournalierBrut)
  {
    if ((m_montantJournalierBrut == null) || (p_montantJournalierBrut == null))
    {
      m_montantJournalierBrut = p_montantJournalierBrut;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierBrutConstitutionMontantsBruts(p_montantJournalierBrut);
    }
    else if ((m_montantJournalierBrut != null) && (p_montantJournalierBrut != null) && (!p_montantJournalierBrut.equals(m_montantJournalierBrut)))
    {
      m_montantJournalierBrut = p_montantJournalierBrut;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierBrutConstitutionMontantsBruts(p_montantJournalierBrut);
    }
  }
  
  protected Quantite rawGetCapitalInitialBrut()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalInitialBrutConstitutionMontantsBruts();
  }
  
  public Quantite getCapitalInitialBrut()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalInitialBrutConstitutionMontantsBruts();
  }
  
  public void setCapitalInitialBrut(Quantite p_capitalInitialBrut)
  {
    if ((m_capitalInitialBrut == null) || (p_capitalInitialBrut == null))
    {
      m_capitalInitialBrut = p_capitalInitialBrut;
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalInitialBrutConstitutionMontantsBruts(p_capitalInitialBrut);
    }
    else if ((m_capitalInitialBrut != null) && (p_capitalInitialBrut != null) && (!p_capitalInitialBrut.equals(m_capitalInitialBrut)))
    {
      m_capitalInitialBrut = p_capitalInitialBrut;
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalInitialBrutConstitutionMontantsBruts(p_capitalInitialBrut);
    }
  }
  
  protected Quantite rawGetMontantMini()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantMiniConstitutionMontantsBruts();
  }
  
  public Quantite getMontantMini()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantMiniConstitutionMontantsBruts();
  }
  
  public void setMontantMini(Quantite p_montantMini)
  {
    if ((m_montantMini == null) || (p_montantMini == null))
    {
      m_montantMini = p_montantMini;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantMiniConstitutionMontantsBruts(p_montantMini);
    }
    else if ((m_montantMini != null) && (p_montantMini != null) && (!p_montantMini.equals(m_montantMini)))
    {
      m_montantMini = p_montantMini;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantMiniConstitutionMontantsBruts(p_montantMini);
    }
  }
  
  protected Quantite rawGetMontantPlancher()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlancherConstitutionMontantsBruts();
  }
  
  public Quantite getMontantPlancher()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlancherConstitutionMontantsBruts();
  }
  
  public void setMontantPlancher(Quantite p_montantPlancher)
  {
    if ((m_montantPlancher == null) || (p_montantPlancher == null))
    {
      m_montantPlancher = p_montantPlancher;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlancherConstitutionMontantsBruts(p_montantPlancher);
    }
    else if ((m_montantPlancher != null) && (p_montantPlancher != null) && (!p_montantPlancher.equals(m_montantPlancher)))
    {
      m_montantPlancher = p_montantPlancher;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlancherConstitutionMontantsBruts(p_montantPlancher);
    }
  }
  
  protected Quantite rawGetMontantPlafond()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlafondConstitutionMontantsBruts();
  }
  
  public Quantite getMontantPlafond()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlafondConstitutionMontantsBruts();
  }
  
  public void setMontantPlafond(Quantite p_montantPlafond)
  {
    if ((m_montantPlafond == null) || (p_montantPlafond == null))
    {
      m_montantPlafond = p_montantPlafond;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlafondConstitutionMontantsBruts(p_montantPlafond);
    }
    else if ((m_montantPlafond != null) && (p_montantPlafond != null) && (!p_montantPlafond.equals(m_montantPlafond)))
    {
      m_montantPlafond = p_montantPlafond;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlafondConstitutionMontantsBruts(p_montantPlafond);
    }
  }
  
  protected Quantite rawGetMontantBase()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBaseConstitutionMontantsBruts();
  }
  
  public Quantite getMontantBase()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBaseConstitutionMontantsBruts();
  }
  
  public void setMontantBase(Quantite p_montantBase)
  {
    if ((m_montantBase == null) || (p_montantBase == null))
    {
      m_montantBase = p_montantBase;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBaseConstitutionMontantsBruts(p_montantBase);
    }
    else if ((m_montantBase != null) && (p_montantBase != null) && (!p_montantBase.equals(m_montantBase)))
    {
      m_montantBase = p_montantBase;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBaseConstitutionMontantsBruts(p_montantBase);
    }
  }
  
  protected Quantite rawGetPensionInvaliditeADeduirePriseEnCompte()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPensionInvaliditeADeduirePriseEnCompteConstitutionMontantsBruts();
  }
  
  public Quantite getPensionInvaliditeADeduirePriseEnCompte()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPensionInvaliditeADeduirePriseEnCompteConstitutionMontantsBruts();
  }
  
  public void setPensionInvaliditeADeduirePriseEnCompte(Quantite p_pensionInvaliditeADeduirePriseEnCompte)
  {
    if ((m_pensionInvaliditeADeduirePriseEnCompte == null) || (p_pensionInvaliditeADeduirePriseEnCompte == null))
    {
      m_pensionInvaliditeADeduirePriseEnCompte = p_pensionInvaliditeADeduirePriseEnCompte;
      ((ConstitutionElementsAbstraitPC)getPC()).setPensionInvaliditeADeduirePriseEnCompteConstitutionMontantsBruts(p_pensionInvaliditeADeduirePriseEnCompte);
    }
    else if ((m_pensionInvaliditeADeduirePriseEnCompte != null) && (p_pensionInvaliditeADeduirePriseEnCompte != null) && (!p_pensionInvaliditeADeduirePriseEnCompte.equals(m_pensionInvaliditeADeduirePriseEnCompte)))
    {
      m_pensionInvaliditeADeduirePriseEnCompte = p_pensionInvaliditeADeduirePriseEnCompte;
      ((ConstitutionElementsAbstraitPC)getPC()).setPensionInvaliditeADeduirePriseEnCompteConstitutionMontantsBruts(p_pensionInvaliditeADeduirePriseEnCompte);
    }
  }
  
  protected Quantite rawGetMontantBrutSansPensionInvaliditeADeduire()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBrutSansPensionInvaliditeADeduireConstitutionMontantsBruts();
  }
  
  public Quantite getMontantBrutSansPensionInvaliditeADeduire()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBrutSansPensionInvaliditeADeduireConstitutionMontantsBruts();
  }
  
  public void setMontantBrutSansPensionInvaliditeADeduire(Quantite p_montantBrutSansPensionInvaliditeADeduire)
  {
    if ((m_montantBrutSansPensionInvaliditeADeduire == null) || (p_montantBrutSansPensionInvaliditeADeduire == null))
    {
      m_montantBrutSansPensionInvaliditeADeduire = p_montantBrutSansPensionInvaliditeADeduire;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBrutSansPensionInvaliditeADeduireConstitutionMontantsBruts(p_montantBrutSansPensionInvaliditeADeduire);
    }
    else if ((m_montantBrutSansPensionInvaliditeADeduire != null) && (p_montantBrutSansPensionInvaliditeADeduire != null) && (!p_montantBrutSansPensionInvaliditeADeduire.equals(m_montantBrutSansPensionInvaliditeADeduire)))
    {
      m_montantBrutSansPensionInvaliditeADeduire = p_montantBrutSansPensionInvaliditeADeduire;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBrutSansPensionInvaliditeADeduireConstitutionMontantsBruts(p_montantBrutSansPensionInvaliditeADeduire);
    }
  }
  
  protected Quantite rawGetMontantJournalierAvantageVieillesse()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseConstitutionMontantsBruts();
  }
  
  public Quantite getMontantJournalierAvantageVieillesse()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseConstitutionMontantsBruts();
  }
  
  public void setMontantJournalierAvantageVieillesse(Quantite p_montantJournalierAvantageVieillesse)
  {
    if ((m_montantJournalierAvantageVieillesse == null) || (p_montantJournalierAvantageVieillesse == null))
    {
      m_montantJournalierAvantageVieillesse = p_montantJournalierAvantageVieillesse;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseConstitutionMontantsBruts(p_montantJournalierAvantageVieillesse);
    }
    else if ((m_montantJournalierAvantageVieillesse != null) && (p_montantJournalierAvantageVieillesse != null) && (!p_montantJournalierAvantageVieillesse.equals(m_montantJournalierAvantageVieillesse)))
    {
      m_montantJournalierAvantageVieillesse = p_montantJournalierAvantageVieillesse;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseConstitutionMontantsBruts(p_montantJournalierAvantageVieillesse);
    }
  }
  
  protected Quantite rawGetMontantJournalierAvantageVieillesseDeduit()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseDeduitConstitutionMontantsBruts();
  }
  
  public Quantite getMontantJournalierAvantageVieillesseDeduit()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseDeduitConstitutionMontantsBruts();
  }
  
  public void setMontantJournalierAvantageVieillesseDeduit(Quantite p_montantJournalierAvantageVieillesseDeduit)
  {
    if ((m_montantJournalierAvantageVieillesseDeduit == null) || (p_montantJournalierAvantageVieillesseDeduit == null))
    {
      m_montantJournalierAvantageVieillesseDeduit = p_montantJournalierAvantageVieillesseDeduit;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseDeduitConstitutionMontantsBruts(p_montantJournalierAvantageVieillesseDeduit);
    }
    else if ((m_montantJournalierAvantageVieillesseDeduit != null) && (p_montantJournalierAvantageVieillesseDeduit != null) && (!p_montantJournalierAvantageVieillesseDeduit.equals(m_montantJournalierAvantageVieillesseDeduit)))
    {
      m_montantJournalierAvantageVieillesseDeduit = p_montantJournalierAvantageVieillesseDeduit;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseDeduitConstitutionMontantsBruts(p_montantJournalierAvantageVieillesseDeduit);
    }
  }
  
  protected Quantite rawGetCrc()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCrcConstitutionMontantsBruts();
  }
  
  public Quantite getCrc()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCrcConstitutionMontantsBruts();
  }
  
  public void setCrc(Quantite p_crc)
  {
    if ((m_crc == null) || (p_crc == null))
    {
      m_crc = p_crc;
      ((ConstitutionElementsAbstraitPC)getPC()).setCrcConstitutionMontantsBruts(p_crc);
    }
    else if ((m_crc != null) && (p_crc != null) && (!p_crc.equals(m_crc)))
    {
      m_crc = p_crc;
      ((ConstitutionElementsAbstraitPC)getPC()).setCrcConstitutionMontantsBruts(p_crc);
    }
  }
  
  protected Quantite rawGetMontantJournalierPreavis()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierPreavis();
  }
  
  public Quantite getMontantJournalierPreavis()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierPreavis();
  }
  
  public void setMontantJournalierPreavis(Quantite p_montantJournalierPreavis)
  {
    if ((m_montantJournalierPreavis == null) || (p_montantJournalierPreavis == null))
    {
      m_montantJournalierPreavis = p_montantJournalierPreavis;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierPreavis(p_montantJournalierPreavis);
    }
    else if ((m_montantJournalierPreavis != null) && (p_montantJournalierPreavis != null) && (!p_montantJournalierPreavis.equals(m_montantJournalierPreavis)))
    {
      m_montantJournalierPreavis = p_montantJournalierPreavis;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierPreavis(p_montantJournalierPreavis);
    }
  }
  
  protected BigDecimal rawGetQuatreVingtSjr()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuatreVingtSjr();
  }
  
  public BigDecimal getQuatreVingtSjr()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuatreVingtSjr();
  }
  
  public void setQuatreVingtSjr(BigDecimal p_quatreVingtSjr)
  {
    if ((m_quatreVingtSjr == null) || (p_quatreVingtSjr == null))
    {
      m_quatreVingtSjr = p_quatreVingtSjr;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuatreVingtSjr(p_quatreVingtSjr);
    }
    else if ((m_quatreVingtSjr != null) && (p_quatreVingtSjr != null) && (!p_quatreVingtSjr.equals(m_quatreVingtSjr)))
    {
      m_quatreVingtSjr = p_quatreVingtSjr;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuatreVingtSjr(p_quatreVingtSjr);
    }
  }
  
  protected BigDecimal rawGetQuatreVingtMontantPreavis()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuatreVingtMontantPreavis();
  }
  
  public BigDecimal getQuatreVingtMontantPreavis()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuatreVingtMontantPreavis();
  }
  
  public void setQuatreVingtMontantPreavis(BigDecimal p_quatreVingtMontantPreavis)
  {
    if ((m_quatreVingtMontantPreavis == null) || (p_quatreVingtMontantPreavis == null))
    {
      m_quatreVingtMontantPreavis = p_quatreVingtMontantPreavis;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuatreVingtMontantPreavis(p_quatreVingtMontantPreavis);
    }
    else if ((m_quatreVingtMontantPreavis != null) && (p_quatreVingtMontantPreavis != null) && (!p_quatreVingtMontantPreavis.equals(m_quatreVingtMontantPreavis)))
    {
      m_quatreVingtMontantPreavis = p_quatreVingtMontantPreavis;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuatreVingtMontantPreavis(p_quatreVingtMontantPreavis);
    }
  }
  
  protected BigDecimal rawGetMiniAREF()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMiniAREF();
  }
  
  public BigDecimal getMiniAREF()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMiniAREF();
  }
  
  public void setMiniAREF(BigDecimal p_miniAREF)
  {
    if ((m_miniAREF == null) || (p_miniAREF == null))
    {
      m_miniAREF = p_miniAREF;
      ((ConstitutionElementsAbstraitPC)getPC()).setMiniAREF(p_miniAREF);
    }
    else if ((m_miniAREF != null) && (p_miniAREF != null) && (!p_miniAREF.equals(m_miniAREF)))
    {
      m_miniAREF = p_miniAREF;
      ((ConstitutionElementsAbstraitPC)getPC()).setMiniAREF(p_miniAREF);
    }
  }
  
  protected String rawGetTypeMontantRetenuDroitCourant()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeMontantRetenuConstitutionMontantsBruts();
  }
  
  public String getTypeMontantRetenuDroitCourant()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeMontantRetenuConstitutionMontantsBruts();
  }
  
  public void setTypeMontantRetenuDroitCourant(String p_typeMontantRetenuDroitCourant)
  {
    if ((m_typeMontantRetenuDroitCourant == null) || (p_typeMontantRetenuDroitCourant == null))
    {
      m_typeMontantRetenuDroitCourant = p_typeMontantRetenuDroitCourant;
      ((ConstitutionElementsAbstraitPC)getPC()).setTypeMontantRetenuConstitutionMontantsBruts(p_typeMontantRetenuDroitCourant);
    }
    else if ((m_typeMontantRetenuDroitCourant != null) && (p_typeMontantRetenuDroitCourant != null) && (!p_typeMontantRetenuDroitCourant.equals(m_typeMontantRetenuDroitCourant)))
    {
      m_typeMontantRetenuDroitCourant = p_typeMontantRetenuDroitCourant;
      ((ConstitutionElementsAbstraitPC)getPC()).setTypeMontantRetenuConstitutionMontantsBruts(p_typeMontantRetenuDroitCourant);
    }
  }
  
  protected Quantite rawGetMontantDroitAssocie()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantDroitAssocieConstitutionMontantsBruts();
  }
  
  public Quantite getMontantDroitAssocie()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantDroitAssocieConstitutionMontantsBruts();
  }
  
  public void setMontantDroitAssocie(Quantite p_montantDroitAssocie)
  {
    if ((m_montantDroitAssocie == null) || (p_montantDroitAssocie == null))
    {
      m_montantDroitAssocie = p_montantDroitAssocie;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantDroitAssocieConstitutionMontantsBruts(p_montantDroitAssocie);
    }
    else if ((m_montantDroitAssocie != null) && (p_montantDroitAssocie != null) && (!p_montantDroitAssocie.equals(m_montantDroitAssocie)))
    {
      m_montantDroitAssocie = p_montantDroitAssocie;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantDroitAssocieConstitutionMontantsBruts(p_montantDroitAssocie);
    }
  }
  
  protected BigDecimal rawGetSjrMontantMaxAsp()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrMontantMaxAspConstitutionMontantsBruts();
  }
  
  public BigDecimal getSjrMontantMaxAsp()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrMontantMaxAspConstitutionMontantsBruts();
  }
  
  public void setSjrMontantMaxAsp(BigDecimal p_sjrMontantMaxAsp)
  {
    if ((m_sjrMontantMaxAsp == null) || (p_sjrMontantMaxAsp == null))
    {
      m_sjrMontantMaxAsp = p_sjrMontantMaxAsp;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrMontantMaxAspConstitutionMontantsBruts(p_sjrMontantMaxAsp);
    }
    else if ((m_sjrMontantMaxAsp != null) && (p_sjrMontantMaxAsp != null) && (!p_sjrMontantMaxAsp.equals(m_sjrMontantMaxAsp)))
    {
      m_sjrMontantMaxAsp = p_sjrMontantMaxAsp;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrMontantMaxAspConstitutionMontantsBruts(p_sjrMontantMaxAsp);
    }
  }
  
  private final Collection getCollectionModifiableMontantBrutPensionInvalidite()
  {
    Iterator itCollectionPC;
    if (m_listePensionInvalidite == null)
    {
      m_listePensionInvalidite = new ArrayList();
      for (itCollectionPC = ((ConstitutionElementsAbstraitPC)getPC()).getCollectionMontantBrutPensionInvalidite().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listePensionInvalidite.add(currentOM);
      }
    }
    return m_listePensionInvalidite;
  }
  
  public Collection getCollectionMontantBrutPensionInvalidite()
  {
    return Collections.unmodifiableCollection(getCollectionModifiableMontantBrutPensionInvalidite());
  }
  
  public List getListMontantBrutPensionInvalidite()
  {
    return Collections.unmodifiableList((List)getCollectionModifiableMontantBrutPensionInvalidite());
  }
  
  public void remplacerCollectionMontantBrutPensionInvalidite(Collection p_collectionACopier)
  {
    clearCollectionMontantBrutPensionInvalidite();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      PensionInvaliditeChainee objet = (PensionInvaliditeChainee)i.next();
      ajouterMontantBrutPensionInvalidite(objet);
    }
  }
  
  public void supprimerSousCollectionMontantBrutPensionInvalidite(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      PensionInvaliditeChainee objet = (PensionInvaliditeChainee)i.next();
      supprimerMontantBrutPensionInvalidite(objet);
    }
  }
  
  public void ajouterMontantBrutPensionInvalidite(PensionInvaliditeChainee p_pensionInvaliditeMontantBrut)
    throws NullPointerException
  {
    if (p_pensionInvaliditeMontantBrut == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_pensionInvaliditeMontantBrut ne devrait pas être nul.", p_pensionInvaliditeMontantBrut);
    }
    getCollectionModifiableMontantBrutPensionInvalidite().add(p_pensionInvaliditeMontantBrut);
    ((ConstitutionElementsAbstraitPC)getPC()).ajouterMontantBrutPensionInvalidite(p_pensionInvaliditeMontantBrut.getPC());
  }
  
  public void supprimerMontantBrutPensionInvalidite(PensionInvaliditeChainee p_pensionInvaliditeMontantBrut)
    throws NullPointerException
  {
    if (p_pensionInvaliditeMontantBrut == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_pensionInvaliditeMontantBrut ne devrait pas être nul.", p_pensionInvaliditeMontantBrut);
    }
    getCollectionModifiableMontantBrutPensionInvalidite().remove(p_pensionInvaliditeMontantBrut);
    ((ConstitutionElementsAbstraitPC)getPC()).supprimerMontantBrutPensionInvalidite(p_pensionInvaliditeMontantBrut.getPC());
  }
  
  public void recopierCollectionMontantBrutPensionInvaliditeVers(ObjetMetierSpec p_copie)
  {
    ConstitutionMontantsBrutsGen copie = (ConstitutionMontantsBrutsGen)p_copie;
    Collection listeACopier = getCollectionMontantBrutPensionInvalidite();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterMontantBrutPensionInvalidite((PensionInvaliditeChainee)objet);
    }
  }
  
  public void clearCollectionMontantBrutPensionInvalidite()
  {
    getCollectionModifiableMontantBrutPensionInvalidite().clear();
    ((ConstitutionElementsAbstraitPC)getPC()).getCollectionMontantBrutPensionInvalidite().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionMontantBrutPensionInvalidite().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setMontantJournalierBrut(null);
    setCapitalInitialBrut(null);
    setMontantMini(null);
    setMontantPlancher(null);
    setMontantPlafond(null);
    setMontantBase(null);
    setPensionInvaliditeADeduirePriseEnCompte(null);
    setMontantBrutSansPensionInvaliditeADeduire(null);
    setMontantJournalierAvantageVieillesse(null);
    setMontantJournalierAvantageVieillesseDeduit(null);
    setCrc(null);
    setMontantJournalierPreavis(null);
    setQuatreVingtSjr(null);
    setQuatreVingtMontantPreavis(null);
    setMiniAREF(null);
    setTypeMontantRetenuDroitCourant(null);
    setMontantDroitAssocie(null);
    setSjrMontantMaxAsp(null);
    for (Iterator iter = getCollectionMontantBrutPensionInvalidite().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if (item != null) {
        DomManager.supprimer(item);
      }
    }
    clearCollectionMontantBrutPensionInvalidite();
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionMontantsBrutsGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */