package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.PensionInvaliditeChainee;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationDroitResultant;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class ConstitutionProduitResultantGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Quantite m_montantDroitPrecedent;
  private Quantite m_capitalDroitPrecedent;
  private Quantite m_dureeDroitPrecedent;
  private Quantite m_capitalMax;
  private Quantite m_dureeTheorique;
  private Quantite m_dureeImputation;
  private Quantite m_dureeEffective;
  private Sjr m_sjrrpProduitPrecedent;
  private Quantite m_crc;
  private Quantite m_montantJournalierBrut;
  private Quantite m_pensionInvaliditeADeduirePriseEnCompte;
  private Quantite m_montantJournalierAvantageVieillesseDeduit;
  private JustificationDroitResultant m_justificationDroitResultant = null;
  private Collection m_listePensionInvalidite;
  
  public ConstitutionProduitResultantGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionProduitResultantGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected int rawGetTypeMontantRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeMontantRetenuConstitutionProduitResultant();
  }
  
  public int getTypeMontantRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeMontantRetenuConstitutionProduitResultant();
  }
  
  public void setTypeMontantRetenu(int p_typeMontantRetenu)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setTypeMontantRetenuConstitutionProduitResultant(p_typeMontantRetenu);
  }
  
  protected int rawGetTypeCapitalRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeCapitalRetenuConstitutionProduitResultant();
  }
  
  public int getTypeCapitalRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeCapitalRetenuConstitutionProduitResultant();
  }
  
  public void setTypeCapitalRetenu(int p_typeCapitalRetenu)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setTypeCapitalRetenuConstitutionProduitResultant(p_typeCapitalRetenu);
  }
  
  protected Quantite rawGetMontantDroitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantDroitPrecedentConstitutionProduitResultant();
  }
  
  public Quantite getMontantDroitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantDroitPrecedentConstitutionProduitResultant();
  }
  
  public void setMontantDroitPrecedent(Quantite p_montantDroitPrecedent)
  {
    if ((m_montantDroitPrecedent == null) || (p_montantDroitPrecedent == null))
    {
      m_montantDroitPrecedent = p_montantDroitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantDroitPrecedentConstitutionProduitResultant(p_montantDroitPrecedent);
    }
    else if ((m_montantDroitPrecedent != null) && (p_montantDroitPrecedent != null) && (!p_montantDroitPrecedent.equals(m_montantDroitPrecedent)))
    {
      m_montantDroitPrecedent = p_montantDroitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantDroitPrecedentConstitutionProduitResultant(p_montantDroitPrecedent);
    }
  }
  
  protected Quantite rawGetCapitalDroitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalDroitPrecedentConstitutionProduitResultant();
  }
  
  public Quantite getCapitalDroitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalDroitPrecedentConstitutionProduitResultant();
  }
  
  public void setCapitalDroitPrecedent(Quantite p_capitalDroitPrecedent)
  {
    if ((m_capitalDroitPrecedent == null) || (p_capitalDroitPrecedent == null))
    {
      m_capitalDroitPrecedent = p_capitalDroitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalDroitPrecedentConstitutionProduitResultant(p_capitalDroitPrecedent);
    }
    else if ((m_capitalDroitPrecedent != null) && (p_capitalDroitPrecedent != null) && (!p_capitalDroitPrecedent.equals(m_capitalDroitPrecedent)))
    {
      m_capitalDroitPrecedent = p_capitalDroitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalDroitPrecedentConstitutionProduitResultant(p_capitalDroitPrecedent);
    }
  }
  
  protected Quantite rawGetDureeDroitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeDroitPrecedentConstitutionProduitResultant();
  }
  
  public Quantite getDureeDroitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeDroitPrecedentConstitutionProduitResultant();
  }
  
  public void setDureeDroitPrecedent(Quantite p_dureeDroitPrecedent)
  {
    if ((m_dureeDroitPrecedent == null) || (p_dureeDroitPrecedent == null))
    {
      m_dureeDroitPrecedent = p_dureeDroitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeDroitPrecedentConstitutionProduitResultant(p_dureeDroitPrecedent);
    }
    else if ((m_dureeDroitPrecedent != null) && (p_dureeDroitPrecedent != null) && (!p_dureeDroitPrecedent.equals(m_dureeDroitPrecedent)))
    {
      m_dureeDroitPrecedent = p_dureeDroitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeDroitPrecedentConstitutionProduitResultant(p_dureeDroitPrecedent);
    }
  }
  
  protected Quantite rawGetCapitalMax()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalMaxConstitutionProduitResultant();
  }
  
  public Quantite getCapitalMax()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalMaxConstitutionProduitResultant();
  }
  
  public void setCapitalMax(Quantite p_capitalMax)
  {
    if ((m_capitalMax == null) || (p_capitalMax == null))
    {
      m_capitalMax = p_capitalMax;
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalMaxConstitutionProduitResultant(p_capitalMax);
    }
    else if ((m_capitalMax != null) && (p_capitalMax != null) && (!p_capitalMax.equals(m_capitalMax)))
    {
      m_capitalMax = p_capitalMax;
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalMaxConstitutionProduitResultant(p_capitalMax);
    }
  }
  
  protected Quantite rawGetDureeTheorique()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeTheoriqueConstitutionProduitResultant();
  }
  
  public Quantite getDureeTheorique()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeTheoriqueConstitutionProduitResultant();
  }
  
  public void setDureeTheorique(Quantite p_dureeTheorique)
  {
    if ((m_dureeTheorique == null) || (p_dureeTheorique == null))
    {
      m_dureeTheorique = p_dureeTheorique;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeTheoriqueConstitutionProduitResultant(p_dureeTheorique);
    }
    else if ((m_dureeTheorique != null) && (p_dureeTheorique != null) && (!p_dureeTheorique.equals(m_dureeTheorique)))
    {
      m_dureeTheorique = p_dureeTheorique;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeTheoriqueConstitutionProduitResultant(p_dureeTheorique);
    }
  }
  
  protected Quantite rawGetDureeImputation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeImputationConstitutionProduitResultant();
  }
  
  public Quantite getDureeImputation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeImputationConstitutionProduitResultant();
  }
  
  public void setDureeImputation(Quantite p_dureeImputation)
  {
    if ((m_dureeImputation == null) || (p_dureeImputation == null))
    {
      m_dureeImputation = p_dureeImputation;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeImputationConstitutionProduitResultant(p_dureeImputation);
    }
    else if ((m_dureeImputation != null) && (p_dureeImputation != null) && (!p_dureeImputation.equals(m_dureeImputation)))
    {
      m_dureeImputation = p_dureeImputation;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeImputationConstitutionProduitResultant(p_dureeImputation);
    }
  }
  
  protected Quantite rawGetDureeEffective()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeEffectiveConstitutionProduitResultant();
  }
  
  public Quantite getDureeEffective()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeEffectiveConstitutionProduitResultant();
  }
  
  public void setDureeEffective(Quantite p_dureeEffective)
  {
    if ((m_dureeEffective == null) || (p_dureeEffective == null))
    {
      m_dureeEffective = p_dureeEffective;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeEffectiveConstitutionProduitResultant(p_dureeEffective);
    }
    else if ((m_dureeEffective != null) && (p_dureeEffective != null) && (!p_dureeEffective.equals(m_dureeEffective)))
    {
      m_dureeEffective = p_dureeEffective;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeEffectiveConstitutionProduitResultant(p_dureeEffective);
    }
  }
  
  protected Sjr rawGetSjrrpProduitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrrpProduitPrecedentConstitutionProduitResultant();
  }
  
  public Sjr getSjrrpProduitPrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrrpProduitPrecedentConstitutionProduitResultant();
  }
  
  public void setSjrrpProduitPrecedent(Sjr p_sjrrpProduitPrecedent)
  {
    if ((m_sjrrpProduitPrecedent == null) || (p_sjrrpProduitPrecedent == null))
    {
      m_sjrrpProduitPrecedent = p_sjrrpProduitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrrpProduitPrecedentConstitutionProduitResultant(p_sjrrpProduitPrecedent);
    }
    else if ((m_sjrrpProduitPrecedent != null) && (p_sjrrpProduitPrecedent != null) && (!p_sjrrpProduitPrecedent.equals(m_sjrrpProduitPrecedent)))
    {
      m_sjrrpProduitPrecedent = p_sjrrpProduitPrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrrpProduitPrecedentConstitutionProduitResultant(p_sjrrpProduitPrecedent);
    }
  }
  
  protected Quantite rawGetCrc()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCrcConstitutionProduitResultant();
  }
  
  public Quantite getCrc()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCrcConstitutionProduitResultant();
  }
  
  public void setCrc(Quantite p_crc)
  {
    if ((m_crc == null) || (p_crc == null))
    {
      m_crc = p_crc;
      ((ConstitutionElementsAbstraitPC)getPC()).setCrcConstitutionProduitResultant(p_crc);
    }
    else if ((m_crc != null) && (p_crc != null) && (!p_crc.equals(m_crc)))
    {
      m_crc = p_crc;
      ((ConstitutionElementsAbstraitPC)getPC()).setCrcConstitutionProduitResultant(p_crc);
    }
  }
  
  protected Quantite rawGetMontantJournalierBrut()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierBrutConstitutionProduitResultant();
  }
  
  public Quantite getMontantJournalierBrut()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierBrutConstitutionProduitResultant();
  }
  
  public void setMontantJournalierBrut(Quantite p_montantJournalierBrut)
  {
    if ((m_montantJournalierBrut == null) || (p_montantJournalierBrut == null))
    {
      m_montantJournalierBrut = p_montantJournalierBrut;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierBrutConstitutionProduitResultant(p_montantJournalierBrut);
    }
    else if ((m_montantJournalierBrut != null) && (p_montantJournalierBrut != null) && (!p_montantJournalierBrut.equals(m_montantJournalierBrut)))
    {
      m_montantJournalierBrut = p_montantJournalierBrut;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierBrutConstitutionProduitResultant(p_montantJournalierBrut);
    }
  }
  
  protected Quantite rawGetPensionInvaliditeADeduirePriseEnCompte()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPensionInvaliditeADeduirePriseEnCompteConstitutionProduitResultant();
  }
  
  public Quantite getPensionInvaliditeADeduirePriseEnCompte()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPensionInvaliditeADeduirePriseEnCompteConstitutionProduitResultant();
  }
  
  public void setPensionInvaliditeADeduirePriseEnCompte(Quantite p_pensionInvaliditeADeduirePriseEnCompte)
  {
    if ((m_pensionInvaliditeADeduirePriseEnCompte == null) || (p_pensionInvaliditeADeduirePriseEnCompte == null))
    {
      m_pensionInvaliditeADeduirePriseEnCompte = p_pensionInvaliditeADeduirePriseEnCompte;
      ((ConstitutionElementsAbstraitPC)getPC()).setPensionInvaliditeADeduirePriseEnCompteConstitutionProduitResultant(p_pensionInvaliditeADeduirePriseEnCompte);
    }
    else if ((m_pensionInvaliditeADeduirePriseEnCompte != null) && (p_pensionInvaliditeADeduirePriseEnCompte != null) && (!p_pensionInvaliditeADeduirePriseEnCompte.equals(m_pensionInvaliditeADeduirePriseEnCompte)))
    {
      m_pensionInvaliditeADeduirePriseEnCompte = p_pensionInvaliditeADeduirePriseEnCompte;
      ((ConstitutionElementsAbstraitPC)getPC()).setPensionInvaliditeADeduirePriseEnCompteConstitutionProduitResultant(p_pensionInvaliditeADeduirePriseEnCompte);
    }
  }
  
  protected Quantite rawGetMontantJournalierAvantageVieillesseDeduit()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseDeduitConstitutionProduitResultant();
  }
  
  public Quantite getMontantJournalierAvantageVieillesseDeduit()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseDeduitConstitutionProduitResultant();
  }
  
  public void setMontantJournalierAvantageVieillesseDeduit(Quantite p_montantJournalierAvantageVieillesseDeduit)
  {
    if ((m_montantJournalierAvantageVieillesseDeduit == null) || (p_montantJournalierAvantageVieillesseDeduit == null))
    {
      m_montantJournalierAvantageVieillesseDeduit = p_montantJournalierAvantageVieillesseDeduit;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseDeduitConstitutionProduitResultant(p_montantJournalierAvantageVieillesseDeduit);
    }
    else if ((m_montantJournalierAvantageVieillesseDeduit != null) && (p_montantJournalierAvantageVieillesseDeduit != null) && (!p_montantJournalierAvantageVieillesseDeduit.equals(m_montantJournalierAvantageVieillesseDeduit)))
    {
      m_montantJournalierAvantageVieillesseDeduit = p_montantJournalierAvantageVieillesseDeduit;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseDeduitConstitutionProduitResultant(p_montantJournalierAvantageVieillesseDeduit);
    }
  }
  
  public JustificationDroitResultant getJustificationDroitResultant()
  {
    if (m_justificationDroitResultant == null)
    {
      DomPCSpec justificationDroitResultantPC = ((ConstitutionElementsAbstraitPC)getPC()).getJustificationDroitResultant();
      if (justificationDroitResultantPC != null) {
        m_justificationDroitResultant = ((JustificationDroitResultant)justificationDroitResultantPC.createOM());
      }
    }
    return m_justificationDroitResultant;
  }
  
  public void setJustificationDroitResultant(JustificationDroitResultant p_justificationDroitResultant)
  {
    if (p_justificationDroitResultant == null)
    {
      ((ConstitutionElementsAbstraitPC)getPC()).setJustificationDroitResultant(null);
      m_justificationDroitResultant = p_justificationDroitResultant;
    }
    else if (!p_justificationDroitResultant.equals(m_justificationDroitResultant))
    {
      ((ConstitutionElementsAbstraitPC)getPC()).setJustificationDroitResultant(p_justificationDroitResultant.getPC());
      m_justificationDroitResultant = p_justificationDroitResultant;
    }
  }
  
  private final Collection getCollectionModifiableProduitResultantPensionInvalidite()
  {
    Iterator itCollectionPC;
    if (m_listePensionInvalidite == null)
    {
      m_listePensionInvalidite = new ArrayList();
      for (itCollectionPC = ((ConstitutionElementsAbstraitPC)getPC()).getCollectionProduitResultantPensionInvalidite().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listePensionInvalidite.add(currentOM);
      }
    }
    return m_listePensionInvalidite;
  }
  
  public Collection getCollectionProduitResultantPensionInvalidite()
  {
    return Collections.unmodifiableCollection(getCollectionModifiableProduitResultantPensionInvalidite());
  }
  
  public List getListProduitResultantPensionInvalidite()
  {
    return Collections.unmodifiableList((List)getCollectionModifiableProduitResultantPensionInvalidite());
  }
  
  public void remplacerCollectionProduitResultantPensionInvalidite(Collection p_collectionACopier)
  {
    clearCollectionProduitResultantPensionInvalidite();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      PensionInvaliditeChainee objet = (PensionInvaliditeChainee)i.next();
      ajouterProduitResultantPensionInvalidite(objet);
    }
  }
  
  public void supprimerSousCollectionProduitResultantPensionInvalidite(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      PensionInvaliditeChainee objet = (PensionInvaliditeChainee)i.next();
      supprimerProduitResultantPensionInvalidite(objet);
    }
  }
  
  public void ajouterProduitResultantPensionInvalidite(PensionInvaliditeChainee p_pensionInvaliditeProduitResultant)
    throws NullPointerException
  {
    if (p_pensionInvaliditeProduitResultant == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_pensionInvaliditeProduitResultant ne devrait pas être nul.", p_pensionInvaliditeProduitResultant);
    }
    getCollectionModifiableProduitResultantPensionInvalidite().add(p_pensionInvaliditeProduitResultant);
    ((ConstitutionElementsAbstraitPC)getPC()).ajouterProduitResultantPensionInvalidite(p_pensionInvaliditeProduitResultant.getPC());
  }
  
  public void supprimerProduitResultantPensionInvalidite(PensionInvaliditeChainee p_pensionInvaliditeProduitResultant)
    throws NullPointerException
  {
    if (p_pensionInvaliditeProduitResultant == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_pensionInvaliditeProduitResultant ne devrait pas être nul.", p_pensionInvaliditeProduitResultant);
    }
    getCollectionModifiableProduitResultantPensionInvalidite().remove(p_pensionInvaliditeProduitResultant);
    ((ConstitutionElementsAbstraitPC)getPC()).supprimerProduitResultantPensionInvalidite(p_pensionInvaliditeProduitResultant.getPC());
  }
  
  public void recopierCollectionProduitResultantPensionInvaliditeVers(ObjetMetierSpec p_copie)
  {
    ConstitutionProduitResultantGen copie = (ConstitutionProduitResultantGen)p_copie;
    Collection listeACopier = getCollectionProduitResultantPensionInvalidite();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterProduitResultantPensionInvalidite((PensionInvaliditeChainee)objet);
    }
  }
  
  public void clearCollectionProduitResultantPensionInvalidite()
  {
    getCollectionModifiableProduitResultantPensionInvalidite().clear();
    ((ConstitutionElementsAbstraitPC)getPC()).getCollectionProduitResultantPensionInvalidite().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object justificationDroitResultant = getJustificationDroitResultant();
    if ((justificationDroitResultant != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(justificationDroitResultant))) {
      DomManager.supprimer(getJustificationDroitResultant(), p_contexteSuppression);
    }
    for (Iterator iter = getCollectionProduitResultantPensionInvalidite().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    if (getJustificationDroitResultant() != null)
    {
      DomManager.supprimer(getJustificationDroitResultant());
      setJustificationDroitResultant(null);
    }
    setTypeMontantRetenu(0);
    setTypeCapitalRetenu(0);
    setMontantDroitPrecedent(null);
    setCapitalDroitPrecedent(null);
    setDureeDroitPrecedent(null);
    setCapitalMax(null);
    setDureeTheorique(null);
    setDureeImputation(null);
    setDureeEffective(null);
    setSjrrpProduitPrecedent(null);
    setCrc(null);
    setMontantJournalierBrut(null);
    setPensionInvaliditeADeduirePriseEnCompte(null);
    setMontantJournalierAvantageVieillesseDeduit(null);
    for (Iterator iter = getCollectionProduitResultantPensionInvalidite().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if (item != null) {
        DomManager.supprimer(item);
      }
    }
    clearCollectionProduitResultantPensionInvalidite();
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionProduitResultantGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */