package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.pc.PrcPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriodeCREM;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public abstract class PrcGen
  extends ObjetChronoPeriodeCREM
  implements DomGenSpec
{
  private Integer m_dureePrc = new Integer("0");
  private BigDecimal m_nombreJourAbsence = new BigDecimal("0");
  private BigDecimal m_diviseur = new BigDecimal("0");
  private Periode m_prip = null;
  private BigDecimal m_nombreHeuresTotal = new BigDecimal("0");
  private BigDecimal m_srip = new BigDecimal("0");
  private Integer m_nombreJourDeductible = new Integer("0");
  private Integer m_nombreJourInappartenance = new Integer("0");
  private BigDecimal m_nombreJourTravailEffectif = new BigDecimal("0");
  private BigDecimal m_nombreHeuresA4ouA5 = new BigDecimal("0");
  private BigDecimal m_droitCongesA4ouA5 = new BigDecimal("0");
  
  public PrcGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public PrcGen() {}
  
  public PrcGen(Damj p_dateDebut, Damj p_dateFin)
  {
    super(p_dateDebut, p_dateFin);
  }
  
  public PrcGen(Periode p_periode)
  {
    super(p_periode);
  }
  
  protected abstract DomPCSpec createPC();
  
  protected Integer rawGetDureePrc()
  {
    return ((PrcPC)getPC()).getDureePrc();
  }
  
  public Integer getDureePrc()
  {
    return ((PrcPC)getPC()).getDureePrc();
  }
  
  public void setDureePrc(Integer p_dureePrc)
  {
    if ((m_dureePrc == null) || (p_dureePrc == null))
    {
      m_dureePrc = p_dureePrc;
      ((PrcPC)getPC()).setDureePrc(p_dureePrc);
    }
    else if ((m_dureePrc != null) && (p_dureePrc != null) && (!p_dureePrc.equals(m_dureePrc)))
    {
      m_dureePrc = p_dureePrc;
      ((PrcPC)getPC()).setDureePrc(p_dureePrc);
    }
  }
  
  protected BigDecimal rawGetNombreJourAbsence()
  {
    return ((PrcPC)getPC()).getNombreJourAbsence();
  }
  
  public BigDecimal getNombreJourAbsence()
  {
    return ((PrcPC)getPC()).getNombreJourAbsence();
  }
  
  public void setNombreJourAbsence(BigDecimal p_nombreJourAbsence)
  {
    if ((m_nombreJourAbsence == null) || (p_nombreJourAbsence == null))
    {
      m_nombreJourAbsence = p_nombreJourAbsence;
      ((PrcPC)getPC()).setNombreJourAbsence(p_nombreJourAbsence);
    }
    else if ((m_nombreJourAbsence != null) && (p_nombreJourAbsence != null) && (!p_nombreJourAbsence.equals(m_nombreJourAbsence)))
    {
      m_nombreJourAbsence = p_nombreJourAbsence;
      ((PrcPC)getPC()).setNombreJourAbsence(p_nombreJourAbsence);
    }
  }
  
  protected BigDecimal rawGetDiviseur()
  {
    return ((PrcPC)getPC()).getDiviseur();
  }
  
  public BigDecimal getDiviseur()
  {
    return ((PrcPC)getPC()).getDiviseur();
  }
  
  public void setDiviseur(BigDecimal p_diviseur)
  {
    if ((m_diviseur == null) || (p_diviseur == null))
    {
      m_diviseur = p_diviseur;
      ((PrcPC)getPC()).setDiviseur(p_diviseur);
    }
    else if ((m_diviseur != null) && (p_diviseur != null) && (!p_diviseur.equals(m_diviseur)))
    {
      m_diviseur = p_diviseur;
      ((PrcPC)getPC()).setDiviseur(p_diviseur);
    }
  }
  
  protected Periode rawGetPrip()
  {
    return ((PrcPC)getPC()).getPrip();
  }
  
  public Periode getPrip()
  {
    return ((PrcPC)getPC()).getPrip();
  }
  
  public void setPrip(Periode p_prip)
  {
    if ((m_prip == null) || (p_prip == null))
    {
      m_prip = p_prip;
      ((PrcPC)getPC()).setPrip(p_prip);
    }
    else if ((m_prip != null) && (p_prip != null) && (!p_prip.equals(m_prip)))
    {
      m_prip = p_prip;
      ((PrcPC)getPC()).setPrip(p_prip);
    }
  }
  
  protected BigDecimal rawGetNombreHeuresTotal()
  {
    return ((PrcPC)getPC()).getNombreHeuresTotal();
  }
  
  public BigDecimal getNombreHeuresTotal()
  {
    return ((PrcPC)getPC()).getNombreHeuresTotal();
  }
  
  public void setNombreHeuresTotal(BigDecimal p_nombreHeuresTotal)
  {
    if ((m_nombreHeuresTotal == null) || (p_nombreHeuresTotal == null))
    {
      m_nombreHeuresTotal = p_nombreHeuresTotal;
      ((PrcPC)getPC()).setNombreHeuresTotal(p_nombreHeuresTotal);
    }
    else if ((m_nombreHeuresTotal != null) && (p_nombreHeuresTotal != null) && (!p_nombreHeuresTotal.equals(m_nombreHeuresTotal)))
    {
      m_nombreHeuresTotal = p_nombreHeuresTotal;
      ((PrcPC)getPC()).setNombreHeuresTotal(p_nombreHeuresTotal);
    }
  }
  
  protected BigDecimal rawGetSrip()
  {
    return ((PrcPC)getPC()).getSrip();
  }
  
  public BigDecimal getSrip()
  {
    return ((PrcPC)getPC()).getSrip();
  }
  
  public void setSrip(BigDecimal p_srip)
  {
    if ((m_srip == null) || (p_srip == null))
    {
      m_srip = p_srip;
      ((PrcPC)getPC()).setSrip(p_srip);
    }
    else if ((m_srip != null) && (p_srip != null) && (!p_srip.equals(m_srip)))
    {
      m_srip = p_srip;
      ((PrcPC)getPC()).setSrip(p_srip);
    }
  }
  
  protected Integer rawGetNombreJourDeductible()
  {
    return ((PrcPC)getPC()).getNombreJourDeductible();
  }
  
  public Integer getNombreJourDeductible()
  {
    return ((PrcPC)getPC()).getNombreJourDeductible();
  }
  
  public void setNombreJourDeductible(Integer p_nombreJourDeductible)
  {
    if ((m_nombreJourDeductible == null) || (p_nombreJourDeductible == null))
    {
      m_nombreJourDeductible = p_nombreJourDeductible;
      ((PrcPC)getPC()).setNombreJourDeductible(p_nombreJourDeductible);
    }
    else if ((m_nombreJourDeductible != null) && (p_nombreJourDeductible != null) && (!p_nombreJourDeductible.equals(m_nombreJourDeductible)))
    {
      m_nombreJourDeductible = p_nombreJourDeductible;
      ((PrcPC)getPC()).setNombreJourDeductible(p_nombreJourDeductible);
    }
  }
  
  protected Integer rawGetNombreJourInappartenance()
  {
    return ((PrcPC)getPC()).getNombreJourInappartenance();
  }
  
  public Integer getNombreJourInappartenance()
  {
    return ((PrcPC)getPC()).getNombreJourInappartenance();
  }
  
  public void setNombreJourInappartenance(Integer p_nombreJourInappartenance)
  {
    if ((m_nombreJourInappartenance == null) || (p_nombreJourInappartenance == null))
    {
      m_nombreJourInappartenance = p_nombreJourInappartenance;
      ((PrcPC)getPC()).setNombreJourInappartenance(p_nombreJourInappartenance);
    }
    else if ((m_nombreJourInappartenance != null) && (p_nombreJourInappartenance != null) && (!p_nombreJourInappartenance.equals(m_nombreJourInappartenance)))
    {
      m_nombreJourInappartenance = p_nombreJourInappartenance;
      ((PrcPC)getPC()).setNombreJourInappartenance(p_nombreJourInappartenance);
    }
  }
  
  protected BigDecimal rawGetNombreJourTravailEffectif()
  {
    return ((PrcPC)getPC()).getNombreJourTravailEffectif();
  }
  
  public BigDecimal getNombreJourTravailEffectif()
  {
    return ((PrcPC)getPC()).getNombreJourTravailEffectif();
  }
  
  public void setNombreJourTravailEffectif(BigDecimal p_nombreJourTravailEffectif)
  {
    if ((m_nombreJourTravailEffectif == null) || (p_nombreJourTravailEffectif == null))
    {
      m_nombreJourTravailEffectif = p_nombreJourTravailEffectif;
      ((PrcPC)getPC()).setNombreJourTravailEffectif(p_nombreJourTravailEffectif);
    }
    else if ((m_nombreJourTravailEffectif != null) && (p_nombreJourTravailEffectif != null) && (!p_nombreJourTravailEffectif.equals(m_nombreJourTravailEffectif)))
    {
      m_nombreJourTravailEffectif = p_nombreJourTravailEffectif;
      ((PrcPC)getPC()).setNombreJourTravailEffectif(p_nombreJourTravailEffectif);
    }
  }
  
  protected BigDecimal rawGetNombreHeuresA4ouA5()
  {
    return ((PrcPC)getPC()).getNombreHeuresA4ouA5();
  }
  
  public BigDecimal getNombreHeuresA4ouA5()
  {
    return ((PrcPC)getPC()).getNombreHeuresA4ouA5();
  }
  
  public void setNombreHeuresA4ouA5(BigDecimal p_nombreHeuresA4ouA5)
  {
    if ((m_nombreHeuresA4ouA5 == null) || (p_nombreHeuresA4ouA5 == null))
    {
      m_nombreHeuresA4ouA5 = p_nombreHeuresA4ouA5;
      ((PrcPC)getPC()).setNombreHeuresA4ouA5(p_nombreHeuresA4ouA5);
    }
    else if ((m_nombreHeuresA4ouA5 != null) && (p_nombreHeuresA4ouA5 != null) && (!p_nombreHeuresA4ouA5.equals(m_nombreHeuresA4ouA5)))
    {
      m_nombreHeuresA4ouA5 = p_nombreHeuresA4ouA5;
      ((PrcPC)getPC()).setNombreHeuresA4ouA5(p_nombreHeuresA4ouA5);
    }
  }
  
  protected BigDecimal rawGetDroitCongesA4ouA5()
  {
    return ((PrcPC)getPC()).getDroitCongesA4ouA5();
  }
  
  public BigDecimal getDroitCongesA4ouA5()
  {
    return ((PrcPC)getPC()).getDroitCongesA4ouA5();
  }
  
  public void setDroitCongesA4ouA5(BigDecimal p_droitCongesA4ouA5)
  {
    if ((m_droitCongesA4ouA5 == null) || (p_droitCongesA4ouA5 == null))
    {
      m_droitCongesA4ouA5 = p_droitCongesA4ouA5;
      ((PrcPC)getPC()).setDroitCongesA4ouA5(p_droitCongesA4ouA5);
    }
    else if ((m_droitCongesA4ouA5 != null) && (p_droitCongesA4ouA5 != null) && (!p_droitCongesA4ouA5.equals(m_droitCongesA4ouA5)))
    {
      m_droitCongesA4ouA5 = p_droitCongesA4ouA5;
      ((PrcPC)getPC()).setDroitCongesA4ouA5(p_droitCongesA4ouA5);
    }
  }
  
  protected boolean rawIsTopContratsDeTypeParticulier()
  {
    return ((PrcPC)getPC()).isTopContratsDeTypeParticulier();
  }
  
  public boolean isTopContratsDeTypeParticulier()
  {
    return ((PrcPC)getPC()).isTopContratsDeTypeParticulier();
  }
  
  public void setTopContratsDeTypeParticulier(boolean p_topContratsDeTypeParticulier)
  {
    ((PrcPC)getPC()).setTopContratsDeTypeParticulier(p_topContratsDeTypeParticulier);
  }
  
  protected boolean rawIsEstSripReduit()
  {
    return ((PrcPC)getPC()).isEstSripReduit();
  }
  
  public boolean isEstSripReduit()
  {
    return ((PrcPC)getPC()).isEstSripReduit();
  }
  
  public void setEstSripReduit(boolean p_estSripReduit)
  {
    ((PrcPC)getPC()).setEstSripReduit(p_estSripReduit);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     PrcGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */