package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.Prc;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenementDebutCREM;

public abstract class SjripGen
  extends ObjetChronoEvenementDebutCREM
  implements DomGenSpec
{
  private Prc m_prc;
  private QuantiteEuro m_plafondSjr;
  private QuantiteEuro m_sjrInitial;
  private Damj m_dateEvenement;
  private String m_contexteParticulierSjr;
  
  public SjripGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public SjripGen() {}
  
  public SjripGen(Damj p_dateEffet)
  {
    super(p_dateEffet);
  }
  
  public Prc getPrc()
  {
    if (m_prc == null)
    {
      DomPCSpec prcPC = ((ConstitutionElementsAbstraitPC)getPC()).getPrcConstitutionSjr();
      if (prcPC != null) {
        m_prc = ((Prc)prcPC.createOM());
      }
    }
    return m_prc;
  }
  
  public void setPrc(Prc p_prc)
  {
    if (p_prc == null)
    {
      ((ConstitutionElementsAbstraitPC)getPC()).setPrcConstitutionSjr(null);
      m_prc = p_prc;
    }
    else if (!p_prc.equals(m_prc))
    {
      ((ConstitutionElementsAbstraitPC)getPC()).setPrcConstitutionSjr(p_prc.getPC());
      m_prc = p_prc;
    }
  }
  
  protected QuantiteEuro rawGetPlafondSjr()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPlafondSjrConstitutionSjr();
  }
  
  public QuantiteEuro getPlafondSjr()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPlafondSjrConstitutionSjr();
  }
  
  public void setPlafondSjr(QuantiteEuro p_plafondSjr)
  {
    if ((m_plafondSjr == null) || (p_plafondSjr == null))
    {
      m_plafondSjr = p_plafondSjr;
      ((ConstitutionElementsAbstraitPC)getPC()).setPlafondSjrConstitutionSjr(p_plafondSjr);
    }
    else if ((m_plafondSjr != null) && (p_plafondSjr != null) && (!p_plafondSjr.equals(m_plafondSjr)))
    {
      m_plafondSjr = p_plafondSjr;
      ((ConstitutionElementsAbstraitPC)getPC()).setPlafondSjrConstitutionSjr(p_plafondSjr);
    }
  }
  
  protected QuantiteEuro rawGetSjrInitial()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrInitialConstitutionSjr();
  }
  
  public QuantiteEuro getSjrInitial()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrInitialConstitutionSjr();
  }
  
  public void setSjrInitial(QuantiteEuro p_sjrInitial)
  {
    if ((m_sjrInitial == null) || (p_sjrInitial == null))
    {
      m_sjrInitial = p_sjrInitial;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrInitialConstitutionSjr(p_sjrInitial);
    }
    else if ((m_sjrInitial != null) && (p_sjrInitial != null) && (!p_sjrInitial.equals(m_sjrInitial)))
    {
      m_sjrInitial = p_sjrInitial;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrInitialConstitutionSjr(p_sjrInitial);
    }
  }
  
  protected Damj rawGetDateEvenement()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDateEvenementConstitutionSjr();
  }
  
  public Damj getDateEvenement()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDateEvenementConstitutionSjr();
  }
  
  public void setDateEvenement(Damj p_dateEvenement)
  {
    if ((m_dateEvenement == null) || (p_dateEvenement == null))
    {
      m_dateEvenement = p_dateEvenement;
      ((ConstitutionElementsAbstraitPC)getPC()).setDateEvenementConstitutionSjr(p_dateEvenement);
    }
    else if ((m_dateEvenement != null) && (p_dateEvenement != null) && (!p_dateEvenement.equals(m_dateEvenement)))
    {
      m_dateEvenement = p_dateEvenement;
      ((ConstitutionElementsAbstraitPC)getPC()).setDateEvenementConstitutionSjr(p_dateEvenement);
    }
  }
  
  protected String rawGetContexteParticulierSjr()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getContexteParticulierSjr();
  }
  
  public String getContexteParticulierSjr()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getContexteParticulierSjr();
  }
  
  public void setContexteParticulierSjr(String p_contexteParticulierSjr)
  {
    if ((m_contexteParticulierSjr == null) || (p_contexteParticulierSjr == null))
    {
      m_contexteParticulierSjr = p_contexteParticulierSjr;
      ((ConstitutionElementsAbstraitPC)getPC()).setContexteParticulierSjr(p_contexteParticulierSjr);
    }
    else if ((m_contexteParticulierSjr != null) && (p_contexteParticulierSjr != null) && (!p_contexteParticulierSjr.equals(m_contexteParticulierSjr)))
    {
      m_contexteParticulierSjr = p_contexteParticulierSjr;
      ((ConstitutionElementsAbstraitPC)getPC()).setContexteParticulierSjr(p_contexteParticulierSjr);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
    
    Object prc = getPrc();
    if ((prc != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(prc))) {
      DomManager.supprimer(getPrc(), p_contexteSuppression);
    }
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    super.initEnProfondeur();
    if (getPrc() != null)
    {
      DomManager.supprimer(getPrc());
      setPrc(null);
    }
    setPlafondSjr(null);
    setSjrInitial(null);
    setDateEvenement(null);
    setContexteParticulierSjr(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     SjripGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */