package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.novation;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ConstitutionSjrSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilMappingSjmSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.SjripSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.QuantiteEuro;
import java.util.List;

public final class OutilConstitutionSjr
{
  public static final String MONTANT_RETENU_ARE_SOUS_JACENT = "2";
  
  public static void alimenterSjr(ConstitutionSjrSpec constitutionSjr, ProduitAsuSpec produit, AttributionAssuranceSpec attribution)
  {
    AttributionAssuranceSpec attributionPrecedente = attribution.getAttributionPrecedente();
    if (attributionPrecedente != null)
    {
      int codeEmploiA2B;
      Sjr sjrAServir;
      Reglement reglementApplicableCourant;
      int codeEmploiA2B;
      if (((ProduitAsuSpec)attributionPrecedente.getProduit()).estTrancheActivee(attributionPrecedente.getDemande()))
      {
        TrancheExecutable trancheExecutableAttributionPrecedente = (TrancheExecutable)((Attribution)attributionPrecedente).getListTranchesExecutables().get(0);
        Sjr sjrAServir = trancheExecutableAttributionPrecedente.getSjr();
        Reglement reglementApplicableCourant = trancheExecutableAttributionPrecedente.getReglement();
        codeEmploiA2B = trancheExecutableAttributionPrecedente.getCodeEmploiA2B();
      }
      else
      {
        ElementBaseIndemnisation ebiAttributionPrecedente = attributionPrecedente.getElementBaseIndemnisation();
        
        ConstitutionMontantsBruts constitutionMontantsBruts = (ConstitutionMontantsBruts)attribution.getConstitutionMontantsBruts();
        if ((constitutionMontantsBruts != null) && (constitutionMontantsBruts.getTypeMontantRetenuDroitCourant() != null) && ("2".equals(constitutionMontantsBruts.getTypeMontantRetenuDroitCourant()))) {
          ebiAttributionPrecedente = ebiAttributionPrecedente.getElementBaseIndemnisationDroitAssocie();
        }
        sjrAServir = ebiAttributionPrecedente.getSjr();
        
        reglementApplicableCourant = ebiAttributionPrecedente.getReglementApplicableMontantRetenu().getReglement();
        
        codeEmploiA2B = ebiAttributionPrecedente.getCodeEmploiA2B();
      }
      SjripSpec sjrip = constitutionSjr.getSjrip();
      
      alimenterSjrip(sjrip, sjrAServir);
      
      constitutionSjr.setCodeEmploiA2b(codeEmploiA2B);
      if ((attributionPrecedente instanceof Attribution))
      {
        Attribution attributionPrecedenteProduit = (Attribution)attributionPrecedente;
        if (attributionPrecedenteProduit.getConstitutionSjr() != null)
        {
          ConstitutionSjr constitutionSjrProduit = attributionPrecedenteProduit.getConstitutionSjr();
          constitutionSjr.setCoeffReducteurSjr(constitutionSjrProduit.getCoeffReducteurSjr());
          constitutionSjr.setPlancherCoefficientSjr(constitutionSjrProduit.getPlancherCoefficientSjr());
          constitutionSjr.setSjrTheorique(constitutionSjrProduit.getSjrTheorique());
        }
      }
      if (sjrAServir != null)
      {
        Sjr sjr;
        Sjr sjr;
        if (reglementApplicableCourant.getNomReglement().equals("A2b")) {
          sjr = new Sjr(sjrip.getSjrInitial().getValeurMontant(), sjrip.getDateEffet(), sjrip.getContexteParticulierSjr());
        } else {
          sjr = OutilMappingSjmSjr.convertirSjr(produit.getSalaireJournalier(attributionPrecedente, attribution.getDateAttribution()));
        }
        constitutionSjr.setSjrrp(sjr);
      }
    }
  }
  
  public static void alimenterSjrip(SjripSpec sjrip, Sjr sjrAServir)
  {
    sjrip.setDateEvenement(sjrAServir.getDateDepart());
    sjrip.setPlafondSjr(null);
    sjrip.setSjrInitial(new QuantiteEuro(sjrAServir.getSalaire()));
  }
}

/* Location:
 * Qualified Name:     OutilConstitutionSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */