package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.dom.ConstitutionMontantsBrutsSpec;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.asu.dom.PensionInvaliditeChainee;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.ConstitutionMontantsBrutsGen;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class ConstitutionMontantsBruts
  extends ConstitutionMontantsBrutsGen
  implements ConstitutionMontantsBrutsSpec
{
  private static final long serialVersionUID = -1122965305317710512L;
  private transient MontantAsuSpec montantAAttribution;
  
  public ConstitutionMontantsBruts(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ConstitutionMontantsBruts() {}
  
  public MontantAsuSpec getMontantAAttribution()
  {
    return montantAAttribution;
  }
  
  public void setMontantAAttribution(MontantAsuSpec montantAAttribution)
  {
    this.montantAAttribution = montantAAttribution;
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    ConstitutionMontantsBruts copie = (ConstitutionMontantsBruts)pCopie;
    super.copieElements(copie);
    copie.setMontantJournalierBrut(getMontantJournalierBrut());
    copie.setMontantJournalierBrutNonPrecompte(getMontantJournalierBrutNonPrecompte());
    copie.setMontantPartieA(getMontantPartieA());
    copie.setMontantPartieB(getMontantPartieB());
    copie.setMontantPartieC(getMontantPartieC());
    copie.setMontantBase(getMontantBase());
    copie.setCotisationRetraiteComplementaire(getCotisationRetraiteComplementaire());
    copie.setMontantBrutPensionInvaliditeDeduit(getMontantBrutPensionInvaliditeDeduit());
    copie.setMontantJournalierAvantageVieillesse(getMontantJournalierAvantageVieillesse());
    copie.setMontantJournalierAvantageVieillesseDeduit(getMontantJournalierAvantageVieillesseDeduit());
    copie.setMontantPlafond(getMontantPlafond());
    if (getJustificationMontantsBruts() != null)
    {
      JustificationMontantsBruts copieJustificationMontantsBruts = copie.createJustificationMontantsBruts();
      getJustificationMontantsBruts().copieElements(copieJustificationMontantsBruts);
    }
    copie.setMontantAAttribution(getMontantAAttribution());
    
    Iterator<?> iter = getListePensionInvalidite().iterator();
    while (iter.hasNext())
    {
      PensionInvaliditeChainee element = (PensionInvaliditeChainee)iter.next();
      copie.ajouterMontantBrutPensionInvalidite((PensionInvaliditeChainee)element.copie());
    }
    copie.setCapitalInitialBrut(getCapitalInitialBrut());
  }
  
  public Collection getListePensionInvalidite()
  {
    return super.getCollectionMontantBrutPensionInvalidite();
  }
  
  public void clearCollectionMontantBrutPensionInvalidite()
  {
    for (Iterator iter = getListePensionInvalidite().iterator(); iter.hasNext();)
    {
      PensionInvaliditeChainee element = (PensionInvaliditeChainee)iter.next();
      DomManager.supprimer(element);
    }
    super.clearCollectionMontantBrutPensionInvalidite();
  }
  
  public void remplacerCollectionMontantBrutPensionInvalidite(Collection collectionACopier)
  {
    for (Iterator iter = getListePensionInvalidite().iterator(); iter.hasNext();)
    {
      PensionInvaliditeChainee element = (PensionInvaliditeChainee)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionMontantBrutPensionInvalidite(collectionACopier);
  }
  
  public void setListePensionInvalidite(Collection listePensionInvalidite)
  {
    remplacerCollectionMontantBrutPensionInvalidite(listePensionInvalidite);
  }
  
  public Collection getCollectionMontantBrutPensionInvalidite()
  {
    return getListePensionInvalidite();
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getJustificationMontantsBruts());
    DomManager.persisterEnProfondeur(super.getCollectionMontantBrutPensionInvalidite());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public BigDecimal getSjrMontantMaxAsp()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     ConstitutionMontantsBruts
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */