package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class ConditionBeneficeAutreProduitGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionsAttributionAbstraitPC;
  private Integer m_dureeAncienneteIntermittant;
  
  public ConditionBeneficeAutreProduitGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionBeneficeAutreProduitGen() {}
  
  public DomPCSpec getPC()
  {
    return m_conditionsAttributionAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionsAttributionAbstraitPC)
  {
    m_conditionsAttributionAbstraitPC = p_conditionsAttributionAbstraitPC;
  }
  
  protected int rawGetEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionBeneficeAutreProduit();
  }
  
  public int getEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionBeneficeAutreProduit();
  }
  
  public void setEtat(int p_etat)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setEtatConditionBeneficeAutreProduit(p_etat);
  }
  
  protected int rawGetCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionBeneficeAutreProduit();
  }
  
  public int getCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionBeneficeAutreProduit();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCodeMotifEchecConditionBeneficeAutreProduit(p_codeMotifEchec);
  }
  
  protected Integer rawGetDureeAncienneteIntermittant()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDureeAncienneteIntermittantConditionBeneficeAutreProduit();
  }
  
  public Integer getDureeAncienneteIntermittant()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDureeAncienneteIntermittantConditionBeneficeAutreProduit();
  }
  
  public void setDureeAncienneteIntermittant(Integer p_dureeAncienneteIntermittant)
  {
    if ((m_dureeAncienneteIntermittant == null) || (p_dureeAncienneteIntermittant == null))
    {
      m_dureeAncienneteIntermittant = p_dureeAncienneteIntermittant;
      ((ConditionsAttributionAbstraitPC)getPC()).setDureeAncienneteIntermittantConditionBeneficeAutreProduit(p_dureeAncienneteIntermittant);
    }
    else if ((m_dureeAncienneteIntermittant != null) && (p_dureeAncienneteIntermittant != null) && (!p_dureeAncienneteIntermittant.equals(m_dureeAncienneteIntermittant)))
    {
      m_dureeAncienneteIntermittant = p_dureeAncienneteIntermittant;
      ((ConditionsAttributionAbstraitPC)getPC()).setDureeAncienneteIntermittantConditionBeneficeAutreProduit(p_dureeAncienneteIntermittant);
    }
  }
  
  protected int rawGetRangAttributionAFDFiliere()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getRangAttributionAFDFiliere();
  }
  
  public int getRangAttributionAFDFiliere()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getRangAttributionAFDFiliere();
  }
  
  public void setRangAttributionAFDFiliere(int p_rangAttributionAFDFiliere)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setRangAttributionAFDFiliere(p_rangAttributionAFDFiliere);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setEtat(0);
    setCodeMotifEchec(0);
    setDureeAncienneteIntermittant(null);
    setRangAttributionAFDFiliere(0);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionBeneficeAutreProduitGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */