package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;

public abstract class ConstitutionNbHeuresTravailleesGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private BigDecimal m_nombreHeuresTravailleesEtendu = new BigDecimal("0");
  private BigDecimal m_nombreHeuresTravailleesPlafonne = new BigDecimal("0");
  private BigDecimal m_nombreHeuresTravailleesMajorees = BigDecimal.ZERO;
  
  public ConstitutionNbHeuresTravailleesGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionNbHeuresTravailleesGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected BigDecimal rawGetNombreHeuresTravailleesEtendu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNombreHeuresTravailleesEtenduConstitutionNbHeuresTravaillees();
  }
  
  public BigDecimal getNombreHeuresTravailleesEtendu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNombreHeuresTravailleesEtenduConstitutionNbHeuresTravaillees();
  }
  
  public void setNombreHeuresTravailleesEtendu(BigDecimal p_nombreHeuresTravailleesEtendu)
  {
    if ((m_nombreHeuresTravailleesEtendu == null) || (p_nombreHeuresTravailleesEtendu == null))
    {
      m_nombreHeuresTravailleesEtendu = p_nombreHeuresTravailleesEtendu;
      ((ConstitutionElementsAbstraitPC)getPC()).setNombreHeuresTravailleesEtenduConstitutionNbHeuresTravaillees(p_nombreHeuresTravailleesEtendu);
    }
    else if ((m_nombreHeuresTravailleesEtendu != null) && (p_nombreHeuresTravailleesEtendu != null) && (!p_nombreHeuresTravailleesEtendu.equals(m_nombreHeuresTravailleesEtendu)))
    {
      m_nombreHeuresTravailleesEtendu = p_nombreHeuresTravailleesEtendu;
      ((ConstitutionElementsAbstraitPC)getPC()).setNombreHeuresTravailleesEtenduConstitutionNbHeuresTravaillees(p_nombreHeuresTravailleesEtendu);
    }
  }
  
  protected BigDecimal rawGetNombreHeuresTravailleesPlafonne()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNombreHeuresTravailleesPlafonneConstitutionNbHeuresTravaillees();
  }
  
  public BigDecimal getNombreHeuresTravailleesPlafonne()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNombreHeuresTravailleesPlafonneConstitutionNbHeuresTravaillees();
  }
  
  public void setNombreHeuresTravailleesPlafonne(BigDecimal p_nombreHeuresTravailleesPlafonne)
  {
    if ((m_nombreHeuresTravailleesPlafonne == null) || (p_nombreHeuresTravailleesPlafonne == null))
    {
      m_nombreHeuresTravailleesPlafonne = p_nombreHeuresTravailleesPlafonne;
      ((ConstitutionElementsAbstraitPC)getPC()).setNombreHeuresTravailleesPlafonneConstitutionNbHeuresTravaillees(p_nombreHeuresTravailleesPlafonne);
    }
    else if ((m_nombreHeuresTravailleesPlafonne != null) && (p_nombreHeuresTravailleesPlafonne != null) && (!p_nombreHeuresTravailleesPlafonne.equals(m_nombreHeuresTravailleesPlafonne)))
    {
      m_nombreHeuresTravailleesPlafonne = p_nombreHeuresTravailleesPlafonne;
      ((ConstitutionElementsAbstraitPC)getPC()).setNombreHeuresTravailleesPlafonneConstitutionNbHeuresTravaillees(p_nombreHeuresTravailleesPlafonne);
    }
  }
  
  protected BigDecimal rawGetNombreHeuresTravailleesMajorees()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNombreHeuresTravailleesMajoreesConstitutionNbHeuresTravaillees();
  }
  
  public BigDecimal getNombreHeuresTravailleesMajorees()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNombreHeuresTravailleesMajoreesConstitutionNbHeuresTravaillees();
  }
  
  public void setNombreHeuresTravailleesMajorees(BigDecimal p_nombreHeuresTravailleesMajorees)
  {
    if ((m_nombreHeuresTravailleesMajorees == null) || (p_nombreHeuresTravailleesMajorees == null))
    {
      m_nombreHeuresTravailleesMajorees = p_nombreHeuresTravailleesMajorees;
      ((ConstitutionElementsAbstraitPC)getPC()).setNombreHeuresTravailleesMajoreesConstitutionNbHeuresTravaillees(p_nombreHeuresTravailleesMajorees);
    }
    else if ((m_nombreHeuresTravailleesMajorees != null) && (p_nombreHeuresTravailleesMajorees != null) && (!p_nombreHeuresTravailleesMajorees.equals(m_nombreHeuresTravailleesMajorees)))
    {
      m_nombreHeuresTravailleesMajorees = p_nombreHeuresTravailleesMajorees;
      ((ConstitutionElementsAbstraitPC)getPC()).setNombreHeuresTravailleesMajoreesConstitutionNbHeuresTravaillees(p_nombreHeuresTravailleesMajorees);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setNombreHeuresTravailleesEtendu(new BigDecimal("0"));
    setNombreHeuresTravailleesPlafonne(new BigDecimal("0"));
    setNombreHeuresTravailleesMajorees(BigDecimal.ZERO);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionNbHeuresTravailleesGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */