package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import java.math.BigDecimal;

public abstract class JustificationMontantsBrutsGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private BigDecimal m_coefA1 = null;
  private BigDecimal m_coefA2 = null;
  private BigDecimal m_coefB1 = null;
  private BigDecimal m_coefB2 = null;
  private BigDecimal m_coefC = null;
  private QuantiteEuro m_montantMini = null;
  private BigDecimal m_salaireReferenceForfaitaire = null;
  private BigDecimal m_forfaitHeures = null;
  
  public JustificationMontantsBrutsGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public JustificationMontantsBrutsGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected BigDecimal rawGetCoefA1()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefA1JustificationMontantsBruts();
  }
  
  public BigDecimal getCoefA1()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefA1JustificationMontantsBruts();
  }
  
  public void setCoefA1(BigDecimal p_coefA1)
  {
    if ((m_coefA1 == null) || (p_coefA1 == null))
    {
      m_coefA1 = p_coefA1;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefA1JustificationMontantsBruts(p_coefA1);
    }
    else if ((m_coefA1 != null) && (p_coefA1 != null) && (!p_coefA1.equals(m_coefA1)))
    {
      m_coefA1 = p_coefA1;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefA1JustificationMontantsBruts(p_coefA1);
    }
  }
  
  protected BigDecimal rawGetCoefA2()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefA2JustificationMontantsBruts();
  }
  
  public BigDecimal getCoefA2()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefA2JustificationMontantsBruts();
  }
  
  public void setCoefA2(BigDecimal p_coefA2)
  {
    if ((m_coefA2 == null) || (p_coefA2 == null))
    {
      m_coefA2 = p_coefA2;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefA2JustificationMontantsBruts(p_coefA2);
    }
    else if ((m_coefA2 != null) && (p_coefA2 != null) && (!p_coefA2.equals(m_coefA2)))
    {
      m_coefA2 = p_coefA2;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefA2JustificationMontantsBruts(p_coefA2);
    }
  }
  
  protected BigDecimal rawGetCoefB1()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefB1JustificationMontantsBruts();
  }
  
  public BigDecimal getCoefB1()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefB1JustificationMontantsBruts();
  }
  
  public void setCoefB1(BigDecimal p_coefB1)
  {
    if ((m_coefB1 == null) || (p_coefB1 == null))
    {
      m_coefB1 = p_coefB1;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefB1JustificationMontantsBruts(p_coefB1);
    }
    else if ((m_coefB1 != null) && (p_coefB1 != null) && (!p_coefB1.equals(m_coefB1)))
    {
      m_coefB1 = p_coefB1;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefB1JustificationMontantsBruts(p_coefB1);
    }
  }
  
  protected BigDecimal rawGetCoefB2()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefB2JustificationMontantsBruts();
  }
  
  public BigDecimal getCoefB2()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefB2JustificationMontantsBruts();
  }
  
  public void setCoefB2(BigDecimal p_coefB2)
  {
    if ((m_coefB2 == null) || (p_coefB2 == null))
    {
      m_coefB2 = p_coefB2;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefB2JustificationMontantsBruts(p_coefB2);
    }
    else if ((m_coefB2 != null) && (p_coefB2 != null) && (!p_coefB2.equals(m_coefB2)))
    {
      m_coefB2 = p_coefB2;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefB2JustificationMontantsBruts(p_coefB2);
    }
  }
  
  protected BigDecimal rawGetCoefC()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefCJustificationMontantsBruts();
  }
  
  public BigDecimal getCoefC()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefCJustificationMontantsBruts();
  }
  
  public void setCoefC(BigDecimal p_coefC)
  {
    if ((m_coefC == null) || (p_coefC == null))
    {
      m_coefC = p_coefC;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefCJustificationMontantsBruts(p_coefC);
    }
    else if ((m_coefC != null) && (p_coefC != null) && (!p_coefC.equals(m_coefC)))
    {
      m_coefC = p_coefC;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefCJustificationMontantsBruts(p_coefC);
    }
  }
  
  protected QuantiteEuro rawGetMontantMini()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantMiniJustificationMontantsBruts();
  }
  
  public QuantiteEuro getMontantMini()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getMontantMiniJustificationMontantsBruts();
  }
  
  public void setMontantMini(QuantiteEuro p_montantMini)
  {
    if ((m_montantMini == null) || (p_montantMini == null))
    {
      m_montantMini = p_montantMini;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantMiniJustificationMontantsBruts(p_montantMini);
    }
    else if ((m_montantMini != null) && (p_montantMini != null) && (!p_montantMini.equals(m_montantMini)))
    {
      m_montantMini = p_montantMini;
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantMiniJustificationMontantsBruts(p_montantMini);
    }
  }
  
  protected BigDecimal rawGetSalaireReferenceForfaitaire()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSalaireReferenceForfaitaireJustificationMontantsBruts();
  }
  
  public BigDecimal getSalaireReferenceForfaitaire()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSalaireReferenceForfaitaireJustificationMontantsBruts();
  }
  
  public void setSalaireReferenceForfaitaire(BigDecimal p_salaireReferenceForfaitaire)
  {
    if ((m_salaireReferenceForfaitaire == null) || (p_salaireReferenceForfaitaire == null))
    {
      m_salaireReferenceForfaitaire = p_salaireReferenceForfaitaire;
      ((ConstitutionElementsAbstraitPC)getPC()).setSalaireReferenceForfaitaireJustificationMontantsBruts(p_salaireReferenceForfaitaire);
    }
    else if ((m_salaireReferenceForfaitaire != null) && (p_salaireReferenceForfaitaire != null) && (!p_salaireReferenceForfaitaire.equals(m_salaireReferenceForfaitaire)))
    {
      m_salaireReferenceForfaitaire = p_salaireReferenceForfaitaire;
      ((ConstitutionElementsAbstraitPC)getPC()).setSalaireReferenceForfaitaireJustificationMontantsBruts(p_salaireReferenceForfaitaire);
    }
  }
  
  protected BigDecimal rawGetForfaitHeures()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getForfaitHeuresJustificationMontantsBruts();
  }
  
  public BigDecimal getForfaitHeures()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getForfaitHeuresJustificationMontantsBruts();
  }
  
  public void setForfaitHeures(BigDecimal p_forfaitHeures)
  {
    if ((m_forfaitHeures == null) || (p_forfaitHeures == null))
    {
      m_forfaitHeures = p_forfaitHeures;
      ((ConstitutionElementsAbstraitPC)getPC()).setForfaitHeuresJustificationMontantsBruts(p_forfaitHeures);
    }
    else if ((m_forfaitHeures != null) && (p_forfaitHeures != null) && (!p_forfaitHeures.equals(m_forfaitHeures)))
    {
      m_forfaitHeures = p_forfaitHeures;
      ((ConstitutionElementsAbstraitPC)getPC()).setForfaitHeuresJustificationMontantsBruts(p_forfaitHeures);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setCoefA1(null);
    setCoefA2(null);
    setCoefB1(null);
    setCoefB2(null);
    setCoefC(null);
    setMontantMini(null);
    setSalaireReferenceForfaitaire(null);
    setForfaitHeures(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     JustificationMontantsBrutsGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */