package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PeriodeSurMoisCivil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.MoisCivilPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class MoisCivilGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_moisCivilPC;
  private Periode m_periode;
  public Collection m_periodeSurMoisCivil;
  
  public MoisCivilGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public MoisCivilGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new MoisCivilPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_moisCivilPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_moisCivilPC)
  {
    m_moisCivilPC = p_moisCivilPC;
  }
  
  protected int rawGetNbJoursTravailles()
  {
    return ((MoisCivilPC)getPC()).getNbJoursTravailles();
  }
  
  public int getNbJoursTravailles()
  {
    return ((MoisCivilPC)getPC()).getNbJoursTravailles();
  }
  
  public void setNbJoursTravailles(int p_nbJoursTravailles)
  {
    ((MoisCivilPC)getPC()).setNbJoursTravailles(p_nbJoursTravailles);
  }
  
  protected int rawGetNbJoursRetenus()
  {
    return ((MoisCivilPC)getPC()).getNbJoursRetenus();
  }
  
  public int getNbJoursRetenus()
  {
    return ((MoisCivilPC)getPC()).getNbJoursRetenus();
  }
  
  public void setNbJoursRetenus(int p_nbJoursRetenus)
  {
    ((MoisCivilPC)getPC()).setNbJoursRetenus(p_nbJoursRetenus);
  }
  
  protected Periode rawGetPeriode()
  {
    return ((MoisCivilPC)getPC()).getPeriode();
  }
  
  public Periode getPeriode()
  {
    return ((MoisCivilPC)getPC()).getPeriode();
  }
  
  public void setPeriode(Periode p_periode)
  {
    if ((m_periode == null) || (p_periode == null))
    {
      m_periode = p_periode;
      ((MoisCivilPC)getPC()).setPeriode(p_periode);
    }
    else if ((m_periode != null) && (p_periode != null) && (!p_periode.equals(m_periode)))
    {
      m_periode = p_periode;
      ((MoisCivilPC)getPC()).setPeriode(p_periode);
    }
  }
  
  private final Collection getCollectionModifiablePeriodeSurMoisCivil()
  {
    Iterator itCollectionPC;
    if (m_periodeSurMoisCivil == null)
    {
      m_periodeSurMoisCivil = new ArrayList();
      for (itCollectionPC = ((MoisCivilPC)getPC()).getCollectionPeriodeSurMoisCivil().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_periodeSurMoisCivil.add(currentOM);
      }
    }
    return m_periodeSurMoisCivil;
  }
  
  public Collection getCollectionPeriodeSurMoisCivil()
  {
    return Collections.unmodifiableCollection(getCollectionModifiablePeriodeSurMoisCivil());
  }
  
  public List getListPeriodeSurMoisCivil()
  {
    return Collections.unmodifiableList((List)getCollectionModifiablePeriodeSurMoisCivil());
  }
  
  public void remplacerCollectionPeriodeSurMoisCivil(Collection p_collectionACopier)
  {
    clearCollectionPeriodeSurMoisCivil();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      PeriodeSurMoisCivil objet = (PeriodeSurMoisCivil)i.next();
      ajouterPeriodeSurMoisCivil(objet);
    }
  }
  
  public void supprimerSousCollectionPeriodeSurMoisCivil(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      PeriodeSurMoisCivil objet = (PeriodeSurMoisCivil)i.next();
      supprimerPeriodeSurMoisCivil(objet);
    }
  }
  
  public void ajouterPeriodeSurMoisCivil(PeriodeSurMoisCivil p_periodeSurMoisCivil)
    throws NullPointerException
  {
    if (p_periodeSurMoisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeSurMoisCivil ne devrait pas être nul.", p_periodeSurMoisCivil);
    }
    getCollectionModifiablePeriodeSurMoisCivil().add(p_periodeSurMoisCivil);
    ((MoisCivilPC)getPC()).ajouterPeriodeSurMoisCivil(p_periodeSurMoisCivil.getPC());
  }
  
  public void supprimerPeriodeSurMoisCivil(PeriodeSurMoisCivil p_periodeSurMoisCivil)
    throws NullPointerException
  {
    if (p_periodeSurMoisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeSurMoisCivil ne devrait pas être nul.", p_periodeSurMoisCivil);
    }
    getCollectionModifiablePeriodeSurMoisCivil().remove(p_periodeSurMoisCivil);
    ((MoisCivilPC)getPC()).supprimerPeriodeSurMoisCivil(p_periodeSurMoisCivil.getPC());
  }
  
  public void recopierCollectionPeriodeSurMoisCivilVers(ObjetMetierSpec p_copie)
  {
    MoisCivilGen copie = (MoisCivilGen)p_copie;
    Collection listeACopier = getCollectionPeriodeSurMoisCivil();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterPeriodeSurMoisCivil((PeriodeSurMoisCivil)objet);
    }
  }
  
  public void clearCollectionPeriodeSurMoisCivil()
  {
    getCollectionModifiablePeriodeSurMoisCivil().clear();
    ((MoisCivilPC)getPC()).getCollectionPeriodeSurMoisCivil().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionPeriodeSurMoisCivil().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     MoisCivilGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */