package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.PeriodeRetenuePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Periode;

public abstract class PeriodeRetenueGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_periodeRetenuePC;
  private Periode m_periode = null;
  private String m_raisonSociale;
  private QuantiteEuro m_montantRetenu = null;
  private String m_nomReglement;
  
  public PeriodeRetenueGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public PeriodeRetenueGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new PeriodeRetenuePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_periodeRetenuePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_periodeRetenuePC)
  {
    m_periodeRetenuePC = p_periodeRetenuePC;
  }
  
  protected Periode rawGetPeriode()
  {
    return ((PeriodeRetenuePC)getPC()).getPeriode();
  }
  
  public Periode getPeriode()
  {
    return ((PeriodeRetenuePC)getPC()).getPeriode();
  }
  
  public void setPeriode(Periode p_periode)
  {
    if ((m_periode == null) || (p_periode == null))
    {
      m_periode = p_periode;
      ((PeriodeRetenuePC)getPC()).setPeriode(p_periode);
    }
    else if ((m_periode != null) && (p_periode != null) && (!p_periode.equals(m_periode)))
    {
      m_periode = p_periode;
      ((PeriodeRetenuePC)getPC()).setPeriode(p_periode);
    }
  }
  
  protected String rawGetRaisonSociale()
  {
    return ((PeriodeRetenuePC)getPC()).getRaisonSociale();
  }
  
  public String getRaisonSociale()
  {
    return ((PeriodeRetenuePC)getPC()).getRaisonSociale();
  }
  
  public void setRaisonSociale(String p_raisonSociale)
  {
    if ((m_raisonSociale == null) || (p_raisonSociale == null))
    {
      m_raisonSociale = p_raisonSociale;
      ((PeriodeRetenuePC)getPC()).setRaisonSociale(p_raisonSociale);
    }
    else if ((m_raisonSociale != null) && (p_raisonSociale != null) && (!p_raisonSociale.equals(m_raisonSociale)))
    {
      m_raisonSociale = p_raisonSociale;
      ((PeriodeRetenuePC)getPC()).setRaisonSociale(p_raisonSociale);
    }
  }
  
  protected QuantiteEuro rawGetMontantRetenu()
  {
    return ((PeriodeRetenuePC)getPC()).getMontantRetenu();
  }
  
  public QuantiteEuro getMontantRetenu()
  {
    return ((PeriodeRetenuePC)getPC()).getMontantRetenu();
  }
  
  public void setMontantRetenu(QuantiteEuro p_montantRetenu)
  {
    if ((m_montantRetenu == null) || (p_montantRetenu == null))
    {
      m_montantRetenu = p_montantRetenu;
      ((PeriodeRetenuePC)getPC()).setMontantRetenu(p_montantRetenu);
    }
    else if ((m_montantRetenu != null) && (p_montantRetenu != null) && (!p_montantRetenu.equals(m_montantRetenu)))
    {
      m_montantRetenu = p_montantRetenu;
      ((PeriodeRetenuePC)getPC()).setMontantRetenu(p_montantRetenu);
    }
  }
  
  protected int rawGetNature()
  {
    return ((PeriodeRetenuePC)getPC()).getNature();
  }
  
  public int getNature()
  {
    return ((PeriodeRetenuePC)getPC()).getNature();
  }
  
  public void setNature(int p_nature)
  {
    ((PeriodeRetenuePC)getPC()).setNature(p_nature);
  }
  
  protected String rawGetNomReglement()
  {
    return ((PeriodeRetenuePC)getPC()).getNomReglement();
  }
  
  public String getNomReglement()
  {
    return ((PeriodeRetenuePC)getPC()).getNomReglement();
  }
  
  public void setNomReglement(String p_nomReglement)
  {
    if ((m_nomReglement == null) || (p_nomReglement == null))
    {
      m_nomReglement = p_nomReglement;
      ((PeriodeRetenuePC)getPC()).setNomReglement(p_nomReglement);
    }
    else if ((m_nomReglement != null) && (p_nomReglement != null) && (!p_nomReglement.equals(m_nomReglement)))
    {
      m_nomReglement = p_nomReglement;
      ((PeriodeRetenuePC)getPC()).setNomReglement(p_nomReglement);
    }
  }
  
  protected int rawGetCodeProduitReglement()
  {
    return ((PeriodeRetenuePC)getPC()).getCodeProduitReglement();
  }
  
  public int getCodeProduitReglement()
  {
    return ((PeriodeRetenuePC)getPC()).getCodeProduitReglement();
  }
  
  public void setCodeProduitReglement(int p_codeProduitReglement)
  {
    ((PeriodeRetenuePC)getPC()).setCodeProduitReglement(p_codeProduitReglement);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     PeriodeRetenueGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */