package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PeriodeRetenue;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class PeriodeRetenuePC
  implements DomPCSpec, PersistenceCapable
{
  private transient PeriodeRetenue m_periodeRetenueOM;
  protected Periode m_periode;
  protected String m_raisonSociale;
  protected QuantiteEuro m_montantRetenu;
  protected int m_nature;
  protected String m_nomReglement;
  protected int m_codeProduitReglement;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_periode", "m_raisonSociale", "m_montantRetenu", "m_nature", "m_nomReglement", "m_codeProduitReglement" };
  private static Class[] jdoFieldTypes = { Periode.class, String.class, QuantiteEuro.class, Integer.TYPE, String.class, Integer.TYPE };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public PeriodeRetenuePC()
  {
    jdoSetm_periode(this, null);
    
    jdoSetm_montantRetenu(this, null);
    jdoSetm_nature(this, 0);
  }
  
  public Object createOM()
  {
    if (m_periodeRetenueOM == null) {
      m_periodeRetenueOM = new PeriodeRetenue(this);
    }
    return m_periodeRetenueOM;
  }
  
  public Periode getPeriode()
  {
    return jdoGetm_periode(this);
  }
  
  public final void setPeriode(Periode p_periode)
  {
    jdoSetm_periode(this, p_periode);
  }
  
  public String getRaisonSociale()
  {
    return jdoGetm_raisonSociale(this);
  }
  
  public final void setRaisonSociale(String p_raisonSociale)
  {
    jdoSetm_raisonSociale(this, p_raisonSociale);
  }
  
  public QuantiteEuro getMontantRetenu()
  {
    return jdoGetm_montantRetenu(this);
  }
  
  public final void setMontantRetenu(QuantiteEuro p_montantRetenu)
  {
    jdoSetm_montantRetenu(this, p_montantRetenu);
  }
  
  public int getNature()
  {
    return jdoGetm_nature(this);
  }
  
  public final void setNature(int p_nature)
  {
    jdoSetm_nature(this, p_nature);
  }
  
  public String getNomReglement()
  {
    return jdoGetm_nomReglement(this);
  }
  
  public final void setNomReglement(String p_nomReglement)
  {
    jdoSetm_nomReglement(this, p_nomReglement);
  }
  
  public int getCodeProduitReglement()
  {
    return jdoGetm_codeProduitReglement(this);
  }
  
  public final void setCodeProduitReglement(int p_codeProduitReglement)
  {
    jdoSetm_codeProduitReglement(this, p_codeProduitReglement);
  }
  
  static
  {
    JDOImplHelper.registerClass(PeriodeRetenuePC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new PeriodeRetenuePC());
  }
  
  protected static final Periode jdoGetm_periode(PeriodeRetenuePC pc)
  {
    if (jdoFlags <= 0) {
      return m_periode;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_periode;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_periode);
    }
    return m_periode;
  }
  
  protected static final String jdoGetm_raisonSociale(PeriodeRetenuePC pc)
  {
    if (jdoFlags <= 0) {
      return m_raisonSociale;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_raisonSociale;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 1, m_raisonSociale);
    }
    return m_raisonSociale;
  }
  
  protected static final QuantiteEuro jdoGetm_montantRetenu(PeriodeRetenuePC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_montantRetenu;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_montantRetenu);
    }
    return m_montantRetenu;
  }
  
  protected static final int jdoGetm_nature(PeriodeRetenuePC pc)
  {
    if (jdoFlags <= 0) {
      return m_nature;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_nature;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 3, m_nature);
    }
    return m_nature;
  }
  
  protected static final String jdoGetm_nomReglement(PeriodeRetenuePC pc)
  {
    if (jdoFlags <= 0) {
      return m_nomReglement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_nomReglement;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 4, m_nomReglement);
    }
    return m_nomReglement;
  }
  
  protected static final int jdoGetm_codeProduitReglement(PeriodeRetenuePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeProduitReglement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_codeProduitReglement;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 5, m_codeProduitReglement);
    }
    return m_codeProduitReglement;
  }
  
  protected static final void jdoSetm_periode(PeriodeRetenuePC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periode = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_periode, newValue);
    } else {
      m_periode = newValue;
    }
  }
  
  protected static final void jdoSetm_raisonSociale(PeriodeRetenuePC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_raisonSociale = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 1, m_raisonSociale, newValue);
    } else {
      m_raisonSociale = newValue;
    }
  }
  
  protected static final void jdoSetm_montantRetenu(PeriodeRetenuePC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_montantRetenu, newValue);
    } else {
      m_montantRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_nature(PeriodeRetenuePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nature = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 3, m_nature, newValue);
    } else {
      m_nature = newValue;
    }
  }
  
  protected static final void jdoSetm_nomReglement(PeriodeRetenuePC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_nomReglement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 4, m_nomReglement, newValue);
    } else {
      m_nomReglement = newValue;
    }
  }
  
  protected static final void jdoSetm_codeProduitReglement(PeriodeRetenuePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeProduitReglement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 5, m_codeProduitReglement, newValue);
    } else {
      m_codeProduitReglement = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periode);
      break;
    case 1: 
      jdoStateManager.providedStringField(this, fieldNumber, m_raisonSociale);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantRetenu);
      break;
    case 3: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nature);
      break;
    case 4: 
      jdoStateManager.providedStringField(this, fieldNumber, m_nomReglement);
      break;
    case 5: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeProduitReglement);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_periode = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_raisonSociale = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 2: 
      m_montantRetenu = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_nature = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 4: 
      m_nomReglement = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 5: 
      m_codeProduitReglement = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    PeriodeRetenuePC pc = new PeriodeRetenuePC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    PeriodeRetenuePC pc = new PeriodeRetenuePC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 6;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof PeriodeRetenuePC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    PeriodeRetenuePC other = (PeriodeRetenuePC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_periode = m_periode;
        break;
      case 1: 
        m_raisonSociale = m_raisonSociale;
        break;
      case 2: 
        m_montantRetenu = m_montantRetenu;
        break;
      case 3: 
        m_nature = m_nature;
        break;
      case 4: 
        m_nomReglement = m_nomReglement;
        break;
      case 5: 
        m_codeProduitReglement = m_codeProduitReglement;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     PeriodeRetenuePC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */