package fr.unedic.cali.asu.spe02.p03.migration.graphes;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionQuantiteAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Decision;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Rejet;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ValidationProduit;
import fr.unedic.cali.autresdoms.cohab.dom.CodesErreursMigration;
import fr.unedic.cali.dom.ConditionAttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cohabitation.sigma.migration.dom.DecisionMigreeAsuV1;
import fr.unedic.cohabitation.sigma.migration.dom.DemandeMigreeAsuV1;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import java.util.Collection;

public class GrapheRejet
  extends GrapheDecision
{
  protected void creerCaps(DossierExamen p_dossierExamen) {}
  
  protected void creerCeps(DossierExamen p_dossierExamen) {}
  
  protected ObjectifExamen creerObjectifDecision(DemandeMigreeAsuV1 p_demandeTemporaireSource)
  {
    ObjectifExamen objectifExamen = null;
    ProduitAsuSpec produitAsu = (ProduitAsuSpec)Parametres.getProduit(p_demandeTemporaireSource.getCodeProduit());
    if (produitAsu != null) {
      objectifExamen = (ObjectifExamen)produitAsu.creerObjectifExamen(10, null);
    }
    objectifExamen.setEtat(22);
    return objectifExamen;
  }
  
  protected Decision creerDecision(int p_natureDecision)
  {
    Decision nouvelleDecision = new Rejet();
    nouvelleDecision.setNatureDecision(16);
    return nouvelleDecision;
  }
  
  protected DossierAffectation creerDossierAffectation()
  {
    DossierAffectation dossierAffectation = new DossierAffecte(1);
    return dossierAffectation;
  }
  
  protected void alimenterCaps(DecisionMigreeAsuV1 p_decisionTemporaireSource, DossierExamen p_dossierExamen)
  {
    p_dossierExamen.getDemande().setCodeMotifEchecPourSigma(Integer.valueOf(p_decisionTemporaireSource.getCodeRejet()).toString());
    
    ConditionAttributionSpec capEchec = null;
    ConditionsAttributionAdmission conditionAttributionAdmission = p_dossierExamen.getConditionAttributionAdmission();
    int codeRejet = p_decisionTemporaireSource.getCodeRejet();
    switch (codeRejet)
    {
    case 11: 
      capEchec = conditionAttributionAdmission.createConditionRechercheEmploi();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      break;
    case 21: 
      break;
    case 41: 
    case 42: 
    case 43: 
    case 44: 
    case 45: 
      capEchec = conditionAttributionAdmission.createConditionFaitGenerateur();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      break;
    case 61: 
    case 62: 
    case 63: 
    case 64: 
    case 625: 
      capEchec = conditionAttributionAdmission.createConditionAge();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      break;
    case 71: 
      capEchec = conditionAttributionAdmission.createConditionQuantiteAffiliation();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      
      DemandeMigreeAsuV1 demandeTemporaireSigma = (DemandeMigreeAsuV1)p_decisionTemporaireSource.getDemandeMigree();
      Decision decisionAsu = (Decision)p_dossierExamen;
      alimenterQuantiteAffilationEchec(demandeTemporaireSigma, decisionAsu);
      break;
    case 91: 
    case 92: 
      capEchec = conditionAttributionAdmission.createConditionChomageInvolontaire();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      
      capEchec = conditionAttributionAdmission.createConditionFaitGenerateur();
      capEchec.setEtatSatisfait(true);
      alimenterConditionFaitGenerateur(p_decisionTemporaireSource, p_dossierExamen);
      
      capEchec = conditionAttributionAdmission.createConditionQuantiteAffiliation();
      capEchec.setEtatSatisfait(true);
      break;
    case 93: 
      capEchec = conditionAttributionAdmission.createConditionChomageInvolontaire();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      
      capEchec = conditionAttributionAdmission.createConditionFaitGenerateur();
      capEchec.setEtatSatisfait(true);
      alimenterConditionFaitGenerateur(p_decisionTemporaireSource, p_dossierExamen);
      
      Demande demande = (Demande)p_dossierExamen.getDemande();
      demande.getDonneesTemporaires().setAvisCommissionParitaire((short)2);
      
      capEchec = conditionAttributionAdmission.createConditionQuantiteAffiliation();
      capEchec.setEtatSatisfait(true);
      break;
    case 171: 
    case 172: 
      capEchec = conditionAttributionAdmission.createConditionCumulPrestationFamiliale();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      break;
    case 181: 
      capEchec = conditionAttributionAdmission.createConditionMontantNonNul();
      capEchec.setEtatSatisfait(false);
      capEchec.setCodeMotifEchec(codeRejet);
      break;
    default: 
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_MOTIF_REJET"));
    }
  }
  
  protected void alimenterIdentifiant(DecisionMigreeAsuV1 p_decisionTemporaireSource, Decision p_decisionInstallee) {}
  
  protected void alimenterCeps(DecisionMigreeAsuV1 p_decisionTemporaireSource, DossierExamen p_dossierExamen) {}
  
  protected void lireCeps(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue) {}
  
  protected void lireCaps(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue) {}
  
  protected void lireIdentifiant(Decision p_decision, DecisionMigreeAsuV1 p_decisionLue) {}
  
  protected void alimenterValidationProduit(DemandeMigreeAsuV1 p_demandeTemporaireSource, Decision p_decision)
  {
    DecisionMigreeAsuV1 decisionTemporaireSource = p_demandeTemporaireSource.getDecision();
    switch (decisionTemporaireSource.getCodeRejet())
    {
    case 91: 
    case 92: 
    case 93: 
      ((DossierAffectation)p_decision.getDossierAffecte()).setValidationProduit(new ValidationProduit());
      super.alimenterValidationProduit(p_demandeTemporaireSource, p_decision);
      break;
    default: 
      ((DossierAffecte)p_decision.getDossierAffecte()).setProduitSecours(Parametres.getProduit(p_demandeTemporaireSource.getCodeProduit()));
    }
  }
  
  protected void alimenterQuantiteAffilationEchec(DemandeMigreeAsuV1 p_demandeTemporaireSource, Decision p_decision)
  {
    ValidationProduit validationProduit = new ValidationProduit();
    
    ProduitSpec produit = Parametres.getProduit(p_demandeTemporaireSource.getCodeProduit());
    validationProduit.setProduitValide(produit);
    validationProduit.setEstProduitValide(true);
    
    DecisionMigreeAsuV1 decisionMigreeAsuV1 = p_demandeTemporaireSource.getDecision();
    if (decisionMigreeAsuV1.getQteAffiliation1() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_QTE_AFFI_1"));
    }
    if (decisionMigreeAsuV1.getUniteAffiliation1() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_1"));
    }
    if ((decisionMigreeAsuV1.getQteAffiliation1() != null) && (decisionMigreeAsuV1.getUniteAffiliation1() != null))
    {
      Unite uniteAffiliation1 = null;
      try
      {
        uniteAffiliation1 = Unite.getParCode(decisionMigreeAsuV1.getUniteAffiliation1());
      }
      catch (NullPointerException e) {}
      if (uniteAffiliation1 == null)
      {
        getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_1", decisionMigreeAsuV1.getUniteAffiliation1()));
      }
      else
      {
        Quantite qteAcquise = new Quantite(p_demandeTemporaireSource.getDecision().getQteAffiliation1(), uniteAffiliation1);
        validationProduit.setQuantiteAcquise(qteAcquise);
        
        ConditionQuantiteAffiliation capa07 = (ConditionQuantiteAffiliation)p_decision.getConditionQuantiteAffiliation();
        capa07.setValidationProduit(validationProduit);
      }
    }
    if ((p_demandeTemporaireSource.getDecision().getReglementApplicable() != null) || (produit.getReglement(p_demandeTemporaireSource.getDecision().getReglementApplicable()) != null)) {
      validationProduit.setReglementApplicable(produit.getReglement(p_demandeTemporaireSource.getDecision().getReglementApplicable()));
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_RA"));
    }
    ((DossierAffectation)p_decision.getDossierAffecte()).setValidationProduit(validationProduit);
  }
}

/* Location:
 * Qualified Name:     GrapheRejet
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */