package fr.unedic.cali.asu.spe02.p05.avant;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.asu.spe02.p05.avant.outilsfonctionnels.TraitementUtAvant;
import fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.ConvertisseurUniteAffiliation;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.calcul.FacadeCalculProduitFactory;
import fr.unedic.cali.calcul.FacadeCalculProduitSpec;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPAEC;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreConflitGaec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.cali.util.ObjetChronoPeriodeConcreteCarence;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;

public class FacadeAvantProduitImpl
  extends fr.unedic.cali.asu.spe02.p04.avant.FacadeAvantProduitImpl
{
  private static final int CENT = 100;
  
  public ResultatAvant executerAvant(AttributionSpec attribution, boolean estAvecPriseEnCompteEvenement, Damj dateEtude, boolean executionPersistante)
    throws CoucheLogiqueException
  {
    ResultatAvant resultatAvant = null;
    Damj pji = null;
    Collection<CarencePrefixeAFixer> carencesEffectives = new ArrayList();
    ObjetChronoPeriodePriseEnCharge periodePEC = null;
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSansConflitGAEC = new ChronologiePeriodes();
    int etat = 0;
    Damj dateDebutUtAvant = null;
    Damj dateFinUtAvant = null;
    Damj finPEC = null;
    
    CalendrierExecutionAvant calendrierAvant = new CalendrierExecutionAvant();
    calendrierAvant.setPremierJourAvant(rechercherDateDebutAvant((Attribution)attribution));
    calendrierAvant.setEtatExecutionAvant(1);
    dateDebutUtAvant = calendrierAvant.getPremierJourAvant().getDebutMois();
    dateFinUtAvant = dateDebutUtAvant.getFinMois();
    if (estAvecPriseEnCompteEvenement)
    {
      chronologiePeriodes = recuperationDeToutesLesDesPeriodes(attribution.getDemandeur(), attribution, attribution.getDateAttribution(), null);
      
      periodePEC = OutillagePeriodes.recupererPeriodePECContenant(attribution.getDemandeur(), attribution.getDateAttribution());
      if (periodePEC == null)
      {
        if ((!"ASU_22".equals(attribution.getTypeExamen())) && (!"ASU_23".equals(attribution.getTypeExamen()))) {
          throw new CoucheLogiqueException("HG_PR_CALI_L_PAS_DE_PEC_POUR_EXECUTION_AVANT", "Attention lors de l'execution de l'avant, impossible de retrouver une periode de prise en charge.", null);
        }
        resultatAvant = new ResultatAvant(pji, new ArrayList(carencesEffectives), true);
        resultatAvant.setEtat(1);
        return resultatAvant;
      }
      finPEC = periodePEC.getDateFin();
    }
    else
    {
      chronologiePeriodes = (ChronologiePeriodes)recuperationDeToutesLesDesPeriodes(attribution.getDemandeur(), attribution, attribution.getDateAttribution(), attribution.getDateAttribution()).copier(new FiltreChevauchePeriode(new Periode(attribution.getDateAttribution(), attribution.getDateAttribution())));
      
      chronologiePeriodesSansConflitGAEC = (ChronologiePeriodes)chronologiePeriodes.copier(new FiltreNegation(new FiltreConflitGaec()));
      
      chronologiePeriodes = chronologiePeriodesSansConflitGAEC;
      
      Qualification qualification = new Qualification();
      QualificationPeriodes periodesQualifie = new QualificationPeriodes();
      periodesQualifie = qualification.qualificationPeriodesPourAvant(chronologiePeriodes, attribution);
      chronologiePeriodes = periodesQualifie.getPeriodesSuspensives();
      chronologiePeriodes.ajouter(periodesQualifie.getPeriodesInterruptives());
    }
    etat = executionAvant(attribution, chronologiePeriodes, etat, dateDebutUtAvant, dateFinUtAvant, calendrierAvant);
    if (etat == 0) {
      pji = calendrierAvant.getDernierJourAvant().lendemain();
    }
    pji = productionEnquete(attribution, estAvecPriseEnCompteEvenement, pji, finPEC, calendrierAvant);
    
    return majResultatAvant(attribution, executionPersistante, pji, carencesEffectives, etat, calendrierAvant);
  }
  
  private Damj productionEnquete(AttributionSpec attribution, boolean estAvecPriseEnCompteEvenement, Damj pji, Damj finPEC, CalendrierExecutionAvant calendrierAvant)
    throws CoucheLogiqueException
  {
    Damj pjiTmp = pji;
    if (estAvecPriseEnCompteEvenement) {
      if ((finPEC != null) && (pjiTmp != null) && (finPEC.estAvantOuCoincideAvec(calendrierAvant.getDernierJourAvant()))) {
        if (OutillagePEC.estPecSuivanteAutreEtatMembreCoordination(attribution.getDemandeur(), finPEC))
        {
          Chronologie chronologiePecEuropeenne = OutillagePEC.getPeriodesPecAutreEtatMembreCoordinationDebutApresDate(attribution.getDemandeur(), finPEC);
          ObjetChronoPeriodePriseEnCharge pec = (ObjetChronoPeriodePriseEnCharge)chronologiePecEuropeenne.premierElement();
          if (pec.getDateDebut().estApres(pjiTmp))
          {
            pjiTmp = Damj.max(pec.getDateDebut(), finPEC);
            
            FacadeCalculProduitSpec facadeCalculProduit = FacadeCalculProduitFactory.getInstance().getInstanceGestionnaireCalculProduit(attribution.getProduitExecution());
            
            GestionSuivi.enregistrerEnquetePbjcNcp(attribution, pjiTmp, 31, 0, true, null, facadeCalculProduit, null);
          }
        }
      }
    }
    return pjiTmp;
  }
  
  private ResultatAvant majResultatAvant(AttributionSpec attribution, boolean executionPersistante, Damj pji, Collection<CarencePrefixeAFixer> carencesEffectives, int etat, CalendrierExecutionAvant calendrierAvant)
  {
    ResultatAvant resultatAvant;
    if (!((AttributionAssuranceSpec)attribution).getListeCarences().isEmpty())
    {
      if (executionPersistante) {
        attribution.setCalendrierExecutionAvant(calendrierAvant);
      }
      mettreAJour(calendrierAvant, (Attribution)attribution, carencesEffectives);
      
      ResultatAvant resultatAvant = new ResultatAvant(pji, new ArrayList(carencesEffectives), calendrierAvant.getEtatAuDernierJourAvant().isDelaiAttenteEntame());
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(calendrierAvant.getDateDebut());
      resultatAvant.setDernierJourAvant(calendrierAvant.getDateFin());
      resultatAvant.setCalendrierExecutionAvantCalcul(calendrierAvant);
    }
    else
    {
      attribution.setCalendrierExecutionAvant(null);
      
      resultatAvant = new ResultatAvant(attribution.getDateAttribution(), new ArrayList(carencesEffectives), false);
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(attribution.getDateAttribution());
      resultatAvant.setDernierJourAvant(attribution.getDateAttribution());
    }
    if (etat == 1) {
      resultatAvant.setMessageErreur("Impossible de determiner le PJI : Un événement interruptif est survenu avant la fin du différé.");
    }
    return resultatAvant;
  }
  
  private int executionAvant(AttributionSpec attribution, ChronologiePeriodes chronologiePeriodes, int etat, Damj dateDebutUtAvant, Damj dateFinUtAvant, CalendrierExecutionAvant calendrierAvant)
    throws CoucheLogiqueException
  {
    int etatResultat = etat;
    Damj dateDebutUtAvantTmp = dateDebutUtAvant;
    Damj dateFinUtAvantTmp = dateFinUtAvant;
    
    IndividuSpec individu = attribution.getDemandeur();
    while ((calendrierAvant.getEtatExecutionAvant() != 3) && (!((AttributionAssuranceSpec)attribution).getListeCarences().isEmpty()))
    {
      Periode periodeUtAvant = new Periode(dateDebutUtAvantTmp, dateFinUtAvantTmp);
      if ((individu != null) && (individu.getDateNaissance() != null) && (periodeUtAvant.getDebut().estApres(individu.getDateNaissance().deplacerVersAvant(new DureeCalendaire(100))))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(new Damj("2200, 01, 01"))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(Damj.FIN_DES_TEMPS)) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { attribution.getDateAttribution() });
      }
      dateDebutUtAvantTmp = dateFinUtAvantTmp.getDebutMoisSuivant();
      dateFinUtAvantTmp = dateDebutUtAvantTmp.getFinMois();
      if (Log.isTraceActive(FacadeAvantProduitImpl.class, Niveau.DEBUG)) {
        Log.ecritTrace(Niveau.DEBUG, FacadeAvantProduitImpl.class, "executerAvant", "Calcul: UT Avant [" + periodeUtAvant.getDebut() + " - " + periodeUtAvant.getFin() + "]");
      }
      etatResultat = TraitementUtAvant.executerUtAvant(attribution, calendrierAvant, periodeUtAvant, chronologiePeriodes);
    }
    return etatResultat;
  }
  
  protected static void mettreAJour(CalendrierExecutionAvant calendrierExecutionAvant, Attribution attribution, Collection carences)
  {
    Chronologie uts = calendrierExecutionAvant.getChronologieUnitesTraitements();
    UniteTraitementAvant derniereUtAvant = (UniteTraitementAvant)uts.dernierElement();
    DureeConsommableAvant duree = null;
    ObjetChronoPeriode periodeOrigineReliquat = null;
    
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(attribution);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(attribution);
    if (pmc != null)
    {
      if (derniereUtAvant != null)
      {
        duree = derniereUtAvant.getDureePmcEnFinUT();
        pmc.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        pmc.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          pmc.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(calendrierExecutionAvant.getDernierJourAvant(), calendrierExecutionAvant.getDernierJourAvant());
          pmc.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      carences.add(pmc);
    }
    if (differeSpecifique != null)
    {
      if (derniereUtAvant != null)
      {
        duree = derniereUtAvant.getDureeDiffereSpecifiqueEnFinUT();
        differeSpecifique.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        differeSpecifique.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          differeSpecifique.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(calendrierExecutionAvant.getDernierJourAvant(), calendrierExecutionAvant.getDernierJourAvant());
          differeSpecifique.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      carences.add(differeSpecifique);
    }
  }
  
  public QualificationPeriodes qualificationPeriodesPourAvant(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Qualification qualification = new Qualification();
    return qualification.qualificationPeriodesPourAvant(chronologiePeriodes, attribution);
  }
  
  public void mettreAJourCarencesSurResultatAvant(CalendrierExecutionAvant calendrierExecutionAvant, AttributionSpec attribution, Collection listeCarences)
  {
    mettreAJour(calendrierExecutionAvant, (Attribution)attribution, listeCarences);
  }
  
  public void convertionCachets(ChronologiePeriodes chronologiePeriodes)
  {
    if ((chronologiePeriodes != null) && (!chronologiePeriodes.estVide()))
    {
      PeriodeActiviteEmploiCalcul periodeActivite = null;
      Chronologie chronoPeriodesPAEC = chronologiePeriodes.copier(new FiltrePeriodeTravailCalculPAEC());
      if ((chronoPeriodesPAEC != null) && (!chronoPeriodesPAEC.estVide()))
      {
        chronoPeriodesPAEC.iterer();
        while (chronoPeriodesPAEC.encoreSuivant())
        {
          periodeActivite = (PeriodeActiviteEmploiCalcul)chronoPeriodesPAEC.elementSuivant();
          if ((periodeActivite.getCachets() != null) && (periodeActivite.getCachets().intValue() > 0)) {
            periodeActivite.setNombreHeures(periodeActivite.getNombreHeuresDeCompletude().add(new Quantite(periodeActivite.getCachets(), UniteAffiliation.CACHET_GROUPE).convertir(UniteAffiliation.HEURE_TRAVAIL, ConvertisseurUniteAffiliation.getInstance()).getValeur()));
          }
        }
      }
    }
  }
  
  public void creerDureeIndemnisation(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant)
  {
    DureeConsommableAvant dureePmc = new DureeConsommableAvant(0, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereStandard = new DureeConsommableAvant(1, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereSpecifique = new DureeConsommableAvant(2, new QuantiteJour("0"));
    DureeConsommableAvant dureeDelaiAttente = new DureeConsommableAvant(3, new QuantiteJour("0"));
    
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer((Attribution)attribution);
    if (pmc != null) {
      dureePmc.setQuantiteInitial(pmc.getQuantiteInitiale());
    }
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer((Attribution)attribution);
    if (differeSpecifique != null) {
      dureeDiffereSpecifique.setQuantiteInitial(differeSpecifique.getQuantiteInitiale());
    }
    dureePmc.activer();
    if (dureePmc.getQuantiteInitial().getValeurEntiere() > 0)
    {
      Periode p = new Periode(calendrierAvant.getPremierJourAvant());
      utAvant.getConsommationPeriodes().setPeriodePmc(p);
    }
    utAvant.setDureePmcEnDebutUT(dureePmc);
    utAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
    utAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
    utAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
  }
  
  public boolean estUnCarenceGereeParLeProduit(DureeConsommableAvant dureeAvant)
  {
    return (dureeAvant.getTypeDureeConsommable() == 0) || (dureeAvant.getTypeDureeConsommable() == 2);
  }
  
  public boolean estCarenceTerminantProduit(DureeConsommableAvant dureeAvant)
  {
    return dureeAvant.getTypeDureeConsommable() == 2;
  }
}

/* Location:
 * Qualified Name:     FacadeAvantProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */