package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI23Impl
  extends YI23
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI23 m_YI23Infra;
  
  public _YI23Impl()
  {
    m_YI23Infra = new _YI23();
  }
  
  public _YI23Impl(_YI23 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI23Infra", pValeur);
    
    m_YI23Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI23Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI23Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI23Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI23Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI23Infra.set_C_ETAT(pCode);
  }
  
  public String getCSASRE()
  {
    return m_YI23Infra.getCSASRE_Code_de_l_Assedic_receptrice();
  }
  
  public String getCodeErreurCSASRE()
  {
    return m_YI23Infra.getCSASRE_Code_de_l_Assedic_receptrice_C_ERR();
  }
  
  public void setCSASRE(String pValeur)
  {
    m_YI23Infra.setCSASRE_Code_de_l_Assedic_receptrice(pValeur);
  }
  
  public void setCodeErreurCSASRE(String pCodeErreur)
  {
    m_YI23Infra.setCSASRE_Code_de_l_Assedic_receptrice_C_ERR(pCodeErreur);
  }
  
  public String getCSASRE_Code_de_l_Assedic_receptrice()
  {
    return m_YI23Infra.getCSASRE_Code_de_l_Assedic_receptrice();
  }
  
  public String getCodeErreurCSASRE_Code_de_l_Assedic_receptrice()
  {
    return m_YI23Infra.getCSASRE_Code_de_l_Assedic_receptrice_C_ERR();
  }
  
  public void setCSASRE_Code_de_l_Assedic_receptrice(String pValeur)
  {
    m_YI23Infra.setCSASRE_Code_de_l_Assedic_receptrice(pValeur);
  }
  
  public void setCodeErreurCSASRE_Code_de_l_Assedic_receptrice(String pCodeErreur)
  {
    m_YI23Infra.setCSASRE_Code_de_l_Assedic_receptrice_C_ERR(pCodeErreur);
  }
  
  public String getCDAPN()
  {
    return m_YI23Infra.getCDAPN_Code_Application();
  }
  
  public String getCodeErreurCDAPN()
  {
    return m_YI23Infra.getCDAPN_Code_Application_C_ERR();
  }
  
  public void setCDAPN(String pValeur)
  {
    m_YI23Infra.setCDAPN_Code_Application(pValeur);
  }
  
  public void setCodeErreurCDAPN(String pCodeErreur)
  {
    m_YI23Infra.setCDAPN_Code_Application_C_ERR(pCodeErreur);
  }
  
  public String getCDAPN_Code_Application()
  {
    return m_YI23Infra.getCDAPN_Code_Application();
  }
  
  public String getCodeErreurCDAPN_Code_Application()
  {
    return m_YI23Infra.getCDAPN_Code_Application_C_ERR();
  }
  
  public void setCDAPN_Code_Application(String pValeur)
  {
    m_YI23Infra.setCDAPN_Code_Application(pValeur);
  }
  
  public void setCodeErreurCDAPN_Code_Application(String pCodeErreur)
  {
    m_YI23Infra.setCDAPN_Code_Application_C_ERR(pCodeErreur);
  }
  
  public String getCDDOD()
  {
    return m_YI23Infra.getCDDOD_Code_Domaine();
  }
  
  public String getCodeErreurCDDOD()
  {
    return m_YI23Infra.getCDDOD_Code_Domaine_C_ERR();
  }
  
  public void setCDDOD(String pValeur)
  {
    m_YI23Infra.setCDDOD_Code_Domaine(pValeur);
  }
  
  public void setCodeErreurCDDOD(String pCodeErreur)
  {
    m_YI23Infra.setCDDOD_Code_Domaine_C_ERR(pCodeErreur);
  }
  
  public String getCDDOD_Code_Domaine()
  {
    return m_YI23Infra.getCDDOD_Code_Domaine();
  }
  
  public String getCodeErreurCDDOD_Code_Domaine()
  {
    return m_YI23Infra.getCDDOD_Code_Domaine_C_ERR();
  }
  
  public void setCDDOD_Code_Domaine(String pValeur)
  {
    m_YI23Infra.setCDDOD_Code_Domaine(pValeur);
  }
  
  public void setCodeErreurCDDOD_Code_Domaine(String pCodeErreur)
  {
    m_YI23Infra.setCDDOD_Code_Domaine_C_ERR(pCodeErreur);
  }
  
  public String getCDCAV()
  {
    return m_YI23Infra.getCDCAV_Code_Activite();
  }
  
  public String getCodeErreurCDCAV()
  {
    return m_YI23Infra.getCDCAV_Code_Activite_C_ERR();
  }
  
  public void setCDCAV(String pValeur)
  {
    m_YI23Infra.setCDCAV_Code_Activite(pValeur);
  }
  
  public void setCodeErreurCDCAV(String pCodeErreur)
  {
    m_YI23Infra.setCDCAV_Code_Activite_C_ERR(pCodeErreur);
  }
  
  public String getCDCAV_Code_Activite()
  {
    return m_YI23Infra.getCDCAV_Code_Activite();
  }
  
  public String getCodeErreurCDCAV_Code_Activite()
  {
    return m_YI23Infra.getCDCAV_Code_Activite_C_ERR();
  }
  
  public void setCDCAV_Code_Activite(String pValeur)
  {
    m_YI23Infra.setCDCAV_Code_Activite(pValeur);
  }
  
  public void setCodeErreurCDCAV_Code_Activite(String pCodeErreur)
  {
    m_YI23Infra.setCDCAV_Code_Activite_C_ERR(pCodeErreur);
  }
  
  public _YI23 getYI23Infra()
  {
    return m_YI23Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCSASRE() != null) && 
      ("".equals(getCodeErreurCSASRE()))) {
      return true;
    }
    if ((getCodeErreurCDAPN() != null) && 
      ("".equals(getCodeErreurCDAPN()))) {
      return true;
    }
    if ((getCodeErreurCDDOD() != null) && 
      ("".equals(getCodeErreurCDDOD()))) {
      return true;
    }
    if ((getCodeErreurCDCAV() != null) && 
      ("".equals(getCodeErreurCDCAV()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI23Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */