package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI26Impl
  extends YI26
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI26 m_YI26Infra;
  
  public _YI26Impl()
  {
    m_YI26Infra = new _YI26();
  }
  
  public _YI26Impl(_YI26 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI26Infra", pValeur);
    
    m_YI26Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI26Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI26Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI26Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI26Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI26Infra.set_C_ETAT(pCode);
  }
  
  public String getCDETY()
  {
    return m_YI26Infra.getCDETY_Type_Entite();
  }
  
  public String getCodeErreurCDETY()
  {
    return m_YI26Infra.getCDETY_Type_Entite_C_ERR();
  }
  
  public void setCDETY(String pValeur)
  {
    m_YI26Infra.setCDETY_Type_Entite(pValeur);
  }
  
  public void setCodeErreurCDETY(String pCodeErreur)
  {
    m_YI26Infra.setCDETY_Type_Entite_C_ERR(pCodeErreur);
  }
  
  public String getCDETY_Type_Entite()
  {
    return m_YI26Infra.getCDETY_Type_Entite();
  }
  
  public String getCodeErreurCDETY_Type_Entite()
  {
    return m_YI26Infra.getCDETY_Type_Entite_C_ERR();
  }
  
  public void setCDETY_Type_Entite(String pValeur)
  {
    m_YI26Infra.setCDETY_Type_Entite(pValeur);
  }
  
  public void setCodeErreurCDETY_Type_Entite(String pCodeErreur)
  {
    m_YI26Infra.setCDETY_Type_Entite_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getCXALAT()
  {
    return m_YI26Infra.getCXALAT_IDENTIFIANT_NATIONAL_INTERNE();
  }
  
  public String getCodeErreurCXALAT()
  {
    return m_YI26Infra.getCXALAT_IDENTIFIANT_NATIONAL_INTERNE_C_ERR();
  }
  
  public void setCXALAT(BigDecimal pValeur)
  {
    m_YI26Infra.setCXALAT_IDENTIFIANT_NATIONAL_INTERNE(pValeur);
  }
  
  public void setCodeErreurCXALAT(String pCodeErreur)
  {
    m_YI26Infra.setCXALAT_IDENTIFIANT_NATIONAL_INTERNE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getCXALAT_IDENTIFIANT_NATIONAL_INTERNE()
  {
    return m_YI26Infra.getCXALAT_IDENTIFIANT_NATIONAL_INTERNE();
  }
  
  public String getCodeErreurCXALAT_IDENTIFIANT_NATIONAL_INTERNE()
  {
    return m_YI26Infra.getCXALAT_IDENTIFIANT_NATIONAL_INTERNE_C_ERR();
  }
  
  public void setCXALAT_IDENTIFIANT_NATIONAL_INTERNE(BigDecimal pValeur)
  {
    m_YI26Infra.setCXALAT_IDENTIFIANT_NATIONAL_INTERNE(pValeur);
  }
  
  public void setCodeErreurCXALAT_IDENTIFIANT_NATIONAL_INTERNE(String pCodeErreur)
  {
    m_YI26Infra.setCXALAT_IDENTIFIANT_NATIONAL_INTERNE_C_ERR(pCodeErreur);
  }
  
  public String getCCIND()
  {
    return m_YI26Infra.getCCIND_CODE_INDIVIDU();
  }
  
  public String getCodeErreurCCIND()
  {
    return m_YI26Infra.getCCIND_CODE_INDIVIDU_C_ERR();
  }
  
  public void setCCIND(String pValeur)
  {
    m_YI26Infra.setCCIND_CODE_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCCIND(String pCodeErreur)
  {
    m_YI26Infra.setCCIND_CODE_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  public String getCCIND_CODE_INDIVIDU()
  {
    return m_YI26Infra.getCCIND_CODE_INDIVIDU();
  }
  
  public String getCodeErreurCCIND_CODE_INDIVIDU()
  {
    return m_YI26Infra.getCCIND_CODE_INDIVIDU_C_ERR();
  }
  
  public void setCCIND_CODE_INDIVIDU(String pValeur)
  {
    m_YI26Infra.setCCIND_CODE_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCCIND_CODE_INDIVIDU(String pCodeErreur)
  {
    m_YI26Infra.setCCIND_CODE_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  public String getCDIDA()
  {
    return m_YI26Infra.getCDIDA_Code_Autre_Identifiant();
  }
  
  public String getCodeErreurCDIDA()
  {
    return m_YI26Infra.getCDIDA_Code_Autre_Identifiant_C_ERR();
  }
  
  public void setCDIDA(String pValeur)
  {
    m_YI26Infra.setCDIDA_Code_Autre_Identifiant(pValeur);
  }
  
  public void setCodeErreurCDIDA(String pCodeErreur)
  {
    m_YI26Infra.setCDIDA_Code_Autre_Identifiant_C_ERR(pCodeErreur);
  }
  
  public String getCDIDA_Code_Autre_Identifiant()
  {
    return m_YI26Infra.getCDIDA_Code_Autre_Identifiant();
  }
  
  public String getCodeErreurCDIDA_Code_Autre_Identifiant()
  {
    return m_YI26Infra.getCDIDA_Code_Autre_Identifiant_C_ERR();
  }
  
  public void setCDIDA_Code_Autre_Identifiant(String pValeur)
  {
    m_YI26Infra.setCDIDA_Code_Autre_Identifiant(pValeur);
  }
  
  public void setCodeErreurCDIDA_Code_Autre_Identifiant(String pCodeErreur)
  {
    m_YI26Infra.setCDIDA_Code_Autre_Identifiant_C_ERR(pCodeErreur);
  }
  
  public String getCSANK()
  {
    return m_YI26Infra.getCSANK_Code_Antenne();
  }
  
  public String getCodeErreurCSANK()
  {
    return m_YI26Infra.getCSANK_Code_Antenne_C_ERR();
  }
  
  public void setCSANK(String pValeur)
  {
    m_YI26Infra.setCSANK_Code_Antenne(pValeur);
  }
  
  public void setCodeErreurCSANK(String pCodeErreur)
  {
    m_YI26Infra.setCSANK_Code_Antenne_C_ERR(pCodeErreur);
  }
  
  public String getCSANK_Code_Antenne()
  {
    return m_YI26Infra.getCSANK_Code_Antenne();
  }
  
  public String getCodeErreurCSANK_Code_Antenne()
  {
    return m_YI26Infra.getCSANK_Code_Antenne_C_ERR();
  }
  
  public void setCSANK_Code_Antenne(String pValeur)
  {
    m_YI26Infra.setCSANK_Code_Antenne(pValeur);
  }
  
  public void setCodeErreurCSANK_Code_Antenne(String pCodeErreur)
  {
    m_YI26Infra.setCSANK_Code_Antenne_C_ERR(pCodeErreur);
  }
  
  public _YI26 getYI26Infra()
  {
    return m_YI26Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCDETY() != null) && 
      ("".equals(getCodeErreurCDETY()))) {
      return true;
    }
    if ((getCodeErreurCXALAT() != null) && 
      ("".equals(getCodeErreurCXALAT()))) {
      return true;
    }
    if ((getCodeErreurCCIND() != null) && 
      ("".equals(getCodeErreurCCIND()))) {
      return true;
    }
    if ((getCodeErreurCDIDA() != null) && 
      ("".equals(getCodeErreurCDIDA()))) {
      return true;
    }
    if ((getCodeErreurCSANK() != null) && 
      ("".equals(getCodeErreurCSANK()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI26Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */