package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import fr.unedic.util.temps.Damj;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI55Impl
  extends YI55
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI55 m_YI55Infra;
  
  public _YI55Impl()
  {
    m_YI55Infra = new _YI55();
  }
  
  public _YI55Impl(_YI55 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI55Infra", pValeur);
    
    m_YI55Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI55Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI55Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI55Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI55Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI55Infra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getRSPEC()
  {
    return m_YI55Infra.getRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurRSPEC()
  {
    return m_YI55Infra.getRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setRSPEC(BigDecimal pValeur)
  {
    m_YI55Infra.setRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurRSPEC(String pCodeErreur)
  {
    m_YI55Infra.setRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE(BigDecimal pValeur)
  {
    m_YI55Infra.setRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE(String pCodeErreur)
  {
    m_YI55Infra.setRSPEC_IDENTIFIANT_DE_LA_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public Damj getDSINDB()
  {
    return m_YI55Infra.getDSINDB_DATE_INSCRIPTION_PEC__format_db2_();
  }
  
  public String getCodeErreurDSINDB()
  {
    return m_YI55Infra.getDSINDB_DATE_INSCRIPTION_PEC__format_db2__C_ERR();
  }
  
  public void setDSINDB(Damj pValeur)
  {
    m_YI55Infra.setDSINDB_DATE_INSCRIPTION_PEC__format_db2_(pValeur);
  }
  
  public void setCodeErreurDSINDB(String pCodeErreur)
  {
    m_YI55Infra.setDSINDB_DATE_INSCRIPTION_PEC__format_db2__C_ERR(pCodeErreur);
  }
  
  public Damj getDSINDB_DATE_INSCRIPTION_PEC__format_db2_()
  {
    return m_YI55Infra.getDSINDB_DATE_INSCRIPTION_PEC__format_db2_();
  }
  
  public String getCodeErreurDSINDB_DATE_INSCRIPTION_PEC__format_db2_()
  {
    return m_YI55Infra.getDSINDB_DATE_INSCRIPTION_PEC__format_db2__C_ERR();
  }
  
  public void setDSINDB_DATE_INSCRIPTION_PEC__format_db2_(Damj pValeur)
  {
    m_YI55Infra.setDSINDB_DATE_INSCRIPTION_PEC__format_db2_(pValeur);
  }
  
  public void setCodeErreurDSINDB_DATE_INSCRIPTION_PEC__format_db2_(String pCodeErreur)
  {
    m_YI55Infra.setDSINDB_DATE_INSCRIPTION_PEC__format_db2__C_ERR(pCodeErreur);
  }
  
  public Damj getDSANDB()
  {
    return m_YI55Infra.getDSANDB_DATE_ANNULATION_Pec__format_db2_();
  }
  
  public String getCodeErreurDSANDB()
  {
    return m_YI55Infra.getDSANDB_DATE_ANNULATION_Pec__format_db2__C_ERR();
  }
  
  public void setDSANDB(Damj pValeur)
  {
    m_YI55Infra.setDSANDB_DATE_ANNULATION_Pec__format_db2_(pValeur);
  }
  
  public void setCodeErreurDSANDB(String pCodeErreur)
  {
    m_YI55Infra.setDSANDB_DATE_ANNULATION_Pec__format_db2__C_ERR(pCodeErreur);
  }
  
  public Damj getDSANDB_DATE_ANNULATION_Pec__format_db2_()
  {
    return m_YI55Infra.getDSANDB_DATE_ANNULATION_Pec__format_db2_();
  }
  
  public String getCodeErreurDSANDB_DATE_ANNULATION_Pec__format_db2_()
  {
    return m_YI55Infra.getDSANDB_DATE_ANNULATION_Pec__format_db2__C_ERR();
  }
  
  public void setDSANDB_DATE_ANNULATION_Pec__format_db2_(Damj pValeur)
  {
    m_YI55Infra.setDSANDB_DATE_ANNULATION_Pec__format_db2_(pValeur);
  }
  
  public void setCodeErreurDSANDB_DATE_ANNULATION_Pec__format_db2_(String pCodeErreur)
  {
    m_YI55Infra.setDSANDB_DATE_ANNULATION_Pec__format_db2__C_ERR(pCodeErreur);
  }
  
  public String getCSMAN()
  {
    return m_YI55Infra.getCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurCSMAN()
  {
    return m_YI55Infra.getCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setCSMAN(String pValeur)
  {
    m_YI55Infra.setCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurCSMAN(String pCodeErreur)
  {
    m_YI55Infra.setCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public String getCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE(String pValeur)
  {
    m_YI55Infra.setCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE(String pCodeErreur)
  {
    m_YI55Infra.setCSMAN_MOTIF_D_ANNULATION_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public String getCSCAT()
  {
    return m_YI55Infra.getCSCAT_CODE_CATEGORIE();
  }
  
  public String getCodeErreurCSCAT()
  {
    return m_YI55Infra.getCSCAT_CODE_CATEGORIE_C_ERR();
  }
  
  public void setCSCAT(String pValeur)
  {
    m_YI55Infra.setCSCAT_CODE_CATEGORIE(pValeur);
  }
  
  public void setCodeErreurCSCAT(String pCodeErreur)
  {
    m_YI55Infra.setCSCAT_CODE_CATEGORIE_C_ERR(pCodeErreur);
  }
  
  public String getCSCAT_CODE_CATEGORIE()
  {
    return m_YI55Infra.getCSCAT_CODE_CATEGORIE();
  }
  
  public String getCodeErreurCSCAT_CODE_CATEGORIE()
  {
    return m_YI55Infra.getCSCAT_CODE_CATEGORIE_C_ERR();
  }
  
  public void setCSCAT_CODE_CATEGORIE(String pValeur)
  {
    m_YI55Infra.setCSCAT_CODE_CATEGORIE(pValeur);
  }
  
  public void setCodeErreurCSCAT_CODE_CATEGORIE(String pCodeErreur)
  {
    m_YI55Infra.setCSCAT_CODE_CATEGORIE_C_ERR(pCodeErreur);
  }
  
  public String getCSTPC()
  {
    return m_YI55Infra.getCSTPC_TYPE_DE_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurCSTPC()
  {
    return m_YI55Infra.getCSTPC_TYPE_DE_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setCSTPC(String pValeur)
  {
    m_YI55Infra.setCSTPC_TYPE_DE_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurCSTPC(String pCodeErreur)
  {
    m_YI55Infra.setCSTPC_TYPE_DE_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public String getCSTPC_TYPE_DE_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getCSTPC_TYPE_DE_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurCSTPC_TYPE_DE_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getCSTPC_TYPE_DE_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setCSTPC_TYPE_DE_PRISE_EN_CHARGE(String pValeur)
  {
    m_YI55Infra.setCSTPC_TYPE_DE_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurCSTPC_TYPE_DE_PRISE_EN_CHARGE(String pCodeErreur)
  {
    m_YI55Infra.setCSTPC_TYPE_DE_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public String getCSSPH()
  {
    return m_YI55Infra.getCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurCSSPH()
  {
    return m_YI55Infra.getCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setCSSPH(String pValeur)
  {
    m_YI55Infra.setCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurCSSPH(String pCodeErreur)
  {
    m_YI55Infra.setCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public String getCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE();
  }
  
  public String getCodeErreurCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE()
  {
    return m_YI55Infra.getCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE_C_ERR();
  }
  
  public void setCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE(String pValeur)
  {
    m_YI55Infra.setCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE(pValeur);
  }
  
  public void setCodeErreurCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE(String pCodeErreur)
  {
    m_YI55Infra.setCSSPH_SOUS_TYPE_DE_PRISE_EN_CHARGE_C_ERR(pCodeErreur);
  }
  
  public String getRSALF()
  {
    return m_YI55Infra.getRSALF_ALE_DE_L_INDIVIDU_DANS_PJC();
  }
  
  public String getCodeErreurRSALF()
  {
    return m_YI55Infra.getRSALF_ALE_DE_L_INDIVIDU_DANS_PJC_C_ERR();
  }
  
  public void setRSALF(String pValeur)
  {
    m_YI55Infra.setRSALF_ALE_DE_L_INDIVIDU_DANS_PJC(pValeur);
  }
  
  public void setCodeErreurRSALF(String pCodeErreur)
  {
    m_YI55Infra.setRSALF_ALE_DE_L_INDIVIDU_DANS_PJC_C_ERR(pCodeErreur);
  }
  
  public String getRSALF_ALE_DE_L_INDIVIDU_DANS_PJC()
  {
    return m_YI55Infra.getRSALF_ALE_DE_L_INDIVIDU_DANS_PJC();
  }
  
  public String getCodeErreurRSALF_ALE_DE_L_INDIVIDU_DANS_PJC()
  {
    return m_YI55Infra.getRSALF_ALE_DE_L_INDIVIDU_DANS_PJC_C_ERR();
  }
  
  public void setRSALF_ALE_DE_L_INDIVIDU_DANS_PJC(String pValeur)
  {
    m_YI55Infra.setRSALF_ALE_DE_L_INDIVIDU_DANS_PJC(pValeur);
  }
  
  public void setCodeErreurRSALF_ALE_DE_L_INDIVIDU_DANS_PJC(String pCodeErreur)
  {
    m_YI55Infra.setRSALF_ALE_DE_L_INDIVIDU_DANS_PJC_C_ERR(pCodeErreur);
  }
  
  public String getCSEMP()
  {
    return m_YI55Infra.getCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI();
  }
  
  public String getCodeErreurCSEMP()
  {
    return m_YI55Infra.getCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI_C_ERR();
  }
  
  public void setCSEMP(String pValeur)
  {
    m_YI55Infra.setCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI(pValeur);
  }
  
  public void setCodeErreurCSEMP(String pCodeErreur)
  {
    m_YI55Infra.setCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI_C_ERR(pCodeErreur);
  }
  
  public String getCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI()
  {
    return m_YI55Infra.getCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI();
  }
  
  public String getCodeErreurCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI()
  {
    return m_YI55Infra.getCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI_C_ERR();
  }
  
  public void setCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI(String pValeur)
  {
    m_YI55Infra.setCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI(pValeur);
  }
  
  public void setCodeErreurCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI(String pCodeErreur)
  {
    m_YI55Infra.setCSEMP_SITUATION_AU_REGARD_DE_L_EMPLOI_C_ERR(pCodeErreur);
  }
  
  public String getCSCDT()
  {
    return m_YI55Infra.getCSCDT_CODE_AU_TITRE_DE();
  }
  
  public String getCodeErreurCSCDT()
  {
    return m_YI55Infra.getCSCDT_CODE_AU_TITRE_DE_C_ERR();
  }
  
  public void setCSCDT(String pValeur)
  {
    m_YI55Infra.setCSCDT_CODE_AU_TITRE_DE(pValeur);
  }
  
  public void setCodeErreurCSCDT(String pCodeErreur)
  {
    m_YI55Infra.setCSCDT_CODE_AU_TITRE_DE_C_ERR(pCodeErreur);
  }
  
  public String getCSCDT_CODE_AU_TITRE_DE()
  {
    return m_YI55Infra.getCSCDT_CODE_AU_TITRE_DE();
  }
  
  public String getCodeErreurCSCDT_CODE_AU_TITRE_DE()
  {
    return m_YI55Infra.getCSCDT_CODE_AU_TITRE_DE_C_ERR();
  }
  
  public void setCSCDT_CODE_AU_TITRE_DE(String pValeur)
  {
    m_YI55Infra.setCSCDT_CODE_AU_TITRE_DE(pValeur);
  }
  
  public void setCodeErreurCSCDT_CODE_AU_TITRE_DE(String pCodeErreur)
  {
    m_YI55Infra.setCSCDT_CODE_AU_TITRE_DE_C_ERR(pCodeErreur);
  }
  
  public String getCSPTD()
  {
    return m_YI55Infra.getCSPTD_TYPE_DE_PEREMPTION();
  }
  
  public String getCodeErreurCSPTD()
  {
    return m_YI55Infra.getCSPTD_TYPE_DE_PEREMPTION_C_ERR();
  }
  
  public void setCSPTD(String pValeur)
  {
    m_YI55Infra.setCSPTD_TYPE_DE_PEREMPTION(pValeur);
  }
  
  public void setCodeErreurCSPTD(String pCodeErreur)
  {
    m_YI55Infra.setCSPTD_TYPE_DE_PEREMPTION_C_ERR(pCodeErreur);
  }
  
  public String getCSPTD_TYPE_DE_PEREMPTION()
  {
    return m_YI55Infra.getCSPTD_TYPE_DE_PEREMPTION();
  }
  
  public String getCodeErreurCSPTD_TYPE_DE_PEREMPTION()
  {
    return m_YI55Infra.getCSPTD_TYPE_DE_PEREMPTION_C_ERR();
  }
  
  public void setCSPTD_TYPE_DE_PEREMPTION(String pValeur)
  {
    m_YI55Infra.setCSPTD_TYPE_DE_PEREMPTION(pValeur);
  }
  
  public void setCodeErreurCSPTD_TYPE_DE_PEREMPTION(String pCodeErreur)
  {
    m_YI55Infra.setCSPTD_TYPE_DE_PEREMPTION_C_ERR(pCodeErreur);
  }
  
  public String getCCNIN()
  {
    return m_YI55Infra.getCCNIN_Code_Contexte_PEC_non_indemnisable();
  }
  
  public String getCodeErreurCCNIN()
  {
    return m_YI55Infra.getCCNIN_Code_Contexte_PEC_non_indemnisable_C_ERR();
  }
  
  public void setCCNIN(String pValeur)
  {
    m_YI55Infra.setCCNIN_Code_Contexte_PEC_non_indemnisable(pValeur);
  }
  
  public void setCodeErreurCCNIN(String pCodeErreur)
  {
    m_YI55Infra.setCCNIN_Code_Contexte_PEC_non_indemnisable_C_ERR(pCodeErreur);
  }
  
  public String getCCNIN_Code_Contexte_PEC_non_indemnisable()
  {
    return m_YI55Infra.getCCNIN_Code_Contexte_PEC_non_indemnisable();
  }
  
  public String getCodeErreurCCNIN_Code_Contexte_PEC_non_indemnisable()
  {
    return m_YI55Infra.getCCNIN_Code_Contexte_PEC_non_indemnisable_C_ERR();
  }
  
  public void setCCNIN_Code_Contexte_PEC_non_indemnisable(String pValeur)
  {
    m_YI55Infra.setCCNIN_Code_Contexte_PEC_non_indemnisable(pValeur);
  }
  
  public void setCodeErreurCCNIN_Code_Contexte_PEC_non_indemnisable(String pCodeErreur)
  {
    m_YI55Infra.setCCNIN_Code_Contexte_PEC_non_indemnisable_C_ERR(pCodeErreur);
  }
  
  public String getCSPEE()
  {
    return m_YI55Infra.getCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE();
  }
  
  public String getCodeErreurCSPEE()
  {
    return m_YI55Infra.getCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE_C_ERR();
  }
  
  public void setCSPEE(String pValeur)
  {
    m_YI55Infra.setCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE(pValeur);
  }
  
  public void setCodeErreurCSPEE(String pCodeErreur)
  {
    m_YI55Infra.setCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE_C_ERR(pCodeErreur);
  }
  
  public String getCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE()
  {
    return m_YI55Infra.getCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE();
  }
  
  public String getCodeErreurCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE()
  {
    return m_YI55Infra.getCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE_C_ERR();
  }
  
  public void setCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE(String pValeur)
  {
    m_YI55Infra.setCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE(pValeur);
  }
  
  public void setCodeErreurCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE(String pCodeErreur)
  {
    m_YI55Infra.setCSPEE_CODE_PAYS_DE_l_UNION_EUROPENNE_C_ERR(pCodeErreur);
  }
  
  public String getCCEES()
  {
    return m_YI55Infra.getCCEES_Contexte_rEglement_europEen();
  }
  
  public String getCodeErreurCCEES()
  {
    return m_YI55Infra.getCCEES_Contexte_rEglement_europEen_C_ERR();
  }
  
  public void setCCEES(String pValeur)
  {
    m_YI55Infra.setCCEES_Contexte_rEglement_europEen(pValeur);
  }
  
  public void setCodeErreurCCEES(String pCodeErreur)
  {
    m_YI55Infra.setCCEES_Contexte_rEglement_europEen_C_ERR(pCodeErreur);
  }
  
  public String getCCEES_Contexte_rEglement_europEen()
  {
    return m_YI55Infra.getCCEES_Contexte_rEglement_europEen();
  }
  
  public String getCodeErreurCCEES_Contexte_rEglement_europEen()
  {
    return m_YI55Infra.getCCEES_Contexte_rEglement_europEen_C_ERR();
  }
  
  public void setCCEES_Contexte_rEglement_europEen(String pValeur)
  {
    m_YI55Infra.setCCEES_Contexte_rEglement_europEen(pValeur);
  }
  
  public void setCodeErreurCCEES_Contexte_rEglement_europEen(String pCodeErreur)
  {
    m_YI55Infra.setCCEES_Contexte_rEglement_europEen_C_ERR(pCodeErreur);
  }
  
  public String getISAFE()
  {
    return m_YI55Infra.getISAFE_NUMERO_AFFILIATION_EMPLOYEUR();
  }
  
  public String getCodeErreurISAFE()
  {
    return m_YI55Infra.getISAFE_NUMERO_AFFILIATION_EMPLOYEUR_C_ERR();
  }
  
  public void setISAFE(String pValeur)
  {
    m_YI55Infra.setISAFE_NUMERO_AFFILIATION_EMPLOYEUR(pValeur);
  }
  
  public void setCodeErreurISAFE(String pCodeErreur)
  {
    m_YI55Infra.setISAFE_NUMERO_AFFILIATION_EMPLOYEUR_C_ERR(pCodeErreur);
  }
  
  public String getISAFE_NUMERO_AFFILIATION_EMPLOYEUR()
  {
    return m_YI55Infra.getISAFE_NUMERO_AFFILIATION_EMPLOYEUR();
  }
  
  public String getCodeErreurISAFE_NUMERO_AFFILIATION_EMPLOYEUR()
  {
    return m_YI55Infra.getISAFE_NUMERO_AFFILIATION_EMPLOYEUR_C_ERR();
  }
  
  public void setISAFE_NUMERO_AFFILIATION_EMPLOYEUR(String pValeur)
  {
    m_YI55Infra.setISAFE_NUMERO_AFFILIATION_EMPLOYEUR(pValeur);
  }
  
  public void setCodeErreurISAFE_NUMERO_AFFILIATION_EMPLOYEUR(String pCodeErreur)
  {
    m_YI55Infra.setISAFE_NUMERO_AFFILIATION_EMPLOYEUR_C_ERR(pCodeErreur);
  }
  
  public String getCDSIR()
  {
    return m_YI55Infra.getCDSIR_CODE_SIREN();
  }
  
  public String getCodeErreurCDSIR()
  {
    return m_YI55Infra.getCDSIR_CODE_SIREN_C_ERR();
  }
  
  public void setCDSIR(String pValeur)
  {
    m_YI55Infra.setCDSIR_CODE_SIREN(pValeur);
  }
  
  public void setCodeErreurCDSIR(String pCodeErreur)
  {
    m_YI55Infra.setCDSIR_CODE_SIREN_C_ERR(pCodeErreur);
  }
  
  public String getCDSIR_CODE_SIREN()
  {
    return m_YI55Infra.getCDSIR_CODE_SIREN();
  }
  
  public String getCodeErreurCDSIR_CODE_SIREN()
  {
    return m_YI55Infra.getCDSIR_CODE_SIREN_C_ERR();
  }
  
  public void setCDSIR_CODE_SIREN(String pValeur)
  {
    m_YI55Infra.setCDSIR_CODE_SIREN(pValeur);
  }
  
  public void setCodeErreurCDSIR_CODE_SIREN(String pCodeErreur)
  {
    m_YI55Infra.setCDSIR_CODE_SIREN_C_ERR(pCodeErreur);
  }
  
  public String getCXALAB()
  {
    return m_YI55Infra.getCXALAB_IDENTIFIANT_NATIONAL_INTERNE();
  }
  
  public String getCodeErreurCXALAB()
  {
    return m_YI55Infra.getCXALAB_IDENTIFIANT_NATIONAL_INTERNE_C_ERR();
  }
  
  public void setCXALAB(String pValeur)
  {
    m_YI55Infra.setCXALAB_IDENTIFIANT_NATIONAL_INTERNE(pValeur);
  }
  
  public void setCodeErreurCXALAB(String pCodeErreur)
  {
    m_YI55Infra.setCXALAB_IDENTIFIANT_NATIONAL_INTERNE_C_ERR(pCodeErreur);
  }
  
  public String getCXALAB_IDENTIFIANT_NATIONAL_INTERNE()
  {
    return m_YI55Infra.getCXALAB_IDENTIFIANT_NATIONAL_INTERNE();
  }
  
  public String getCodeErreurCXALAB_IDENTIFIANT_NATIONAL_INTERNE()
  {
    return m_YI55Infra.getCXALAB_IDENTIFIANT_NATIONAL_INTERNE_C_ERR();
  }
  
  public void setCXALAB_IDENTIFIANT_NATIONAL_INTERNE(String pValeur)
  {
    m_YI55Infra.setCXALAB_IDENTIFIANT_NATIONAL_INTERNE(pValeur);
  }
  
  public void setCodeErreurCXALAB_IDENTIFIANT_NATIONAL_INTERNE(String pCodeErreur)
  {
    m_YI55Infra.setCXALAB_IDENTIFIANT_NATIONAL_INTERNE_C_ERR(pCodeErreur);
  }
  
  public _YI55 getYI55Infra()
  {
    return m_YI55Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurRSPEC() != null) && 
      ("".equals(getCodeErreurRSPEC()))) {
      return true;
    }
    if ((getCodeErreurDSINDB() != null) && 
      ("".equals(getCodeErreurDSINDB()))) {
      return true;
    }
    if ((getCodeErreurDSANDB() != null) && 
      ("".equals(getCodeErreurDSANDB()))) {
      return true;
    }
    if ((getCodeErreurCSMAN() != null) && 
      ("".equals(getCodeErreurCSMAN()))) {
      return true;
    }
    if ((getCodeErreurCSCAT() != null) && 
      ("".equals(getCodeErreurCSCAT()))) {
      return true;
    }
    if ((getCodeErreurCSTPC() != null) && 
      ("".equals(getCodeErreurCSTPC()))) {
      return true;
    }
    if ((getCodeErreurCSSPH() != null) && 
      ("".equals(getCodeErreurCSSPH()))) {
      return true;
    }
    if ((getCodeErreurRSALF() != null) && 
      ("".equals(getCodeErreurRSALF()))) {
      return true;
    }
    if ((getCodeErreurCSEMP() != null) && 
      ("".equals(getCodeErreurCSEMP()))) {
      return true;
    }
    if ((getCodeErreurCSCDT() != null) && 
      ("".equals(getCodeErreurCSCDT()))) {
      return true;
    }
    if ((getCodeErreurCSPTD() != null) && 
      ("".equals(getCodeErreurCSPTD()))) {
      return true;
    }
    if ((getCodeErreurCCNIN() != null) && 
      ("".equals(getCodeErreurCCNIN()))) {
      return true;
    }
    if ((getCodeErreurCSPEE() != null) && 
      ("".equals(getCodeErreurCSPEE()))) {
      return true;
    }
    if ((getCodeErreurCCEES() != null) && 
      ("".equals(getCodeErreurCCEES()))) {
      return true;
    }
    if ((getCodeErreurISAFE() != null) && 
      ("".equals(getCodeErreurISAFE()))) {
      return true;
    }
    if ((getCodeErreurCDSIR() != null) && 
      ("".equals(getCodeErreurCDSIR()))) {
      return true;
    }
    if ((getCodeErreurCXALAB() != null) && 
      ("".equals(getCodeErreurCXALAB()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI55Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */