package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import fr.unedic.util.temps.Damj;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI67Impl
  extends YI67
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI67 m_YI67Infra;
  
  public _YI67Impl()
  {
    m_YI67Infra = new _YI67();
  }
  
  public _YI67Impl(_YI67 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI67Infra", pValeur);
    
    m_YI67Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI67Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI67Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI67Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI67Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI67Infra.set_C_ETAT(pCode);
  }
  
  public String getCDGAM2()
  {
    return m_YI67Infra.getCDGAM2_GAMME_DE_PRODUIT_NCP();
  }
  
  public String getCodeErreurCDGAM2()
  {
    return m_YI67Infra.getCDGAM2_GAMME_DE_PRODUIT_NCP_C_ERR();
  }
  
  public void setCDGAM2(String pValeur)
  {
    m_YI67Infra.setCDGAM2_GAMME_DE_PRODUIT_NCP(pValeur);
  }
  
  public void setCodeErreurCDGAM2(String pCodeErreur)
  {
    m_YI67Infra.setCDGAM2_GAMME_DE_PRODUIT_NCP_C_ERR(pCodeErreur);
  }
  
  public String getCDGAM2_GAMME_DE_PRODUIT_NCP()
  {
    return m_YI67Infra.getCDGAM2_GAMME_DE_PRODUIT_NCP();
  }
  
  public String getCodeErreurCDGAM2_GAMME_DE_PRODUIT_NCP()
  {
    return m_YI67Infra.getCDGAM2_GAMME_DE_PRODUIT_NCP_C_ERR();
  }
  
  public void setCDGAM2_GAMME_DE_PRODUIT_NCP(String pValeur)
  {
    m_YI67Infra.setCDGAM2_GAMME_DE_PRODUIT_NCP(pValeur);
  }
  
  public void setCodeErreurCDGAM2_GAMME_DE_PRODUIT_NCP(String pCodeErreur)
  {
    m_YI67Infra.setCDGAM2_GAMME_DE_PRODUIT_NCP_C_ERR(pCodeErreur);
  }
  
  public String getCDLIS2()
  {
    return m_YI67Infra.getCDLIS2_LIGNE_DE_PRODUIT_NCP();
  }
  
  public String getCodeErreurCDLIS2()
  {
    return m_YI67Infra.getCDLIS2_LIGNE_DE_PRODUIT_NCP_C_ERR();
  }
  
  public void setCDLIS2(String pValeur)
  {
    m_YI67Infra.setCDLIS2_LIGNE_DE_PRODUIT_NCP(pValeur);
  }
  
  public void setCodeErreurCDLIS2(String pCodeErreur)
  {
    m_YI67Infra.setCDLIS2_LIGNE_DE_PRODUIT_NCP_C_ERR(pCodeErreur);
  }
  
  public String getCDLIS2_LIGNE_DE_PRODUIT_NCP()
  {
    return m_YI67Infra.getCDLIS2_LIGNE_DE_PRODUIT_NCP();
  }
  
  public String getCodeErreurCDLIS2_LIGNE_DE_PRODUIT_NCP()
  {
    return m_YI67Infra.getCDLIS2_LIGNE_DE_PRODUIT_NCP_C_ERR();
  }
  
  public void setCDLIS2_LIGNE_DE_PRODUIT_NCP(String pValeur)
  {
    m_YI67Infra.setCDLIS2_LIGNE_DE_PRODUIT_NCP(pValeur);
  }
  
  public void setCodeErreurCDLIS2_LIGNE_DE_PRODUIT_NCP(String pCodeErreur)
  {
    m_YI67Infra.setCDLIS2_LIGNE_DE_PRODUIT_NCP_C_ERR(pCodeErreur);
  }
  
  public String getCPROD2()
  {
    return m_YI67Infra.getCPROD2_CODE_PRODUIT();
  }
  
  public String getCodeErreurCPROD2()
  {
    return m_YI67Infra.getCPROD2_CODE_PRODUIT_C_ERR();
  }
  
  public void setCPROD2(String pValeur)
  {
    m_YI67Infra.setCPROD2_CODE_PRODUIT(pValeur);
  }
  
  public void setCodeErreurCPROD2(String pCodeErreur)
  {
    m_YI67Infra.setCPROD2_CODE_PRODUIT_C_ERR(pCodeErreur);
  }
  
  public String getCPROD2_CODE_PRODUIT()
  {
    return m_YI67Infra.getCPROD2_CODE_PRODUIT();
  }
  
  public String getCodeErreurCPROD2_CODE_PRODUIT()
  {
    return m_YI67Infra.getCPROD2_CODE_PRODUIT_C_ERR();
  }
  
  public void setCPROD2_CODE_PRODUIT(String pValeur)
  {
    m_YI67Infra.setCPROD2_CODE_PRODUIT(pValeur);
  }
  
  public void setCodeErreurCPROD2_CODE_PRODUIT(String pCodeErreur)
  {
    m_YI67Infra.setCPROD2_CODE_PRODUIT_C_ERR(pCodeErreur);
  }
  
  public String getCDEXA2()
  {
    return m_YI67Infra.getCDEXA2_TYPE_D_EXAMEN();
  }
  
  public String getCodeErreurCDEXA2()
  {
    return m_YI67Infra.getCDEXA2_TYPE_D_EXAMEN_C_ERR();
  }
  
  public void setCDEXA2(String pValeur)
  {
    m_YI67Infra.setCDEXA2_TYPE_D_EXAMEN(pValeur);
  }
  
  public void setCodeErreurCDEXA2(String pCodeErreur)
  {
    m_YI67Infra.setCDEXA2_TYPE_D_EXAMEN_C_ERR(pCodeErreur);
  }
  
  public String getCDEXA2_TYPE_D_EXAMEN()
  {
    return m_YI67Infra.getCDEXA2_TYPE_D_EXAMEN();
  }
  
  public String getCodeErreurCDEXA2_TYPE_D_EXAMEN()
  {
    return m_YI67Infra.getCDEXA2_TYPE_D_EXAMEN_C_ERR();
  }
  
  public void setCDEXA2_TYPE_D_EXAMEN(String pValeur)
  {
    m_YI67Infra.setCDEXA2_TYPE_D_EXAMEN(pValeur);
  }
  
  public void setCodeErreurCDEXA2_TYPE_D_EXAMEN(String pCodeErreur)
  {
    m_YI67Infra.setCDEXA2_TYPE_D_EXAMEN_C_ERR(pCodeErreur);
  }
  
  public Damj getDEPOT2()
  {
    return m_YI67Infra.getDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2();
  }
  
  public String getCodeErreurDEPOT2()
  {
    return m_YI67Infra.getDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2_C_ERR();
  }
  
  public void setDEPOT2(Damj pValeur)
  {
    m_YI67Infra.setDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2(pValeur);
  }
  
  public void setCodeErreurDEPOT2(String pCodeErreur)
  {
    m_YI67Infra.setDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2_C_ERR(pCodeErreur);
  }
  
  public Damj getDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2()
  {
    return m_YI67Infra.getDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2();
  }
  
  public String getCodeErreurDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2()
  {
    return m_YI67Infra.getDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2_C_ERR();
  }
  
  public void setDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2(Damj pValeur)
  {
    m_YI67Infra.setDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2(pValeur);
  }
  
  public void setCodeErreurDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2(String pCodeErreur)
  {
    m_YI67Infra.setDEPOT2_DATE_DE_DEPOT_DE_LA_DAL_DB2_C_ERR(pCodeErreur);
  }
  
  public Damj getDSEXA2()
  {
    return m_YI67Infra.getDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2();
  }
  
  public String getCodeErreurDSEXA2()
  {
    return m_YI67Infra.getDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2_C_ERR();
  }
  
  public void setDSEXA2(Damj pValeur)
  {
    m_YI67Infra.setDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2(pValeur);
  }
  
  public void setCodeErreurDSEXA2(String pCodeErreur)
  {
    m_YI67Infra.setDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2_C_ERR(pCodeErreur);
  }
  
  public Damj getDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2()
  {
    return m_YI67Infra.getDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2();
  }
  
  public String getCodeErreurDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2()
  {
    return m_YI67Infra.getDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2_C_ERR();
  }
  
  public void setDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2(Damj pValeur)
  {
    m_YI67Infra.setDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2(pValeur);
  }
  
  public void setCodeErreurDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2(String pCodeErreur)
  {
    m_YI67Infra.setDSEXA2_DATE_EXAMEN_CONDITIONS_O_D__DB2_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSPEC9()
  {
    return m_YI67Infra.getRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_();
  }
  
  public String getCodeErreurRSPEC9()
  {
    return m_YI67Infra.getRSPEC9_IDENTIFIANT_DERNIERE_P_E_C__C_ERR();
  }
  
  public void setRSPEC9(BigDecimal pValeur)
  {
    m_YI67Infra.setRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_(pValeur);
  }
  
  public void setCodeErreurRSPEC9(String pCodeErreur)
  {
    m_YI67Infra.setRSPEC9_IDENTIFIANT_DERNIERE_P_E_C__C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_()
  {
    return m_YI67Infra.getRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_();
  }
  
  public String getCodeErreurRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_()
  {
    return m_YI67Infra.getRSPEC9_IDENTIFIANT_DERNIERE_P_E_C__C_ERR();
  }
  
  public void setRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_(BigDecimal pValeur)
  {
    m_YI67Infra.setRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_(pValeur);
  }
  
  public void setCodeErreurRSPEC9_IDENTIFIANT_DERNIERE_P_E_C_(String pCodeErreur)
  {
    m_YI67Infra.setRSPEC9_IDENTIFIANT_DERNIERE_P_E_C__C_ERR(pCodeErreur);
  }
  
  public String getREFEX2()
  {
    return m_YI67Infra.getREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE();
  }
  
  public String getCodeErreurREFEX2()
  {
    return m_YI67Infra.getREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR();
  }
  
  public void setREFEX2(String pValeur)
  {
    m_YI67Infra.setREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE(pValeur);
  }
  
  public void setCodeErreurREFEX2(String pCodeErreur)
  {
    m_YI67Infra.setREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR(pCodeErreur);
  }
  
  public String getREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE()
  {
    return m_YI67Infra.getREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE();
  }
  
  public String getCodeErreurREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE()
  {
    return m_YI67Infra.getREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR();
  }
  
  public void setREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE(String pValeur)
  {
    m_YI67Infra.setREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE(pValeur);
  }
  
  public void setCodeErreurREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE(String pCodeErreur)
  {
    m_YI67Infra.setREFEX2_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR(pCodeErreur);
  }
  
  public String getCDDAL2()
  {
    return m_YI67Infra.getCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE();
  }
  
  public String getCodeErreurCDDAL2()
  {
    return m_YI67Infra.getCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE_C_ERR();
  }
  
  public void setCDDAL2(String pValeur)
  {
    m_YI67Infra.setCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE(pValeur);
  }
  
  public void setCodeErreurCDDAL2(String pCodeErreur)
  {
    m_YI67Infra.setCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE_C_ERR(pCodeErreur);
  }
  
  public String getCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE()
  {
    return m_YI67Infra.getCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE();
  }
  
  public String getCodeErreurCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE()
  {
    return m_YI67Infra.getCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE_C_ERR();
  }
  
  public void setCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE(String pValeur)
  {
    m_YI67Infra.setCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE(pValeur);
  }
  
  public void setCodeErreurCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE(String pCodeErreur)
  {
    m_YI67Infra.setCDDAL2_CODE_ETAT_DEMANDE_LIQUIDABLE_C_ERR(pCodeErreur);
  }
  
  public String getFSPAE2()
  {
    return m_YI67Infra.getFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR();
  }
  
  public String getCodeErreurFSPAE2()
  {
    return m_YI67Infra.getFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR_C_ERR();
  }
  
  public void setFSPAE2(String pValeur)
  {
    m_YI67Infra.setFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR(pValeur);
  }
  
  public void setCodeErreurFSPAE2(String pCodeErreur)
  {
    m_YI67Infra.setFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR_C_ERR(pCodeErreur);
  }
  
  public String getFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR()
  {
    return m_YI67Infra.getFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR();
  }
  
  public String getCodeErreurFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR()
  {
    return m_YI67Infra.getFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR_C_ERR();
  }
  
  public void setFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR(String pValeur)
  {
    m_YI67Infra.setFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR(pValeur);
  }
  
  public void setCodeErreurFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR(String pCodeErreur)
  {
    m_YI67Infra.setFSPAE2_INDICATEUR_PRESENCE_ATTEST_EMPLOYEUR_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSF32()
  {
    return m_YI67Infra.getRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION();
  }
  
  public String getCodeErreurRSF32()
  {
    return m_YI67Infra.getRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION_C_ERR();
  }
  
  public void setRSF32(BigDecimal pValeur)
  {
    m_YI67Infra.setRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION(pValeur);
  }
  
  public void setCodeErreurRSF32(String pCodeErreur)
  {
    m_YI67Infra.setRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION()
  {
    return m_YI67Infra.getRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION();
  }
  
  public String getCodeErreurRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION()
  {
    return m_YI67Infra.getRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION_C_ERR();
  }
  
  public void setRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION(BigDecimal pValeur)
  {
    m_YI67Infra.setRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION(pValeur);
  }
  
  public void setCodeErreurRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION(String pCodeErreur)
  {
    m_YI67Infra.setRSF32_IDENTIFIANT_DU_PLAN_DE_FORMATION_C_ERR(pCodeErreur);
  }
  
  public String getFSFNE2()
  {
    return m_YI67Infra.getFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE();
  }
  
  public String getCodeErreurFSFNE2()
  {
    return m_YI67Infra.getFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE_C_ERR();
  }
  
  public void setFSFNE2(String pValeur)
  {
    m_YI67Infra.setFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE(pValeur);
  }
  
  public void setCodeErreurFSFNE2(String pCodeErreur)
  {
    m_YI67Infra.setFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE_C_ERR(pCodeErreur);
  }
  
  public String getFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE()
  {
    return m_YI67Infra.getFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE();
  }
  
  public String getCodeErreurFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE()
  {
    return m_YI67Infra.getFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE_C_ERR();
  }
  
  public void setFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE(String pValeur)
  {
    m_YI67Infra.setFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE(pValeur);
  }
  
  public void setCodeErreurFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE(String pCodeErreur)
  {
    m_YI67Infra.setFSFNE2_REFUS_D_ADHESION_A_CONVENTION_FNE_C_ERR(pCodeErreur);
  }
  
  public String getFSCRS2()
  {
    return m_YI67Infra.getFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT();
  }
  
  public String getCodeErreurFSCRS2()
  {
    return m_YI67Infra.getFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT_C_ERR();
  }
  
  public void setFSCRS2(String pValeur)
  {
    m_YI67Infra.setFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT(pValeur);
  }
  
  public void setCodeErreurFSCRS2(String pCodeErreur)
  {
    m_YI67Infra.setFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT_C_ERR(pCodeErreur);
  }
  
  public String getFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT()
  {
    return m_YI67Infra.getFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT();
  }
  
  public String getCodeErreurFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT()
  {
    return m_YI67Infra.getFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT_C_ERR();
  }
  
  public void setFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT(String pValeur)
  {
    m_YI67Infra.setFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT(pValeur);
  }
  
  public void setCodeErreurFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT(String pCodeErreur)
  {
    m_YI67Infra.setFSCRS2_DE_CONCERNE_PAR_CONGE_RECLASSEMENT_C_ERR(pCodeErreur);
  }
  
  public String getFSANT2()
  {
    return m_YI67Infra.getFSANT2_PROPOSITION_PARE_ANTICIPE();
  }
  
  public String getCodeErreurFSANT2()
  {
    return m_YI67Infra.getFSANT2_PROPOSITION_PARE_ANTICIPE_C_ERR();
  }
  
  public void setFSANT2(String pValeur)
  {
    m_YI67Infra.setFSANT2_PROPOSITION_PARE_ANTICIPE(pValeur);
  }
  
  public void setCodeErreurFSANT2(String pCodeErreur)
  {
    m_YI67Infra.setFSANT2_PROPOSITION_PARE_ANTICIPE_C_ERR(pCodeErreur);
  }
  
  public String getFSANT2_PROPOSITION_PARE_ANTICIPE()
  {
    return m_YI67Infra.getFSANT2_PROPOSITION_PARE_ANTICIPE();
  }
  
  public String getCodeErreurFSANT2_PROPOSITION_PARE_ANTICIPE()
  {
    return m_YI67Infra.getFSANT2_PROPOSITION_PARE_ANTICIPE_C_ERR();
  }
  
  public void setFSANT2_PROPOSITION_PARE_ANTICIPE(String pValeur)
  {
    m_YI67Infra.setFSANT2_PROPOSITION_PARE_ANTICIPE(pValeur);
  }
  
  public void setCodeErreurFSANT2_PROPOSITION_PARE_ANTICIPE(String pCodeErreur)
  {
    m_YI67Infra.setFSANT2_PROPOSITION_PARE_ANTICIPE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSEQV2()
  {
    return m_YI67Infra.getRSEQV2_NUMERO_DOSSIER_DV();
  }
  
  public String getCodeErreurRSEQV2()
  {
    return m_YI67Infra.getRSEQV2_NUMERO_DOSSIER_DV_C_ERR();
  }
  
  public void setRSEQV2(BigDecimal pValeur)
  {
    m_YI67Infra.setRSEQV2_NUMERO_DOSSIER_DV(pValeur);
  }
  
  public void setCodeErreurRSEQV2(String pCodeErreur)
  {
    m_YI67Infra.setRSEQV2_NUMERO_DOSSIER_DV_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSEQV2_NUMERO_DOSSIER_DV()
  {
    return m_YI67Infra.getRSEQV2_NUMERO_DOSSIER_DV();
  }
  
  public String getCodeErreurRSEQV2_NUMERO_DOSSIER_DV()
  {
    return m_YI67Infra.getRSEQV2_NUMERO_DOSSIER_DV_C_ERR();
  }
  
  public void setRSEQV2_NUMERO_DOSSIER_DV(BigDecimal pValeur)
  {
    m_YI67Infra.setRSEQV2_NUMERO_DOSSIER_DV(pValeur);
  }
  
  public void setCodeErreurRSEQV2_NUMERO_DOSSIER_DV(String pCodeErreur)
  {
    m_YI67Infra.setRSEQV2_NUMERO_DOSSIER_DV_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSIA22()
  {
    return m_YI67Infra.getRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE();
  }
  
  public String getCodeErreurRSIA22()
  {
    return m_YI67Infra.getRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE_C_ERR();
  }
  
  public void setRSIA22(BigDecimal pValeur)
  {
    m_YI67Infra.setRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE(pValeur);
  }
  
  public void setCodeErreurRSIA22(String pCodeErreur)
  {
    m_YI67Infra.setRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE()
  {
    return m_YI67Infra.getRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE();
  }
  
  public String getCodeErreurRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE()
  {
    return m_YI67Infra.getRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE_C_ERR();
  }
  
  public void setRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE(BigDecimal pValeur)
  {
    m_YI67Infra.setRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE(pValeur);
  }
  
  public void setCodeErreurRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE(String pCodeErreur)
  {
    m_YI67Infra.setRSIA22_REFERENCE_DEMANDE_ALLOCATION_SUIVIE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSEQ23()
  {
    return m_YI67Infra.getRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_();
  }
  
  public String getCodeErreurRSEQ23()
  {
    return m_YI67Infra.getRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV__C_ERR();
  }
  
  public void setRSEQ23(BigDecimal pValeur)
  {
    m_YI67Infra.setRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_(pValeur);
  }
  
  public void setCodeErreurRSEQ23(String pCodeErreur)
  {
    m_YI67Infra.setRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV__C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_()
  {
    return m_YI67Infra.getRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_();
  }
  
  public String getCodeErreurRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_()
  {
    return m_YI67Infra.getRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV__C_ERR();
  }
  
  public void setRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_(BigDecimal pValeur)
  {
    m_YI67Infra.setRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_(pValeur);
  }
  
  public void setCodeErreurRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV_(String pCodeErreur)
  {
    m_YI67Infra.setRSEQ23_NUMERO_DOSSIER_DE_SUIVI_RENOUV__C_ERR(pCodeErreur);
  }
  
  public String getFSDAL2()
  {
    return m_YI67Infra.getFSDAL2_ENVOI_DAL_EFFECTUE();
  }
  
  public String getCodeErreurFSDAL2()
  {
    return m_YI67Infra.getFSDAL2_ENVOI_DAL_EFFECTUE_C_ERR();
  }
  
  public void setFSDAL2(String pValeur)
  {
    m_YI67Infra.setFSDAL2_ENVOI_DAL_EFFECTUE(pValeur);
  }
  
  public void setCodeErreurFSDAL2(String pCodeErreur)
  {
    m_YI67Infra.setFSDAL2_ENVOI_DAL_EFFECTUE_C_ERR(pCodeErreur);
  }
  
  public String getFSDAL2_ENVOI_DAL_EFFECTUE()
  {
    return m_YI67Infra.getFSDAL2_ENVOI_DAL_EFFECTUE();
  }
  
  public String getCodeErreurFSDAL2_ENVOI_DAL_EFFECTUE()
  {
    return m_YI67Infra.getFSDAL2_ENVOI_DAL_EFFECTUE_C_ERR();
  }
  
  public void setFSDAL2_ENVOI_DAL_EFFECTUE(String pValeur)
  {
    m_YI67Infra.setFSDAL2_ENVOI_DAL_EFFECTUE(pValeur);
  }
  
  public void setCodeErreurFSDAL2_ENVOI_DAL_EFFECTUE(String pCodeErreur)
  {
    m_YI67Infra.setFSDAL2_ENVOI_DAL_EFFECTUE_C_ERR(pCodeErreur);
  }
  
  public String getRSTICE()
  {
    return m_YI67Infra.getRSTICE_TIERS_DEMANDEUR();
  }
  
  public String getCodeErreurRSTICE()
  {
    return m_YI67Infra.getRSTICE_TIERS_DEMANDEUR_C_ERR();
  }
  
  public void setRSTICE(String pValeur)
  {
    m_YI67Infra.setRSTICE_TIERS_DEMANDEUR(pValeur);
  }
  
  public void setCodeErreurRSTICE(String pCodeErreur)
  {
    m_YI67Infra.setRSTICE_TIERS_DEMANDEUR_C_ERR(pCodeErreur);
  }
  
  public String getRSTICE_TIERS_DEMANDEUR()
  {
    return m_YI67Infra.getRSTICE_TIERS_DEMANDEUR();
  }
  
  public String getCodeErreurRSTICE_TIERS_DEMANDEUR()
  {
    return m_YI67Infra.getRSTICE_TIERS_DEMANDEUR_C_ERR();
  }
  
  public void setRSTICE_TIERS_DEMANDEUR(String pValeur)
  {
    m_YI67Infra.setRSTICE_TIERS_DEMANDEUR(pValeur);
  }
  
  public void setCodeErreurRSTICE_TIERS_DEMANDEUR(String pCodeErreur)
  {
    m_YI67Infra.setRSTICE_TIERS_DEMANDEUR_C_ERR(pCodeErreur);
  }
  
  public String getFFMAN2()
  {
    return m_YI67Infra.getFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE();
  }
  
  public String getCodeErreurFFMAN2()
  {
    return m_YI67Infra.getFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE_C_ERR();
  }
  
  public void setFFMAN2(String pValeur)
  {
    m_YI67Infra.setFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE(pValeur);
  }
  
  public void setCodeErreurFFMAN2(String pCodeErreur)
  {
    m_YI67Infra.setFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE_C_ERR(pCodeErreur);
  }
  
  public String getFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE()
  {
    return m_YI67Infra.getFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE();
  }
  
  public String getCodeErreurFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE()
  {
    return m_YI67Infra.getFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE_C_ERR();
  }
  
  public void setFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE(String pValeur)
  {
    m_YI67Infra.setFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE(pValeur);
  }
  
  public void setCodeErreurFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE(String pCodeErreur)
  {
    m_YI67Infra.setFFMAN2_TOP_MANDATEMENT_DEMANDE_EFFECTUE_C_ERR(pCodeErreur);
  }
  
  public String getRSTICQ()
  {
    return m_YI67Infra.getRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE();
  }
  
  public String getCodeErreurRSTICQ()
  {
    return m_YI67Infra.getRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE_C_ERR();
  }
  
  public void setRSTICQ(String pValeur)
  {
    m_YI67Infra.setRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE(pValeur);
  }
  
  public void setCodeErreurRSTICQ(String pCodeErreur)
  {
    m_YI67Infra.setRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE_C_ERR(pCodeErreur);
  }
  
  public String getRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE()
  {
    return m_YI67Infra.getRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE();
  }
  
  public String getCodeErreurRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE()
  {
    return m_YI67Infra.getRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE_C_ERR();
  }
  
  public void setRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE(String pValeur)
  {
    m_YI67Infra.setRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE(pValeur);
  }
  
  public void setCodeErreurRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE(String pCodeErreur)
  {
    m_YI67Infra.setRSTICQ_TIERS_CONCERNE_PAR_LA_DEMANDE_C_ERR(pCodeErreur);
  }
  
  public String getFSLCDR()
  {
    return m_YI67Infra.getFSLCDR_TOP_LIEN_COMPLETUDE_DAL();
  }
  
  public String getCodeErreurFSLCDR()
  {
    return m_YI67Infra.getFSLCDR_TOP_LIEN_COMPLETUDE_DAL_C_ERR();
  }
  
  public void setFSLCDR(String pValeur)
  {
    m_YI67Infra.setFSLCDR_TOP_LIEN_COMPLETUDE_DAL(pValeur);
  }
  
  public void setCodeErreurFSLCDR(String pCodeErreur)
  {
    m_YI67Infra.setFSLCDR_TOP_LIEN_COMPLETUDE_DAL_C_ERR(pCodeErreur);
  }
  
  public String getFSLCDR_TOP_LIEN_COMPLETUDE_DAL()
  {
    return m_YI67Infra.getFSLCDR_TOP_LIEN_COMPLETUDE_DAL();
  }
  
  public String getCodeErreurFSLCDR_TOP_LIEN_COMPLETUDE_DAL()
  {
    return m_YI67Infra.getFSLCDR_TOP_LIEN_COMPLETUDE_DAL_C_ERR();
  }
  
  public void setFSLCDR_TOP_LIEN_COMPLETUDE_DAL(String pValeur)
  {
    m_YI67Infra.setFSLCDR_TOP_LIEN_COMPLETUDE_DAL(pValeur);
  }
  
  public void setCodeErreurFSLCDR_TOP_LIEN_COMPLETUDE_DAL(String pCodeErreur)
  {
    m_YI67Infra.setFSLCDR_TOP_LIEN_COMPLETUDE_DAL_C_ERR(pCodeErreur);
  }
  
  public _YI67 getYI67Infra()
  {
    return m_YI67Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCDGAM2() != null) && 
      ("".equals(getCodeErreurCDGAM2()))) {
      return true;
    }
    if ((getCodeErreurCDLIS2() != null) && 
      ("".equals(getCodeErreurCDLIS2()))) {
      return true;
    }
    if ((getCodeErreurCPROD2() != null) && 
      ("".equals(getCodeErreurCPROD2()))) {
      return true;
    }
    if ((getCodeErreurCDEXA2() != null) && 
      ("".equals(getCodeErreurCDEXA2()))) {
      return true;
    }
    if ((getCodeErreurDEPOT2() != null) && 
      ("".equals(getCodeErreurDEPOT2()))) {
      return true;
    }
    if ((getCodeErreurDSEXA2() != null) && 
      ("".equals(getCodeErreurDSEXA2()))) {
      return true;
    }
    if ((getCodeErreurRSPEC9() != null) && 
      ("".equals(getCodeErreurRSPEC9()))) {
      return true;
    }
    if ((getCodeErreurREFEX2() != null) && 
      ("".equals(getCodeErreurREFEX2()))) {
      return true;
    }
    if ((getCodeErreurCDDAL2() != null) && 
      ("".equals(getCodeErreurCDDAL2()))) {
      return true;
    }
    if ((getCodeErreurFSPAE2() != null) && 
      ("".equals(getCodeErreurFSPAE2()))) {
      return true;
    }
    if ((getCodeErreurRSF32() != null) && 
      ("".equals(getCodeErreurRSF32()))) {
      return true;
    }
    if ((getCodeErreurFSFNE2() != null) && 
      ("".equals(getCodeErreurFSFNE2()))) {
      return true;
    }
    if ((getCodeErreurFSCRS2() != null) && 
      ("".equals(getCodeErreurFSCRS2()))) {
      return true;
    }
    if ((getCodeErreurFSANT2() != null) && 
      ("".equals(getCodeErreurFSANT2()))) {
      return true;
    }
    if ((getCodeErreurRSEQV2() != null) && 
      ("".equals(getCodeErreurRSEQV2()))) {
      return true;
    }
    if ((getCodeErreurRSIA22() != null) && 
      ("".equals(getCodeErreurRSIA22()))) {
      return true;
    }
    if ((getCodeErreurRSEQ23() != null) && 
      ("".equals(getCodeErreurRSEQ23()))) {
      return true;
    }
    if ((getCodeErreurFSDAL2() != null) && 
      ("".equals(getCodeErreurFSDAL2()))) {
      return true;
    }
    if ((getCodeErreurRSTICE() != null) && 
      ("".equals(getCodeErreurRSTICE()))) {
      return true;
    }
    if ((getCodeErreurFFMAN2() != null) && 
      ("".equals(getCodeErreurFFMAN2()))) {
      return true;
    }
    if ((getCodeErreurRSTICQ() != null) && 
      ("".equals(getCodeErreurRSTICQ()))) {
      return true;
    }
    if ((getCodeErreurFSLCDR() != null) && 
      ("".equals(getCodeErreurFSLCDR()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI67Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */