package fr.unedic.logique.service.rac.commun.dra.d01;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.contexte.Utilisateur;
import fr.unedic.archi.logique.deploiement.DomaineFabrique;

public abstract class DomaineD01Fabrique
  extends DomaineFabrique
{
  public static DomaineD01ServiceSync getDomaineD01ServiceSync()
    throws TechniqueException
  {
    DomaineD01ServiceSync domaineInstance = (DomaineD01ServiceSync)getCachedDomaineInstance(DomaineD01ServiceSync.class);
    DomaineD01ServiceSync retour;
    DomaineD01ServiceSync retour;
    if (domaineInstance == null) {
      retour = loadDomaineInstanceSync();
    } else {
      retour = domaineInstance;
    }
    return retour;
  }
  
  public static DomaineD01ServiceAsync getDomaineD01ServiceAsync()
    throws TechniqueException
  {
    DomaineD01ServiceAsync domaineInstance = (DomaineD01ServiceAsync)getCachedDomaineInstance(DomaineD01ServiceAsync.class);
    DomaineD01ServiceAsync retour;
    DomaineD01ServiceAsync retour;
    if (domaineInstance == null) {
      retour = loadDomaineInstanceAsync();
    } else {
      retour = domaineInstance;
    }
    return retour;
  }
  
  public static DomaineD01Flux getDomaineD01Flux(Utilisateur pUtilisateur, String pAssedic)
    throws TechniqueException
  {
    DomaineD01Flux domaineInstance = (DomaineD01Flux)getCachedDomaineInstance(DomaineD01Flux.class);
    _DomaineD01FluxImpl impl;
    _DomaineD01FluxImpl impl;
    if (domaineInstance == null)
    {
      DomaineD01Flux newDomaine = loadDomaineInstanceFlux(pUtilisateur, pAssedic);
      
      ExceptionUtil.assertInstanceOf("newDomaine", newDomaine, _DomaineD01FluxImpl.class);
      
      impl = (_DomaineD01FluxImpl)newDomaine;
    }
    else
    {
      ExceptionUtil.assertInstanceOf("domaineInstance", domaineInstance, _DomaineD01FluxImpl.class);
      impl = (_DomaineD01FluxImpl)domaineInstance;
    }
    impl.setCodeAssedic(pAssedic);
    impl.setUtilisateur(pUtilisateur);
    
    return impl;
  }
  
  public static DomaineD01Flux getDomaineD01Flux()
    throws TechniqueException
  {
    return getDomaineD01Flux(getCurrentUser(), getCurrentAssedic());
  }
  
  public static DomaineD01Flux getDomaineD01Flux(Utilisateur pUtilisateur)
    throws TechniqueException
  {
    return getDomaineD01Flux(pUtilisateur, getCurrentAssedic());
  }
  
  public static DomaineD01Flux getDomaineD01Flux(String pAssedic)
    throws TechniqueException
  {
    return getDomaineD01Flux(getCurrentUser(), pAssedic);
  }
  
  private static synchronized DomaineD01ServiceSync loadDomaineInstanceSync()
    throws TechniqueException
  {
    DomaineD01ServiceSync domaineInstance = (DomaineD01ServiceSync)getCachedDomaineInstance(DomaineD01ServiceSync.class);
    DomaineD01ServiceSync retour;
    DomaineD01ServiceSync retour;
    if (domaineInstance == null)
    {
      DomaineD01ServiceSyncImpl domaineImpl = new DomaineD01ServiceSyncImpl();
      retour = (DomaineD01ServiceSync)configureDomaineSyncImpl(DomaineD01ServiceSync.class, domaineImpl);
    }
    else
    {
      retour = domaineInstance;
    }
    return retour;
  }
  
  private static synchronized DomaineD01ServiceAsync loadDomaineInstanceAsync()
    throws TechniqueException
  {
    DomaineD01ServiceAsync domaineInstance = (DomaineD01ServiceAsync)getCachedDomaineInstance(DomaineD01ServiceAsync.class);
    DomaineD01ServiceAsync retour;
    DomaineD01ServiceAsync retour;
    if (domaineInstance == null)
    {
      DomaineD01ServiceAsyncImpl domaineImpl = new DomaineD01ServiceAsyncImpl();
      retour = (DomaineD01ServiceAsync)configureDomaineAsyncImpl(DomaineD01ServiceAsync.class, domaineImpl);
    }
    else
    {
      retour = domaineInstance;
    }
    return retour;
  }
  
  private static synchronized DomaineD01Flux loadDomaineInstanceFlux(Utilisateur pUser, String pAssedic)
    throws TechniqueException
  {
    DomaineD01Flux domaineInstance = (DomaineD01Flux)getCachedDomaineInstance(DomaineD01Flux.class, pUser, pAssedic);
    DomaineD01Flux retour;
    DomaineD01Flux retour;
    if (domaineInstance == null)
    {
      _DomaineD01FluxImpl domaineImpl = new _DomaineD01FluxImpl();
      retour = (DomaineD01Flux)configureDomaineFluxImpl(DomaineD01Flux.class, domaineImpl, pUser, pAssedic);
    }
    else
    {
      retour = domaineInstance;
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     DomaineD01Fabrique
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */