package fr.unedic.cali.asu.asr.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.DeterminationCompetenceCge;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ResultatDeterminationCompetence;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.Entreprise;
import fr.unedic.util.services.CoucheLogiqueException;

public class DeterminationCompetence
  extends DeterminationCompetenceCge
{
  public static DeterminationCompetenceCge getInstance()
  {
    return new DeterminationCompetence();
  }
  
  public void determinerChargeIndemnisationDroitCourant(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    int champApplicationFg = demande.getFaitGenerateur().getPeriodeFaitGenerateur().getChampApplicationRenseigne();
    int competence = 0;
    if (champApplicationFg == 1)
    {
      if ((!demande.getFaitGenerateur().getPeriodeFaitGenerateur().getEntreprise().isEstSecteurPublic()) || (demande.getFaitGenerateur().getPeriodeFaitGenerateur().getEntreprise().isEstEmployeurAdherantATitreIrrevocable())) {
        competence = 1;
      } else {
        competence = 2;
      }
    }
    else if ((champApplicationFg == 3) || (champApplicationFg == 4)) {
      competence = 2;
    } else if (champApplicationFg == 14) {
      competence = 1;
    } else {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_L_CALI_CHAMP_APPLICATION_ASP");
    }
    resultatDeterminationCompetence.setChargeIndemnisationDroitCourant(competence);
  }
  
  protected void determinerEmployeurCompetentSecteurPublic(Demande p_demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    ActiviteSalarie faitGenerateur = p_demande.getFaitGenerateur().getPeriodeFaitGenerateur();
    resultatDeterminationCompetence.setLibelleEmployeurCompetent(faitGenerateur.getEntreprise().getLibelleEntreprise());
  }
  
  protected void determinerRegimeFinancementSecteurPrive(Demande p_demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {}
  
  public void determinerCompetenceAdministrativeDroitCourant(Demande p_demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
  {
    resultatDeterminationCompetence.setCompetenceAdministrative(resultatDeterminationCompetence.getChargeIndemnisationDroitCourant());
    if (resultatDeterminationCompetence.getCompetenceAdministrative() == 2) {
      resultatDeterminationCompetence.setEstPCRCForce(p_demande.getDonneesTemporaires().isEstPCRCForceDroitCourant());
    }
  }
}

/* Location:
 * Qualified Name:     DeterminationCompetence
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */