package fr.unedic.cali.asu.asr.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionReglementApplicable;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.services.OutilFonctionnel;

public class DeterminationReglementApplicable
  implements OutilFonctionnel
{
  public static DeterminationReglementApplicable getInstance()
  {
    return new DeterminationReglementApplicable();
  }
  
  public ConstitutionReglementApplicable determinerReglementApplicable(Demande p_demande)
    throws ApplicativeException
  {
    ConstitutionReglementApplicable reglementApplicable = ((DossierExamen)p_demande.getDossierExamen()).getConstitutionElementsActifs().createConstitutionReglementApplicable();
    
    Reglement reglementValidation = ((DossierAffectation)p_demande.getDossierAffectation()).getReglementPeriodeValidationProduit();
    
    Reglement reglementDernierSinistre = ((ActiviteSalarie)((DossierAffectation)p_demande.getDossierAffectation()).getSinistre()).getReglement();
    
    String contexteDemande = p_demande.getContexteAffiliationValide();
    boolean estContexteAsrSuiteCsrOuAeRevise = false;
    if (contexteDemande != null) {
      estContexteAsrSuiteCsrOuAeRevise = true;
    }
    if ((!estContexteAsrSuiteCsrOuAeRevise) && ((reglementValidation == null) || (!reglementValidation.getLibelleCourt().equals(reglementDernierSinistre.getLibelleCourt())))) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A11MB25");
    }
    reglementApplicable.setReglement(reglementDernierSinistre);
    
    return reglementApplicable;
  }
}

/* Location:
 * Qualified Name:     DeterminationReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */