package fr.unedic.cali.asu.caa14.calcul.dom;

import fr.unedic.cali.asu.caa14.calcul.dom.gen.MontantASPAREFGen;
import fr.unedic.cali.asu.caa14.calcul.dom.pc.MontantASPAREFPC;
import fr.unedic.cali.dom.MontantAREFSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.util.ObjetMetierSpec;

public class MontantASPAREF
  extends MontantASPAREFGen
  implements DomGenSpec, MontantAREFSpec
{
  private static final long serialVersionUID = 1L;
  
  private MontantASPAREF() {}
  
  public MontantASPAREF(Montant p_montant)
  {
    setMontantBrut(p_montant.getMontantBrut());
    setCrc(p_montant.getCrc());
    setBase(p_montant.getBase());
    setBaseCalculCrc(p_montant.getBaseCalculCrc());
    setCrds(p_montant.getCrds());
    setCsg(p_montant.getCsg());
    setJustificationCalculMontant(p_montant.getJustificationCalculMontant());
    setMini(p_montant.getMini());
    setMontantBrutSansPensionInvaliditeADeduire(p_montant.getMontantBrutSansPensionInvaliditeADeduire());
    setPensionInvaliditeADeduirePriseEnCompte(p_montant.getPensionInvaliditeADeduirePriseEnCompte());
    setPlafond(p_montant.getPlafond());
    setPlancher(p_montant.getPlancher());
    setPositionExonerationCrc(p_montant.getPositionExonerationCrc());
    setTauxCrc(p_montant.getTauxCrc());
    setTotalCotisationContribution(p_montant.getTotalCotisationContribution());
    setType(p_montant.getType());
    setSjrNonReduit(p_montant.getSjrNonReduit());
    setMiniFormation(p_montant.getMiniFormation());
  }
  
  public MontantASPAREF(MontantBaseSpec p_montant)
  {
    setMontantBrut(p_montant.getMontantBrut());
    setCrc(p_montant.getCrc());
    setBase(p_montant.getBase());
    setBaseCalculCrc(p_montant.getBaseCalculCrc());
    setCrds(p_montant.getCrds());
    setCsg(p_montant.getCsg());
    setJustificationCalculMontant(p_montant.getJustificationCalculMontant());
    setMini(p_montant.getMini());
    setMontantBrutSansPensionInvaliditeADeduire(p_montant.getMontantBrutSansPensionInvaliditeADeduire());
    setPensionInvaliditeADeduirePriseEnCompte(p_montant.getPensionInvaliditeADeduirePriseEnCompte());
    setPlafond(p_montant.getPlafond());
    setPlancher(p_montant.getPlancher());
    setPositionExonerationCrc(p_montant.getPositionExonerationCrc());
    setTauxCrc(p_montant.getTauxCrc());
    setType(p_montant.getType());
    setSjrNonReduit(p_montant.getSjrNonReduit());
    setMiniFormation(p_montant.getMiniFormation());
  }
  
  public MontantASPAREF(MontantASPAREFPC p_montant)
  {
    super(p_montant);
  }
  
  public ObjetMetierSpec copie()
  {
    MontantASPAREF copie = new MontantASPAREF();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    MontantASPAREF copie = (MontantASPAREF)p_copie;
    super.copieElements(copie);
  }
}

/* Location:
 * Qualified Name:     MontantASPAREF
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */