package fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.produits.liquidation.dom.DureeIndemnisation;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.PasAssezInformationException;

public class DeterminationDureeEffective
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationDureeEffective
{
  public static fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationDureeEffective getInstance()
  {
    return new DeterminationDureeEffective();
  }
  
  public DureeIndemnisation determinerDureeEffective(Demande p_demande)
    throws PasAssezInformationException, CoucheLogiqueException, ApplicativeException
  {
    DureeIndemnisation dureeIndemnisation = super.determinerDureeEffective(p_demande);
    
    int dureeEffectiveBornee = bornerDureeEffectiveADateLimiteIndemnisation(p_demande, dureeIndemnisation.getDureeEffective().getValeurEntiere());
    
    dureeIndemnisation.setDureeEffective(new Quantite(dureeEffectiveBornee, UniteAffiliation.JOUR));
    return dureeIndemnisation;
  }
}

/* Location:
 * Qualified Name:     DeterminationDureeEffective
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */