package fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels.strategies.StrategieConstitutionProduitResultantApres;
import fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels.strategies.StrategieConstitutionProduitResultantAvant;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieConstitutionProduitResultant
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_APPLICATION = new Damj(2011, 4, 14);
  private static FabriqueStrategieConstitutionProduitResultant s_instance = new FabriqueStrategieConstitutionProduitResultant();
  
  public static FabriqueStrategieConstitutionProduitResultant getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieSpec strategie = null;
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieConstitutionProduitResultant : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieConstitutionProduitResultantApres();
    } else {
      strategie = new StrategieConstitutionProduitResultantAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieConstitutionProduitResultant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */