package fr.unedic.cali.asu.caa14.parcours.asp;

import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.caa14.liquidation.outilsfonctionnels.RechercheConditionFaitGenerateur;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ComparateurTemporelsSurDateDebut;

public class DeterminationConditionFaitGenerateur
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCAPA04 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    
    ConditionFaitGenerateur faitGenerateur = RechercheConditionFaitGenerateur.getInstance().rechercheConditionFaitGenerateur(demande);
    if (faitGenerateur.estSatisfait())
    {
      resultatCAPA04.setEtat(0);
    }
    else
    {
      resultatCAPA04.setEtat(1);
      resultatCAPA04.setMessageErreur(Integer.toString(faitGenerateur.getCodeMotifEchec()));
    }
    DomLiquidationAssurance.getDemande(contexte).getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().setComparateur(new ComparateurTemporelsSurDateDebut());
    
    OutilTrace.ecrireTrace(Niveau.DEBUG, new Object[] { "Résultat : " + resultatCAPA04 });
    
    OutilTrace.tracerFinParcours();
    
    return resultatCAPA04;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionFaitGenerateur
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */