package fr.unedic.cali.asu.calcul.dom;

import fr.unedic.cali.asu.calcul.dom.gen.DureeProlongationGen;
import fr.unedic.cali.asu.mnt.outilsfonctionnels.SimulateurImputeurDureeIndemnisation;
import fr.unedic.cali.dom.EtatQuantiteDroit;
import fr.unedic.cali.dom.ImputationJour;
import fr.unedic.cali.dom.ImputationSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.UniteDuree;
import java.math.BigDecimal;

public class DureeProlongation
  extends DureeProlongationGen
{
  private static final long serialVersionUID = 7768714887530598144L;
  public static final Unite UNITE_DEFAUT = UniteDuree.JOUR;
  public static final int NB_JOUR_STANDARD = 182;
  
  private DureeProlongation() {}
  
  public DureeProlongation(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DureeProlongation(int p_quantiteInitial)
  {
    setQuantiteInitial(new Quantite(new BigDecimal(Integer.toString(p_quantiteInitial)), UNITE_DEFAUT));
    setQuantiteCourante(new Quantite(new BigDecimal("0"), UNITE_DEFAUT));
  }
  
  public ObjetMetierSpec copie()
  {
    DureeProlongation copie = new DureeProlongation();
    copieElements(copie);
    return copie;
  }
  
  public ImputationSpec simulerImputer(Quantite p_quantite)
  {
    ImputationJour monImputation = (ImputationJour)getEtatQuantiteDroit().accepteVisiteur(new SimulateurImputeurDureeIndemnisation(this, p_quantite));
    
    return monImputation;
  }
}

/* Location:
 * Qualified Name:     DureeProlongation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */