package fr.unedic.cali.asu.calcul.dom.periode.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.calcul.dom.periode.pc.DsmTravailPC;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class DsmTravailGen
  extends DsmTravail
  implements DomGenSpec
{
  public DsmTravailGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DsmTravailGen() {}
  
  public DsmTravailGen(Damj p_dateDebut, Damj p_dateFin)
  {
    super(p_dateDebut, p_dateFin);
  }
  
  public DsmTravailGen(DsmTravail p_dsmTravail)
  {
    super(p_dsmTravail);
  }
  
  protected DomPCSpec createPC()
  {
    return new DsmTravailPC();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     DsmTravailGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */