package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieActiviteReduitePansConserveeApres;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieActiviteReduitePansConserveeAvant;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieActiviteReduitePansConserveeSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieActiviteReduitePansConservee
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_PIVOT = new Damj(2010, 4, 1);
  
  public StrategieSpec getStrategie(CritereStrategie critereStrategie)
  {
    StrategieActiviteReduitePansConserveeSpec strategie = null;
    
    Damj datePivot = critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieActiviteReduitePansConservee : la date pivot activité réduite pans conservée est nulle.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_PIVOT)) {
      strategie = new StrategieActiviteReduitePansConserveeApres();
    } else {
      strategie = new StrategieActiviteReduitePansConserveeAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieActiviteReduitePansConservee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */