package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import java.util.Iterator;

public class StrategieAREM2016Avant
  extends Qualification
  implements StrategieAREM2016Spec
{
  public QualificationPeriodes qualificationPeriodesPourAvant(QualificationPeriodes qualificationPeriodes, ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriodeCalcul periode = null;
    Iterator iterator = null;
    
    iterator = chronologiePeriodes.iterer();
    while (iterator.hasNext())
    {
      periode = (ObjetChronoPeriodeCalcul)iterator.next();
      
      boolean resultat = qualifierUnePeriodeSuspensivesPourAvant(periode, qualificationPeriodes, attribution);
      
      resultat = (qualifierUnePeriodeInterruptives(periode, qualificationPeriodes, attribution)) || (resultat);
      if (resultat)
      {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
        ObjetChronoPeriodeCalcul periodeSegmentanteEnDebut = (ObjetChronoPeriodeCalcul)periode.copie();
        periodeSegmentanteEnDebut.setDateFin(periodeSegmentanteEnDebut.getDateDebut());
        ObjetChronoPeriodeCalcul periodeSegmentanteEnFin = (ObjetChronoPeriodeCalcul)periode.copie();
        periodeSegmentanteEnFin.setDateDebut(periodeSegmentanteEnFin.getDateFin().lendemain());
        qualificationPeriodes.ajouterPeriodesSegmentantes(periodeSegmentanteEnFin);
      }
      resultat = (qualifierUnePeriodeInterruptivesDefinitives(periode, qualificationPeriodes, attribution)) || (resultat);
      resultat = (qualifierUnePeriodeSegmentantesPourAvant(periode, qualificationPeriodes, attribution)) || (resultat);
      if ((!resultat) && (estTypeAPrendreEnCompte(periode))) {
        qualificationPeriodes.ajouterPeriodesNonQualifiees(periode);
      }
    }
    return qualificationPeriodes;
  }
}

/* Location:
 * Qualified Name:     StrategieAREM2016Avant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */