package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheConditionCumulActiviteConservee;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieConditionCumulActiviteConservee;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieConditionCumulActiviteConserveeSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationPansConservees;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class StrategieActiviteReduitePansConserveeApres
  implements StrategieActiviteReduitePansConserveeSpec
{
  public BigDecimal getGainPansConserveeALaLiquidation(AttributionSpec p_attribution, BigDecimal p_cumulGainPansConservee)
    throws CoucheLogiqueException
  {
    BigDecimal remunerationBrutePansConserve = null;
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(((Attribution)p_attribution).getDateFaitGenerateurDroit());
    StrategieConditionCumulActiviteConserveeSpec strategie = (StrategieConditionCumulActiviteConserveeSpec)FabriqueStrategieConditionCumulActiviteConservee.getInstance().getStrategie(critere);
    
    Chronologie chronologiePeriodeActivitesConservees = ((Attribution)p_attribution).getListeActiviteConservee();
    
    remunerationBrutePansConserve = strategie.determinerMontantRemunerationBrutePansConserve(p_attribution, chronologiePeriodeActivitesConservees);
    if (remunerationBrutePansConserve == null)
    {
      RechercheConditionCumulActiviteConservee rechercheConditionCumulActiviteConservee = RechercheConditionCumulActiviteConservee.getInstance();
      Periode periodeAnneeCivilePrecedente = rechercheConditionCumulActiviteConservee.determinerAnneeCivilePrecedantDate(((Attribution)p_attribution).getTermePrcActiviteConservee());
      Periode periodeAnneeCivileEnCours = rechercheConditionCumulActiviteConservee.determinerDebutAnneeCivileDateExamen(((Attribution)p_attribution).getTermePrcActiviteConservee());
      JustificationPansConservees justificationPansConservees = rechercheConditionCumulActiviteConservee.determinerRemunerationMensuellePansConservees(periodeAnneeCivilePrecedente, periodeAnneeCivileEnCours, chronologiePeriodeActivitesConservees);
      if (justificationPansConservees != null) {
        remunerationBrutePansConserve = justificationPansConservees.getMontantRemunerationMensuelPansCalcule();
      }
    }
    return remunerationBrutePansConserve;
  }
}

/* Location:
 * Qualified Name:     StrategieActiviteReduitePansConserveeApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */