package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class DeterminationDateAttributionCsr
{
  public static DeterminationDateAttributionCsr getInstance()
  {
    return new DeterminationDateAttributionCsr();
  }
  
  public Damj determinerDateAttributionTheoriquePourAdmissionCsr(Demande p_demande)
    throws CoucheLogiqueException
  {
    Damj dateAttribution = p_demande.getDonneesTemporaires().getNouvelleDateAttributionChomageTotalSansRupture();
    if (dateAttribution == null)
    {
      Damj dateAttributionOdTheorique = p_demande.getDateExamen();
      Damj dateAttributionCP = p_demande.getDonneesTemporaires().getDateAttributionCPChomageTotalSansRupture();
      if (dateAttributionCP != null) {
        verifierDateAttributionForcee(p_demande, dateAttributionCP);
      }
      dateAttribution = Damj.max(dateAttributionCP, dateAttributionOdTheorique);
    }
    Periode periodeSuspension = OutilsChomageSansRCT.trouverPeriodeDeSuspension(p_demande).getPeriode();
    if (!dateAttribution.estContenueDans(periodeSuspension)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_CSR_NON_APPLICABLE_POUR_REGLEMENT");
    }
    return dateAttribution;
  }
  
  private void verifierDateAttributionForcee(Demande p_demande, Damj p_dateAttributionForcee)
    throws CoucheLogiqueException
  {
    if (!OutillagePEC.estContenueDansUnePecIndemnisable(p_demande.getDemandeur(), p_dateAttributionForcee)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A11MB22");
    }
  }
}

/* Location:
 * Qualified Name:     DeterminationDateAttributionCsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */