package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.DelaiRechercheProduit;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;

public class OutilFaitGenerateurDelaiValidite
{
  public static DelaiRechercheProduit determinerDelaiValiditeFaitGenerateur(Demande p_demande)
  {
    DelaiRechercheProduit delaiValiditeFgd = (DelaiRechercheProduit)((DossierAffectation)p_demande.getDossierAffectation()).getDelaiRecherche().copie();
    if (delaiValiditeFgd != null)
    {
      Chronologie chronoPeriodesPecIndemnisablesPrecedentes = OutillagePEC.getPeriodesPecFinAvantOuCoincideAvecDate(p_demande.getDemandeur(), p_demande.getDateExamen());
      if ((chronoPeriodesPecIndemnisablesPrecedentes != null) && (!chronoPeriodesPecIndemnisablesPrecedentes.estVide()))
      {
        ObjetChronoPeriodePriseEnCharge objetChronoPecPrecedente = (ObjetChronoPeriodePriseEnCharge)chronoPeriodesPecIndemnisablesPrecedentes.dernierElement();
        if (delaiValiditeFgd.getDebut().estAvant(objetChronoPecPrecedente.getDateFin()))
        {
          delaiValiditeFgd.setDebut(objetChronoPecPrecedente.getDateFin());
          if (delaiValiditeFgd.getDebut().estApres(delaiValiditeFgd.getFin())) {
            delaiValiditeFgd = null;
          }
        }
      }
    }
    return delaiValiditeFgd;
  }
}

/* Location:
 * Qualified Name:     OutilFaitGenerateurDelaiValidite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */