package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.mnt.dom.ConditionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Damj;

public class RechercheConditionAgePourMaintien
  implements OutilFonctionnel
{
  public static final Damj DATE_FCT_DU_FAIT_GENERATEUR = new Damj(2010, 1, 1);
  private static RechercheConditionAgePourMaintien s_instance = null;
  
  public static RechercheConditionAgePourMaintien getInstance()
  {
    if (s_instance == null) {
      s_instance = new RechercheConditionAgePourMaintien();
    }
    return s_instance;
  }
  
  public ConditionAgeMaintien rechercherConditionAge(DemandeMaintien p_demande)
  {
    ConditionAgeMaintien conditionAge = new ConditionAgeMaintien();
    Damj dateObtentionAgeMinimum = p_demande.getProduitMaintenu().getDateObtentionAgePourMaintien(p_demande);
    conditionAge.setAgeMinimum(p_demande.getProduitMaintenu().getAgeMinimumObtentionMaintien(p_demande));
    conditionAge.setDateObtentionAgeMinimum(dateObtentionAgeMinimum);
    if (dateObtentionAgeMinimum.estAvantOuCoincideAvec(p_demande.getDateExamen()))
    {
      conditionAge.setEtatConditionAge(true);
    }
    else
    {
      conditionAge.setEtatConditionAge(false);
      conditionAge.setCodeMotifEchec(981);
    }
    return conditionAge;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionAgePourMaintien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */