package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieActiviteConserveeConvention2014Apres;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieActiviteConserveeConvention2014Avant;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieActiviteConserveeConvention2014Spec;
import fr.unedic.cali.fabriques.FabriqueConvention2014;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieActiviteConserveeConvention2014
  extends FabriqueConvention2014
{
  private static FabriqueStrategieActiviteConserveeConvention2014 s_instance = new FabriqueStrategieActiviteConserveeConvention2014();
  
  public static FabriqueStrategieActiviteConserveeConvention2014 getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieActiviteConserveeConvention2014Spec strategie = null;
    
    Damj datePivotRegleAC = p_critereStrategie.getDatePivot();
    if (datePivotRegleAC == null) {
      throw new UnsupportedOperationException("FabriqueStrategieActiviteConserveeConvention2014 : la date pivot est null.");
    }
    if (datePivotRegleAC.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieActiviteConserveeConvention2014Apres();
    } else {
      strategie = new StrategieActiviteConserveeConvention2014Avant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieActiviteConserveeConvention2014
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */