package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationCompetenceSecteurPublicApres;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationCompetenceSecteurPublicAvant;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieDeterminationCompetenceSecteurPublicSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieDeterminationCompetenceSecteurPublic
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_APPLICATION = new Damj(2012, 3, 1);
  private static FabriqueStrategieDeterminationCompetenceSecteurPublic s_instance = new FabriqueStrategieDeterminationCompetenceSecteurPublic();
  
  public static FabriqueStrategieDeterminationCompetenceSecteurPublic getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieDeterminationCompetenceSecteurPublicSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieDeterminationCompetenceSecteurPublic : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieDeterminationCompetenceSecteurPublicApres();
    } else {
      strategie = new StrategieDeterminationCompetenceSecteurPublicAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieDeterminationCompetenceSecteurPublic
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */