package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieReglementAffiliationApresARE14;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieReglementAffiliationAvantARE14;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieReglementAffiliationSpec;
import fr.unedic.cali.fabriques.FabriqueConvention2014;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieReglementAffiliation
  extends FabriqueConvention2014
{
  private static FabriqueStrategieReglementAffiliation s_instance = new FabriqueStrategieReglementAffiliation();
  
  public static FabriqueStrategieReglementAffiliation getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieReglementAffiliationSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieReglementAffiliation : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieReglementAffiliationApresARE14();
    } else {
      strategie = new StrategieReglementAffiliationAvantARE14();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieReglementAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */