package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StategieDateDebutMaxActiviteConserveeSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.ContratTravail;
import fr.unedic.cali.autresdoms.ga.dom.Preavis;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class StategieDateDebutMaxActiviteConserveeAvant
  implements StategieDateDebutMaxActiviteConserveeSpec
{
  public Damj determinerDateExclueAuPlusTardDebutActiviteConservee(ActiviteSalarie p_pas)
  {
    Damj dateRetour = p_pas.getDateFin();
    ActiviteSalarie dernierSinistre = p_pas;
    if (dernierSinistre.getContrat().getPreavis() != null)
    {
      Preavis preavis = dernierSinistre.getContrat().getPreavis();
      if (preavis.getPeriodeNonEffectueeNonPayee() != null) {
        dateRetour = preavis.getPeriodeNonEffectueeNonPayee().getDebut();
      }
      if (preavis.getPeriodeEffectuee() != null) {
        dateRetour = Damj.min(dateRetour, preavis.getPeriodeEffectuee().getDebut());
      }
      if (preavis.getPeriodeNonEffectueePayee() != null) {
        dateRetour = Damj.min(dateRetour, preavis.getPeriodeNonEffectueePayee().getDebut());
      }
    }
    return dateRetour;
  }
}

/* Location:
 * Qualified Name:     StategieDateDebutMaxActiviteConserveeAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */