package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.FormuleDiffereICCPConservatoireBatiment;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.FormuleDiffereICCPMontant;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.FormuleDiffereICCPTemps;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FormuleDelaiReportSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieFormuleICCPSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.BaseDelaiReport;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJourTravailDansSemaineSpec;
import java.math.BigDecimal;

public class StrategieIccpAvantARE14
  implements StrategieFormuleICCPSpec
{
  public FormuleDelaiReportSpec getFormuleICCP(BaseDelaiReport baseDelaiReport)
  {
    FormuleDelaiReportSpec formuleDelaiReportRetour = null;
    if ((baseDelaiReport.getQuantiteEuroIccp() != null) && (baseDelaiReport.getQuantiteEuroIccp().getValeurMontant().compareTo(BigDecimal.ZERO) > 0)) {
      formuleDelaiReportRetour = new FormuleDiffereICCPMontant();
    } else if ((baseDelaiReport.getQuantiteJourIccp() != null) && (baseDelaiReport.getQuantiteJourIccp().getNombreJours() > 0)) {
      formuleDelaiReportRetour = new FormuleDiffereICCPTemps();
    } else if ((baseDelaiReport.isIccpConservatoireAutoriseBatiment()) && (!estUneRepriseSimplifiee(baseDelaiReport))) {
      formuleDelaiReportRetour = new FormuleDiffereICCPConservatoireBatiment();
    }
    return formuleDelaiReportRetour;
  }
  
  protected boolean estUneRepriseSimplifiee(BaseDelaiReport baseDelaiReport)
  {
    return 34 == baseDelaiReport.getSousTypeObjectif();
  }
}

/* Location:
 * Qualified Name:     StrategieIccpAvantARE14
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */