package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionBaseCarence;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieMajorationRemunerationIccpSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.ContratTravail;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class StrategieMajorationRemunerationIccpApres
  extends ConstructionBaseCarence
  implements StrategieMajorationRemunerationIccpSpec
{
  public QuantiteEuro determinerMontantIccpOdRg(ActiviteSalarie p_periodeActiviteSalarie, Damj p_dateFg)
  {
    return determinerMontantIccpA5(p_periodeActiviteSalarie, p_dateFg);
  }
  
  public QuantiteEuro determinerMontantIccpA5(ActiviteSalarie p_periodeActiviteSalarie, Damj p_dateFg)
  {
    QuantiteEuro quantiteEuroIccpRetournee = null;
    BigDecimal cumulMontantsIccpA5 = null;
    
    QuantiteEuro quantiteEuroIccpCourante = p_periodeActiviteSalarie.getQuantiteEuroIccp();
    if (quantiteEuroIccpCourante != null) {
      cumulMontantsIccpA5 = quantiteEuroIccpCourante.getValeurMontant();
    }
    quantiteEuroIccpCourante = determinerMontantIccpA5Salaires(p_periodeActiviteSalarie, p_dateFg);
    if (quantiteEuroIccpCourante != null) {
      if (cumulMontantsIccpA5 == null) {
        cumulMontantsIccpA5 = quantiteEuroIccpCourante.getValeurMontant();
      } else {
        cumulMontantsIccpA5 = cumulMontantsIccpA5.add(quantiteEuroIccpCourante.getValeurMontant());
      }
    }
    if (cumulMontantsIccpA5 != null) {
      quantiteEuroIccpRetournee = new QuantiteEuro(cumulMontantsIccpA5);
    }
    return quantiteEuroIccpRetournee;
  }
  
  public QuantiteJour determinerCongesPrisA5(QuantiteJour p_resultatFormuleIccp, ActiviteSalarie p_periodeActiviteSalarie)
  {
    if (p_periodeActiviteSalarie.getContrat().getNbreJoursCongesPris() > 0)
    {
      int nbJoursIccp = p_resultatFormuleIccp.getNombreJours();
      
      p_resultatFormuleIccp = new QuantiteJour(new BigDecimal("0").max(new BigDecimal(nbJoursIccp - p_periodeActiviteSalarie.getContrat().getNbreJoursCongesPris())));
    }
    return p_resultatFormuleIccp;
  }
  
  public QuantiteJour determinerCongesPrisHorsA5(QuantiteJour p_resultatFormuleIccp, ActiviteSalarie p_periodeActiviteSalarie)
  {
    if (p_periodeActiviteSalarie.getContrat().getNbreJoursCongesPris() > 0)
    {
      int nbJoursIccp = p_resultatFormuleIccp.getNombreJours();
      
      p_resultatFormuleIccp = new QuantiteJour(new BigDecimal("0").max(new BigDecimal(nbJoursIccp - p_periodeActiviteSalarie.getContrat().getNbreJoursCongesPris())));
    }
    return p_resultatFormuleIccp;
  }
}

/* Location:
 * Qualified Name:     StrategieMajorationRemunerationIccpApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */