package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.math.BigDecimal;

public class StrategieMontantICCPAvecMajorationRemuneration
  extends StrategieMontantICCP
{
  public QuantiteEuro determinerMontantICCP(DemandeAssuranceSpec demande, ActiviteSalarie activiteSalarie, ChronologiePeriodes chronoPeriodesIndemnisation)
    throws ApplicativeException
  {
    QuantiteEuro quantiteEuroICCPRetour = null;
    BigDecimal montantICCPRetour = null;
    
    BigDecimal montantRuptureICCPProratiseHorsPeriodesIndemnisation = BigDecimal.ZERO;
    QuantiteEuro quantiteEuroICCPRupture = recupererQuantiteEuroICCPSurFCT(activiteSalarie);
    if ((quantiteEuroICCPRupture != null) && (quantiteEuroICCPRupture.getValeurMontant().compareTo(BigDecimal.ZERO) > 0))
    {
      montantRuptureICCPProratiseHorsPeriodesIndemnisation = determinerMontantRuptureICCPProratiseHorsPeriodesIndemnisation(quantiteEuroICCPRupture.getValeurMontant(), activiteSalarie, chronoPeriodesIndemnisation);
      
      mettreAJourInfoProratisation(activiteSalarie, quantiteEuroICCPRupture.getValeur(), montantRuptureICCPProratiseHorsPeriodesIndemnisation);
    }
    BigDecimal montantICCPMajorationRemuneration = determinerMontantICCPMajorationRemuneration(activiteSalarie, ((Demande)demande).getDateFaitGenerateurOuDernierSinistrePourCarences(), chronoPeriodesIndemnisation);
    
    montantICCPRetour = montantRuptureICCPProratiseHorsPeriodesIndemnisation;
    if (montantICCPMajorationRemuneration != null) {
      montantICCPRetour = montantICCPRetour.add(montantICCPMajorationRemuneration);
    }
    if (montantICCPRetour != null) {
      quantiteEuroICCPRetour = new QuantiteEuro(montantICCPRetour);
    }
    return quantiteEuroICCPRetour;
  }
}

/* Location:
 * Qualified Name:     StrategieMontantICCPAvecMajorationRemuneration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */