package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheConditionDureeIndemnisationMaintien;
import fr.unedic.cali.asu.mnt.dom.ConditionDureeIndemnisationMaintien;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.asu.mnt.dom.DossierExamen;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.DomLiquidationDemande;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionDureeIndemnisationPourMaintien
  extends ParcoursCali
  implements ParcoursAssurance
{
  public static DemandeSpec getDemande(Contexte p_contexte)
  {
    return ((DomLiquidationDemande)p_contexte.getDonnees()).getDemandeSpec();
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCam04 = new Resultat(1);
    DemandeMaintien demandeMaintien = (DemandeMaintien)getDemande(p_contexte);
    
    ConditionDureeIndemnisationMaintien conditionDureeIndemnisation = RechercheConditionDureeIndemnisationMaintien.rechercherConditionDureeIndemnisation(demandeMaintien);
    
    demandeMaintien.getDossierExamen().setConditionDureeIndemnisation(conditionDureeIndemnisation);
    if (conditionDureeIndemnisation.estSatisfait())
    {
      resultatCam04.setEtat(0);
    }
    else
    {
      resultatCam04.setEtat(1);
      resultatCam04.setMessageErreur(Integer.toString(conditionDureeIndemnisation.getCodeMotifEchec()));
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCam04;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionDureeIndemnisationPourMaintien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */