package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationOrdreObjectifs;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ParcoursDeterminationOrdreObjectifs
  extends ParcoursCali
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    DomLiquidationAssurance dom = getDom(p_contexte);
    Demande demande = getDemande(dom);
    int contexteExamen = dom.getContexteExamen();
    ProduitAsuSpec produitPrecedent = dom.getProduitPrecedent();
    boolean estContexteRepriseContextuelle = dom.estEnRepriseContextuelle();
    boolean estReliquatDroitMaintenu = estReliquatDroitMaintenu(dom);
    
    getOutilDeterminationOrdreObjectifs().determinerOrdreObjectifs(demande, contexteExamen, produitPrecedent, estContexteRepriseContextuelle, estReliquatDroitMaintenu);
    
    OutilTrace.tracerFinParcours();
    
    return new Resultat();
  }
  
  protected OutilDeterminationOrdreObjectifs getOutilDeterminationOrdreObjectifs()
  {
    return OutilDeterminationOrdreObjectifs.getInstance();
  }
  
  protected Demande getDemande(DomLiquidationAssurance p_dom)
  {
    Demande demande = (Demande)p_dom.getDemandeSpec();
    demande.setLiquideeAvecDroitOptionReprise(p_dom.isLiquidationAvecDroitOptionReprise());
    
    return demande;
  }
  
  protected DomLiquidationAssurance getDom(Contexte p_contexte)
  {
    return (DomLiquidationAssurance)p_contexte.getDonnees();
  }
  
  protected boolean estReliquatDroitMaintenu(DomLiquidationAssurance p_dom)
  {
    ResultatExecutionCalculSpec resultat = p_dom.getResultatExecutionCalculDroitPrecedent();
    if (resultat != null)
    {
      AttributionAssuranceSpec attribution = (AttributionAssuranceSpec)resultat.getAttributionEtudiee();
      if (attribution != null) {
        return attribution.estMaintenue();
      }
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     ParcoursDeterminationOrdreObjectifs
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */