package fr.unedic.cali.asu.cge01.liquidation.parcours.fabrique;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantClassiqueFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantFinDroitDcSuiteCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantSPFinDroit;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.outilsfonctionnels.OutilFinDroit;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.services.Parcours;

public class FabriqueParcoursConstitutionProduitResultantFinDroit
  extends FabriqueParcoursConstitutionProduitResultant
{
  public static Parcours getParcoursProduitResultant(int p_contexteExamen, Demande p_demandeCourante)
    throws ApplicativeException
  {
    AttributionSpec attributionCorrespondante = OutilFinDroit.rechercherAttributionCorrespondantePecedente(p_demandeCourante);
    int codeProduitAsr = ((DossierExamen)attributionCorrespondante).getDossierAffecte().getProduit().getCode();
    DossierAffecte dossierAffecteCourant = (DossierAffecte)((DossierExamen)p_demandeCourante.getDossierExamen()).getDossierAffecte();
    if ((codeProduitAsr == 37) || (codeProduitAsr == 50))
    {
      if (p_contexteExamen == 3) {
        return new ConstitutionProduitResultantClassiqueFinDroit();
      }
      if (p_contexteExamen == 4) {
        return new ConstitutionProduitResultantSPFinDroit();
      }
    }
    else if ((codeProduitAsr == 51) || (codeProduitAsr == 36))
    {
      if ((OutilFinDroit.estDemandeFinDroitContextePrecSuiteCsr(p_demandeCourante)) && (dossierAffecteCourant.getValidationProduit().getQteAcquise() == null)) {
        return new ConstitutionProduitResultantFinDroitDcSuiteCsr();
      }
      if ((codeProduitAsr == 51) && (p_contexteExamen == 3)) {
        return new ConstitutionProduitResultantClassiqueFinDroit();
      }
      if ((codeProduitAsr == 51) && (p_contexteExamen == 4)) {
        return new ConstitutionProduitResultantSPFinDroit();
      }
    }
    return FabriqueParcoursConstitutionProduitResultant.getParcoursProduitResultant(p_contexteExamen, p_demandeCourante);
  }
}

/* Location:
 * Qualified Name:     FabriqueParcoursConstitutionProduitResultantFinDroit
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */