package fr.unedic.cali.asu.cge01.p02.calcul.dom;

import fr.unedic.cali.asu.cge01.p02.calcul.dom.gen.DureeRenouvellementGen;
import fr.unedic.cali.asu.cge01.p02.calcul.outilsfonctionnels.SimulateurImputeurDureeIndemnisation;
import fr.unedic.cali.dom.EtatQuantiteDroit;
import fr.unedic.cali.dom.ImputationJour;
import fr.unedic.cali.dom.ImputationSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;

public class DureeRenouvellement
  extends DureeRenouvellementGen
{
  private static final long serialVersionUID = 3001415372219316639L;
  public static final int NB_JOUR_STANDARD = 182;
  
  private DureeRenouvellement() {}
  
  public DureeRenouvellement(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DureeRenouvellement(int p_quantiteInitial)
  {
    setQuantiteInitial(new Quantite(new BigDecimal(Integer.toString(p_quantiteInitial)), DureeIndemnisation.UNITE_DEFAUT));
    setQuantiteCourante(new Quantite(new BigDecimal("0"), DureeIndemnisation.UNITE_DEFAUT));
  }
  
  public ObjetMetierSpec copie()
  {
    DureeRenouvellement copie = new DureeRenouvellement();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    DureeRenouvellement copie = (DureeRenouvellement)p_copie;
    super.copieElements(copie);
    copie.setRangActualisation(getRangActualisation());
  }
  
  public ImputationSpec simulerImputer(Quantite p_quantite)
  {
    ImputationJour monImputation = (ImputationJour)getEtatQuantiteDroit().accepteVisiteur(new SimulateurImputeurDureeIndemnisation(this, p_quantite));
    
    return monImputation;
  }
  
  public String toString()
  {
    StringBuffer string = new StringBuffer();
    string.append(super.toString());
    string.append("\nRang actualisation : " + getRangActualisation() + "\n");
    return string.toString();
  }
}

/* Location:
 * Qualified Name:     DureeRenouvellement
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */