package fr.unedic.cali.asu.cge01.p02.calcul.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.calcul.dom.EtatAuDjiGamme;
import fr.unedic.cali.asu.cge01.p02.calcul.dom.pc.EtatAuDjiProduitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class EtatAuDjiProduitGen
  extends EtatAuDjiGamme
  implements DomGenSpec
{
  private Quantite m_reliquatDureeRenouvellement;
  
  public EtatAuDjiProduitGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public EtatAuDjiProduitGen() {}
  
  protected DomPCSpec createPC()
  {
    return new EtatAuDjiProduitPC();
  }
  
  protected Quantite rawGetReliquatDureeRenouvellement()
  {
    return ((EtatAuDjiProduitPC)getPC()).getReliquatDureeRenouvellement();
  }
  
  public Quantite getReliquatDureeRenouvellement()
  {
    return ((EtatAuDjiProduitPC)getPC()).getReliquatDureeRenouvellement();
  }
  
  public void setReliquatDureeRenouvellement(Quantite p_reliquatDureeRenouvellement)
  {
    if ((m_reliquatDureeRenouvellement == null) || (p_reliquatDureeRenouvellement == null))
    {
      m_reliquatDureeRenouvellement = p_reliquatDureeRenouvellement;
      ((EtatAuDjiProduitPC)getPC()).setReliquatDureeRenouvellement(p_reliquatDureeRenouvellement);
    }
    else if ((m_reliquatDureeRenouvellement != null) && (p_reliquatDureeRenouvellement != null) && (!p_reliquatDureeRenouvellement.equals(m_reliquatDureeRenouvellement)))
    {
      m_reliquatDureeRenouvellement = p_reliquatDureeRenouvellement;
      ((EtatAuDjiProduitPC)getPC()).setReliquatDureeRenouvellement(p_reliquatDureeRenouvellement);
    }
  }
  
  protected boolean rawIsEstEnAttenteRenouvellement()
  {
    return ((EtatAuDjiProduitPC)getPC()).isEstEnAttenteRenouvellement();
  }
  
  public boolean isEstEnAttenteRenouvellement()
  {
    return ((EtatAuDjiProduitPC)getPC()).isEstEnAttenteRenouvellement();
  }
  
  public void setEstEnAttenteRenouvellement(boolean p_estEnAttenteRenouvellement)
  {
    ((EtatAuDjiProduitPC)getPC()).setEstEnAttenteRenouvellement(p_estEnAttenteRenouvellement);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     EtatAuDjiProduitGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */