package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.CarenceIccpGen;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import org.apache.commons.lang.builder.EqualsBuilder;

public class CarenceIccp
  extends CarenceIccpGen
{
  private static final long serialVersionUID = 123053057522046495L;
  
  public CarenceIccp() {}
  
  public CarenceIccp(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public CarenceIccp(int p_jours)
  {
    super(p_jours);
  }
  
  public CarenceIccp(ObjetChronoPeriode p_periodeOrigine, int p_nombreJours)
  {
    super(p_nombreJours);
    setOrigine(p_periodeOrigine);
  }
  
  public Periode getPeriodeApplicationCarence()
  {
    if (super.getPeriodeApplicationCarence() == null)
    {
      Damj dateDebutCarence = getDateFinPeriodeOrigine().lendemain();
      if (getCarencePrecedente() != null) {
        dateDebutCarence = ((CarencePrefixeAFixerJour)getCarencePrecedente()).getPeriodeApplicationCarence().getFin().lendemain();
      }
      Damj dateFinCarence = dateDebutCarence.veille().deplacerVersAvant(new DureeCalendaire(0, 0, getQuantiteInitialJour()));
      super.setPeriodeApplicationCarence(new Periode(dateDebutCarence, dateFinCarence));
    }
    return super.getPeriodeApplicationCarence();
  }
  
  public String getTypeCarence()
  {
    return "ICCP";
  }
  
  public boolean peutEtreFixee()
  {
    return getCarencePrecedente() == null;
  }
  
  public String toString()
  {
    StringBuffer chaineRetour = new StringBuffer();
    
    chaineRetour.append("Carence ICCP:");
    chaineRetour.append("\n\t Période d'origine: " + getOrigine());
    chaineRetour.append("\n\t Nombre initial de jours: " + getQuantiteInitialJour());
    chaineRetour.append("\n\t Carence PMC liée: " + getCarencePrecedente());
    chaineRetour.append("\n\t Carence ISLR liée: " + getCarenceSuivante());
    
    return chaineRetour.toString();
  }
  
  public void jdoPreDelete()
  {
    super.jdoPreDelete();
  }
  
  public CarencePrefixeAFixer getCarencePrecedente()
  {
    return getEnsembleCarences().getCarencePmc();
  }
  
  public CarencePrefixeAFixer getCarenceSuivante()
  {
    return getEnsembleCarences().getCarenceIslr();
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    CarenceIccp copie = (CarenceIccp)p_copie;
    
    super.copieElements(copie);
  }
  
  public ObjetMetierSpec copie()
  {
    CarenceIccp copie = new CarenceIccp();
    copieElements(copie);
    return copie;
  }
  
  public boolean estIdentiqueA(CarencePrefixeAFixer p_carence)
  {
    if ((p_carence == null) || (!(p_carence instanceof CarenceIccp))) {
      return false;
    }
    CarenceIccp aComparer = (CarenceIccp)p_carence;
    
    EqualsBuilder eqb = new EqualsBuilder();
    return eqb.append(getPeriodeApplicationCarence().getDebut(), aComparer.getPeriodeApplicationCarence().getDebut()).append(getPeriodeApplicationCarence().getFin(), aComparer.getPeriodeApplicationCarence().getFin()).append(getQuantiteInitial(), aComparer.getQuantiteInitial()).append(getIdentifiantPeriodeOrigine(), aComparer.getIdentifiantPeriodeOrigine()).isEquals();
  }
}

/* Location:
 * Qualified Name:     CarenceIccp
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */