package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ConditionAgeGen;
import fr.unedic.cali.dom.ConditionAttributionSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConditionAge
  extends ConditionAgeGen
  implements ConditionAttributionSpec
{
  private static final long serialVersionUID = -7385016472555862465L;
  public static final int SITUATION_MOINS_60_ANS = 1;
  public static final int SITUATION_TITULAIRE_PENSION_CAN = 2;
  public static final int SITUATION_PLUS_65_ANS = 3;
  public static final int SITUATION_DATE_EFFET_PENSION_SUPERIEUR_DOD = 5;
  public static final int SITUATION_DATE_EFFET_PENSION_INFERIEUR_DOD = 6;
  public static final int SITUATION_TITULAIRE_PENSION_CAN_ET_RACCORDEMENT = 7;
  
  public ConditionAge() {}
  
  public ConditionAge(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public boolean getEtatConditionAge()
  {
    return estSatisfait();
  }
  
  public void setEtatConditionAge(boolean p_conditionAge)
  {
    setEtatSatisfait(p_conditionAge);
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
    sb.append("ConditionAge:");
    
    sb.append("\n\tEtat Condition Age:");
    sb.append("\n\t" + getEtatConditionAge());
    if (getDateEffetPension() != null)
    {
      sb.append("\n\tDate effet Pension:");
      sb.append("\n\t" + getDateEffetPension());
    }
    if (getSituationConditionAge() != 0)
    {
      sb.append("\n\tSituation condition âge:");
      sb.append("\n\t" + getSituationConditionAge());
    }
    return sb.toString();
  }
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (super.getResultatElementDroit() == null) {
      super.setResultatElementDroit(new ResultatElementDroit());
    }
    return super.getResultatElementDroit();
  }
  
  public boolean estSatisfait()
  {
    return getResultatElementDroit().estSatisfait();
  }
  
  public int getCodeMotifEchec()
  {
    return getResultatElementDroit().getCodeMotifEchec();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    getResultatElementDroit().setCodeMotifEchec(p_codeMotifEchec);
  }
  
  public void setEtatSatisfait(boolean p_etatSatisfait)
  {
    getResultatElementDroit().setEtatSatisfait(p_etatSatisfait);
  }
  
  public ObjetMetierSpec copie()
  {
    ConditionAge copie = new ConditionAge();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConditionAge copie = (ConditionAge)p_copie;
    copie.setCodeMotifEchec(getCodeMotifEchec());
    copie.setEtat(getEtat());
    copie.setDateEffetPension(getDateEffetPension());
    copie.setSituationConditionAge(getSituationConditionAge());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreStore() {}
  
  public void setEtat(int p_etat)
  {
    getResultatElementDroit().setEtat(p_etat);
  }
  
  public int getEtat()
  {
    return getResultatElementDroit().getEtat();
  }
}

/* Location:
 * Qualified Name:     ConditionAge
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */