package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ConstitutionSjcGen;
import fr.unedic.cali.asu.dom.ConstitutionSjcSpec;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.dom.ConstitutionDroitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionSjc
  extends ConstitutionSjcGen
  implements ConstitutionDroitSpec, ConstitutionSjcSpec
{
  private static final long serialVersionUID = -6037394216256995007L;
  private transient JustificationSjc m_justificationSjc;
  
  public ConstitutionSjc() {}
  
  public ConstitutionSjc(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void setSjcip(Sjcip p_sjcip)
  {
    DomManager.supprimer(super.getSjcip(), p_sjcip);
    super.setSjcip(p_sjcip);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete()
  {
    DomManager.supprimer(super.getSjcip());
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getSjcip());
  }
  
  public void jdoPreStore() {}
  
  public ObjetMetierSpec copie()
  {
    ConstitutionSjc copie = new ConstitutionSjc();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionSjc copie = (ConstitutionSjc)p_copie;
    
    copie.setSjcip(getSjcip() != null ? (Sjcip)getSjcip().copie() : null);
    copie.setSjcrp(getSjcrp() != null ? (Sjc)getSjcrp().copie() : null);
    copie.setJustificationSjc(getJustificationSjc() != null ? (JustificationSjc)getJustificationSjc().copie() : null);
  }
  
  public JustificationSjc getJustificationSjc()
  {
    return m_justificationSjc;
  }
  
  public void setJustificationSjc(JustificationSjc p_justificationSjc)
  {
    m_justificationSjc = p_justificationSjc;
  }
}

/* Location:
 * Qualified Name:     ConstitutionSjc
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */