package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.JustificationSrGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.math.BigDecimal;

public class JustificationSr
  extends JustificationSrGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = 4785647296092988821L;
  private transient BigDecimal m_salaireReferencePlafonnne;
  private transient Chronologie m_listeActivitesSalarieesRetenues;
  
  public JustificationSr()
  {
    m_listeActivitesSalarieesRetenues = new ChronologiePeriodes();
    m_salaireReferencePlafonnne = new BigDecimal("0");
    super.setTotalSalairesRetenus(new BigDecimal("0"));
    super.setTotalPrimesNormalesRetenues(new BigDecimal("0"));
    super.setTotalPrimesExceptionnellesRetenues(new BigDecimal("0"));
    super.setSalaireReferenceNonPlafonne(new BigDecimal("0"));
  }
  
  public JustificationSr(DomPCSpec p_pc)
  {
    super(p_pc);
    m_listeActivitesSalarieesRetenues = new ChronologiePeriodes();
    m_salaireReferencePlafonnne = new BigDecimal("0");
    super.setTotalSalairesRetenus(new BigDecimal("0"));
    super.setTotalPrimesNormalesRetenues(new BigDecimal("0"));
    super.setTotalPrimesExceptionnellesRetenues(new BigDecimal("0"));
    super.setSalaireReferenceNonPlafonne(new BigDecimal("0"));
  }
  
  public Chronologie getListeActivitesSalarieesRetenues()
  {
    return m_listeActivitesSalarieesRetenues;
  }
  
  public void setListeActivitesSalarieesRetenues(Chronologie p_listeActivitesSalarieesRetenues)
  {
    m_listeActivitesSalarieesRetenues = p_listeActivitesSalarieesRetenues;
  }
  
  public BigDecimal getSalaireReferencePlafonnne()
  {
    return m_salaireReferencePlafonnne;
  }
  
  public void setSalaireReferencePlafonnne(BigDecimal p_salaireReferencePlafonnne)
  {
    m_salaireReferencePlafonnne = p_salaireReferencePlafonnne;
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationSr copie = new JustificationSr();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationSr copie = (JustificationSr)p_copie;
    copie.setListeActivitesSalarieesRetenues((Chronologie)getListeActivitesSalarieesRetenues().copie());
    copie.setSalaireReferenceNonPlafonne(getSalaireReferenceNonPlafonne());
    copie.setSalaireReferencePlafonnne(getSalaireReferencePlafonnne());
    copie.setTotalPrimesExceptionnellesRetenues(getTotalPrimesExceptionnellesRetenues());
    copie.setTotalPrimesNormalesRetenues(getTotalPrimesNormalesRetenues());
    copie.setTotalSalairesRetenus(getTotalSalairesRetenus());
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public void jdoPreStore() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
}

/* Location:
 * Qualified Name:     JustificationSr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */