package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.util.Hashtable;

public class Pra
  extends Periode
  implements ObjetMetierSpec
{
  private static final long serialVersionUID = 1924386391231355968L;
  private Hashtable m_listeQuantitesAffiliationRequises = new Hashtable();
  private Hashtable m_listeQuantitesAssimilationMaximales = new Hashtable();
  private Quantite m_dureeInitiale = null;
  private String m_article3;
  
  public Pra() {}
  
  public Pra(Damj p_date, int p_n)
  {
    super(p_date, p_n);
  }
  
  public Pra(Damj p_date1, Damj p_date2)
  {
    super(p_date1, p_date2);
  }
  
  public Pra(Damj p_date, DureeCalendaire p_duree, int p_sens)
  {
    super(p_date, p_duree, p_sens);
  }
  
  public Pra(String p_article3)
  {
    m_article3 = p_article3;
  }
  
  public Pra(Periode p_periodeReference)
  {
    super(p_periodeReference.getDebut(), p_periodeReference.getFin());
  }
  
  public String getArticle3()
  {
    return m_article3;
  }
  
  public Quantite getDureeInitiale()
  {
    return m_dureeInitiale;
  }
  
  public Quantite getQuantiteAffiliationRequise(Unite p_unite)
  {
    return (Quantite)getListeQuantitesAffiliationRequises().get(p_unite);
  }
  
  public Quantite getQuantiteAssimilationMaximale(Unite p_unite)
  {
    return (Quantite)getListeQuantitesAssimilationMaximales().get(p_unite);
  }
  
  public Hashtable getListeQuantitesAffiliationRequises()
  {
    return m_listeQuantitesAffiliationRequises;
  }
  
  public Hashtable getListeQuantitesAssimilationMaximales()
  {
    return m_listeQuantitesAssimilationMaximales;
  }
  
  public void setArticle3(String p_article3)
  {
    m_article3 = p_article3;
  }
  
  public void setDureeInitiale(Quantite p_dureeInitiale)
  {
    m_dureeInitiale = p_dureeInitiale;
  }
  
  public void setListeQuantitesAffiliationRequises(Hashtable p_listeQuantitesAffiliationRequises)
  {
    m_listeQuantitesAffiliationRequises = p_listeQuantitesAffiliationRequises;
  }
  
  public void setListeQuantitesAssimilationMaximales(Hashtable p_listeQuantitesAssimilationMaximales)
  {
    m_listeQuantitesAssimilationMaximales = p_listeQuantitesAssimilationMaximales;
  }
  
  public String toString()
  {
    return "PRA [" + getDebut() + " - " + getFin() + "]";
  }
  
  public ObjetMetierSpec copie()
  {
    Pra copie = new Pra();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    Pra copie = (Pra)p_copie;
    
    copie.setListeQuantitesAffiliationRequises(getListeQuantitesAffiliationRequises());
    copie.setListeQuantitesAssimilationMaximales(getListeQuantitesAssimilationMaximales());
    copie.setArticle3(getArticle3());
    copie.setDebut(getDebut());
    copie.setDureeInitiale(getDureeInitiale());
    copie.setFin(getFin());
  }
}

/* Location:
 * Qualified Name:     Pra
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */