package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.CarencePrefixeAFixerJour;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.EnsembleCarences;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.CarenceIccpPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class CarenceIccpGen
  extends CarencePrefixeAFixerJour
  implements DomGenSpec
{
  private EnsembleCarences m_ensembleCarences;
  
  public CarenceIccpGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public CarenceIccpGen() {}
  
  public CarenceIccpGen(int p_jours)
  {
    super(p_jours);
  }
  
  protected DomPCSpec createPC()
  {
    return new CarenceIccpPC();
  }
  
  public EnsembleCarences getEnsembleCarences()
  {
    if (m_ensembleCarences == null)
    {
      DomPCSpec ensembleCarencesPC = ((CarenceIccpPC)getPC()).getEnsembleCarences();
      if (ensembleCarencesPC != null) {
        m_ensembleCarences = ((EnsembleCarences)ensembleCarencesPC.createOM());
      }
    }
    return m_ensembleCarences;
  }
  
  public void setEnsembleCarences(EnsembleCarences p_ensembleCarences)
  {
    if (p_ensembleCarences == null)
    {
      ((CarenceIccpPC)getPC()).setEnsembleCarences(null);
      m_ensembleCarences = p_ensembleCarences;
    }
    else if (!p_ensembleCarences.equals(m_ensembleCarences))
    {
      ((CarenceIccpPC)getPC()).setEnsembleCarences(p_ensembleCarences.getPC());
      m_ensembleCarences = p_ensembleCarences;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     CarenceIccpGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */