package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConstitutionReglementApplicablePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class ConstitutionReglementApplicableGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionReglementApplicablePC;
  private String m_nomReglement;
  
  public ConstitutionReglementApplicableGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionReglementApplicableGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionReglementApplicablePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionReglementApplicablePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionReglementApplicablePC)
  {
    m_constitutionReglementApplicablePC = p_constitutionReglementApplicablePC;
  }
  
  protected String rawGetNomReglement()
  {
    return ((ConstitutionReglementApplicablePC)getPC()).getNomReglement();
  }
  
  public String getNomReglement()
  {
    return ((ConstitutionReglementApplicablePC)getPC()).getNomReglement();
  }
  
  public void setNomReglement(String p_nomReglement)
  {
    if ((m_nomReglement == null) || (p_nomReglement == null))
    {
      m_nomReglement = p_nomReglement;
      ((ConstitutionReglementApplicablePC)getPC()).setNomReglement(p_nomReglement);
    }
    else if ((m_nomReglement != null) && (p_nomReglement != null) && (!p_nomReglement.equals(m_nomReglement)))
    {
      m_nomReglement = p_nomReglement;
      ((ConstitutionReglementApplicablePC)getPC()).setNomReglement(p_nomReglement);
    }
  }
  
  protected int rawGetCodeProduit()
  {
    return ((ConstitutionReglementApplicablePC)getPC()).getCodeProduit();
  }
  
  public int getCodeProduit()
  {
    return ((ConstitutionReglementApplicablePC)getPC()).getCodeProduit();
  }
  
  public void setCodeProduit(int p_codeProduit)
  {
    ((ConstitutionReglementApplicablePC)getPC()).setCodeProduit(p_codeProduit);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionReglementApplicableGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */