package fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.comparator.ComparatorPRAOrdreQuantiteAppartenance;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.comparator.ComparatorPRAOrdreReglementApplicable;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionPra;
import fr.unedic.cali.asu.cge01.p02.parametres.ParametrageListePRA;
import fr.unedic.cali.asu.cge01.p02.parametres.ParametrageListePRARechargement;
import fr.unedic.cali.asu.cge01.parametres.ParametrageListePRASpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.asu.produits.liquidation.parametres.CleAccesPRA;
import fr.unedic.cali.dom.DonneesEntreeDeterminationListePra;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.spec.ConstructionPRASpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class OutilConstructionPRA
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilConstructionPRA
  implements ConstructionPRASpec
{
  public Collection<Pra> determinerListePraQuantiteAppartenance(DonneesEntreeDeterminationListePra p_donneesEntreeDeterminationListePra)
    throws CoucheLogiqueException
  {
    Demande demande = (Demande)p_donneesEntreeDeterminationListePra.getDemande();
    Comparator<Pra> comparateur = new ComparatorPRAOrdreReglementApplicable();
    if (ConstructionPra.ORDRE_QUANTITE_APPARTENANCE == p_donneesEntreeDeterminationListePra.getOrdreTriListe())
    {
      Damj dateFG = demande.getFaitGenerateur().getDateFaitGenerateur();
      DureeCalendaire ageFG = demande.getDemandeur().getAgeALaDate(dateFG);
      p_donneesEntreeDeterminationListePra.setAgeIndividu(ageFG);
      comparateur = new ComparatorPRAOrdreQuantiteAppartenance();
    }
    CleAccesPRA cle = construireCleAccesPRA(p_donneesEntreeDeterminationListePra);
    
    ParametrageListePRASpec parametre = null;
    if (p_donneesEntreeDeterminationListePra.isUtiliserParametreAffiRechargement()) {
      parametre = ParametrageListePRARechargement.getInstance();
    } else {
      parametre = ParametrageListePRA.getInstance();
    }
    List listePRA = parametre.getListePra(cle);
    Collections.sort(listePRA, comparateur);
    
    return listePRA;
  }
}

/* Location:
 * Qualified Name:     OutilConstructionPRA
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */