package fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.mnt.dom.ConditionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Damj;

public class RechercheConditionAgePourMaintien
  implements OutilFonctionnel
{
  public static ConditionAgeMaintien rechercherConditionAge(DemandeMaintien p_demande)
  {
    ConditionAgeMaintien conditionAge = new ConditionAgeMaintien();
    
    Damj dateObtentionAgeMinimum = p_demande.getProduitMaintenu().getDateObtentionAgePourMaintien(p_demande);
    conditionAge.setDateObtentionAgeMinimum(dateObtentionAgeMinimum);
    
    ProduitAsuSpec produit = (ProduitAsuSpec)p_demande.getAttributionAssurance().getProduit();
    conditionAge.setAgeMinimum(produit.getAgeMinimumObtentionMaintien(p_demande));
    if (dateObtentionAgeMinimum.estAvantOuCoincideAvec(p_demande.getDateExamen()))
    {
      conditionAge.setEtatConditionAge(true);
    }
    else
    {
      conditionAge.setEtatConditionAge(false);
      conditionAge.setCodeMotifEchec(981);
    }
    return conditionAge;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionAgePourMaintien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */