package fr.unedic.cali.asu.cge01.p02.liquidation.parcours;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels.DeterminationDateOdTheorique;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttribution
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(p_contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "Une demande est obligatoire pour ce produit. : ConstitutionDateAttribution impossible");
    }
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    if (Log.isTraceActive(ConstitutionDateAttribution.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "\t\t******** Début Parcours ConstitutionDateAttribution ********");
    }
    Resultat resultatCEPA14 = new Resultat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionDateAttribution constitutionDate = new fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionDateAttribution();
    if (verifierPreconditions(p_contexte))
    {
      Damj dodTheorique = DeterminationDateOdTheorique.determinerDateAttributionTheoriquePourAdmission(demande);
      
      constitutionDate.setDateAttribution(dodTheorique);
    }
    dossierExamenCourant.setConstitutionDateAttribution(constitutionDate);
    if (Log.isTraceActive(ConstitutionDateAttribution.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "\t\t******** Résultat Parcours ConstitutionDateAttribution ********\n" + resultatCEPA14);
      
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "\t\t******** Fin Parcours ConstitutionDateAttribution ********\n");
    }
    return resultatCEPA14;
  }
  
  protected boolean verifierPreconditions(Contexte p_contexte)
  {
    boolean preconditionsValides = true;
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    if ((dossierExamenCourant.getConditionsAttributionAdmission() != null) && (dossierExamenCourant.getConditionsAttributionAdmission().estSatisfait())) {
      preconditionsValides = true;
    } else {
      preconditionsValides = false;
    }
    return preconditionsValides;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttribution
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */