package fr.unedic.cali.asu.cge01.p02.migration.recalcul;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionProduitResultant;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.migration.RecalculerDonneesSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;

public class RecalculerCapitalDroitPrecedent
  implements RecalculerDonneesSpec
{
  public Collection recalculer(DemandeSpec p_demande)
  {
    Attribution attributionCourante = (Attribution)p_demande.getDossierAffectation().getDossierExamen();
    
    Quantite nbJourIndemnisesEffectif = attributionCourante.getConstitutionProduitResultant().getDureeDroitPrecedent();
    Quantite montantBrutDP = attributionCourante.getConstitutionProduitResultant().getMontantDroitPrecedent();
    
    Quantite capitalDroitPrecedent = new QuantiteEuro(nbJourIndemnisesEffectif.getValeur().multiply(montantBrutDP.getValeur()));
    
    attributionCourante.getConstitutionProduitResultant().setCapitalDroitPrecedent(capitalDroitPrecedent);
    
    return new ArrayList();
  }
}

/* Location:
 * Qualified Name:     RecalculerCapitalDroitPrecedent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */