package fr.unedic.cali.asu.cge01.p02.migration.recalcul;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionProduitResultant;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.asu.liquidation.outilsfonctionnels.DeterminationMontant;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.GammeAsuSpec;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.cali.migration.RecalculerDonneesSpec;
import fr.unedic.util.services.ApplicativeRuntimeException;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.ArrayList;
import java.util.Collection;

public class RecalculerMontantBrutDroitPrecedent
  implements RecalculerDonneesSpec
{
  public Collection recalculer(DemandeSpec p_demande)
  {
    Attribution attribution = (Attribution)p_demande.getDossierAffectation().getDossierExamen();
    AttributionAssuranceSpec attributionPrecedente = attribution.getAttributionPrecedente();
    
    MontantAsuSpec montantBrutAttribution = null;
    try
    {
      GammeAsuSpec gamme = (GammeAsuSpec)attribution.getGamme();
      DonneesEntreesRecuperationMontant donneesEntreesRecuperationMontant = gamme.mapperDonneesEntreesRecuperationMontant(attributionPrecedente);
      donneesEntreesRecuperationMontant.setDateCalculMontant(attribution.getDateAttribution());
      
      montantBrutAttribution = DeterminationMontant.determinerMontant(donneesEntreesRecuperationMontant);
    }
    catch (CoucheLogiqueException ex)
    {
      throw new ApplicativeRuntimeException("", ex);
    }
    ConstitutionProduitResultant constitutionProduitResultant = attribution.getConstitutionProduitResultant();
    if (montantBrutAttribution != null) {
      constitutionProduitResultant.setMontantDroitPrecedent(montantBrutAttribution.getMontantPrecompteEffectif());
    }
    return new ArrayList();
  }
}

/* Location:
 * Qualified Name:     RecalculerMontantBrutDroitPrecedent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */