package fr.unedic.cali.asu.cge01.p03.antecedent;

import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsu;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.CalendrierExecutionCalcul;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Antecedent;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Periode;

public class GestionAntecedentCalcul
  extends GestionAntecedentCalculAsu
{
  public static GestionAntecedentCalculAsuSpec getInstance()
  {
    return new GestionAntecedentCalcul();
  }
  
  public void alimenterGrapheCalcul(AttributionSpec p_attribution)
  {
    AttributionAssuranceSpec antecedent = (AttributionAssuranceSpec)p_attribution;
    SaisieAntecedent saisieAntecedent = ((Antecedent)antecedent).getSaisieAntecedent();
    
    alimenterCalendrierExecutionCalculAvant(antecedent, saisieAntecedent);
    
    alimenterCalendrierExecutionCalculPendant(antecedent, saisieAntecedent);
  }
  
  protected CalendrierExecutionCalculPeriodique instancierCalendrierExecutionCalcul()
  {
    return new CalendrierExecutionCalcul();
  }
  
  protected fr.unedic.cali.calcul.dom.UniteTraitement instancierUniteTraitement(Unite p_uniteParDefautQuantites, Periode p_periode)
  {
    return new fr.unedic.cali.asu.cge01.p03.calcul.dom.UniteTraitement(p_uniteParDefautQuantites, p_periode);
  }
}

/* Location:
 * Qualified Name:     GestionAntecedentCalcul
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */