package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConditionsAttributionRepriseGen;
import fr.unedic.cali.dom.ElementDroitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ConditionsAttributionReprise
  extends ConditionsAttributionRepriseGen
  implements ConditionsAttributionSpec
{
  private static final long serialVersionUID = 3761748040231871030L;
  
  public ConditionsAttributionReprise() {}
  
  public ConditionsAttributionReprise(DomPCSpec p_reprisePC)
  {
    super(p_reprisePC);
  }
  
  public List getListeConditionsAttribution()
  {
    List listeConditions = new ArrayList();
    listeConditions.add(getConditionRechercheEmploi());
    listeConditions.add(getConditionAge());
    listeConditions.add(getConditionChomageInvolontaire());
    listeConditions.add(getConditionMontantNonNul());
    listeConditions.add(getConditionCumulPrestationFamiliale());
    listeConditions.add(getConditionValiditeReliquat());
    return listeConditions;
  }
  
  public boolean estSatisfait()
  {
    for (Iterator iter = getListeConditionsAttribution().iterator(); iter.hasNext();)
    {
      ElementDroitSpec droit = (ElementDroitSpec)iter.next();
      if ((droit != null) && 
        (!(droit instanceof ConditionChomageInvolontaire)) && (!droit.estSatisfait())) {
        return false;
      }
    }
    return true;
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getConditionAge());
    DomManager.persisterEnProfondeur(super.getConditionChomageInvolontaire());
    DomManager.persisterEnProfondeur(super.getConditionMontantNonNul());
    DomManager.persisterEnProfondeur(super.getConditionRechercheEmploi());
    DomManager.persisterEnProfondeur(super.getConditionCumulPrestationFamiliale());
    DomManager.persisterEnProfondeur(super.getConditionValiditeReliquat());
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConditionsAttributionReprise copie = (ConditionsAttributionReprise)p_copie;
    
    super.copieElements(copie);
    if (getConditionAge() != null)
    {
      ConditionAge copieCondition = copie.createConditionAge();
      getConditionAge().copieElements(copieCondition);
    }
    if (getConditionChomageInvolontaire() != null)
    {
      ConditionChomageInvolontaire copieCondition = copie.createConditionChomageInvolontaire();
      getConditionChomageInvolontaire().copieElements(copieCondition);
    }
    if (getConditionMontantNonNul() != null)
    {
      ConditionMontantNonNul copieCondition = copie.createConditionMontantNonNul();
      getConditionMontantNonNul().copieElements(copieCondition);
    }
    if (getConditionRechercheEmploi() != null)
    {
      ConditionRechercheEmploi copieCondition = copie.createConditionRechercheEmploi();
      getConditionRechercheEmploi().copieElements(copieCondition);
    }
    if (getConditionCumulPrestationFamiliale() != null)
    {
      ConditionCumulPrestationFamiliale copieCondition = copie.createConditionCumulPrestationFamiliale();
      getConditionCumulPrestationFamiliale().copieElements(copieCondition);
    }
    if (getConditionValiditeReliquat() != null)
    {
      ConditionValiditeReliquat copieCondition = copie.createConditionValiditeReliquat();
      getConditionValiditeReliquat().copieElements(copieCondition);
    }
  }
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
}

/* Location:
 * Qualified Name:     ConditionsAttributionReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */