package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class JustificationPlafondsParEmployeur
  implements ObjetMetierSpec
{
  private transient String m_raisonSociale;
  private transient BigDecimal m_srNonPlafonne;
  private transient BigDecimal m_plafond;
  private transient BigDecimal m_srPlafonne;
  private transient Collection m_listeDetailsPlafondsParExerciceEtEmployeur;
  
  public JustificationPlafondsParEmployeur()
  {
    m_srNonPlafonne = new BigDecimal("0");
    m_plafond = new BigDecimal("0");
    m_srPlafonne = new BigDecimal("0");
    m_listeDetailsPlafondsParExerciceEtEmployeur = new ArrayList();
  }
  
  public String getRaisonSociale()
  {
    return m_raisonSociale;
  }
  
  public void setRaisonSociale(String p_raisonSociale)
  {
    m_raisonSociale = p_raisonSociale;
  }
  
  public Collection getListeDetailsPlafondsParExerciceEtEmployeur()
  {
    return m_listeDetailsPlafondsParExerciceEtEmployeur;
  }
  
  public void setListeDetailsPlafondsParExerciceEtEmployeur(Collection p_listeDetailsPlafondsParExerciceEtEmployeur)
  {
    m_listeDetailsPlafondsParExerciceEtEmployeur = p_listeDetailsPlafondsParExerciceEtEmployeur;
  }
  
  public BigDecimal getPlafond()
  {
    return m_plafond;
  }
  
  public void setPlafond(BigDecimal p_plafond)
  {
    m_plafond = p_plafond;
  }
  
  public BigDecimal getSrNonPlafonne()
  {
    return m_srNonPlafonne;
  }
  
  public void setSrNonPlafonne(BigDecimal p_srNonPlafonne)
  {
    m_srNonPlafonne = p_srNonPlafonne;
  }
  
  public BigDecimal getSrPlafonne()
  {
    return m_srPlafonne;
  }
  
  public void setSrPlafonne(BigDecimal p_srPlafonne)
  {
    m_srPlafonne = p_srPlafonne;
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationPlafondsParEmployeur copie = new JustificationPlafondsParEmployeur();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationPlafondsParEmployeur copie = (JustificationPlafondsParEmployeur)p_copie;
    copie.setRaisonSociale(getRaisonSociale());
    Collection listeDetailsPlafondsParExerciceEtEmployeur = new ArrayList();
    Iterator elements = getListeDetailsPlafondsParExerciceEtEmployeur().iterator();
    while (elements.hasNext()) {
      listeDetailsPlafondsParExerciceEtEmployeur.add(((JustificationPlafondsDetailParExerciceEtEmployeur)elements.next()).copie());
    }
    copie.setListeDetailsPlafondsParExerciceEtEmployeur(listeDetailsPlafondsParExerciceEtEmployeur);
    copie.setPlafond(getPlafond());
    copie.setSrNonPlafonne(getSrNonPlafonne());
    copie.setSrPlafonne(getSrPlafonne());
  }
}

/* Location:
 * Qualified Name:     JustificationPlafondsParEmployeur
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */