package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.JustificationSjrGen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.pc.ConstitutionElementsAdmissionPC;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class JustificationSjr
  extends JustificationSjrGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -336124847463366836L;
  private transient JustificationDiviseur justificationDiviseur = new JustificationDiviseur();
  private transient JustificationPlafonds justificationPlafonds = new JustificationPlafonds();
  
  private JustificationSjr()
  {
    createJustificationSr();
  }
  
  public static JustificationSjr createNonPersistent()
  {
    return new JustificationSjr(new ConstitutionElementsAdmissionPC());
  }
  
  public JustificationSjr copieNonPersistante()
  {
    JustificationSjr retour = createNonPersistent();
    copieElements(retour);
    return retour;
  }
  
  public static JustificationSjr copieNonPersistante(JustificationSjr origine)
  {
    if (origine == null) {
      return createNonPersistent();
    }
    return origine.copieNonPersistante();
  }
  
  public JustificationSjr(DomPCSpec cepAbstraitPC)
  {
    super(cepAbstraitPC);
  }
  
  public JustificationDiviseur getJustificationDiviseur()
  {
    return justificationDiviseur;
  }
  
  public void setJustificationDiviseur(JustificationDiviseur justificationDiviseur)
  {
    this.justificationDiviseur = justificationDiviseur;
  }
  
  public JustificationPlafonds getJustificationPlafonds()
  {
    return justificationPlafonds;
  }
  
  public void setJustificationPlafonds(JustificationPlafonds justificationPlafonds)
  {
    this.justificationPlafonds = justificationPlafonds;
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    JustificationSjr copie = (JustificationSjr)pCopie;
    copie.setJustificationDiviseur((JustificationDiviseur)getJustificationDiviseur().copie());
    copie.setJustificationPlafonds((JustificationPlafonds)getJustificationPlafonds().copie());
    JustificationSr copieJustif = copie.createJustificationSr();
    getJustificationSr().copieElements(copieJustif);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getJustificationSr());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
}

/* Location:
 * Qualified Name:     JustificationSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */