package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.autresdoms.ga.dom.spec.RemunerationSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class JustificationSrPeriodeRemunerationParticipante
  extends ObjetChronoPeriode
  implements ObjetMetierSpec
{
  private transient RemunerationSpec m_periodeRemunerationParticipante;
  private transient BigDecimal m_montantRetenu;
  
  public JustificationSrPeriodeRemunerationParticipante() {}
  
  public JustificationSrPeriodeRemunerationParticipante(Damj p_dateDebut, Damj p_dateFin)
  {
    super(p_dateDebut, p_dateFin);
  }
  
  public JustificationSrPeriodeRemunerationParticipante(Periode p_periode)
  {
    super(p_periode);
  }
  
  public BigDecimal getMontantRetenu()
  {
    return m_montantRetenu;
  }
  
  public void setMontantRetenu(BigDecimal p_montantRetenu)
  {
    m_montantRetenu = p_montantRetenu;
  }
  
  public RemunerationSpec getPeriodeRemunerationParticipante()
  {
    return m_periodeRemunerationParticipante;
  }
  
  public void setPeriodeRemunerationParticipante(RemunerationSpec p_periodeRemunerationParticipante)
  {
    m_periodeRemunerationParticipante = p_periodeRemunerationParticipante;
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationSrPeriodeRemunerationParticipante copie = new JustificationSrPeriodeRemunerationParticipante();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationSrPeriodeRemunerationParticipante copie = (JustificationSrPeriodeRemunerationParticipante)p_copie;
    copie.setMontantRetenu(getMontantRetenu());
    
    copie.setDateDebut(getDateDebut());
    copie.setDateFin(getDateFin());
    if (getPeriodeRemunerationParticipante() != null) {
      copie.setPeriodeRemunerationParticipante((RemunerationSpec)getPeriodeRemunerationParticipante().copie());
    }
  }
}

/* Location:
 * Qualified Name:     JustificationSrPeriodeRemunerationParticipante
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */