package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.RepriseAssocieeGen;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.AttributionAssocieeSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.FinancementSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class RepriseAssociee
  extends RepriseAssocieeGen
  implements FinancementSpec, AttributionAssocieeSpec
{
  private static final long serialVersionUID = 1L;
  
  public RepriseAssociee(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public RepriseAssociee() {}
  
  public RepriseAssociee(Damj p_dateEvenement)
  {
    super(p_dateEvenement);
  }
  
  public RepriseAssociee(Damj p_dateEvenement, DossierExamen p_dossierExamen)
  {
    super(p_dateEvenement);
    copie(p_dossierExamen);
  }
  
  protected void copie(Attribution p_source)
  {
    if (p_source == null) {
      return;
    }
    super.copie(p_source);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    RepriseAssociee copie = (RepriseAssociee)p_copie;
    super.copieElements(copie);
  }
  
  public ObjetMetierSpec copie()
  {
    RepriseAssociee copie = new RepriseAssociee();
    copieElements(copie);
    return copie;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public boolean estExecutable()
  {
    return false;
  }
  
  public String getNatureFinancement()
  {
    if (getConstitutionDurees().getDureeIndemnisation().getDureeEffective().getValeurEntiere() == 0) {
      return "E";
    }
    if (getCompetenceFinanciere() == 2) {
      return "E";
    }
    return "P";
  }
  
  public BigDecimal getSJRRetenu()
  {
    return getConstitutionSjr().getSjrrp().getSalaire();
  }
}

/* Location:
 * Qualified Name:     RepriseAssociee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */