package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.SjrActiviteConserveeGen;
import fr.unedic.cali.asu.dom.SjrActiviteConserveeSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.parcours.ContexteParcoursCali;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;

public class SjrActiviteConservee
  extends SjrActiviteConserveeGen
  implements SjrActiviteConserveeSpec, ObjetPersistantSpec
{
  private transient TravailSpec m_periodeActiviteConservee;
  
  public SjrActiviteConservee() {}
  
  public SjrActiviteConservee(DomPCSpec conserveePC)
  {
    super(conserveePC);
  }
  
  public SjrActiviteConservee(QuantiteEuro sjrInitial)
  {
    setSjrInitial(sjrInitial);
  }
  
  public void setPrc(PrcSjc prc)
  {
    DomManager.supprimer(super.getPrc(), prc);
    super.setPrc(prc);
  }
  
  public String toString()
  {
    StringBuffer chaineRetour = new StringBuffer();
    chaineRetour.append(super.toString() + "\n");
    chaineRetour.append("SjrInitial activité conservée : " + getSjrInitial() + "\n");
    chaineRetour.append("PrcSjc : " + getPrc() + "\n");
    return chaineRetour.toString();
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(getPrc());
  }
  
  public ObjetMetierSpec copie()
  {
    SjrActiviteConservee copie = new SjrActiviteConservee();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    SjrActiviteConservee copie = (SjrActiviteConservee)p_copie;
    if (getPrc() != null) {
      copie.setPrc((PrcSjc)getPrc().copie());
    }
    copie.setSjrInitial(getSjrInitial());
    copie.setIdentifiantPeriodeActiviteConservee(getIdentifiantPeriodeActiviteConservee());
    copie.setTypeActiviteConservee(getTypeActiviteConservee());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public TravailSpec getPeriodeActiviteConservee()
  {
    if (m_periodeActiviteConservee == null)
    {
      Individu individuCourant = ContexteParcoursCali.getIndividuCourant();
      
      m_periodeActiviteConservee = ((TravailSpec)individuCourant.rechercherPeriodePasseProfessionnel(getIdentifiantPeriodeActiviteConservee()));
    }
    return m_periodeActiviteConservee;
  }
  
  public void setPeriodeActiviteConservee(TravailSpec periodeActiviteConservee)
  {
    m_periodeActiviteConservee = periodeActiviteConservee;
    if (periodeActiviteConservee != null) {
      setIdentifiantPeriodeActiviteConservee(periodeActiviteConservee.getIdentifiant());
    }
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
}

/* Location:
 * Qualified Name:     SjrActiviteConservee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */