package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.pc.DifferePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Periode;

public abstract class DiffereGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_differePC;
  private Periode m_periodeEffet = null;
  private Quantite m_quantiteInitial;
  
  public DiffereGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public DiffereGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new DifferePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_differePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_differePC)
  {
    m_differePC = p_differePC;
  }
  
  protected Periode rawGetPeriodeEffet()
  {
    return ((DifferePC)getPC()).getPeriodeEffet();
  }
  
  public Periode getPeriodeEffet()
  {
    return ((DifferePC)getPC()).getPeriodeEffet();
  }
  
  public void setPeriodeEffet(Periode p_periodeEffet)
  {
    if ((m_periodeEffet == null) || (p_periodeEffet == null))
    {
      m_periodeEffet = p_periodeEffet;
      ((DifferePC)getPC()).setPeriodeEffet(p_periodeEffet);
    }
    else if ((m_periodeEffet != null) && (p_periodeEffet != null) && (!p_periodeEffet.equals(m_periodeEffet)))
    {
      m_periodeEffet = p_periodeEffet;
      ((DifferePC)getPC()).setPeriodeEffet(p_periodeEffet);
    }
  }
  
  protected Quantite rawGetQuantiteInitial()
  {
    return ((DifferePC)getPC()).getQuantiteInitial();
  }
  
  public Quantite getQuantiteInitial()
  {
    return ((DifferePC)getPC()).getQuantiteInitial();
  }
  
  public void setQuantiteInitial(Quantite p_quantiteInitial)
  {
    if ((m_quantiteInitial == null) || (p_quantiteInitial == null))
    {
      m_quantiteInitial = p_quantiteInitial;
      ((DifferePC)getPC()).setQuantiteInitial(p_quantiteInitial);
    }
    else if ((m_quantiteInitial != null) && (p_quantiteInitial != null) && (!p_quantiteInitial.equals(m_quantiteInitial)))
    {
      m_quantiteInitial = p_quantiteInitial;
      ((DifferePC)getPC()).setQuantiteInitial(p_quantiteInitial);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     DiffereGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */