package fr.unedic.cali.asu.cge01.p03.liquidation.fabriques;

import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies.StrategieSjrPndsApresMEP08SI2;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies.StrategieSjrPndsAvantMEP08SI2;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies.StrategieSjrPndsSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieSjrPnds
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_PIVOT_MEP_08SI2 = new Damj(2008, 6, 14);
  private static FabriqueStrategieSjrPnds s_instance = new FabriqueStrategieSjrPnds();
  
  public static FabriqueStrategieSjrPnds getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StrategieSjrPndsSpec strategie = null;
    
    Damj datePivotSjrPnds = p_critereStrategie.getDatePivot();
    if (datePivotSjrPnds == null) {
      throw new UnsupportedOperationException("FabriqueStrategieSjrPnds : la date pivot est null.");
    }
    if (datePivotSjrPnds.estApresOuCoincideAvec(DATE_PIVOT_MEP_08SI2)) {
      strategie = new StrategieSjrPndsApresMEP08SI2();
    } else {
      strategie = new StrategieSjrPndsAvantMEP08SI2();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieSjrPnds
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */