package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.CalculAppartenance;
import fr.unedic.cali.asu.parametres.AccesListeUnitesReglement;
import fr.unedic.cali.asu.parametres.ValeurListeUnitesReglement;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationAffiliation;
import fr.unedic.cali.asu.produits.liquidation.dom.QuantitesAppartenance;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.Convertisseur;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Iterator;

public class StrategieCalculCoeffSaisonnierAvantMEP08SI2
  implements StrategieCalculCoeffSaisonnierSpec
{
  public static final Unite JOUR = Unite.get("jour d'affiliation");
  
  public Quantite calculAppartenance(DemandeSpec p_demande, JustificationAffiliation p_justificationAffi, Periode p_periode, Chronologie p_passeProfessionnel, Reglement p_reglement)
    throws ApplicativeException
  {
    QuantitesAppartenance listeAffiSaisonniere = CalculAppartenance.getInstance().calculer(p_demande, null, p_periode, p_passeProfessionnel, p_reglement);
    
    ProduitAsuSpec produitAffecte = (ProduitAsuSpec)p_demande.getDossierAffectation().getProduit();
    Convertisseur convertisseurUniteAffiliation = produitAffecte.determinerConvertisseurUniteAffiliation();
    
    return determinerAffiliationJour(listeAffiSaisonniere, p_reglement, convertisseurUniteAffiliation);
  }
  
  private Quantite determinerAffiliationJour(QuantitesAppartenance p_listeAffiSaisonniere, Reglement p_reglement, Convertisseur p_convertisseurUniteAffiliation)
  {
    Quantite affiSaisonnierJourTable = p_listeAffiSaisonniere.getQuantiteAffiliation(JOUR);
    if (affiSaisonnierJourTable == null)
    {
      Iterator iterUniteAffiliation = AccesListeUnitesReglement.get(p_reglement, null).getListeUnites().iterator();
      do
      {
        Unite unite = (Unite)iterUniteAffiliation.next();
        affiSaisonnierJourTable = p_listeAffiSaisonniere.getQuantiteAffiliation(unite);
        if (affiSaisonnierJourTable != null) {
          affiSaisonnierJourTable = p_convertisseurUniteAffiliation.convertir(affiSaisonnierJourTable, JOUR);
        }
      } while ((affiSaisonnierJourTable == null) && (iterUniteAffiliation.hasNext()));
    }
    Quantite affiSaisonnierJour = new Quantite(affiSaisonnierJourTable.getValeurEntiere(), affiSaisonnierJourTable.getUnite());
    return affiSaisonnierJour;
  }
}

/* Location:
 * Qualified Name:     StrategieCalculCoeffSaisonnierAvantMEP08SI2
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */