package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.services.Resultat;

public class ConstitutionProduitResultant
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException, ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA15 = new Resultat(0);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    
    dossierExamenCourant.createConstitutionProduitResultant();
    if (verifierPreconditions(p_contexte))
    {
      int contexteExamen = getContexteExamen(p_contexte);
      if (contexteExamen == 3) {
        getParcours().effectuerParcours(p_contexte);
      } else if (contexteExamen == 4) {
        getParcoursSP().effectuerParcours(p_contexte);
      }
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA15;
  }
  
  protected boolean verifierPreconditions(Contexte p_contexte)
  {
    boolean preconditionsValides = true;
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    if ((dossierExamenCourant.getConditionsAttributionAdmission() != null) && (dossierExamenCourant.getConditionsAttributionAdmission().estSatisfait())) {
      preconditionsValides = true;
    } else {
      preconditionsValides = false;
    }
    return preconditionsValides;
  }
  
  private int getContexteExamen(Contexte p_contexte)
  {
    return ((DomLiquidationAssurance)p_contexte.getDonnees()).getContexteExamen();
  }
  
  protected Parcours getParcours()
  {
    return new ConstitutionProduitResultantClassique();
  }
  
  protected Parcours getParcoursSP()
  {
    return new ConstitutionProduitResultantSP();
  }
}

/* Location:
 * Qualified Name:     ConstitutionProduitResultant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */