package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.RechercheConditionAgePourMaintien;
import fr.unedic.cali.asu.mnt.dom.ConditionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.asu.mnt.dom.DossierExamen;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.parcours.DomLiquidationDemande;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionAgePourMaintien
  extends ParcoursCali
  implements ParcoursAssurance
{
  public static DemandeSpec getDemande(Contexte p_contexte)
  {
    return ((DomLiquidationDemande)p_contexte.getDonnees()).getDemandeSpec();
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    Resultat resultatCam01 = new Resultat(1);
    DemandeMaintien demandeMaintien = (DemandeMaintien)getDemande(p_contexte);
    if (Log.isTraceActive(DeterminationConditionAgePourMaintien.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionAgePourMaintien.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionAgePourMaintien.class, "demarrer", "\t\t******** Début Parcours DeterminationConditionAgePourMaintien ********\n");
    }
    ConditionAgeMaintien conditionAge = RechercheConditionAgePourMaintien.rechercherConditionAge(demandeMaintien);
    
    demandeMaintien.getDossierExamen().setConditionAge(conditionAge);
    if (conditionAge.estSatisfait())
    {
      resultatCam01.setEtat(0);
    }
    else
    {
      resultatCam01.setEtat(1);
      resultatCam01.setMessageErreur(Integer.toString(conditionAge.getCodeMotifEchec()));
    }
    if (Log.isTraceActive(DeterminationConditionAgePourMaintien.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionAgePourMaintien.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionAgePourMaintien.class, "demarrer", "\t\t******** Fin Parcours DeterminationConditionAgePourMaintien ********\n");
    }
    return resultatCam01;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionAgePourMaintien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */