package fr.unedic.cali.asu.cge01.p03.liquidation.parcours.asp;

import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionFaitGenerateur
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCAPA04 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    
    ConditionFaitGenerateur capaFaitGenerateur = ((DossierExamen)demande.getDossierExamen()).createConditionFaitGenerateur();
    TravailSpec dernierSinistre = ((DossierAffectation)demande.getDossierAffectation()).getSinistre();
    
    capaFaitGenerateur.setPeriodeFaitGenerateur((ActiviteSalarie)dernierSinistre);
    resultatCAPA04.setEtat(0);
    
    OutilTrace.ecrireTrace(Niveau.DEBUG, new Object[] { "Résultat : ", resultatCAPA04 });
    
    OutilTrace.tracerFinParcours();
    
    return resultatCAPA04;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionFaitGenerateur
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */