package fr.unedic.cali.asu.cge01.p03.liquidation.parcours.novation;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.novation.OutilConstitutionCoefficientSaisonnier;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public final class ParcoursConstitutionCoefficientSaisonnier
  extends ParcoursCali
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    Attribution attributionAssurance = (Attribution)demande.getAttribution();
    
    ConstitutionCoefficientSaisonnier coefficientSaisonnier = attributionAssurance.getConstitutionElementsActifs().getConstitutionCoefficientSaisonnier();
    if (coefficientSaisonnier == null) {
      coefficientSaisonnier = attributionAssurance.getConstitutionElementsActifs().createConstitutionCoefficientSaisonnier();
    }
    OutilConstitutionCoefficientSaisonnier.getInstance().alimenterConstitutionCoefficientSaisonnier(coefficientSaisonnier, attributionAssurance);
    return new Resultat(0);
  }
}

/* Location:
 * Qualified Name:     ParcoursConstitutionCoefficientSaisonnier
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */