package fr.unedic.cali.asu.cge01.p04.antecedent;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.ResultatDeterminationDateLimiteIndemnisation;
import fr.unedic.util.services.CoucheLogiqueException;

public class GrapheAntecedent
  extends fr.unedic.cali.asu.cge01.antecedent.GrapheAntecedent
{
  public static GrapheAntecedent getInstance()
  {
    return new GrapheAntecedent();
  }
  
  protected void alimenterConstitutionMontantBrut(DossierExamenAssuranceSpec dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    DeterminationMontantsBruts.getInstance().determinerMontantsBruts((Demande)dossierExamen.getDemande());
    DeterminationMontantsBruts.getInstance().alimentationCapitalDroitCourant((Demande)dossierExamen.getDemande());
  }
  
  protected void alimenterDateLimiteIndemnisation(Demande demande, DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    if ((OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ASPARE")) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ASPDC")))
    {
      ConstitutionDateLimiteIndemnisation dateLimiteIndemnisation = dossierExamen.getConstitutionElementsActifs().createConstitutionDateLimiteIndemnisation();
      ResultatDeterminationDateLimiteIndemnisation resultat = DeterminationDateLimiteIndemnisation.determinerDateLimiteIndemnisation(demande);
      dateLimiteIndemnisation.setDateLimiteIndem(resultat.getDateLimiteIndemnisation());
    }
  }
}

/* Location:
 * Qualified Name:     GrapheAntecedent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */