package fr.unedic.cali.asu.cge01.p04.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatDeterminationDuree;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationDureeReglementaire;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ConstitutionDureeReglementaireFinancement
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA02 = new Resultat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    ResultatDeterminationDuree resultat = DeterminationDureeReglementaire.getInstance().determinerDureeReglementaireFinancementAtp(demande);
    DeterminationDureeReglementaire.getInstance().mapperResultatSurDom(resultat, dossierExamenCourant.getConstitutionElementsActifs().createConstitutionDurees().createDureeIndemnisation());
    
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA02;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDureeReglementaireFinancement
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */