package fr.unedic.cali.asu.cge01.p07.liquidation.outilsfonctionnels.reglementapplicable;

import fr.pe.cali.reglementaire.regles.assurance.cep.reglementapplicable.outils.spec.IOutilFonctionnelReglementApplicable;
import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.EreGammeAsu;
import fr.unedic.cali.asu.dom.EreRechargement;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.parcours.ParcoursAffectationDemandeAssurance;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.affectation.outilsfonctionnels.qualification.ValidationAnnexe4Convention2014;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.temps.Chronologie;

public class OutilFonctionnelReglementApplicable
  implements IOutilFonctionnelReglementApplicable
{
  private Demande demande;
  
  public OutilFonctionnelReglementApplicable(Demande demande)
  {
    this.demande = demande;
  }
  
  public boolean estActiviteRG5(ActiviteSalarie activiteSalarie)
  {
    ValidationAnnexe4Convention2014 outilValidation = new ValidationAnnexe4Convention2014();
    return outilValidation.validerPeriode(activiteSalarie.getPeriodeActiviteSalarieGaec());
  }
  
  public boolean estProduitValiditeAvecActiviteRG5(Chronologie activitesParticipantes)
    throws ApplicativeException
  {
    Demande copieDemande = (Demande)demande.copie();
    copieDemande.annulerDecisions();
    copieDemande.setDemandeLiquidee(true);
    Contexte contexte = new Contexte();
    DomLiquidationAssurance dom = new DomLiquidationAssurance();
    dom.setDemande(copieDemande);
    contexte.setDonnees(dom);
    if ((copieDemande.getEvenementReferenceExamen() instanceof EreRechargement)) {
      ((EreRechargement)copieDemande.getEvenementReferenceExamen()).activerReglementInterimaire();
    }
    ((EreGammeAsu)copieDemande.getEvenementReferenceExamen()).determinerParcoursAffectationDemandeAssurance(copieDemande).effectuerParcours(contexte);
    return (copieDemande.getDossierAffectationAdmission().getValidationProduit() != null) && (copieDemande.getDossierAffectationAdmission().getValidationProduit().isEstProduitValide()) && ("RG5".equals(copieDemande.getDossierAffectationAdmission().getValidationProduit().getReglementApplicable().getNomReglement()));
  }
}

/* Location:
 * Qualified Name:     OutilFonctionnelReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */