package fr.unedic.cali.asu.cge01.parametres;

import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.temps.DureeCalendaire;
import java.math.BigDecimal;

public class Parametres
{
  public static final int DUREE_POUR_IMPUTATION_FORMATION = 1094;
  public static final BigDecimal PLAFOND_DIVISEUR_PRC = new BigDecimal(365);
  public static final BigDecimal PLAFOND_HORAIRE_ACTIVITES_CONSERVEES = new BigDecimal("110");
  public static final BigDecimal POURCENTAGE_PLAFOND_REMUNERATION_ACTIVITES_CONSERVEES = new BigDecimal("0.7");
  public static final DureeCalendaire AGE_57_ANS_6_MOIS = new DureeCalendaire(57, 6);
  public static final DureeCalendaire AGE_58_ANS = new DureeCalendaire(58);
  public static final DureeCalendaire AGE_MINIMUM_MAINTIEN_60_ANS_6_MOIS = new DureeCalendaire(60, 6);
  public static final DureeCalendaire AGE_MINIMUM_MAINTIEN = AGE_MINIMUM_MAINTIEN_60_ANS_6_MOIS;
  public static final DureeCalendaire AGE_MINIMUM_MAINTIEN_61_ANS = new DureeCalendaire(61);
  public static final DureeCalendaire AGE_MINIMUM_MAINTIEN_62_ANS = new DureeCalendaire(62);
  public static final DureeCalendaire AGE_MINIMUM_MAINTIEN_61_ANS_7_MOIS = new DureeCalendaire(61, 7);
  public static final int ANNEE_1954 = 1954;
  public static final DureeCalendaire AGE_MINIMUM_MAINTIEN_61_ANS_2_MOIS = new DureeCalendaire(61, 2);
  public static final int ANNEE_1953 = 1953;
  public static final int NOMBRE_TRIMESTRES_REQUIS_MAINTIEN = 100;
  public static final int NOMBRE_JOURS_INDEMNISATION_REQUIS_MAINTIEN = 365;
  public static final DureeCalendaire AGE_DEBUT_PASSE_PROFESSIONNEL_MAINTIEN = new DureeCalendaire(14);
  public static final DureeCalendaire DUREE_PERIODE_RECHERCHE_ACTIVITE_MAINTIEN = new DureeCalendaire(5);
  public static final Quantite QUANTITE_APPARTENANCE_REQUISE_MAINTIEN = new Quantite(4380, Unite.getParCode("11"));
  public static final Quantite QUANTITE_LIMITE_ASSIMILATION_MAINTIEN = new Quantite(1825, Unite.getParCode("11"));
  private static final Quantite QUANTITE_ACTIVITE_REQUISE_CAS_GENERAL_MAINTIEN = new Quantite(730, Unite.getParCode("11"));
  private static final Quantite QUANTITE_ACTIVITE_REQUISE_ANNEXE4_MAINTIEN = new Quantite(3264, Unite.getParCode("3"));
  private static final Quantite QUANTITE_ACTIVITE_CONSECUTIVE_REQUISE_CAS_GENERAL_MAINTIEN = new Quantite(365, Unite.getParCode("11"));
  private static final Quantite QUANTITE_ACTIVITE_CONSECUTIVE_REQUISE_ANNEXE4_MAINTIEN = new Quantite(1812, Unite.getParCode("3"));
  
  public static Quantite getQuantiteActiviteConsecutiveRequisePourMaintien(Reglement p_reglementApplicable)
  {
    Quantite activiteRequise = null;
    if (p_reglementApplicable.estNomReglementIdentique("A4")) {
      activiteRequise = new Quantite(QUANTITE_ACTIVITE_CONSECUTIVE_REQUISE_ANNEXE4_MAINTIEN.getValeur(), UniteAffiliation.HEURE_TRAVAIL);
    } else {
      activiteRequise = QUANTITE_ACTIVITE_CONSECUTIVE_REQUISE_CAS_GENERAL_MAINTIEN;
    }
    return activiteRequise;
  }
  
  public static Quantite getQuantiteActiviteRequisePourMaintien(Reglement p_reglementApplicable)
  {
    Quantite activiteRequise = null;
    if (p_reglementApplicable.estNomReglementIdentique("A4")) {
      activiteRequise = new Quantite(QUANTITE_ACTIVITE_REQUISE_ANNEXE4_MAINTIEN.getValeur(), UniteAffiliation.HEURE_TRAVAIL);
    } else {
      activiteRequise = QUANTITE_ACTIVITE_REQUISE_CAS_GENERAL_MAINTIEN;
    }
    return activiteRequise;
  }
}

/* Location:
 * Qualified Name:     Parametres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */