package fr.unedic.cali.asu.cge01.parametres;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation.spec.ParametresDernierJourFevrierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

public class ParametresDerniersJoursFevrier
  implements ParametresDernierJourFevrierSpec
{
  private static Map s_parametresFevrier = new HashMap();
  private static final Unite UNITE_HEURE = Unite.getParCode("18");
  private static final Unite UNITE_JOUR = Unite.getParCode("11");
  private static final Unite UNITE_EMBARQUEMENT_ADMINISTRATIF = Unite.getParCode("16");
  
  static
  {
    Map quantitesRG = new HashMap();
    s_parametresFevrier.put("RG", quantitesRG);
    quantitesRG.put(UNITE_HEURE, new Quantite(new BigDecimal(10), UNITE_HEURE));
    quantitesRG.put(UNITE_JOUR, new Quantite(new BigDecimal(2), UNITE_JOUR));
    
    Map quantitesA1 = new HashMap();
    s_parametresFevrier.put("A1", quantitesA1);
    quantitesA1.put(UNITE_JOUR, new Quantite(new BigDecimal(2), UNITE_JOUR));
    
    Map quantitesA2A = new HashMap();
    s_parametresFevrier.put("A2a".toUpperCase(), quantitesA2A);
    quantitesA2A.put(UNITE_EMBARQUEMENT_ADMINISTRATIF, new Quantite(new BigDecimal(2), UNITE_EMBARQUEMENT_ADMINISTRATIF));
    quantitesA2A.put(UNITE_HEURE, new Quantite(new BigDecimal(14), UNITE_HEURE));
    
    Map quantitesA2B = new HashMap();
    s_parametresFevrier.put("A2b".toUpperCase(), quantitesA2B);
    quantitesA2B.put(UNITE_EMBARQUEMENT_ADMINISTRATIF, new Quantite(new BigDecimal(2), UNITE_EMBARQUEMENT_ADMINISTRATIF));
    
    Map quantitesA5 = new HashMap();
    s_parametresFevrier.put("A5", quantitesA5);
    quantitesA5.put(UNITE_HEURE, new Quantite(new BigDecimal(10), UNITE_HEURE));
    
    Map quantitesA9B = new HashMap();
    s_parametresFevrier.put("A9B", quantitesA9B);
    quantitesA5.put(UNITE_JOUR, new Quantite(new BigDecimal(2), UNITE_JOUR));
  }
  
  public Map recupererQuantiteDernierJourFevrierPourReglement(String p_reglement)
  {
    return (Map)s_parametresFevrier.get(p_reglement);
  }
}

/* Location:
 * Qualified Name:     ParametresDerniersJoursFevrier
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */