package fr.unedic.cali.asu.cge01.revision;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsRevisions;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ObjectifExamenSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.util.List;

public class ConstitutionDelaisReports
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA = null;
    Demande demande = ((DomLiquidationAssurance)p_contexte.getDonnees()).getDemande();
    IndividuSpec individu = demande.getDemandeur();
    
    List<TravailSpec> fctsAdmission = OutilsRevisions.getListeFctsAssocieesAdmission(demande);
    
    ChronologiePeriodes chronofcts = new ChronologiePeriodes();
    chronofcts.ajouter(fctsAdmission);
    
    individu.setChronoPeriodePasseProfessionnelLiquidationRevision(chronofcts);
    individu.activerChronoPasseProPourLiquidationRevision();
    
    ProduitAsuSpec produit = (ProduitAsuSpec)demande.getDossierAffectation().getProduit();
    
    ObjectifExamenSpec objectif = (ObjectifExamenSpec)produit.creerObjectifExamen(15, demande.getListContexteDemande());
    Parcours parcours = objectif.creerParcoursDelaisReports();
    if (parcours != null) {
      parcours.effectuerParcours(p_contexte);
    }
    individu.desactiverChronoPasseProPourLiquidationRevision();
    
    OutilTrace.tracerFinParcours();
    
    resultatCEPA = new Resultat(0);
    return resultatCEPA;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDelaisReports
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */