package fr.unedic.cali.asu.cge01.revision;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.revision.outilsfonctionnels.DeterminationListePensionInvaliditeRevisionAre14;
import fr.unedic.cali.asu.cge01.revision.outilsfonctionnels.DeterminationMontantsBruts;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodePensionInvaliditeChaineeSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import java.math.BigDecimal;
import java.util.Collection;

public class ConstitutionMontantsBruts
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA = new Resultat();
    
    Demande demandeRevision = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen attributionRevision = (DossierExamen)demandeRevision.getDossierExamen();
    
    fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionMontantsBruts cepaMontant = attributionRevision.getConstitutionElementsActifs().getConstitutionMontantsBruts();
    
    BigDecimal montantRevision = DeterminationMontantsBruts.determinerMontantRevision(demandeRevision);
    Collection<PeriodePensionInvaliditeChaineeSpec> listePi = DeterminationListePensionInvaliditeRevisionAre14.determinationListePisRevision(demandeRevision);
    QuantiteEuro montantJournalierBrut = new QuantiteEuro(montantRevision);
    
    cepaMontant.setMontantJournalierBrut(montantJournalierBrut);
    cepaMontant.setListePensionInvalidite(listePi);
    resultatCEPA.setEtat(0);
    
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA;
  }
}

/* Location:
 * Qualified Name:     ConstitutionMontantsBruts
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */