package fr.unedic.cali.asu.cge01.revision;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.revision.outilsfonctionnels.DeterminationReglementApplicable;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ConstitutionReglementApplicable
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierExamen();
    fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionReglementApplicable constitutionReglementApplicableRevision = (fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionReglementApplicable)dossierExamen.createConstitutionReglementApplicable();
    
    fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionReglementApplicable constitutionReglementApplicableOd = (fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionReglementApplicable)DeterminationReglementApplicable.determinerReglementApplicable(demande);
    
    constitutionReglementApplicableOd.copieElements(constitutionReglementApplicableRevision);
    
    resultatCEPA.setEtat(0);
    
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA;
  }
}

/* Location:
 * Qualified Name:     ConstitutionReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */