package fr.unedic.cali.asu.cge01.revision.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;

public class DeterminationDureeReglementaire
{
  public static BigDecimal deteminerDureeReglementaire(Demande pDemandeRevision)
  {
    DossierExamen dossierExamen = (DossierExamen)pDemandeRevision.getDossierExamen();
    ConstitutionMontantsBruts constitutionMontantsBruts = dossierExamen.getConstitutionMontantsBruts();
    BigDecimal capital = constitutionMontantsBruts.getCapitalInitialBrut().getValeur();
    BigDecimal montant = constitutionMontantsBruts.getMontantJournalierBrut().getValeur();
    return calculerDuree(capital, montant);
  }
  
  public static BigDecimal calculerDuree(BigDecimal pCapital, BigDecimal pMontant)
  {
    if ((pCapital == null) || (pMontant == null) || (pMontant.compareTo(BigDecimal.ZERO) == 0)) {
      return BigDecimal.ZERO;
    }
    BigDecimal dureeRevision = Mathematiques.diviseParDefaut(pCapital, pMontant);
    dureeRevision = dureeRevision.setScale(0, 0);
    return dureeRevision;
  }
}

/* Location:
 * Qualified Name:     DeterminationDureeReglementaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */