package fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.csa06.parametres.FabriqueParametres;
import fr.unedic.cali.asu.csa06.parametres.spec.ParametresSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.ComparateurTemporelSurDateFinDecroissante;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieAutreQueFormationCifCdd;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieeMotifDvNonLegitime;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.FiltreFinDansBornes;
import fr.unedic.util.temps.FiltresTemporel;

public class ConstructionChronologie
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionChronologie
{
  public static Chronologie determinerChronoActivitesDV(Demande p_demande, DossierExamen p_dossierExamen)
  {
    Chronologie chronoActivitesDV = null;
    
    ParametresSpec parametres = FabriqueParametres.getParametres(p_demande);
    
    Pra pra = ConstructionPra.getPra(p_dossierExamen.getFaitGenerateur().getPeriodeFaitGenerateur(), p_demande, parametres);
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarieAutreQueFormationCifCdd());
    
    filtres.ajouterFiltre(new FiltreActiviteSalarieeMotifDvNonLegitime());
    filtres.ajouterFiltre(new FiltreFinDansBornes(pra.getDebut(), pra.getFin()));
    chronoActivitesDV = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    chronoActivitesDV.setComparateur(new ComparateurTemporelSurDateFinDecroissante());
    
    return chronoActivitesDV;
  }
}

/* Location:
 * Qualified Name:     ConstructionChronologie
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */