package fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.csa06.parametres.spec.ParametresSpec;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;

public class ConstructionPra
{
  public static Pra getPra(ActiviteSalarie p_periodeActiviteSalarie, DemandeAssuranceSpec p_demande, ParametresSpec p_parametres)
  {
    Periode periodeReference = determinerPeriodeReference(p_periodeActiviteSalarie, p_demande, p_parametres);
    Pra pra = new Pra(periodeReference);
    
    return pra;
  }
  
  private static Periode determinerPeriodeReference(ActiviteSalarie p_periodeActiviteSalarie, DemandeAssuranceSpec p_demande, ParametresSpec p_parametres)
  {
    int duree = p_parametres.getDureePraEnMois().getValeurEntiere();
    
    Damj terme = p_periodeActiviteSalarie.getDateFin();
    
    Damj dateFgOdPrecedent = p_demande.getDateFaitGenerateurOdPrecedente();
    DureeCalendaire dureeCalendaire = new DureeCalendaire(0, duree, 0);
    Damj depart = terme.deplacerVersArriere(dureeCalendaire).lendemain();
    if ((dateFgOdPrecedent != null) && (depart.estAvant(dateFgOdPrecedent))) {
      depart = dateFgOdPrecedent.lendemain();
    }
    return new Periode(depart, terme);
  }
}

/* Location:
 * Qualified Name:     ConstructionPra
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */