package fr.unedic.cali.asu.csa06.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatRechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.strategies.spec.StrategieConditionChomageInvolontaireAre14Spec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieConditionChomageInvolontaire;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.GestionDemandeDv122eJour;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionChomageInvolontaire;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConditionsAttributionSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public abstract class DeterminationConditionChomageInvolontaire
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCapa09 = new Resultat(1);
    
    Demande demandeAssurance = DomLiquidationAssurance.getDemande(contexte);
    
    ConditionChomageInvolontaire conditionChomageInvolontaire = ((DossierExamen)demandeAssurance.getDossierExamen()).getConditionsAttributionActives().createConditionChomageInvolontaire();
    
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDemande(demandeAssurance);
    critereStrategie.setDatePivot(demandeAssurance.getDateExamen());
    StrategieConditionChomageInvolontaireAre14Spec strategie = (StrategieConditionChomageInvolontaireAre14Spec)FabriqueStrategieConditionChomageInvolontaire.getInstance().getStrategie(critereStrategie);
    
    ResultatRechercheConditionChomageInvolontaire resultat = strategie.rechercheConditionChomageInvolontairePourOd(demandeAssurance);
    alimenterCap(conditionChomageInvolontaire, resultat, demandeAssurance);
    if (conditionChomageInvolontaire.estSatisfait())
    {
      resultatCapa09.setEtat(0);
    }
    else
    {
      resultatCapa09.setEtat(1);
      resultatCapa09.setMessageErreur(Integer.toString(conditionChomageInvolontaire.getCodeMotifEchec()));
    }
    OutilTrace.tracerFinParcours();
    return resultatCapa09;
  }
  
  private static void alimenterCap(ConditionChomageInvolontaire conditionChomageInvolontaire, ResultatRechercheConditionChomageInvolontaire resultat, Demande demandeAssurance)
    throws CoucheLogiqueException
  {
    conditionChomageInvolontaire.setEtatSatisfait(resultat.getResultatElementDroit().estSatisfait());
    conditionChomageInvolontaire.setSituationConditionChomageInvolontaire(resultat.getSituationConditionChomageInvolontaire());
    conditionChomageInvolontaire.setCodeMotifEchec(resultat.getResultatElementDroit().getCodeMotifEchec());
    if ((!conditionChomageInvolontaire.estSatisfait()) && (conditionChomageInvolontaire.getCodeMotifEchec() != 93)) {
      conditionChomageInvolontaire.setDateDepartDelai121j(GestionDemandeDv122eJour.calculerPointDepart(demandeAssurance, demandeAssurance));
    }
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionChomageInvolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */