package fr.unedic.cali.asu.csa06.p01.liquidation.dom;

import fr.unedic.cali.asu.csa06.p01.liquidation.dom.gen.ObjectifExamenRepriseGen;
import fr.unedic.cali.asu.csa06.p01.liquidation.parcours.ConstitutionDureePourReprise;
import fr.unedic.cali.asu.csa06.p01.liquidation.parcours.ConstitutionDureeReglementaireRepriseAdhesionVolontaire;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;
import java.util.List;

public class ObjectifExamenReprise
  extends ObjectifExamenRepriseGen
{
  public ObjectifExamenReprise() {}
  
  public ObjectifExamenReprise(List<ContexteDemandeSpec> p_contexteDemande)
  {
    m_contexteDemande = p_contexteDemande;
  }
  
  public ObjectifExamenReprise(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenReprise copie = new ObjectifExamenReprise();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    if ((m_contexteDemande != null) && ((OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "FINASPVOL")) || (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(m_contexteDemande, "ACTIMPREL")))) {
      return new ConstitutionDureeReglementaireRepriseAdhesionVolontaire();
    }
    return new ConstitutionDureePourReprise();
  }
  
  public void marquerGraphePersistant() {}
}

/* Location:
 * Qualified Name:     ObjectifExamenReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */