package fr.unedic.cali.asu.csa06.p01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatRechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.strategies.spec.StrategieConditionChomageInvolontaireAre14Spec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionChomageInvolontaire
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    if (Log.isTraceActive(DeterminationConditionChomageInvolontaire.class, Niveau.DEBUG)) {
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionChomageInvolontaire.class, "demarrer", "\t\t******** Début Parcours DeterminationConditionChomageInvolontaire ********\n");
    }
    Resultat resultatCapa09 = new Resultat(1);
    
    Demande demandeAssurance = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamen = (DossierExamen)demandeAssurance.getDossierExamen();
    ConditionChomageInvolontaire conditionChomageInvolontaire = new ConditionChomageInvolontaire();
    
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDemande(demandeAssurance);
    critereStrategie.setDatePivot(demandeAssurance.getDateExamen());
    StrategieConditionChomageInvolontaireAre14Spec strategie = (StrategieConditionChomageInvolontaireAre14Spec)FabriqueStrategieConditionChomageInvolontaire.getInstance().getStrategie(critereStrategie);
    
    ResultatRechercheConditionChomageInvolontaire resultat = strategie.rechercheConditionChomageInvolontairePourOd(demandeAssurance);
    alimenterCap(conditionChomageInvolontaire, resultat);
    
    dossierExamen.setConditionChomageInvolontaire(conditionChomageInvolontaire);
    if (conditionChomageInvolontaire.estSatisfait())
    {
      resultatCapa09.setEtat(0);
    }
    else
    {
      resultatCapa09.setEtat(1);
      resultatCapa09.setMessageErreur(Integer.toString(conditionChomageInvolontaire.getCodeMotifEchec()));
    }
    if (Log.isTraceActive(DeterminationConditionChomageInvolontaire.class, Niveau.DEBUG)) {
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionChomageInvolontaire.class, "demarrer", "\t\t******** Fin Parcours DeterminationConditionChomageInvolontaire ********\n");
    }
    return resultatCapa09;
  }
  
  private static void alimenterCap(ConditionChomageInvolontaire p_conditionChomageInvolontaire, ResultatRechercheConditionChomageInvolontaire p_resultat)
  {
    p_conditionChomageInvolontaire.setEtatSatisfait(p_resultat.getResultatElementDroit().estSatisfait());
    p_conditionChomageInvolontaire.setSituationConditionChomageInvolontaire(p_resultat.getSituationConditionChomageInvolontaire());
    p_conditionChomageInvolontaire.setCodeMotifEchec(p_resultat.getResultatElementDroit().getCodeMotifEchec());
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionChomageInvolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */