package fr.unedic.cali.asu.csa06.p02.liquidation.parcours;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class ConstitutionReglementApplicable
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {}
  
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    if (Log.isTraceActive(ConstitutionReglementApplicable.class, Niveau.DEBUG)) {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionReglementApplicable.class, "demarrer", "\t\t******** Début Parcours ConstitutionReglementApplicable ********\n");
    }
    Resultat resultatCepa13 = new Resultat(0);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    
    ReglementApplicableSpec reglementApplicable = ((DossierExamen)demandeCourante.getDossierExamen()).createConstitutionReglementApplicable();
    
    reglementApplicable.setReglement(Reglement.getInstance("RG", ProduitAsuCge01P03.getInstance()));
    if (Log.isTraceActive(ConstitutionReglementApplicable.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionReglementApplicable.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionReglementApplicable.class, "demarrer", "\t\t******** Fin Parcours ConstitutionReglementApplicable ********\n");
    }
    return resultatCepa13;
  }
}

/* Location:
 * Qualified Name:     ConstitutionReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */