package fr.unedic.cali.asu.csa06.p02.liquidation.parcours;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.EreDemandeExpresse;
import fr.unedic.cali.asu.outilsfonctionnels.OutilDeterminationObjectifReprise;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.ArrayList;
import java.util.List;

public class ParcoursDeterminationOrdreObjectifs
  extends fr.unedic.cali.asu.cge01.p03.liquidation.parcours.ParcoursDeterminationOrdreObjectifs
{
  protected List<Integer> determinerObjectifsAvecAntecedentValide(Contexte contexte)
    throws CoucheLogiqueException
  {
    Demande demande = getDemande(contexte);
    
    List<Integer> typesObjectifs = new ArrayList();
    if (OutilDeterminationObjectifReprise.getInstance().determineDateExtinctionReliquatSurObjectifReprise(demande) != null)
    {
      typesObjectifs.add(Integer.valueOf(12));
      typesObjectifs.add(Integer.valueOf(13));
    }
    if ((!demande.estDroitOptionReadmission()) && (!(demande.getEvenementReferenceExamen() instanceof EreDemandeExpresse)))
    {
      typesObjectifs.add(Integer.valueOf(13));
      typesObjectifs.add(Integer.valueOf(12));
    }
    else if ((demande.getEvenementReferenceExamen() instanceof EreDemandeExpresse))
    {
      typesObjectifs.addAll(determinerObjectifDemandeExpresseAvecReliquatValide(demande));
    }
    else
    {
      typesObjectifs.add(Integer.valueOf(12));
    }
    return typesObjectifs;
  }
}

/* Location:
 * Qualified Name:     ParcoursDeterminationOrdreObjectifs
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */