package fr.unedic.cali.asu.csa06.p04;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.AlimenterBaseEchangesClauseSauvegarde;
import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.ConstructionPra;
import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.RecuperationFormuleMontant;
import fr.unedic.cali.asu.csa06.liquidation.parcours.ParcoursDeterminationOrdreObjectifs;
import fr.unedic.cali.asu.csa06.p04.liquidation.outilsfonctionnels.FabriqueObjectifExamen;
import fr.unedic.cali.asu.csa06.p04.liquidation.outilsfonctionnels.RechercheValiditeProduit;
import fr.unedic.cali.asu.csa06.p04.liquidation.outilsfonctionnels.strategies.StrategieConditionChomageInvolontaireAre14Avant;
import fr.unedic.cali.asu.csa06.parametres.FabriqueParametres;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P04;
import fr.unedic.cali.dom.affectation.ValidationProduitSpec;
import fr.unedic.cali.dom.echange.Decision;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.List;

public class ProduitDelegue
  extends fr.unedic.cali.asu.cge01.p05.ProduitDelegue
{
  public Object creerObjectifExamen(int sousType, List<ContexteDemandeSpec> contexteDemande)
  {
    return FabriqueObjectifExamen.creerObjectif(sousType, contexteDemande);
  }
  
  public ValidationProduitSpec obtenirValidationProduit(ActiviteSalarie activiteSalarie, IndividuSpec individu, DemandeSpec demande, boolean avecPeriodeNonAttestee)
    throws ApplicativeException
  {
    return RechercheValiditeProduit.getInstance().validerProduit(activiteSalarie, (DemandeAssuranceSpec)demande, avecPeriodeNonAttestee, FabriqueParametres.getParametres(demande), ProduitAsuCsa06P04.getInstance());
  }
  
  public Periode determinerPraLaPlusLongue(DemandeSpec demandeCourante, ActiviteSalarie periodeFctCourante)
    throws CoucheLogiqueException
  {
    return ConstructionPra.getPra(periodeFctCourante, (Demande)demandeCourante, FabriqueParametres.getParametres(demandeCourante));
  }
  
  public Resultat verifierConditionChomageTotal(Contexte contexte)
    throws CoucheLogiqueException
  {
    return new Resultat(0);
  }
  
  public void alimenterBaseEchangesProduit(DossierExamenSpec dossierExamen, Decision demandeEchange)
    throws CoucheLogiqueException
  {
    AlimenterBaseEchangesClauseSauvegarde.getInstance().alimenterDonneesProduit(dossierExamen, demandeEchange);
  }
  
  public void determinerOrdreObjectifs(Contexte contexte)
    throws ApplicativeException
  {
    ParcoursDeterminationOrdreObjectifs parcours = new ParcoursDeterminationOrdreObjectifs();
    parcours.effectuerParcours(contexte);
  }
  
  public boolean verifierCapasPreliminaires(Contexte contexte)
    throws ApplicativeException
  {
    return true;
  }
  
  public FormuleMontantSpec getFormuleMontant(String code)
  {
    return RecuperationFormuleMontant.getInstanceFormuleMontant(code);
  }
  
  public BigDecimal determinerDureeMaximumPourProduit()
  {
    return new BigDecimal(122);
  }
  
  public StrategieSpec retournerStrategieAvantDeterminationChomageInvolontaire()
  {
    return new StrategieConditionChomageInvolontaireAre14Avant();
  }
}

/* Location:
 * Qualified Name:     ProduitDelegue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */