package fr.unedic.cali.asu.csr04.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.temps.ObjectChronoFinChomageSansRct;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeCarences;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodePreavis;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.util.services.CoucheLogiqueException;

public class Qualification
  extends fr.unedic.cali.asu.cge01.p03.calcul.outilsfonctionnels.Qualification
{
  public boolean qualifierUnePeriodeSuspensives(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    boolean estSuspensivePourAre2006 = super.qualifierUnePeriodeSuspensives(p_periode, p_qualificationPeriodes, p_attribution);
    if (estSuspensivePourAre2006) {
      return true;
    }
    if (((p_periode instanceof ObjetChronoPeriodeCarences)) || ((p_periode instanceof ObjetChronoPeriodePreavis))) {
      p_qualificationPeriodes.ajouterPeriodesSuspensives(p_periode);
    } else if (((p_periode instanceof ObjetChronoPeriodeInterProduits)) && (!p_attribution.equals(((ObjetChronoPeriodeInterProduits)p_periode).getAttribution())))
    {
      if (((ObjetChronoPeriodeInterProduits)p_periode).getTypePeriode() == 7) {
        p_qualificationPeriodes.ajouterPeriodesSuspensives(p_periode);
      }
    }
    else {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeInterruptivesDefinitives(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    boolean estInterruptivePourAre2006 = super.qualifierUnePeriodeInterruptivesDefinitives(p_periode, p_qualificationPeriodes, p_attribution);
    if (estInterruptivePourAre2006) {
      return true;
    }
    if ((p_periode instanceof ObjectChronoFinChomageSansRct)) {
      p_qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(p_periode);
    } else {
      return false;
    }
    return true;
  }
}

/* Location:
 * Qualified Name:     Qualification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */