package fr.unedic.cali.asu.csr04.p01.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.csr04.liquidation.outilsfonctionnels.DeterminationDureeEffective;
import fr.unedic.cali.asu.dom.CompetenceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.RejetSpec;
import java.math.BigDecimal;

public class AlimenterBaseEchanges
  extends fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.AlimenterBaseEchanges
{
  public static void alimenterDonneesProduit(DossierExamenSpec p_dossierExamen, fr.unedic.cali.dom.echange.Decision p_demandeEchange)
    throws ApplicativeException
  {
    if (p_demandeEchange == null) {
      p_demandeEchange = new fr.unedic.cali.dom.echange.Decision();
    }
    p_demandeEchange.setLigne("ASU_CSR04");
    if (p_dossierExamen.getDemande().estNotifieeCourrier())
    {
      alimenterDonneesCourrierECAX(p_dossierExamen, p_demandeEchange);
      if (!(p_dossierExamen instanceof RejetSpec))
      {
        alimenterDonneesCourrier(p_dossierExamen, p_demandeEchange);
        alimenterDonneesCourrierEcep(p_dossierExamen, p_demandeEchange);
      }
    }
  }
  
  protected static void alimenterDonneesCourrier(DossierExamenSpec p_dossierExamen, fr.unedic.cali.dom.echange.Decision p_demandeEchange)
    throws ApplicativeException
  {
    fr.unedic.cali.asu.cge01.p03.liquidation.dom.Decision dossierExamen = (fr.unedic.cali.asu.cge01.p03.liquidation.dom.Decision)p_dossierExamen;
    switch (dossierExamen.getNatureDecision())
    {
    case 11: 
    case 26: 
      alimenterDonneesCourrierReadAntecedent(dossierExamen, p_demandeEchange);
      break;
    default: 
      alimenterDonneesCourrierNonReadAntecedent(dossierExamen, p_demandeEchange);
    }
    p_demandeEchange.setLibelleEmployeur(dossierExamen.getCompetence().getLibelleEmployeurCompetent());
  }
  
  protected static void alimenterDonneesCourrierNonReadAntecedent(fr.unedic.cali.asu.cge01.p03.liquidation.dom.Decision p_dossierExamen, fr.unedic.cali.dom.echange.Decision p_demandeEchange)
    throws ApplicativeException
  {
    fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.AlimenterBaseEchanges.alimenterDonneesCourrierNonReadAntecedent(p_dossierExamen, p_demandeEchange);
    
    int dureeRenouvellementAreCourrier = p_demandeEchange.getDureeRenouvellementAreCourrier();
    if (dureeRenouvellementAreCourrier != 0)
    {
      BigDecimal dureeEffective = new BigDecimal(dureeRenouvellementAreCourrier);
      BigDecimal dureeEffectiveBornee = DeterminationDureeEffective.getInstance().bornerDureeEffective((Demande)p_dossierExamen.getDemande(), dureeEffective, true, null);
      
      p_demandeEchange.setDureeRenouvellementAreCourrier(dureeEffectiveBornee.intValue());
    }
  }
}

/* Location:
 * Qualified Name:     AlimenterBaseEchanges
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */