package fr.unedic.cali.asu.csr04.p01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Differe;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.EnsembleCarences;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationCarenceRCT;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class ConstitutionDelaiReportPourReprise
  extends fr.unedic.cali.asu.cge01.p03.liquidation.parcours.ConstitutionDelaiReportPourReprise
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    Resultat resultat = null;
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    if (!OutilsChomageSansRCT.estUnContexteRuptureContratPendantSuspension(demande))
    {
      if (OutilsChomageSansRCT.estDansUnePeriodeDeSuspension(demande)) {
        resultat = demarrerParcours(p_contexte);
      } else {
        resultat = super.demarrer(p_contexte);
      }
    }
    else {
      resultat = demarrerParcours(p_contexte);
    }
    return resultat;
  }
  
  public Resultat demarrerParcours(Contexte p_contexte)
    throws ApplicativeException
  {
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    
    Differe differe = DeterminationCarenceRCT.definirDiffereContexteChomageSansRCT(demande);
    
    EnsembleCarences ensembleCarencesChomageSansRCT = DeterminationCarenceRCT.definirCarenceSupSiContexteChomageSansRCT(demande);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    ConstitutionDelais constitutionDelais = dossierExamenCourant.createConstitutionDelais();
    
    Damj dateDebut = OutilsChomageSansRCT.getDateFinSuspension(demande);
    if (dateDebut == null)
    {
      Demande demandePrecedente = (Demande)demande.getAttribution().getAttributionPrecedente().getDemande();
      dateDebut = OutilsChomageSansRCT.getDateFinSuspension(demandePrecedente);
    }
    if (ensembleCarencesChomageSansRCT != null) {
      constitutionDelais.ajouterEnsembleCarences(ensembleCarencesChomageSansRCT);
    }
    Damj dateFinCarences = null;
    if (ensembleCarencesChomageSansRCT != null) {
      dateFinCarences = ensembleCarencesChomageSansRCT.getDateFinDerniereCarence();
    }
    if (differe != null)
    {
      dateDebut = Damj.max(dateFinCarences, dateDebut).lendemain();
      
      differe.setPeriodeEffet(new Periode(dateDebut, differe.getQuantiteInitialJour()));
      constitutionDelais.ajouterDelaisReports(differe);
    }
    return new Resultat(0);
  }
}

/* Location:
 * Qualified Name:     ConstitutionDelaiReportPourReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */