package fr.unedic.cali.asu.cva10.p02.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesDemandeAssociee;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.Decision;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.AttributionAssocieeSpec;
import fr.unedic.cali.dom.DecisionSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.pivot.DemandePivot;
import fr.unedic.util.services.CoucheLogiqueException;

public final class AlimentationBasePivot
{
  public static final String MONTANT_RETENU_ASP = "1";
  public static final String MONTANT_RETENU_ARE_SOUS_JACENT = "2";
  
  public static void alimenterDonneesProduit(DossierExamenSpec dossierExamen, DemandePivot demandePivot)
    throws ApplicativeException
  {
    fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.AlimentationBasePivot.getInstance().alimenterDonneesProduit(dossierExamen, demandePivot);
    
    Demande demandeAssurance = (Demande)dossierExamen.getDemande();
    
    fr.unedic.cali.dom.pivot.Attribution attribution = demandePivot.getAttribution();
    if (attribution != null) {
      renseignerAttribution(demandePivot.getAttribution(), demandeAssurance);
    }
  }
  
  protected static void renseignerAttribution(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
    throws CoucheLogiqueException
  {
    renseignerDroitCourant(attribution, demande);
  }
  
  private static void renseignerDroitCourant(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
    throws CoucheLogiqueException
  {
    Decision decision = (Decision)demande.getDossierExamen();
    if (decision != null)
    {
      boolean estDemandeAssocieeNonNull = (demande.getDonneesDemandeAssociee() != null) && (demande.getDonneesDemandeAssociee().getDemandeAssociee() != null) && (demande.getDonneesDemandeAssociee().getDemandeAssociee().getDossierAffectation() != null);
      if ((decision.getConstitutionMontantsBruts() != null) && ("2".equals(decision.getConstitutionMontantsBruts().getTypeMontantRetenuDroitCourant())) && (estDemandeAssocieeNonNull))
      {
        Demande demandeAssociee = demande.getDonneesDemandeAssociee().getDemandeAssociee();
        if ((((DecisionSpec)demandeAssociee.getDossierAffectation().getDossierExamen()).getNatureDecision() == 35) || (((DecisionSpec)demandeAssociee.getDossierAffectation().getDossierExamen()).getNatureDecision() == 46))
        {
          AttributionAssocieeSpec decisionAreSousJacent = (AttributionAssocieeSpec)demandeAssociee.getDossierAffectation().getDossierExamen();
          if (decisionAreSousJacent != null) {
            attribution.setMontantSjrCourantPlafonne(decisionAreSousJacent.getSJRRetenu());
          }
        }
        else
        {
          fr.unedic.cali.asu.produits.liquidation.dom.Attribution decisionAreSousJacent = (fr.unedic.cali.asu.produits.liquidation.dom.Attribution)demandeAssociee.getDossierAffectation().getDossierExamen();
          
          attribution.setMontantSjrCourantPlafonne(decisionAreSousJacent.getConstitutionSjr().getSjrrp().getSalaire());
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     AlimentationBasePivot
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */