package fr.unedic.cali.asu.cva10.p03.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.spec.ConventionGestionSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public final class MajCi
  extends fr.unedic.cali.asu.cva10.calcul.outilsfonctionnels.MajCi
{
  public static ConstituantsIndemnisation miseAJourConstituantsIndemnisation(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    QuantiteDroitSpec dureeDroit = null;
    Collection collectionDurees = null;
    Iterator iterator = null;
    String codeFormuleMontant = null;
    
    codeFormuleMontant = constituantsIndemnisation.getCodeFormuleMontant();
    if (codeFormuleMontant != null) {
      miseAJourParametres(attribution, constituantsIndemnisation, dateDeMiseAjour);
    }
    collectionDurees = constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        dureeDroit = (QuantiteDroitSpec)iterator.next();
        if ((dureeDroit instanceof QuantiteIndemnisationSpec)) {
          miseAJourParametres(attribution, constituantsIndemnisation, dateDeMiseAjour);
        }
      }
    }
    return constituantsIndemnisation;
  }
  
  private static void miseAJourParametres(AttributionSpec attribution, ConstituantsIndemnisation constituantIndemnisation, Damj dateMiseAJour)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndem = null;
    Sjr nouveauSjr = null;
    AttributionAssuranceSpec attrib = (AttributionAssuranceSpec)attribution;
    
    elementBaseIndem = (ElementBaseIndemnisation)constituantIndemnisation.getElementBaseIndemnisationCourant();
    
    nouveauSjr = RevalorisationSalaire.revaloriserSjr(attrib, dateMiseAJour);
    
    elementBaseIndem.getSjr().setSalaire(nouveauSjr.getSalaire());
    if ((elementBaseIndem.getCoefficientSaisonnier() != null) && (elementBaseIndem.getCoefficientSaisonnier().intValue() != 1) && (attribution.getDemandeur().getAgeALaDate(dateMiseAJour).getAnnees() >= 50) && (estCaractereSaisonnierParRythme(elementBaseIndem))) {
      elementBaseIndem.setCoefficientSaisonnier(BigDecimal.ONE);
    }
    if ((elementBaseIndem.getAvecPrecompteCRC() == null) && (attrib.getCompetenceFinanciere() == 2) && (!estCompetenceAssedicOuCGSansPrecompteCRC(attrib))) {
      elementBaseIndem.setAvecPrecompteCRC(Boolean.FALSE);
    }
  }
  
  private static boolean estCaractereSaisonnierParRythme(ElementBaseIndemnisation ebi)
  {
    return (ebi.getTypeCaractereSaisonnierRetenu() == 1) && (ebi.isConditionCaractereSaisonnierParRythme());
  }
  
  private static boolean estCompetenceAssedicOuCGSansPrecompteCRC(AttributionAssuranceSpec attribution)
  {
    return (attribution.getCompetenceAdministrative() == 1) || ((attribution.getConventionGestion() != null) && (!attribution.getConventionGestion().estPrecompteCRC()));
  }
}

/* Location:
 * Qualified Name:     MajCi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */