package fr.unedic.cali.asu.cve13.p01.calcul.dom;

import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FormuleMontantATPF
  extends FormuleMontantATP
  implements FormuleMontantATPFSpec
{
  public static String getCode()
  {
    return "2";
  }
  
  public MontantBaseSpec calculer(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    Montant montant = (Montant)super.calculer(p_constituantsIndemnisation, p_dateCalcul);
    MontantATPF montantATPF = new MontantATPF(montant);
    
    ElementBaseIndemnisationATPF ebiATPF = (ElementBaseIndemnisationATPF)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    if ((ebiATPF != null) && (ebiATPF.estEffectif())) {
      montantATPF.setType("FORMATION EFFECTIVE");
    }
    return montantATPF;
  }
}

/* Location:
 * Qualified Name:     FormuleMontantATPF
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */