package fr.unedic.cali.asu.cve13.p01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ContributionParticuliere;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.echange.Decision;
import fr.unedic.util.services.CoucheLogiqueException;

public class AlimenterBaseEchanges
{
  private static final int FAUX = 0;
  private static final int VRAI = 1;
  private static final String CODE_BASSIN_ATP06 = "22";
  private static final String CODE_BASSIN_ATP09 = "23";
  
  public static void alimenterDonneesProduit(DossierExamenSpec p_dossierExamen, Decision p_demandeEchange)
    throws CoucheLogiqueException
  {
    if ((p_dossierExamen instanceof Attribution))
    {
      Attribution attribution = (Attribution)p_dossierExamen;
      
      p_demandeEchange.setLigne("ASU_CVE13");
      p_demandeEchange.setProduit("ASU_CVE13_01");
      
      int codeBassinEmploi = attribution.getBassinEmploi();
      if (codeBassinEmploi == 3) {
        p_demandeEchange.setCodeSousProduit("23");
      } else if (codeBassinEmploi == 1) {
        p_demandeEchange.setCodeSousProduit("22");
      } else if (codeBassinEmploi == 2) {
        p_demandeEchange.setCodeSousProduit("23");
      }
      p_demandeEchange.setDateBanalisee(attribution.getDateLimiteIndemnisation());
    }
    alimenterContribution(p_dossierExamen, p_demandeEchange);
  }
  
  private static void alimenterContribution(DossierExamenSpec p_dossierExamen, Decision p_demandeEchange)
    throws CoucheLogiqueException
  {
    DossierExamen dossierExamenCourant = (DossierExamen)p_dossierExamen;
    ContributionParticuliere contributionParticuliere = (ContributionParticuliere)dossierExamenCourant.getContributionParticuliere();
    if (contributionParticuliere != null)
    {
      p_demandeEchange.setEstContribPreavis(contributionParticuliere.isTopDetectionContributionPreavis() ? 1 : 0);
      p_demandeEchange.setEstContribDif(contributionParticuliere.isTopDetectionContributionDif() ? 1 : 0);
      p_demandeEchange.setMontantPreavisCR(contributionParticuliere.getMontantPreavisCtp());
      p_demandeEchange.setMontantFormationD(contributionParticuliere.getMontantFormationDifCtp());
    }
    else
    {
      p_demandeEchange.setEstContribPreavis(0);
      p_demandeEchange.setEstContribDif(0);
      p_demandeEchange.setMontantPreavisCR(null);
      p_demandeEchange.setMontantFormationD(null);
    }
  }
}

/* Location:
 * Qualified Name:     AlimenterBaseEchanges
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */