package fr.unedic.cali.asu.ddm16.p01.calcul.dom;

import fr.unedic.cali.ari.dom.ElementBaseIndemnisationAriSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilMappingSjmSjr;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.DureeCalendaire;

public class ElementBaseIndemnisation
  extends fr.unedic.cali.asu.dom.ElementBaseIndemnisation
  implements ElementBaseIndemnisationAriSpec
{
  private static final long serialVersionUID = 2886809436473519835L;
  private SalaireJournalierSpec m_salaireJournalierRevalorisePlafonne = null;
  private DureeCalendaire m_ageALaDateCalcul = null;
  
  public DureeCalendaire getAgeFinMoisDateAttribution()
  {
    return m_ageALaDateCalcul;
  }
  
  public void setAgeALaDateCalcul(DureeCalendaire p_ageALaDateCalcul)
  {
    m_ageALaDateCalcul = p_ageALaDateCalcul;
  }
  
  public ObjetMetierSpec copie()
  {
    ElementBaseIndemnisation copie = new ElementBaseIndemnisation();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ElementBaseIndemnisation copie = (ElementBaseIndemnisation)p_copie;
    super.copieElements(p_copie);
    if (getSjrRP() != null) {
      copie.setSjrRP((Sjr)getSjr().copie());
    }
  }
  
  public Sjr getSjrRP()
  {
    if (m_salaireJournalierRevalorisePlafonne != null) {
      return OutilMappingSjmSjr.convertirSjr(m_salaireJournalierRevalorisePlafonne);
    }
    return null;
  }
  
  public void setSjrRP(Sjr p_sjrRP)
  {
    m_salaireJournalierRevalorisePlafonne = p_sjrRP;
  }
}

/* Location:
 * Qualified Name:     ElementBaseIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */