package fr.unedic.cali.asu.ddm16.p01.calcul.dom;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsAlimentationDonneesCalculMontant;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuAbstrait;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P04;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontant;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FormuleMontantRegimeGeneral
  implements FormuleMontantSpec
{
  public static String getCode()
  {
    return "1";
  }
  
  public MontantBaseSpec calculer(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    ProduitAsuAbstrait produitARE = ProduitAsuCge01P04.getInstance();
    MontantBaseSpec montantARE = null;
    DonneesEntreesRecuperationMontant donneesEntreesRecuperationMontant = new DonneesEntreesRecuperationMontant();
    
    ElementBaseIndemnisation ebi = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    OutilsAlimentationDonneesCalculMontant.alimenterDonneesEntreesRecuperationMontant(donneesEntreesRecuperationMontant, ebi);
    donneesEntreesRecuperationMontant.setDateCalculMontant(p_dateCalcul);
    donneesEntreesRecuperationMontant.getDonneesCalculMontant().setProduit(produitARE);
    donneesEntreesRecuperationMontant.setAgeALaDateCalcul(ebi.getAgeFinMoisDateAttribution());
    try
    {
      montantARE = produitARE.recupererMontant(donneesEntreesRecuperationMontant);
    }
    catch (ApplicativeException e)
    {
      e.printStackTrace();
    }
    Montant montant = new Montant();
    montant.setEstAvecPrecompte(montantARE.getAvecPrecompteCRC());
    montant.setCrc(montantARE.getCrc());
    montant.setMontantBrut(montantARE.getMontantBrut());
    
    montant.setType(montantARE.getType());
    montant.setMini(montantARE.getMini());
    montant.setPlafond(montantARE.getPlafond());
    montant.setBase(montantARE.getBase());
    montant.setTauxCrc(montantARE.getTauxCrc());
    montant.setSjrNonReduit(montantARE.getSjrNonReduit());
    montant.setBaseCalculCrc(montantARE.getBaseCalculCrc());
    montant.setPositionExonerationCrc(montantARE.getPositionExonerationCrc());
    montant.setCsg(montantARE.getCsg());
    montant.setCrds(montantARE.getCrds());
    montant.setMontantBrutSansPensionInvaliditeADeduire(montantARE.getMontantBrutSansPensionInvaliditeADeduire());
    montant.setPensionInvaliditeADeduirePriseEnCompte(montantARE.getPensionInvaliditeADeduirePriseEnCompte());
    montant.setMontantJournalierAvantageVieillesse(montantARE.getMontantJournalierAvantageVieillesse());
    montant.setMontantJournalierAvantageVieillesseDeduit(montantARE.getMontantJournalierAvantageVieillesseDeduit());
    montant.setJustificationCalculMontant(montantARE.getJustificationCalculMontant());
    
    return montant;
  }
  
  public void setFormuleMontantDroitAssocie(FormuleMontantSpec p_formuleMontantDroitAssocie) {}
  
  public void setFormuleMontantApplicable(int p_formuleMontantApplicable) {}
}

/* Location:
 * Qualified Name:     FormuleMontantRegimeGeneral
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */