package fr.unedic.cali.asu.ddm16.p01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.ari.dom.Demande;
import fr.unedic.cali.ari.dom.ElementDroit;
import fr.unedic.cali.ari.outilsfonctionnels.OutilElementDroit;
import fr.unedic.cali.asu.ddm16.p01.liquidation.dom.Admission;
import fr.unedic.cali.asu.ddm16.p01.liquidation.outilsfonctionnels.DeterminationConstituantsSupplementaires;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.parcours.DomLiquidationDemande;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ConstitutionConstituantsSupplementaires
  extends ParcoursCali
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    Demande demande = getDemande(p_contexte);
    Admission admission = (Admission)demande.getDossierExamen();
    MontantBaseSpec montant = DeterminationConstituantsSupplementaires.determinationMontantJournalier(demande);
    
    Quantite montantCalcule = montant.getMontantBrut();
    ElementDroit elementDroitMontantCalcule = OutilElementDroit.creerElementDroit("MONTANT_J_CALCULE", false, null, null, montantCalcule, null);
    
    elementDroitMontantCalcule.setTypeElement("3");
    admission.ajouterElementsDroits(elementDroitMontantCalcule);
    return new Resultat(0);
  }
  
  private Demande getDemande(Contexte p_contexte)
  {
    return (Demande)((DomLiquidationDemande)p_contexte.getDonnees()).getDemandeSpec();
  }
}

/* Location:
 * Qualified Name:     ConstitutionConstituantsSupplementaires
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */