package fr.unedic.cali.asu.dom;

import fr.unedic.cali.asu.dom.gen.AffiliationAssimileeGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;

public class AffiliationAssimilee
  extends AffiliationAssimileeGen
  implements PeriodeAffiliationSpec, ObjetPersistantSpec
{
  private static final long serialVersionUID = 4904199850848332829L;
  
  public AffiliationAssimilee() {}
  
  public AffiliationAssimilee(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public String getLibelle()
  {
    return "Formation assimilable";
  }
  
  public Periode getPeriode()
  {
    return getPeriodeAssimilation();
  }
  
  public ObjetMetierSpec copie()
  {
    AffiliationAssimilee copie = new AffiliationAssimilee();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    AffiliationAssimilee copie = (AffiliationAssimilee)p_copie;
    copie.setIdPeriodeActivite(getIdPeriodeActivite());
    copie.setNature(getNature());
    copie.setPeriodeAssimilation(getPeriodeAssimilation());
    copie.setQuantiteAssimilation(getQuantiteAssimilation());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant() {}
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     AffiliationAssimilee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */