package fr.unedic.cali.asu.dom;

import fr.unedic.cali.dom.SalaireReferenceSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class SalaireReference
  implements SalaireReferenceSpec
{
  private static final long serialVersionUID = 1L;
  private Quantite m_montant;
  private static final Unite UNITE_SR = Unite.get("Euros");
  private Damj m_dateDepart = null;
  
  private SalaireReference() {}
  
  public SalaireReference(BigDecimal p_montant, Damj p_date)
  {
    setSalaire(p_montant);
    setDateDepart(p_date);
  }
  
  public ObjetMetierSpec copie()
  {
    SalaireReference copie = new SalaireReference();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    SalaireReference copie = (SalaireReference)p_copie;
    copie.setMontant(getMontant());
    copie.setDateDepart(getDateDepart());
  }
  
  public Quantite getMontant()
  {
    return m_montant;
  }
  
  public void setMontant(Quantite p_montant)
  {
    m_montant = p_montant;
  }
  
  public BigDecimal getSalaire()
  {
    return getMontant().getValeur();
  }
  
  public void setSalaire(BigDecimal p_salaire)
  {
    setMontant(new Quantite(p_salaire, UNITE_SR));
  }
  
  public String toString()
  {
    StringBuffer chaineRetour = new StringBuffer();
    chaineRetour.append("Salaire journalier: " + getMontant() + "\n");
    chaineRetour.append("Date de revalorisation: " + getDateDepart() + "\n");
    return chaineRetour.toString();
  }
  
  public Damj getDateDepart()
  {
    return m_dateDepart;
  }
  
  public void setDateDepart(Damj p_dateDepart)
  {
    m_dateDepart = p_dateDepart;
  }
}

/* Location:
 * Qualified Name:     SalaireReference
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */