package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.pc.DelaiRechercheProduitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.PeriodeCREM;

public abstract class DelaiRechercheProduitGen
  extends PeriodeCREM
  implements DomGenSpec
{
  public DelaiRechercheProduitGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DelaiRechercheProduitGen() {}
  
  public DelaiRechercheProduitGen(Damj p_d1, Damj p_d2)
  {
    super(p_d1, p_d2);
  }
  
  public DelaiRechercheProduitGen(Damj p_dateDebut, int p_n)
  {
    super(p_dateDebut, p_n);
  }
  
  public DelaiRechercheProduitGen(Damj p_dateDebut)
  {
    super(p_dateDebut);
  }
  
  public DelaiRechercheProduitGen(Damj p_date, DureeCalendaire p_duree, int p_sens)
  {
    super(p_date, p_duree, p_sens);
  }
  
  protected DomPCSpec createPC()
  {
    return new DelaiRechercheProduitPC();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     DelaiRechercheProduitGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */