package fr.unedic.cali.asu.eur05.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ResultatActiviteReduite;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;

public class TraitementActiviteReduite
{
  public static void traitementPeriodesGelantes(UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    preTraitementPeriodesGelantes(p_ut);
  }
  
  protected static void preTraitementPeriodesGelantes(UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    switch (p_ut.getStatut())
    {
    case -1: 
    case 1: 
    case 2: 
    case 5: 
    case 7: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    case 3: 
    case 4: 
      break;
    case 6: 
      p_ut.setNeutralisee(true);
      p_ut.setTypeNeutralisation(8);
      break;
    case 0: 
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    }
  }
  
  public static void traitementPeriodesDecalantes(ChronologiePeriodes p_periodesDecalantes, UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    if (!p_periodesDecalantes.estVide())
    {
      ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(p_periodesDecalantes, p_ut.getQualificationPeriodes().getPeriodesSuspensives());
      Quantite qteDecalage = new Quantite(resultatActiviteReduite.getCreditDecalage(), p_ut.getUniteParDefautQuantites());
      p_ut.setCreditDecalage(p_ut.getCreditDecalage() == null ? qteDecalage : p_ut.getCreditDecalage().ajouter(qteDecalage));
    }
  }
  
  protected static ResultatActiviteReduite appelleActiviteReduite(ChronologiePeriodes p_periodesDecalantesGelantes, ChronologiePeriodes p_periodesSuspensives)
    throws CoucheLogiqueException
  {
    return ActiviteReduite.genererEvenementActiviteReduite(p_periodesDecalantesGelantes, p_periodesSuspensives);
  }
}

/* Location:
 * Qualified Name:     TraitementActiviteReduite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */