package fr.unedic.cali.asu.eur05.p01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.eur05.p01.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.eur05.p01.liquidation.dom.Admission;
import fr.unedic.cali.asu.outilsfonctionnels.CREM;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import java.math.BigDecimal;
import java.util.Hashtable;
import java.util.List;

public class ConstitutionCREMConstituant
{
  private static final int NB_DECIMALES_ARRONDI_2 = 2;
  private static final int NB_DECIMALES_ARRONDI_4 = 4;
  
  public static Hashtable recupererElementsConstituant(DossierExamenSpec p_dossierExamen)
    throws CoucheLogiqueException
  {
    Hashtable listeConstituant = CREM.getElementsConstitutantVides();
    if ((p_dossierExamen instanceof AttributionSpec))
    {
      Admission dossierExamen = (Admission)p_dossierExamen;
      if ((dossierExamen.getListeDurees() != null) && (!dossierExamen.getListeDurees().isEmpty()))
      {
        DureeIndemnisation dureeIndemnisation = (DureeIndemnisation)dossierExamen.getListeDurees().get(0);
        if (dureeIndemnisation != null) {
          listeConstituant.put("Duree", Mathematiques.arrondiASup(dureeIndemnisation.getQuantiteInitial().getValeur(), 2).toString());
        }
      }
      if (dossierExamen.getMontantJournalierCalcule() != null) {
        listeConstituant.put("Montant journalier", Mathematiques.arrondiASup(dossierExamen.getMontantJournalierCalcule(), 2).toString());
      }
    }
    return listeConstituant;
  }
}

/* Location:
 * Qualified Name:     ConstitutionCREMConstituant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */