package fr.unedic.cali.asu.exp03.p01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.comparator.ComparatorPRAOrdreQuantiteAppartenance;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.comparator.ComparatorPRAOrdreReglementApplicable;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionPra;
import fr.unedic.cali.asu.cge01.parametres.ParametrageListePRASpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.exp03.p01.parametres.ParametrageListePRA;
import fr.unedic.cali.asu.exp03.parametres.ParametragePRAPourDV;
import fr.unedic.cali.asu.exp03.parametres.ParametragePraCouvertureSuiteDv;
import fr.unedic.cali.asu.exp03.parametres.ParametragePraOppositionDv;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.asu.produits.liquidation.parametres.CleAccesPRA;
import fr.unedic.cali.dom.DonneesEntreeDeterminationListePra;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.spec.ConstructionPRASpec;
import fr.unedic.cali.dom.spec.PraSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class OutilConstructionPRA
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilConstructionPRA
  implements ConstructionPRASpec
{
  public Collection determinerListePraQuantiteAppartenance(DonneesEntreeDeterminationListePra donneesEntreeDeterminationListePra)
    throws CoucheLogiqueException
  {
    Demande demande = (Demande)donneesEntreeDeterminationListePra.getDemande();
    
    Comparator<Pra> comparateur = new ComparatorPRAOrdreReglementApplicable();
    if (ConstructionPra.ORDRE_QUANTITE_APPARTENANCE == donneesEntreeDeterminationListePra.getOrdreTriListe())
    {
      Damj dateFG = demande.getFaitGenerateur().getDateFaitGenerateur();
      DureeCalendaire ageFG = demande.getDemandeur().getAgeALaDate(dateFG);
      donneesEntreeDeterminationListePra.setAgeIndividu(ageFG);
      comparateur = new ComparatorPRAOrdreQuantiteAppartenance();
    }
    CleAccesPRA cle = construireCleAccesPRA(donneesEntreeDeterminationListePra);
    
    ParametrageListePRASpec parametre = null;
    parametre = ParametrageListePRA.getInstance();
    List listePRA = parametre.getListePra(cle);
    
    Collections.sort(listePRA, comparateur);
    
    return listePRA;
  }
  
  public PraSpec determinerPraPourDV(String reglement)
  {
    CleAccesPRA cle = new CleAccesPRA(reglement);
    
    return ParametragePRAPourDV.getInstanceProduit().getPram(cle);
  }
  
  public PraSpec determinerPraCouvertureSuiteDV(String reglement)
  {
    CleAccesPRA cle = new CleAccesPRA(reglement);
    
    return ParametragePraCouvertureSuiteDv.getInstance().getPram(cle);
  }
  
  public PraSpec determinerPraOppositionDV(String reglement, Damj dateRecherche)
  {
    CleAccesPRA cle = new CleAccesPRA(reglement);
    cle.setDateRecherche(dateRecherche);
    
    return ParametragePraOppositionDv.getInstance().getPram(cle);
  }
}

/* Location:
 * Qualified Name:     OutilConstructionPRA
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */