package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieIslrIndemniteLetTApres;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieIslrIndemniteLetTAvant;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieIslrIndemniteLetTSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieIslrIndemniteLetT
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_PIVOT = new Damj(2010, 1, 22);
  private static FabriqueStrategieIslrIndemniteLetT s_instance = new FabriqueStrategieIslrIndemniteLetT();
  
  public static FabriqueStrategieIslrIndemniteLetT getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StrategieIslrIndemniteLetTSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieIslr : la date pivot Islr est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_PIVOT)) {
      strategie = new StrategieIslrIndemniteLetTApres();
    } else {
      strategie = new StrategieIslrIndemniteLetTAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieIslrIndemniteLetT
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */