package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategiePeriodeAbsencePointageDelaiAttenteApresMEP09SI3;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategiePeriodeAbsencePointageDelaiAttenteAvantMEP09SI3;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategiePeriodeAbsencePointageDelaiAttenteSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategiePeriodeAbsencePointageDelaiAttente
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_MEP_09SI3 = new Damj(2010, 2, 1);
  private static FabriqueStrategiePeriodeAbsencePointageDelaiAttente s_instance = new FabriqueStrategiePeriodeAbsencePointageDelaiAttente();
  
  public static FabriqueStrategiePeriodeAbsencePointageDelaiAttente getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StrategiePeriodeAbsencePointageDelaiAttenteSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategiePeriodeAbsencePointageDelaiAttente : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_MEP_09SI3)) {
      strategie = new StrategiePeriodeAbsencePointageDelaiAttenteApresMEP09SI3();
    } else {
      strategie = new StrategiePeriodeAbsencePointageDelaiAttenteAvantMEP09SI3();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategiePeriodeAbsencePointageDelaiAttente
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */