package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieReglesArSurCiPuisRepriseAsuApresMEP10SI2;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieReglesArSurCiPuisRepriseAsuAvantMEP10SI2;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieReglesArSurCiPuisRepriseAsuSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieReglesArSurCiPuisRepriseAsu
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_MEP_10SI2 = new Damj(2010, 11, 1);
  private static FabriqueStrategieReglesArSurCiPuisRepriseAsu s_instance = new FabriqueStrategieReglesArSurCiPuisRepriseAsu();
  
  public static FabriqueStrategieReglesArSurCiPuisRepriseAsu getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieReglesArSurCiPuisRepriseAsuSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieReglesArSurCiPuisReprise : la date pivot est nulle.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_MEP_10SI2)) {
      strategie = new StrategieReglesArSurCiPuisRepriseAsuApresMEP10SI2();
    } else {
      strategie = new StrategieReglesArSurCiPuisRepriseAsuAvantMEP10SI2();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieReglesArSurCiPuisRepriseAsu
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */