package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieRejetDvAssApres13SI1;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieRejetDvAssAvant13SI1;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieRejetDvAssSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieRejetDvAss
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_MEP_13SI1 = new Damj(2013, 4, 1);
  private static FabriqueStrategieRejetDvAss s_instance = new FabriqueStrategieRejetDvAss();
  
  public static FabriqueStrategieRejetDvAss getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StrategieRejetDvAssSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieIslr : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_MEP_13SI1)) {
      strategie = new StrategieRejetDvAssApres13SI1();
    } else {
      strategie = new StrategieRejetDvAssAvant13SI1();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieRejetDvAss
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */