package fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.filtres;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels.OutilDeterminationFiliere;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreAttribution;
import fr.unedic.util.temps.FiltreTemporel;
import fr.unedic.util.temps.Temporel;

public class FiltreAttributionAFDFiliere
  extends FiltreAttribution
  implements FiltreTemporel
{
  private static final long serialVersionUID = 1L;
  private int m_filiere;
  
  public FiltreAttributionAFDFiliere(int p_filiere)
  {
    m_filiere = p_filiere;
  }
  
  public boolean accepter(Temporel p_temporel)
  {
    if (p_temporel.estType(Demande.class))
    {
      Demande demande = (Demande)p_temporel;
      if (demande.getSaisieAntecedent() != null) {
        return false;
      }
      DossierExamen dossierExamen = (DossierExamen)demande.getDossierAffectation().getDossierExamen();
      if ((dossierExamen instanceof OdSpec))
      {
        int filiere = OutilDeterminationFiliere.determinerFiliere(demande.getDonneesTemporaires().getDureeAncienneteIntermittantSpectacle());
        return (super.accepter(demande)) && (filiere == m_filiere);
      }
      return false;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     FiltreAttributionAFDFiliere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */