package fr.unedic.cali.asu.fds12.p03.calcul;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.outilsfonctionnels.OutilDemande;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.ConvertisseurUniteAffiliation;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT.ElementContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPAEC;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.OdAssuranceSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends fr.unedic.cali.asu.fds12.p02.calcul.FacadeCalculProduitImpl
{
  public void convertionCachets(ChronologiePeriodes periodes)
  {
    if ((periodes != null) && (!periodes.estVide()))
    {
      Chronologie chronoPeriodesPAEC = periodes.copier(new FiltrePeriodeTravailCalculPAEC());
      if ((chronoPeriodesPAEC != null) && (!chronoPeriodesPAEC.estVide()))
      {
        chronoPeriodesPAEC.iterer();
        while (chronoPeriodesPAEC.encoreSuivant())
        {
          PeriodeActiviteEmploiCalcul periodeActivite = (PeriodeActiviteEmploiCalcul)chronoPeriodesPAEC.elementSuivant();
          if ((periodeActivite.getCachets() != null) && (periodeActivite.getCachets().intValue() > 0)) {
            periodeActivite.setNombreHeures(periodeActivite.getNombreHeuresDeCompletude().add(new Quantite(periodeActivite.getCachets(), UniteAffiliation.CACHET_GROUPE).convertir(UniteAffiliation.HEURE_TRAVAIL, ConvertisseurUniteAffiliation.getInstance()).getValeur()));
          }
        }
      }
    }
  }
  
  public void appliquerFiltreSurFDDSuiteEpuismentOuDateAnniverssaire(PeriodesPriseEnCompte periodesPriseEnCompte, Periode periodeUT, ContexteUT contexteUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if ((OutilDemande.estUneDemandeFinDeDroitSurEpuissement((AttributionAssuranceSpec)attribution, periodeUT)) && (!((AttributionAssuranceSpec)attribution).getOuvertureDroit().getDateAttribution().coincideAvec(periodeUT.getDebut())))
    {
      Damj dateFinTraitementARattributionPrecedente = null;
      
      List<?> listeAttributions = contexteUT.getListeOrdonneeCandidats();
      Iterator<?> it = listeAttributions.iterator();
      while (it.hasNext())
      {
        AttributionSpec attributionCandidate = (AttributionSpec)it.next();
        if (attributionCandidate != attribution)
        {
          ContexteUT.ElementContexteUT elementContexteUT = contexteUT.getElementContexteUT(attributionCandidate);
          dateFinTraitementARattributionPrecedente = (dateFinTraitementARattributionPrecedente == null) || ((elementContexteUT.recupererDateTraitementARSurMoisDJI() != null) && (dateFinTraitementARattributionPrecedente.estAvant(elementContexteUT.recupererDateTraitementARSurMoisDJI()))) ? elementContexteUT.recupererDateTraitementARSurMoisDJI() : dateFinTraitementARattributionPrecedente;
        }
      }
      if (dateFinTraitementARattributionPrecedente != null)
      {
        periodesPriseEnCompte.tronquePeriodeParTypologieEnDebut(dateFinTraitementARattributionPrecedente.lendemain(), 5);
        periodesPriseEnCompte.tronquePeriodeParTypologieEnDebut(dateFinTraitementARattributionPrecedente.lendemain(), 4);
      }
    }
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */