package fr.unedic.cali.asu.fps.liquidation.outilsaffiliation;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ActiviteParticipante;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.JustifierAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.spec.ComportementAffiliationSpec;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeEvenementPersonnel;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Iterator;
import java.util.Map;

public class JustifierAffiliationFPS
  extends JustifierAffiliation
{
  public void justifierAffiliations(ComportementAffiliationSpec p_comportementCalcul, JustificationAffiliation p_justification, Map p_chronologies)
  {
    super.justifierAffiliations(p_comportementCalcul, p_justification, p_chronologies);
    
    justifierAssimilationMaladiesLongueDuree(p_justification, p_chronologies);
    justifierAssimilationMaladiesGraves(p_justification, p_chronologies);
  }
  
  protected void justifierAssimilationMaladiesLongueDuree(JustificationAffiliation p_justification, Map p_chronologies)
  {
    Chronologie chronoPourAssimilationMaladieLongueDuree = (Chronologie)p_chronologies.get("chronoAffiMaladiesLongueDuree");
    if ((p_justification != null) && (chronoPourAssimilationMaladieLongueDuree != null))
    {
      Iterator itAssimMaladieLongueDuree = chronoPourAssimilationMaladieLongueDuree.iterer();
      int natureActivite = 12;
      while (itAssimMaladieLongueDuree.hasNext())
      {
        PeriodeEvenementPersonnel pep = (PeriodeEvenementPersonnel)itAssimMaladieLongueDuree.next();
        ActiviteParticipante activiteParticipante = creerActiviteParticipante();
        activiteParticipante.setNature(natureActivite);
        activiteParticipante.setPeriodeActivite(pep.getPeriode());
        int quantiteHeure = ParametresAffiliationFPS.NOMBRE_HEURE_PAR_JOUR_MALADIE_LONGUE_DUREE.intValue() * activiteParticipante.getPeriodeActivite().getDuree();
        
        activiteParticipante.setQuantiteTotaleTravaillee(new Quantite(new BigDecimal(quantiteHeure), UNITE_HEURE));
        p_justification.ajouterActiviteParticipante(activiteParticipante);
      }
    }
  }
  
  protected void justifierAssimilationMaladiesGraves(JustificationAffiliation p_justification, Map p_chronologies)
  {
    Chronologie chronoPourAssimilationMaladieLongueDuree = (Chronologie)p_chronologies.get("chronoAffiMaladiesGraves");
    if ((p_justification != null) && (chronoPourAssimilationMaladieLongueDuree != null))
    {
      Iterator itAssimMaladieLongueDuree = chronoPourAssimilationMaladieLongueDuree.iterer();
      int natureActivite = 13;
      while (itAssimMaladieLongueDuree.hasNext())
      {
        PeriodeEvenementPersonnel pep = (PeriodeEvenementPersonnel)itAssimMaladieLongueDuree.next();
        ActiviteParticipante activiteParticipante = creerActiviteParticipante();
        activiteParticipante.setNature(natureActivite);
        activiteParticipante.setPeriodeActivite(pep.getPeriode());
        int quantiteHeure = ParametresAffiliationFPS.NOMBRE_HEURE_PAR_JOUR_MALADIE_GRAVE.intValue() * activiteParticipante.getPeriodeActivite().getDuree();
        
        activiteParticipante.setQuantiteTotaleTravaillee(new Quantite(new BigDecimal(quantiteHeure), UNITE_HEURE));
        p_justification.ajouterActiviteParticipante(activiteParticipante);
      }
    }
  }
}

/* Location:
 * Qualified Name:     JustifierAffiliationFPS
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */