package fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.convention2017;

import fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.CalculAffiliationSupplementaireFPS;
import fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.spec.IComportementAffiliationFPS;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.dom.ComportementCalculAffiliation;
import fr.unedic.cali.dom.affectation.Reglement;

public class ComportementAffiliationConvention2017
  extends ComportementCalculAffiliation
  implements IComportementAffiliationFPS
{
  private boolean calculAffiliationAssimilableMaladieLongueDuree;
  private boolean calculAffiliationAssimilableMaladieGrave;
  
  public ComportementAffiliationConvention2017()
  {
    setOutilCalculAffiliationSupplementaire(new CalculAffiliationSupplementaireFPS());
    setOutilCalculAssimilation(new CalculAssimilationConvention2017());
    setOutilParametreAffiliation(new ParametresAffiliationConvention2017());
    setOutilConstructionChronologie(new ConstructionChonologieConvention2017());
    setOutilJustifierAffiliation(new JustifierAffiliationConvention2017());
  }
  
  public void setCalculAffiliationAssimilable(boolean calculAffiliationAssimilable)
  {
    super.setCalculAffiliationAssimilable(calculAffiliationAssimilable);
    setCalculAffiliationAssimilableMaladieGrave(calculAffiliationAssimilable);
    setCalculAffiliationAssimilableMaladieLongueDuree(calculAffiliationAssimilable);
  }
  
  public boolean isCalculAffiliationAssimilableMaladieLongueDuree()
  {
    return calculAffiliationAssimilableMaladieLongueDuree;
  }
  
  public void setCalculAffiliationAssimilableMaladieLongueDuree(boolean calculAffiliationAssimilableMaladieLongueDuree)
  {
    this.calculAffiliationAssimilableMaladieLongueDuree = calculAffiliationAssimilableMaladieLongueDuree;
  }
  
  public boolean isCalculAffiliationAssimilableMaladieGrave()
  {
    return calculAffiliationAssimilableMaladieGrave;
  }
  
  public void setCalculAffiliationAssimilableMaladieGrave(boolean calculAffiliationAssimilableMaladieGrave)
  {
    this.calculAffiliationAssimilableMaladieGrave = calculAffiliationAssimilableMaladieGrave;
  }
  
  public boolean estEnseignementApplicablePourReglement(Reglement reglement)
  {
    return true;
  }
}

/* Location:
 * Qualified Name:     ComportementAffiliationConvention2017
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */