package fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.convention2017;

import fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.ParametresAffiliationFPS;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ActiviteParticipante;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.JustifierAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.spec.ComportementAffiliationSpec;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeEvenementPersonnel;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Iterator;
import java.util.Map;

public class JustifierAffiliationConvention2017
  extends JustifierAffiliation
{
  public void justifierAffiliations(ComportementAffiliationSpec comportementCalcul, JustificationAffiliation justification, Map chronologies)
  {
    super.justifierAffiliations(comportementCalcul, justification, chronologies);
    justifierAssimilationMaladiesLongueDuree(justification, chronologies);
  }
  
  protected void justifierAssimilationMaladiesLongueDuree(JustificationAffiliation justification, Map chronologies)
  {
    Chronologie chronoPourAssimilationMaladieLongueDuree = (Chronologie)chronologies.get("chronoAffiMaladiesLongueDuree");
    if ((justification != null) && (chronoPourAssimilationMaladieLongueDuree != null))
    {
      Iterator<?> itAssimMaladieLongueDuree = chronoPourAssimilationMaladieLongueDuree.iterer();
      int natureActivite = 12;
      while (itAssimMaladieLongueDuree.hasNext())
      {
        PeriodeEvenementPersonnel pep = (PeriodeEvenementPersonnel)itAssimMaladieLongueDuree.next();
        ActiviteParticipante activiteParticipante = creerActiviteParticipante();
        activiteParticipante.setNature(natureActivite);
        activiteParticipante.setPeriodeActivite(pep.getPeriode());
        int quantiteHeure = ParametresAffiliationFPS.NOMBRE_HEURE_PAR_JOUR_MALADIE_LONGUE_DUREE.intValue() * activiteParticipante.getPeriodeActivite().getDuree();
        
        activiteParticipante.setQuantiteTotaleTravaillee(new Quantite(new BigDecimal(quantiteHeure), UNITE_HEURE));
        justification.ajouterActiviteParticipante(activiteParticipante);
      }
    }
  }
}

/* Location:
 * Qualified Name:     JustifierAffiliationConvention2017
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */