package fr.unedic.cali.asu.fps.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.DelaiRechercheProduit;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.RechercheConditionFaitGenerateurDemandeClassique;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.outilsfonctionnels.RechercherDernierSinistre;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeHorsChamp;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.DureeCalendaire;

public class RechercheConditionFaitGenerateurDemandeFps
  extends RechercheConditionFaitGenerateurDemandeClassique
{
  protected DelaiRechercheProduit determinerDelaiForclusion(Demande p_demande)
    throws CoucheLogiqueException
  {
    DelaiRechercheProduit delaiForclusion = null;
    
    DureeCalendaire delaiAllongementForce = recupererDelaiAllongement(p_demande);
    
    DossierAffectation dossierAffectationCourant = (DossierAffectation)p_demande.getDossierAffectation();
    ProduitAsuSpec produitFpsCourant = (ProduitAsuSpec)dossierAffectationCourant.getProduit();
    delaiForclusion = (DelaiRechercheProduit)produitFpsCourant.obtenirDelaiRechercheProduit(dossierAffectationCourant, delaiAllongementForce);
    
    return delaiForclusion;
  }
  
  protected TravailSpec determinerDernierSinistre(Demande p_demande)
    throws CoucheLogiqueException
  {
    TravailSpec dernierSinistre = null;
    
    Chronologie chronoActivitesRechercheDernierSinistre = RechercherDernierSinistre.determinerChronologieActivitesRechercheDernierSinistre(p_demande);
    
    Chronologie chronoActivitesParticipantes = chronoActivitesRechercheDernierSinistre.copier(new FiltrePeriodeActiviteSalarieeHorsChamp(false));
    
    dernierSinistre = RechercherDernierSinistre.rechercherDernierSinistre(p_demande.getDateExamen(), chronoActivitesParticipantes);
    
    return dernierSinistre;
  }
  
  protected TravailSpec determinerDerniereFctEtudiee(Demande p_demande)
  {
    return null;
  }
  
  private DureeCalendaire recupererDelaiAllongement(DemandeAssuranceSpec p_demande)
  {
    DureeCalendaire delai = null;
    if ((p_demande.getDonneesTemporaires() != null) && (p_demande.getDonneesTemporaires().getAllongementDelaiForclusion() != null) && (p_demande.getDonneesTemporaires().getAllongementDelaiForclusion().getJours() != 0)) {
      delai = p_demande.getDonneesTemporaires().getAllongementDelaiForclusion();
    }
    return delai;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionFaitGenerateurDemandeFps
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */