package fr.unedic.cali.asu.liquidation.pnds.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.CreationPeriodeNonDeclareeSanction;
import fr.unedic.cali.asu.liquidation.pnds.StrategiePNDSSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.pnds.PeriodeNonDeclareeSanction;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriodeConcrete;
import fr.unedic.util.temps.OutilOptimisationChronologie;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.util.ArrayList;
import java.util.Collection;

public class StrategiePNDSCgeAvantMEP08SI1
  implements StrategiePNDSSpec
{
  public PeriodeNonDeclareeSanction determinerPNDS(IndividuSpec p_individu, ActiviteSalarie p_activite, Damj p_dateDebut, Damj p_dateFin, Damj p_dateExamen)
    throws ApplicativeException
  {
    Periode periodeCalcul = new Periode(p_dateDebut, p_dateFin);
    
    ChronologiePeriodes chronologiePeriodeCalculAvecPnds = CreationPeriodeNonDeclareeSanction.creerPeriodeNonDeclareeSanctionPourLiquidation(p_dateDebut, p_dateFin, p_individu.getListeAttributionsChevauchantPeriode(new Periode(p_activite.getDateDebut(), p_activite.getDateFin()), p_dateExamen));
    
    ChronologiePeriodes chronologieResultat = determinerChronologieSurPeriodeCalcul(chronologiePeriodeCalculAvecPnds, periodeCalcul);
    
    PeriodeNonDeclareeSanction resultat = PeriodeNonDeclareeSanction.creerInstance(chronologieResultat);
    resultat.setPeriodeActivite(p_activite);
    return resultat;
  }
  
  public Collection determinerPNDS(IndividuSpec p_individu, Collection p_listeAttributions, Damj p_dateDebut, Damj p_dateFin, Damj p_dateExamen)
    throws ApplicativeException
  {
    Periode periodeCalcul = new Periode(p_dateDebut, p_dateFin);
    
    ChronologiePeriodes chronologiePeriodeCalculAvecPnds = null;
    chronologiePeriodeCalculAvecPnds = CreationPeriodeNonDeclareeSanction.creerPeriodeNonDeclareeSanctionPourLiquidation(p_dateDebut, p_dateFin, p_individu.getListeAttributionsChevauchantPeriode(new Periode(p_dateDebut, p_dateFin), p_dateExamen));
    
    ChronologiePeriodes chronologieResultat = determinerChronologieSurPeriodeCalcul(chronologiePeriodeCalculAvecPnds, periodeCalcul);
    
    PeriodeNonDeclareeSanction pnds = PeriodeNonDeclareeSanction.creerInstance(chronologieResultat);
    Collection resultat = new ArrayList();
    resultat.add(pnds);
    return resultat;
  }
  
  private ChronologiePeriodes determinerChronologieSurPeriodeCalcul(ChronologiePeriodes chronologiePeriodeCalculAvecPnds, Periode periodeCalcul)
  {
    chronologiePeriodeCalculAvecPnds.iterer();
    ChronologiePeriodes chronologieResultat = new ChronologiePeriodes();
    
    OutilOptimisationChronologie outilOptimisationChronologie = new OutilOptimisationChronologie(chronologieResultat);
    while (chronologiePeriodeCalculAvecPnds.encoreSuivant())
    {
      Temporel temporel = chronologiePeriodeCalculAvecPnds.elementSuivant();
      Periode periodeCourante = new Periode(temporel.getDateDebut(), temporel.getDateFin());
      Periode periodeIncluseDansPeriodeCalcul = periodeCourante.periodeIntersection(periodeCalcul);
      if (periodeIncluseDansPeriodeCalcul != null) {
        outilOptimisationChronologie.ajouter(new ObjetChronoPeriodeConcrete(periodeIncluseDansPeriodeCalcul));
      }
    }
    return (ChronologiePeriodes)outilOptimisationChronologie.getChronologieTriee();
  }
}

/* Location:
 * Qualified Name:     StrategiePNDSCgeAvantMEP08SI1
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */