package fr.unedic.cali.asu.mnt.dom;

import fr.unedic.cali.asu.mnt.dom.gen.DecisionGen;
import fr.unedic.cali.dom.DecisionSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class Decision
  extends DecisionGen
  implements DecisionSpec
{
  private transient int origine;
  
  protected Decision() {}
  
  public Decision(DomPCSpec pc)
  {
    super(pc);
  }
  
  protected Decision(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public boolean estValidee()
  {
    return super.isValidee();
  }
  
  public boolean estSanctionnee()
  {
    return false;
  }
  
  protected ConditionsAttributionSpec getConditionsAttributionActives()
  {
    return getConditionsAttributionAdmission();
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    Decision copie = (Decision)pCopie;
    
    super.copieElements(copie);
    copie.setValidee(estValidee());
    copie.setNatureDecision(getNatureDecision());
  }
  
  public int getOrigine()
  {
    return origine;
  }
  
  public void setOrigine(int origine)
  {
    this.origine = origine;
  }
  
  public String determinerCodeSousProduitPourSigma()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     Decision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */