package fr.unedic.cali.asu.mnt.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.mnt.dom.pc.DureeDetectionMaintienPC;
import fr.unedic.cali.dom.DureeDetectionMaintienAbstraite;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class DureeDetectionMaintienGen
  extends DureeDetectionMaintienAbstraite
  implements DomGenSpec
{
  private Quantite m_quantiteCourante;
  
  public DureeDetectionMaintienGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DureeDetectionMaintienGen() {}
  
  protected DomPCSpec createPC()
  {
    return new DureeDetectionMaintienPC();
  }
  
  protected int rawGetEtat()
  {
    return ((DureeDetectionMaintienPC)getPC()).getEtat();
  }
  
  public int getEtat()
  {
    return ((DureeDetectionMaintienPC)getPC()).getEtat();
  }
  
  public void setEtat(int p_etat)
  {
    ((DureeDetectionMaintienPC)getPC()).setEtat(p_etat);
  }
  
  protected Quantite rawGetQuantiteCourante()
  {
    return ((DureeDetectionMaintienPC)getPC()).getQuantiteCourante();
  }
  
  public Quantite getQuantiteCourante()
  {
    return ((DureeDetectionMaintienPC)getPC()).getQuantiteCourante();
  }
  
  public void setQuantiteCourante(Quantite p_quantiteCourante)
  {
    if ((m_quantiteCourante == null) || (p_quantiteCourante == null))
    {
      m_quantiteCourante = p_quantiteCourante;
      ((DureeDetectionMaintienPC)getPC()).setQuantiteCourante(p_quantiteCourante);
    }
    else if ((m_quantiteCourante != null) && (p_quantiteCourante != null) && (!p_quantiteCourante.equals(m_quantiteCourante)))
    {
      m_quantiteCourante = p_quantiteCourante;
      ((DureeDetectionMaintienPC)getPC()).setQuantiteCourante(p_quantiteCourante);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     DureeDetectionMaintienGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */