package fr.unedic.cali.asu.occasionnel.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.NovationSpec;
import fr.unedic.cali.occasionnel.outilsfonctionnels.CriteresTraitementPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.ResultatTraitementPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.TraitementPopulationSpec;
import fr.unedic.util.temps.Chronologie;

public class TraitementAppelsContribCSP
  implements TraitementPopulationSpec
{
  public ResultatTraitementPopulation effectuerTraitement(CriteresTraitementPopulation criteres)
    throws ApplicativeException
  {
    IndividuSpec individu = criteres.getIndividu();
    Chronologie demandesAssurances = individu.getChronoDemandeAssurance();
    demandesAssurances.iterer();
    while (demandesAssurances.encoreSuivant())
    {
      Demande demandeCourante = (Demande)demandesAssurances.elementSuivant();
      DossierExamenSpec dossierExamen = demandeCourante.getDossierExamen();
      if (((dossierExamen instanceof NovationSpec)) && (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demandeCourante, "AREENTRCSP"))) {
        demandeCourante.setTopAppelContribution(true);
      }
    }
    return new ResultatTraitementPopulation();
  }
}

/* Location:
 * Qualified Name:     TraitementAppelsContribCSP
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */