package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public final class AccesValeursParametres
  implements OutilFonctionnel
{
  public static QuantiteEuro getPlafondSjr(Damj datePlafonnement)
  {
    QuantiteEuro plafondSjr = null;
    
    ParametresIndemnisation parametresIndemnisation = ParametresIndemnisation.getParametresIndemnisation();
    
    BigDecimal plafondMensuelApplicable = parametresIndemnisation.getElementActif(datePlafonnement).getPlafond();
    
    BigDecimal nominateur1 = new BigDecimal("12");
    BigDecimal nominateur2 = plafondMensuelApplicable;
    BigDecimal denominateur = new BigDecimal("365");
    BigDecimal valeurPlafondSjr = Mathematiques.proratiser(nominateur1, nominateur2, denominateur);
    
    valeurPlafondSjr = Mathematiques.tronque(valeurPlafondSjr, 2);
    plafondSjr = new QuantiteEuro(valeurPlafondSjr);
    
    return plafondSjr;
  }
}

/* Location:
 * Qualified Name:     AccesValeursParametres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */