package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.parametres.AccesListeUnitesReglement;
import fr.unedic.cali.asu.parametres.ValeurListeUnitesReglement;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeMesureActivite;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.ConvertisseurUniteAppletLiquidation;
import fr.unedic.util.Convertisseur;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Chronologie;
import java.util.ArrayList;

public class CalculerQuantiteTravailPas
  implements OutilFonctionnel
{
  public static String calculerTotalQuantiteTravailPas(ActiviteSalarie p_pas, Reglement p_reglement)
  {
    StringBuffer quantiteAffiliation = new StringBuffer("");
    ArrayList listeUnite;
    ArrayList listeUnite;
    if (p_reglement != null)
    {
      listeUnite = recupererUnitesReglement(p_reglement);
    }
    else
    {
      listeUnite = new ArrayList();
      listeUnite.add(UniteAffiliation.JOUR);
    }
    for (int i = 0; i < listeUnite.size(); i++)
    {
      UniteAffiliation uniteCourante = (UniteAffiliation)listeUnite.get(i);
      
      Quantite quantiteCumul = new Quantite(0, uniteCourante);
      
      Chronologie listePeriodesMesureActivite = p_pas.getListePeriodesMesureActivite();
      PeriodeMesureActivite periodeMesureActiviteCourante = null;
      
      listePeriodesMesureActivite.iterer();
      while (listePeriodesMesureActivite.encoreSuivant())
      {
        Quantite quantiteCourante = null;
        
        periodeMesureActiviteCourante = (PeriodeMesureActivite)listePeriodesMesureActivite.elementSuivant();
        
        quantiteCourante = periodeMesureActiviteCourante.getQuantiteAffiliation(uniteCourante);
        if ((p_reglement != null) && (p_reglement.estNomReglementIdentique("A1")) && (quantiteCourante == null))
        {
          quantiteCourante = periodeMesureActiviteCourante.getQuantiteAffiliation(UniteAffiliation.HEURE_TRAVAIL);
          
          ProduitAsuSpec produit = (ProduitAsuSpec)p_reglement.getProduit();
          Convertisseur convertisseurUniteAffiliation = produit.determinerConvertisseurUniteAffiliation();
          if ((quantiteCourante != null) && (convertisseurUniteAffiliation != null))
          {
            Quantite quantiteeConvertie = convertisseurUniteAffiliation.convertir(quantiteCourante, UniteAffiliation.JOUR);
            quantiteCourante = quantiteeConvertie;
          }
        }
        if (quantiteCourante != null) {
          quantiteCumul = quantiteCumul.ajouter(quantiteCourante);
        }
      }
      if (quantiteCumul.getValeurEntiere() > 0)
      {
        if (quantiteAffiliation.length() > 0) {
          quantiteAffiliation.append("/");
        }
        quantiteAffiliation.append(Mathematiques.parserBigDecimalEnString(quantiteCumul.getValeur(), 2) + ConvertisseurUniteAppletLiquidation.getUniteApplet(uniteCourante));
      }
    }
    return quantiteAffiliation.toString();
  }
  
  public static ArrayList recupererUnitesReglement(Reglement p_reglement)
  {
    return AccesListeUnitesReglement.get(p_reglement, null) != null ? AccesListeUnitesReglement.get(p_reglement, null).getListeUnites() : new ArrayList();
  }
}

/* Location:
 * Qualified Name:     CalculerQuantiteTravailPas
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */