package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.CodesMotifsEchec;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.dom.ConditionAttributionSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.RejetSpec;
import java.math.BigDecimal;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public final class OutilMotifEchec
{
  public static int retournerMotifEchecNotifie(int motifRejetPivot, DossierExamenSpec dossierExamen)
  {
    if ((71 == motifRejetPivot) || (CodesMotifsEchec.s_codeMotifRejetAffi.containsValue(Integer.valueOf(motifRejetPivot))))
    {
      if (rechercherMotifEchecCapaFaitGenerateurPourAffiliationInsuffisante(dossierExamen.getListConditionsAttribution())) {
        return 71;
      }
      return 46;
    }
    return motifRejetPivot;
  }
  
  public static int retournerPremierMotifEchec(List listeCap)
  {
    int motif = 0;
    
    Iterator iterateurCap = listeCap.iterator();
    while ((iterateurCap.hasNext()) && (motif == 0))
    {
      ConditionAttributionSpec cap = (ConditionAttributionSpec)iterateurCap.next();
      if (cap != null) {
        motif = cap.getCodeMotifEchec();
      }
    }
    return motif;
  }
  
  public static boolean rechercherMotifEchecCapaFaitGenerateurPourAffiliationInsuffisante(List listeCap)
  {
    Iterator iterateurCap = listeCap.iterator();
    while (iterateurCap.hasNext())
    {
      ConditionAttributionSpec cap = (ConditionAttributionSpec)iterateurCap.next();
      if ((cap != null) && (cap.getCodeMotifEchec() == 71)) {
        return true;
      }
    }
    return false;
  }
  
  public static String getCapEchec(DemandeAssuranceSpec demandeAssurance)
  {
    String libelleMotifRetour = null;
    DossierExamenSpec dossierExam = demandeAssurance.getDossierExamen();
    if ((dossierExam instanceof RejetSpec))
    {
      int codeMotif = retournerPremierMotifEchec(dossierExam.getListConditionsAttribution());
      if (codeMotif != 0)
      {
        Map map = CodesMotifsEchec.getLibelleEchecCap();
        libelleMotifRetour = (String)map.get(new BigDecimal(codeMotif));
      }
    }
    return libelleMotifRetour;
  }
  
  public static String getCapEchecSansAffi(DemandeAssuranceSpec demandeAssurance)
  {
    String libelleMotifRetour = null;
    DossierExamenSpec dossierExam = demandeAssurance.getDossierExamen();
    if ((dossierExam instanceof RejetSpec))
    {
      int codeMotif = retournerPremierMotifEchec(dossierExam.getListConditionsAttribution());
      if ((codeMotif != 0) && (codeMotif != 71))
      {
        Map map = CodesMotifsEchec.getLibelleEchecCap();
        libelleMotifRetour = (String)map.get(new BigDecimal(codeMotif));
      }
    }
    return libelleMotifRetour;
  }
}

/* Location:
 * Qualified Name:     OutilMotifEchec
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */