package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.autresdoms.ga.outilsfonctionnels.OutilPasseProfessionel;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeE301;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Temporel;
import java.util.Iterator;
import java.util.List;

public class OutilPasseProfessionelAsu
{
  public static ChronologiePeriodes trouverChronoPasseProfessionelAvecFiltrageE301etDNJ(IndividuSpec p_individu, boolean p_estCoordCee)
  {
    ChronologiePeriodes retour = null;
    ChronologiePeriodes chronoPeriodesGa = OutilPasseProfessionel.trouverChronoPasseProfessionelAvecFiltrageDNJ(p_individu);
    if (p_estCoordCee)
    {
      retour = chronoPeriodesGa;
    }
    else
    {
      ChronologiePeriodes chronoPeriodesSansE301 = (ChronologiePeriodes)chronoPeriodesGa.copier(new FiltrePeriodeActiviteSalarieeE301(false));
      retour = chronoPeriodesSansE301;
    }
    return retour;
  }
  
  public static void positionnerPasseProRevisionAvecExclusionFctReviseesAre14(Demande p_demande)
  {
    IndividuSpec individu = p_demande.getDemandeur();
    List<TravailSpec> listeFct = OutilsRevisions.trouverListeFctReviseesAre14(p_demande);
    
    ChronologiePeriodes chronoARetourner = new ChronologiePeriodes();
    Iterator<Temporel> iterateur = individu.getChronoPeriodePasseProfessionnelLiquidation().iterer();
    while (iterateur.hasNext())
    {
      Temporel periode = (Temporel)iterateur.next();
      if ((!(periode instanceof TravailSpec)) || (!estFCTAExclure(listeFct, (TravailSpec)periode))) {
        chronoARetourner.ajouter(periode);
      }
    }
    individu.setChronoPeriodePasseProfessionnelLiquidationRevision(chronoARetourner);
  }
  
  private static boolean estFCTAExclure(List<TravailSpec> p_listeFCTAExclure, TravailSpec p_activite)
  {
    if (p_listeFCTAExclure != null)
    {
      Iterator<TravailSpec> it = p_listeFCTAExclure.iterator();
      while (it.hasNext())
      {
        TravailSpec periodeCourante = (TravailSpec)it.next();
        if (formaterIdentifiant(periodeCourante.getIdentifiant()).equals(formaterIdentifiant(p_activite.getIdentifiant()))) {
          return true;
        }
      }
    }
    return false;
  }
  
  private static String formaterIdentifiant(String identifiantPeriode)
  {
    int index = identifiantPeriode.indexOf("-");
    if (index > 0) {
      return identifiantPeriode.substring(0, index);
    }
    return identifiantPeriode;
  }
}

/* Location:
 * Qualified Name:     OutilPasseProfessionelAsu
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */