package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.outilsfonctionnels.ComparateurSurDateDeclenchementEtPrioriteDemande;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDemandePourERE;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;

public class OutilVerificationPreconditions
  extends fr.unedic.cali.outilsfonctionnels.OutilVerificationPreconditions
{
  public static OutilVerificationPreconditions getInstance()
  {
    return new OutilVerificationPreconditions();
  }
  
  protected void verifierDemandeRechargementValidee(DemandeSpec demandeCourante)
    throws CoucheLogiqueException
  {
    DemandeSpec demandeRechargementPrecedente = null;
    FiltreET filtre = new FiltreET();
    filtre.ajouterFiltre(new FiltreDemandePourERE("ASU_29"));
    Chronologie chronoDemandeRechargement = OutilRecherche.rechercherDemandesPrecedentes(demandeCourante.getChronologieDemandesAssuranceSansCourante(), demandeCourante.getDateRecherche(), filtre);
    if (chronoDemandeRechargement != null)
    {
      chronoDemandeRechargement.setComparateur(new ComparateurSurDateDeclenchementEtPrioriteDemande());
      chronoDemandeRechargement.iterer();
      while (chronoDemandeRechargement.encoreSuivant())
      {
        demandeRechargementPrecedente = (DemandeSpec)chronoDemandeRechargement.elementSuivant();
        if (((Demande)demandeRechargementPrecedente).isEstNonExecutable()) {
          GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEMANDE_RECHARGEMENT_NON_EXECUTABLE");
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     OutilVerificationPreconditions
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */