package fr.unedic.cali.asu.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.dom.affectation.ProduitAsuCSR04P01;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P02;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.temps.Chronologie;

public class AffectationDemandeAsuCsr
  extends AffectationDemandeASUClassique
{
  protected void validerProduit(DemandeAssuranceSpec p_demandeAsuCourante, Chronologie p_chronoPeriodesParticipantes, ProduitAsuSpec p_produitDernierSinistre)
    throws ApplicativeException
  {
    super.validerProduit(p_demandeAsuCourante, p_chronoPeriodesParticipantes, p_produitDernierSinistre);
    
    DossierAffectation dossierAffectationCourant = (DossierAffectation)p_demandeAsuCourante.getDossierAffectation();
    if ((dossierAffectationCourant.getValidationProduit() != null) && (dossierAffectationCourant.getValidationProduit().isEstProduitValide()))
    {
      ProduitAsuSpec produitCourant = (ProduitAsuSpec)dossierAffectationCourant.getValidationProduit().getProduitValide();
      
      ProduitAsuSpec produitChomageSansRCT = null;
      if (produitCourant.equals(ProduitAsuCge01P02.getInstance())) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_CSR_NON_APPLICABLE_POUR_PRODUIT");
      } else if (produitCourant.equals(ProduitAsuCge01P03.getInstance())) {
        produitChomageSansRCT = ProduitAsuCSR04P01.getInstance();
      } else {
        produitChomageSansRCT = produitCourant;
      }
      if (produitChomageSansRCT.contientReglement(dossierAffectationCourant.getValidationProduit().getReglementApplicable())) {
        dossierAffectationCourant.getValidationProduit().setProduitValide(produitChomageSansRCT);
      } else {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_CSR_NON_APPLICABLE_POUR_REGLEMENT");
      }
    }
  }
}

/* Location:
 * Qualified Name:     AffectationDemandeAsuCsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */