package fr.unedic.cali.asu.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.affectation.LigneAsuFds12;
import fr.unedic.cali.dom.affectation.LigneAsuSsp07;
import fr.unedic.cali.dom.affectation.ProduitAsuFds12P02;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ValidationProduitSpec;
import fr.unedic.cali.outilsfonctionnels.RechercherDernierSinistre;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class AffectationDemandeAsuExamenFilEau
  extends ParcoursAffectationDemandeAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demandeAssuranceExistante = getDemande(contexte);
    
    initialiserDemande(demandeAssuranceExistante);
    
    DossierAffectation dossierAffectation = (DossierAffectation)demandeAssuranceExistante.getDossierAffectation();
    
    Chronologie chronoPeriodesParticipantesRechercherDernierSinistre = determinerChronologieActivitesRechercheDernierSinistre(demandeAssuranceExistante);
    
    rechercherDernierSinistre(demandeAssuranceExistante, chronoPeriodesParticipantesRechercherDernierSinistre);
    if (dossierAffectation.getSinistre() != null) {
      recupererDecorReglementaire(dossierAffectation);
    }
    DossierAffecte dossierAffecte = (DossierAffecte)dossierAffectation;
    
    ValidationProduitSpec validationProduit = null;
    
    TravailSpec dernierSinistre = dossierAffectation.getSinistre();
    if (demandeAssuranceExistante.estUneDemandeAps())
    {
      ProduitAsuSpec produit = (ProduitAsuSpec)LigneAsuSsp07.getInstance().getProduitActif(demandeAssuranceExistante.getDateExamen());
      validationProduit = produit.obtenirValidationProduit(null, demandeAssuranceExistante.getDemandeur(), demandeAssuranceExistante, false);
    }
    else if ((demandeAssuranceExistante.estUneDemandeAtAfd()) && (dernierSinistre != null))
    {
      ProduitAsuSpec produit = (ProduitAsuSpec)LigneAsuFds12.getInstance().getProduitActif(demandeAssuranceExistante.getDateExamen());
      if ((ProduitAsuFds12P02.getInstance().getCode() == produit.getCode()) && (!dernierSinistre.getDateFin().estContenueDans(produit.getPeriodeValidite()))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_PRODUIT_FDS_NON_VALIDE_POUR_FGD", new Object[] { produit.getPeriodeValidite().getDebut() });
      }
      validationProduit = produit.obtenirValidationProduit(null, demandeAssuranceExistante.getDemandeur(), demandeAssuranceExistante, false);
    }
    else if (dernierSinistre == null)
    {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_AFFEC_DERNIER_SINISTRE_NON_TROUVE");
    }
    else
    {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_PRODUIT_NON_VALIDE_POUR_EXAMEN");
    }
    dossierAffecte.setValidationProduit((ValidationProduit)validationProduit);
    
    return new Resultat(0);
  }
  
  protected Chronologie determinerChronologieActivitesRechercheDernierSinistre(Demande demandeAssuranceExistante)
  {
    return RechercherDernierSinistre.determinerChronologieActivitesRechercheDernierSinistre(demandeAssuranceExistante);
  }
}

/* Location:
 * Qualified Name:     AffectationDemandeAsuExamenFilEau
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */