package fr.unedic.cali.asu.parcours;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.PensionInvaliditeChainee;
import fr.unedic.cali.asu.outilsfonctionnels.OutilPensionInvalidite;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodePensionInvaliditeChaineeSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.parcours.LireDemandePrestation;
import fr.unedic.cali.parcours.ResultatServicePrestation;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.util.ListIterator;

public class LireDemandePrestationAssurance
  extends LireDemandePrestation
{
  protected void mettreAJourPensionsInvalidite(ResultatServicePrestation p_resultatLireDemande, DemandeSpec p_demande)
    throws CoucheLogiqueException
  {
    Chronologie listePI = p_demande.getDemandeur().getChronoPensionsInvaliditeChainees();
    ChronologiePeriodes retour = new ChronologiePeriodes();
    
    ListIterator it = listePI.iterer();
    while (it.hasNext())
    {
      PensionInvaliditeChainee pension = OutilPensionInvalidite.conversionDomPensionInvaliditeEnDomLiquidation((PeriodePensionInvaliditeChaineeSpec)it.next());
      PeriodePensionInvaliditeChaineeSpec pensionForcee = OutilPensionInvalidite.rechercherPensionInvaliditeSurDemande((DemandeAssuranceSpec)p_demande, pension);
      if (pensionForcee != null) {
        pension.setStatut(pensionForcee.getStatut());
      }
      retour.ajouter(pension);
    }
    p_resultatLireDemande.setChronoPensionsInvalidite(retour);
  }
}

/* Location:
 * Qualified Name:     LireDemandePrestationAssurance
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */