package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.ConditionValiditeReliquatSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.ConditionValiditeReliquatGen;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConditionValiditeReliquat
  extends ConditionValiditeReliquatGen
  implements ConditionValiditeReliquatSpec
{
  private static final long serialVersionUID = -7186129994734319208L;
  
  public ConditionValiditeReliquat(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ConditionValiditeReliquat() {}
  
  public boolean estSatisfait()
  {
    return getEtat() == 0;
  }
  
  public void setEtatSatisfait(boolean p_etatSatisfait)
  {
    if (p_etatSatisfait) {
      setEtat(0);
    } else {
      setEtat(1);
    }
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  /**
   * @deprecated
   */
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConditionValiditeReliquat copie = (ConditionValiditeReliquat)p_copie;
    copie.setCodeMotifEchec(getCodeMotifEchec());
    copie.setEtat(getEtat());
    copie.setCauseExtinction(getCauseExtinction());
    copie.setDateDecheance(getDateDecheance());
    copie.setMotifNonValidite(getMotifNonValidite());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     ConditionValiditeReliquat
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */