package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.DiffereSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.DiffereGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;

public class Differe
  extends DiffereGen
  implements ObjetPersistantSpec, DiffereSpec
{
  private static final long serialVersionUID = 5494997877825602807L;
  public static final int DIFFERE_7_JOURS = 7;
  
  public Differe(DomPCSpec pc)
  {
    super(pc);
  }
  
  public Differe(int jours)
  {
    setQuantiteInitial(new Quantite(new BigDecimal(Integer.toString(jours)), UNITE_DEFAUT));
  }
  
  public Differe() {}
  
  public String getTypeCarence()
  {
    return "Différé";
  }
  
  public ObjetMetierSpec copie()
  {
    Differe copie = new Differe();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    Differe copie = (Differe)pCopie;
    copie.setDateFinPeriodeOrigine(getDateFinPeriodeOrigine());
    copie.setIdentifiantPeriodeOrigine(getIdentifiantPeriodeOrigine());
    copie.setPeriodeApplicationCarence(getPeriodeApplicationCarence());
    copie.setQuantiteInitial(getQuantiteInitial());
    copie.setReliquat(getReliquat());
    copie.setReliquatCarence(isReliquatCarence());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     Differe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */