package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.produits.liquidation.dom.gen.JustificationDroitResultantGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class JustificationDroitResultant
  extends JustificationDroitResultantGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = 8206335191874487650L;
  
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    JustificationDroitResultant copie = new JustificationDroitResultant();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationDroitResultant copie = (JustificationDroitResultant)p_copie;
    
    copie.setCompetenceFinanciereDroitCourant(getCompetenceFinanciereDroitCourant());
    copie.setMontantInitialDroitCourant(getMontantInitialDroitCourant());
    copie.setCapitalDroitCourant(getCapitalDroitCourant());
    copie.setImputationDroitCourant(getImputationDroitCourant());
    copie.setDureeDroitCourant(getDureeDroitCourant());
    copie.setAvantageVieillesseDroitCourant(getAvantageVieillesseDroitCourant());
    copie.setPensionInvaliditeDroitCourant(getPensionInvaliditeDroitCourant());
    copie.setCrcDroitCourantCompCapitaux(getCrcDroitCourantCompCapitaux());
    copie.setCrcDroitCourantCompMontants(getCrcDroitCourantCompMontants());
    copie.setMontantBrutDroitCourantCompCapitaux(getMontantBrutDroitCourantCompCapitaux());
    copie.setMontantBrutDroitCourantCompMontants(getMontantBrutDroitCourantCompMontants());
    
    copie.setCompetenceFinanciereDroitPrecedent(getCompetenceFinanciereDroitPrecedent());
    copie.setMontantInitialDroitPrecedent(getMontantInitialDroitPrecedent());
    copie.setCapitalDroitPrecedent(getCapitalDroitPrecedent());
    copie.setImputationDroitPrecedent(getImputationDroitPrecedent());
    copie.setDureeDroitPrecedent(getDureeDroitPrecedent());
    copie.setAvantageVieillesseDroitPrecedent(getAvantageVieillesseDroitPrecedent());
    copie.setPensionInvaliditeDroitPrecedent(getPensionInvaliditeDroitPrecedent());
    copie.setCrcDroitPrecedentCompCapitaux(getCrcDroitPrecedentCompCapitaux());
    copie.setCrcDroitPrecedentCompMontants(getCrcDroitPrecedentCompMontants());
    copie.setMontantBrutDroitPrecedentCompCapitaux(getMontantBrutDroitPrecedentCompCapitaux());
    copie.setMontantBrutDroitPrecedentCompMontants(getMontantBrutDroitPrecedentCompMontants());
    copie.setStatutPensionInvaliditeDroitCourant(getStatutPensionInvaliditeDroitCourant());
    
    copie.setCompetenceFinanciereDroitRetenu(getCompetenceFinanciereDroitRetenu());
    copie.setMontantDroitRetenu(getMontantDroitRetenu());
    copie.setCapitalDroitRetenu(getCapitalDroitRetenu());
    copie.setImputationDroitRetenu(getImputationDroitRetenu());
    copie.setDureeDroitRetenu(getDureeDroitRetenu());
    
    copie.setEstCasParticulierPensionInvalidite(isEstCasParticulierPensionInvalidite());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public JustificationDroitResultant(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public JustificationDroitResultant() {}
}

/* Location:
 * Qualified Name:     JustificationDroitResultant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */