package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;

public class JustificationPrc
  implements ObjetMetierSpec
{
  private static final long serialVersionUID = -6679971210978686246L;
  public static final int TYPE_BORNAGE_PRC_AUCUN = 0;
  public static final int TYPE_BORNAGE_PRC_FGD_PRECEDENT = 1;
  public static final int TYPE_BORNAGE_PRC_FCT_E301 = 2;
  private Periode m_periodePrcInitiale;
  private Periode m_periodePrcBornee;
  private int m_typeBornagePrc = 0;
  
  private JustificationPrc() {}
  
  public JustificationPrc(Periode p_periodePrcInitiale)
  {
    m_periodePrcInitiale = p_periodePrcInitiale;
  }
  
  public Periode getPeriodePrcBornee()
  {
    return m_periodePrcBornee;
  }
  
  public void setPeriodePrcBornee(Periode p_periodePrcBornee)
  {
    m_periodePrcBornee = p_periodePrcBornee;
  }
  
  public Periode getPeriodePrcInitiale()
  {
    return m_periodePrcInitiale;
  }
  
  public void setPeriodePrcInitiale(Periode p_periodePrcInitiale)
  {
    m_periodePrcInitiale = p_periodePrcInitiale;
  }
  
  public int getTypeBornagePrc()
  {
    return m_typeBornagePrc;
  }
  
  public void setTypeBornagePrc(int p_typeBornagePrc)
  {
    m_typeBornagePrc = p_typeBornagePrc;
  }
  
  public Periode getPeriodePrcEffective()
  {
    Periode periodePrc = getPeriodePrcInitiale();
    if (getTypeBornagePrc() != 0) {
      periodePrc = getPeriodePrcBornee();
    }
    return periodePrc;
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationPrc copie = new JustificationPrc();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationPrc copie = (JustificationPrc)p_copie;
    if (getPeriodePrcInitiale() != null) {
      copie.setPeriodePrcInitiale(new Periode(getPeriodePrcInitiale().getDebut(), getPeriodePrcInitiale().getFin()));
    }
    if (getPeriodePrcBornee() != null) {
      copie.setPeriodePrcBornee(new Periode(getPeriodePrcBornee().getDebut(), getPeriodePrcBornee().getFin()));
    }
    copie.setTypeBornagePrc(getTypeBornagePrc());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     JustificationPrc
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */