package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.produits.liquidation.dom.gen.JustificationSjrGen;
import fr.unedic.cali.asu.produits.liquidation.dom.pc.ConstitutionElementsAdmissionPC;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class JustificationSjr
  extends JustificationSjrGen
  implements ObjetPersistantSpec
{
  private transient JustificationDiviseur justificationDiviseur = new JustificationDiviseur();
  private transient JustificationPlafonds justificationPlafonds = new JustificationPlafonds();
  private static final long serialVersionUID = 9076619693388043886L;
  
  public JustificationSjr(DomPCSpec pc)
  {
    super(pc);
  }
  
  public JustificationSjr() {}
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getJustificationSr());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec copie)
  {
    JustificationSjr copieJustifSjr = (JustificationSjr)copie;
    copieJustifSjr.setJustificationDiviseur((JustificationDiviseur)getJustificationDiviseur().copie());
    copieJustifSjr.setJustificationPlafonds((JustificationPlafonds)getJustificationPlafonds().copie());
    JustificationSr copieJustifSr = copieJustifSjr.createJustificationSr();
    getJustificationSr().copieElements(copieJustifSr);
  }
  
  public JustificationSjr copieNonPersistante()
  {
    JustificationSjr retour = createNonPersistent();
    copieElements(retour);
    return retour;
  }
  
  public static JustificationSjr copieNonPersistante(JustificationSjr origine)
  {
    if (origine == null) {
      return createNonPersistent();
    }
    return origine.copieNonPersistante();
  }
  
  public static JustificationSjr createNonPersistent()
  {
    return new JustificationSjr(new ConstitutionElementsAdmissionPC());
  }
  
  public JustificationDiviseur getJustificationDiviseur()
  {
    return justificationDiviseur;
  }
  
  public void setJustificationDiviseur(JustificationDiviseur justificationDiviseur)
  {
    this.justificationDiviseur = justificationDiviseur;
  }
  
  public JustificationPlafonds getJustificationPlafonds()
  {
    return justificationPlafonds;
  }
  
  public void setJustificationPlafonds(JustificationPlafonds justificationPlafonds)
  {
    this.justificationPlafonds = justificationPlafonds;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     JustificationSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */