package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.produits.liquidation.dom.gen.NonFinancementGen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.FinancementSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public class NonFinancement
  extends NonFinancementGen
  implements FinancementSpec
{
  private static final long serialVersionUID = -3564642380396855339L;
  
  public NonFinancement(DomPCSpec pc)
  {
    super(pc);
  }
  
  public NonFinancement() {}
  
  public NonFinancement(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public NonFinancement(Damj dateEvenement, DossierExamen dossierExamen)
  {
    super(dateEvenement);
    copie(dossierExamen);
  }
  
  protected void copie(Attribution source)
  {
    if (source == null) {
      return;
    }
    super.copie(source);
  }
  
  public void copieElements(ObjetMetierSpec copie)
  {
    NonFinancement copieNonFinancement = (NonFinancement)copie;
    super.copieElements(copieNonFinancement);
  }
  
  public ObjetMetierSpec copie()
  {
    NonFinancement copie = new NonFinancement();
    copieElements(copie);
    return copie;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public String getNatureFinancement()
  {
    return "E";
  }
}

/* Location:
 * Qualified Name:     NonFinancement
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */