package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.PoursuiteGen;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.dom.PoursuiteSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public class Poursuite
  extends PoursuiteGen
  implements PoursuiteSpec
{
  private transient Damj m_pjp;
  private static final long serialVersionUID = 1L;
  
  public Poursuite(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public Poursuite() {}
  
  public Poursuite(Damj p_dateEvenement)
  {
    super(p_dateEvenement);
  }
  
  public Poursuite(Damj p_dateEvenement, DossierExamen p_dossierExamen)
  {
    super(p_dateEvenement);
    copie(p_dossierExamen);
  }
  
  protected void copie(Attribution p_source)
  {
    if (p_source == null) {
      return;
    }
    super.copie(p_source);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    Od copie = (Od)p_copie;
    super.copieElements(copie);
  }
  
  public ObjetMetierSpec copie()
  {
    Poursuite copie = new Poursuite();
    copieElements(copie);
    return copie;
  }
  
  public boolean estExecutable()
  {
    return (!estEnReexamen()) && (estValidee());
  }
  
  public SaisieAntecedent getSaisieAntecedent()
  {
    return ((Demande)getDemande()).getSaisieAntecedent();
  }
  
  public Damj getPjp()
  {
    if (m_pjp == null) {
      m_pjp = getSaisieAntecedent().getDateDernierJourCalcule().lendemain();
    }
    return m_pjp;
  }
  
  public void setUniteTraitement(UniteTraitement p_uniteTraitement)
  {
    DomManager.supprimer(super.getUniteTraitement(), p_uniteTraitement);
    super.setUniteTraitement(p_uniteTraitement);
  }
  
  public void setUniteTraitementAvant(UniteTraitementAvant p_uniteTraitementAvant)
  {
    DomManager.supprimer(super.getUniteTraitementAvant(), p_uniteTraitementAvant);
    super.setUniteTraitementAvant(p_uniteTraitementAvant);
  }
  
  public void marquerGraphePersistant()
  {
    super.marquerGraphePersistant();
    DomManager.persisterEnProfondeur(super.getUniteTraitement());
    DomManager.persisterEnProfondeur(super.getUniteTraitementAvant());
  }
}

/* Location:
 * Qualified Name:     Poursuite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */