package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.PreavisMesureConservatoireIndemnisableSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.PreavisMesureConservatoireIndemnisableGen;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class PreavisMesureConservatoireIndemnisable
  extends PreavisMesureConservatoireIndemnisableGen
  implements ObjetPersistantSpec, PreavisMesureConservatoireIndemnisableSpec
{
  private static final long serialVersionUID = -2256521748758110528L;
  
  public PreavisMesureConservatoireIndemnisable(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public PreavisMesureConservatoireIndemnisable() {}
  
  public PreavisMesureConservatoireIndemnisable(ObjetChronoPeriode p_periodeOrigine, Periode p_periodeApplication)
  {
    setPeriodeApplicationCarence(p_periodeApplication);
    setQuantiteInitial(new QuantiteJour(new BigDecimal(p_periodeApplication.getDuree())));
    if (p_periodeOrigine != null) {
      setDateFinPeriodeOrigine(p_periodeOrigine.getDateFin());
    }
    setOrigine(p_periodeOrigine);
    if ((p_periodeOrigine instanceof TravailSpec)) {
      setIdentifiantPeriodeOrigine(((TravailSpec)p_periodeOrigine).getIdentifiant());
    }
  }
  
  public ObjetMetierSpec copie()
  {
    PreavisMesureConservatoireIndemnisable copie = new PreavisMesureConservatoireIndemnisable();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
    
    PreavisMesureConservatoireIndemnisable copie = (PreavisMesureConservatoireIndemnisable)p_copie;
    copie.setPeriodeApplicationCarence((Periode)getPeriodeApplicationCarence().copie());
    copie.setDateFinPeriodeOrigine(getDateFinPeriodeOrigine());
    copie.setIdentifiantPeriodeOrigine(getIdentifiantPeriodeOrigine());
    copie.setQuantiteInitial(getQuantiteInitial());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public String getTypeCarence()
  {
    return "PMC_I";
  }
}

/* Location:
 * Qualified Name:     PreavisMesureConservatoireIndemnisable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */