package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.PreavisMesureConservatoireNonIndemnisableSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.PreavisMesureConservatoireNonIndemnisableGen;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;

public class PreavisMesureConservatoireNonIndemnisable
  extends PreavisMesureConservatoireNonIndemnisableGen
  implements ObjetPersistantSpec, PreavisMesureConservatoireNonIndemnisableSpec
{
  private static final long serialVersionUID = -3427999377922613849L;
  
  public PreavisMesureConservatoireNonIndemnisable(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public PreavisMesureConservatoireNonIndemnisable() {}
  
  public PreavisMesureConservatoireNonIndemnisable(int p_quantiteInitial)
  {
    super(p_quantiteInitial);
  }
  
  public PreavisMesureConservatoireNonIndemnisable(ObjetChronoPeriode p_periodeOrigine, Periode p_periodeApplication)
  {
    super(p_periodeApplication.getDuree());
    
    setPeriodeApplicationCarence(p_periodeApplication);
    if (p_periodeOrigine != null) {
      setDateFinPeriodeOrigine(p_periodeOrigine.getDateFin());
    }
    setOrigine(p_periodeOrigine);
    if ((p_periodeOrigine instanceof TravailSpec)) {
      setIdentifiantPeriodeOrigine(((TravailSpec)p_periodeOrigine).getIdentifiant());
    }
  }
  
  public ObjetMetierSpec copie()
  {
    PreavisMesureConservatoireNonIndemnisable copie = new PreavisMesureConservatoireNonIndemnisable();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
    PreavisMesureConservatoireNonIndemnisable copie = (PreavisMesureConservatoireNonIndemnisable)p_copie;
    if (getPeriodeApplicationCarence() != null) {
      copie.setPeriodeApplicationCarence((Periode)getPeriodeApplicationCarence().copie());
    }
    copie.setDateFinPeriodeOrigine(getDateFinPeriodeOrigine());
    copie.setIdentifiantPeriodeOrigine(getIdentifiantPeriodeOrigine());
    copie.setQuantiteInitial(getQuantiteInitial());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public String getTypeCarence()
  {
    return "PMC_NI";
  }
}

/* Location:
 * Qualified Name:     PreavisMesureConservatoireNonIndemnisable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */