package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConstitutionPointDepartIndemnisationGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Damj m_pji;
  
  public ConstitutionPointDepartIndemnisationGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionPointDepartIndemnisationGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected Damj rawGetPji()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPjiConstitutionPointDepartIndemnisation();
  }
  
  public Damj getPji()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPjiConstitutionPointDepartIndemnisation();
  }
  
  public void setPji(Damj p_pji)
  {
    if ((m_pji == null) || (p_pji == null))
    {
      m_pji = p_pji;
      ((ConstitutionElementsAbstraitPC)getPC()).setPjiConstitutionPointDepartIndemnisation(p_pji);
    }
    else if ((m_pji != null) && (p_pji != null) && (!p_pji.equals(m_pji)))
    {
      m_pji = p_pji;
      ((ConstitutionElementsAbstraitPC)getPC()).setPjiConstitutionPointDepartIndemnisation(p_pji);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setPji(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionPointDepartIndemnisationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */