package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.ProduitAsuCaa14P01;
import fr.unedic.cali.dom.affectation.ProduitAsuCve13P01;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class DeterminationSituationParticuliere
{
  public static String getSituationParticuliere(AttributionAssuranceSpec od)
  {
    String situation = "";
    DemandeAssuranceSpec demandeAssurance = (DemandeAssuranceSpec)od.getDemande();
    ActiviteSalarie sinistre = od.getFaitGenerateur().getPeriodeFaitGenerateur();
    boolean casCSP = false;
    Damj dateEngagementProcedure = null;
    if (sinistre != null)
    {
      dateEngagementProcedure = sinistre.getDateEngagementProcedureLicenciement();
      if (dateEngagementProcedure == null) {
        dateEngagementProcedure = sinistre.getDateFin();
      }
      casCSP = dateEngagementProcedure.estApres(ProduitAsuCaa14P01.getInstance().getPeriodeValidite().getFin());
    }
    String topContrib = demandeAssurance.getTopContribution();
    if ((sinistre != null) && (sinistre.getCodeMotifFin() == 47)) {
      situation = getSituationNonPropositionPap(demandeAssurance);
    } else if ("N".equals(topContrib)) {
      situation = getSituationNonPropositionCrpCsp(casCSP);
    } else if ("T".equals(topContrib)) {
      situation = getSituationNonPropositionCtp(od, sinistre, dateEngagementProcedure);
    }
    return situation;
  }
  
  private static String getSituationNonPropositionCtp(AttributionAssuranceSpec od, ActiviteSalarie sinistre, Damj dateEngagementProcedure)
  {
    String situation = "";
    if (sinistre != null)
    {
      situation = "";
      if (dateEngagementProcedure.estAvantOuCoincideAvec(ProduitAsuCve13P01.getInstance().getPeriodeValidite().getFin()))
      {
        int etatCrpCtp = od.getBassinEmploi();
        if (1 == etatCrpCtp) {
          situation = "6";
        } else if (2 == etatCrpCtp) {
          situation = "7";
        }
      }
    }
    return situation;
  }
  
  private static String getSituationNonPropositionCrpCsp(boolean casCSP)
  {
    String situation;
    String situation;
    if (casCSP) {
      situation = "8";
    } else {
      situation = "5";
    }
    return situation;
  }
  
  private static String getSituationNonPropositionPap(DemandeAssuranceSpec demandeAssurance)
  {
    Boolean propositionPAP = demandeAssurance.estTopPropositionPAP();
    String situation;
    String situation;
    if ((propositionPAP == null) || (propositionPAP.booleanValue())) {
      situation = "";
    } else {
      situation = "A";
    }
    return situation;
  }
}

/* Location:
 * Qualified Name:     DeterminationSituationParticuliere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */