package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.asr;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.produits.liquidation.dom.ResultatConditionRechercheEmploi;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public abstract class RechercheConditionRechercheEmploi
  extends fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionRechercheEmploi
{
  private static final String TYPE_PEC_1 = "1";
  private static final String TYPE_PEC_2 = "2";
  private static final String SOUS_TYPE_PEC_6 = "6";
  
  public ResultatConditionRechercheEmploi rechercherConditionRechercheEmploi(Demande demande)
    throws CoucheLogiqueException
  {
    ResultatConditionRechercheEmploi resultatConditionRechercheEmploi = new ResultatConditionRechercheEmploi();
    ResultatElementDroit resultatElementDroit = new ResultatElementDroit();
    resultatConditionRechercheEmploi.setResultatElementDroit(resultatElementDroit);
    resultatElementDroit.setEtatSatisfait(true);
    
    ObjetChronoPeriodePriseEnCharge periodePEC = trouverPecIndemnisable(demande.getDemandeur(), demande.getDateExamen());
    
    boolean estDemandeRechargement = "ASU_29".equals(demande.getEvenementReferenceExamen().getTypeExamen());
    
    controlerExistancePec(periodePEC, resultatConditionRechercheEmploi, estDemandeRechargement);
    
    controlerCoherencePec(periodePEC, demande, resultatConditionRechercheEmploi);
    if (!controleTypePec(periodePEC)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ERR_INSCRIP_DEMANDEUR_NON_VALIDE");
    }
    return resultatConditionRechercheEmploi;
  }
  
  protected boolean controleTypePec(ObjetChronoPeriodePriseEnCharge periodePEC)
  {
    return (testTypePecClassique(periodePEC)) || (testTypePecFormation(periodePEC));
  }
  
  protected boolean testTypePecClassique(ObjetChronoPeriodePriseEnCharge periodePEC)
  {
    return ("1".equals(periodePEC.getTypePec())) && ("6".equals(periodePEC.getSousType()));
  }
  
  protected boolean testTypePecFormation(ObjetChronoPeriodePriseEnCharge periodePEC)
  {
    return ("2".equals(periodePEC.getTypePec())) && ("6".equals(periodePEC.getSousType()));
  }
  
  protected ObjetChronoPeriodePriseEnCharge trouverPecIndemnisable(IndividuSpec individu, Damj dateRecherche)
  {
    return OutillagePEC.getPeriodePECIndemnisableContenant(individu, dateRecherche);
  }
}

/* Location:
 * Qualified Name:     RechercheConditionRechercheEmploi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */