package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.spec.StrategieMotifRejetSPSpec;
import fr.unedic.cali.dom.ClassementCompetenceSecteurPublic;
import fr.unedic.cali.dom.ObjetAlertesNonBloquantes;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;

public class StrategieMotifRejetSPApres
  implements StrategieMotifRejetSPSpec
{
  public void verifierMotifRejetSP(int motifNotification)
    throws CoucheLogiqueException
  {
    if ((motifNotification == 4) || (motifNotification == 5)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_REJET_B15_B16");
    }
  }
  
  public void verifierAlerteNonBloquanteMotifRejetSP(Demande demande)
  {
    if ((demande.getClassementAdministratif() instanceof ClassementCompetenceSecteurPublic))
    {
      ClassementCompetenceSecteurPublic classement = (ClassementCompetenceSecteurPublic)demande.getClassementAdministratif();
      int motifNotification = classement.getMotifNotification();
      if ((motifNotification == 1) || (motifNotification == 2) || (motifNotification == 3) || (motifNotification == 6))
      {
        Collection<ObjetAlertesNonBloquantes> listePeriodes = new ArrayList();
        
        ObjetAlertesNonBloquantes objetAlerteNonBloquante = new ObjetAlertesNonBloquantes(Damj.NUIT_DES_TEMPS, Damj.FIN_DES_TEMPS, 999);
        
        listePeriodes.add(objetAlerteNonBloquante);
        demande.getAlertesNonBloquantes().put("ERR_PR_CALI_P_ALERTE_SORTIE_CSP", listePeriodes);
      }
    }
  }
}

/* Location:
 * Qualified Name:     StrategieMotifRejetSPApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */