package fr.unedic.cali.asu.produits.liquidation.parametres;

import fr.unedic.cali.asu.parametres.CleAcces;
import fr.unedic.util.temps.Damj;

public class CleAccesPRA
  implements CleAcces
{
  public static final int[] CODE_AGE_SANS_OBJET = null;
  public static final int DONNEE_SANS_OBJET = -1;
  public static final String TOUT_TYPE = "";
  private String m_nomReglement = null;
  private int[] m_codeAge = CODE_AGE_SANS_OBJET;
  private int m_codeNombreTrimestres = -1;
  private Damj m_dateRecherche;
  private String m_contexte = "AUCUN";
  
  public String getContexte()
  {
    return m_contexte;
  }
  
  public void setContexte(String p_contexte)
  {
    m_contexte = (p_contexte != null ? p_contexte : "AUCUN");
  }
  
  private CleAccesPRA() {}
  
  public CleAccesPRA(String p_nomReglement)
  {
    m_nomReglement = p_nomReglement;
  }
  
  public CleAccesPRA(String p_nomReglement, int[] p_codeAge, String p_contexte)
  {
    m_nomReglement = p_nomReglement;
    m_codeAge = p_codeAge;
    m_contexte = (p_contexte != null ? p_contexte : "AUCUN");
  }
  
  public CleAccesPRA(String p_nomReglement, int[] p_codeAge)
  {
    m_nomReglement = p_nomReglement;
    m_codeAge = p_codeAge;
  }
  
  public CleAccesPRA(String p_nomReglement, int[] p_codeAge, int p_codeNombreTrimestres, String p_contexte)
  {
    m_nomReglement = p_nomReglement;
    m_codeAge = p_codeAge;
    m_codeNombreTrimestres = p_codeNombreTrimestres;
    m_contexte = (p_contexte != null ? p_contexte : "AUCUN");
  }
  
  public CleAccesPRA(String p_nomReglement, int[] p_codeAge, Damj p_dateRecherche)
  {
    m_nomReglement = p_nomReglement;
    m_codeAge = p_codeAge;
    m_dateRecherche = p_dateRecherche;
  }
  
  public CleAccesPRA(String p_nomReglement, int[] p_codeAge, int p_codeNombreTrimestres)
  {
    m_nomReglement = p_nomReglement;
    m_codeAge = p_codeAge;
    m_codeNombreTrimestres = p_codeNombreTrimestres;
  }
  
  public int[] getCodeAge()
  {
    return m_codeAge;
  }
  
  public void setCodeAge(int[] p_codeAge)
  {
    m_codeAge = p_codeAge;
  }
  
  public String getNomReglement()
  {
    return m_nomReglement;
  }
  
  public void setNomReglement(String p_nomReglement)
  {
    m_nomReglement = p_nomReglement;
  }
  
  public int getCodeNombreTrimestres()
  {
    return m_codeNombreTrimestres;
  }
  
  public void setCodeNombreTrimestres(int p_centTrimestres)
  {
    m_codeNombreTrimestres = p_centTrimestres;
  }
  
  public boolean equals(Object p_arg0)
  {
    if ((p_arg0 instanceof CleAccesPRA))
    {
      CleAccesPRA cleCandidate = (CleAccesPRA)p_arg0;
      if (!cleCandidate.getNomReglement().equals(getNomReglement())) {
        return false;
      }
      int[] codeAge = getCodeAge();
      if (codeAge != CODE_AGE_SANS_OBJET)
      {
        boolean estContenu = false;
        int codeAgeCandidat = cleCandidate.getCodeAge()[0];
        for (int i = 0; i < codeAge.length; i++)
        {
          int code = codeAge[i];
          if (code == codeAgeCandidat) {
            estContenu = true;
          }
        }
        if (!estContenu) {
          return false;
        }
      }
      if ((getCodeNombreTrimestres() != -1) && (cleCandidate.getCodeNombreTrimestres() != getCodeNombreTrimestres())) {
        return false;
      }
      if ((cleCandidate.getContexte() != null) && (!cleCandidate.getContexte().equals(getContexte()))) {
        return false;
      }
      return true;
    }
    return false;
  }
  
  public Damj getDateRecherche()
  {
    return m_dateRecherche;
  }
  
  public void setDateRecherche(Damj p_dateRecherche)
  {
    m_dateRecherche = p_dateRecherche;
  }
}

/* Location:
 * Qualified Name:     CleAccesPRA
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */