package fr.unedic.cali.asu.produits.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionsAttributionReprise;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateAttribution;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttributionReprise
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEP14 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    ConstitutionDateAttribution constitutionDate = dossierExamenCourant.getConstitutionElementsActifs().createConstitutionDateAttribution();
    if (verifierPreconditions(p_contexte))
    {
      Damj dateAttribution = DeterminationDateAttribution.getInstance().determinerDateAttributionTheoriquePourReprise(demande);
      
      constitutionDate.setDateAttribution(dateAttribution);
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCEP14;
  }
  
  protected boolean verifierPreconditions(Contexte p_contexte)
  {
    boolean preconditionsValides = true;
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    if ((dossierExamenCourant.getConditionsAttributionReprise() != null) && (dossierExamenCourant.getConditionsAttributionReprise().estSatisfait())) {
      preconditionsValides = true;
    } else {
      preconditionsValides = false;
    }
    return preconditionsValides;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttributionReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */