package fr.unedic.cali.asu.produits.liquidation.parcours;

import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionMontantNonNul;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConditionsAttributionSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionMontantNonNul;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.util.Collection;

public class DeterminationConditionMontantProduitNonNul
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    Resultat resultatCapa18 = new Resultat(0);
    
    ResultatElementDroit resultatElementDroit = RechercheConditionMontantNonNul.getInstance().rechercherConditionMontantNonNul(demandeCourante);
    
    ConditionMontantNonNul conditionMontantNonNul = ((DossierExamen)demandeCourante.getDossierExamen()).getConditionsAttributionActives().createConditionMontantNonNul();
    conditionMontantNonNul.setEtat(resultatElementDroit.getEtat());
    conditionMontantNonNul.setCodeMotifEchec(resultatElementDroit.getCodeMotifEchec());
    if (conditionMontantNonNul.estSatisfait())
    {
      resultatCapa18.setEtat(0);
    }
    else
    {
      ProduitAsuSpec produit = (ProduitAsuSpec)demandeCourante.getDossierAffectation().getProduit();
      if (produit.estProduitGerantPensionInvalidite(demandeCourante))
      {
        Attribution attribution = (Attribution)demandeCourante.getDossierExamen();
        if (((attribution.getListePensionInvalidite() == null) || (attribution.getListePensionInvalidite().size() == 0)) && ((demandeCourante.getDemandeur().getChronoPensionsInvaliditeChainees() == null) || (demandeCourante.getDemandeur().getChronoPensionsInvaliditeChainees().estVide()))) {
          fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_CAPA_MONTANT_NON_NUL_CAUSE_PI");
        }
      }
      else if ((demandeCourante.getDemandeur().getChronoPensionsInvaliditeEtAvantagesVieillesse() == null) || (demandeCourante.getDemandeur().getChronoPensionsInvaliditeEtAvantagesVieillesse().estVide()))
      {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_CAPA_MONTANT_NON_NUL_CAUSE_PI");
      }
      resultatCapa18.setEtat(1);
      resultatCapa18.setMessageErreur(Integer.toString(conditionMontantNonNul.getCodeMotifEchec()));
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCapa18;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionMontantProduitNonNul
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */