package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.dom.AccesseurDroitsSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Damj;

public class AccesseurDroits
  implements AccesseurDroitsSpec
{
  private DossierExamen dossierExamen;
  
  public AccesseurDroits(DossierExamen pDossierExamen)
  {
    dossierExamen = pDossierExamen;
  }
  
  public Damj getDateEffetSjr()
  {
    return dossierExamen.getConstitutionSalaireJournalierMoyen().getDateSalaireJournalierMoyenInitial();
  }
  
  public Damj getDateFinDiffere()
  {
    return dossierExamen.getConstitutionElementsActifs().getConstitutionDelaisReport().getTermeDelaiReport();
  }
  
  public Quantite getDureeIndemnisationInitiale()
  {
    return dossierExamen.getConstitutionElementsActifs().getConstitutionDurees().getDureeEffective();
  }
  
  public Quantite getDureeIndemnisationTheorique()
  {
    ConstitutionDurees constitutionDuree = dossierExamen.getConstitutionElementsActifs().getConstitutionDurees();
    Quantite dureeTheorique = null;
    if (constitutionDuree != null) {
      dureeTheorique = constitutionDuree.getDureeTheorique();
    }
    return dureeTheorique;
  }
  
  public QuantiteEuro getMontantBrutJournalier()
  {
    return dossierExamen.getConstitutionElementsActifs().getConstitutionMontantsBruts().getMontantJournalierBrut();
  }
  
  public QuantiteEuro getSjrInitial()
  {
    return dossierExamen.getConstitutionSalaireJournalierMoyen().getMontantSalaireJournalierMoyenInitial();
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public String getContexteParticulierSjr()
  {
    return null;
  }
  
  public Quantite getDureeProlongation()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     AccesseurDroits
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */