package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.CarenceIslrGen;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import org.apache.commons.lang.builder.EqualsBuilder;

public class CarenceIslr
  extends CarenceIslrGen
{
  private transient boolean m_presenceTransaction = false;
  private transient boolean m_presenceAutreIndemnite;
  
  public CarenceIslr(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public CarenceIslr() {}
  
  public ObjetMetierSpec copie()
  {
    CarenceIslr copie = new CarenceIslr();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    CarenceIslr copie = (CarenceIslr)p_copie;
    super.copieElements(copie);
  }
  
  public String getTypeCarence()
  {
    return "3";
  }
  
  public boolean estIdentiqueA(CarencePrefixeAFixer p_carence)
  {
    if ((p_carence == null) || (!(p_carence instanceof CarenceIslr))) {
      return false;
    }
    CarenceIslr aComparer = (CarenceIslr)p_carence;
    
    EqualsBuilder eqb = new EqualsBuilder();
    return eqb.append(getPeriodeApplicationCarence().getDebut(), aComparer.getPeriodeApplicationCarence().getDebut()).append(getPeriodeApplicationCarence().getFin(), aComparer.getPeriodeApplicationCarence().getFin()).append(getQuantiteInitiale(), aComparer.getQuantiteInitiale()).append(getIdentifiantPeriodeOrigine(), aComparer.getIdentifiantPeriodeOrigine()).isEquals();
  }
  
  public boolean isPresenceAutreIndemnite()
  {
    return m_presenceAutreIndemnite;
  }
  
  public void setPresenceAutreIndemnite(boolean p_presenceAutreIndemnite)
  {
    m_presenceAutreIndemnite = p_presenceAutreIndemnite;
  }
  
  public boolean isPresenceTransaction()
  {
    return m_presenceTransaction;
  }
  
  public void setPresenceTransaction(boolean p_presenceTransaction)
  {
    m_presenceTransaction = p_presenceTransaction;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     CarenceIslr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */