package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.CarenceStandardGen;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import org.apache.commons.lang.builder.EqualsBuilder;

public class CarenceStandard
  extends CarenceStandardGen
{
  public CarenceStandard(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public CarenceStandard() {}
  
  public ObjetMetierSpec copie()
  {
    CarenceStandard copie = new CarenceStandard();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    CarenceStandard copie = (CarenceStandard)p_copie;
    super.copieElements(copie);
  }
  
  public String getTypeCarence()
  {
    return "4";
  }
  
  public boolean estIdentiqueA(CarencePrefixeAFixer p_carence)
  {
    if ((p_carence == null) || (!(p_carence instanceof CarenceStandard))) {
      return false;
    }
    CarenceStandard aComparer = (CarenceStandard)p_carence;
    
    EqualsBuilder eqb = new EqualsBuilder();
    return eqb.append(getPeriodeApplicationCarence().getDebut(), aComparer.getPeriodeApplicationCarence().getDebut()).append(getPeriodeApplicationCarence().getFin(), aComparer.getPeriodeApplicationCarence().getFin()).append(getQuantiteInitiale(), aComparer.getQuantiteInitiale()).append(getIdentifiantPeriodeOrigine(), aComparer.getIdentifiantPeriodeOrigine()).isEquals();
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     CarenceStandard
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */