package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import java.util.List;

public class FabriqueObjectifExamen
  implements FabriqueObjectifExamenSpec
{
  private static FabriqueObjectifExamenSpec instanceUnique = null;
  
  public ObjectifExamen creerObjectif(int sousType, List<ContexteDemandeSpec> contexteDemande)
  {
    ObjectifExamen objectif = null;
    switch (sousType)
    {
    case 10: 
    case 11: 
    case 12: 
    case 26: 
      objectif = creerObjectifAdmission(contexteDemande);
      break;
    case 13: 
    case 14: 
    case 15: 
    case 27: 
    case 34: 
    case 50: 
      objectif = creerObjectifReprise(contexteDemande);
      break;
    default: 
      throw new UnsupportedOperationException("FabriqueObjectifExamen : le sous-type " + sousType + " est inconnu.");
    }
    objectif.setSousType(sousType);
    return objectif;
  }
  
  protected ObjectifExamen creerObjectifAdmission(List<ContexteDemandeSpec> contexteDemande)
  {
    return new ObjectifExamenAdmission(contexteDemande);
  }
  
  protected ObjectifExamen creerObjectifReprise(List<ContexteDemandeSpec> contexteDemande)
  {
    return new ObjectifExamenReprise(contexteDemande);
  }
  
  public static FabriqueObjectifExamenSpec getInstance()
  {
    if (instanceUnique == null) {
      instanceUnique = new FabriqueObjectifExamen();
    }
    return instanceUnique;
  }
}

/* Location:
 * Qualified Name:     FabriqueObjectifExamen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */