package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.JustificationDiffereGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.util.Collection;
import java.util.Iterator;

public class JustificationDiffere
  extends JustificationDiffereGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = 3904481994483537804L;
  
  public JustificationDiffere() {}
  
  public JustificationDiffere(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationDiffere copie = new JustificationDiffere();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    JustificationDiffere copie = (JustificationDiffere)pCopie;
    super.copieElements(copie);
    copie.setTotalSalairesNonPlafonnes(getTotalSalairesNonPlafonnes());
    copie.setSmicMensuel(getSmicMensuel());
    copie.setSmicJournalier(getSmicJournalier());
    copie.setFormule(super.getFormule());
    Iterator<?> iter = getCollectionPeriodeRetenue().iterator();
    while (iter.hasNext())
    {
      PeriodeRetenue periodeRetenueACloner = (PeriodeRetenue)iter.next();
      if (periodeRetenueACloner != null)
      {
        PeriodeRetenue periodeRetenueClone = (PeriodeRetenue)periodeRetenueACloner.copie();
        copie.ajouterPeriodeRetenue(periodeRetenueClone);
      }
    }
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(getCollectionPeriodeRetenue());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public void remplacerCollectionPeriodeRetenue(Collection collectionACopier)
  {
    for (Iterator<?> iter = super.getCollectionPeriodeRetenue().iterator(); iter.hasNext();)
    {
      PeriodeRetenue element = (PeriodeRetenue)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeRetenue(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     JustificationDiffere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */