package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.JustificationReductionSalaireMoisCivilGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.Collection;
import java.util.Iterator;

public class JustificationReductionSalaireMoisCivil
  extends JustificationReductionSalaireMoisCivilGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -295709592677132209L;
  
  public JustificationReductionSalaireMoisCivil() {}
  
  public JustificationReductionSalaireMoisCivil(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationReductionSalaireMoisCivil copie = new JustificationReductionSalaireMoisCivil();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    JustificationReductionSalaireMoisCivil copie = (JustificationReductionSalaireMoisCivil)pCopie;
    super.copieElements(copie);
    copie.setPeriode(getPeriode() != null ? new Periode(getPeriode().getDebut(), getPeriode().getFin()) : null);
    
    Iterator iter = getCollectionPeriodeActiviteSurMois().iterator();
    while (iter.hasNext())
    {
      JustificationReductionSalairePeriodeActiviteSurMois periodeActiviteACloner = (JustificationReductionSalairePeriodeActiviteSurMois)iter.next();
      if (periodeActiviteACloner != null)
      {
        JustificationReductionSalairePeriodeActiviteSurMois periodeActiviteClone = (JustificationReductionSalairePeriodeActiviteSurMois)periodeActiviteACloner.copie();
        
        copie.ajouterPeriodeActiviteSurMois(periodeActiviteClone);
      }
    }
    copie.setCoefficientEcretementHeures(getCoefficientEcretementHeures());
    copie.setTotalHeures(getTotalHeures());
    copie.setMontantPlafondCachets(getMontantPlafondCachets());
    copie.setCoefficientEcretementCachets(getCoefficientEcretementCachets());
    copie.setTotalCachets(getTotalCachets());
    copie.setMontantPlafondHeures(getMontantPlafondHeures());
    copie.setHeuresMulti(getHeuresMulti());
    copie.setPlafondMulti(getPlafondMulti());
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(getCollectionPeriodeActiviteSurMois());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public void remplacerCollectionPeriodeActiviteSurMois(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionPeriodeActiviteSurMois().iterator(); iter.hasNext();)
    {
      JustificationReductionSalairePeriodeActiviteSurMois element = (JustificationReductionSalairePeriodeActiviteSurMois)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeActiviteSurMois(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     JustificationReductionSalaireMoisCivil
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */