package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.JustificationSalaireReferenceGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.util.Collection;
import java.util.Iterator;

public class JustificationSalaireReference
  extends JustificationSalaireReferenceGen
  implements ObjetPersistantSpec
{
  public JustificationSalaireReference() {}
  
  public JustificationSalaireReference(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationSalaireReference copie = new JustificationSalaireReference();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationSalaireReference copie = (JustificationSalaireReference)p_copie;
    super.copieElements(copie);
    Iterator iter = getCollectionPeriodeActivite().iterator();
    while (iter.hasNext())
    {
      JustificationSRPeriodeActivite periodeActiviteACloner = (JustificationSRPeriodeActivite)iter.next();
      if (periodeActiviteACloner != null)
      {
        JustificationSRPeriodeActivite periodeActiviteClone = (JustificationSRPeriodeActivite)periodeActiviteACloner.copie();
        
        copie.ajouterPeriodeActivite(periodeActiviteClone);
      }
    }
    copie.setMontantTotalSalairesRetenus(getMontantTotalSalairesRetenus());
    copie.setMontantTotalPrimesNormalesRetenues(getMontantTotalPrimesNormalesRetenues());
    copie.setMontantTotalPrimesExceptionnellesRetenues(getMontantTotalPrimesExceptionnellesRetenues());
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(getCollectionPeriodeActivite());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public void remplacerCollectionPeriodeActivite(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionPeriodeActivite().iterator(); iter.hasNext();)
    {
      JustificationSRPeriodeActivite element = (JustificationSRPeriodeActivite)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeActivite(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     JustificationSalaireReference
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */