package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.MoisCivilGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.util.Collection;
import java.util.Iterator;

public class MoisCivil
  extends MoisCivilGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -590648986835435323L;
  
  public MoisCivil() {}
  
  public MoisCivil(DomPCSpec pc)
  {
    super(pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getCollectionPeriodeSurMoisCivil());
  }
  
  public ObjetMetierSpec copie()
  {
    MoisCivil copie = new MoisCivil();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    MoisCivil copie = (MoisCivil)pCopie;
    copie.setNbJoursRetenus(super.getNbJoursRetenus());
    copie.setNbJoursTravailles(super.getNbJoursTravailles());
    copie.setPeriode(super.getPeriode());
    if (super.getCollectionPeriodeSurMoisCivil() != null)
    {
      Iterator<?> it = super.getCollectionPeriodeSurMoisCivil().iterator();
      while (it.hasNext())
      {
        PeriodeSurMoisCivil mois = (PeriodeSurMoisCivil)it.next();
        if (mois != null) {
          copie.ajouterPeriodeSurMoisCivil((PeriodeSurMoisCivil)mois.copie());
        }
      }
    }
  }
  
  public void remplacerCollectionPeriodeSurMoisCivil(Collection collectionACopier)
  {
    for (Iterator<?> iter = super.getCollectionPeriodeSurMoisCivil().iterator(); iter.hasNext();)
    {
      PeriodeSurMoisCivil element = (PeriodeSurMoisCivil)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeSurMoisCivil(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     MoisCivil
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */