package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.AffiliationSupplementairePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class AffiliationSupplementaireGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_affiliationSupplementairePC;
  private Quantite m_quantite;
  
  public AffiliationSupplementaireGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public AffiliationSupplementaireGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new AffiliationSupplementairePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_affiliationSupplementairePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_affiliationSupplementairePC)
  {
    m_affiliationSupplementairePC = p_affiliationSupplementairePC;
  }
  
  protected int rawGetNature()
  {
    return ((AffiliationSupplementairePC)getPC()).getNature();
  }
  
  public int getNature()
  {
    return ((AffiliationSupplementairePC)getPC()).getNature();
  }
  
  public void setNature(int p_nature)
  {
    ((AffiliationSupplementairePC)getPC()).setNature(p_nature);
  }
  
  protected Quantite rawGetQuantite()
  {
    return ((AffiliationSupplementairePC)getPC()).getQuantite();
  }
  
  public Quantite getQuantite()
  {
    return ((AffiliationSupplementairePC)getPC()).getQuantite();
  }
  
  public void setQuantite(Quantite p_quantite)
  {
    if ((m_quantite == null) || (p_quantite == null))
    {
      m_quantite = p_quantite;
      ((AffiliationSupplementairePC)getPC()).setQuantite(p_quantite);
    }
    else if ((m_quantite != null) && (p_quantite != null) && (!p_quantite.equals(m_quantite)))
    {
      m_quantite = p_quantite;
      ((AffiliationSupplementairePC)getPC()).setQuantite(p_quantite);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     AffiliationSupplementaireGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */