package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.PeriodeSurMoisCivilPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;

public abstract class PeriodeSurMoisCivilGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_periodeSurMoisCivilPC;
  private String m_raisonSociale;
  private Periode m_periode;
  
  public PeriodeSurMoisCivilGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public PeriodeSurMoisCivilGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new PeriodeSurMoisCivilPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_periodeSurMoisCivilPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_periodeSurMoisCivilPC)
  {
    m_periodeSurMoisCivilPC = p_periodeSurMoisCivilPC;
  }
  
  protected String rawGetRaisonSociale()
  {
    return ((PeriodeSurMoisCivilPC)getPC()).getRaisonSociale();
  }
  
  public String getRaisonSociale()
  {
    return ((PeriodeSurMoisCivilPC)getPC()).getRaisonSociale();
  }
  
  public void setRaisonSociale(String p_raisonSociale)
  {
    if ((m_raisonSociale == null) || (p_raisonSociale == null))
    {
      m_raisonSociale = p_raisonSociale;
      ((PeriodeSurMoisCivilPC)getPC()).setRaisonSociale(p_raisonSociale);
    }
    else if ((m_raisonSociale != null) && (p_raisonSociale != null) && (!p_raisonSociale.equals(m_raisonSociale)))
    {
      m_raisonSociale = p_raisonSociale;
      ((PeriodeSurMoisCivilPC)getPC()).setRaisonSociale(p_raisonSociale);
    }
  }
  
  protected Periode rawGetPeriode()
  {
    return ((PeriodeSurMoisCivilPC)getPC()).getPeriode();
  }
  
  public Periode getPeriode()
  {
    return ((PeriodeSurMoisCivilPC)getPC()).getPeriode();
  }
  
  public void setPeriode(Periode p_periode)
  {
    if ((m_periode == null) || (p_periode == null))
    {
      m_periode = p_periode;
      ((PeriodeSurMoisCivilPC)getPC()).setPeriode(p_periode);
    }
    else if ((m_periode != null) && (p_periode != null) && (!p_periode.equals(m_periode)))
    {
      m_periode = p_periode;
      ((PeriodeSurMoisCivilPC)getPC()).setPeriode(p_periode);
    }
  }
  
  protected int rawGetJoursTravailles()
  {
    return ((PeriodeSurMoisCivilPC)getPC()).getJoursTravailles();
  }
  
  public int getJoursTravailles()
  {
    return ((PeriodeSurMoisCivilPC)getPC()).getJoursTravailles();
  }
  
  public void setJoursTravailles(int p_joursTravailles)
  {
    ((PeriodeSurMoisCivilPC)getPC()).setJoursTravailles(p_joursTravailles);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     PeriodeSurMoisCivilGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */