package fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.spec;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.dom.ComportementCalculAffiliation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.Convertisseur;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.List;

public abstract interface ComportementAffiliationSpec
  extends fr.unedic.cali.dom.spec.ComportementAffiliationSpec
{
  public abstract void setCalculTouteAffiliation(boolean paramBoolean);
  
  public abstract void setCalculAffiliationAssimilable(boolean paramBoolean);
  
  public abstract void setCalculAffiliationSupplementaire(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationDeBase();
  
  public abstract void setCalculAffiliationDeBase(boolean paramBoolean);
  
  public abstract List getListeReglementPrisEnCompte();
  
  public abstract void setListeReglementPrisEnCompte(List paramList);
  
  public abstract Periode getPeriodeRecherche();
  
  public abstract void setPeriodeRecherche(Periode paramPeriode);
  
  public abstract void copie(ComportementCalculAffiliation paramComportementCalculAffiliation);
  
  public abstract Chronologie getChronologieActivitesParticipantes();
  
  public abstract void setChronologieActivitesParticipantes(Chronologie paramChronologie);
  
  public abstract Reglement getReglementCandidat();
  
  public abstract void setReglementCandidat(Reglement paramReglement);
  
  public abstract Quantite getQuantiteAffiliationRequise();
  
  public abstract void setQuantiteAffiliationRequise(Quantite paramQuantite);
  
  public abstract ObjetChronoPeriode getFaitGenerateur();
  
  public abstract void setFaitGenerateur(ObjetChronoPeriode paramObjetChronoPeriode);
  
  public abstract boolean estEnseignementApplicablePourReglement(Reglement paramReglement);
  
  public abstract boolean isCalculAffiliationAssimilableEnseignement();
  
  public abstract void setCalculAffiliationAssimilableEnseignement(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationAssimilableFormation();
  
  public abstract void setCalculAffiliationAssimilableFormation(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationAssimilableMaterniteAdoptionAccidentTravail();
  
  public abstract void setCalculAffiliationAssimilableMaterniteAdoptionAccidentTravail(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationSupplementaireNonExecution();
  
  public abstract void setCalculAffiliationSupplementaireNonExecution(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationSupplementaireSuspension();
  
  public abstract void setCalculAffiliationSupplementaireSuspension(boolean paramBoolean);
  
  public abstract boolean isJustifierPeriodesSansAffiliation();
  
  public abstract void setJustifierPeriodesSansAffiliation(boolean paramBoolean);
  
  public abstract CalculAffiliationBaseSpec getOutilCalculAffiliationBase();
  
  public abstract void setOutilCalculAffiliationBase(CalculAffiliationBaseSpec paramCalculAffiliationBaseSpec);
  
  public abstract CalculAffiliationSupplementaireSpec getOutilCalculAffiliationSupplementaire();
  
  public abstract void setOutilCalculAffiliationSupplementaire(CalculAffiliationSupplementaireSpec paramCalculAffiliationSupplementaireSpec);
  
  public abstract CalculAssimilationSpec getOutilCalculAssimilation();
  
  public abstract void setOutilCalculAssimilation(CalculAssimilationSpec paramCalculAssimilationSpec);
  
  public abstract ConstructionChronologieSpec getOutilConstructionChronologie();
  
  public abstract void setOutilConstructionChronologie(ConstructionChronologieSpec paramConstructionChronologieSpec);
  
  public abstract JustifierAffiliationSpec getOutilJustifierAffiliation();
  
  public abstract void setOutilJustifierAffiliation(JustifierAffiliationSpec paramJustifierAffiliationSpec);
  
  public abstract ParametresAffiliationSpec getOutilParametreAffiliation();
  
  public abstract void setOutilParametreAffiliation(ParametresAffiliationSpec paramParametresAffiliationSpec);
  
  public abstract boolean isCalculAffiliationAssimilableMaladie();
  
  public abstract void setCalculAffiliationAssimilableMaladie(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationSupplementaireMaterniteAdoptionAccidentTravail();
  
  public abstract void setCalculAffiliationSupplementaireMaterniteAdoptionAccidentTravail(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationSupplementaireMaladieGrave();
  
  public abstract void setCalculAffiliationSupplementaireMaladieGrave(boolean paramBoolean);
  
  public abstract boolean isCalculAffiliationSupplementaireMaladieLongueDuree();
  
  public abstract void setCalculAffiliationSupplementaireMaladieLongueDuree(boolean paramBoolean);
  
  public abstract void setDateExamen(Damj paramDamj);
  
  public abstract Damj getDateExamen();
  
  public abstract Convertisseur getConvertisseurUniteAffiliation();
  
  public abstract void setConvertisseurUniteAffiliation(Convertisseur paramConvertisseur);
  
  public abstract Demande getDemande();
  
  public abstract void setDemande(Demande paramDemande);
  
  public abstract boolean estActiviteAPrendreEnComptePourEnseignement(ActiviteSalarie paramActiviteSalarie);
  
  public abstract void setEstPrimo(boolean paramBoolean);
  
  public abstract boolean estUnPrimo();
}

/* Location:
 * Qualified Name:     ComportementAffiliationSpec
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */