package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.liquidation.outilsfonctionnels.RechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionChomageInvolontaire;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.util.services.CoucheLogiqueException;

public class RechercheConditionChomageInvolontaireDemandeExamenCpSuiteDv
  implements RechercheConditionChomageInvolontaireSpec
{
  public ConditionChomageInvolontaire rechercherConditionChomageInvolontaire(Demande p_demande)
    throws CoucheLogiqueException
  {
    ConditionChomageInvolontaire conditionChomageInvolontaire = ((DossierExamen)p_demande.getDossierExamen()).getConditionsAttributionActives().createConditionChomageInvolontaire();
    if (p_demande.getDonneesTemporaires().estAvisFavorableCommissionParitaire())
    {
      conditionChomageInvolontaire.setEtatSatisfait(true);
    }
    else if (p_demande.getDonneesTemporaires().estAvisDefavorableCommissionParitaire())
    {
      conditionChomageInvolontaire.setEtatSatisfait(false);
      conditionChomageInvolontaire.setCodeMotifEchec(93);
    }
    else
    {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A11MB5");
    }
    RechercheConditionChomageInvolontaire.getInstance().leverAlerteA11MB26(p_demande);
    return conditionChomageInvolontaire;
  }
  
  public ConditionChomageInvolontaire rechercherConditionChomageInvolontairePourReprise(Demande p_demande)
    throws CoucheLogiqueException
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée...");
  }
}

/* Location:
 * Qualified Name:     RechercheConditionChomageInvolontaireDemandeExamenCpSuiteDv
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */