package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.DelaiRechercheProduit;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;

public class RechercheConditionFaitGenerateurDemandeIDE
  extends RechercheConditionFaitGenerateurDemandeClassique
{
  protected DelaiRechercheProduit determinerDelaiValiditeFaitGenerateur(Demande p_demande, DelaiRechercheProduit p_delaiForclusion)
  {
    DelaiRechercheProduit delaiValiditeFgd = (DelaiRechercheProduit)p_delaiForclusion.copie();
    
    Chronologie chronoPeriodesPecIndemnisablesPrecedentes = OutillagePEC.getPeriodesPecFinAvantOuCoincideAvecDate(p_demande.getDemandeur(), p_demande.getDateExamen());
    if ((chronoPeriodesPecIndemnisablesPrecedentes != null) && (!chronoPeriodesPecIndemnisablesPrecedentes.estVide()))
    {
      ObjetChronoPeriodePriseEnCharge objetChronoPecPrecedente = (ObjetChronoPeriodePriseEnCharge)chronoPeriodesPecIndemnisablesPrecedentes.dernierElement();
      if (delaiValiditeFgd.getDebut().estAvant(objetChronoPecPrecedente.getDateFin()))
      {
        delaiValiditeFgd.setDebut(objetChronoPecPrecedente.getDateFin());
        if (delaiValiditeFgd.getDebut().estApres(delaiValiditeFgd.getFin())) {
          delaiValiditeFgd = null;
        }
      }
    }
    return delaiValiditeFgd;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionFaitGenerateurDemandeIDE
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */