package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.mnt.dom.ConditionActiviteMaintien;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.asu.mnt.dom.DonneesForcees;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.OutilDeterminationConditionMaintien;
import fr.unedic.cali.asu.spe02.p03.parametres.Parametres;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import java.math.BigDecimal;

public class StrategieDeterminationConditionActiviteIntermittent3AnsAvant
  implements StrategieDeterminationConditionActiviteIntermittent3AnsSpec
{
  public boolean determinerResultatSousConditionActiviteIntermittent3Ans(DemandeMaintien demandeMaintien, ConditionActiviteMaintien conditionActiviteMaintien)
    throws CoucheLogiqueException
  {
    Quantite quantiteActiviteIntermittent3Ans = OutilDeterminationConditionMaintien.getInstance().quantiteActiviteAcquiseIntermittentDansLes3ans(demandeMaintien);
    
    Quantite quantiteActiviteIntermittent3AnsImposee = demandeMaintien.getDonneesForcees().getQuantiteActiviteTroisAns();
    Quantite quantiteActiviteIntermittent3AnsVerifiee;
    Quantite quantiteActiviteIntermittent3AnsVerifiee;
    if ((quantiteActiviteIntermittent3AnsImposee != null) && (quantiteActiviteIntermittent3AnsImposee.getValeur().compareTo(BigDecimal.ZERO) > 0)) {
      quantiteActiviteIntermittent3AnsVerifiee = quantiteActiviteIntermittent3AnsImposee;
    } else {
      quantiteActiviteIntermittent3AnsVerifiee = quantiteActiviteIntermittent3Ans;
    }
    boolean estConditionDureeActiviteIntermittent3AnsSatisfaite = quantiteActiviteIntermittent3AnsVerifiee.compareTo(Parametres.DUREE_ACTIVITE_INTERMITTENT_3_ANS) >= 0;
    
    conditionActiviteMaintien.setQuantiteActiviteContinueCalculee(quantiteActiviteIntermittent3Ans);
    conditionActiviteMaintien.setQuantiteActiviteContinueRequise(Parametres.DUREE_ACTIVITE_INTERMITTENT_3_ANS);
    conditionActiviteMaintien.setQuantiteActiviteContinueImposee(quantiteActiviteIntermittent3AnsImposee);
    
    return estConditionDureeActiviteIntermittent3AnsSatisfaite;
  }
}

/* Location:
 * Qualified Name:     StrategieDeterminationConditionActiviteIntermittent3AnsAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */