package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationMontantsBruts;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.Resultat;

public class ConstitutionMontantsBrutsPourReprise
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {}
  
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA05 = new Resultat();
    resultatCEPA05.setEtat(1);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    
    DeterminationMontantsBruts determinationMontantsBruts = DeterminationMontantsBruts.getInstance();
    determinationMontantsBruts.determinerMontantsBrutsPourReprise(demande);
    
    resultatCEPA05.setEtat(0);
    
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA05;
  }
}

/* Location:
 * Qualified Name:     ConstitutionMontantsBrutsPourReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */