package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieNombreHeuresTravaillees;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.strategies.StrategieNombreHeuresTravailleesSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.Resultat;

public class ConstitutionNbHeuresTravaillees
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(p_contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "La DemandeAssurance est null pour le calcul du nombre d'heures travaillees");
    }
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA24 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    
    StrategieNombreHeuresTravailleesSpec strategie = (StrategieNombreHeuresTravailleesSpec)FabriqueStrategieNombreHeuresTravaillees.getStrategie(demande);
    
    strategie.determinerNombreHeuresTravaillees(demande);
    
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA24;
  }
}

/* Location:
 * Qualified Name:     ConstitutionNbHeuresTravaillees
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */