package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.Resultat;

public class ConstitutionSalaireReferenceEtSjm
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {}
  
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    if (Log.isTraceActive(ConstitutionSalaireReferenceEtSjm.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSalaireReferenceEtSjm.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSalaireReferenceEtSjm.class, "demarrer", "\t\t******** Début Parcours ConstitutionSalaireReferenceEtSjm ********");
    }
    Resultat resultatCEPA = new Resultat();
    
    Resultat res1 = new ConstitutionSalaireReference().demarrer(p_contexte);
    Resultat res2 = new ConstitutionSjm().demarrer(p_contexte);
    
    resultatCEPA.setEtat((res1.estSatisfait()) && (res2.estSatisfait()) ? 0 : 1);
    resultatCEPA.setCodeErreur(res1.getCodeErreur() != null ? res1.getCodeErreur() : res2.getCodeErreur());
    resultatCEPA.setMessageErreur(res1.getMessageErreur() != null ? res1.getMessageErreur() : res2.getMessageErreur());
    if (Log.isTraceActive(ConstitutionSalaireReferenceEtSjm.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSalaireReferenceEtSjm.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSalaireReferenceEtSjm.class, "demarrer", "\t\t******** Résultat Parcours ConstitutionSalaireReferenceEtSjm ********\n" + resultatCEPA);
      
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSalaireReferenceEtSjm.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSalaireReferenceEtSjm.class, "demarrer", "\t\t******** Fin Parcours ConstitutionSalaireReferenceEtSjm ********\n");
    }
    return resultatCEPA;
  }
}

/* Location:
 * Qualified Name:     ConstitutionSalaireReferenceEtSjm
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */