package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Pra;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.ParametresAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.dom.ParametresCalculAffiliation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpe02P03;
import fr.unedic.cali.dom.affectation.ValidationProduitSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.CalculDelais;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;

public class ConstructionPra
{
  public static Pra determinerPraLaPlusLongue(DemandeSpec p_demandeCourante, ActiviteSalarie p_periodeFctCourante)
    throws CoucheLogiqueException
  {
    ValidationProduitSpec vp = ((DossierAffectation)p_demandeCourante.getDossierAffectation()).getValidationProduit();
    if ((vp != null) && (vp.getPeriodePra() != null)) {
      return new Pra(vp.getPeriodePra());
    }
    ParametresCalculAffiliation parametres = new ParametresCalculAffiliation();
    parametres.setRangEtude(0);
    parametres.setReglementEtudie(ProduitAsuSpe02P03.getInstance().getReglement("A10"));
    DureeCalendaire dureeCalendairePra = new ParametresAffiliation().determinerDureePeriodeReference(parametres);
    Periode periodePra = CalculDelais.determinerDelaiCalendaire(p_periodeFctCourante.getDateFin(), dureeCalendairePra);
    return new Pra(periodePra);
  }
}

/* Location:
 * Qualified Name:     ConstructionPra
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */