package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.FabriqueRechercheConditionFaitGenerateur;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.RechercheConditionFaitGenerateurSpec;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import java.math.BigDecimal;

public class DeterminationConditionFaitGenerateur
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte contexte)
    throws ContexteException
  {}
  
  public Resultat demarrer(Contexte contexte)
    throws CoucheLogiqueException
  {
    Demande demandeCourante = DomLiquidationAssurance.getDemande(contexte);
    
    Resultat resultatCapa04 = new Resultat(1);
    
    DomLiquidationAssurance dom = (DomLiquidationAssurance)contexte.getDonnees();
    
    AttributionAssuranceSpec attributionPrecedente = dom.getAttributionPrecedente();
    int etatReliquat = 0;
    if (dom.getResultatExecutionCalculDroitPrecedent() != null) {
      etatReliquat = dom.getResultatExecutionCalculDroitPrecedent().getEtatAttribution();
    }
    RechercheConditionFaitGenerateurSpec ofConditionFaitGenerateur = getOutilFonctionnel(demandeCourante, attributionPrecedente, etatReliquat);
    
    ConditionFaitGenerateur conditionFaitGenerateurCourante = ofConditionFaitGenerateur.rechercherConditionFaitGenerateur(demandeCourante);
    if (conditionFaitGenerateurCourante.estSatisfait())
    {
      resultatCapa04.setEtat(0);
    }
    else
    {
      resultatCapa04.setEtat(1);
      resultatCapa04.setMessageErreur(Integer.toString(conditionFaitGenerateurCourante.getCodeMotifEchec()));
    }
    alimenterDonneesComplementairesConditionFaitGenerateur(conditionFaitGenerateurCourante);
    
    return resultatCapa04;
  }
  
  protected RechercheConditionFaitGenerateurSpec getOutilFonctionnel(Demande demandeCourante, AttributionAssuranceSpec attributionPrecedente, int etatReliquat)
  {
    return FabriqueRechercheConditionFaitGenerateur.getOutilFonctionnelRechercheConditionFaitGenerateur(demandeCourante, attributionPrecedente, etatReliquat);
  }
  
  private void alimenterDonneesComplementairesConditionFaitGenerateur(ConditionFaitGenerateur faitGenerateur)
  {
    if ((faitGenerateur != null) && (faitGenerateur.getRefusFne() != null)) {
      faitGenerateur.setRefusAdhesionFne(String.valueOf(faitGenerateur.getRefusFne().intValue()));
    }
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionFaitGenerateur
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */