package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.OutilDeterminationOrdreObjectifs;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ParcoursDeterminationOrdreObjectifs
  extends ParcoursCali
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    OutilDeterminationOrdreObjectifs.getInstance().determinerObjectifs(getDemande(p_contexte), getDom(p_contexte).getContexteExamen());
    OutilTrace.tracerFinParcours();
    return new Resultat();
  }
  
  protected Demande getDemande(Contexte p_contexte)
  {
    Demande demande = (Demande)getDom(p_contexte).getDemandeSpec();
    demande.setLiquideeAvecDroitOptionReprise(((DomLiquidationAssurance)p_contexte.getDonnees()).isLiquidationAvecDroitOptionReprise());
    
    return demande;
  }
  
  protected DomLiquidationAssurance getDom(Contexte p_contexte)
  {
    return (DomLiquidationAssurance)p_contexte.getDonnees();
  }
}

/* Location:
 * Qualified Name:     ParcoursDeterminationOrdreObjectifs
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */