package fr.unedic.cali.asu.spe02.p03.migration;

import fr.unedic.cali.asu.migration.graphes.GrapheClassementAdministratif;
import fr.unedic.cali.asu.spe02.p03.migration.graphes.GrapheOd;
import fr.unedic.cali.asu.spe02.p03.migration.graphes.GrapheReadmissionDroitCourant;
import fr.unedic.cali.asu.spe02.p03.migration.graphes.GrapheRejet;
import fr.unedic.cali.asu.spe02.p03.migration.graphes.GrapheReprise;
import fr.unedic.cali.migration.GrapheLiquidationSpec;

public class FabriqueGraphe
{
  public static GrapheLiquidationSpec creegraphe(int p_natureDecision, boolean p_classement)
  {
    GrapheLiquidationSpec graphe = null;
    if (p_classement) {
      graphe = new GrapheClassementAdministratif();
    } else {
      switch (p_natureDecision)
      {
      case 10: 
        graphe = new GrapheOd();
        break;
      case 12: 
        graphe = new GrapheReadmissionDroitCourant();
        break;
      case 3: 
      case 13: 
      case 14: 
      case 15: 
        graphe = new GrapheReprise();
        break;
      case 16: 
        graphe = new GrapheRejet();
        break;
      case 4: 
      case 5: 
      case 6: 
      case 7: 
      case 8: 
      case 9: 
      case 11: 
      default: 
        throw new UnsupportedOperationException("LIQ_HG_OBJECT_DECIS");
      }
    }
    return graphe;
  }
}

/* Location:
 * Qualified Name:     FabriqueGraphe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */