package fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p05.calcul.dom.ObjetChronoDateLimiteIndemnisation;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.dom.AttributionSpec;

public class Qualification
  extends fr.unedic.cali.asu.spe02.p04.calcul.outilsfonctionnels.Qualification
{
  protected boolean qualifierUnePeriodeInterruptivesDefinitives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    if (((periode instanceof ObjetChronoDateLimiteIndemnisation)) && (((ObjetChronoDateLimiteIndemnisation)periode).getRsod().equals(attribution.getRsod())) && (!((AttributionAssuranceSpec)attribution).estMaintenue())) {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    } else {
      return super.qualifierUnePeriodeInterruptivesDefinitives(periode, qualificationPeriodes, attribution);
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSegmentante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attributionSpec)
  {
    Attribution attribution = (Attribution)attributionSpec;
    if ((!attribution.getElementBaseIndemnisation().isClauseRattrapage()) || ((nestPasChronoAnniversaire60AnsEnClauseRattrapage(periode, attribution)) && (nestPasAVenClauseRattrapage(periode, attribution)))) {
      return super.qualifierUnePeriodeSegmentante(periode, qualificationPeriodes, attribution);
    }
    return false;
  }
  
  private boolean nestPasAVenClauseRattrapage(ObjetChronoPeriodeCalcul periode, Attribution attribution)
  {
    return (attribution.getElementBaseIndemnisation().isClauseRattrapage()) && (!(periode instanceof PeriodeAvantageVieillesse));
  }
  
  private boolean nestPasChronoAnniversaire60AnsEnClauseRattrapage(ObjetChronoPeriodeCalcul periode, Attribution attribution)
  {
    return (attribution.getElementBaseIndemnisation().isClauseRattrapage()) && (!(periode instanceof ObjetChronoAnniversaire60Ans));
  }
}

/* Location:
 * Qualified Name:     Qualification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */