package fr.unedic.cali.asu.spe02.p05.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionAnciennete;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ParcoursConditionAnciennete
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = recupererDemande(contexte);
    DonneesTemporaires donneesForcees = demande.getDonneesTemporaires();
    
    Resultat resultat = new Resultat();
    ConditionAnciennete conditionAnciennnete = recupererConditionAnciennete(demande);
    if (donneesForcees.isConditionAncienneteSatisfaiteForcee().booleanValue())
    {
      resultat.setEtat(0);
      conditionAnciennnete.setEtatSatisfait(true);
      conditionAnciennnete.setDateDernierEvtEtudie(donneesForcees.getDateFinPeriodeAncienneteForcee());
    }
    else
    {
      resultat.setEtat(1);
      conditionAnciennnete.setEtatSatisfait(false);
      conditionAnciennnete.setCodeMotifEchec(261);
    }
    return resultat;
  }
  
  protected Demande recupererDemande(Contexte contexte)
  {
    return DomLiquidationAssurance.getDemande(contexte);
  }
  
  protected ConditionAnciennete recupererConditionAnciennete(Demande demande)
  {
    return ((DossierExamen)demande.getDossierExamen()).getConditionAttributionAdmission().createConditionAnciennete();
  }
}

/* Location:
 * Qualified Name:     ParcoursConditionAnciennete
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */