package fr.unedic.cali.asu.spe02.p05.liquidation.parcours;

import fr.pe.cali.liquidation.outilsfonctionnels.dom.ResultatImputationSuiteArce;
import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ParcoursConstitutionDateLimiteIndemnisationPourReprise
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    Attribution attribution = (Attribution)demande.getDossierExamen();
    
    Resultat resultat = new Resultat(0);
    
    calculerDateIndemnisationLimite(attribution, ((DomLiquidationAssurance)getDom()).getResultatImputationArce());
    return resultat;
  }
  
  private void calculerDateIndemnisationLimite(Attribution attribution, ResultatImputationSuiteArce resultatImputationArce)
    throws CoucheLogiqueException
  {
    Attribution odOrigine = (Attribution)attribution.getOuvertureDroit();
    if ((odOrigine.getConstitutionElementsActifs() != null) && (odOrigine.getConstitutionElementsActifs().getConstitutionDateLimiteIndemnisation() != null))
    {
      ConstitutionDateLimiteIndemnisation constitutionDroitPrecedent = odOrigine.getConstitutionElementsActifs().getConstitutionDateLimiteIndemnisation();
      Damj dateLimiteReprise = determinerDateLimiteIndemnisation(constitutionDroitPrecedent.getDateLimiteIndemnisation(), resultatImputationArce);
      mettreAJourCepDateLimite(attribution.getConstitutionElementsActifs().getConstitutionDateLimiteIndemnisation(), constitutionDroitPrecedent, dateLimiteReprise);
    }
  }
  
  private void mettreAJourCepDateLimite(ConstitutionDateLimiteIndemnisation constitution, ConstitutionDateLimiteIndemnisation constitutionDroitPrecedent, Damj dateLimite)
  {
    if (constitutionDroitPrecedent != null)
    {
      constitution.setDateLimiteIndemnisation(dateLimite);
      constitution.setContexteDateLimiteIndemnisation(constitutionDroitPrecedent.getContexteDateLimiteIndemnisation());
      constitution.setDureeImputee(constitutionDroitPrecedent.getDureeImputee());
      constitution.setDureeIndemnisation(constitutionDroitPrecedent.getDureeIndemnisation());
      constitution.setPointDepart(constitutionDroitPrecedent.getPointDepart());
    }
  }
  
  protected Damj determinerDateLimiteIndemnisation(Damj dateLimiteOd, ResultatImputationSuiteArce resultatImputationArce)
  {
    Damj dateLimiteARetourner = dateLimiteOd;
    if ((resultatImputationArce != null) && (resultatImputationArce.isDateLimiteImputee())) {
      dateLimiteARetourner = resultatImputationArce.getNouvelleDateLimiteIndemnisation();
    }
    return dateLimiteARetourner;
  }
}

/* Location:
 * Qualified Name:     ParcoursConstitutionDateLimiteIndemnisationPourReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */