package fr.unedic.cali.asu.ssp07.p03.calcul.dom;

import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.asu.spe02.p03.calcul.dom.FormuleMontantAREF;
import fr.unedic.cali.asu.spe02.p03.calcul.dom.Montant;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteMonaitaire;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class FormuleMontantAPSF
  extends FormuleMontantAREF
  implements FormuleMontantSpec
{
  public static String getCode()
  {
    return "2";
  }
  
  public MontantBaseSpec calculer(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    Montant montant = null;
    MontantAPSF montantAPSF = null;
    EvenementParametre evenementParametre = null;
    
    evenementParametre = ParametresIndemnisation.getParametresIndemnisation().getElementActif(p_dateCalcul);
    
    montant = (Montant)super.calculer(p_constituantsIndemnisation, p_dateCalcul);
    
    montantAPSF = new MontantAPSF(montant);
    
    montantAPSF.setMini(new Quantite(evenementParametre.getSeuilMinimalAREF(), UniteMonaitaire.EUROS));
    montantAPSF.setMontantBrut(new Quantite(montant.getMontantBrut().getValeur().max(montantAPSF.getMini().getValeur()), UniteMonaitaire.EUROS));
    if (montantAPSF.getMontantBrut().equals(montantAPSF.getMini())) {
      montantAPSF.setJustificationCalculMontant("04");
    }
    if (((ElementBaseIndemnisationAREF)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).estEffectif()) {
      montantAPSF.setType("FORMATION EFFECTIVE");
    }
    return montantAPSF;
  }
}

/* Location:
 * Qualified Name:     FormuleMontantAPSF
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */