package fr.unedic.cali.asu.utilitaire.filtres.generiques;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.dom.AntecedentSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.utilitaire.filtres.FiltreCaliAbstrait;
import fr.unedic.util.temps.Temporel;
import java.util.List;

public class FiltreDemandePourTypeContexteAntecedent
  extends FiltreCaliAbstrait
{
  private static final long serialVersionUID = 1L;
  private int m_typeContexteAntecedent;
  
  public FiltreDemandePourTypeContexteAntecedent(int p_typeContexteAntecedent)
  {
    m_typeContexteAntecedent = p_typeContexteAntecedent;
  }
  
  public boolean accepterElement(Temporel p_temporel)
  {
    if ((p_temporel instanceof Demande))
    {
      Demande demande = (Demande)p_temporel;
      boolean estAntecedent = false;
      List listeDossiersExamen = demande.getListeDossiersExamen();
      if ((listeDossiersExamen != null) && (!listeDossiersExamen.isEmpty()))
      {
        DossierExamenSpec dossierExamen = (DossierExamenSpec)listeDossiersExamen.get(0);
        estAntecedent = dossierExamen.estType(AntecedentSpec.class);
      }
      return (estAntecedent) && (demande.getSaisieAntecedent().getContexteDemande().intValue() == m_typeContexteAntecedent);
    }
    return false;
  }
  
  public int getTypeElementManipule()
  {
    return 2;
  }
}

/* Location:
 * Qualified Name:     FiltreDemandePourTypeContexteAntecedent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */