package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI59Impl
  extends YI59
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI59 m_YI59Infra;
  
  public _YI59Impl()
  {
    m_YI59Infra = new _YI59();
  }
  
  public _YI59Impl(_YI59 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI59Infra", pValeur);
    
    m_YI59Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI59Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI59Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI59Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI59Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI59Infra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getDSAAS1()
  {
    return m_YI59Infra.getDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED();
  }
  
  public String getCodeErreurDSAAS1()
  {
    return m_YI59Infra.getDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED_C_ERR();
  }
  
  public void setDSAAS1(BigDecimal pValeur)
  {
    m_YI59Infra.setDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED(pValeur);
  }
  
  public void setCodeErreurDSAAS1(String pCodeErreur)
  {
    m_YI59Infra.setDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED()
  {
    return m_YI59Infra.getDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED();
  }
  
  public String getCodeErreurDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED()
  {
    return m_YI59Infra.getDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED_C_ERR();
  }
  
  public void setDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED(BigDecimal pValeur)
  {
    m_YI59Infra.setDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED(pValeur);
  }
  
  public void setCodeErreurDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED(String pCodeErreur)
  {
    m_YI59Infra.setDSAAS1_SIECLE_ANNEE_D_IMPUTATION_ACT_RED_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA2()
  {
    return m_YI59Infra.getDSMA2_MOIS_D_IMPUTATION_ACT_RED();
  }
  
  public String getCodeErreurDSMA2()
  {
    return m_YI59Infra.getDSMA2_MOIS_D_IMPUTATION_ACT_RED_C_ERR();
  }
  
  public void setDSMA2(BigDecimal pValeur)
  {
    m_YI59Infra.setDSMA2_MOIS_D_IMPUTATION_ACT_RED(pValeur);
  }
  
  public void setCodeErreurDSMA2(String pCodeErreur)
  {
    m_YI59Infra.setDSMA2_MOIS_D_IMPUTATION_ACT_RED_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA2_MOIS_D_IMPUTATION_ACT_RED()
  {
    return m_YI59Infra.getDSMA2_MOIS_D_IMPUTATION_ACT_RED();
  }
  
  public String getCodeErreurDSMA2_MOIS_D_IMPUTATION_ACT_RED()
  {
    return m_YI59Infra.getDSMA2_MOIS_D_IMPUTATION_ACT_RED_C_ERR();
  }
  
  public void setDSMA2_MOIS_D_IMPUTATION_ACT_RED(BigDecimal pValeur)
  {
    m_YI59Infra.setDSMA2_MOIS_D_IMPUTATION_ACT_RED(pValeur);
  }
  
  public void setCodeErreurDSMA2_MOIS_D_IMPUTATION_ACT_RED(String pCodeErreur)
  {
    m_YI59Infra.setDSMA2_MOIS_D_IMPUTATION_ACT_RED_C_ERR(pCodeErreur);
  }
  
  public _YI59 getYI59Infra()
  {
    return m_YI59Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurDSAAS1() != null) && 
      ("".equals(getCodeErreurDSAAS1()))) {
      return true;
    }
    if ((getCodeErreurDSMA2() != null) && 
      ("".equals(getCodeErreurDSMA2()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI59Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */