package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI5TImpl
  extends YI5T
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI5T m_YI5TInfra;
  
  public _YI5TImpl()
  {
    m_YI5TInfra = new _YI5T();
  }
  
  public _YI5TImpl(_YI5T pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI5TInfra", pValeur);
    
    m_YI5TInfra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI5TInfra;
  }
  
  public String getIdentifiant()
  {
    return m_YI5TInfra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI5TInfra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI5TInfra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI5TInfra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getDSAAS7()
  {
    return m_YI5TInfra.getDSAAS7_ANNEE_PRESENCE_RETOUR_UL961();
  }
  
  public String getCodeErreurDSAAS7()
  {
    return m_YI5TInfra.getDSAAS7_ANNEE_PRESENCE_RETOUR_UL961_C_ERR();
  }
  
  public void setDSAAS7(BigDecimal pValeur)
  {
    m_YI5TInfra.setDSAAS7_ANNEE_PRESENCE_RETOUR_UL961(pValeur);
  }
  
  public void setCodeErreurDSAAS7(String pCodeErreur)
  {
    m_YI5TInfra.setDSAAS7_ANNEE_PRESENCE_RETOUR_UL961_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSAAS7_ANNEE_PRESENCE_RETOUR_UL961()
  {
    return m_YI5TInfra.getDSAAS7_ANNEE_PRESENCE_RETOUR_UL961();
  }
  
  public String getCodeErreurDSAAS7_ANNEE_PRESENCE_RETOUR_UL961()
  {
    return m_YI5TInfra.getDSAAS7_ANNEE_PRESENCE_RETOUR_UL961_C_ERR();
  }
  
  public void setDSAAS7_ANNEE_PRESENCE_RETOUR_UL961(BigDecimal pValeur)
  {
    m_YI5TInfra.setDSAAS7_ANNEE_PRESENCE_RETOUR_UL961(pValeur);
  }
  
  public void setCodeErreurDSAAS7_ANNEE_PRESENCE_RETOUR_UL961(String pCodeErreur)
  {
    m_YI5TInfra.setDSAAS7_ANNEE_PRESENCE_RETOUR_UL961_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA7()
  {
    return m_YI5TInfra.getDSMA7_MOIS_PRESENCE_RETOUR_UL961();
  }
  
  public String getCodeErreurDSMA7()
  {
    return m_YI5TInfra.getDSMA7_MOIS_PRESENCE_RETOUR_UL961_C_ERR();
  }
  
  public void setDSMA7(BigDecimal pValeur)
  {
    m_YI5TInfra.setDSMA7_MOIS_PRESENCE_RETOUR_UL961(pValeur);
  }
  
  public void setCodeErreurDSMA7(String pCodeErreur)
  {
    m_YI5TInfra.setDSMA7_MOIS_PRESENCE_RETOUR_UL961_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA7_MOIS_PRESENCE_RETOUR_UL961()
  {
    return m_YI5TInfra.getDSMA7_MOIS_PRESENCE_RETOUR_UL961();
  }
  
  public String getCodeErreurDSMA7_MOIS_PRESENCE_RETOUR_UL961()
  {
    return m_YI5TInfra.getDSMA7_MOIS_PRESENCE_RETOUR_UL961_C_ERR();
  }
  
  public void setDSMA7_MOIS_PRESENCE_RETOUR_UL961(BigDecimal pValeur)
  {
    m_YI5TInfra.setDSMA7_MOIS_PRESENCE_RETOUR_UL961(pValeur);
  }
  
  public void setCodeErreurDSMA7_MOIS_PRESENCE_RETOUR_UL961(String pCodeErreur)
  {
    m_YI5TInfra.setDSMA7_MOIS_PRESENCE_RETOUR_UL961_C_ERR(pCodeErreur);
  }
  
  public _YI5T getYI5TInfra()
  {
    return m_YI5TInfra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurDSAAS7() != null) && 
      ("".equals(getCodeErreurDSAAS7()))) {
      return true;
    }
    if ((getCodeErreurDSMA7() != null) && 
      ("".equals(getCodeErreurDSMA7()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI5TImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */