package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI5WImpl
  extends YI5W
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI5W m_YI5WInfra;
  
  public _YI5WImpl()
  {
    m_YI5WInfra = new _YI5W();
  }
  
  public _YI5WImpl(_YI5W pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI5WInfra", pValeur);
    
    m_YI5WInfra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI5WInfra;
  }
  
  public String getIdentifiant()
  {
    return m_YI5WInfra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI5WInfra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI5WInfra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI5WInfra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getDSAAS3()
  {
    return m_YI5WInfra.getDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961();
  }
  
  public String getCodeErreurDSAAS3()
  {
    return m_YI5WInfra.getDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961_C_ERR();
  }
  
  public void setDSAAS3(BigDecimal pValeur)
  {
    m_YI5WInfra.setDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961(pValeur);
  }
  
  public void setCodeErreurDSAAS3(String pCodeErreur)
  {
    m_YI5WInfra.setDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961()
  {
    return m_YI5WInfra.getDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961();
  }
  
  public String getCodeErreurDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961()
  {
    return m_YI5WInfra.getDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961_C_ERR();
  }
  
  public void setDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961(BigDecimal pValeur)
  {
    m_YI5WInfra.setDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961(pValeur);
  }
  
  public void setCodeErreurDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961(String pCodeErreur)
  {
    m_YI5WInfra.setDSAAS3_SIECLE_ANNEE_D_IMPUTATION_UL961_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA3()
  {
    return m_YI5WInfra.getDSMA3_MOIS_D_IMPUTATION_UL961();
  }
  
  public String getCodeErreurDSMA3()
  {
    return m_YI5WInfra.getDSMA3_MOIS_D_IMPUTATION_UL961_C_ERR();
  }
  
  public void setDSMA3(BigDecimal pValeur)
  {
    m_YI5WInfra.setDSMA3_MOIS_D_IMPUTATION_UL961(pValeur);
  }
  
  public void setCodeErreurDSMA3(String pCodeErreur)
  {
    m_YI5WInfra.setDSMA3_MOIS_D_IMPUTATION_UL961_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA3_MOIS_D_IMPUTATION_UL961()
  {
    return m_YI5WInfra.getDSMA3_MOIS_D_IMPUTATION_UL961();
  }
  
  public String getCodeErreurDSMA3_MOIS_D_IMPUTATION_UL961()
  {
    return m_YI5WInfra.getDSMA3_MOIS_D_IMPUTATION_UL961_C_ERR();
  }
  
  public void setDSMA3_MOIS_D_IMPUTATION_UL961(BigDecimal pValeur)
  {
    m_YI5WInfra.setDSMA3_MOIS_D_IMPUTATION_UL961(pValeur);
  }
  
  public void setCodeErreurDSMA3_MOIS_D_IMPUTATION_UL961(String pCodeErreur)
  {
    m_YI5WInfra.setDSMA3_MOIS_D_IMPUTATION_UL961_C_ERR(pCodeErreur);
  }
  
  public _YI5W getYI5WInfra()
  {
    return m_YI5WInfra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurDSAAS3() != null) && 
      ("".equals(getCodeErreurDSAAS3()))) {
      return true;
    }
    if ((getCodeErreurDSMA3() != null) && 
      ("".equals(getCodeErreurDSMA3()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI5WImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */