package fr.unedic.logique.donnees.rac.commun.dra.d01.zu;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _ML49Impl
  extends ML49
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _ML49 m_ML49Infra;
  
  public _ML49Impl()
  {
    m_ML49Infra = new _ML49();
  }
  
  public _ML49Impl(_ML49 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("ML49Infra", pValeur);
    
    m_ML49Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_ML49Infra;
  }
  
  public String getIdentifiant()
  {
    return m_ML49Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_ML49Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_ML49Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_ML49Infra.set_C_ETAT(pCode);
  }
  
  public String getCITRT_CODE_TRAITEMENT()
  {
    return m_ML49Infra.getCITRT_CODE_TRAITEMENT();
  }
  
  public String getCodeErreurCITRT_CODE_TRAITEMENT()
  {
    return m_ML49Infra.getCITRT_CODE_TRAITEMENT_C_ERR();
  }
  
  public void setCITRT_CODE_TRAITEMENT(String pValeur)
  {
    m_ML49Infra.setCITRT_CODE_TRAITEMENT(pValeur);
  }
  
  public void setCodeErreurCITRT_CODE_TRAITEMENT(String pCodeErreur)
  {
    m_ML49Infra.setCITRT_CODE_TRAITEMENT_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCITRT()
  {
    return getCITRT_CODE_TRAITEMENT();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCITRT()
  {
    return getCodeErreurCITRT_CODE_TRAITEMENT();
  }
  
  /**
   * @deprecated
   */
  public void setCITRT(String pValeur)
  {
    setCITRT_CODE_TRAITEMENT(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCITRT(String pCodeErreur)
  {
    setCodeErreurCITRT_CODE_TRAITEMENT(pCodeErreur);
  }
  
  public BigDecimal getCXALA_IDENTIFIANT_NATIONAL_ALADIN()
  {
    return m_ML49Infra.getCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  public String getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN()
  {
    return m_ML49Infra.getCXALA_IDENTIFIANT_NATIONAL_ALADIN_C_ERR();
  }
  
  public void setCXALA_IDENTIFIANT_NATIONAL_ALADIN(BigDecimal pValeur)
  {
    m_ML49Infra.setCXALA_IDENTIFIANT_NATIONAL_ALADIN(pValeur);
  }
  
  public void setCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN(String pCodeErreur)
  {
    m_ML49Infra.setCXALA_IDENTIFIANT_NATIONAL_ALADIN_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public BigDecimal getCXALA()
  {
    return getCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXALA()
  {
    return getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  /**
   * @deprecated
   */
  public void setCXALA(BigDecimal pValeur)
  {
    setCXALA_IDENTIFIANT_NATIONAL_ALADIN(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXALA(String pCodeErreur)
  {
    setCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN(pCodeErreur);
  }
  
  public _ML49 getML49Infra()
  {
    return m_ML49Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCITRT_CODE_TRAITEMENT() != null) && 
      ("".equals(getCodeErreurCITRT_CODE_TRAITEMENT()))) {
      return true;
    }
    if ((getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN() != null) && 
      ("".equals(getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _ML49Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */