package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDEPUEnumeration
{
  public static final SRCDEPUEnumeration E_O = new SRCDEPUEnumeration("OUI", "O");
  public static final SRCDEPUEnumeration E_N = new SRCDEPUEnumeration("NON", "N");
  static final SRCDEPUEnumeration[] LISTE_ENUM = { E_O, E_N };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDEPUEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDEPUEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDEPUEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDEPUEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDEPUEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDEPUEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDEPUEnumeration getPourValeur(String pValeur)
  {
    SRCDEPUEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDEPUEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDEPUEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */