package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDRDVCEnumeration
{
  public static final SRCDRDVCEnumeration E_PE = new SRCDRDVCEnumeration("Premier entretien", "PE");
  public static final SRCDRDVCEnumeration E_AE = new SRCDRDVCEnumeration("Autre entretien", "AE");
  public static final SRCDRDVCEnumeration E_S1 = new SRCDRDVCEnumeration("SMP 1er RDV", "S1");
  public static final SRCDRDVCEnumeration E_S2 = new SRCDRDVCEnumeration("SMP 2eme RDV et suivant", "S2");
  static final SRCDRDVCEnumeration[] LISTE_ENUM = { E_PE, E_AE, E_S1, E_S2 };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDRDVCEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDRDVCEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDRDVCEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDRDVCEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDRDVCEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDRDVCEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDRDVCEnumeration getPourValeur(String pValeur)
  {
    SRCDRDVCEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDRDVCEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDRDVCEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */