package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDRSOEnumeration
{
  public static final SRCDRSOEnumeration E_01 = new SRCDRSOEnumeration("FranÃ§ais", "01");
  public static final SRCDRSOEnumeration E_02 = new SRCDRSOEnumeration("Ressortissant de l'UE", "02");
  public static final SRCDRSOEnumeration E_03 = new SRCDRSOEnumeration("Ressortissant de l'EEE", "03");
  public static final SRCDRSOEnumeration E_04 = new SRCDRSOEnumeration("Reste du monde", "04");
  static final SRCDRSOEnumeration[] LISTE_ENUM = { E_01, E_02, E_03, E_04 };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDRSOEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDRSOEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDRSOEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDRSOEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDRSOEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDRSOEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDRSOEnumeration getPourValeur(String pValeur)
  {
    SRCDRSOEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDRSOEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDRSOEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */