package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDSFEnumeration
{
  public static final SRCDSFEnumeration E_M = new SRCDSFEnumeration("mariÃ©(e) ou vie maritale", "M");
  public static final SRCDSFEnumeration E_C = new SRCDSFEnumeration("cÃ©libataire", "C");
  public static final SRCDSFEnumeration E_D = new SRCDSFEnumeration("divorcÃ©(e) ou sÃ©parÃ©(e)", "D");
  public static final SRCDSFEnumeration E_V = new SRCDSFEnumeration("veuf(ve)", "V");
  public static final SRCDSFEnumeration E_Z = new SRCDSFEnumeration("migration", "Z");
  static final SRCDSFEnumeration[] LISTE_ENUM = { E_M, E_C, E_D, E_V, E_Z };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDSFEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDSFEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDSFEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDSFEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDSFEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDSFEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDSFEnumeration getPourValeur(String pValeur)
  {
    SRCDSFEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDSFEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDSFEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */