package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDSUIEnumeration
{
  public static final SRCDSUIEnumeration E_PAE = new SRCDSUIEnumeration("DE en suivi mensuel.", "PAE");
  public static final SRCDSUIEnumeration E_CRP = new SRCDSUIEnumeration("DE Suivi en CRP.", "CRP");
  static final SRCDSUIEnumeration[] LISTE_ENUM = { E_PAE, E_CRP };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDSUIEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDSUIEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDSUIEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDSUIEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDSUIEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDSUIEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDSUIEnumeration getPourValeur(String pValeur)
  {
    SRCDSUIEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDSUIEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDSUIEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */