package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDTPEEnumeration
{
  public static final SRCDTPEEnumeration E_1 = new SRCDTPEEnumeration("Entreprise", "1");
  public static final SRCDTPEEnumeration E_2 = new SRCDTPEEnumeration("Etablissement", "2");
  public static final SRCDTPEEnumeration E_3 = new SRCDTPEEnumeration("Individu employeur", "3");
  public static final SRCDTPEEnumeration E_4 = new SRCDTPEEnumeration("Demandeur d'emploi", "4");
  public static final SRCDTPEEnumeration E_5 = new SRCDTPEEnumeration("Demandeur d'emploi et individu employeur", "5");
  static final SRCDTPEEnumeration[] LISTE_ENUM = { E_1, E_2, E_3, E_4, E_5 };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDTPEEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDTPEEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDTPEEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDTPEEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDTPEEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDTPEEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDTPEEnumeration getPourValeur(String pValeur)
  {
    SRCDTPEEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDTPEEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDTPEEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */