package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCICJEnumeration
{
  public static final SRCICJEnumeration E_O = new SRCICJEnumeration("CertifiÃ©", "O");
  public static final SRCICJEnumeration E_N = new SRCICJEnumeration("Non certifiÃ©", "N");
  public static final SRCICJEnumeration E_B = new SRCICJEnumeration("BloquÃ©", "B");
  static final SRCICJEnumeration[] LISTE_ENUM = { E_O, E_N, E_B };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCICJEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCICJEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCICJEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCICJEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCICJEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCICJEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCICJEnumeration getPourValeur(String pValeur)
  {
    SRCICJEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCICJEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCICJEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */