package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCINCPEnumeration
{
  public static final SRCINCPEnumeration E_A = new SRCINCPEnumeration("Individu SIGMA", "A");
  public static final SRCINCPEnumeration E_M = new SRCINCPEnumeration("Individu migrÃ© NCP", "M");
  public static final SRCINCPEnumeration E_C = new SRCINCPEnumeration("Individu en cours de migration NCP", "C");
  static final SRCINCPEnumeration[] LISTE_ENUM = { E_A, E_M, E_C };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCINCPEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCINCPEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCINCPEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCINCPEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCINCPEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCINCPEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCINCPEnumeration getPourValeur(String pValeur)
  {
    SRCINCPEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCINCPEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCINCPEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */