package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCSDISAEnumeration
{
  public static final SRCSDISAEnumeration E_0 = new SRCSDISAEnumeration("'DISPONIBLE'", "0");
  public static final SRCSDISAEnumeration E_1 = new SRCSDISAEnumeration("'ACTUELLEMENT EN FORMATION'", "1");
  public static final SRCSDISAEnumeration E_2 = new SRCSDISAEnumeration("'ARRET MALADIE MATERNITE'", "2");
  public static final SRCSDISAEnumeration E_3 = new SRCSDISAEnumeration("'CES'", "3");
  public static final SRCSDISAEnumeration E_4 = new SRCSDISAEnumeration("'AUTRE EMPLOI QUE CES'", "4");
  static final SRCSDISAEnumeration[] LISTE_ENUM = { E_0, E_1, E_2, E_3, E_4 };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCSDISAEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCSDISAEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCSDISAEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCSDISAEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSDISAEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCSDISAEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSDISAEnumeration getPourValeur(String pValeur)
  {
    SRCSDISAEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSDISAEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCSDISAEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */