package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCSINEEnumeration
{
  public static final SRCSINEEnumeration E_A = new SRCSINEEnumeration("OUI", "A");
  public static final SRCSINEEnumeration E_B = new SRCSINEEnumeration("NON", "B");
  public static final SRCSINEEnumeration E_D = new SRCSINEEnumeration("CARENCE", "D");
  public static final SRCSINEEnumeration E_E = new SRCSINEEnumeration("DIFFERE", "E");
  public static final SRCSINEEnumeration E_F = new SRCSINEEnumeration("EXCLUSION TEMPORAIRE", "F");
  public static final SRCSINEEnumeration E_G = new SRCSINEEnumeration("ATTENTE ACTUALISATION", "G");
  public static final SRCSINEEnumeration E_H = new SRCSINEEnumeration("AVANT INDEMNISATION", "H");
  public static final SRCSINEEnumeration E_I = new SRCSINEEnumeration("INTERRUPTION POUR PENSION INVALIDITE", "I");
  public static final SRCSINEEnumeration E_J = new SRCSINEEnumeration("INTERRUPTION POUR MALADIE", "J");
  public static final SRCSINEEnumeration E_K = new SRCSINEEnumeration("NON REPONSE A QUEST. RESSOURCES", "K");
  public static final SRCSINEEnumeration E_L = new SRCSINEEnumeration("INTERRUPTION POUR SEUIL REMUNERATION AR DEPASSE", "L");
  public static final SRCSINEEnumeration E_M = new SRCSINEEnumeration("INTERRUPTION POUR SEUIL ACTIVITE AR DEPASSE (18 MOIS)", "M");
  public static final SRCSINEEnumeration E_N = new SRCSINEEnumeration("DEPASSEMENT PLAFOND RESSOURCES ASS", "N");
  public static final SRCSINEEnumeration E_P = new SRCSINEEnumeration("INTERRUPTION POUR SEUIL ACTIVITE AR > 750H", "P");
  public static final SRCSINEEnumeration E_Z = new SRCSINEEnumeration("INDETERMINEE (cas d'erreur )", "Z");
  static final SRCSINEEnumeration[] LISTE_ENUM = { E_A, E_B, E_D, E_E, E_F, E_G, E_H, E_I, E_J, E_K, E_L, E_M, E_N, E_P, E_Z };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCSINEEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCSINEEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCSINEEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCSINEEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSINEEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCSINEEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSINEEnumeration getPourValeur(String pValeur)
  {
    SRCSINEEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSINEEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCSINEEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */