package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCSTLDEnumeration
{
  public static final SRCSTLDEnumeration E_G = new SRCSTLDEnumeration("Global", "G");
  public static final SRCSTLDEnumeration E_P = new SRCSTLDEnumeration("PrÃ©compte", "P");
  public static final SRCSTLDEnumeration E_R = new SRCSTLDEnumeration("Retenue", "R");
  static final SRCSTLDEnumeration[] LISTE_ENUM = { E_G, E_P, E_R };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCSTLDEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCSTLDEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCSTLDEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCSTLDEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSTLDEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCSTLDEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSTLDEnumeration getPourValeur(String pValeur)
  {
    SRCSTLDEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSTLDEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCSTLDEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */