package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRFICSVEnumeration
{
  public static final SRFICSVEnumeration E_O = new SRFICSVEnumeration("DonnÃ©e modifiable", "O");
  public static final SRFICSVEnumeration E_N = new SRFICSVEnumeration("DonnÃ©e non modifiable", "N");
  static final SRFICSVEnumeration[] LISTE_ENUM = { E_O, E_N };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRFICSVEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRFICSVEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRFICSVEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRFICSVEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFICSVEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRFICSVEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFICSVEnumeration getPourValeur(String pValeur)
  {
    SRFICSVEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFICSVEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRFICSVEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */