package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRFIRCHEnumeration
{
  public static final SRFIRCHEnumeration E_S = new SRFIRCHEnumeration("Recherche individu standard pour AUDE et DUDE", "S");
  public static final SRFIRCHEnumeration E_R = new SRFIRCHEnumeration("Recherche individu standard pour AIDA", "R");
  public static final SRFIRCHEnumeration E_I = new SRFIRCHEnumeration("Recherche individu pour identification", "I");
  public static final SRFIRCHEnumeration E_J = new SRFIRCHEnumeration("Recherche individu pour identification pour AUDE", "J");
  public static final SRFIRCHEnumeration E_B = new SRFIRCHEnumeration("Recherche individu par BATCH", "B");
  static final SRFIRCHEnumeration[] LISTE_ENUM = { E_S, E_R, E_I, E_J, E_B };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRFIRCHEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRFIRCHEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRFIRCHEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRFIRCHEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFIRCHEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRFIRCHEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFIRCHEnumeration getPourValeur(String pValeur)
  {
    SRFIRCHEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFIRCHEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRFIRCHEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */