package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRFISESEnumeration
{
  public static final SRFISESEnumeration E_O = new SRFISESEnumeration("DonnÃ©e modifiable", "O");
  public static final SRFISESEnumeration E_N = new SRFISESEnumeration("DonnÃ©e non modifiable", "N");
  static final SRFISESEnumeration[] LISTE_ENUM = { E_O, E_N };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRFISESEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRFISESEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRFISESEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRFISESEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFISESEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRFISESEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFISESEnumeration getPourValeur(String pValeur)
  {
    SRFISESEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFISESEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRFISESEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */