package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRFITREEnumeration
{
  public static final SRFITREEnumeration E_A = new SRFITREEnumeration("A transfÃ©rer", "A");
  public static final SRFITREEnumeration E_E = new SRFITREEnumeration("En-cours", "E");
  public static final SRFITREEnumeration E_T = new SRFITREEnumeration("TerminÃ©", "T");
  static final SRFITREEnumeration[] LISTE_ENUM = { E_A, E_E, E_T };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRFITREEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRFITREEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRFITREEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRFITREEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFITREEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRFITREEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFITREEnumeration getPourValeur(String pValeur)
  {
    SRFITREEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFITREEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRFITREEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */